c --------------------------------------------------------------------
      real*8 function LQ_QBB(s,t1,ms1)

      implicit none 

      real*8 Pi,Nc,Cf,alphas,fac 
      real*8 s,t1,u1,ms1 

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      alphas = 1.D0
      
      u1 = - s - t1 

      fac = 1.D0/(64*Pi*Nc**2)
      
      LQ_QBB =
     +  + Nc*Cf*Pi**2*alphas**2 * (  - 64*ms1**2*s**(-3) + 64*s**(-4)*
     +    t1*u1 )

      LQ_QBB = fac * LQ_QBB 

      end

c --------------------------------------------------------------------
      real*8 function LQ_QB1(s,t1,ms1,mu)

      implicit none 

      real*8 Pi,Nc,Cf,Nf,alphas
      real*8 s,t1,u1,ms1,sca,mu 
      real*8 conalp,consof,LQ_QBB

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      Nf = 6.D0
      alphas = 1.D0
      
      sca = (mu/ms1)**2

      u1 = - s - t1 

c renormalization of coupling with light flavours
      conalp = alphas/2.D0/Pi * LQ_QBB(s,t1,ms1)
     &       * ( 11.D0/3.D0*Nc - 2.D0/3.D0 * (Nf-1.D0)) * log(sca)

      consof = -alphas*Cf/2.D0/Pi * LQ_QBB(s,t1,ms1)
     &       * ( - 2.D0 * log(-t1/ms1**2)
     &           - 2.D0 * log(-u1/ms1**2)
     &           + 3.D0                  ) * log(sca)
 
      LQ_QB1 = conalp + consof 

      end

c --------------------------------------------------------------------
      real*8 function LQ_QB2(s,t1,s4,ms1,del,s4max,mu)

      implicit none 

      real*8 Pi,Cf,alphas
      real*8 s,t1,s4,del,s4max,ms1,sca,mu
      real*8 dldel1,LQ_QBB

      Pi = 4.D0*atan(1.D0)
      Cf = 4.D0/3.D0 
      alphas = 1.D0

      sca = (mu/ms1)**2

      dldel1 = log(s4max/ms1**2)
     &       - ( s4max - del )/s4 

      LQ_QB2 = -alphas*Cf/2.D0/Pi * LQ_QBB(s,t1,ms1)
     &      * 4.D0*dldel1 * log(sca)

      end

c --------------------------------------------------------------------
      real*8 function LQ_QB3(s,t1,s4,ms1,mu)

      implicit none 

      real*8 Pi,Nc,Cf,fac,alphas 
      real*8 s,t1,u1,s4,ms1,sca,mu 
      real*8 COLO1(9)

      Pi = 4.D0*atan(1.D0)
      Cf = 4.D0/3.D0 
      Nc = 3.D0
      alphas = 1.D0

      sca = (mu/ms1)**2

      u1 = s4 - s - t1 

      fac = s4 /(s4+ms1**2) /8.D0 /(16*Pi**2)**2 /Nc**2
      
      COLO1(9) = -log(sca)

      LQ_QB3 = 0.D0
      LQ_QB3 = LQ_QB3 + COLO1(9)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-4)*t1**(-1)*u1 + 1024*ms1**2*s**(-4)*t1*u1**(-1) + 4096
     +    *ms1**2*s**(-4)*t1*s4**(-1) - 4096*ms1**2*s**(-4)*t1**2*
     +    s4**(-2) - 2048*ms1**2*s**(-4) - 1024*ms1**2*s**(-3)*t1**(-2)
     +    *u1 + 1024*ms1**2*s**(-3)*t1**(-1) - 1024*ms1**2*s**(-3)*t1*
     +    u1**(-2) - 4096*ms1**2*s**(-3)*t1*s4**(-2) + 1024*ms1**2*
     +    s**(-3)*u1**(-1) - 2048*ms1**2*s**(-3)*s4**(-1) - 1024*ms1**2
     +    *s**(-2)*t1**(-2) - 1024*ms1**2*s**(-2)*u1**(-2) - 1024*
     +    ms1**4*s**(-3)*t1**(-2) + 2048*ms1**4*s**(-3)*t1**(-1)*
     +    s4**(-1) - 1024*ms1**4*s**(-3)*u1**(-2) + 2048*ms1**4*s**(-3)
     +    *u1**(-1)*s4**(-1) - 4096*ms1**4*s**(-3)*s4**(-2) + 1024*
     +    s**(-4)*t1**(-1)*u1**2 + 3072*s**(-4)*t1 + 1024*s**(-4)*t1**2
     +    *u1**(-1) - 4096*s**(-4)*t1**2*s4**(-1) - 1024*s**(-4)*u1 + 
     +    1024*s**(-3)*t1**(-1)*u1 + 1024*s**(-3)*t1*u1**(-1) - 4096*
     +    s**(-3)*t1*s4**(-1) )

      LQ_QB3 = fac * LQ_QB3

      end

c --------------------------------------------------------------------
      real*8 function LQ_QBD(s,t1,s4,ms1,del,s4max)

      implicit none 

      real*8 Pi,Nc,Cf,alphas,fac 
      real*8 s,t1,u1,ms1,s4,del,s4max 
      real*8 xw,COLO1(9),dldel1,dldel2 
      real*8 m2(5)

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      alphas = 1.D0
      
      u1 = - s - t1 
      xw = sqrt(1.D0-4.D0*ms1**2/s)

      m2(1) = s 
      m2(2) = t1 
      m2(3) = u1 
      m2(4) = s4
      m2(5) = ms1**2 

      call LOGAS_LQ(m2,COLO1)

      dldel1 = log(s4max/ms1**2)
     &       - ( s4max - del )/s4 
      dldel2 = log(s4max/ms1**2)**2 
     &       - 2.D0* ( s4max - del )/s4 * log(s4/ms1**2)

      fac = 1.D0/(64*Pi*Nc**2)
      
      LQ_QBD =
     +  + Nc*Cf**2*Pi*alphas**3*dldel1 * ( 128*ms1**2*s**(-3) + 128*
     +    s**(-4)*t1**2 + 128*s**(-3)*t1 )
      LQ_QBD = LQ_QBD + Nc*Cf**2*Pi*alphas**3*dldel2 * (  - 128*ms1**2*
     +    s**(-3) - 128*s**(-4)*t1**2 - 128*s**(-3)*t1 )
      LQ_QBD = LQ_QBD + COLO1(1)*Nc*Cf**2*Pi*alphas**3*dldel1 * ( -256*
     +    ms1**2*s**(-5)*t1**2*xw**(-1) - 256*ms1**2*s**(-4)*t1*
     +    xw**(-1) + 128*ms1**2*s**(-3)*xw**(-1) - 256*ms1**4*s**(-4)*
     +    xw**(-1) + 128*s**(-4)*t1**2*xw**(-1) + 128*s**(-3)*t1*
     +    xw**(-1) )
      LQ_QBD = LQ_QBD + COLO1(1)*Nc**2*Cf*Pi*alphas**3*dldel1 * ( 128*
     +    ms1**2*s**(-5)*t1**2*xw**(-1) + 128*ms1**2*s**(-4)*t1*
     +    xw**(-1) - 64*ms1**2*s**(-3)*xw**(-1) + 128*ms1**4*s**(-4)*
     +    xw**(-1) - 64*s**(-4)*t1**2*xw**(-1) - 64*s**(-3)*t1*xw**(-1)
     +     )
      LQ_QBD = LQ_QBD + COLO1(3)*Nc*Cf**2*Pi*alphas**3*dldel1 * ( -128*
     +    ms1**2*s**(-3) - 128*s**(-4)*t1**2 - 128*s**(-3)*t1 )
      LQ_QBD = LQ_QBD + COLO1(3)*Nc**2*Cf*Pi*alphas**3*dldel1 * ( 64*
     +    ms1**2*s**(-3) + 64*s**(-4)*t1**2 + 64*s**(-3)*t1 )
      LQ_QBD = LQ_QBD + COLO1(4)*Nc*Cf**2*Pi*alphas**3*dldel1 * ( -384*
     +    ms1**2*s**(-3) - 384*s**(-4)*t1**2 - 384*s**(-3)*t1 )
      LQ_QBD = LQ_QBD + COLO1(4)*Nc**2*Cf*Pi*alphas**3*dldel1 * ( 128*
     +    ms1**2*s**(-3) + 128*s**(-4)*t1**2 + 128*s**(-3)*t1 )
      LQ_QBD = LQ_QBD + COLO1(8)*Nc*Cf**2*Pi*alphas**3*dldel1 * ( 640*
     +    ms1**2*s**(-3) + 640*s**(-4)*t1**2 + 640*s**(-3)*t1 )
      LQ_QBD = LQ_QBD + COLO1(8)*Nc**2*Cf*Pi*alphas**3*dldel1 * ( -256*
     +    ms1**2*s**(-3) - 256*s**(-4)*t1**2 - 256*s**(-3)*t1 )

      LQ_QBD = fac * LQ_QBD 

      end 



c --------------------------------------------------------------------
      real*8 function LQ_QBV(s,t1,ms1,mt)

      implicit none 

      real*8 Pi,Nc,Cf,Nf,alphas,fac,Nl 
      real*8 s,t1,u1,ms1,mt
      real*8 ms12
      real*8 m2(2,6),softin(4)
      real*8 SK3B0A(5),SK3B0B(6),SK3B0C(2),SK3B0D(2,2),SK3BP(3) 
      real*8 SK3C0A(8),SK3C0B(4),SK3C0C(5,2),SK3D0(7,2)
      real*8 SOF1(8) 
      real*8 mur,dec,LQ_QBB

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      Nf = 6.D0
      Nl = 1.D0
      alphas = 1.D0

      u1 = - s - t1 
      fac = 1.D0/(64*Pi*Nc**2)

      m2(1,1) = s 
      m2(1,2) = t1 + ms1**2  
      m2(1,3) = u1 + ms1**2 
      m2(1,4) = t1
      m2(1,5) = u1
      m2(2,1) = ms1**2 
      m2(2,2) = 1.D0 
      m2(2,3) = 1.D0 
      m2(2,4) = 1.D0 
      m2(2,5) = mt**2 
      m2(2,6) = ms1**2 

      call SCALAR_ARRAY_LQ_B(m2,SK3B0A,SK3B0B,SK3B0C,SK3B0D,SK3BP)
      call SCALAR_ARRAY_LQ_C(m2,SK3C0A,SK3C0B,SK3C0C,SK3D0)

c      write(99,*)'test1 ',m2

      softin(1) = s
      softin(2) = t1 
      softin(3) = u1 
      softin(4) = ms1**2 

      call SOFT_ARRAY_LQ(softin,SOF1)

      mur = ms1
      
c decoupling of the heavy flavours from alpha_s      
      dec = 2.D0*alphas/Pi * LQ_QBB(s,t1,ms1)*
     &      (  Nl/24.D0        * log(mur**2/ms1**2)
     &       + 1.D0/6.D0       * log(mur**2/mt**2)  )

      ms12 = ms1**2 

      LQ_QBV =
     +  + Nc*Cf*Pi*alphas**3 * (  - 64./9.*Nf*ms1**2*s**(-3) - 64./9.*
     +    Nf*s**(-4)*t1**2 - 64./9.*Nf*s**(-3)*t1 + 32./9.*Nl*ms1**2*
     +    s**(-3) + 32./9.*Nl*s**(-4)*t1**2 + 32./9.*Nl*s**(-3)*t1 )
      LQ_QBV = LQ_QBV + Nc*Cf**2*Pi*alphas**3 * ( 64*ms1**2*s**(-3)+64*
     +    s**(-4)*t1**2 + 64*s**(-3)*t1 )
      LQ_QBV = LQ_QBV + Nc**2*Cf*Pi*alphas**3 * (  - 320./9.*ms1**2*
     +    s**(-3) - 320./9.*s**(-4)*t1**2 - 320./9.*s**(-3)*t1 )
      LQ_QBV = LQ_QBV + SK3B0A(2)*Nc*Cf*Pi*alphas**3 * ( -128./3.*mt**2
     +    *ms1**2*s**(-4) - 128./3.*mt**2*s**(-5)*t1**2 - 128./3.*mt**2
     +    *s**(-4)*t1 )
      LQ_QBV = LQ_QBV + SK3B0B(1)*Nc*Cf*Pi*alphas**3*( 64./3.*Nf*ms1**2
     +    *s**(-3) + 64./3.*Nf*s**(-4)*t1**2 + 64./3.*Nf*s**(-3)*t1 - 
     +    64./3.*ms1**2*s**(-3) - 64./3.*s**(-4)*t1**2 - 64./3.*s**(-3)
     +    *t1 )
      LQ_QBV = LQ_QBV + SK3B0B(1)*Nc*Cf**2*Pi*alphas**3 * ( 96*ms1**2*
     +    s**(-3) + 96*s**(-4)*t1**2 + 96*s**(-3)*t1 )
      LQ_QBV = LQ_QBV + SK3B0B(1)*Nc**2*Cf*Pi*alphas**3 * ( 32*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*s**(-2)*
     +    t1 + 8*(s-4*ms12)**(-1)*s**(-1) - 256./3.*ms1**2*s**(-3) - 
     +    256./3.*s**(-4)*t1**2 - 256./3.*s**(-3)*t1 - 8*s**(-2) )
      LQ_QBV = LQ_QBV + SK3B0B(2)*Nc*Cf*Pi*alphas**3 * (  - 64./3.*Nl*
     +    ms1**2*s**(-5)*t1**2 - 64./3.*Nl*ms1**2*s**(-4)*t1 + 16./3.*
     +    Nl*ms1**2*s**(-3) - 64./3.*Nl*ms1**4*s**(-4) + 16./3.*Nl*
     +    s**(-4)*t1**2 + 16./3.*Nl*s**(-3)*t1 )
      LQ_QBV = LQ_QBV + SK3B0B(2)*Nc*Cf**2*Pi*alphas**3 * ( 64*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 64*(s-4*ms12)**(-1)*s**(-2)*
     +    t1 + 16*(s-4*ms12)**(-1)*s**(-1) + 64*ms1**2*s**(-3) + 64*
     +    s**(-4)*t1**2 + 64*s**(-3)*t1 - 16*s**(-2) )
      LQ_QBV = LQ_QBV + SK3B0B(2)*Nc**2*Cf*Pi*alphas**3 * (  - 32*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)*s**(-2)*
     +    t1 - 8*(s-4*ms12)**(-1)*s**(-1) - 32*ms1**2*s**(-3) - 32*
     +    s**(-4)*t1**2 - 32*s**(-3)*t1 + 8*s**(-2) )
      LQ_QBV = LQ_QBV + SK3B0B(4)*Nc*Cf*Pi*alphas**3 * ( 128./3.*mt**2*
     +    ms1**2*s**(-4) + 128./3.*mt**2*s**(-5)*t1**2 + 128./3.*mt**2*
     +    s**(-4)*t1 + 64./3.*ms1**2*s**(-3) + 64./3.*s**(-4)*t1**2 + 
     +    64./3.*s**(-3)*t1 )
      LQ_QBV = LQ_QBV + SK3B0C(1)*Nc*Cf**2*Pi*alphas**3 * (  - 64*
     +    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 64*(s-4*ms12)**(-1)*s**(-2)*
     +    t1 - 16*(s-4*ms12)**(-1)*s**(-1) - 64*ms1**2*s**(-3) - 64*
     +    s**(-4)*t1**2 - 64*s**(-3)*t1 + 16*s**(-2) )
      LQ_QBV = LQ_QBV + SK3BP(1)*Nc*Cf**2*Pi*alphas**3 * ( -128*ms1**2*
     +    s**(-4)*t1**2 - 128*ms1**2*s**(-3)*t1 - 128*ms1**4*s**(-3) )
      LQ_QBV = LQ_QBV + SK3C0A(1)*Nc*Cf**2*Pi*alphas**3 * ( 64*ms1**2*
     +    s**(-2) + 64*s**(-3)*t1**2 + 192*s**(-2)*t1 + 64*s**(-1) )
      LQ_QBV = LQ_QBV + SK3C0A(1)*Nc**2*Cf*Pi*alphas**3 * ( -48*ms1**2*
     +    s**(-2) - 64*s**(-3)*t1**2 - 112*s**(-2)*t1 - 32*s**(-1) )
      LQ_QBV = LQ_QBV + SK3C0B(1)*Nc*Cf**2*Pi*alphas**3 * ( -128*ms1**2
     +    *s**(-4)*t1**2 - 128*ms1**2*s**(-3)*t1 + 64*ms1**2*s**(-2) - 
     +    128*ms1**4*s**(-3) + 64*s**(-3)*t1**2 + 64*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SK3C0B(1)*Nc**2*Cf*Pi*alphas**3 * ( 64*ms1**2*
     +    s**(-4)*t1**2 + 64*ms1**2*s**(-3)*t1 - 32*ms1**2*s**(-2) + 64
     +    *ms1**4*s**(-3) - 32*s**(-3)*t1**2 - 32*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SK3C0B(2)*Nc*Cf**2*Pi*alphas**3 * ( -256*ms1**2
     +    *s**(-3)*t1 - 128*ms1**2*s**(-2) + 128*s**(-2)*t1 + 64*
     +    s**(-1) )
      LQ_QBV = LQ_QBV + SK3C0B(2)*Nc**2*Cf*Pi*alphas**3 * ( 16*
     +    (s-4*ms12)**(-1)*s**(-2)*t1**2 + 16*(s-4*ms12)**(-1)*s**(-1)*
     +    t1 + 4*(s-4*ms12)**(-1) + 96*ms1**2*s**(-3)*t1 + 32*ms1**2*
     +    s**(-2) - 48*s**(-3)*t1**2 - 96*s**(-2)*t1 - 36*s**(-1) )
      LQ_QBV = LQ_QBV + SK3C0C(1,1)*Nc*Cf**2*Pi*alphas**3 *(128*ms1**2*
     +    s**(-3)*t1 + 128*s**(-3)*t1**2 )
      LQ_QBV = LQ_QBV + SK3C0C(1,1)*Nc**2*Cf*Pi*alphas**3 * (  - 32*
     +    ms1**2*s**(-3)*t1 - 32*s**(-3)*t1**2 )
      LQ_QBV = LQ_QBV + SK3C0C(1,2)*Nc*Cf**2*Pi*alphas**3 *(128*ms1**2*
     +    s**(-3)*t1 + 128*ms1**2*s**(-2) - 128*s**(-3)*t1**2 - 256*
     +    s**(-2)*t1 - 128*s**(-1) )
      LQ_QBV = LQ_QBV + SK3C0C(1,2)*Nc**2*Cf*Pi*alphas**3 * (  - 64*
     +    ms1**2*s**(-3)*t1 - 64*ms1**2*s**(-2) + 64*s**(-3)*t1**2 + 
     +    128*s**(-2)*t1 + 64*s**(-1) )
      LQ_QBV = LQ_QBV + SK3D0(1,1)*Nc*Cf**2*Pi*alphas**3 * ( 64*ms1**2*
     +    s**(-2)*t1 + 128*s**(-3)*t1**3 + 64*s**(-2)*t1**2 )
      LQ_QBV = LQ_QBV + SK3D0(1,1)*Nc**2*Cf*Pi*alphas**3 * ( -16*ms1**2
     +    *s**(-2)*t1 - 32*s**(-3)*t1**3 - 16*s**(-2)*t1**2 )
      LQ_QBV = LQ_QBV + SK3D0(1,2)*Nc*Cf**2*Pi*alphas**3 * ( 64 + 64*
     +    ms1**2*s**(-2)*t1 + 64*ms1**2*s**(-1) + 128*s**(-3)*t1**3 + 
     +    320*s**(-2)*t1**2 + 256*s**(-1)*t1 )
      LQ_QBV = LQ_QBV + SK3D0(1,2)*Nc**2*Cf*Pi*alphas**3 * ( -32 - 32*
     +    ms1**2*s**(-2)*t1 - 32*ms1**2*s**(-1) - 64*s**(-3)*t1**3 - 
     +    160*s**(-2)*t1**2 - 128*s**(-1)*t1 )
      LQ_QBV = LQ_QBV + SOF1(1)*Nc*Cf**2*Pi*alphas**3 * ( 512*ms1**2*
     +    s**(-4)*t1**2 + 512*ms1**2*s**(-3)*t1 - 256*ms1**2*s**(-2) + 
     +    512*ms1**4*s**(-3) - 256*s**(-3)*t1**2 - 256*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SOF1(1)*Nc**2*Cf*Pi*alphas**3 * ( -256*ms1**2*
     +    s**(-4)*t1**2 - 256*ms1**2*s**(-3)*t1 + 128*ms1**2*s**(-2) - 
     +    256*ms1**4*s**(-3) + 128*s**(-3)*t1**2 + 128*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SOF1(2)*Nc*Cf**2*Pi*alphas**3 * ( 256*ms1**2*
     +    s**(-4)*t1**2 + 256*ms1**2*s**(-3)*t1 + 256*ms1**4*s**(-3) )
      LQ_QBV = LQ_QBV + SOF1(3)*Nc*Cf**2*Pi*alphas**3 * ( 256*ms1**2*
     +    s**(-4)*t1**2 + 256*ms1**2*s**(-3)*t1 + 256*ms1**4*s**(-3) )
      LQ_QBV = LQ_QBV + SOF1(4)*Nc*Cf**2*Pi*alphas**3 * ( -512*ms1**2*
     +    s**(-3)*t1 - 512*ms1**2*s**(-2) - 512*s**(-4)*t1**3 - 1024*
     +    s**(-3)*t1**2 - 512*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SOF1(4)*Nc**2*Cf*Pi*alphas**3 * ( 256*ms1**2*
     +    s**(-3)*t1 + 256*ms1**2*s**(-2) + 256*s**(-4)*t1**3 + 512*
     +    s**(-3)*t1**2 + 256*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SOF1(5)*Nc*Cf**2*Pi*alphas**3 * ( -512*ms1**2*
     +    s**(-3)*t1 - 512*s**(-4)*t1**3 - 512*s**(-3)*t1**2 )
      LQ_QBV = LQ_QBV + SOF1(5)*Nc**2*Cf*Pi*alphas**3 * ( 128*ms1**2*
     +    s**(-3)*t1 + 128*s**(-4)*t1**3 + 128*s**(-3)*t1**2 )
      LQ_QBV = LQ_QBV + SOF1(6)*Nc*Cf**2*Pi*alphas**3 * ( -512*ms1**2*
     +    s**(-3)*t1 - 512*s**(-4)*t1**3 - 512*s**(-3)*t1**2 )
      LQ_QBV = LQ_QBV + SOF1(6)*Nc**2*Cf*Pi*alphas**3 * ( 128*ms1**2*
     +    s**(-3)*t1 + 128*s**(-4)*t1**3 + 128*s**(-3)*t1**2 )
      LQ_QBV = LQ_QBV + SOF1(7)*Nc*Cf**2*Pi*alphas**3 * ( -512*ms1**2*
     +    s**(-3)*t1 - 512*ms1**2*s**(-2) - 512*s**(-4)*t1**3 - 1024*
     +    s**(-3)*t1**2 - 512*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SOF1(7)*Nc**2*Cf*Pi*alphas**3 * ( 256*ms1**2*
     +    s**(-3)*t1 + 256*ms1**2*s**(-2) + 256*s**(-4)*t1**3 + 512*
     +    s**(-3)*t1**2 + 256*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SOF1(8)*Nc*Cf**2*Pi*alphas**3 * ( -256*ms1**2*
     +    s**(-2) - 256*s**(-3)*t1**2 - 256*s**(-2)*t1 )
      LQ_QBV = LQ_QBV + SOF1(8)*Nc**2*Cf*Pi*alphas**3 * ( 128*ms1**2*
     +    s**(-2) + 128*s**(-3)*t1**2 + 128*s**(-2)*t1 )

      LQ_QBV = fac * LQ_QBV  + dec

      end




c --------------------------------------------------------------------
      real*8 function LQ_QBH(s,t1,s4,ms1)

      implicit none 

      real*8 Pi,Nc,Cf,alphas,fac 
      real*8 s,t1,u1,ms1,s4
      real*8 hardin(5)
      real*8 ANG4(71),COLO1(9)

      Pi = 4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      alphas = 1.D0

      u1 = s4 - s - t1 
      fac = s4 /(s4+ms1**2) /8.D0 /(16*Pi**2)**2 /Nc**2

      hardin(1) = s
      hardin(2) = t1 
      hardin(3) = u1 
      hardin(4) = s4 
      hardin(5) = ms1**2 

      call LOGAS_LQ(hardin,COLO1)
      call ANGULAR_ARRAY_LQ(hardin,ANG4)

      LQ_QBH =
     +  + Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2*s**(-4)*t1**(-1)*u1
     +     + 1024*ms1**2*s**(-4)*t1*u1**(-1) - 4096*ms1**2*s**(-4)*t1*
     +    s4**(-1) + 2048*ms1**2*s**(-4)*t1**2*s4**(-2) + 2048*ms1**2*
     +    s**(-4) - 1024*ms1**2*s**(-3)*t1**(-2)*u1 - 1024*ms1**2*
     +    s**(-3)*t1**(-1) - 1024*ms1**2*s**(-3)*t1*u1**(-2) + 2048*
     +    ms1**2*s**(-3)*t1*s4**(-2) - 1024*ms1**2*s**(-3)*u1**(-1) - 
     +    1024*ms1**2*s**(-2)*t1**(-2) - 1024*ms1**2*s**(-2)*u1**(-2)
     +     - 1024*ms1**4*s**(-3)*t1**(-2) - 1024*ms1**4*s**(-3)*
     +    u1**(-2) + 2048*ms1**4*s**(-3)*s4**(-2) + 1024*s**(-4)*
     +    t1**(-1)*u1**2 + 1024*s**(-4)*t1 + 1024*s**(-4)*t1**2*
     +    u1**(-1) + 1024*s**(-4)*u1 + 1024*s**(-3)*t1**(-1)*u1 + 1024*
     +    s**(-3)*t1*u1**(-1) + 1024*s**(-3)*t1*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(9)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2*
     +    s**(-4) )
      LQ_QBH = LQ_QBH + ANG4(10)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-3) )
      LQ_QBH = LQ_QBH + ANG4(11)*Nc**2*Cf*Pi**4*alphas**3 * ( -1024*
     +    ms1**2*s**(-5)*s4*(t1+u1)**(-1) + 1024*ms1**2*s**(-5) )
      LQ_QBH = LQ_QBH + ANG4(12)*Nc*Cf**2*Pi**4*alphas**3 *(2048*ms1**2
     +    *s**(-4)*t1*s4**(-1) - 4096*ms1**2*s**(-4)*s4*(t1+u1)**(-1)
     +     + 2048*ms1**2*s**(-4) + 1024*ms1**2*s**(-3)*s4**(-1) - 1024*
     +    s**(-3)*t1*s4**(-1) + 512*s**(-3) - 512*s**(-2)*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(12)*Nc**2*Cf*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-5)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-5)*t1 - 1024*
     +    ms1**2*s**(-4)*t1*s4**(-1) + 512*ms1**2*s**(-4)*s4*
     +    (t1+u1)**(-1) - 512*ms1**2*s**(-4) - 512*ms1**2*s**(-3)*
     +    s4**(-1) + 512*s**(-3)*t1*s4**(-1) - 256*s**(-3) + 256*
     +    s**(-2)*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(13)*Nc**2*Cf*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-4) )
      LQ_QBH = LQ_QBH + ANG4(14)*Nc**2*Cf*Pi**4*alphas**3 *(2048*ms1**2
     +    *s**(-4)*u1 + 1024*ms1**2*s**(-3) )
      LQ_QBH = LQ_QBH + ANG4(15)*Nc**2*Cf*Pi**4*alphas**3 * (  - 1024*
     +    ms1**2*s**(-5)*s4*(t1+u1)**(-1) + 1024*ms1**2*s**(-5) )
      LQ_QBH = LQ_QBH + ANG4(16)*Nc*Cf**2*Pi**4*alphas**3 * (  - 4096*
     +    ms1**2*s**(-4)*s4*(t1+u1)**(-1) + 4096*ms1**2*s**(-4) )
      LQ_QBH = LQ_QBH + ANG4(16)*Nc**2*Cf*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-5)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-5)*t1 - 1024*
     +    ms1**2*s**(-4)*t1*s4**(-1) + 512*ms1**2*s**(-4)*s4*
     +    (t1+u1)**(-1) - 512*ms1**2*s**(-4) - 512*ms1**2*s**(-3)*
     +    s4**(-1) + 512*s**(-3)*t1*s4**(-1) - 256*s**(-3) + 256*
     +    s**(-2)*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(36)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**4
     +    *s**(-3) )
      LQ_QBH = LQ_QBH + ANG4(37)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-3)*t1*s4**(-1) - 2048*ms1**2*s**(-3)*s4*(t1+u1)**(-1)
     +     + 2048*ms1**2*s**(-3) - 1024*ms1**2*s**(-2)*s4**(-1) + 2048*
     +    ms1**4*s**(-3)*s4**(-1) + 1024*s**(-3)*t1 - 1024*s**(-3)*u1
     +     - 512*s**(-2)*t1*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(37)*Nc**2*Cf*Pi**4*alphas**3 *(512*ms1**2*
     +    s**(-4)*t1*s4*(t1+u1)**(-1) - 512*ms1**2*s**(-4)*t1 - 512*
     +    ms1**2*s**(-3)*t1*s4**(-1) + 512*ms1**2*s**(-3)*s4*
     +    (t1+u1)**(-1) - 768*ms1**2*s**(-3) + 512*ms1**2*s**(-2)*
     +    s4**(-1) - 1024*ms1**4*s**(-3)*s4**(-1) + 512*s**(-4)*t1**2*
     +    s4*(t1+u1)**(-1) - 512*s**(-4)*t1**2 - 768*s**(-3)*t1 + 512*
     +    s**(-3)*u1 + 256*s**(-2)*t1*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(38)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-2) )
      LQ_QBH = LQ_QBH + ANG4(38)*Nc**2*Cf*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-4)*u1**2 + 1024*ms1**2*s**(-3)*u1 + 512*ms1**2*s**(-2)
     +     )
      LQ_QBH = LQ_QBH + ANG4(39)*Nc*Cf**2*Pi**4*alphas**3 *(4096*ms1**2
     +    *s**(-3)*t1*s4**(-1) - 2048*ms1**2*s**(-3)*s4*(t1+u1)**(-1)
     +     - 2048*ms1**2*s**(-3) + 2048*ms1**2*s**(-2)*s4**(-1) - 2048*
     +    s**(-2)*t1*s4**(-1) + 1024*s**(-2) - 1024*s**(-1)*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(39)*Nc**2*Cf*Pi**4*alphas**3 *(512*ms1**2*
     +    s**(-4)*t1*s4*(t1+u1)**(-1) - 1536*ms1**2*s**(-4)*t1 + 1024*
     +    ms1**2*s**(-4)*t1**2*s4**(-1) + 1024*ms1**2*s**(-4)*u1 - 512*
     +    ms1**2*s**(-3)*t1*s4**(-1) + 512*ms1**2*s**(-3)*s4*
     +    (t1+u1)**(-1) + 1024*ms1**2*s**(-3) - 256*ms1**2*s**(-2)*
     +    s4**(-1) + 512*s**(-4)*t1**2*s4*(t1+u1)**(-1) - 512*s**(-4)*
     +    t1**2 - 512*s**(-3)*t1 + 512*s**(-3)*t1**2*s4**(-1) + 256*
     +    s**(-3)*u1 + 1280*s**(-2)*t1*s4**(-1) - 512*s**(-2) + 512*
     +    s**(-1)*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(48)*Nc*Cf**2*Pi**4*alphas**3 * (  - 1024*
     +    ms1**2*s**(-2) - 512*s**(-3)*t1**2 - 512*s**(-3)*u1**2 - 512*
     +    s**(-2)*t1 - 512*s**(-2)*u1 )
      LQ_QBH = LQ_QBH + ANG4(48)*Nc**2*Cf*Pi**4*alphas**3 *(512*ms1**2*
     +    s**(-2) + 256*s**(-3)*t1**2 + 256*s**(-3)*u1**2 + 256*s**(-2)
     +    *t1 + 256*s**(-2)*u1 )
      LQ_QBH = LQ_QBH + ANG4(49)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-3)*t1*s4*(t1+u1)**(-1) - 2048*ms1**2*s**(-3)*t1 + 2048*
     +    s**(-4)*t1**3*s4*(t1+u1)**(-1) - 2048*s**(-4)*t1**3 + 1024*
     +    s**(-3)*t1**2*s4*(t1+u1)**(-1) - 2048*s**(-3)*t1**2 )
      LQ_QBH = LQ_QBH + ANG4(49)*Nc**2*Cf*Pi**4*alphas**3 * (  - 256*
     +    ms1**2*s**(-3)*t1*s4*(t1+u1)**(-1) + 512*ms1**2*s**(-3)*t1 - 
     +    512*s**(-4)*t1**3*s4*(t1+u1)**(-1) + 512*s**(-4)*t1**3 - 256*
     +    s**(-3)*t1**2*s4*(t1+u1)**(-1) + 512*s**(-3)*t1**2 )
      LQ_QBH = LQ_QBH + ANG4(50)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-3)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-3)*t1 + 1024*
     +    ms1**2*s**(-3)*u1 - 1024*ms1**2*s**(-2) + 2048*s**(-4)*t1**3*
     +    s4*(t1+u1)**(-1) - 2048*s**(-4)*t1**3 + 2048*s**(-3)*t1*u1 - 
     +    1024*s**(-3)*t1**2*s4*(t1+u1)**(-1) - 1024*s**(-3)*t1**2 - 
     +    1024*s**(-3)*u1**2 + 1024*s**(-2)*t1 - 1024*s**(-2)*u1 )
      LQ_QBH = LQ_QBH + ANG4(50)*Nc**2*Cf*Pi**4*alphas**3 * (  - 512*
     +    ms1**2*s**(-3)*t1*s4*(t1+u1)**(-1) + 512*ms1**2*s**(-3)*t1 - 
     +    512*ms1**2*s**(-3)*u1 + 512*ms1**2*s**(-2) - 1024*s**(-4)*
     +    t1**3*s4*(t1+u1)**(-1) + 1024*s**(-4)*t1**3 - 1024*s**(-3)*t1
     +    *u1 + 512*s**(-3)*t1**2*s4*(t1+u1)**(-1) + 512*s**(-3)*t1**2
     +     + 512*s**(-3)*u1**2 - 512*s**(-2)*t1 + 512*s**(-2)*u1 )
      LQ_QBH = LQ_QBH + ANG4(52)*Nc*Cf**2*Pi**4*alphas**3 *(512*ms1**2*
     +    s**(-1) )
      LQ_QBH = LQ_QBH + ANG4(54)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-3)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-3)*t1 - 1024*
     +    ms1**2*s**(-2)*t1*s4**(-1) + 512*ms1**2*s**(-2) - 1024*ms1**2
     +    *s**(-1)*s4**(-1) + 2048*s**(-4)*t1**3*s4*(t1+u1)**(-1) - 
     +    2048*s**(-4)*t1**3 + 1024*s**(-3)*t1**2*s4*(t1+u1)**(-1) - 
     +    512*s**(-3)*t1**2 - 2048*s**(-3)*t1**3*s4**(-1) + 512*s**(-3)
     +    *u1**2 + 2560*s**(-2)*t1 - 5120*s**(-2)*t1**2*s4**(-1) - 1024
     +    *s**(-2)*u1 - 4096*s**(-1)*t1*s4**(-1) + 1024*s**(-1) - 1024*
     +    s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(54)*Nc**2*Cf*Pi**4*alphas**3 * (  - 256*
     +    ms1**2*s**(-3)*t1*s4*(t1+u1)**(-1) + 256*ms1**2*s**(-3)*t1 + 
     +    512*ms1**2*s**(-2)*t1*s4**(-1) - 256*ms1**2*s**(-2) + 512*
     +    ms1**2*s**(-1)*s4**(-1) - 512*s**(-4)*t1**3*s4*(t1+u1)**(-1)
     +     + 512*s**(-4)*t1**3 + 256*s**(-3)*t1*u1 - 256*s**(-3)*t1**2*
     +    s4*(t1+u1)**(-1) - 256*s**(-3)*t1**2 + 1024*s**(-3)*t1**3*
     +    s4**(-1) - 256*s**(-3)*u1**2 - 1280*s**(-2)*t1 + 2560*s**(-2)
     +    *t1**2*s4**(-1) + 512*s**(-2)*u1 + 2048*s**(-1)*t1*s4**(-1)
     +     - 512*s**(-1) + 512*s4**(-1) )
      LQ_QBH = LQ_QBH + ANG4(56)*Nc*Cf**2*Pi**4*alphas**3 *(512*ms1**2*
     +    s**(-1) )
      LQ_QBH = LQ_QBH + ANG4(58)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-3)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-3)*t1 - 1024*
     +    ms1**2*s**(-2)*t1*s4**(-1) + 512*ms1**2*s**(-2) + 2048*
     +    s**(-4)*t1**3*s4*(t1+u1)**(-1) - 2048*s**(-4)*t1**3 - 1024*
     +    s**(-3)*t1**2*s4*(t1+u1)**(-1) + 1536*s**(-3)*t1**2 - 2048*
     +    s**(-3)*t1**3*s4**(-1) + 512*s**(-3)*u1**2 + 1024*s**(-2)*t1
     +     - 1024*s**(-2)*t1**2*s4**(-1) + 512*s**(-2)*u1 )
      LQ_QBH = LQ_QBH + ANG4(58)*Nc**2*Cf*Pi**4*alphas**3 * (  - 512*
     +    ms1**2*s**(-3)*t1*s4*(t1+u1)**(-1) + 512*ms1**2*s**(-3)*t1 + 
     +    256*ms1**2*s**(-2)*t1*s4**(-1) - 1024*s**(-4)*t1**3*s4*
     +    (t1+u1)**(-1) + 1024*s**(-4)*t1**3 - 256*s**(-3)*t1*u1 + 512*
     +    s**(-3)*t1**2*s4*(t1+u1)**(-1) - 256*s**(-3)*t1**2 + 512*
     +    s**(-3)*t1**3*s4**(-1) - 512*s**(-2)*t1 + 256*s**(-2)*t1**2*
     +    s4**(-1) )
      LQ_QBH = LQ_QBH + COLO1(9)*Nc*Cf**2*Pi**4*alphas**3 *(1024*ms1**2
     +    *s**(-4)*t1**(-1)*u1 + 1024*ms1**2*s**(-4)*t1*u1**(-1) + 4096
     +    *ms1**2*s**(-4)*t1*s4**(-1) - 4096*ms1**2*s**(-4)*t1**2*
     +    s4**(-2) - 2048*ms1**2*s**(-4) - 1024*ms1**2*s**(-3)*t1**(-2)
     +    *u1 + 1024*ms1**2*s**(-3)*t1**(-1) - 1024*ms1**2*s**(-3)*t1*
     +    u1**(-2) - 4096*ms1**2*s**(-3)*t1*s4**(-2) + 1024*ms1**2*
     +    s**(-3)*u1**(-1) - 2048*ms1**2*s**(-3)*s4**(-1) - 1024*ms1**2
     +    *s**(-2)*t1**(-2) - 1024*ms1**2*s**(-2)*u1**(-2) - 1024*
     +    ms1**4*s**(-3)*t1**(-2) + 2048*ms1**4*s**(-3)*t1**(-1)*
     +    s4**(-1) - 1024*ms1**4*s**(-3)*u1**(-2) + 2048*ms1**4*s**(-3)
     +    *u1**(-1)*s4**(-1) - 4096*ms1**4*s**(-3)*s4**(-2) + 1024*
     +    s**(-4)*t1**(-1)*u1**2 + 3072*s**(-4)*t1 + 1024*s**(-4)*t1**2
     +    *u1**(-1) - 4096*s**(-4)*t1**2*s4**(-1) - 1024*s**(-4)*u1 + 
     +    1024*s**(-3)*t1**(-1)*u1 + 1024*s**(-3)*t1*u1**(-1) - 4096*
     +    s**(-3)*t1*s4**(-1) )

      LQ_QBH = fac * LQ_QBH 

      end







