c --------------------------------------------------------------------
      real*8 function TB_QBB(s,t1,ms1)

      implicit none 

      real*8 Pi,Nc,Cf,alphas,fac 
      real*8 s,t1,u1,ms1 

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      alphas = 1.D0
      
      u1 = - s - t1 

      fac = 1.D0/(64*Pi*Nc**2)
      
      TB_QBB = 
     +    Nc*Cf*Pi**2*alphas**2 * (  - 64*ms1**2*s**(-3) + 64*s**(-4)*
     +    t1*u1 )

      TB_QBB = fac * TB_QBB 
ctp      TB_QBB = fac * 389379660.D0 * TB_QBB 

      end

c --------------------------------------------------------------------
ctp  Nf number of SM quarks in the running of alpha_s
      real*8 function TB_QB1(s,t1,ms1,sca)

      implicit none 

      real*8 Pi,Nc,Cf,Nf,alphas
      real*8 s,t1,u1,ms1,sca 
      real*8 conalp,consof,TB_QBB

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      Nf = 6.D0
      alphas = 1.D0
      
      u1 = - s - t1 

      conalp = alphas/2.D0/Pi * TB_QBB(s,t1,ms1)
     &    * ( 11.D0/3.D0*Nc - 2.D0/3.D0 * (Nf-1.D0)) * 2.0*log(sca/ms1)

      consof = -alphas*Cf/2.D0/Pi * TB_QBB(s,t1,ms1)
     &       * ( - 2.D0 * log(-t1/ms1**2)
     &           - 2.D0 * log(-u1/ms1**2)
     &           + 3.D0                  ) * 2.0*log(sca/ms1)
 
      TB_QB1 = conalp + consof 

      end
c --------------------------------------------------------------------
      real*8 function TB_QB2(s,t1,s4,ms1,del,s4max,sca)

      implicit none 

      real*8 Pi,Cf,alphas
      real*8 s,t1,s4,del,s4max,ms1,sca 
      real*8 dldel1,TB_QBB

      Pi=4.D0*atan(1.D0)
      Cf = 4.D0/3.D0 
      alphas = 1.D0
      
      dldel1 = log(s4max/ms1**2)
     &       - ( s4max - del )/s4 

      TB_QB2 = -alphas*Cf/2.D0/Pi * TB_QBB(s,t1,ms1)
     &      * 4.D0*dldel1 * 2.0*log(sca/ms1)

      end

c --------------------------------------------------------------------
      real*8 function TB_QB3(s,t1,s4,ms1,sca)

      implicit none 

      real*8 Pi,Nc,Cf,alphas,fac 
      real*8 s,t1,u1,s4,ms1,sca 
      real*8 COLO1(9)

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      alphas = 1.D0
      
      u1 = s4 - s - t1 

      fac = s4 /(s4+ms1**2) /8.D0 /(16*Pi**2)**2 /Nc**2
      
      COLO1(9) = -2.0*log(sca/ms1)

      TB_QB3 = 0.D0
      TB_QB3=TB_QB3 + COLO1(9)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-4)*t1**(-1)*u1 + 1024*ms1**2*s**(-4)*t1*u1**(-1) + 4096
     +    *ms1**2*s**(-4)*t1*s4**(-1) - 4096*ms1**2*s**(-4)*t1**2*
     +    s4**(-2) - 2048*ms1**2*s**(-4) - 1024*ms1**2*s**(-3)*t1**(-2)
     +    *u1 + 1024*ms1**2*s**(-3)*t1**(-1) - 1024*ms1**2*s**(-3)*t1*
     +    u1**(-2) - 4096*ms1**2*s**(-3)*t1*s4**(-2) + 1024*ms1**2*
     +    s**(-3)*u1**(-1) - 2048*ms1**2*s**(-3)*s4**(-1) - 1024*ms1**2
     +    *s**(-2)*t1**(-2) - 1024*ms1**2*s**(-2)*u1**(-2) - 1024*
     +    ms1**4*s**(-3)*t1**(-2) + 2048*ms1**4*s**(-3)*t1**(-1)*
     +    s4**(-1) - 1024*ms1**4*s**(-3)*u1**(-2) + 2048*ms1**4*s**(-3)
     +    *u1**(-1)*s4**(-1) - 4096*ms1**4*s**(-3)*s4**(-2) + 1024*
     +    s**(-4)*t1**(-1)*u1**2 + 3072*s**(-4)*t1 + 1024*s**(-4)*t1**2
     +    *u1**(-1) - 4096*s**(-4)*t1**2*s4**(-1) - 1024*s**(-4)*u1 + 
     +    1024*s**(-3)*t1**(-1)*u1 + 1024*s**(-3)*t1*u1**(-1) - 4096*
     +    s**(-3)*t1*s4**(-1) )

      TB_QB3 = fac * TB_QB3
ctp      TB_QB3 = fac * 389379660.D0 * TB_QB3

      end

c --------------------------------------------------------------------
      real*8 function TB_QBD(s,t1,s4,ms1,del,s4max)

      implicit none 

      real*8 Pi,Nc,Cf,alphas,fac 
      real*8 s,t1,u1,ms1,s4,del,s4max 
      real*8 xw,COLO1(9),dldel1,dldel2 
      real*8 m2(5)

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      alphas = 1.D0
      
      u1 = - s - t1 
      xw = sqrt(1.D0-4.D0*ms1**2/s)

      m2(1) = s 
      m2(2) = t1 
      m2(3) = u1 
      m2(4) = s4
      m2(5) = ms1**2 

      call LOGAS_LQ(m2,COLO1)

      dldel1 = log(s4max/ms1**2)
     &       - ( s4max - del )/s4 
      dldel2 = log(s4max/ms1**2)**2 
     &       - 2.D0* ( s4max - del )/s4 * log(s4/ms1**2)

      fac = 1.D0/(64*Pi*Nc**2)
      
      TB_QBD =
     +  + Nc*Cf**2*Pi*alphas**3*dldel1 * ( 128*ms1**2*s**(-3) + 128*
     +    s**(-4)*t1**2 + 128*s**(-3)*t1 )
      TB_QBD=TB_QBD + Nc*Cf**2*Pi*alphas**3*dldel2 * (  - 128*ms1**2*
     +    s**(-3) - 128*s**(-4)*t1**2 - 128*s**(-3)*t1 )
      TB_QBD=TB_QBD + COLO1(1)*Nc*Cf**2*Pi*alphas**3*dldel1 * (  - 256*
     +    ms1**2*s**(-5)*t1**2*xw**(-1) - 256*ms1**2*s**(-4)*t1*
     +    xw**(-1) + 128*ms1**2*s**(-3)*xw**(-1) - 256*ms1**4*s**(-4)*
     +    xw**(-1) + 128*s**(-4)*t1**2*xw**(-1) + 128*s**(-3)*t1*
     +    xw**(-1) )
      TB_QBD=TB_QBD + COLO1(1)*Nc**2*Cf*Pi*alphas**3*dldel1 * ( 128*
     +    ms1**2*s**(-5)*t1**2*xw**(-1) + 128*ms1**2*s**(-4)*t1*
     +    xw**(-1) - 64*ms1**2*s**(-3)*xw**(-1) + 128*ms1**4*s**(-4)*
     +    xw**(-1) - 64*s**(-4)*t1**2*xw**(-1) - 64*s**(-3)*t1*xw**(-1)
     +     )
      TB_QBD=TB_QBD + COLO1(3)*Nc*Cf**2*Pi*alphas**3*dldel1 * (  - 128*
     +    ms1**2*s**(-3) - 128*s**(-4)*t1**2 - 128*s**(-3)*t1 )
      TB_QBD=TB_QBD + COLO1(3)*Nc**2*Cf*Pi*alphas**3*dldel1 * ( 64*
     +    ms1**2*s**(-3) + 64*s**(-4)*t1**2 + 64*s**(-3)*t1 )
      TB_QBD=TB_QBD + COLO1(4)*Nc*Cf**2*Pi*alphas**3*dldel1 * (  - 384*
     +    ms1**2*s**(-3) - 384*s**(-4)*t1**2 - 384*s**(-3)*t1 )
      TB_QBD=TB_QBD + COLO1(4)*Nc**2*Cf*Pi*alphas**3*dldel1 * ( 128*
     +    ms1**2*s**(-3) + 128*s**(-4)*t1**2 + 128*s**(-3)*t1 )
      TB_QBD=TB_QBD + COLO1(8)*Nc*Cf**2*Pi*alphas**3*dldel1 * ( 640*
     +    ms1**2*s**(-3) + 640*s**(-4)*t1**2 + 640*s**(-3)*t1 )
      TB_QBD=TB_QBD + COLO1(8)*Nc**2*Cf*Pi*alphas**3*dldel1 * (  - 256*
     +    ms1**2*s**(-3) - 256*s**(-4)*t1**2 - 256*s**(-3)*t1 )

      TB_QBD = fac * TB_QBD 
ctp      TB_QBD = fac * 389379660.D0 * TB_QBD 

      end 

c --------------------------------------------------------------------
      real*8 function TB_QBV(s,t1,ms1,mg,mt,ms,ms2,mx1,mx2,s2t,susy)

      implicit none 

      real*8 Pi,Nc,Cf,Nf,Ns,alphas,fac,susy 
      real*8 s,t1,u1,ms1,mg,mt,ms,ms2,s2t
      real*8 ms12,mx1,mx2
      real*8 m2(2,8),softin(4)
      real*8 SK3B0A(7),SK3B0B(8),SK3B0C(3),SK3B0D(3,2),SK3BP(4) 
      real*8 SK3C0A(10),SK3C0B(6),SK3C0C(8,2),SK3D0(11,2)
      real*8 SOF1(8) 
      real*8 mur,dec,TB_QBB,STQBV

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      Nf = 6.D0
      Ns = 6.D0
      alphas = 1.D0

      u1 = - s - t1 
      fac = 1.D0/(64*Pi*Nc**2)

      m2(1,1) = s 
      m2(1,2) = t1 + ms1**2  
      m2(1,3) = u1 + ms1**2 
      m2(1,4) = t1
      m2(1,5) = u1
      m2(2,1) = ms1**2 
      m2(2,2) = ms2**2 
      m2(2,3) = ms**2 
      m2(2,4) = mg**2 
      m2(2,5) = mt**2 
      m2(2,6) = ms1**2 
      m2(2,7) = mx1**2 
      m2(2,8) = mx2**2 
      
      call SCALAR_ARRAY_TB_B_QS(m2,SK3B0A,SK3B0B,SK3B0C,SK3B0D,SK3BP)
      call SCALAR_ARRAY_TB_C_QS(m2,SK3C0A,SK3C0B,SK3C0C,SK3D0)

      softin(1) = s
      softin(2) = t1 
      softin(3) = u1 
      softin(4) = ms1**2 

      call SOFT_ARRAY_LQ(softin,SOF1)

      mur = ms1
      
      dec = 2.D0*alphas/Pi * TB_QBB(s,t1,ms1)*
     &      (  (Ns-2.D0)/12.D0 * susy * log(mur**2/ms**2)
     &       + 1.D0/24.D0             * log(mur**2/ms1**2)
     &       + 1.D0/24.D0      * susy * log(mur**2/ms2**2)
     &       + 1.D0/24.D0      * susy * log(mur**2/mx1**2)
     &       + 1.D0/24.D0      * susy * log(mur**2/mx2**2)
     &       + 1.D0/6.D0              * log(mur**2/mt**2) 
     &       + Nc/6.D0         * susy * log(mur**2/mg**2)   )

      ms12 = ms1**2 

      STQBV =
     &  + Nc*Cf*Pi*alphas**3 * (  - 32./9.*s**(-4)*t1**2 - 32./9.*
     &    s**(-3)*t1 - 32./9.*ms1**2*s**(-3) )
      STQBV = STQBV + Nc*Cf*(Nf-1)*Pi*alphas**3 * (  - 64./9.*s**(-4)*
     &    t1**2 - 64./9.*s**(-3)*t1 - 64./9.*ms1**2*s**(-3) )
      STQBV = STQBV + Nc*Cf**2*Pi*alphas**3 * ( 64*s**(-4)*t1**2 + 64*
     &    s**(-3)*t1 + 64*ms1**2*s**(-3) )
      STQBV = STQBV + Nc**2*Cf*Pi*alphas**3 * (  - 320./9.*s**(-4)*
     &    t1**2 - 320./9.*s**(-3)*t1 - 320./9.*ms1**2*s**(-3) )
      STQBV = STQBV + susy*Nc*Cf*Pi*alphas**3 * ( 32./3.*s**(-4)*t1**2
     &     + 32./3.*s**(-3)*t1 + 32./3.*ms1**2*s**(-3) )
      STQBV = STQBV + susy*Nc*Cf*(Ns-2)*Pi*alphas**3 * ( 64./9.*s**(-4)
     &    *t1**2 + 64./9.*s**(-3)*t1 + 64./9.*ms1**2*s**(-3) )
      STQBV = STQBV + susy*Nc*Cf**2*Pi*alphas**3 * (  - 32*s**(-4)*
     &    t1**2 - 32*s**(-3)*t1 - 32*ms1**2*s**(-3) )
      STQBV = STQBV + susy*Nc**2*Cf*Pi*alphas**3 * ( 224./9.*s**(-4)*
     &    t1**2 + 224./9.*s**(-3)*t1 + 224./9.*ms1**2*s**(-3) )
      STQBV = STQBV + SK3B0A(1)*susy*Nc**2*Cf*Pi*alphas**3 * (  - 128./
     &    3.*mg**2*s**(-5)*t1**2 - 128./3.*mg**2*s**(-4)*t1 - 128./3.*
     &    mg**2*ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0A(2)*Nc*Cf*Pi*alphas**3 * (  - 128./3.*mt**2
     &    *s**(-5)*t1**2 - 128./3.*mt**2*s**(-4)*t1 - 128./3.*mt**2*
     &    ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0A(3)*susy*Nc*Cf**2*Pi*alphas**3 * ( 32*
     &    s**(-4)*t1**2 + 32*s**(-3)*t1 + 32*ms1**2*s**(-3) - 64*ms**2*
     &    s**(-5)*t1**2 - 64*ms**2*s**(-4)*t1 - 64*ms**2*ms1**2*s**(-4)
     &     + 64*mg**2*s**(-5)*t1**2 + 64*mg**2*s**(-4)*t1 + 64*mg**2*
     &    ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0A(4)*susy*Nc*Cf*(Ns-2)*Pi*alphas**3 * ( 128./
     &    3.*ms**2*s**(-5)*t1**2 + 128./3.*ms**2*s**(-4)*t1 + 128./3.*
     &    ms**2*ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0A(5)*susy*Nc*Cf*Pi*alphas**3 * ( 64./3.*
     &    ms2**2*s**(-5)*t1**2 + 64./3.*ms2**2*s**(-4)*t1 + 64./3.*
     &    ms2**2*ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0A(6)*susy*Nc*Cf*Pi*alphas**3 * ( 64./3.*
     &    mx1**2*s**(-5)*t1**2 + 64./3.*mx1**2*s**(-4)*t1 + 64./3.*
     &    ms1**2*mx1**2*s**(-4) )
      STQBV = STQBV + SK3B0A(7)*susy*Nc*Cf*Pi*alphas**3 * ( 64./3.*
     &    mx2**2*s**(-5)*t1**2 + 64./3.*mx2**2*s**(-4)*t1 + 64./3.*
     &    mx2**2*ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0B(1)*Nc*Cf*(Nf-1)*Pi*alphas**3 * ( 64./3.*
     &    s**(-4)*t1**2 + 64./3.*s**(-3)*t1 + 64./3.*ms1**2*s**(-3) )
      STQBV = STQBV + SK3B0B(1)*Nc*Cf**2*Pi*alphas**3 * ( 96*s**(-4)*
     &    t1**2 + 96*s**(-3)*t1 + 96*ms1**2*s**(-3) )
      STQBV = STQBV + SK3B0B(1)*Nc**2*Cf*Pi*alphas**3 * ( 32*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 + 8*(s-4*ms12)**(-1)*s**(-1) - 256./3.*s**(-4)*t1**2 - 256.
     &    /3.*s**(-3)*t1 - 8*s**(-2) - 256./3.*ms1**2*s**(-3) )
      STQBV = STQBV + SK3B0B(2)*Nc*Cf*Pi*alphas**3 * ( 16./3.*s**(-4)*
     &    t1**2 + 16./3.*s**(-3)*t1 - 64./3.*ms1**2*s**(-5)*t1**2 - 64./
     &    3.*ms1**2*s**(-4)*t1 + 16./3.*ms1**2*s**(-3) - 64./3.*ms1**4*
     &    s**(-4) )
      STQBV = STQBV + SK3B0B(2)*Nc*Cf**2*Pi*alphas**3 * ( 64*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 64*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 + 16*(s-4*ms12)**(-1)*s**(-1) + 64*s**(-4)*t1**2 + 64*
     &    s**(-3)*t1 - 16*s**(-2) + 64*ms1**2*s**(-3) )
      STQBV = STQBV + SK3B0B(2)*Nc**2*Cf*Pi*alphas**3 * (  - 32*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 - 8*(s-4*ms12)**(-1)*s**(-1) - 32*s**(-4)*t1**2 - 32*
     &    s**(-3)*t1 + 8*s**(-2) - 32*ms1**2*s**(-3) )
      STQBV = STQBV + SK3B0B(3)*susy*Nc**2*Cf*Pi*alphas**3 * (  - 16*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 16*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 - 4*(s-4*ms12)**(-1)*s**(-1) - 64*(s-4*ms12)**(-1)*mt**2*
     &    s**(-4)*t1**2 - 64*(s-4*ms12)**(-1)*mt**2*s**(-3)*t1 - 16*
     &    (s-4*ms12)**(-1)*mt**2*s**(-2) - 64*(s-4*ms12)**(-1)*mg**2*
     &    s**(-4)*t1**2 - 64*(s-4*ms12)**(-1)*mg**2*s**(-3)*t1 - 16*
     &    (s-4*ms12)**(-1)*mg**2*s**(-2) - 32./3.*s**(-4)*t1**2 - 32./3.
     &    *s**(-3)*t1 + 4*s**(-2) - 32./3.*ms1**2*s**(-3) + 16*mt**2*
     &    s**(-3) + 32*ms**2*s**(-5)*t1**2 + 32*ms**2*s**(-4)*t1 + 32*
     &    ms**2*ms1**2*s**(-4) + 32./3.*mg**2*s**(-5)*t1**2 + 32./3.*
     &    mg**2*s**(-4)*t1 + 16*mg**2*s**(-3) + 32./3.*mg**2*ms1**2*
     &    s**(-4) )
      STQBV = STQBV + SK3B0B(3)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * ( 128*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-4)*t1**2 + 128*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-3)*t1 + 32*(s-4*ms12)**(-1)*mg*mt*s**(-2) - 32*mg*
     &    mt*s**(-3) )
      STQBV = STQBV + SK3B0B(4)*Nc*Cf*Pi*alphas**3 * ( 64./3.*s**(-4)*
     &    t1**2 + 64./3.*s**(-3)*t1 + 64./3.*ms1**2*s**(-3) + 128./3.*
     &    mt**2*s**(-5)*t1**2 + 128./3.*mt**2*s**(-4)*t1 + 128./3.*
     &    mt**2*ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0B(4)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 32*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 - 8*(s-4*ms12)**(-1)*s**(-1) - 128*(s-4*ms12)**(-1)*mt**2*
     &    s**(-4)*t1**2 - 128*(s-4*ms12)**(-1)*mt**2*s**(-3)*t1 - 32*
     &    (s-4*ms12)**(-1)*mt**2*s**(-2) - 128*(s-4*ms12)**(-1)*mg**2*
     &    s**(-4)*t1**2 - 128*(s-4*ms12)**(-1)*mg**2*s**(-3)*t1 - 32*
     &    (s-4*ms12)**(-1)*mg**2*s**(-2) - 32*s**(-4)*t1**2 - 32*
     &    s**(-3)*t1 + 8*s**(-2) - 32*ms1**2*s**(-3) + 32*mt**2*s**(-3)
     &     + 32*mg**2*s**(-3) )
      STQBV = STQBV + SK3B0B(4)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * ( 256*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-4)*t1**2 + 256*(s-4*ms12)**(-1)*
     &    mg*mt*s**(-3)*t1 + 64*(s-4*ms12)**(-1)*mg*mt*s**(-2) - 64*mg*
     &    mt*s**(-3) )
      STQBV = STQBV + SK3B0B(4)*susy*Nc**2*Cf*Pi*alphas**3 * ( 16*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 16*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 + 4*(s-4*ms12)**(-1)*s**(-1) + 64*(s-4*ms12)**(-1)*mt**2*
     &    s**(-4)*t1**2 + 64*(s-4*ms12)**(-1)*mt**2*s**(-3)*t1 + 16*
     &    (s-4*ms12)**(-1)*mt**2*s**(-2) + 64*(s-4*ms12)**(-1)*mg**2*
     &    s**(-4)*t1**2 + 64*(s-4*ms12)**(-1)*mg**2*s**(-3)*t1 + 16*
     &    (s-4*ms12)**(-1)*mg**2*s**(-2) + 16*s**(-4)*t1**2 + 16*
     &    s**(-3)*t1 - 4*s**(-2) + 16*ms1**2*s**(-3) - 16*mt**2*s**(-3)
     &     - 16*mg**2*s**(-3) )
      STQBV = STQBV + SK3B0B(4)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * (  - 
     &    128*(s-4*ms12)**(-1)*mg*mt*s**(-4)*t1**2 - 128*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-3)*t1 - 32*(s-4*ms12)**(-1)*mg*mt
     &    *s**(-2) + 32*mg*mt*s**(-3) )
      STQBV = STQBV + SK3B0B(5)*susy*Nc*Cf*(Ns-2)*Pi*alphas**3 * ( 32./
     &    3.*s**(-4)*t1**2 + 32./3.*s**(-3)*t1 + 32./3.*ms1**2*s**(-3)
     &     - 128./3.*ms**2*s**(-5)*t1**2 - 128./3.*ms**2*s**(-4)*t1 - 
     &    128./3.*ms**2*ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0B(5)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 32*
     &    s**(-4)*t1**2 - 32*s**(-3)*t1 - 32*ms1**2*s**(-3) + 64*ms**2*
     &    s**(-5)*t1**2 + 64*ms**2*s**(-4)*t1 + 64*ms**2*ms1**2*s**(-4)
     &     - 64*mg**2*s**(-5)*t1**2 - 64*mg**2*s**(-4)*t1 - 64*mg**2*
     &    ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0B(5)*susy*Nc**2*Cf*Pi*alphas**3 * ( 16*
     &    s**(-4)*t1**2 + 16*s**(-3)*t1 + 16*ms1**2*s**(-3) - 32*ms**2*
     &    s**(-5)*t1**2 - 32*ms**2*s**(-4)*t1 - 32*ms**2*ms1**2*s**(-4)
     &     + 32*mg**2*s**(-5)*t1**2 + 32*mg**2*s**(-4)*t1 + 32*mg**2*
     &    ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0B(6)*susy*Nc*Cf*Pi*alphas**3 * ( 16./3.*
     &    s**(-4)*t1**2 + 16./3.*s**(-3)*t1 + 16./3.*ms1**2*s**(-3) - 
     &    64./3.*ms2**2*s**(-5)*t1**2 - 64./3.*ms2**2*s**(-4)*t1 - 64./
     &    3.*ms2**2*ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0B(7)*susy*Nc*Cf*Pi*alphas**3 * ( 16./3.*
     &    s**(-4)*t1**2 + 16./3.*s**(-3)*t1 - 64./3.*mx1**2*s**(-5)*
     &    t1**2 - 64./3.*mx1**2*s**(-4)*t1 + 16./3.*ms1**2*s**(-3) - 64.
     &    /3.*ms1**2*mx1**2*s**(-4) )
      STQBV = STQBV + SK3B0B(8)*susy*Nc*Cf*Pi*alphas**3 * ( 16./3.*
     &    s**(-4)*t1**2 + 16./3.*s**(-3)*t1 + 16./3.*ms1**2*s**(-3) - 
     &    64./3.*mx2**2*s**(-5)*t1**2 - 64./3.*mx2**2*s**(-4)*t1 - 64./
     &    3.*mx2**2*ms1**2*s**(-4) )
      STQBV = STQBV + SK3B0C(1)*Nc*Cf**2*Pi*alphas**3 * (  - 64*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 - 64*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 - 16*(s-4*ms12)**(-1)*s**(-1) - 64*s**(-4)*t1**2 - 64*
     &    s**(-3)*t1 + 16*s**(-2) - 64*ms1**2*s**(-3) )
      STQBV = STQBV + SK3B0C(2)*susy*Nc*Cf**2*Pi*alphas**3 * ( 32*
     &    (s-4*ms12)**(-1)*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*s**(-2)*
     &    t1 + 8*(s-4*ms12)**(-1)*s**(-1) + 128*(s-4*ms12)**(-1)*mt**2*
     &    s**(-4)*t1**2 + 128*(s-4*ms12)**(-1)*mt**2*s**(-3)*t1 + 32*
     &    (s-4*ms12)**(-1)*mt**2*s**(-2) + 128*(s-4*ms12)**(-1)*mg**2*
     &    s**(-4)*t1**2 + 128*(s-4*ms12)**(-1)*mg**2*s**(-3)*t1 + 32*
     &    (s-4*ms12)**(-1)*mg**2*s**(-2) + 32*s**(-4)*t1**2 + 32*
     &    s**(-3)*t1 - 8*s**(-2) + 32*ms1**2*s**(-3) - 32*mt**2*s**(-3)
     &     - 32*mg**2*s**(-3) )
      STQBV = STQBV + SK3B0C(2)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * (  - 
     &    256*(s-4*ms12)**(-1)*mg*mt*s**(-4)*t1**2 - 256*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-3)*t1 - 64*(s-4*ms12)**(-1)*mg*mt
     &    *s**(-2) + 64*mg*mt*s**(-3) )
      STQBV = STQBV + SK3BP(1)*Nc*Cf**2*Pi*alphas**3 * (  - 128*ms1**2*
     &    s**(-4)*t1**2 - 128*ms1**2*s**(-3)*t1 - 128*ms1**4*s**(-3) )
      STQBV = STQBV + SK3BP(2)*susy*Nc*Cf**2*Pi*alphas**3 * ( 64*ms1**2
     &    *s**(-4)*t1**2 + 64*ms1**2*s**(-3)*t1 + 64*ms1**4*s**(-3) - 
     &    64*mt**2*s**(-4)*t1**2 - 64*mt**2*s**(-3)*t1 - 64*mt**2*
     &    ms1**2*s**(-3) - 64*mg**2*s**(-4)*t1**2 - 64*mg**2*s**(-3)*t1
     &     - 64*mg**2*ms1**2*s**(-3) )
      STQBV = STQBV + SK3BP(2)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * ( 128*
     &    mg*mt*s**(-4)*t1**2 + 128*mg*mt*s**(-3)*t1 + 128*mg*mt*ms1**2
     &    *s**(-3) )
      STQBV = STQBV + SK3BP(3)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 32*
     &    ms**2*s**(-4)*t1**2 - 32*ms**2*s**(-3)*t1 - 32*ms**2*ms1**2*
     &    s**(-3) + 32*mg**2*s**(-4)*t1**2 + 32*mg**2*s**(-3)*t1 + 32*
     &    mg**2*ms1**2*s**(-3) )
      STQBV = STQBV + SK3C0A(1)*Nc*Cf**2*Pi*alphas**3 * ( 64*s**(-3)*
     &    t1**2 + 192*s**(-2)*t1 + 64*s**(-1) + 64*ms1**2*s**(-2) )
      STQBV = STQBV + SK3C0A(1)*Nc**2*Cf*Pi*alphas**3 * (  - 64*s**(-3)
     &    *t1**2 - 112*s**(-2)*t1 - 32*s**(-1) - 48*ms1**2*s**(-2) )
      STQBV = STQBV + SK3C0A(5)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 64*
     &    ms**4*s**(-5)*t1**2 - 64*ms**4*s**(-4)*t1 - 64*ms**4*ms1**2*
     &    s**(-4) - 64*mg**2*s**(-4)*t1**2 - 64*mg**2*s**(-3)*t1 - 64*
     &    mg**2*ms1**2*s**(-3) + 128*mg**2*ms**2*s**(-5)*t1**2 + 128*
     &    mg**2*ms**2*s**(-4)*t1 + 128*mg**2*ms**2*ms1**2*s**(-4) - 64*
     &    mg**4*s**(-5)*t1**2 - 64*mg**4*s**(-4)*t1 - 64*mg**4*ms1**2*
     &    s**(-4) )
      STQBV = STQBV + SK3C0A(5)*susy*Nc**2*Cf*Pi*alphas**3 * ( 32*ms**4
     &    *s**(-5)*t1**2 + 32*ms**4*s**(-4)*t1 + 32*ms**4*ms1**2*
     &    s**(-4) + 32*mg**2*s**(-4)*t1**2 + 32*mg**2*s**(-3)*t1 + 32*
     &    mg**2*ms1**2*s**(-3) - 64*mg**2*ms**2*s**(-5)*t1**2 - 64*
     &    mg**2*ms**2*s**(-4)*t1 - 64*mg**2*ms**2*ms1**2*s**(-4) + 32*
     &    mg**4*s**(-5)*t1**2 + 32*mg**4*s**(-4)*t1 + 32*mg**4*ms1**2*
     &    s**(-4) )
      STQBV = STQBV + SK3C0A(6)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 64*
     &    s**(-2)*t1 - 32*s**(-1) )
      STQBV = STQBV + SK3C0A(6)*susy*Nc**2*Cf*Pi*alphas**3 * ( 24*
     &    s**(-2)*t1 + 16*s**(-1) - 8*ms1**2*s**(-2) + 8*mt**2*s**(-2)
     &     + 32*ms**4*s**(-5)*t1**2 + 32*ms**4*s**(-4)*t1 + 32*ms**4*
     &    ms1**2*s**(-4) + 32*mg**2*s**(-4)*t1**2 + 32*mg**2*s**(-3)*t1
     &     + 8*mg**2*s**(-2) + 32*mg**2*ms1**2*s**(-3) - 64*mg**2*ms**2
     &    *s**(-5)*t1**2 - 64*mg**2*ms**2*s**(-4)*t1 - 64*mg**2*ms**2*
     &    ms1**2*s**(-4) + 32*mg**4*s**(-5)*t1**2 + 32*mg**4*s**(-4)*t1
     &     + 32*mg**4*ms1**2*s**(-4) )
      STQBV = STQBV + SK3C0A(6)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * (  - 
     &    16*mg*mt*s**(-2) )
      STQBV = STQBV + SK3C0B(1)*Nc*Cf**2*Pi*alphas**3 * ( 64*s**(-3)*
     &    t1**2 + 64*s**(-2)*t1 - 128*ms1**2*s**(-4)*t1**2 - 128*ms1**2
     &    *s**(-3)*t1 + 64*ms1**2*s**(-2) - 128*ms1**4*s**(-3) )
      STQBV = STQBV + SK3C0B(1)*Nc**2*Cf*Pi*alphas**3 * (  - 32*s**(-3)
     &    *t1**2 - 32*s**(-2)*t1 + 64*ms1**2*s**(-4)*t1**2 + 64*ms1**2*
     &    s**(-3)*t1 - 32*ms1**2*s**(-2) + 64*ms1**4*s**(-3) )
      STQBV = STQBV + SK3C0B(2)*Nc*Cf**2*Pi*alphas**3 * ( 128*s**(-2)*
     &    t1 + 64*s**(-1) - 256*ms1**2*s**(-3)*t1 - 128*ms1**2*s**(-2)
     &     )
      STQBV = STQBV + SK3C0B(2)*Nc**2*Cf*Pi*alphas**3 * ( 16*
     &    (s-4*ms12)**(-1)*s**(-2)*t1**2 + 16*(s-4*ms12)**(-1)*s**(-1)*
     &    t1 + 4*(s-4*ms12)**(-1) - 48*s**(-3)*t1**2 - 96*s**(-2)*t1 - 
     &    36*s**(-1) + 96*ms1**2*s**(-3)*t1 + 32*ms1**2*s**(-2) )
      STQBV = STQBV + SK3C0B(3)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 64*
     &    s**(-2)*t1 - 32*s**(-1) + 128*ms1**2*s**(-3)*t1 + 64*ms1**2*
     &    s**(-2) - 128*mt**2*s**(-3)*t1 - 64*mt**2*s**(-2) - 128*mg**2
     &    *s**(-3)*t1 - 64*mg**2*s**(-2) )
      STQBV = STQBV + SK3C0B(3)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * ( 256*
     &    mg*mt*s**(-3)*t1 + 128*mg*mt*s**(-2) )
      STQBV = STQBV + SK3C0B(3)*susy*Nc**2*Cf*Pi*alphas**3 * (  - 4*
     &    (s-4*ms12)**(-1)*s**(-2)*t1**2 - 4*(s-4*ms12)**(-1)*s**(-1)*
     &    t1 - (s-4*ms12)**(-1) - 32*(s-4*ms12)**(-1)*mt**2*s**(-3)*
     &    t1**2 - 32*(s-4*ms12)**(-1)*mt**2*s**(-2)*t1 - 8*
     &    (s-4*ms12)**(-1)*mt**2*s**(-1) - 64*(s-4*ms12)**(-1)*mt**4*
     &    s**(-4)*t1**2 - 64*(s-4*ms12)**(-1)*mt**4*s**(-3)*t1 - 16*
     &    (s-4*ms12)**(-1)*mt**4*s**(-2) + 64*(s-4*ms12)**(-1)*mg**4*
     &    s**(-4)*t1**2 + 64*(s-4*ms12)**(-1)*mg**4*s**(-3)*t1 + 16*
     &    (s-4*ms12)**(-1)*mg**4*s**(-2) + 4*s**(-3)*t1**2 + 28*s**(-2)
     &    *t1 + 17*s**(-1) + 16*ms1**2*s**(-4)*t1**2 - 32*ms1**2*
     &    s**(-3)*t1 - 36*ms1**2*s**(-2) + 16*ms1**4*s**(-3) - 32*mt**2
     &    *s**(-4)*t1**2 + 16*mt**2*s**(-3)*t1 + 32*mt**2*s**(-2) - 32*
     &    mt**2*ms1**2*s**(-3) + 16*mt**4*s**(-3) + 48*mg**2*s**(-3)*t1
     &     + 24*mg**2*s**(-2) - 16*mg**4*s**(-3) )
      STQBV = STQBV + SK3C0B(3)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * ( 32*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*mg
     &    *mt*s**(-2)*t1 + 8*(s-4*ms12)**(-1)*mg*mt*s**(-1) + 128*
     &    (s-4*ms12)**(-1)*mg*mt**3*s**(-4)*t1**2 + 128*
     &    (s-4*ms12)**(-1)*mg*mt**3*s**(-3)*t1 + 32*(s-4*ms12)**(-1)*mg
     &    *mt**3*s**(-2) - 128*(s-4*ms12)**(-1)*mg**3*mt*s**(-4)*t1**2
     &     - 128*(s-4*ms12)**(-1)*mg**3*mt*s**(-3)*t1 - 32*
     &    (s-4*ms12)**(-1)*mg**3*mt*s**(-2) + 32*mg*mt*s**(-4)*t1**2 - 
     &    64*mg*mt*s**(-3)*t1 - 56*mg*mt*s**(-2) + 32*mg*mt*ms1**2*
     &    s**(-3) - 32*mg*mt**3*s**(-3) + 32*mg**3*mt*s**(-3) )
      STQBV = STQBV + SK3C0B(4)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 8*
     &    (s-4*ms12)**(-1)*s**(-2)*t1**2 - 8*(s-4*ms12)**(-1)*s**(-1)*
     &    t1 - 2*(s-4*ms12)**(-1) + 128*(s-4*ms12)**(-1)*mt**4*s**(-4)*
     &    t1**2 + 128*(s-4*ms12)**(-1)*mt**4*s**(-3)*t1 + 32*
     &    (s-4*ms12)**(-1)*mt**4*s**(-2) - 64*(s-4*ms12)**(-1)*mg**2*
     &    s**(-3)*t1**2 - 64*(s-4*ms12)**(-1)*mg**2*s**(-2)*t1 - 16*
     &    (s-4*ms12)**(-1)*mg**2*s**(-1) - 128*(s-4*ms12)**(-1)*mg**4*
     &    s**(-4)*t1**2 - 128*(s-4*ms12)**(-1)*mg**4*s**(-3)*t1 - 32*
     &    (s-4*ms12)**(-1)*mg**4*s**(-2) + 8*s**(-3)*t1**2 + 8*s**(-2)*
     &    t1 + 2*s**(-1) + 32*ms1**2*s**(-4)*t1**2 + 32*ms1**2*s**(-3)*
     &    t1 + 8*ms1**2*s**(-2) + 32*ms1**4*s**(-3) - 32*mt**4*s**(-3)
     &     - 64*mg**2*s**(-4)*t1**2 - 64*mg**2*s**(-3)*t1 + 16*mg**2*
     &    s**(-2) - 64*mg**2*ms1**2*s**(-3) + 32*mg**4*s**(-3) )
      STQBV = STQBV + SK3C0B(4)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * ( 64*
     &    (s-4*ms12)**(-1)*mg*mt*s**(-3)*t1**2 + 64*(s-4*ms12)**(-1)*mg
     &    *mt*s**(-2)*t1 + 16*(s-4*ms12)**(-1)*mg*mt*s**(-1) - 256*
     &    (s-4*ms12)**(-1)*mg*mt**3*s**(-4)*t1**2 - 256*
     &    (s-4*ms12)**(-1)*mg*mt**3*s**(-3)*t1 - 64*(s-4*ms12)**(-1)*mg
     &    *mt**3*s**(-2) + 256*(s-4*ms12)**(-1)*mg**3*mt*s**(-4)*t1**2
     &     + 256*(s-4*ms12)**(-1)*mg**3*mt*s**(-3)*t1 + 64*
     &    (s-4*ms12)**(-1)*mg**3*mt*s**(-2) + 64*mg*mt*s**(-4)*t1**2 + 
     &    64*mg*mt*s**(-3)*t1 - 16*mg*mt*s**(-2) + 64*mg*mt*ms1**2*
     &    s**(-3) + 64*mg*mt**3*s**(-3) - 64*mg**3*mt*s**(-3) )
      STQBV = STQBV + SK3C0B(4)*susy*Nc**2*Cf*Pi*alphas**3 * ( 4*
     &    (s-4*ms12)**(-1)*s**(-2)*t1**2 + 4*(s-4*ms12)**(-1)*s**(-1)*
     &    t1 + (s-4*ms12)**(-1) - 64*(s-4*ms12)**(-1)*mt**4*s**(-4)*
     &    t1**2 - 64*(s-4*ms12)**(-1)*mt**4*s**(-3)*t1 - 16*
     &    (s-4*ms12)**(-1)*mt**4*s**(-2) + 32*(s-4*ms12)**(-1)*mg**2*
     &    s**(-3)*t1**2 + 32*(s-4*ms12)**(-1)*mg**2*s**(-2)*t1 + 8*
     &    (s-4*ms12)**(-1)*mg**2*s**(-1) + 64*(s-4*ms12)**(-1)*mg**4*
     &    s**(-4)*t1**2 + 64*(s-4*ms12)**(-1)*mg**4*s**(-3)*t1 + 16*
     &    (s-4*ms12)**(-1)*mg**4*s**(-2) - 4*s**(-3)*t1**2 - 4*s**(-2)*
     &    t1 - s**(-1) - 16*ms1**2*s**(-4)*t1**2 - 16*ms1**2*s**(-3)*t1
     &     - 4*ms1**2*s**(-2) - 16*ms1**4*s**(-3) + 16*mt**4*s**(-3) + 
     &    32*mg**2*s**(-4)*t1**2 + 32*mg**2*s**(-3)*t1 - 8*mg**2*
     &    s**(-2) + 32*mg**2*ms1**2*s**(-3) - 16*mg**4*s**(-3) )
      STQBV = STQBV + SK3C0B(4)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * (  - 
     &    32*(s-4*ms12)**(-1)*mg*mt*s**(-3)*t1**2 - 32*(s-4*ms12)**(-1)
     &    *mg*mt*s**(-2)*t1 - 8*(s-4*ms12)**(-1)*mg*mt*s**(-1) + 128*
     &    (s-4*ms12)**(-1)*mg*mt**3*s**(-4)*t1**2 + 128*
     &    (s-4*ms12)**(-1)*mg*mt**3*s**(-3)*t1 + 32*(s-4*ms12)**(-1)*mg
     &    *mt**3*s**(-2) - 128*(s-4*ms12)**(-1)*mg**3*mt*s**(-4)*t1**2
     &     - 128*(s-4*ms12)**(-1)*mg**3*mt*s**(-3)*t1 - 32*
     &    (s-4*ms12)**(-1)*mg**3*mt*s**(-2) - 32*mg*mt*s**(-4)*t1**2 - 
     &    32*mg*mt*s**(-3)*t1 + 8*mg*mt*s**(-2) - 32*mg*mt*ms1**2*
     &    s**(-3) - 32*mg*mt**3*s**(-3) + 32*mg**3*mt*s**(-3) )
      STQBV = STQBV + SK3C0C(1,1)*Nc*Cf**2*Pi*alphas**3 * ( 128*s**(-3)
     &    *t1**2 + 128*ms1**2*s**(-3)*t1 )
      STQBV = STQBV + SK3C0C(1,1)*Nc**2*Cf*Pi*alphas**3 * (  - 32*
     &    s**(-3)*t1**2 - 32*ms1**2*s**(-3)*t1 )
      STQBV = STQBV + SK3C0C(1,2)*Nc*Cf**2*Pi*alphas**3 * (  - 128*
     &    s**(-3)*t1**2 - 256*s**(-2)*t1 - 128*s**(-1) + 128*ms1**2*
     &    s**(-3)*t1 + 128*ms1**2*s**(-2) )
      STQBV = STQBV + SK3C0C(1,2)*Nc**2*Cf*Pi*alphas**3 * ( 64*s**(-3)*
     &    t1**2 + 128*s**(-2)*t1 + 64*s**(-1) - 64*ms1**2*s**(-3)*t1 - 
     &    64*ms1**2*s**(-2) )
      STQBV = STQBV + SK3C0C(2,1)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 64*
     &    s**(-3)*t1**2 - 64*ms1**2*s**(-3)*t1 + 64*mt**2*s**(-3)*t1 + 
     &    64*mg**2*s**(-3)*t1 )
      STQBV = STQBV + SK3C0C(2,1)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * ( 
     &     - 128*mg*mt*s**(-3)*t1 )
      STQBV = STQBV + SK3C0C(2,1)*susy*Nc**2*Cf*Pi*alphas**3 * ( 16*
     &    s**(-3)*t1**2 + 16*ms1**2*s**(-3)*t1 - 16*mt**2*s**(-3)*t1 - 
     &    16*mg**2*s**(-3)*t1 )
      STQBV = STQBV + SK3C0C(2,1)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * ( 32
     &    *mg*mt*s**(-3)*t1 )
      STQBV = STQBV + SK3C0C(2,2)*susy*Nc*Cf**2*Pi*alphas**3 * ( 64*
     &    s**(-3)*t1**2 + 128*s**(-2)*t1 + 64*s**(-1) - 64*ms1**2*
     &    s**(-3)*t1 - 64*ms1**2*s**(-2) + 64*mt**2*s**(-3)*t1 + 64*
     &    mt**2*s**(-2) + 64*mg**2*s**(-3)*t1 + 64*mg**2*s**(-2) )
      STQBV = STQBV + SK3C0C(2,2)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * ( 
     &     - 128*mg*mt*s**(-3)*t1 - 128*mg*mt*s**(-2) )
      STQBV = STQBV + SK3C0C(2,2)*susy*Nc**2*Cf*Pi*alphas**3 * (  - 32*
     &    s**(-3)*t1**2 - 64*s**(-2)*t1 - 32*s**(-1) + 32*ms1**2*
     &    s**(-3)*t1 + 32*ms1**2*s**(-2) - 32*mt**2*s**(-3)*t1 - 32*
     &    mt**2*s**(-2) - 32*mg**2*s**(-3)*t1 - 32*mg**2*s**(-2) )
      STQBV = STQBV + SK3C0C(2,2)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * ( 64
     &    *mg*mt*s**(-3)*t1 + 64*mg*mt*s**(-2) )
      STQBV = STQBV + SK3D0(1,1)*Nc*Cf**2*Pi*alphas**3 * ( 128*s**(-3)*
     &    t1**3 + 64*s**(-2)*t1**2 + 64*ms1**2*s**(-2)*t1 )
      STQBV = STQBV + SK3D0(1,1)*Nc**2*Cf*Pi*alphas**3 * (  - 32*
     &    s**(-3)*t1**3 - 16*s**(-2)*t1**2 - 16*ms1**2*s**(-2)*t1 )
      STQBV = STQBV + SK3D0(1,2)*Nc*Cf**2*Pi*alphas**3 * ( 64 + 128*
     &    s**(-3)*t1**3 + 320*s**(-2)*t1**2 + 256*s**(-1)*t1 + 64*
     &    ms1**2*s**(-2)*t1 + 64*ms1**2*s**(-1) )
      STQBV = STQBV + SK3D0(1,2)*Nc**2*Cf*Pi*alphas**3 * (  - 32 - 64*
     &    s**(-3)*t1**3 - 160*s**(-2)*t1**2 - 128*s**(-1)*t1 - 32*
     &    ms1**2*s**(-2)*t1 - 32*ms1**2*s**(-1) )
      STQBV = STQBV + SK3D0(7,1)*susy*Nc*Cf**2*Pi*alphas**3 * ( 32*
     &    s**(-2)*t1**2 + 64*ms1**2*s**(-2)*t1 + 32*ms1**4*s**(-2) - 64
     &    *mt**2*s**(-2)*t1 - 64*mt**2*ms1**2*s**(-2) + 32*mt**4*
     &    s**(-2) - 32*ms**2*s**(-2)*t1 + 64*ms**2*ms1**2*s**(-3)*t1 - 
     &    32*ms**2*ms1**2*s**(-2) - 64*ms**2*mt**2*s**(-3)*t1 - 32*
     &    ms**2*mt**2*s**(-2) + 32*mg**2*s**(-2)*t1 - 64*mg**2*ms1**2*
     &    s**(-3)*t1 + 32*mg**2*ms1**2*s**(-2) + 64*mg**2*mt**2*s**(-3)
     &    *t1 + 32*mg**2*mt**2*s**(-2) - 64*mg**2*ms**2*s**(-3)*t1 - 32
     &    *mg**2*ms**2*s**(-2) + 64*mg**4*s**(-3)*t1 )
      STQBV = STQBV + SK3D0(7,1)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * ( 64*
     &    mg*mt*s**(-2)*t1 + 64*mg*mt*ms1**2*s**(-2) - 64*mg*mt**3*
     &    s**(-2) + 128*mg*ms**2*mt*s**(-3)*t1 + 64*mg*ms**2*mt*s**(-2)
     &     - 128*mg**3*mt*s**(-3)*t1 )
      STQBV = STQBV + SK3D0(7,1)*susy*Nc**2*Cf*Pi*alphas**3 * (  - 8*
     &    s**(-2)*t1**2 - 16*ms1**2*s**(-2)*t1 - 8*ms1**4*s**(-2) + 16*
     &    mt**2*s**(-2)*t1 + 16*mt**2*ms1**2*s**(-2) - 8*mt**4*s**(-2)
     &     + 8*ms**2*s**(-2)*t1 - 16*ms**2*ms1**2*s**(-3)*t1 + 8*ms**2*
     &    ms1**2*s**(-2) + 16*ms**2*mt**2*s**(-3)*t1 + 8*ms**2*mt**2*
     &    s**(-2) - 8*mg**2*s**(-2)*t1 + 16*mg**2*ms1**2*s**(-3)*t1 - 8
     &    *mg**2*ms1**2*s**(-2) - 16*mg**2*mt**2*s**(-3)*t1 - 8*mg**2*
     &    mt**2*s**(-2) + 16*mg**2*ms**2*s**(-3)*t1 + 8*mg**2*ms**2*
     &    s**(-2) - 16*mg**4*s**(-3)*t1 )
      STQBV = STQBV + SK3D0(7,1)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * (  - 
     &    16*mg*mt*s**(-2)*t1 - 16*mg*mt*ms1**2*s**(-2) + 16*mg*mt**3*
     &    s**(-2) - 32*mg*ms**2*mt*s**(-3)*t1 - 16*mg*ms**2*mt*s**(-2)
     &     + 32*mg**3*mt*s**(-3)*t1 )
      STQBV = STQBV + SK3D0(7,2)*susy*Nc*Cf**2*Pi*alphas**3 * (  - 32
     &     - 32*s**(-2)*t1**2 - 64*s**(-1)*t1 + 64*ms1**2*s**(-2)*t1 + 
     &    64*ms1**2*s**(-1) - 32*ms1**4*s**(-2) - 64*mt**2*s**(-2)*t1
     &     - 64*mt**2*s**(-1) + 64*mt**2*ms1**2*s**(-2) - 32*mt**4*
     &    s**(-2) - 32*ms**2*s**(-2)*t1 - 32*ms**2*s**(-1) + 64*ms**2*
     &    ms1**2*s**(-3)*t1 + 96*ms**2*ms1**2*s**(-2) - 64*ms**2*mt**2*
     &    s**(-3)*t1 - 32*ms**2*mt**2*s**(-2) + 32*mg**2*s**(-2)*t1 + 
     &    32*mg**2*s**(-1) - 64*mg**2*ms1**2*s**(-3)*t1 - 96*mg**2*
     &    ms1**2*s**(-2) + 64*mg**2*mt**2*s**(-3)*t1 + 32*mg**2*mt**2*
     &    s**(-2) - 64*mg**2*ms**2*s**(-3)*t1 - 32*mg**2*ms**2*s**(-2)
     &     + 64*mg**4*s**(-3)*t1 + 64*mg**4*s**(-2) )
      STQBV = STQBV + SK3D0(7,2)*susy*Nc*Cf**2*s2t*Pi*alphas**3 * ( 64*
     &    mg*mt*s**(-2)*t1 + 64*mg*mt*s**(-1) - 64*mg*mt*ms1**2*s**(-2)
     &     + 64*mg*mt**3*s**(-2) + 128*mg*ms**2*mt*s**(-3)*t1 + 64*mg*
     &    ms**2*mt*s**(-2) - 128*mg**3*mt*s**(-3)*t1 - 128*mg**3*mt*
     &    s**(-2) )
      STQBV = STQBV + SK3D0(7,2)*susy*Nc**2*Cf*Pi*alphas**3 * ( 16 + 16
     &    *s**(-2)*t1**2 + 32*s**(-1)*t1 - 32*ms1**2*s**(-2)*t1 - 32*
     &    ms1**2*s**(-1) + 16*ms1**4*s**(-2) + 32*mt**2*s**(-2)*t1 + 32
     &    *mt**2*s**(-1) - 32*mt**2*ms1**2*s**(-2) + 16*mt**4*s**(-2)
     &     + 16*ms**2*s**(-2)*t1 + 16*ms**2*s**(-1) - 32*ms**2*ms1**2*
     &    s**(-3)*t1 - 48*ms**2*ms1**2*s**(-2) + 32*ms**2*mt**2*s**(-3)
     &    *t1 + 16*ms**2*mt**2*s**(-2) - 16*mg**2*s**(-2)*t1 - 16*mg**2
     &    *s**(-1) + 32*mg**2*ms1**2*s**(-3)*t1 + 48*mg**2*ms1**2*
     &    s**(-2) - 32*mg**2*mt**2*s**(-3)*t1 - 16*mg**2*mt**2*s**(-2)
     &     + 32*mg**2*ms**2*s**(-3)*t1 + 16*mg**2*ms**2*s**(-2) - 32*
     &    mg**4*s**(-3)*t1 - 32*mg**4*s**(-2) )
      STQBV = STQBV + SK3D0(7,2)*susy*Nc**2*Cf*s2t*Pi*alphas**3 * (  - 
     &    32*mg*mt*s**(-2)*t1 - 32*mg*mt*s**(-1) + 32*mg*mt*ms1**2*
     &    s**(-2) - 32*mg*mt**3*s**(-2) - 64*mg*ms**2*mt*s**(-3)*t1 - 
     &    32*mg*ms**2*mt*s**(-2) + 64*mg**3*mt*s**(-3)*t1 + 64*mg**3*mt
     &    *s**(-2) )
      STQBV = STQBV + SOF1(1)*Nc*Cf**2*Pi*alphas**3 * (  - 256*s**(-3)*
     &    t1**2 - 256*s**(-2)*t1 + 512*ms1**2*s**(-4)*t1**2 + 512*
     &    ms1**2*s**(-3)*t1 - 256*ms1**2*s**(-2) + 512*ms1**4*s**(-3) )
      STQBV = STQBV + SOF1(1)*Nc**2*Cf*Pi*alphas**3 * ( 128*s**(-3)*
     &    t1**2 + 128*s**(-2)*t1 - 256*ms1**2*s**(-4)*t1**2 - 256*
     &    ms1**2*s**(-3)*t1 + 128*ms1**2*s**(-2) - 256*ms1**4*s**(-3) )
      STQBV = STQBV + SOF1(2)*Nc*Cf**2*Pi*alphas**3 * ( 256*ms1**2*
     &    s**(-4)*t1**2 + 256*ms1**2*s**(-3)*t1 + 256*ms1**4*s**(-3) )
      STQBV = STQBV + SOF1(3)*Nc*Cf**2*Pi*alphas**3 * ( 256*ms1**2*
     &    s**(-4)*t1**2 + 256*ms1**2*s**(-3)*t1 + 256*ms1**4*s**(-3) )
      STQBV = STQBV + SOF1(4)*Nc*Cf**2*Pi*alphas**3 * (  - 512*s**(-4)*
     &    t1**3 - 1024*s**(-3)*t1**2 - 512*s**(-2)*t1 - 512*ms1**2*
     &    s**(-3)*t1 - 512*ms1**2*s**(-2) )
      STQBV = STQBV + SOF1(4)*Nc**2*Cf*Pi*alphas**3 * ( 256*s**(-4)*
     &    t1**3 + 512*s**(-3)*t1**2 + 256*s**(-2)*t1 + 256*ms1**2*
     &    s**(-3)*t1 + 256*ms1**2*s**(-2) )
      STQBV = STQBV + SOF1(5)*Nc*Cf**2*Pi*alphas**3 * (  - 512*s**(-4)*
     &    t1**3 - 512*s**(-3)*t1**2 - 512*ms1**2*s**(-3)*t1 )
      STQBV = STQBV + SOF1(5)*Nc**2*Cf*Pi*alphas**3 * ( 128*s**(-4)*
     &    t1**3 + 128*s**(-3)*t1**2 + 128*ms1**2*s**(-3)*t1 )
      STQBV = STQBV + SOF1(6)*Nc*Cf**2*Pi*alphas**3 * (  - 512*s**(-4)*
     &    t1**3 - 512*s**(-3)*t1**2 - 512*ms1**2*s**(-3)*t1 )
      STQBV = STQBV + SOF1(6)*Nc**2*Cf*Pi*alphas**3 * ( 128*s**(-4)*
     &    t1**3 + 128*s**(-3)*t1**2 + 128*ms1**2*s**(-3)*t1 )
      STQBV = STQBV + SOF1(7)*Nc*Cf**2*Pi*alphas**3 * (  - 512*s**(-4)*
     &    t1**3 - 1024*s**(-3)*t1**2 - 512*s**(-2)*t1 - 512*ms1**2*
     &    s**(-3)*t1 - 512*ms1**2*s**(-2) )
      STQBV = STQBV + SOF1(7)*Nc**2*Cf*Pi*alphas**3 * ( 256*s**(-4)*
     &    t1**3 + 512*s**(-3)*t1**2 + 256*s**(-2)*t1 + 256*ms1**2*
     &    s**(-3)*t1 + 256*ms1**2*s**(-2) )
      STQBV = STQBV + SOF1(8)*Nc*Cf**2*Pi*alphas**3 * (  - 256*s**(-3)*
     &    t1**2 - 256*s**(-2)*t1 - 256*ms1**2*s**(-2) )
      STQBV = STQBV + SOF1(8)*Nc**2*Cf*Pi*alphas**3 * ( 128*s**(-3)*
     &    t1**2 + 128*s**(-2)*t1 + 128*ms1**2*s**(-2) )

      TB_QBV = fac * STQBV  + dec

      end

c --------------------------------------------------------------------
      real*8 function TB_QBH(s,t1,s4,ms1)

      implicit none 

      real*8 Pi,Nc,Cf,alphas,fac 
      real*8 s,t1,u1,ms1,s4
      real*8 hardin(5)
      real*8 ANG4(71),COLO1(9)

      Pi=4.D0*atan(1.D0)
      Nc = 3.D0
      Cf = 4.D0/3.D0 
      alphas = 1.D0

      u1 = s4 - s - t1 
      fac = s4 /(s4+ms1**2) /8.D0 /(16*Pi**2)**2 /Nc**2

      hardin(1) = s
      hardin(2) = t1 
      hardin(3) = u1 
      hardin(4) = s4 
      hardin(5) = ms1**2 

      call LOGAS_LQ(hardin,COLO1)
      call ANGULAR_ARRAY_TB_QS(hardin,ANG4)

      TB_QBH =
     +  + Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2*s**(-4)*t1**(-1)*u1
     +     + 1024*ms1**2*s**(-4)*t1*u1**(-1) - 4096*ms1**2*s**(-4)*t1*
     +    s4**(-1) + 2048*ms1**2*s**(-4)*t1**2*s4**(-2) + 2048*ms1**2*
     +    s**(-4) - 1024*ms1**2*s**(-3)*t1**(-2)*u1 - 1024*ms1**2*
     +    s**(-3)*t1**(-1) - 1024*ms1**2*s**(-3)*t1*u1**(-2) + 2048*
     +    ms1**2*s**(-3)*t1*s4**(-2) - 1024*ms1**2*s**(-3)*u1**(-1) - 
     +    1024*ms1**2*s**(-2)*t1**(-2) - 1024*ms1**2*s**(-2)*u1**(-2)
     +     - 1024*ms1**4*s**(-3)*t1**(-2) - 1024*ms1**4*s**(-3)*
     +    u1**(-2) + 2048*ms1**4*s**(-3)*s4**(-2) + 1024*s**(-4)*
     +    t1**(-1)*u1**2 + 1024*s**(-4)*t1 + 1024*s**(-4)*t1**2*
     +    u1**(-1) + 1024*s**(-4)*u1 + 1024*s**(-3)*t1**(-1)*u1 + 1024*
     +    s**(-3)*t1*u1**(-1) + 1024*s**(-3)*t1*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(9)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2*
     +    s**(-4) )
      TB_QBH=TB_QBH + ANG4(10)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-3) )
      TB_QBH=TB_QBH + ANG4(11)*Nc**2*Cf*Pi**4*alphas**3 * (  - 1024*
     +    ms1**2*s**(-5)*s4*(t1+u1)**(-1) + 1024*ms1**2*s**(-5) )
      TB_QBH=TB_QBH + ANG4(12)*Nc*Cf**2*Pi**4*alphas**3 * ( 2048*ms1**2
     +    *s**(-4)*t1*s4**(-1) - 4096*ms1**2*s**(-4)*s4*(t1+u1)**(-1)
     +     + 2048*ms1**2*s**(-4) + 1024*ms1**2*s**(-3)*s4**(-1) - 1024*
     +    s**(-3)*t1*s4**(-1) + 512*s**(-3) - 512*s**(-2)*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(12)*Nc**2*Cf*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-5)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-5)*t1 - 1024*
     +    ms1**2*s**(-4)*t1*s4**(-1) + 512*ms1**2*s**(-4)*s4*
     +    (t1+u1)**(-1) - 512*ms1**2*s**(-4) - 512*ms1**2*s**(-3)*
     +    s4**(-1) + 512*s**(-3)*t1*s4**(-1) - 256*s**(-3) + 256*
     +    s**(-2)*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(13)*Nc**2*Cf*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-4) )
      TB_QBH=TB_QBH + ANG4(14)*Nc**2*Cf*Pi**4*alphas**3 * ( 2048*ms1**2
     +    *s**(-4)*u1 + 1024*ms1**2*s**(-3) )
      TB_QBH=TB_QBH + ANG4(15)*Nc**2*Cf*Pi**4*alphas**3 * (  - 1024*
     +    ms1**2*s**(-5)*s4*(t1+u1)**(-1) + 1024*ms1**2*s**(-5) )
      TB_QBH=TB_QBH + ANG4(16)*Nc*Cf**2*Pi**4*alphas**3 * (  - 4096*
     +    ms1**2*s**(-4)*s4*(t1+u1)**(-1) + 4096*ms1**2*s**(-4) )
      TB_QBH=TB_QBH + ANG4(16)*Nc**2*Cf*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-5)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-5)*t1 - 1024*
     +    ms1**2*s**(-4)*t1*s4**(-1) + 512*ms1**2*s**(-4)*s4*
     +    (t1+u1)**(-1) - 512*ms1**2*s**(-4) - 512*ms1**2*s**(-3)*
     +    s4**(-1) + 512*s**(-3)*t1*s4**(-1) - 256*s**(-3) + 256*
     +    s**(-2)*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(36)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**4
     +    *s**(-3) )
      TB_QBH=TB_QBH + ANG4(37)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-3)*t1*s4**(-1) - 2048*ms1**2*s**(-3)*s4*(t1+u1)**(-1)
     +     + 2048*ms1**2*s**(-3) - 1024*ms1**2*s**(-2)*s4**(-1) + 2048*
     +    ms1**4*s**(-3)*s4**(-1) + 1024*s**(-3)*t1 - 1024*s**(-3)*u1
     +     - 512*s**(-2)*t1*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(37)*Nc**2*Cf*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-4)*t1*s4*(t1+u1)**(-1) - 512*ms1**2*s**(-4)*t1 - 512*
     +    ms1**2*s**(-3)*t1*s4**(-1) + 512*ms1**2*s**(-3)*s4*
     +    (t1+u1)**(-1) - 768*ms1**2*s**(-3) + 512*ms1**2*s**(-2)*
     +    s4**(-1) - 1024*ms1**4*s**(-3)*s4**(-1) + 512*s**(-4)*t1**2*
     +    s4*(t1+u1)**(-1) - 512*s**(-4)*t1**2 - 768*s**(-3)*t1 + 512*
     +    s**(-3)*u1 + 256*s**(-2)*t1*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(38)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-2) )
      TB_QBH=TB_QBH + ANG4(38)*Nc**2*Cf*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-4)*u1**2 + 1024*ms1**2*s**(-3)*u1 + 512*ms1**2*s**(-2)
     +     )
      TB_QBH=TB_QBH + ANG4(39)*Nc*Cf**2*Pi**4*alphas**3 * ( 4096*ms1**2
     +    *s**(-3)*t1*s4**(-1) - 2048*ms1**2*s**(-3)*s4*(t1+u1)**(-1)
     +     - 2048*ms1**2*s**(-3) + 2048*ms1**2*s**(-2)*s4**(-1) - 2048*
     +    s**(-2)*t1*s4**(-1) + 1024*s**(-2) - 1024*s**(-1)*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(39)*Nc**2*Cf*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-4)*t1*s4*(t1+u1)**(-1) - 1536*ms1**2*s**(-4)*t1 + 1024*
     +    ms1**2*s**(-4)*t1**2*s4**(-1) + 1024*ms1**2*s**(-4)*u1 - 512*
     +    ms1**2*s**(-3)*t1*s4**(-1) + 512*ms1**2*s**(-3)*s4*
     +    (t1+u1)**(-1) + 1024*ms1**2*s**(-3) - 256*ms1**2*s**(-2)*
     +    s4**(-1) + 512*s**(-4)*t1**2*s4*(t1+u1)**(-1) - 512*s**(-4)*
     +    t1**2 - 512*s**(-3)*t1 + 512*s**(-3)*t1**2*s4**(-1) + 256*
     +    s**(-3)*u1 + 1280*s**(-2)*t1*s4**(-1) - 512*s**(-2) + 512*
     +    s**(-1)*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(48)*Nc*Cf**2*Pi**4*alphas**3 * (  - 1024*
     +    ms1**2*s**(-2) - 512*s**(-3)*t1**2 - 512*s**(-3)*u1**2 - 512*
     +    s**(-2)*t1 - 512*s**(-2)*u1 )
      TB_QBH=TB_QBH + ANG4(48)*Nc**2*Cf*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-2) + 256*s**(-3)*t1**2 + 256*s**(-3)*u1**2 + 256*s**(-2)
     +    *t1 + 256*s**(-2)*u1 )
      TB_QBH=TB_QBH + ANG4(49)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-3)*t1*s4*(t1+u1)**(-1) - 2048*ms1**2*s**(-3)*t1 + 2048*
     +    s**(-4)*t1**3*s4*(t1+u1)**(-1) - 2048*s**(-4)*t1**3 + 1024*
     +    s**(-3)*t1**2*s4*(t1+u1)**(-1) - 2048*s**(-3)*t1**2 )
      TB_QBH=TB_QBH + ANG4(49)*Nc**2*Cf*Pi**4*alphas**3 * (  - 256*
     +    ms1**2*s**(-3)*t1*s4*(t1+u1)**(-1) + 512*ms1**2*s**(-3)*t1 - 
     +    512*s**(-4)*t1**3*s4*(t1+u1)**(-1) + 512*s**(-4)*t1**3 - 256*
     +    s**(-3)*t1**2*s4*(t1+u1)**(-1) + 512*s**(-3)*t1**2 )
      TB_QBH=TB_QBH + ANG4(50)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-3)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-3)*t1 + 1024*
     +    ms1**2*s**(-3)*u1 - 1024*ms1**2*s**(-2) + 2048*s**(-4)*t1**3*
     +    s4*(t1+u1)**(-1) - 2048*s**(-4)*t1**3 + 2048*s**(-3)*t1*u1 - 
     +    1024*s**(-3)*t1**2*s4*(t1+u1)**(-1) - 1024*s**(-3)*t1**2 - 
     +    1024*s**(-3)*u1**2 + 1024*s**(-2)*t1 - 1024*s**(-2)*u1 )
      TB_QBH=TB_QBH + ANG4(50)*Nc**2*Cf*Pi**4*alphas**3 * (  - 512*
     +    ms1**2*s**(-3)*t1*s4*(t1+u1)**(-1) + 512*ms1**2*s**(-3)*t1 - 
     +    512*ms1**2*s**(-3)*u1 + 512*ms1**2*s**(-2) - 1024*s**(-4)*
     +    t1**3*s4*(t1+u1)**(-1) + 1024*s**(-4)*t1**3 - 1024*s**(-3)*t1
     +    *u1 + 512*s**(-3)*t1**2*s4*(t1+u1)**(-1) + 512*s**(-3)*t1**2
     +     + 512*s**(-3)*u1**2 - 512*s**(-2)*t1 + 512*s**(-2)*u1 )
      TB_QBH=TB_QBH + ANG4(52)*Nc*Cf**2*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-1) )
      TB_QBH=TB_QBH + ANG4(54)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-3)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-3)*t1 - 1024*
     +    ms1**2*s**(-2)*t1*s4**(-1) + 512*ms1**2*s**(-2) - 1024*ms1**2
     +    *s**(-1)*s4**(-1) + 2048*s**(-4)*t1**3*s4*(t1+u1)**(-1) - 
     +    2048*s**(-4)*t1**3 + 1024*s**(-3)*t1**2*s4*(t1+u1)**(-1) - 
     +    512*s**(-3)*t1**2 - 2048*s**(-3)*t1**3*s4**(-1) + 512*s**(-3)
     +    *u1**2 + 2560*s**(-2)*t1 - 5120*s**(-2)*t1**2*s4**(-1) - 1024
     +    *s**(-2)*u1 - 4096*s**(-1)*t1*s4**(-1) + 1024*s**(-1) - 1024*
     +    s4**(-1) )
      TB_QBH=TB_QBH + ANG4(54)*Nc**2*Cf*Pi**4*alphas**3 * (  - 256*
     +    ms1**2*s**(-3)*t1*s4*(t1+u1)**(-1) + 256*ms1**2*s**(-3)*t1 + 
     +    512*ms1**2*s**(-2)*t1*s4**(-1) - 256*ms1**2*s**(-2) + 512*
     +    ms1**2*s**(-1)*s4**(-1) - 512*s**(-4)*t1**3*s4*(t1+u1)**(-1)
     +     + 512*s**(-4)*t1**3 + 256*s**(-3)*t1*u1 - 256*s**(-3)*t1**2*
     +    s4*(t1+u1)**(-1) - 256*s**(-3)*t1**2 + 1024*s**(-3)*t1**3*
     +    s4**(-1) - 256*s**(-3)*u1**2 - 1280*s**(-2)*t1 + 2560*s**(-2)
     +    *t1**2*s4**(-1) + 512*s**(-2)*u1 + 2048*s**(-1)*t1*s4**(-1)
     +     - 512*s**(-1) + 512*s4**(-1) )
      TB_QBH=TB_QBH + ANG4(56)*Nc*Cf**2*Pi**4*alphas**3 * ( 512*ms1**2*
     +    s**(-1) )
      TB_QBH=TB_QBH + ANG4(58)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-3)*t1*s4*(t1+u1)**(-1) - 1024*ms1**2*s**(-3)*t1 - 1024*
     +    ms1**2*s**(-2)*t1*s4**(-1) + 512*ms1**2*s**(-2) + 2048*
     +    s**(-4)*t1**3*s4*(t1+u1)**(-1) - 2048*s**(-4)*t1**3 - 1024*
     +    s**(-3)*t1**2*s4*(t1+u1)**(-1) + 1536*s**(-3)*t1**2 - 2048*
     +    s**(-3)*t1**3*s4**(-1) + 512*s**(-3)*u1**2 + 1024*s**(-2)*t1
     +     - 1024*s**(-2)*t1**2*s4**(-1) + 512*s**(-2)*u1 )
      TB_QBH=TB_QBH + ANG4(58)*Nc**2*Cf*Pi**4*alphas**3 * (  - 512*
     +    ms1**2*s**(-3)*t1*s4*(t1+u1)**(-1) + 512*ms1**2*s**(-3)*t1 + 
     +    256*ms1**2*s**(-2)*t1*s4**(-1) - 1024*s**(-4)*t1**3*s4*
     +    (t1+u1)**(-1) + 1024*s**(-4)*t1**3 - 256*s**(-3)*t1*u1 + 512*
     +    s**(-3)*t1**2*s4*(t1+u1)**(-1) - 256*s**(-3)*t1**2 + 512*
     +    s**(-3)*t1**3*s4**(-1) - 512*s**(-2)*t1 + 256*s**(-2)*t1**2*
     +    s4**(-1) )
      TB_QBH=TB_QBH + COLO1(9)*Nc*Cf**2*Pi**4*alphas**3 * ( 1024*ms1**2
     +    *s**(-4)*t1**(-1)*u1 + 1024*ms1**2*s**(-4)*t1*u1**(-1) + 4096
     +    *ms1**2*s**(-4)*t1*s4**(-1) - 4096*ms1**2*s**(-4)*t1**2*
     +    s4**(-2) - 2048*ms1**2*s**(-4) - 1024*ms1**2*s**(-3)*t1**(-2)
     +    *u1 + 1024*ms1**2*s**(-3)*t1**(-1) - 1024*ms1**2*s**(-3)*t1*
     +    u1**(-2) - 4096*ms1**2*s**(-3)*t1*s4**(-2) + 1024*ms1**2*
     +    s**(-3)*u1**(-1) - 2048*ms1**2*s**(-3)*s4**(-1) - 1024*ms1**2
     +    *s**(-2)*t1**(-2) - 1024*ms1**2*s**(-2)*u1**(-2) - 1024*
     +    ms1**4*s**(-3)*t1**(-2) + 2048*ms1**4*s**(-3)*t1**(-1)*
     +    s4**(-1) - 1024*ms1**4*s**(-3)*u1**(-2) + 2048*ms1**4*s**(-3)
     +    *u1**(-1)*s4**(-1) - 4096*ms1**4*s**(-3)*s4**(-2) + 1024*
     +    s**(-4)*t1**(-1)*u1**2 + 3072*s**(-4)*t1 + 1024*s**(-4)*t1**2
     +    *u1**(-1) - 4096*s**(-4)*t1**2*s4**(-1) - 1024*s**(-4)*u1 + 
     +    1024*s**(-3)*t1**(-1)*u1 + 1024*s**(-3)*t1*u1**(-1) - 4096*
     +    s**(-3)*t1*s4**(-1) )

      TB_QBH = fac * TB_QBH 
ctp      TB_QBH = fac * 389379660.D0 * TB_QBH 

      end







