      REAL*8 FUNCTION DGGGG1(ALPHAS,S,TG,MS,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF VIRTUAL
C***  SCA = Q**2/MG**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,TG,UG,MS,MG,SCA,PI,BETAL,PGG,DGGGGB,NS
      PI = 4.D0*ATAN(1.D0)
      NS = 6.D0
      UG = -S -TG
      BETAL = -11.D0 + 2.D0/3.D0*(NS -1.D0)
      PGG = 3.D0*(-2.D0*LOG(-TG/MG**2) -2*LOG(-UG/MG**2) +11.D0/3.D0)
     +     -2.D0/3.D0*(NS -1.D0)
      DGGGG1 = DGGGGB(ALPHAS,S,TG,MS,MG)*
     +     ALPHAS/2.D0/PI*LOG(1.D0/SCA)*( BETAL +PGG)
      RETURN
      END


      REAL*8 FUNCTION DGGGG2(ALPHAS,S,TG,S4G,MS,MG,DEL,S4GMAX,SCA)
C***  GIVES THE SCALE DEPENDENCE OF LOG(DEL)
C***  SCA = Q**2/MG**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,TG,S4G,S4GMAX,MS,MG,SCA,PI,DGGGGB,DLDEL1,DEL
      PI = 4.D0*ATAN(1.D0)
      DLDEL1 = LOG(S4GMAX/MG**2) -(S4GMAX -DEL)/S4G
      DGGGG2 = 3.D0*4.D0*DLDEL1*DGGGGB(ALPHAS,S,TG,MS,MG)
     +     * ALPHAS/2.D0/PI*LOG(1.D0/SCA)
      RETURN
      END


      REAL*8 FUNCTION DGGGG3(ALPHAS,S,TG,S4G,MS,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF HARD
C***  SCA = Q**2/MG**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,TG,UG,S4G,MS,MG,PI
      REAL*8 DGGGGB,PGG1,PGG2,SCA,X1,X2
      PI = 4.D0*ATAN(1.D0)
      UG = S4G -S -TG
      X1 = -UG/(S+TG)
      X2 = -TG/(S+UG)
      PGG1 = 3.D0*( 2.D0/(1.D0 -X1) +2.D0/X1 -4.D0 +2.D0*X1 -2.D0*X1**2)
      PGG2 = 3.D0*( 2.D0/(1.D0 -X2) +2.D0/X2 -4.D0 +2.D0*X2 -2.D0*X2**2)
      DGGGG3 = ALPHAS/2.D0/PI*LOG(1.D0/SCA) *
     +     (-1/UG*DGGGGB(ALPHAS,X1*S,X1*TG,MS,MG)*PGG1*X1**2
     +      -1/TG*DGGGGB(ALPHAS,X2*S,TG,MS,MG)*PGG2*X2**2 )
      RETURN
      END

      REAL*8 FUNCTION DGGGGB(ALPHAS,S,TG,MS,MG)
C***  BORN CROSS SECTION FOR G + G -> GL + GL
      IMPLICIT NONE
      REAL*8 ALPHAS,S,TG,UG,MS,MG,MG2
      REAL*8 NS,CONV,PI,N,CO,AVG
      NS = 6.D0
      CONV = 389379660.D0
      PI = 4.D0*ATAN(1.D0)
      N = 3.D0
      CO = N*(N**2 -1.D0)
      AVG = (1.D0/2.D0)**2 * (1.D0/(N**2 -1.D0))**2
      UG = -S -TG
      MG2 = MG**2
      DGGGGB = 0.5D0 * ALPHAS**2 * CONV *AVG *PI/S**2 * N*CO *
     +     (  - 8*S**(-2)*TG**2 - 8*S**(-2)*
     +    UG**2 - 32*S**(-1)*MG2 + 32*S*TG**(-1)*UG**(-1)*MG2 - 32*S**2
     +    *TG**(-2)*UG**(-2)*MG2**2 + 32*TG**(-1)*UG**(-1)*MG2**2 + 8*
     +    TG**(-1)*UG + 8*TG*UG**(-1) )

      RETURN
      END


      REAL*8 FUNCTION DGGGGV(ALPHAS,S,TG,MS,MG,MT)
C***  VIRTUAL+SOFT CROSS SECTION FOR G + G -> GL + GL
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T,TG,U,UG,T1,U1,SBG,S1,MS,MG,MT,MS2,MG2,MT2,M2
      REAL*8 NS,CONV,PI,ZETA2,N,CO,AVG,BETA,XG,SPENCE,THREE
      REAL*8 SK1B0A(1:3), SK1B0B(1:4), SK1B0C(1:3), SK1B0D(1:4,1:2)
      REAL*8 SK1B0E(1:3), SK1BP(1:5), SK1C0A(1:6), SK1C0B(1:6)
      REAL*8 SK1C0C(1:8,1:2), SK1D0(1:12,1:2)
      REAL*8 SL1B0A, SL1B0B, SL1B0C, SL1B0D,SL1B0E
      REAL*8 SL1BP, SL1C0A, SL1C0B
      REAL*8 SL1C0C, SL1D0
      REAL*8 SOF1(1:8)
      REAL*8 M2GGSV,DGGGGB
      real*8 ms2x
      COMPLEX*16 KBETAS,KXS,KBETAT,KXT            
      PI = 4.D0*ATAN(1.D0)
      ZETA2 = PI**2/6.D0
      CONV = 389379660.D0

      NS = 6
      N = 3.D0
      CO = N*(N**2 -1.D0)
      AVG = (1.D0/2.D0)**2 * (1.D0/(N**2 -1.D0))**2
      THREE = 3.D0

      MS2 = MS**2
      MG2 = MG**2
      MT2 = MT**2
      M2 = MG2 - MS2
      UG = -S -TG
      T = TG +MG2
      U = UG +MG2
      T1 = T -MS2
      U1 = U -MS2
      S1 = 4*MG2 -S

      ms2x = ms2
      if ( (ms.gt.1.D4).and.(ms.gt.10.D0*mg) ) ms2x = ms2x/10.D0 

      BETA = SQRT(1.D0 - 4.D0*MG2/S)
      XG = (1.D0 -BETA)*(1.D0+BETA)**(-1)
      SBG = S*BETA

      KBETAS = SQRT( DCMPLX(1.D0 - 4.D0*MS2/S)) 
      KXS = (1.D0 -KBETAS)/(1.D0+KBETAS)
      KBETAT = SQRT( DCMPLX(1.D0 - 4.D0*MT2/S)) 
      KXT = (1.D0 -KBETAT)/(1.D0+KBETAT)

      SK1B0A(1) = SL1B0A(MG2,MS2X,MT2,1)
      SK1B0A(2) = SL1B0A(MG2,MS2X,MT2,2)
      SK1B0A(3) = SL1B0A(MG2,MS2X,MT2,3)

      SK1B0B(1) = SL1B0B(MG2,MS2X,MT2,S,BETA,XG,KBETAS,KXS,KBETAT,KXT,1)
      SK1B0B(2) = SL1B0B(MG2,MS2X,MT2,S,BETA,XG,KBETAS,KXS,KBETAT,KXT,2)
      SK1B0B(3) = SL1B0B(MG2,MS2X,MT2,S,BETA,XG,KBETAS,KXS,KBETAT,KXT,3)
      SK1B0B(4) = SL1B0B(MG2,MS2X,MT2,S,BETA,XG,KBETAS,KXS,KBETAT,KXT,4)

      SK1B0C(1) = SL1B0C(MG2,MS2X,MT2,1)
      SK1B0C(2) = SL1B0C(MG2,MS2X,MT2,2)
      SK1B0C(3) = SL1B0C(MG2,MS2X,MT2,3)

      SK1B0D(1,1) = SL1B0D(MG2,MS2X,MT2,T,1)
      SK1B0D(2,1) = SL1B0D(MG2,MS2X,MT2,T,2)
      SK1B0D(3,1) = SL1B0D(MG2,MS2X,MT2,T,3)
      SK1B0D(4,1) = SL1B0D(MG2,MS2X,MT2,T,4)
      SK1B0D(1,2) = SL1B0D(MG2,MS2X,MT2,U,1)
      SK1B0D(2,2) = SL1B0D(MG2,MS2X,MT2,U,2)
      SK1B0D(3,2) = SL1B0D(MG2,MS2X,MT2,U,3)
      SK1B0D(4,2) = SL1B0D(MG2,MS2X,MT2,U,4)

      SK1B0E(1) = SL1B0E(MG2,MS2X,MT2,1)
      SK1B0E(2) = SL1B0E(MG2,MS2X,MT2,2)
      SK1B0E(3) = SL1B0E(MG2,MS2X,MT2,3)

      SK1BP(1) = SL1BP(MG2,MS2X,MT2,1)
      SK1BP(2) = SL1BP(MG2,MS2X,MT2,2)
      SK1BP(3) = SL1BP(MG2,MS2X,MT2,3)
      SK1BP(4) = SL1BP(MG2,MS2X,MT2,4)
      SK1BP(5) = SL1BP(MG2,MS2X,MT2,5)


      SK1C0A(1) = SL1C0A(MG2,MS2X,MT2,S,XG,ZETA2,KXS,KXT,1)
      SK1C0A(2) = SL1C0A(MG2,MS2X,MT2,S,XG,ZETA2,KXS,KXT,2)
      SK1C0A(3) = SL1C0A(MG2,MS2X,MT2,S,XG,ZETA2,KXS,KXT,3)
      SK1C0A(4) = SL1C0A(MG2,MS2X,MT2,S,XG,ZETA2,KXS,KXT,4)
C$$$      SK1C0A(5) = SL1C0A(MG2,MS2X,MT2,S,XG,ZETA2,KXS,KXT,5)
C$$$      SK1C0A(6) = SL1C0A(MG2,MS2X,MT2,S,XG,ZETA2,KXS,KXT,6)

      SK1C0B(1) = SL1C0B(MG2,MS2X,MT2,S,XG,ZETA2,SBG,1)
      SK1C0B(2) = SL1C0B(MG2,MS2X,MT2,S,XG,ZETA2,SBG,2)
      SK1C0B(3) = SL1C0B(MG2,MS2X,MT2,S,XG,ZETA2,SBG,3)
      SK1C0B(4) = SL1C0B(MG2,MS2X,MT2,S,XG,ZETA2,SBG,4)
      SK1C0B(5) = SL1C0B(MG2,MS2X,MT2,S,XG,ZETA2,SBG,5)
      SK1C0B(6) = SL1C0B(MG2,MS2X,MT2,S,XG,ZETA2,SBG,6)

      SK1C0C(1,1) = SL1C0C(MG2,MS2X,MT2,T,ZETA2,1)
      SK1C0C(2,1) = SL1C0C(MG2,MS2X,MT2,T,ZETA2,2)
      SK1C0C(3,1) = SL1C0C(MG2,MS2X,MT2,T,ZETA2,3)
      SK1C0C(4,1) = SL1C0C(MG2,MS2X,MT2,T,ZETA2,4)
C$$$      SK1C0C(5,1) = SL1C0C(MG2,MS2X,MT2,T,ZETA2,5)
C$$$      SK1C0C(6,1) = SL1C0C(MG2,MS2X,MT2,T,ZETA2,6)
      SK1C0C(7,1) = SL1C0C(MG2,MS2X,MT2,T,ZETA2,7)
      SK1C0C(8,1) = SL1C0C(MG2,MS2X,MT2,T,ZETA2,8)

      SK1C0C(1,2) = SL1C0C(MG2,MS2X,MT2,U,ZETA2,1)
      SK1C0C(2,2) = SL1C0C(MG2,MS2X,MT2,U,ZETA2,2)
      SK1C0C(3,2) = SL1C0C(MG2,MS2X,MT2,U,ZETA2,3)
      SK1C0C(4,2) = SL1C0C(MG2,MS2X,MT2,U,ZETA2,4)
C$$$      SK1C0C(5,2) = SL1C0C(MG2,MS2X,MT2,U,ZETA2,5)
C$$$      SK1C0C(6,2) = SL1C0C(MG2,MS2X,MT2,U,ZETA2,6)
      SK1C0C(7,2) = SL1C0C(MG2,MS2X,MT2,U,ZETA2,7)
      SK1C0C(8,2) = SL1C0C(MG2,MS2X,MT2,U,ZETA2,8)


      SK1D0(1,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,1)
      SK1D0(2,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,2)
      SK1D0(3,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,3)
      SK1D0(4,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,4)
      SK1D0(5,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,5)
      SK1D0(6,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,6)
C$$$      SK1D0(7,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,7)
C$$$      SK1D0(8,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,8)
C$$$      SK1D0(9,1) = SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,9)
      SK1D0(10,1)= SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,10)
      SK1D0(11,1)= SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,11)
      SK1D0(12,1)= SL1D0(MG2,MS2X,MT2,S,T,U,SBG,XG,ZETA2,12)

      SK1D0(1,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,1)
      SK1D0(2,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,2)
      SK1D0(3,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,3)
      SK1D0(4,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,4)
      SK1D0(5,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,5)
C$$$      SK1D0(6,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,6)
C$$$      SK1D0(7,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,7)
C$$$      SK1D0(8,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,8)
C$$$      SK1D0(9,2) = SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,9)
      SK1D0(10,2)= SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,10)
      SK1D0(11,2)= SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,11)
C$$$      SK1D0(12,2)= SL1D0(MG2,MS2X,MT2,S,U,T,SBG,XG,ZETA2,12)


      SOF1(1) = 0.125D0/SBG * ( +4*SPENCE(XG) +4*SPENCE(-XG) 
     +     +4*LOG(XG)*LOG(1-XG**2)-2*LOG(XG)**2 -2*ZETA2 )
      SOF1(2) = 0.125D0/MG2* (+2*(S -2*MG2)/SBG*LOG(XG))
      SOF1(3) = 0.125D0/MG2*(-2)
      SOF1(4) = 0.125D0/UG*(-1.5D0*ZETA2)
      SOF1(5) = 0.125D0/TG*(-1.5D0*ZETA2)
      SOF1(6) = 0.125D0/TG*(-2*LOG(XG)**2 +LOG(XG*UG/TG)**2 
     +     +2*SPENCE(1 -TG/XG/UG) -2*SPENCE(1 -UG/XG/TG) -1.5D0*ZETA2 )
      SOF1(7) = 0.125D0/UG*(-2*LOG(XG)**2 +LOG(XG*TG/UG)**2 
     +     +2*SPENCE(1 -UG/XG/TG) -2*SPENCE(1 -TG/XG/UG) -1.5D0*ZETA2)
      SOF1(8) = 0.125D0/S*(LOG(TG*UG/MG2/S)**2
     +     +2*SPENCE(1 -MG2*S/TG/UG) -3*ZETA2 )


      IF (MG.EQ.MS) THEN

      M2GGSV = 0.D0
      M2GGSV = M2GGSV + N*CO * (  - 128*S**(-2)*TG**(-1)*NS*MG2**3 + 64
     +    *S**(-2)*TG**(-1)*NS*MG2**4*T**(-1) + 64*S**(-2)*TG**(-1)*NS*
     +    MG2**4*U**(-1) + 128*S**(-2)*TG**(-1)*MG2**2*MT2 - 64*S**(-2)
     +    *TG**(-1)*MG2**3*MT2*T**(-1) - 64*S**(-2)*TG**(-1)*MG2**3*MT2
     +    *U**(-1) - 128*S**(-2)*UG**(-1)*NS*MG2**3 + 64*S**(-2)*
     +    UG**(-1)*NS*MG2**4*T**(-1) + 64*S**(-2)*UG**(-1)*NS*MG2**4*
     +    U**(-1) + 128*S**(-2)*UG**(-1)*MG2**2*MT2 - 64*S**(-2)*
     +    UG**(-1)*MG2**3*MT2*T**(-1) - 64*S**(-2)*UG**(-1)*MG2**3*MT2*
     +    U**(-1) + 64*S**(-1)*TG**(-2)*NS*MG2**3 - 64*S**(-1)*TG**(-2)
     +    *NS*MG2**4*T**(-1) - 64*S**(-1)*TG**(-2)*MG2**2*MT2 + 64*
     +    S**(-1)*TG**(-2)*MG2**3*MT2*T**(-1) - 64*S**(-1)*TG**(-1)*NS*
     +    MG2**3*T**(-1) - 64*S**(-1)*TG**(-1)*NS*MG2**3*U**(-1) + 64*
     +    S**(-1)*TG**(-1)*MG2**2*MT2*T**(-1) + 64*S**(-1)*TG**(-1)*
     +    MG2**2*MT2*U**(-1) - 8*S**(-1)*TG*NS*MG2*T**(-1) + 8*S**(-1)*
     +    TG*NS*MG2*U**(-1) + 8*S**(-1)*TG*MT2*T**(-1) - 8*S**(-1)*TG*
     +    MT2*U**(-1) )
     +
      M2GGSV = M2GGSV + N*CO * ( 8*S**(-1)*TG**2*NS*MG2**(-1) - 8*
     +    S**(-1)*TG**2*MG2**(-2)*MT2 + 64*S**(-1)*UG**(-2)*NS*MG2**3
     +     - 64*S**(-1)*UG**(-2)*NS*MG2**4*U**(-1) - 64*S**(-1)*
     +    UG**(-2)*MG2**2*MT2 + 64*S**(-1)*UG**(-2)*MG2**3*MT2*U**(-1)
     +     - 64*S**(-1)*UG**(-1)*NS*MG2**3*T**(-1) - 64*S**(-1)*
     +    UG**(-1)*NS*MG2**3*U**(-1) + 64*S**(-1)*UG**(-1)*MG2**2*MT2*
     +    T**(-1) + 64*S**(-1)*UG**(-1)*MG2**2*MT2*U**(-1) + 32*S**(-1)
     +    *NS*MG2 - 16*S**(-1)*NS*MG2**2*T**(-1) - 16*S**(-1)*NS*MG2**2
     +    *U**(-1) + 16*S**(-1)*MG2*MT2*T**(-1) + 16*S**(-1)*MG2*MT2*
     +    U**(-1) - 32*S**(-1)*MT2 + 32*S*TG**(-3)*NS*MG2**2 - 32*S*
     +    TG**(-3)*NS*MG2**3*T**(-1) - 32*S*TG**(-3)*MG2*MT2 + 32*S*
     +    TG**(-3)*MG2**2*MT2*T**(-1) - 48*S*TG**(-2)*NS*MG2 - 16*S*
     +    TG**(-2)*NS*MG2**2*T**(-1) + 16*S*TG**(-2)*MG2*MT2*T**(-1) + 
     +    48*S*TG**(-2)*MT2 + 16*S*TG**(-1)*NS*MG2*T**(-1) - 8*S*
     +    TG**(-1)*NS*MG2*U**(-1) - 16*S*TG**(-1)*NS + 16*S*TG**(-1)*
     +    MG2**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + N*CO * (  - 16*S*TG**(-1)*MT2*T**(-1) + 8*S*
     +    TG**(-1)*MT2*U**(-1) + 32*S*UG**(-3)*NS*MG2**2 - 32*S*
     +    UG**(-3)*NS*MG2**3*U**(-1) - 32*S*UG**(-3)*MG2*MT2 + 32*S*
     +    UG**(-3)*MG2**2*MT2*U**(-1) - 48*S*UG**(-2)*NS*MG2 - 16*S*
     +    UG**(-2)*NS*MG2**2*U**(-1) + 16*S*UG**(-2)*MG2*MT2*U**(-1) + 
     +    48*S*UG**(-2)*MT2 - 8*S*UG**(-1)*NS*MG2*T**(-1) + 16*S*
     +    UG**(-1)*NS*MG2*U**(-1) - 16*S*UG**(-1)*NS + 16*S*UG**(-1)*
     +    MG2**(-1)*MT2 + 8*S*UG**(-1)*MT2*T**(-1) - 16*S*UG**(-1)*MT2*
     +    U**(-1) - 128*TG**(-3)*NS*MG2**3 + 128*TG**(-3)*NS*MG2**4*
     +    T**(-1) + 128*TG**(-3)*MG2**2*MT2 - 128*TG**(-3)*MG2**3*MT2*
     +    T**(-1) - 16*TG**(-2)*NS*MG2**2 + 144*TG**(-2)*NS*MG2**3*
     +    T**(-1) + 16*TG**(-2)*MG2*MT2 - 144*TG**(-2)*MG2**2*MT2*
     +    T**(-1) + 32*TG**(-1)*S1**(-1)*NS*MG2**2 - 32*TG**(-1)*
     +    S1**(-1)*MG2*MT2 - 40*TG**(-1)*NS*MG2 + 56*TG**(-1)*NS*MG2**2
     +    *T**(-1) + 24*TG**(-1)*NS*MG2**2*U**(-1) - 56*TG**(-1)*MG2*
     +    MT2*T**(-1) )
     +
      M2GGSV = M2GGSV + N*CO * (  - 24*TG**(-1)*MG2*MT2*U**(-1) + 40*
     +    TG**(-1)*MT2 + 32*TG*S1**(-1)*NS - 32*TG*S1**(-1)*MG2**(-1)*
     +    MT2 + 8*TG**2*S1**(-1)*NS*MG2**(-1) - 8*TG**2*S1**(-1)*
     +    MG2**(-2)*MT2 - 128*UG**(-3)*NS*MG2**3 + 128*UG**(-3)*NS*
     +    MG2**4*U**(-1) + 128*UG**(-3)*MG2**2*MT2 - 128*UG**(-3)*
     +    MG2**3*MT2*U**(-1) - 16*UG**(-2)*NS*MG2**2 + 144*UG**(-2)*NS*
     +    MG2**3*U**(-1) + 16*UG**(-2)*MG2*MT2 - 144*UG**(-2)*MG2**2*
     +    MT2*U**(-1) + 32*UG**(-1)*S1**(-1)*NS*MG2**2 - 32*UG**(-1)*
     +    S1**(-1)*MG2*MT2 - 40*UG**(-1)*NS*MG2 + 24*UG**(-1)*NS*MG2**2
     +    *T**(-1) + 56*UG**(-1)*NS*MG2**2*U**(-1) - 24*UG**(-1)*MG2*
     +    MT2*T**(-1) - 56*UG**(-1)*MG2*MT2*U**(-1) + 40*UG**(-1)*MT2
     +     + 64*S1**(-1)*NS*MG2 - 64*S1**(-1)*MT2 + 16*NS*MG2*T**(-1)
     +     + 24*NS*MG2*U**(-1) - 48*NS + 48*MG2**(-1)*MT2 - 16*MT2*
     +    T**(-1) - 24*MT2*U**(-1) )
     +
      M2GGSV = M2GGSV + N**2*CO * ( 48 + 128*S**(-2)*TG**(-1)*MG2**3 - 
     +    64*S**(-2)*TG**(-1)*MG2**4*T**(-1) - 64*S**(-2)*TG**(-1)*
     +    MG2**4*U**(-1) + 128*S**(-2)*UG**(-1)*MG2**3 - 64*S**(-2)*
     +    UG**(-1)*MG2**4*T**(-1) - 64*S**(-2)*UG**(-1)*MG2**4*U**(-1)
     +     - 64*S**(-1)*TG**(-2)*MG2**3 + 64*S**(-1)*TG**(-2)*MG2**4*
     +    T**(-1) + 64*S**(-1)*TG**(-1)*MG2**3*T**(-1) + 64*S**(-1)*
     +    TG**(-1)*MG2**3*U**(-1) + 8*S**(-1)*TG*MG2*T**(-1) - 8*
     +    S**(-1)*TG*MG2*U**(-1) - 8*S**(-1)*TG**2*MG2**(-1) - 64*
     +    S**(-1)*UG**(-2)*MG2**3 + 64*S**(-1)*UG**(-2)*MG2**4*U**(-1)
     +     + 64*S**(-1)*UG**(-1)*MG2**3*T**(-1) + 64*S**(-1)*UG**(-1)*
     +    MG2**3*U**(-1) - 32*S**(-1)*MG2 + 16*S**(-1)*MG2**2*T**(-1)
     +     + 16*S**(-1)*MG2**2*U**(-1) - 32*S*TG**(-3)*MG2**2 + 32*S*
     +    TG**(-3)*MG2**3*T**(-1) + 48*S*TG**(-2)*MG2 + 16*S*TG**(-2)*
     +    MG2**2*T**(-1) - 16*S*TG**(-1)*MG2*T**(-1) + 8*S*TG**(-1)*MG2
     +    *U**(-1) + 16*S*TG**(-1) - 32*S*UG**(-3)*MG2**2 + 32*S*
     +    UG**(-3)*MG2**3*U**(-1) )
     +
      M2GGSV = M2GGSV + N**2*CO * ( 48*S*UG**(-2)*MG2 + 16*S*UG**(-2)*
     +    MG2**2*U**(-1) + 8*S*UG**(-1)*MG2*T**(-1) - 16*S*UG**(-1)*MG2
     +    *U**(-1) + 16*S*UG**(-1) + 128*TG**(-3)*MG2**3 - 128*TG**(-3)
     +    *MG2**4*T**(-1) + 16*TG**(-2)*MG2**2 - 144*TG**(-2)*MG2**3*
     +    T**(-1) - 32*TG**(-1)*S1**(-1)*MG2**2 + 40*TG**(-1)*MG2 - 56*
     +    TG**(-1)*MG2**2*T**(-1) - 24*TG**(-1)*MG2**2*U**(-1) - 32*TG*
     +    S1**(-1) - 8*TG**2*S1**(-1)*MG2**(-1) + 128*UG**(-3)*MG2**3
     +     - 128*UG**(-3)*MG2**4*U**(-1) + 16*UG**(-2)*MG2**2 - 144*
     +    UG**(-2)*MG2**3*U**(-1) - 32*UG**(-1)*S1**(-1)*MG2**2 + 40*
     +    UG**(-1)*MG2 - 24*UG**(-1)*MG2**2*T**(-1) - 56*UG**(-1)*
     +    MG2**2*U**(-1) - 64*S1**(-1)*MG2 - 16*MG2*T**(-1) - 24*MG2*
     +    U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0A(1)*N*CO*THREE**(-1) * ( 96*S**(-2)*TG**2
     +     - 288*S**(-1)*TG**(-1)*MG2**2 - 96*S**(-1)*TG**(-1)*MG2**3*
     +    T**(-1) - 48*S**(-1)*TG*MG2*T**(-1) + 48*S**(-1)*TG*MG2*
     +    U**(-1) + 96*S**(-1)*TG + 24*S**(-1)*TG**2*MG2**(-1) - 288*
     +    S**(-1)*UG**(-1)*MG2**2 - 96*S**(-1)*UG**(-1)*MG2**3*U**(-1)
     +     + 288*S**(-1)*MG2 - 96*S**(-1)*MG2**2*T**(-1) - 96*S**(-1)*
     +    MG2**2*U**(-1) + 96*S*TG**(-3)*MG2**2 - 96*S*TG**(-3)*MG2**3*
     +    T**(-1) - 96*S*TG**(-2)*MG2 - 96*S*TG**(-2)*MG2**2*T**(-1) - 
     +    24*S*TG**(-1)*MG2*U**(-1) + 96*S*UG**(-3)*MG2**2 - 96*S*
     +    UG**(-3)*MG2**3*U**(-1) - 96*S*UG**(-2)*MG2 - 96*S*UG**(-2)*
     +    MG2**2*U**(-1) - 24*S*UG**(-1)*MG2*T**(-1) + 528*TG**(-2)*
     +    MG2**2 - 144*TG**(-2)*MG2**3*T**(-1) + 96*TG**(-1)*S1**(-1)*
     +    MG2**2 + 168*TG**(-1)*MG2 - 48*TG**(-1)*MG2**2*T**(-1) + 24*
     +    TG**(-1)*MG2**2*U**(-1) + 96*TG*S1**(-1) + 24*TG**2*S1**(-1)*
     +    MG2**(-1) + 528*UG**(-2)*MG2**2 - 144*UG**(-2)*MG2**3*U**(-1)
     +     + 96*UG**(-1)*S1**(-1)*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1B0A(1)*N*CO*THREE**(-1) * ( 168*UG**(-1)*MG2
     +     + 24*UG**(-1)*MG2**2*T**(-1) - 48*UG**(-1)*MG2**2*U**(-1) + 
     +    192*S1**(-1)*MG2 - 24*MG2*T**(-1) + 24*MG2*U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0A(2)*N*CO*THREE**(-1) * ( 96 + 384*S**(-2)
     +    *TG**(-1)*MG2**2*MT2 - 192*S**(-2)*TG**(-1)*MG2**3*MT2*
     +    T**(-1) - 192*S**(-2)*TG**(-1)*MG2**3*MT2*U**(-1) + 64*
     +    S**(-2)*TG**2 + 384*S**(-2)*UG**(-1)*MG2**2*MT2 - 192*S**(-2)
     +    *UG**(-1)*MG2**3*MT2*T**(-1) - 192*S**(-2)*UG**(-1)*MG2**3*
     +    MT2*U**(-1) + 384*S**(-2)*MG2*MT2 - 192*S**(-1)*TG**(-2)*
     +    MG2**2*MT2 + 192*S**(-1)*TG**(-2)*MG2**3*MT2*T**(-1) + 96*
     +    S**(-1)*TG**(-1)*MG2*MT2 + 192*S**(-1)*TG**(-1)*MG2**2*MT2*
     +    T**(-1) + 192*S**(-1)*TG**(-1)*MG2**2*MT2*U**(-1) - 128*
     +    S**(-1)*TG**(-1)*MG2**2 + 24*S**(-1)*TG*MT2*T**(-1) - 24*
     +    S**(-1)*TG*MT2*U**(-1) + 64*S**(-1)*TG - 24*S**(-1)*TG**2*
     +    MG2**(-2)*MT2 - 192*S**(-1)*UG**(-2)*MG2**2*MT2 + 192*S**(-1)
     +    *UG**(-2)*MG2**3*MT2*U**(-1) + 96*S**(-1)*UG**(-1)*MG2*MT2 + 
     +    192*S**(-1)*UG**(-1)*MG2**2*MT2*T**(-1) + 192*S**(-1)*
     +    UG**(-1)*MG2**2*MT2*U**(-1) - 128*S**(-1)*UG**(-1)*MG2**2 + 
     +    48*S**(-1)*MG2*MT2*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0A(2)*N*CO*THREE**(-1) * ( 48*S**(-1)*MG2*
     +    MT2*U**(-1) + 128*S**(-1)*MG2 - 96*S**(-1)*MT2 - 96*S*
     +    TG**(-3)*MG2*MT2 + 96*S*TG**(-3)*MG2**2*MT2*T**(-1) + 48*S*
     +    TG**(-2)*MG2*MT2*T**(-1) + 144*S*TG**(-2)*MT2 + 48*S*TG**(-1)
     +    *MG2**(-1)*MT2 - 48*S*TG**(-1)*MT2*T**(-1) + 24*S*TG**(-1)*
     +    MT2*U**(-1) + 32*S*TG**(-1) - 96*S*UG**(-3)*MG2*MT2 + 96*S*
     +    UG**(-3)*MG2**2*MT2*U**(-1) + 48*S*UG**(-2)*MG2*MT2*U**(-1)
     +     + 144*S*UG**(-2)*MT2 + 48*S*UG**(-1)*MG2**(-1)*MT2 + 24*S*
     +    UG**(-1)*MT2*T**(-1) - 48*S*UG**(-1)*MT2*U**(-1) + 32*S*
     +    UG**(-1) + 384*TG**(-3)*MG2**2*MT2 - 384*TG**(-3)*MG2**3*MT2*
     +    T**(-1) + 48*TG**(-2)*MG2*MT2 - 432*TG**(-2)*MG2**2*MT2*
     +    T**(-1) + 128*TG**(-2)*MG2**2 - 96*TG**(-1)*S1**(-1)*MG2*MT2
     +     - 168*TG**(-1)*MG2*MT2*T**(-1) - 72*TG**(-1)*MG2*MT2*U**(-1)
     +     + 128*TG**(-1)*MG2 + 120*TG**(-1)*MT2 - 96*TG*S1**(-1)*
     +    MG2**(-1)*MT2 - 24*TG**2*S1**(-1)*MG2**(-2)*MT2 + 384*
     +    UG**(-3)*MG2**2*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0A(2)*N*CO*THREE**(-1) * (  - 384*UG**(-3)*
     +    MG2**3*MT2*U**(-1) + 48*UG**(-2)*MG2*MT2 - 432*UG**(-2)*
     +    MG2**2*MT2*U**(-1) + 128*UG**(-2)*MG2**2 - 96*UG**(-1)*
     +    S1**(-1)*MG2*MT2 - 72*UG**(-1)*MG2*MT2*T**(-1) - 168*UG**(-1)
     +    *MG2*MT2*U**(-1) + 128*UG**(-1)*MG2 + 120*UG**(-1)*MT2 - 192*
     +    S1**(-1)*MT2 + 144*MG2**(-1)*MT2 - 48*MT2*T**(-1) - 72*MT2*
     +    U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0B(1)*N*CO * (  - 12 + 16*S**(-1)*TG**2*NS*
     +    MG2**(-1) - 16*S**(-1)*TG**2*MG2**(-1) + 8*S*S1**(-1)*NS - 8*
     +    S*S1**(-1) + 192*TG**(-1)*S1**(-2)*NS*MG2**3 - 192*TG**(-1)*
     +    S1**(-2)*MG2**3 - 64*TG**(-1)*S1**(-1)*NS*MG2**2 + 64*
     +    TG**(-1)*S1**(-1)*MG2**2 + 4*TG**(-1)*NS*MG2 - 4*TG**(-1)*MG2
     +     + 192*TG*S1**(-2)*NS*MG2 - 192*TG*S1**(-2)*MG2 + 16*TG*
     +    S1**(-1)*NS - 16*TG*S1**(-1) + 48*TG**2*S1**(-2)*NS - 48*
     +    TG**2*S1**(-2) + 16*TG**2*S1**(-1)*NS*MG2**(-1) - 16*TG**2*
     +    S1**(-1)*MG2**(-1) + 192*UG**(-1)*S1**(-2)*NS*MG2**3 - 192*
     +    UG**(-1)*S1**(-2)*MG2**3 - 64*UG**(-1)*S1**(-1)*NS*MG2**2 + 
     +    64*UG**(-1)*S1**(-1)*MG2**2 + 4*UG**(-1)*NS*MG2 - 4*UG**(-1)*
     +    MG2 + 384*S1**(-2)*NS*MG2**2 - 384*S1**(-2)*MG2**2 - 80*
     +    S1**(-1)*NS*MG2 + 80*S1**(-1)*MG2 + 12*NS )
     +
      M2GGSV = M2GGSV + SK1B0B(1)*N**2*CO * (  - 12 + 32*S**(-2)*TG**2
     +     + 32*S**(-1)*TG - 16*S**(-1)*TG**2*MG2**(-1) + 32*S**(-1)*
     +    MG2 - 16*S*S1**(-1) - 192*TG**(-1)*S1**(-2)*MG2**3 + 64*
     +    TG**(-1)*S1**(-1)*MG2**2 + 4*TG**(-1)*MG2 - 192*TG*S1**(-2)*
     +    MG2 - 16*TG*S1**(-1) - 48*TG**2*S1**(-2) - 16*TG**2*S1**(-1)*
     +    MG2**(-1) - 192*UG**(-1)*S1**(-2)*MG2**3 + 64*UG**(-1)*
     +    S1**(-1)*MG2**2 + 4*UG**(-1)*MG2 - 384*S1**(-2)*MG2**2 + 112*
     +    S1**(-1)*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0B(2)*N*CO * ( 12 + 128*S**(-2)*NS*MG2**2
     +     + 32*S**(-1)*TG**(-1)*NS*MG2**2 + 4*S**(-1)*TG**2*NS*
     +    MG2**(-1) - 4*S**(-1)*TG**2*MG2**(-1) + 32*S**(-1)*UG**(-1)*
     +    NS*MG2**2 + 48*TG**(-1)*S1**(-1)*NS*MG2**2 - 48*TG**(-1)*
     +    S1**(-1)*MG2**2 - 12*TG**(-1)*NS*MG2 + 12*TG**(-1)*MG2 + 16*
     +    TG*S1**(-1)*NS - 16*TG*S1**(-1) + 4*TG**2*S1**(-1)*NS*
     +    MG2**(-1) - 4*TG**2*S1**(-1)*MG2**(-1) + 48*UG**(-1)*S1**(-1)
     +    *NS*MG2**2 - 48*UG**(-1)*S1**(-1)*MG2**2 - 12*UG**(-1)*NS*MG2
     +     + 12*UG**(-1)*MG2 + 64*S1**(-1)*NS*MG2 - 64*S1**(-1)*MG2 - 
     +    12*NS )
     +
      M2GGSV = M2GGSV + SK1B0B(2)*N**2*CO * ( 28 + 32*S**(-2)*TG**2 - 
     +    128*S**(-2)*MG2**2 - 32*S**(-1)*TG**(-1)*MG2**2 + 32*S**(-1)*
     +    TG - 4*S**(-1)*TG**2*MG2**(-1) - 32*S**(-1)*UG**(-1)*MG2**2
     +     + 32*S**(-1)*MG2 + 8*S*S1**(-1) - 48*TG**(-1)*S1**(-1)*
     +    MG2**2 + 20*TG**(-1)*MG2 - 16*TG*S1**(-1) - 4*TG**2*S1**(-1)*
     +    MG2**(-1) - 48*UG**(-1)*S1**(-1)*MG2**2 + 20*UG**(-1)*MG2 - 
     +    96*S1**(-1)*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0B(3)*N*CO * (  - 12 - 16*S**(-2)*TG**2*
     +    MG2**(-1)*MT2 - 16*S**(-1)*TG*MG2**(-1)*MT2 - 10*S**(-1)*
     +    TG**2*MG2**(-2)*MT2 + 4*S**(-1)*TG**2*MG2**(-1) - 16*S**(-1)*
     +    MT2 - 96*TG**(-1)*S1**(-2)*MG2**2*MT2 + 8*TG**(-1)*S1**(-1)*
     +    MG2*MT2 + 48*TG**(-1)*S1**(-1)*MG2**2 - 12*TG**(-1)*MG2 - 96*
     +    TG*S1**(-2)*MT2 - 16*TG*S1**(-1)*MG2**(-1)*MT2 + 16*TG*
     +    S1**(-1) - 24*TG**2*S1**(-2)*MG2**(-1)*MT2 - 10*TG**2*
     +    S1**(-1)*MG2**(-2)*MT2 + 4*TG**2*S1**(-1)*MG2**(-1) - 96*
     +    UG**(-1)*S1**(-2)*MG2**2*MT2 + 8*UG**(-1)*S1**(-1)*MG2*MT2 + 
     +    48*UG**(-1)*S1**(-1)*MG2**2 - 12*UG**(-1)*MG2 - 192*S1**(-2)*
     +    MG2*MT2 + 64*S1**(-1)*MG2 - 8*S1**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0B(4)*N*CO * ( 12 - 16*S**(-2)*TG**2*
     +    MG2**(-1)*MT2 - 128*S**(-2)*MG2*MT2 - 32*S**(-1)*TG**(-1)*MG2
     +    *MT2 - 16*S**(-1)*TG*MG2**(-1)*MT2 - 10*S**(-1)*TG**2*
     +    MG2**(-2)*MT2 + 16*S**(-1)*TG**2*MG2**(-1) - 32*S**(-1)*
     +    UG**(-1)*MG2*MT2 - 16*S**(-1)*MT2 + 8*S*S1**(-1) - 96*
     +    TG**(-1)*S1**(-2)*MG2**2*MT2 + 192*TG**(-1)*S1**(-2)*MG2**3
     +     + 8*TG**(-1)*S1**(-1)*MG2*MT2 - 64*TG**(-1)*S1**(-1)*MG2**2
     +     + 4*TG**(-1)*MG2 + 192*TG*S1**(-2)*MG2 - 96*TG*S1**(-2)*MT2
     +     - 16*TG*S1**(-1)*MG2**(-1)*MT2 + 16*TG*S1**(-1) - 24*TG**2*
     +    S1**(-2)*MG2**(-1)*MT2 + 48*TG**2*S1**(-2) - 10*TG**2*
     +    S1**(-1)*MG2**(-2)*MT2 + 16*TG**2*S1**(-1)*MG2**(-1) - 96*
     +    UG**(-1)*S1**(-2)*MG2**2*MT2 + 192*UG**(-1)*S1**(-2)*MG2**3
     +     + 8*UG**(-1)*S1**(-1)*MG2*MT2 - 64*UG**(-1)*S1**(-1)*MG2**2
     +     + 4*UG**(-1)*MG2 - 192*S1**(-2)*MG2*MT2 + 384*S1**(-2)*
     +    MG2**2 - 80*S1**(-1)*MG2 - 8*S1**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0C(1)*N*CO * (  - 88 - 32*S**(-1)*TG**(-1)*
     +    NS*MG2**2 + 32*S**(-1)*TG**(-1)*MG2**2 - 28*S**(-1)*TG**2*NS*
     +    MG2**(-1) + 28*S**(-1)*TG**2*MG2**(-1) - 32*S**(-1)*UG**(-1)*
     +    NS*MG2**2 + 32*S**(-1)*UG**(-1)*MG2**2 - 32*S*TG**(-3)*NS*
     +    MG2**2 + 32*S*TG**(-3)*MG2**2 + 32*S*TG**(-2)*NS*MG2 - 32*S*
     +    TG**(-2)*MG2 + 32*S*TG**(-1)*NS - 32*S*TG**(-1) - 32*S*
     +    UG**(-3)*NS*MG2**2 + 32*S*UG**(-3)*MG2**2 + 32*S*UG**(-2)*NS*
     +    MG2 - 32*S*UG**(-2)*MG2 + 32*S*UG**(-1)*NS - 32*S*UG**(-1) - 
     +    8*S*S1**(-1)*NS + 8*S*S1**(-1) + 16*TG**(-2)*NS*MG2**2 - 16*
     +    TG**(-2)*MG2**2 - 192*TG**(-1)*S1**(-2)*NS*MG2**3 + 192*
     +    TG**(-1)*S1**(-2)*MG2**3 - 16*TG**(-1)*S1**(-1)*NS*MG2**2 + 
     +    16*TG**(-1)*S1**(-1)*MG2**2 + 80*TG**(-1)*NS*MG2 - 80*
     +    TG**(-1)*MG2 - 192*TG*S1**(-2)*NS*MG2 + 192*TG*S1**(-2)*MG2
     +     - 64*TG*S1**(-1)*NS + 64*TG*S1**(-1) - 48*TG**2*S1**(-2)*NS
     +     + 48*TG**2*S1**(-2) - 28*TG**2*S1**(-1)*NS*MG2**(-1) + 28*
     +    TG**2*S1**(-1)*MG2**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0C(1)*N*CO * ( 16*UG**(-2)*NS*MG2**2 - 16*
     +    UG**(-2)*MG2**2 - 192*UG**(-1)*S1**(-2)*NS*MG2**3 + 192*
     +    UG**(-1)*S1**(-2)*MG2**3 - 16*UG**(-1)*S1**(-1)*NS*MG2**2 + 
     +    16*UG**(-1)*S1**(-1)*MG2**2 + 80*UG**(-1)*NS*MG2 - 80*
     +    UG**(-1)*MG2 - 384*S1**(-2)*NS*MG2**2 + 384*S1**(-2)*MG2**2
     +     - 48*S1**(-1)*NS*MG2 + 48*S1**(-1)*MG2 + 88*NS )
     +
      M2GGSV = M2GGSV + SK1B0C(1)*N**2*CO * (  - 184 - 256*S**(-2)*
     +    TG**(-1)*MG2**3 - 64*S**(-2)*TG**2 - 256*S**(-2)*UG**(-1)*
     +    MG2**3 + 128*S**(-1)*TG**(-2)*MG2**3 + 224*S**(-1)*TG**(-1)*
     +    MG2**2 - 64*S**(-1)*TG + 28*S**(-1)*TG**2*MG2**(-1) + 128*
     +    S**(-1)*UG**(-2)*MG2**3 + 224*S**(-1)*UG**(-1)*MG2**2 - 192*
     +    S**(-1)*MG2 + 32*S*TG**(-3)*MG2**2 - 64*S*TG**(-2)*MG2 - 64*S
     +    *TG**(-1) + 32*S*UG**(-3)*MG2**2 - 64*S*UG**(-2)*MG2 - 64*S*
     +    UG**(-1) + 8*S*S1**(-1) - 256*TG**(-3)*MG2**3 - 400*TG**(-2)*
     +    MG2**2 + 192*TG**(-1)*S1**(-2)*MG2**3 + 16*TG**(-1)*S1**(-1)*
     +    MG2**2 - 336*TG**(-1)*MG2 + 192*TG*S1**(-2)*MG2 + 64*TG*
     +    S1**(-1) + 48*TG**2*S1**(-2) + 28*TG**2*S1**(-1)*MG2**(-1) - 
     +    256*UG**(-3)*MG2**3 - 400*UG**(-2)*MG2**2 + 192*UG**(-1)*
     +    S1**(-2)*MG2**3 + 16*UG**(-1)*S1**(-1)*MG2**2 - 336*UG**(-1)*
     +    MG2 + 384*S1**(-2)*MG2**2 + 48*S1**(-1)*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0C(3)*N*CO * ( 88 + 128*S**(-2)*TG**(-1)*
     +    MG2**2*MT2 + 32*S**(-2)*TG**2*MG2**(-1)*MT2 + 128*S**(-2)*
     +    UG**(-1)*MG2**2*MT2 - 64*S**(-1)*TG**(-2)*MG2**2*MT2 - 64*
     +    S**(-1)*TG**(-1)*MG2*MT2 - 32*S**(-1)*TG**(-1)*MG2**2 + 32*
     +    S**(-1)*TG*MG2**(-1)*MT2 + 28*S**(-1)*TG**2*MG2**(-2)*MT2 - 
     +    28*S**(-1)*TG**2*MG2**(-1) - 64*S**(-1)*UG**(-2)*MG2**2*MT2
     +     - 64*S**(-1)*UG**(-1)*MG2*MT2 - 32*S**(-1)*UG**(-1)*MG2**2
     +     + 96*S**(-1)*MT2 + 32*S*TG**(-3)*MG2*MT2 - 32*S*TG**(-3)*
     +    MG2**2 + 32*S*TG**(-2)*MG2 - 16*S*TG**(-2)*MT2 - 16*S*
     +    TG**(-1)*MG2**(-1)*MT2 + 32*S*TG**(-1) + 32*S*UG**(-3)*MG2*
     +    MT2 - 32*S*UG**(-3)*MG2**2 + 32*S*UG**(-2)*MG2 - 16*S*
     +    UG**(-2)*MT2 - 16*S*UG**(-1)*MG2**(-1)*MT2 + 32*S*UG**(-1) - 
     +    8*S*S1**(-1) + 128*TG**(-3)*MG2**2*MT2 + 176*TG**(-2)*MG2*MT2
     +     + 16*TG**(-2)*MG2**2 + 192*TG**(-1)*S1**(-2)*MG2**2*MT2 - 
     +    192*TG**(-1)*S1**(-2)*MG2**3 + 16*TG**(-1)*S1**(-1)*MG2*MT2
     +     - 16*TG**(-1)*S1**(-1)*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1B0C(3)*N*CO * ( 80*TG**(-1)*MG2 + 48*
     +    TG**(-1)*MT2 - 192*TG*S1**(-2)*MG2 + 192*TG*S1**(-2)*MT2 + 64
     +    *TG*S1**(-1)*MG2**(-1)*MT2 - 64*TG*S1**(-1) + 48*TG**2*
     +    S1**(-2)*MG2**(-1)*MT2 - 48*TG**2*S1**(-2) + 28*TG**2*
     +    S1**(-1)*MG2**(-2)*MT2 - 28*TG**2*S1**(-1)*MG2**(-1) + 128*
     +    UG**(-3)*MG2**2*MT2 + 176*UG**(-2)*MG2*MT2 + 16*UG**(-2)*
     +    MG2**2 + 192*UG**(-1)*S1**(-2)*MG2**2*MT2 - 192*UG**(-1)*
     +    S1**(-2)*MG2**3 + 16*UG**(-1)*S1**(-1)*MG2*MT2 - 16*UG**(-1)*
     +    S1**(-1)*MG2**2 + 80*UG**(-1)*MG2 + 48*UG**(-1)*MT2 + 384*
     +    S1**(-2)*MG2*MT2 - 384*S1**(-2)*MG2**2 - 48*S1**(-1)*MG2 + 80
     +    *S1**(-1)*MT2 - 48*MG2**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0D(1,1)*N*CO * ( 24 + 64*S**(-2)*TG**(-1)*
     +    NS*MG2**3 - 64*S**(-2)*TG**(-1)*NS*MG2**4*T**(-1) - 64*
     +    S**(-2)*TG**(-1)*MG2**3 + 64*S**(-2)*TG**(-1)*MG2**4*T**(-1)
     +     + 64*S**(-2)*UG**(-1)*NS*MG2**3 - 64*S**(-2)*UG**(-1)*NS*
     +    MG2**4*T**(-1) - 64*S**(-2)*UG**(-1)*MG2**3 + 64*S**(-2)*
     +    UG**(-1)*MG2**4*T**(-1) - 64*S**(-1)*TG**(-2)*NS*MG2**3 + 64*
     +    S**(-1)*TG**(-2)*NS*MG2**4*T**(-1) + 64*S**(-1)*TG**(-2)*
     +    MG2**3 - 64*S**(-1)*TG**(-2)*MG2**4*T**(-1) + 16*S**(-1)*
     +    TG**(-1)*NS*MG2**2 + 64*S**(-1)*TG**(-1)*NS*MG2**3*T**(-1) - 
     +    16*S**(-1)*TG**(-1)*MG2**2 - 64*S**(-1)*TG**(-1)*MG2**3*
     +    T**(-1) + 8*S**(-1)*TG*NS*MG2*T**(-1) - 8*S**(-1)*TG*NS - 8*
     +    S**(-1)*TG*MG2*T**(-1) + 8*S**(-1)*TG + 16*S**(-1)*UG**(-1)*
     +    NS*MG2**2 + 64*S**(-1)*UG**(-1)*NS*MG2**3*T**(-1) - 16*
     +    S**(-1)*UG**(-1)*MG2**2 - 64*S**(-1)*UG**(-1)*MG2**3*T**(-1)
     +     - 16*S**(-1)*NS*MG2 + 16*S**(-1)*NS*MG2**2*T**(-1) + 16*
     +    S**(-1)*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0D(1,1)*N*CO * (  - 16*S**(-1)*MG2**2*
     +    T**(-1) + 32*S*TG**(-3)*NS*MG2**3*T**(-1) - 32*S*TG**(-3)*
     +    MG2**3*T**(-1) + 16*S*TG**(-2)*NS*MG2 + 16*S*TG**(-2)*NS*
     +    MG2**2*T**(-1) - 16*S*TG**(-2)*MG2 - 16*S*TG**(-2)*MG2**2*
     +    T**(-1) - 16*S*TG**(-1)*NS*MG2*T**(-1) - 16*S*TG**(-1)*NS + 
     +    16*S*TG**(-1)*MG2*T**(-1) + 16*S*TG**(-1) + 8*S*UG**(-1)*NS*
     +    MG2*T**(-1) - 8*S*UG**(-1)*MG2*T**(-1) + 128*TG**(-3)*NS*
     +    MG2**3 - 128*TG**(-3)*NS*MG2**4*T**(-1) - 128*TG**(-3)*MG2**3
     +     + 128*TG**(-3)*MG2**4*T**(-1) - 144*TG**(-2)*NS*MG2**3*
     +    T**(-1) + 144*TG**(-2)*MG2**3*T**(-1) - 24*TG**(-1)*NS*MG2 - 
     +    56*TG**(-1)*NS*MG2**2*T**(-1) + 24*TG**(-1)*MG2 + 56*TG**(-1)
     +    *MG2**2*T**(-1) - 8*UG**(-1)*NS*MG2 - 24*UG**(-1)*NS*MG2**2*
     +    T**(-1) + 8*UG**(-1)*MG2 + 24*UG**(-1)*MG2**2*T**(-1) - 16*NS
     +    *MG2*T**(-1) - 24*NS + 16*MG2*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(1,1)*N**2*CO * ( 72 + 64*S**(-2)*
     +    TG**(-1)*MG2**3 + 64*S**(-2)*TG**(-1)*MG2**4*T**(-1) + 64*
     +    S**(-2)*UG**(-1)*MG2**3 + 64*S**(-2)*UG**(-1)*MG2**4*T**(-1)
     +     - 64*S**(-1)*TG**(-2)*MG2**3 - 64*S**(-1)*TG**(-2)*MG2**4*
     +    T**(-1) - 80*S**(-1)*TG**(-1)*MG2**2 - 64*S**(-1)*TG**(-1)*
     +    MG2**3*T**(-1) - 8*S**(-1)*TG*MG2*T**(-1) + 24*S**(-1)*TG - 
     +    144*S**(-1)*UG**(-1)*MG2**2 - 64*S**(-1)*UG**(-1)*MG2**3*
     +    T**(-1) + 80*S**(-1)*MG2 - 16*S**(-1)*MG2**2*T**(-1) - 32*S*
     +    TG**(-3)*MG2**3*T**(-1) + 16*S*TG**(-2)*MG2 - 16*S*TG**(-2)*
     +    MG2**2*T**(-1) + 16*S*TG**(-1)*MG2*T**(-1) + 48*S*TG**(-1) - 
     +    8*S*UG**(-1)*MG2*T**(-1) + 128*TG**(-3)*MG2**3 + 128*TG**(-3)
     +    *MG2**4*T**(-1) + 384*TG**(-2)*MG2**2 + 144*TG**(-2)*MG2**3*
     +    T**(-1) + 232*TG**(-1)*MG2 + 56*TG**(-1)*MG2**2*T**(-1) + 40*
     +    UG**(-1)*MG2 + 24*UG**(-1)*MG2**2*T**(-1) + 16*MG2*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(1,2)*N*CO * ( 16 + 64*S**(-2)*TG**(-1)*
     +    NS*MG2**3 - 64*S**(-2)*TG**(-1)*NS*MG2**4*U**(-1) - 64*
     +    S**(-2)*TG**(-1)*MG2**3 + 64*S**(-2)*TG**(-1)*MG2**4*U**(-1)
     +     + 64*S**(-2)*UG**(-1)*NS*MG2**3 - 64*S**(-2)*UG**(-1)*NS*
     +    MG2**4*U**(-1) - 64*S**(-2)*UG**(-1)*MG2**3 + 64*S**(-2)*
     +    UG**(-1)*MG2**4*U**(-1) + 16*S**(-1)*TG**(-1)*NS*MG2**2 + 64*
     +    S**(-1)*TG**(-1)*NS*MG2**3*U**(-1) - 16*S**(-1)*TG**(-1)*
     +    MG2**2 - 64*S**(-1)*TG**(-1)*MG2**3*U**(-1) - 8*S**(-1)*TG*NS
     +    *MG2*U**(-1) + 8*S**(-1)*TG*NS + 8*S**(-1)*TG*MG2*U**(-1) - 8
     +    *S**(-1)*TG - 64*S**(-1)*UG**(-2)*NS*MG2**3 + 64*S**(-1)*
     +    UG**(-2)*NS*MG2**4*U**(-1) + 64*S**(-1)*UG**(-2)*MG2**3 - 64*
     +    S**(-1)*UG**(-2)*MG2**4*U**(-1) + 16*S**(-1)*UG**(-1)*NS*
     +    MG2**2 + 64*S**(-1)*UG**(-1)*NS*MG2**3*U**(-1) - 16*S**(-1)*
     +    UG**(-1)*MG2**2 - 64*S**(-1)*UG**(-1)*MG2**3*U**(-1) - 16*
     +    S**(-1)*NS*MG2 + 16*S**(-1)*NS*MG2**2*U**(-1) + 16*S**(-1)*
     +    MG2 )
     +
      M2GGSV = M2GGSV + SK1B0D(1,2)*N*CO * (  - 16*S**(-1)*MG2**2*
     +    U**(-1) + 8*S*TG**(-1)*NS*MG2*U**(-1) - 8*S*TG**(-1)*MG2*
     +    U**(-1) + 32*S*UG**(-3)*NS*MG2**3*U**(-1) - 32*S*UG**(-3)*
     +    MG2**3*U**(-1) + 16*S*UG**(-2)*NS*MG2 + 16*S*UG**(-2)*NS*
     +    MG2**2*U**(-1) - 16*S*UG**(-2)*MG2 - 16*S*UG**(-2)*MG2**2*
     +    U**(-1) - 16*S*UG**(-1)*NS*MG2*U**(-1) - 16*S*UG**(-1)*NS + 
     +    16*S*UG**(-1)*MG2*U**(-1) + 16*S*UG**(-1) - 8*TG**(-1)*NS*MG2
     +     - 24*TG**(-1)*NS*MG2**2*U**(-1) + 8*TG**(-1)*MG2 + 24*
     +    TG**(-1)*MG2**2*U**(-1) + 128*UG**(-3)*NS*MG2**3 - 128*
     +    UG**(-3)*NS*MG2**4*U**(-1) - 128*UG**(-3)*MG2**3 + 128*
     +    UG**(-3)*MG2**4*U**(-1) - 144*UG**(-2)*NS*MG2**3*U**(-1) + 
     +    144*UG**(-2)*MG2**3*U**(-1) - 24*UG**(-1)*NS*MG2 - 56*
     +    UG**(-1)*NS*MG2**2*U**(-1) + 24*UG**(-1)*MG2 + 56*UG**(-1)*
     +    MG2**2*U**(-1) - 24*NS*MG2*U**(-1) - 16*NS + 24*MG2*U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(1,2)*N**2*CO * ( 48 + 64*S**(-2)*
     +    TG**(-1)*MG2**3 + 64*S**(-2)*TG**(-1)*MG2**4*U**(-1) + 64*
     +    S**(-2)*UG**(-1)*MG2**3 + 64*S**(-2)*UG**(-1)*MG2**4*U**(-1)
     +     - 144*S**(-1)*TG**(-1)*MG2**2 - 64*S**(-1)*TG**(-1)*MG2**3*
     +    U**(-1) + 8*S**(-1)*TG*MG2*U**(-1) - 24*S**(-1)*TG - 64*
     +    S**(-1)*UG**(-2)*MG2**3 - 64*S**(-1)*UG**(-2)*MG2**4*U**(-1)
     +     - 80*S**(-1)*UG**(-1)*MG2**2 - 64*S**(-1)*UG**(-1)*MG2**3*
     +    U**(-1) + 80*S**(-1)*MG2 - 16*S**(-1)*MG2**2*U**(-1) - 8*S*
     +    TG**(-1)*MG2*U**(-1) - 32*S*UG**(-3)*MG2**3*U**(-1) + 16*S*
     +    UG**(-2)*MG2 - 16*S*UG**(-2)*MG2**2*U**(-1) + 16*S*UG**(-1)*
     +    MG2*U**(-1) + 48*S*UG**(-1) + 40*TG**(-1)*MG2 + 24*TG**(-1)*
     +    MG2**2*U**(-1) + 128*UG**(-3)*MG2**3 + 128*UG**(-3)*MG2**4*
     +    U**(-1) + 384*UG**(-2)*MG2**2 + 144*UG**(-2)*MG2**3*U**(-1)
     +     + 232*UG**(-1)*MG2 + 56*UG**(-1)*MG2**2*U**(-1) + 24*MG2*
     +    U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,1)*N*CO * (  - 24 - 128*S**(-2)*
     +    TG**(-1)*MG2**2*MT2 + 64*S**(-2)*TG**(-1)*MG2**3*MT2*T**(-1)
     +     + 64*S**(-2)*TG**(-1)*MG2**3 - 64*S**(-2)*TG**(-1)*MG2**4*
     +    T**(-1) - 128*S**(-2)*UG**(-1)*MG2**2*MT2 + 64*S**(-2)*
     +    UG**(-1)*MG2**3*MT2*T**(-1) + 64*S**(-2)*UG**(-1)*MG2**3 - 64
     +    *S**(-2)*UG**(-1)*MG2**4*T**(-1) + 128*S**(-1)*TG**(-2)*
     +    MG2**2*MT2 - 64*S**(-1)*TG**(-2)*MG2**3*MT2*T**(-1) - 64*
     +    S**(-1)*TG**(-2)*MG2**3 + 64*S**(-1)*TG**(-2)*MG2**4*T**(-1)
     +     + 16*S**(-1)*TG**(-1)*MG2*MT2 - 64*S**(-1)*TG**(-1)*MG2**2*
     +    MT2*T**(-1) + 16*S**(-1)*TG**(-1)*MG2**2 + 64*S**(-1)*
     +    TG**(-1)*MG2**3*T**(-1) + 8*S**(-1)*TG*MG2*T**(-1) - 8*
     +    S**(-1)*TG*MT2*T**(-1) - 8*S**(-1)*TG + 48*S**(-1)*UG**(-1)*
     +    MG2*MT2 - 64*S**(-1)*UG**(-1)*MG2**2*MT2*T**(-1) + 16*S**(-1)
     +    *UG**(-1)*MG2**2 + 64*S**(-1)*UG**(-1)*MG2**3*T**(-1) - 16*
     +    S**(-1)*MG2*MT2*T**(-1) - 16*S**(-1)*MG2 + 16*S**(-1)*MG2**2*
     +    T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,1)*N*CO * (  - 16*S**(-1)*MT2 - 32*S*
     +    TG**(-3)*MG2**2*MT2*T**(-1) + 32*S*TG**(-3)*MG2**3*T**(-1) - 
     +    16*S*TG**(-2)*MG2*MT2*T**(-1) + 16*S*TG**(-2)*MG2 + 16*S*
     +    TG**(-2)*MG2**2*T**(-1) - 32*S*TG**(-2)*MT2 - 16*S*TG**(-1)*
     +    MG2*T**(-1) + 16*S*TG**(-1)*MT2*T**(-1) - 16*S*TG**(-1) + 8*S
     +    *UG**(-1)*MG2*T**(-1) - 8*S*UG**(-1)*MT2*T**(-1) - 256*
     +    TG**(-3)*MG2**2*MT2 + 128*TG**(-3)*MG2**3*MT2*T**(-1) + 128*
     +    TG**(-3)*MG2**3 - 128*TG**(-3)*MG2**4*T**(-1) - 192*TG**(-2)*
     +    MG2*MT2 + 144*TG**(-2)*MG2**2*MT2*T**(-1) - 144*TG**(-2)*
     +    MG2**3*T**(-1) + 56*TG**(-1)*MG2*MT2*T**(-1) - 24*TG**(-1)*
     +    MG2 - 56*TG**(-1)*MG2**2*T**(-1) - 80*TG**(-1)*MT2 + 24*
     +    UG**(-1)*MG2*MT2*T**(-1) - 8*UG**(-1)*MG2 - 24*UG**(-1)*
     +    MG2**2*T**(-1) - 8*UG**(-1)*MT2 - 16*MG2*T**(-1) + 16*MT2*
     +    T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,2)*N*CO * (  - 16 - 128*S**(-2)*
     +    TG**(-1)*MG2**2*MT2 + 64*S**(-2)*TG**(-1)*MG2**3*MT2*U**(-1)
     +     + 64*S**(-2)*TG**(-1)*MG2**3 - 64*S**(-2)*TG**(-1)*MG2**4*
     +    U**(-1) - 128*S**(-2)*UG**(-1)*MG2**2*MT2 + 64*S**(-2)*
     +    UG**(-1)*MG2**3*MT2*U**(-1) + 64*S**(-2)*UG**(-1)*MG2**3 - 64
     +    *S**(-2)*UG**(-1)*MG2**4*U**(-1) + 48*S**(-1)*TG**(-1)*MG2*
     +    MT2 - 64*S**(-1)*TG**(-1)*MG2**2*MT2*U**(-1) + 16*S**(-1)*
     +    TG**(-1)*MG2**2 + 64*S**(-1)*TG**(-1)*MG2**3*U**(-1) - 8*
     +    S**(-1)*TG*MG2*U**(-1) + 8*S**(-1)*TG*MT2*U**(-1) + 8*S**(-1)
     +    *TG + 128*S**(-1)*UG**(-2)*MG2**2*MT2 - 64*S**(-1)*UG**(-2)*
     +    MG2**3*MT2*U**(-1) - 64*S**(-1)*UG**(-2)*MG2**3 + 64*S**(-1)*
     +    UG**(-2)*MG2**4*U**(-1) + 16*S**(-1)*UG**(-1)*MG2*MT2 - 64*
     +    S**(-1)*UG**(-1)*MG2**2*MT2*U**(-1) + 16*S**(-1)*UG**(-1)*
     +    MG2**2 + 64*S**(-1)*UG**(-1)*MG2**3*U**(-1) - 16*S**(-1)*MG2*
     +    MT2*U**(-1) - 16*S**(-1)*MG2 + 16*S**(-1)*MG2**2*U**(-1) - 16
     +    *S**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0D(4,2)*N*CO * ( 8*S*TG**(-1)*MG2*U**(-1)
     +     - 8*S*TG**(-1)*MT2*U**(-1) - 32*S*UG**(-3)*MG2**2*MT2*
     +    U**(-1) + 32*S*UG**(-3)*MG2**3*U**(-1) - 16*S*UG**(-2)*MG2*
     +    MT2*U**(-1) + 16*S*UG**(-2)*MG2 + 16*S*UG**(-2)*MG2**2*
     +    U**(-1) - 32*S*UG**(-2)*MT2 - 16*S*UG**(-1)*MG2*U**(-1) + 16*
     +    S*UG**(-1)*MT2*U**(-1) - 16*S*UG**(-1) + 24*TG**(-1)*MG2*MT2*
     +    U**(-1) - 8*TG**(-1)*MG2 - 24*TG**(-1)*MG2**2*U**(-1) - 8*
     +    TG**(-1)*MT2 - 256*UG**(-3)*MG2**2*MT2 + 128*UG**(-3)*MG2**3*
     +    MT2*U**(-1) + 128*UG**(-3)*MG2**3 - 128*UG**(-3)*MG2**4*
     +    U**(-1) - 192*UG**(-2)*MG2*MT2 + 144*UG**(-2)*MG2**2*MT2*
     +    U**(-1) - 144*UG**(-2)*MG2**3*U**(-1) + 56*UG**(-1)*MG2*MT2*
     +    U**(-1) - 24*UG**(-1)*MG2 - 56*UG**(-1)*MG2**2*U**(-1) - 80*
     +    UG**(-1)*MT2 - 24*MG2*U**(-1) + 24*MT2*U**(-1) )
     +
      M2GGSV = M2GGSV + SK1BP(1)*N**2*CO * (  - 128*S**(-2)*TG**2*MG2
     +     + 256*S**(-1)*TG**(-1)*MG2**3 - 128*S**(-1)*TG*MG2 + 256*
     +    S**(-1)*UG**(-1)*MG2**3 - 256*S**(-1)*MG2**2 - 64*S*TG**(-1)*
     +    MG2 - 64*S*UG**(-1)*MG2 - 256*TG**(-2)*MG2**3 - 256*TG**(-1)*
     +    MG2**2 - 256*UG**(-2)*MG2**3 - 256*UG**(-1)*MG2**2 - 192*MG2
     +     )
     +
      M2GGSV = M2GGSV + SK1BP(5)*N*CO * ( 64*S**(-2)*TG**2*MT2 - 128*
     +    S**(-1)*TG**(-1)*MG2**2*MT2 + 64*S**(-1)*TG*MT2 - 128*S**(-1)
     +    *UG**(-1)*MG2**2*MT2 + 128*S**(-1)*MG2*MT2 + 32*S*TG**(-1)*
     +    MT2 + 32*S*UG**(-1)*MT2 + 128*TG**(-2)*MG2**2*MT2 + 128*
     +    TG**(-1)*MG2*MT2 + 128*UG**(-2)*MG2**2*MT2 + 128*UG**(-1)*MG2
     +    *MT2 + 96*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0A(1)*N*CO * (  - 4*S*TG**(-1)*NS*MG2 + 4*S
     +    *TG**(-1)*MG2 - 4*S*UG**(-1)*NS*MG2 + 4*S*UG**(-1)*MG2 + 4*S*
     +    NS - 4*S )
     +
      M2GGSV = M2GGSV + SK1C0A(1)*N**2*CO * ( 16*S*TG**(-1)*MG2 + 16*S*
     +    UG**(-1)*MG2 + 8*S + 4*S**2*TG**(-1) + 4*S**2*UG**(-1) + 32*
     +    MG2 )
     +
      M2GGSV = M2GGSV + SK1C0A(2)*N*CO * ( 64*S**(-1)*NS*MG2**2 - 4*S*
     +    TG**(-1)*NS*MG2 + 4*S*TG**(-1)*MG2 - 4*S*UG**(-1)*NS*MG2 + 4*
     +    S*UG**(-1)*MG2 - 8*S*NS + 8*S + 32*TG**(-1)*NS*MG2**2 - 16*
     +    TG**(-1)*MG2**2 + 32*UG**(-1)*NS*MG2**2 - 16*UG**(-1)*MG2**2
     +     )
     +
      M2GGSV = M2GGSV + SK1C0A(2)*N**2*CO * (  - 64*S**(-1)*MG2**2 + 8*
     +    S*TG**(-1)*MG2 + 8*S*UG**(-1)*MG2 + 4*S - 4*S**2*TG**(-1) - 4
     +    *S**2*UG**(-1) + 32*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0A(3)*N*CO * (  - 4*S*TG**(-1)*MG2 + 4*S*
     +    TG**(-1)*MT2 - 4*S*UG**(-1)*MG2 + 4*S*UG**(-1)*MT2 - 8*S - 16
     +    *TG**(-1)*MG2*MT2 + 16*TG**(-1)*MG2**2 + 8*TG**(-1)*MT2**2 - 
     +    16*UG**(-1)*MG2*MT2 + 16*UG**(-1)*MG2**2 + 8*UG**(-1)*MT2**2
     +     - 16*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0A(4)*N*CO * (  - 64*S**(-1)*MG2*MT2 - 4*S*
     +    TG**(-1)*MG2 - 4*S*TG**(-1)*MT2 - 4*S*UG**(-1)*MG2 - 4*S*
     +    UG**(-1)*MT2 + 4*S - 32*TG**(-1)*MG2*MT2 - 8*TG**(-1)*MT2**2
     +     - 32*UG**(-1)*MG2*MT2 - 8*UG**(-1)*MT2**2 - 16*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0B(1)*N*CO * (  - 4*S*TG**(-1)*NS*MG2 + 4*S
     +    *TG**(-1)*MG2 - 4*S*UG**(-1)*NS*MG2 + 4*S*UG**(-1)*MG2 - 8*S*
     +    NS + 8*S + 16*NS*MG2 - 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(1)*N**2*CO * (  - 64*S**(-2)*TG**2*MG2
     +     - 64*S**(-1)*TG*MG2 + 32*S**(-1)*TG**2 - 192*S**(-1)*MG2**2
     +     + 8*S*TG**(-1)*MG2 + 8*S*UG**(-1)*MG2 + 36*S + 4*S**2*
     +    TG**(-1) + 4*S**2*UG**(-1) - 32*TG**(-1)*MG2**2 + 32*TG - 32*
     +    UG**(-1)*MG2**2 - 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(3)*N*CO * ( 16*S**(-1)*TG**2*NS - 16*
     +    S**(-1)*TG**2 + 4*S*TG**(-1)*NS*MG2 - 4*S*TG**(-1)*MG2 + 4*S*
     +    UG**(-1)*NS*MG2 - 4*S*UG**(-1)*MG2 + 16*S*S1**(-1)*NS*MG2 - 
     +    16*S*S1**(-1)*MG2 + 4*S*NS - 4*S + 384*TG**(-1)*S1**(-2)*NS*
     +    MG2**4 - 384*TG**(-1)*S1**(-2)*MG2**4 - 192*TG**(-1)*S1**(-1)
     +    *NS*MG2**3 + 192*TG**(-1)*S1**(-1)*MG2**3 + 24*TG**(-1)*NS*
     +    MG2**2 - 24*TG**(-1)*MG2**2 + 384*TG*S1**(-2)*NS*MG2**2 - 384
     +    *TG*S1**(-2)*MG2**2 - 32*TG*S1**(-1)*NS*MG2 + 32*TG*S1**(-1)*
     +    MG2 + 96*TG**2*S1**(-2)*NS*MG2 - 96*TG**2*S1**(-2)*MG2 + 16*
     +    TG**2*S1**(-1)*NS - 16*TG**2*S1**(-1) + 384*UG**(-1)*S1**(-2)
     +    *NS*MG2**4 - 384*UG**(-1)*S1**(-2)*MG2**4 - 192*UG**(-1)*
     +    S1**(-1)*NS*MG2**3 + 192*UG**(-1)*S1**(-1)*MG2**3 + 24*
     +    UG**(-1)*NS*MG2**2 - 24*UG**(-1)*MG2**2 + 768*S1**(-2)*NS*
     +    MG2**3 - 768*S1**(-2)*MG2**3 - 288*S1**(-1)*NS*MG2**2 + 288*
     +    S1**(-1)*MG2**2 + 40*NS*MG2 - 40*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(3)*N**2*CO * (  - 48*S**(-1)*TG**2 - 8*S
     +    *TG**(-1)*MG2 - 8*S*UG**(-1)*MG2 - 32*S*S1**(-1)*MG2 - 24*S
     +     - 4*S**2*TG**(-1) - 4*S**2*UG**(-1) - 384*TG**(-1)*S1**(-2)*
     +    MG2**4 + 192*TG**(-1)*S1**(-1)*MG2**3 - 8*TG**(-1)*MG2**2 - 
     +    384*TG*S1**(-2)*MG2**2 + 32*TG*S1**(-1)*MG2 - 32*TG - 96*
     +    TG**2*S1**(-2)*MG2 - 16*TG**2*S1**(-1) - 384*UG**(-1)*
     +    S1**(-2)*MG2**4 + 192*UG**(-1)*S1**(-1)*MG2**3 - 8*UG**(-1)*
     +    MG2**2 - 768*S1**(-2)*MG2**3 + 352*S1**(-1)*MG2**2 - 72*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(5)*N*CO * ( 16*S**(-2)*TG**2*MG2**(-1)*
     +    MT2**2 + 16*S**(-1)*TG*MG2**(-1)*MT2**2 + 10*S**(-1)*TG**2*
     +    MG2**(-2)*MT2**2 - 32*S**(-1)*TG**2*MG2**(-1)*MT2 + 16*
     +    S**(-1)*TG**2 + 48*S**(-1)*MT2**2 + 4*S*TG**(-1)*MG2 + 4*S*
     +    TG**(-1)*MT2 + 4*S*UG**(-1)*MG2 + 4*S*UG**(-1)*MT2 + 16*S*
     +    S1**(-1)*MG2 - 8*S*S1**(-1)*MT2 + 4*S + 96*TG**(-1)*S1**(-2)*
     +    MG2**2*MT2**2 - 384*TG**(-1)*S1**(-2)*MG2**3*MT2 + 384*
     +    TG**(-1)*S1**(-2)*MG2**4 - 8*TG**(-1)*S1**(-1)*MG2*MT2**2 + 
     +    96*TG**(-1)*S1**(-1)*MG2**2*MT2 - 192*TG**(-1)*S1**(-1)*
     +    MG2**3 - 8*TG**(-1)*MG2*MT2 + 24*TG**(-1)*MG2**2 + 8*TG**(-1)
     +    *MT2**2 - 384*TG*S1**(-2)*MG2*MT2 + 384*TG*S1**(-2)*MG2**2 + 
     +    96*TG*S1**(-2)*MT2**2 + 16*TG*S1**(-1)*MG2**(-1)*MT2**2 - 32*
     +    TG*S1**(-1)*MG2 - 32*TG*S1**(-1)*MT2 + 24*TG**2*S1**(-2)*
     +    MG2**(-1)*MT2**2 + 96*TG**2*S1**(-2)*MG2 - 96*TG**2*S1**(-2)*
     +    MT2 + 10*TG**2*S1**(-1)*MG2**(-2)*MT2**2 - 32*TG**2*S1**(-1)*
     +    MG2**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0B(5)*N*CO * ( 16*TG**2*S1**(-1) + 96*
     +    UG**(-1)*S1**(-2)*MG2**2*MT2**2 - 384*UG**(-1)*S1**(-2)*
     +    MG2**3*MT2 + 384*UG**(-1)*S1**(-2)*MG2**4 - 8*UG**(-1)*
     +    S1**(-1)*MG2*MT2**2 + 96*UG**(-1)*S1**(-1)*MG2**2*MT2 - 192*
     +    UG**(-1)*S1**(-1)*MG2**3 - 8*UG**(-1)*MG2*MT2 + 24*UG**(-1)*
     +    MG2**2 + 8*UG**(-1)*MT2**2 + 192*S1**(-2)*MG2*MT2**2 - 768*
     +    S1**(-2)*MG2**2*MT2 + 768*S1**(-2)*MG2**3 + 96*S1**(-1)*MG2*
     +    MT2 - 288*S1**(-1)*MG2**2 + 8*S1**(-1)*MT2**2 + 40*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(6)*N*CO * (  - 16*S**(-2)*TG**2*
     +    MG2**(-1)*MT2**2 + 32*S**(-2)*TG**2*MT2 - 16*S**(-1)*TG*
     +    MG2**(-1)*MT2**2 + 32*S**(-1)*TG*MT2 - 10*S**(-1)*TG**2*
     +    MG2**(-2)*MT2**2 + 16*S**(-1)*TG**2*MG2**(-1)*MT2 + 96*
     +    S**(-1)*MG2*MT2 - 48*S**(-1)*MT2**2 - 4*S*TG**(-1)*MG2 - 4*S*
     +    TG**(-1)*MT2 - 4*S*UG**(-1)*MG2 - 4*S*UG**(-1)*MT2 - 8*S - 96
     +    *TG**(-1)*S1**(-2)*MG2**2*MT2**2 + 8*TG**(-1)*S1**(-1)*MG2*
     +    MT2**2 + 96*TG**(-1)*S1**(-1)*MG2**2*MT2 - 8*TG**(-1)*MG2*MT2
     +     - 8*TG**(-1)*MT2**2 - 96*TG*S1**(-2)*MT2**2 - 16*TG*S1**(-1)
     +    *MG2**(-1)*MT2**2 + 64*TG*S1**(-1)*MT2 - 24*TG**2*S1**(-2)*
     +    MG2**(-1)*MT2**2 - 10*TG**2*S1**(-1)*MG2**(-2)*MT2**2 + 16*
     +    TG**2*S1**(-1)*MG2**(-1)*MT2 - 96*UG**(-1)*S1**(-2)*MG2**2*
     +    MT2**2 + 8*UG**(-1)*S1**(-1)*MG2*MT2**2 + 96*UG**(-1)*
     +    S1**(-1)*MG2**2*MT2 - 8*UG**(-1)*MG2*MT2 - 8*UG**(-1)*MT2**2
     +     - 192*S1**(-2)*MG2*MT2**2 + 160*S1**(-1)*MG2*MT2 - 8*
     +    S1**(-1)*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1C0B(6)*N*CO * ( 16*MG2 - 40*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0C(1,1)*N*CO * ( 32*S*TG**(-2)*NS*MG2**2 - 
     +    32*S*TG**(-2)*MG2**2 + 8*S*UG**(-1)*NS*MG2 - 8*S*UG**(-1)*MG2
     +     - 16*TG**(-1)*NS*MG2**2 + 16*TG**(-1)*MG2**2 - 8*TG*NS + 8*
     +    TG - 16*UG**(-1)*NS*MG2**2 + 16*UG**(-1)*MG2**2 - 8*NS*MG2 + 
     +    8*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(1,1)*N**2*CO * ( 32*S**(-1)*TG*MG2 - 8*
     +    S**(-1)*TG**2 + 64*S**(-1)*MG2**2 - 32*S*TG**(-2)*MG2**2 - 16
     +    *S*UG**(-1)*MG2 - 8*S + 8*S**2*UG**(-1) + 16*TG**(-1)*MG2**2
     +     - 16*TG + 16*UG**(-1)*MG2**2 + 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(1,2)*N*CO * ( 8*S*TG**(-1)*NS*MG2 - 8*S*
     +    TG**(-1)*MG2 + 32*S*UG**(-2)*NS*MG2**2 - 32*S*UG**(-2)*MG2**2
     +     + 8*S*NS - 8*S - 16*TG**(-1)*NS*MG2**2 + 16*TG**(-1)*MG2**2
     +     + 8*TG*NS - 8*TG - 16*UG**(-1)*NS*MG2**2 + 16*UG**(-1)*
     +    MG2**2 - 8*NS*MG2 + 8*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(1,2)*N**2*CO * (  - 32*S**(-1)*TG*MG2 - 
     +    8*S**(-1)*TG**2 + 64*S**(-1)*MG2**2 - 16*S*TG**(-1)*MG2 - 32*
     +    S*UG**(-2)*MG2**2 + 8*S**2*TG**(-1) + 16*TG**(-1)*MG2**2 + 16
     +    *UG**(-1)*MG2**2 - 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(3,1)*N*CO * (  - 8*S**(-1)*TG**2*NS + 8*
     +    S**(-1)*TG**2 + 8*S*UG**(-1)*NS*MG2 - 8*S*UG**(-1)*MG2 - 8*NS
     +    *MG2 + 8*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(3,1)*N**2*CO * ( 32*S**(-1)*TG*MG2 + 32*
     +    S**(-1)*TG**2 - 32*S*UG**(-1)*MG2 + 8*S - 8*S**2*UG**(-1) + 
     +    40*TG + 64*UG**(-1)*MG2**2 + 32*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(3,2)*N*CO * (  - 8*S**(-1)*TG**2*NS + 8*
     +    S**(-1)*TG**2 + 8*S*TG**(-1)*NS*MG2 - 8*S*TG**(-1)*MG2 - 8*S*
     +    NS + 8*S - 16*TG*NS + 16*TG - 8*NS*MG2 + 8*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(3,2)*N**2*CO * (  - 32*S**(-1)*TG*MG2 + 
     +    32*S**(-1)*TG**2 - 32*S*TG**(-1)*MG2 - 8*S**2*TG**(-1) + 64*
     +    TG**(-1)*MG2**2 + 24*TG )
     +
      M2GGSV = M2GGSV + SK1C0C(7,1)*N*CO * (  - 16*S**(-1)*TG*MT2 - 8*
     +    S**(-1)*TG**2 - 16*S**(-1)*MT2**2 - 32*S*TG**(-2)*MG2*MT2 + 8
     +    *S*UG**(-1)*MG2 + 8*S*UG**(-1)*MT2 + 16*TG**(-1)*MG2*MT2 - 16
     +    *UG**(-1)*MG2*MT2 + 16*UG**(-1)*MT2**2 - 8*MG2 - 8*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0C(7,2)*N*CO * ( 16*S**(-1)*TG*MT2 - 8*
     +    S**(-1)*TG**2 - 16*S**(-1)*MT2**2 + 8*S*TG**(-1)*MG2 + 8*S*
     +    TG**(-1)*MT2 - 32*S*UG**(-2)*MG2*MT2 - 8*S - 16*TG**(-1)*MG2*
     +    MT2 + 16*TG**(-1)*MT2**2 - 16*TG + 16*UG**(-1)*MG2*MT2 - 8*
     +    MG2 + 8*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0C(8,1)*N*CO * (  - 16*S**(-1)*TG*MT2 - 32*
     +    S**(-1)*MG2*MT2 + 16*S**(-1)*MT2**2 + 32*S*TG**(-2)*MG2**2 + 
     +    8*S*UG**(-1)*MG2 - 8*S*UG**(-1)*MT2 - 16*TG**(-1)*MG2**2 - 8*
     +    TG - 16*UG**(-1)*MG2**2 - 16*UG**(-1)*MT2**2 - 8*MG2 + 8*MT2
     +     )
     +
      M2GGSV = M2GGSV + SK1C0C(8,2)*N*CO * ( 16*S**(-1)*TG*MT2 - 32*
     +    S**(-1)*MG2*MT2 + 16*S**(-1)*MT2**2 + 8*S*TG**(-1)*MG2 - 8*S*
     +    TG**(-1)*MT2 + 32*S*UG**(-2)*MG2**2 + 8*S - 16*TG**(-1)*
     +    MG2**2 - 16*TG**(-1)*MT2**2 + 8*TG - 16*UG**(-1)*MG2**2 - 8*
     +    MG2 + 24*MT2 )
     +
      M2GGSV = M2GGSV + SK1D0(1,1)*N*CO * ( 4*S*NS*MG2 - 4*S*MG2 + 4*
     +    TG**2*NS - 4*TG**2 )
     +
      M2GGSV = M2GGSV + SK1D0(1,1)*N**2*CO * ( 16*S**(-1)*TG**3 + 32*S*
     +    TG**(-1)*MG2**2 + 12*S*TG + 16*S*MG2 + 4*S**2 + 16*TG*MG2 + 
     +    16*TG**2 )
     +
      M2GGSV = M2GGSV + SK1D0(1,2)*N*CO * ( 8*S*TG*NS - 8*S*TG + 4*S*NS
     +    *MG2 - 4*S*MG2 + 4*S**2*NS - 4*S**2 + 4*TG**2*NS - 4*TG**2 )
     +
      M2GGSV = M2GGSV + SK1D0(1,2)*N**2*CO * (  - 16*S**(-1)*TG**3 - 28
     +    *S*TG + 32*S*UG**(-1)*MG2**2 - 8*S**2 - 16*TG*MG2 - 32*TG**2
     +     )
     +
      M2GGSV = M2GGSV + SK1D0(2,1)*N*CO * ( 4*S*TG*NS - 4*S*TG + 4*S*NS
     +    *MG2 - 4*S*MG2 - 8*TG*NS*MG2 + 8*TG*MG2 )
     +
      M2GGSV = M2GGSV + SK1D0(2,1)*N**2*CO * ( 32*S**(-1)*TG*MG2**2 + 
     +    32*S*TG**(-1)*MG2**2 + 8*S*MG2 + 4*S**2 - 64*TG**(-1)*MG2**3
     +     + 8*TG*MG2 + 4*TG**2 - 32*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(2,2)*N*CO * (  - 4*S*TG*NS + 4*S*TG + 12*
     +    S*NS*MG2 - 12*S*MG2 - 4*S**2*NS + 4*S**2 + 8*TG*NS*MG2 - 8*TG
     +    *MG2 )
     +
      M2GGSV = M2GGSV + SK1D0(2,2)*N**2*CO * (  - 32*S**(-1)*TG*MG2**2
     +     + 8*S*TG + 32*S*UG**(-1)*MG2**2 + 8*S**2 - 8*TG*MG2 + 4*
     +    TG**2 - 64*UG**(-1)*MG2**3 - 64*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(3,1)*N*CO * (  - 8*S*NS*MG2 + 8*S*MG2 )
     +
      M2GGSV = M2GGSV + SK1D0(3,1)*N**2*CO * (  - 64*S*TG**(-1)*MG2**2
     +     - 16*S*TG - 64*S*UG**(-1)*MG2**2 - 32*S*MG2 - 8*S**2 - 16*
     +    TG**2 - 64*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(10,1)*N*CO * (  - 16*S**(-1)*TG*MT2**2 - 
     +    12*S*TG**(-1)*MG2*MT2 + 4*S*TG**(-1)*MT2**2 + 4*S*MG2 + 4*S*
     +    MT2 + 8*TG**(-1)*MT2**3 + 12*TG*MT2 + 4*TG**2 )
     +
      M2GGSV = M2GGSV + SK1D0(10,2)*N*CO * ( 16*S**(-1)*TG*MT2**2 + 8*S
     +    *TG - 12*S*UG**(-1)*MG2*MT2 + 4*S*UG**(-1)*MT2**2 + 4*S*MG2
     +     - 8*S*MT2 + 4*S**2 - 12*TG*MT2 + 4*TG**2 + 8*UG**(-1)*MT2**3
     +     + 16*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(11,1)*N*CO * (  - 16*S**(-1)*TG*MG2*MT2
     +     - 12*S*TG**(-1)*MG2*MT2 + 4*S*TG**(-1)*MT2**2 + 4*S*TG + 4*S
     +    *MG2 - 8*S*MT2 - 32*TG**(-1)*MG2*MT2**2 + 32*TG**(-1)*MG2**2*
     +    MT2 + 8*TG**(-1)*MT2**3 - 8*TG*MG2 + 8*TG*MT2 + 16*MG2*MT2 - 
     +    16*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(11,2)*N*CO * ( 16*S**(-1)*TG*MG2*MT2 - 4*
     +    S*TG - 12*S*UG**(-1)*MG2*MT2 + 4*S*UG**(-1)*MT2**2 + 12*S*MG2
     +     - 16*S*MT2 - 4*S**2 + 8*TG*MG2 - 8*TG*MT2 - 32*UG**(-1)*MG2*
     +    MT2**2 + 32*UG**(-1)*MG2**2*MT2 + 8*UG**(-1)*MT2**3 + 32*MG2*
     +    MT2 - 16*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(12,1)*N*CO * ( 24*S*TG**(-1)*MG2*MT2 - 8*
     +    S*TG**(-1)*MT2**2 + 24*S*UG**(-1)*MG2*MT2 - 8*S*UG**(-1)*
     +    MT2**2 - 8*S*MG2 + 8*S*MT2 + 32*TG**(-1)*MG2*MT2**2 - 16*
     +    TG**(-1)*MT2**3 + 32*UG**(-1)*MG2*MT2**2 - 16*UG**(-1)*MT2**3
     +     + 32*MG2*MT2 + 16*MT2**2 )
     +
      M2GGSV = M2GGSV + SOF1(1)*N**2*CO * ( 256*S**(-2)*TG**2*MG2 + 256
     +    *S**(-1)*TG*MG2 - 128*S**(-1)*TG**2 + 512*S**(-1)*MG2**2 - 
     +    128*S*TG**(-2)*MG2**2 - 64*S*TG**(-1)*MG2 - 128*S*UG**(-2)*
     +    MG2**2 - 64*S*UG**(-1)*MG2 - 128*S - 32*S**2*TG**(-1) - 32*
     +    S**2*UG**(-1) + 256*TG**(-2)*MG2**3 + 256*TG**(-1)*MG2**2 - 
     +    128*TG + 256*UG**(-2)*MG2**3 + 256*UG**(-1)*MG2**2 )
     +
      M2GGSV = M2GGSV + SOF1(2)*N**2*CO * ( 256*S**(-2)*TG**2*MG2 + 256
     +    *S**(-1)*TG*MG2 + 512*S**(-1)*MG2**2 + 128*S*TG**(-1)*MG2 + 
     +    128*S*UG**(-1)*MG2 + 512*TG**(-2)*MG2**3 + 512*TG**(-1)*
     +    UG**(-1)*MG2**3 + 512*TG**(-1)*MG2**2 + 512*UG**(-2)*MG2**3
     +     + 512*UG**(-1)*MG2**2 + 384*MG2 )
     +
      M2GGSV = M2GGSV + SOF1(3)*N**2*CO * ( 256*S**(-2)*TG**2*MG2 + 256
     +    *S**(-1)*TG*MG2 + 512*S**(-1)*MG2**2 + 128*S*TG**(-1)*MG2 + 
     +    128*S*UG**(-1)*MG2 + 512*TG**(-2)*MG2**3 + 512*TG**(-1)*
     +    UG**(-1)*MG2**3 + 512*TG**(-1)*MG2**2 + 512*UG**(-2)*MG2**3
     +     + 512*UG**(-1)*MG2**2 + 384*MG2 )
     +
      M2GGSV = M2GGSV + SOF1(4)*N**2*CO * ( 64*S**(-2)*TG**3 + 128*
     +    S**(-1)*TG*MG2 + 64*S**(-1)*TG**2 + 128*S*TG**(-2)*MG2**2 + 
     +    128*S*TG**(-1)*MG2 + 64*S + 32*S**2*TG**(-1) - 128*TG**(-1)*
     +    MG2**2 + 96*TG - 256*UG**(-1)*MG2**2 )
     +
      M2GGSV = M2GGSV + SOF1(5)*N**2*CO * (  - 64*S**(-2)*TG**3 - 128*
     +    S**(-1)*TG*MG2 - 128*S**(-1)*TG**2 + 128*S*UG**(-2)*MG2**2 + 
     +    128*S*UG**(-1)*MG2 - 32*S + 32*S**2*UG**(-1) - 256*TG**(-1)*
     +    MG2**2 - 160*TG - 128*UG**(-1)*MG2**2 - 128*MG2 )
     +
      M2GGSV = M2GGSV + SOF1(6)*N**2*CO * (  - 64*S**(-2)*TG**3 - 128*
     +    S**(-1)*TG*MG2 - 128*S**(-1)*TG**2 + 128*S*UG**(-2)*MG2**2 + 
     +    128*S*UG**(-1)*MG2 - 32*S + 32*S**2*UG**(-1) - 256*TG**(-1)*
     +    MG2**2 - 160*TG - 128*UG**(-1)*MG2**2 - 128*MG2 )
     +
      M2GGSV = M2GGSV + SOF1(7)*N**2*CO * ( 64*S**(-2)*TG**3 + 128*
     +    S**(-1)*TG*MG2 + 64*S**(-1)*TG**2 + 128*S*TG**(-2)*MG2**2 + 
     +    128*S*TG**(-1)*MG2 + 64*S + 32*S**2*TG**(-1) - 128*TG**(-1)*
     +    MG2**2 + 96*TG - 256*UG**(-1)*MG2**2 )
     +
      M2GGSV = M2GGSV + SOF1(8)*N**2*CO * (  - 128*S**(-1)*TG**2 - 128*
     +    S*TG**(-2)*MG2**2 - 128*S*TG**(-1)*MG2 - 128*S*UG**(-2)*
     +    MG2**2 - 128*S*UG**(-1)*MG2 - 128*S - 32*S**2*TG**(-1) - 32*
     +    S**2*UG**(-1) - 128*TG - 256*MG2 )

      
      ELSE

      M2GGSV = 0.D0
      M2GGSV = M2GGSV + N*CO * ( 8 - 128*S**(-2)*TG**(-1)*NS*MS2*MG2**2
     +     + 64*S**(-2)*TG**(-1)*NS*MS2*MG2**3*T**(-1) + 64*S**(-2)*
     +    TG**(-1)*NS*MS2*MG2**3*U**(-1) + 128*S**(-2)*TG**(-1)*MG2**2*
     +    MT2 - 64*S**(-2)*TG**(-1)*MG2**3*MT2*T**(-1) - 64*S**(-2)*
     +    TG**(-1)*MG2**3*MT2*U**(-1) - 128*S**(-2)*UG**(-1)*NS*MS2*
     +    MG2**2 + 64*S**(-2)*UG**(-1)*NS*MS2*MG2**3*T**(-1) + 64*
     +    S**(-2)*UG**(-1)*NS*MS2*MG2**3*U**(-1) + 128*S**(-2)*UG**(-1)
     +    *MG2**2*MT2 - 64*S**(-2)*UG**(-1)*MG2**3*MT2*T**(-1) - 64*
     +    S**(-2)*UG**(-1)*MG2**3*MT2*U**(-1) + 64*S**(-1)*TG**(-2)*NS*
     +    MS2*MG2**2 - 64*S**(-1)*TG**(-2)*NS*MS2*MG2**3*T**(-1) - 64*
     +    S**(-1)*TG**(-2)*MG2**2*MT2 + 64*S**(-1)*TG**(-2)*MG2**3*MT2*
     +    T**(-1) - 64*S**(-1)*TG**(-1)*NS*MS2*MG2**2*T**(-1) - 64*
     +    S**(-1)*TG**(-1)*NS*MS2*MG2**2*U**(-1) + 64*S**(-1)*TG**(-1)*
     +    MG2**2*MT2*T**(-1) + 64*S**(-1)*TG**(-1)*MG2**2*MT2*U**(-1)
     +     - 8*S**(-1)*TG*NS*MS2*T**(-1) + 8*S**(-1)*TG*NS*MS2*U**(-1)
     +     + 8*S**(-1)*TG*MT2*T**(-1) )
     +
      M2GGSV = M2GGSV + N*CO * (  - 8*S**(-1)*TG*MT2*U**(-1) + 8*
     +    S**(-1)*TG**2*NS*MS2*MG2**(-2) - 8*S**(-1)*TG**2*MG2**(-2)*
     +    MT2 + 64*S**(-1)*UG**(-2)*NS*MS2*MG2**2 - 64*S**(-1)*UG**(-2)
     +    *NS*MS2*MG2**3*U**(-1) - 64*S**(-1)*UG**(-2)*MG2**2*MT2 + 64*
     +    S**(-1)*UG**(-2)*MG2**3*MT2*U**(-1) - 64*S**(-1)*UG**(-1)*NS*
     +    MS2*MG2**2*T**(-1) - 64*S**(-1)*UG**(-1)*NS*MS2*MG2**2*
     +    U**(-1) + 64*S**(-1)*UG**(-1)*MG2**2*MT2*T**(-1) + 64*S**(-1)
     +    *UG**(-1)*MG2**2*MT2*U**(-1) - 16*S**(-1)*NS*MS2*MG2*T**(-1)
     +     - 16*S**(-1)*NS*MS2*MG2*U**(-1) + 32*S**(-1)*NS*MS2 + 16*
     +    S**(-1)*MG2*MT2*T**(-1) + 16*S**(-1)*MG2*MT2*U**(-1) - 32*
     +    S**(-1)*MT2 + 32*S*TG**(-3)*NS*MS2*MG2 - 32*S*TG**(-3)*NS*MS2
     +    *MG2**2*T**(-1) - 32*S*TG**(-3)*MG2*MT2 + 32*S*TG**(-3)*
     +    MG2**2*MT2*T**(-1) - 16*S*TG**(-2)*NS*MS2*MG2*T**(-1) - 48*S*
     +    TG**(-2)*NS*MS2 + 16*S*TG**(-2)*MG2*MT2*T**(-1) + 48*S*
     +    TG**(-2)*MT2 - 16*S*TG**(-1)*NS*MS2*MG2**(-1) + 16*S*TG**(-1)
     +    *NS*MS2*T**(-1) )
     +
      M2GGSV = M2GGSV + N*CO * (  - 8*S*TG**(-1)*NS*MS2*U**(-1) + 16*S*
     +    TG**(-1)*MG2**(-1)*MT2 - 16*S*TG**(-1)*MT2*T**(-1) + 8*S*
     +    TG**(-1)*MT2*U**(-1) + 32*S*UG**(-3)*NS*MS2*MG2 - 32*S*
     +    UG**(-3)*NS*MS2*MG2**2*U**(-1) - 32*S*UG**(-3)*MG2*MT2 + 32*S
     +    *UG**(-3)*MG2**2*MT2*U**(-1) - 16*S*UG**(-2)*NS*MS2*MG2*
     +    U**(-1) - 48*S*UG**(-2)*NS*MS2 + 16*S*UG**(-2)*MG2*MT2*
     +    U**(-1) + 48*S*UG**(-2)*MT2 - 16*S*UG**(-1)*NS*MS2*MG2**(-1)
     +     - 8*S*UG**(-1)*NS*MS2*T**(-1) + 16*S*UG**(-1)*NS*MS2*U**(-1)
     +     + 16*S*UG**(-1)*MG2**(-1)*MT2 + 8*S*UG**(-1)*MT2*T**(-1) - 
     +    16*S*UG**(-1)*MT2*U**(-1) - 4*S*U1**(-1)*NS + 4*S*U1**(-1) - 
     +    128*TG**(-3)*NS*MS2*MG2**2 + 128*TG**(-3)*NS*MS2*MG2**3*
     +    T**(-1) + 128*TG**(-3)*MG2**2*MT2 - 128*TG**(-3)*MG2**3*MT2*
     +    T**(-1) - 16*TG**(-2)*NS*MS2*MG2 + 144*TG**(-2)*NS*MS2*MG2**2
     +    *T**(-1) + 16*TG**(-2)*MG2*MT2 - 144*TG**(-2)*MG2**2*MT2*
     +    T**(-1) + 32*TG**(-1)*S1**(-1)*NS*MS2*MG2 - 32*TG**(-1)*
     +    S1**(-1)*MG2*MT2 )
     +
      M2GGSV = M2GGSV + N*CO * ( 56*TG**(-1)*NS*MS2*MG2*T**(-1) + 24*
     +    TG**(-1)*NS*MS2*MG2*U**(-1) - 40*TG**(-1)*NS*MS2 - 56*
     +    TG**(-1)*MG2*MT2*T**(-1) - 24*TG**(-1)*MG2*MT2*U**(-1) + 40*
     +    TG**(-1)*MT2 + 32*TG*S1**(-1)*NS*MS2*MG2**(-1) - 32*TG*
     +    S1**(-1)*MG2**(-1)*MT2 + 4*TG*T1**(-1)*NS - 4*TG*T1**(-1) - 4
     +    *TG*U1**(-1)*NS + 4*TG*U1**(-1) + 8*TG**2*S1**(-1)*NS*MS2*
     +    MG2**(-2) - 8*TG**2*S1**(-1)*MG2**(-2)*MT2 - 128*UG**(-3)*NS*
     +    MS2*MG2**2 + 128*UG**(-3)*NS*MS2*MG2**3*U**(-1) + 128*
     +    UG**(-3)*MG2**2*MT2 - 128*UG**(-3)*MG2**3*MT2*U**(-1) - 16*
     +    UG**(-2)*NS*MS2*MG2 + 144*UG**(-2)*NS*MS2*MG2**2*U**(-1) + 16
     +    *UG**(-2)*MG2*MT2 - 144*UG**(-2)*MG2**2*MT2*U**(-1) + 32*
     +    UG**(-1)*S1**(-1)*NS*MS2*MG2 - 32*UG**(-1)*S1**(-1)*MG2*MT2
     +     + 24*UG**(-1)*NS*MS2*MG2*T**(-1) + 56*UG**(-1)*NS*MS2*MG2*
     +    U**(-1) - 40*UG**(-1)*NS*MS2 - 24*UG**(-1)*MG2*MT2*T**(-1) - 
     +    56*UG**(-1)*MG2*MT2*U**(-1) + 40*UG**(-1)*MT2 + 64*S1**(-1)*
     +    NS*MS2 )
     +
      M2GGSV = M2GGSV + N*CO * (  - 64*S1**(-1)*MT2 - 4*T1**(-1)*NS*MS2
     +     + 4*T1**(-1)*NS*MG2 + 4*T1**(-1)*MS2 - 4*T1**(-1)*MG2 - 4*
     +    U1**(-1)*NS*MS2 + 4*U1**(-1)*NS*MG2 + 4*U1**(-1)*MS2 - 4*
     +    U1**(-1)*MG2 - 48*NS*MS2*MG2**(-1) + 16*NS*MS2*T**(-1) + 24*
     +    NS*MS2*U**(-1) - 8*NS + 48*MG2**(-1)*MT2 - 16*MT2*T**(-1) - 
     +    24*MT2*U**(-1) )
     +
      M2GGSV = M2GGSV + N**2*CO * ( 48 + 128*S**(-2)*TG**(-1)*MG2**3 - 
     +    64*S**(-2)*TG**(-1)*MG2**4*T**(-1) - 64*S**(-2)*TG**(-1)*
     +    MG2**4*U**(-1) + 128*S**(-2)*UG**(-1)*MG2**3 - 64*S**(-2)*
     +    UG**(-1)*MG2**4*T**(-1) - 64*S**(-2)*UG**(-1)*MG2**4*U**(-1)
     +     - 64*S**(-1)*TG**(-2)*MG2**3 + 64*S**(-1)*TG**(-2)*MG2**4*
     +    T**(-1) + 64*S**(-1)*TG**(-1)*MG2**3*T**(-1) + 64*S**(-1)*
     +    TG**(-1)*MG2**3*U**(-1) + 8*S**(-1)*TG*MG2*T**(-1) - 8*
     +    S**(-1)*TG*MG2*U**(-1) - 8*S**(-1)*TG**2*MG2**(-1) - 64*
     +    S**(-1)*UG**(-2)*MG2**3 + 64*S**(-1)*UG**(-2)*MG2**4*U**(-1)
     +     + 64*S**(-1)*UG**(-1)*MG2**3*T**(-1) + 64*S**(-1)*UG**(-1)*
     +    MG2**3*U**(-1) - 32*S**(-1)*MG2 + 16*S**(-1)*MG2**2*T**(-1)
     +     + 16*S**(-1)*MG2**2*U**(-1) - 32*S*TG**(-3)*MG2**2 + 32*S*
     +    TG**(-3)*MG2**3*T**(-1) + 48*S*TG**(-2)*MG2 + 16*S*TG**(-2)*
     +    MG2**2*T**(-1) - 16*S*TG**(-1)*MG2*T**(-1) + 8*S*TG**(-1)*MG2
     +    *U**(-1) + 16*S*TG**(-1) - 32*S*UG**(-3)*MG2**2 + 32*S*
     +    UG**(-3)*MG2**3*U**(-1) )
     +
      M2GGSV = M2GGSV + N**2*CO * ( 48*S*UG**(-2)*MG2 + 16*S*UG**(-2)*
     +    MG2**2*U**(-1) + 8*S*UG**(-1)*MG2*T**(-1) - 16*S*UG**(-1)*MG2
     +    *U**(-1) + 16*S*UG**(-1) + 128*TG**(-3)*MG2**3 - 128*TG**(-3)
     +    *MG2**4*T**(-1) + 16*TG**(-2)*MG2**2 - 144*TG**(-2)*MG2**3*
     +    T**(-1) - 32*TG**(-1)*S1**(-1)*MG2**2 + 40*TG**(-1)*MG2 - 56*
     +    TG**(-1)*MG2**2*T**(-1) - 24*TG**(-1)*MG2**2*U**(-1) - 32*TG*
     +    S1**(-1) - 8*TG**2*S1**(-1)*MG2**(-1) + 128*UG**(-3)*MG2**3
     +     - 128*UG**(-3)*MG2**4*U**(-1) + 16*UG**(-2)*MG2**2 - 144*
     +    UG**(-2)*MG2**3*U**(-1) - 32*UG**(-1)*S1**(-1)*MG2**2 + 40*
     +    UG**(-1)*MG2 - 24*UG**(-1)*MG2**2*T**(-1) - 56*UG**(-1)*
     +    MG2**2*U**(-1) - 64*S1**(-1)*MG2 - 16*MG2*T**(-1) - 24*MG2*
     +    U**(-1) )
     +
ctp  decouple the squark mass in the numerator 
ctp      if ( (ms>1.D4).and.(ms.gt.20.D0*mg) ) ms2 = 0.D0
      M2GGSV = M2GGSV + SK1B0A(1)*N*CO*THREE**(-1) * (  - 384*S**(-2)*
     +    TG**(-1)*NS*MS2*MG2**2 + 192*S**(-2)*TG**(-1)*NS*MS2*MG2**3*
     +    T**(-1) + 192*S**(-2)*TG**(-1)*NS*MS2*MG2**3*U**(-1) + 32*
     +    S**(-2)*TG**2*NS - 384*S**(-2)*UG**(-1)*NS*MS2*MG2**2 + 192*
     +    S**(-2)*UG**(-1)*NS*MS2*MG2**3*T**(-1) + 192*S**(-2)*UG**(-1)
     +    *NS*MS2*MG2**3*U**(-1) - 384*S**(-2)*NS*MS2*MG2 + 192*S**(-1)
     +    *TG**(-2)*NS*MS2*MG2**2 - 192*S**(-1)*TG**(-2)*NS*MS2*MG2**3*
     +    T**(-1) - 96*S**(-1)*TG**(-1)*NS*MS2*MG2 - 192*S**(-1)*
     +    TG**(-1)*NS*MS2*MG2**2*T**(-1) - 192*S**(-1)*TG**(-1)*NS*MS2*
     +    MG2**2*U**(-1) - 64*S**(-1)*TG**(-1)*NS*MG2**2 - 24*S**(-1)*
     +    TG*NS*MS2*T**(-1) + 24*S**(-1)*TG*NS*MS2*U**(-1) + 32*S**(-1)
     +    *TG*NS + 24*S**(-1)*TG**2*NS*MS2*MG2**(-2) + 192*S**(-1)*
     +    UG**(-2)*NS*MS2*MG2**2 - 192*S**(-1)*UG**(-2)*NS*MS2*MG2**3*
     +    U**(-1) - 96*S**(-1)*UG**(-1)*NS*MS2*MG2 - 192*S**(-1)*
     +    UG**(-1)*NS*MS2*MG2**2*T**(-1) - 192*S**(-1)*UG**(-1)*NS*MS2*
     +    MG2**2*U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0A(1)*N*CO*THREE**(-1) * (  - 64*S**(-1)*
     +    UG**(-1)*NS*MG2**2 - 48*S**(-1)*NS*MS2*MG2*T**(-1) - 48*
     +    S**(-1)*NS*MS2*MG2*U**(-1) + 96*S**(-1)*NS*MS2 + 64*S**(-1)*
     +    NS*MG2 + 96*S*TG**(-3)*NS*MS2*MG2 - 96*S*TG**(-3)*NS*MS2*
     +    MG2**2*T**(-1) - 48*S*TG**(-2)*NS*MS2*MG2*T**(-1) - 144*S*
     +    TG**(-2)*NS*MS2 - 48*S*TG**(-1)*NS*MS2*MG2**(-1) + 48*S*
     +    TG**(-1)*NS*MS2*T**(-1) - 24*S*TG**(-1)*NS*MS2*U**(-1) + 16*S
     +    *TG**(-1)*NS + 96*S*UG**(-3)*NS*MS2*MG2 - 96*S*UG**(-3)*NS*
     +    MS2*MG2**2*U**(-1) - 48*S*UG**(-2)*NS*MS2*MG2*U**(-1) - 144*S
     +    *UG**(-2)*NS*MS2 - 48*S*UG**(-1)*NS*MS2*MG2**(-1) - 24*S*
     +    UG**(-1)*NS*MS2*T**(-1) + 48*S*UG**(-1)*NS*MS2*U**(-1) + 16*S
     +    *UG**(-1)*NS - 384*TG**(-3)*NS*MS2*MG2**2 + 384*TG**(-3)*NS*
     +    MS2*MG2**3*T**(-1) - 48*TG**(-2)*NS*MS2*MG2 + 432*TG**(-2)*NS
     +    *MS2*MG2**2*T**(-1) + 64*TG**(-2)*NS*MG2**2 + 96*TG**(-1)*
     +    S1**(-1)*NS*MS2*MG2 + 168*TG**(-1)*NS*MS2*MG2*T**(-1) + 72*
     +    TG**(-1)*NS*MS2*MG2*U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0A(1)*N*CO*THREE**(-1) * (  - 120*TG**(-1)*
     +    NS*MS2 + 64*TG**(-1)*NS*MG2 + 96*TG*S1**(-1)*NS*MS2*MG2**(-1)
     +     + 24*TG**2*S1**(-1)*NS*MS2*MG2**(-2) - 384*UG**(-3)*NS*MS2*
     +    MG2**2 + 384*UG**(-3)*NS*MS2*MG2**3*U**(-1) - 48*UG**(-2)*NS*
     +    MS2*MG2 + 432*UG**(-2)*NS*MS2*MG2**2*U**(-1) + 64*UG**(-2)*NS
     +    *MG2**2 + 96*UG**(-1)*S1**(-1)*NS*MS2*MG2 + 72*UG**(-1)*NS*
     +    MS2*MG2*T**(-1) + 168*UG**(-1)*NS*MS2*MG2*U**(-1) - 120*
     +    UG**(-1)*NS*MS2 + 64*UG**(-1)*NS*MG2 + 192*S1**(-1)*NS*MS2 - 
     +    144*NS*MS2*MG2**(-1) + 48*NS*MS2*T**(-1) + 72*NS*MS2*U**(-1)
     +     + 48*NS )
     +
      M2GGSV = M2GGSV + SK1B0A(2)*N*CO*THREE**(-1) * ( 96 + 384*S**(-2)
     +    *TG**(-1)*MG2**2*MT2 - 192*S**(-2)*TG**(-1)*MG2**3*MT2*
     +    T**(-1) - 192*S**(-2)*TG**(-1)*MG2**3*MT2*U**(-1) + 64*
     +    S**(-2)*TG**2 + 384*S**(-2)*UG**(-1)*MG2**2*MT2 - 192*S**(-2)
     +    *UG**(-1)*MG2**3*MT2*T**(-1) - 192*S**(-2)*UG**(-1)*MG2**3*
     +    MT2*U**(-1) + 384*S**(-2)*MG2*MT2 - 192*S**(-1)*TG**(-2)*
     +    MG2**2*MT2 + 192*S**(-1)*TG**(-2)*MG2**3*MT2*T**(-1) + 96*
     +    S**(-1)*TG**(-1)*MG2*MT2 + 192*S**(-1)*TG**(-1)*MG2**2*MT2*
     +    T**(-1) + 192*S**(-1)*TG**(-1)*MG2**2*MT2*U**(-1) - 128*
     +    S**(-1)*TG**(-1)*MG2**2 + 24*S**(-1)*TG*MT2*T**(-1) - 24*
     +    S**(-1)*TG*MT2*U**(-1) + 64*S**(-1)*TG - 24*S**(-1)*TG**2*
     +    MG2**(-2)*MT2 - 192*S**(-1)*UG**(-2)*MG2**2*MT2 + 192*S**(-1)
     +    *UG**(-2)*MG2**3*MT2*U**(-1) + 96*S**(-1)*UG**(-1)*MG2*MT2 + 
     +    192*S**(-1)*UG**(-1)*MG2**2*MT2*T**(-1) + 192*S**(-1)*
     +    UG**(-1)*MG2**2*MT2*U**(-1) - 128*S**(-1)*UG**(-1)*MG2**2 + 
     +    48*S**(-1)*MG2*MT2*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0A(2)*N*CO*THREE**(-1) * ( 48*S**(-1)*MG2*
     +    MT2*U**(-1) + 128*S**(-1)*MG2 - 96*S**(-1)*MT2 - 96*S*
     +    TG**(-3)*MG2*MT2 + 96*S*TG**(-3)*MG2**2*MT2*T**(-1) + 48*S*
     +    TG**(-2)*MG2*MT2*T**(-1) + 144*S*TG**(-2)*MT2 + 48*S*TG**(-1)
     +    *MG2**(-1)*MT2 - 48*S*TG**(-1)*MT2*T**(-1) + 24*S*TG**(-1)*
     +    MT2*U**(-1) + 32*S*TG**(-1) - 96*S*UG**(-3)*MG2*MT2 + 96*S*
     +    UG**(-3)*MG2**2*MT2*U**(-1) + 48*S*UG**(-2)*MG2*MT2*U**(-1)
     +     + 144*S*UG**(-2)*MT2 + 48*S*UG**(-1)*MG2**(-1)*MT2 + 24*S*
     +    UG**(-1)*MT2*T**(-1) - 48*S*UG**(-1)*MT2*U**(-1) + 32*S*
     +    UG**(-1) + 384*TG**(-3)*MG2**2*MT2 - 384*TG**(-3)*MG2**3*MT2*
     +    T**(-1) + 48*TG**(-2)*MG2*MT2 - 432*TG**(-2)*MG2**2*MT2*
     +    T**(-1) + 128*TG**(-2)*MG2**2 - 96*TG**(-1)*S1**(-1)*MG2*MT2
     +     - 168*TG**(-1)*MG2*MT2*T**(-1) - 72*TG**(-1)*MG2*MT2*U**(-1)
     +     + 128*TG**(-1)*MG2 + 120*TG**(-1)*MT2 - 96*TG*S1**(-1)*
     +    MG2**(-1)*MT2 - 24*TG**2*S1**(-1)*MG2**(-2)*MT2 + 384*
     +    UG**(-3)*MG2**2*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0A(2)*N*CO*THREE**(-1) * (  - 384*UG**(-3)*
     +    MG2**3*MT2*U**(-1) + 48*UG**(-2)*MG2*MT2 - 432*UG**(-2)*
     +    MG2**2*MT2*U**(-1) + 128*UG**(-2)*MG2**2 - 96*UG**(-1)*
     +    S1**(-1)*MG2*MT2 - 72*UG**(-1)*MG2*MT2*T**(-1) - 168*UG**(-1)
     +    *MG2*MT2*U**(-1) + 128*UG**(-1)*MG2 + 120*UG**(-1)*MT2 - 192*
     +    S1**(-1)*MT2 + 144*MG2**(-1)*MT2 - 48*MT2*T**(-1) - 72*MT2*
     +    U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0B(1)*N*CO * (  - 12 + 16*S**(-2)*TG**2*NS*
     +    MS2*MG2**(-1) - 16*S**(-2)*TG**2*NS - 16*S**(-2)*TG**2*MS2*
     +    MG2**(-1) + 16*S**(-2)*TG**2 + 16*S**(-1)*TG*NS*MS2*MG2**(-1)
     +     - 16*S**(-1)*TG*NS - 16*S**(-1)*TG*MS2*MG2**(-1) + 16*
     +    S**(-1)*TG + 10*S**(-1)*TG**2*NS*MS2*MG2**(-2) + 6*S**(-1)*
     +    TG**2*NS*MG2**(-1) - 10*S**(-1)*TG**2*MS2*MG2**(-2) - 6*
     +    S**(-1)*TG**2*MG2**(-1) + 16*S**(-1)*NS*MS2 - 16*S**(-1)*NS*
     +    MG2 - 16*S**(-1)*MS2 + 16*S**(-1)*MG2 + 8*S*S1**(-1)*NS - 8*S
     +    *S1**(-1) + 96*TG**(-1)*S1**(-2)*NS*MS2*MG2**2 + 96*TG**(-1)*
     +    S1**(-2)*NS*MG2**3 - 96*TG**(-1)*S1**(-2)*MS2*MG2**2 - 96*
     +    TG**(-1)*S1**(-2)*MG2**3 - 8*TG**(-1)*S1**(-1)*NS*MS2*MG2 - 
     +    56*TG**(-1)*S1**(-1)*NS*MG2**2 + 8*TG**(-1)*S1**(-1)*MS2*MG2
     +     + 56*TG**(-1)*S1**(-1)*MG2**2 + 4*TG**(-1)*NS*MG2 - 4*
     +    TG**(-1)*MG2 + 96*TG*S1**(-2)*NS*MS2 + 96*TG*S1**(-2)*NS*MG2
     +     - 96*TG*S1**(-2)*MS2 - 96*TG*S1**(-2)*MG2 + 16*TG*S1**(-1)*
     +    NS*MS2*MG2**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0B(1)*N*CO * (  - 16*TG*S1**(-1)*MS2*
     +    MG2**(-1) + 24*TG**2*S1**(-2)*NS*MS2*MG2**(-1) + 24*TG**2*
     +    S1**(-2)*NS - 24*TG**2*S1**(-2)*MS2*MG2**(-1) - 24*TG**2*
     +    S1**(-2) + 10*TG**2*S1**(-1)*NS*MS2*MG2**(-2) + 6*TG**2*
     +    S1**(-1)*NS*MG2**(-1) - 10*TG**2*S1**(-1)*MS2*MG2**(-2) - 6*
     +    TG**2*S1**(-1)*MG2**(-1) + 96*UG**(-1)*S1**(-2)*NS*MS2*MG2**2
     +     + 96*UG**(-1)*S1**(-2)*NS*MG2**3 - 96*UG**(-1)*S1**(-2)*MS2*
     +    MG2**2 - 96*UG**(-1)*S1**(-2)*MG2**3 - 8*UG**(-1)*S1**(-1)*NS
     +    *MS2*MG2 - 56*UG**(-1)*S1**(-1)*NS*MG2**2 + 8*UG**(-1)*
     +    S1**(-1)*MS2*MG2 + 56*UG**(-1)*S1**(-1)*MG2**2 + 4*UG**(-1)*
     +    NS*MG2 - 4*UG**(-1)*MG2 + 192*S1**(-2)*NS*MS2*MG2 + 192*
     +    S1**(-2)*NS*MG2**2 - 192*S1**(-2)*MS2*MG2 - 192*S1**(-2)*
     +    MG2**2 + 8*S1**(-1)*NS*MS2 - 88*S1**(-1)*NS*MG2 - 8*S1**(-1)*
     +    MS2 + 88*S1**(-1)*MG2 + 12*NS )
     +
      M2GGSV = M2GGSV + SK1B0B(1)*N**2*CO * (  - 12 + 32*S**(-2)*TG**2
     +     + 32*S**(-1)*TG - 16*S**(-1)*TG**2*MG2**(-1) + 32*S**(-1)*
     +    MG2 - 16*S*S1**(-1) - 192*TG**(-1)*S1**(-2)*MG2**3 + 64*
     +    TG**(-1)*S1**(-1)*MG2**2 + 4*TG**(-1)*MG2 - 192*TG*S1**(-2)*
     +    MG2 - 16*TG*S1**(-1) - 48*TG**2*S1**(-2) - 16*TG**2*S1**(-1)*
     +    MG2**(-1) - 192*UG**(-1)*S1**(-2)*MG2**3 + 64*UG**(-1)*
     +    S1**(-1)*MG2**2 + 4*UG**(-1)*MG2 - 384*S1**(-2)*MG2**2 + 112*
     +    S1**(-1)*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0B(2)*N**2*CO * ( 28 + 32*S**(-2)*TG**2 - 
     +    128*S**(-2)*MG2**2 - 32*S**(-1)*TG**(-1)*MG2**2 + 32*S**(-1)*
     +    TG - 4*S**(-1)*TG**2*MG2**(-1) - 32*S**(-1)*UG**(-1)*MG2**2
     +     + 32*S**(-1)*MG2 + 8*S*S1**(-1) - 48*TG**(-1)*S1**(-1)*
     +    MG2**2 + 20*TG**(-1)*MG2 - 16*TG*S1**(-1) - 4*TG**2*S1**(-1)*
     +    MG2**(-1) - 48*UG**(-1)*S1**(-1)*MG2**2 + 20*UG**(-1)*MG2 - 
     +    96*S1**(-1)*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0B(3)*N*CO * ( 16*S**(-2)*TG**2*NS*MS2*
     +    MG2**(-1) - 16*S**(-2)*TG**2*NS - 16*S**(-2)*TG**2*MG2**(-1)*
     +    MT2 + 128*S**(-2)*NS*MS2*MG2 + 32*S**(-1)*TG**(-1)*NS*MS2*MG2
     +     + 16*S**(-1)*TG*NS*MS2*MG2**(-1) - 16*S**(-1)*TG*NS - 16*
     +    S**(-1)*TG*MG2**(-1)*MT2 + 10*S**(-1)*TG**2*NS*MS2*MG2**(-2)
     +     - 6*S**(-1)*TG**2*NS*MG2**(-1) - 10*S**(-1)*TG**2*MG2**(-2)*
     +    MT2 + 32*S**(-1)*UG**(-1)*NS*MS2*MG2 + 16*S**(-1)*NS*MS2 - 16
     +    *S**(-1)*NS*MG2 - 16*S**(-1)*MT2 + 96*TG**(-1)*S1**(-2)*NS*
     +    MS2*MG2**2 - 96*TG**(-1)*S1**(-2)*NS*MG2**3 - 96*TG**(-1)*
     +    S1**(-2)*MG2**2*MT2 - 8*TG**(-1)*S1**(-1)*NS*MS2*MG2 + 56*
     +    TG**(-1)*S1**(-1)*NS*MG2**2 + 8*TG**(-1)*S1**(-1)*MG2*MT2 - 
     +    12*TG**(-1)*NS*MG2 + 96*TG*S1**(-2)*NS*MS2 - 96*TG*S1**(-2)*
     +    NS*MG2 - 96*TG*S1**(-2)*MT2 + 16*TG*S1**(-1)*NS*MS2*MG2**(-1)
     +     - 16*TG*S1**(-1)*MG2**(-1)*MT2 + 24*TG**2*S1**(-2)*NS*MS2*
     +    MG2**(-1) - 24*TG**2*S1**(-2)*NS - 24*TG**2*S1**(-2)*
     +    MG2**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0B(3)*N*CO * ( 10*TG**2*S1**(-1)*NS*MS2*
     +    MG2**(-2) - 6*TG**2*S1**(-1)*NS*MG2**(-1) - 10*TG**2*S1**(-1)
     +    *MG2**(-2)*MT2 + 96*UG**(-1)*S1**(-2)*NS*MS2*MG2**2 - 96*
     +    UG**(-1)*S1**(-2)*NS*MG2**3 - 96*UG**(-1)*S1**(-2)*MG2**2*MT2
     +     - 8*UG**(-1)*S1**(-1)*NS*MS2*MG2 + 56*UG**(-1)*S1**(-1)*NS*
     +    MG2**2 + 8*UG**(-1)*S1**(-1)*MG2*MT2 - 12*UG**(-1)*NS*MG2 + 
     +    192*S1**(-2)*NS*MS2*MG2 - 192*S1**(-2)*NS*MG2**2 - 192*
     +    S1**(-2)*MG2*MT2 + 8*S1**(-1)*NS*MS2 + 56*S1**(-1)*NS*MG2 - 8
     +    *S1**(-1)*MT2 - 12*NS )
     +
      M2GGSV = M2GGSV + SK1B0B(4)*N*CO * ( 12 + 16*S**(-2)*TG**2*MS2*
     +    MG2**(-1) - 16*S**(-2)*TG**2*MG2**(-1)*MT2 - 16*S**(-2)*TG**2
     +     - 128*S**(-2)*MG2*MT2 - 32*S**(-1)*TG**(-1)*MG2*MT2 + 16*
     +    S**(-1)*TG*MS2*MG2**(-1) - 16*S**(-1)*TG*MG2**(-1)*MT2 - 16*
     +    S**(-1)*TG + 10*S**(-1)*TG**2*MS2*MG2**(-2) - 10*S**(-1)*
     +    TG**2*MG2**(-2)*MT2 + 6*S**(-1)*TG**2*MG2**(-1) - 32*S**(-1)*
     +    UG**(-1)*MG2*MT2 + 16*S**(-1)*MS2 - 16*S**(-1)*MG2 - 16*
     +    S**(-1)*MT2 + 8*S*S1**(-1) + 96*TG**(-1)*S1**(-2)*MS2*MG2**2
     +     - 96*TG**(-1)*S1**(-2)*MG2**2*MT2 + 96*TG**(-1)*S1**(-2)*
     +    MG2**3 - 8*TG**(-1)*S1**(-1)*MS2*MG2 + 8*TG**(-1)*S1**(-1)*
     +    MG2*MT2 - 56*TG**(-1)*S1**(-1)*MG2**2 + 4*TG**(-1)*MG2 + 96*
     +    TG*S1**(-2)*MS2 + 96*TG*S1**(-2)*MG2 - 96*TG*S1**(-2)*MT2 + 
     +    16*TG*S1**(-1)*MS2*MG2**(-1) - 16*TG*S1**(-1)*MG2**(-1)*MT2
     +     + 24*TG**2*S1**(-2)*MS2*MG2**(-1) - 24*TG**2*S1**(-2)*
     +    MG2**(-1)*MT2 + 24*TG**2*S1**(-2) + 10*TG**2*S1**(-1)*MS2*
     +    MG2**(-2) )
     +
      M2GGSV = M2GGSV + SK1B0B(4)*N*CO * (  - 10*TG**2*S1**(-1)*
     +    MG2**(-2)*MT2 + 6*TG**2*S1**(-1)*MG2**(-1) + 96*UG**(-1)*
     +    S1**(-2)*MS2*MG2**2 - 96*UG**(-1)*S1**(-2)*MG2**2*MT2 + 96*
     +    UG**(-1)*S1**(-2)*MG2**3 - 8*UG**(-1)*S1**(-1)*MS2*MG2 + 8*
     +    UG**(-1)*S1**(-1)*MG2*MT2 - 56*UG**(-1)*S1**(-1)*MG2**2 + 4*
     +    UG**(-1)*MG2 + 192*S1**(-2)*MS2*MG2 - 192*S1**(-2)*MG2*MT2 + 
     +    192*S1**(-2)*MG2**2 + 8*S1**(-1)*MS2 - 88*S1**(-1)*MG2 - 8*
     +    S1**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0C(1)*N**2*CO * (  - 184 - 256*S**(-2)*
     +    TG**(-1)*MG2**3 - 64*S**(-2)*TG**2 - 256*S**(-2)*UG**(-1)*
     +    MG2**3 + 128*S**(-1)*TG**(-2)*MG2**3 + 224*S**(-1)*TG**(-1)*
     +    MG2**2 - 64*S**(-1)*TG + 28*S**(-1)*TG**2*MG2**(-1) + 128*
     +    S**(-1)*UG**(-2)*MG2**3 + 224*S**(-1)*UG**(-1)*MG2**2 - 192*
     +    S**(-1)*MG2 + 32*S*TG**(-3)*MG2**2 - 64*S*TG**(-2)*MG2 - 64*S
     +    *TG**(-1) + 32*S*UG**(-3)*MG2**2 - 64*S*UG**(-2)*MG2 - 64*S*
     +    UG**(-1) + 8*S*S1**(-1) - 256*TG**(-3)*MG2**3 - 400*TG**(-2)*
     +    MG2**2 + 192*TG**(-1)*S1**(-2)*MG2**3 + 16*TG**(-1)*S1**(-1)*
     +    MG2**2 - 336*TG**(-1)*MG2 + 192*TG*S1**(-2)*MG2 + 64*TG*
     +    S1**(-1) + 48*TG**2*S1**(-2) + 28*TG**2*S1**(-1)*MG2**(-1) - 
     +    256*UG**(-3)*MG2**3 - 400*UG**(-2)*MG2**2 + 192*UG**(-1)*
     +    S1**(-2)*MG2**3 + 16*UG**(-1)*S1**(-1)*MG2**2 - 336*UG**(-1)*
     +    MG2 + 384*S1**(-2)*MG2**2 + 48*S1**(-1)*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0C(2)*N*CO * (  - 40 - 128*S**(-2)*TG**(-1)
     +    *NS*MS2*MG2**2 + 128*S**(-2)*TG**(-1)*NS*MG2**3 + 128*S**(-2)
     +    *TG**(-1)*MS2*MG2**2 - 128*S**(-2)*TG**(-1)*MG2**3 - 32*
     +    S**(-2)*TG**2*NS*MS2*MG2**(-1) + 32*S**(-2)*TG**2*NS + 32*
     +    S**(-2)*TG**2*MS2*MG2**(-1) - 32*S**(-2)*TG**2 - 128*S**(-2)*
     +    UG**(-1)*NS*MS2*MG2**2 + 128*S**(-2)*UG**(-1)*NS*MG2**3 + 128
     +    *S**(-2)*UG**(-1)*MS2*MG2**2 - 128*S**(-2)*UG**(-1)*MG2**3 + 
     +    64*S**(-1)*TG**(-2)*NS*MS2*MG2**2 - 64*S**(-1)*TG**(-2)*NS*
     +    MG2**3 - 64*S**(-1)*TG**(-2)*MS2*MG2**2 + 64*S**(-1)*TG**(-2)
     +    *MG2**3 + 64*S**(-1)*TG**(-1)*NS*MS2*MG2 - 96*S**(-1)*
     +    TG**(-1)*NS*MG2**2 - 64*S**(-1)*TG**(-1)*MS2*MG2 + 96*S**(-1)
     +    *TG**(-1)*MG2**2 - 32*S**(-1)*TG*NS*MS2*MG2**(-1) + 32*
     +    S**(-1)*TG*NS + 32*S**(-1)*TG*MS2*MG2**(-1) - 32*S**(-1)*TG
     +     - 28*S**(-1)*TG**2*NS*MS2*MG2**(-2) + 28*S**(-1)*TG**2*MS2*
     +    MG2**(-2) + 64*S**(-1)*UG**(-2)*NS*MS2*MG2**2 - 64*S**(-1)*
     +    UG**(-2)*NS*MG2**3 )
     +
      M2GGSV = M2GGSV + SK1B0C(2)*N*CO * (  - 64*S**(-1)*UG**(-2)*MS2*
     +    MG2**2 + 64*S**(-1)*UG**(-2)*MG2**3 + 64*S**(-1)*UG**(-1)*NS*
     +    MS2*MG2 - 96*S**(-1)*UG**(-1)*NS*MG2**2 - 64*S**(-1)*UG**(-1)
     +    *MS2*MG2 + 96*S**(-1)*UG**(-1)*MG2**2 - 96*S**(-1)*NS*MS2 + 
     +    96*S**(-1)*NS*MG2 + 96*S**(-1)*MS2 - 96*S**(-1)*MG2 - 32*S*
     +    TG**(-3)*NS*MS2*MG2 + 32*S*TG**(-3)*MS2*MG2 + 16*S*TG**(-2)*
     +    NS*MS2 + 16*S*TG**(-2)*NS*MG2 - 16*S*TG**(-2)*MS2 - 16*S*
     +    TG**(-2)*MG2 + 16*S*TG**(-1)*NS*MS2*MG2**(-1) + 16*S*TG**(-1)
     +    *NS - 16*S*TG**(-1)*MS2*MG2**(-1) - 16*S*TG**(-1) - 32*S*
     +    UG**(-3)*NS*MS2*MG2 + 32*S*UG**(-3)*MS2*MG2 + 16*S*UG**(-2)*
     +    NS*MS2 + 16*S*UG**(-2)*NS*MG2 - 16*S*UG**(-2)*MS2 - 16*S*
     +    UG**(-2)*MG2 + 16*S*UG**(-1)*NS*MS2*MG2**(-1) + 16*S*UG**(-1)
     +    *NS - 16*S*UG**(-1)*MS2*MG2**(-1) - 16*S*UG**(-1) - 8*S*
     +    S1**(-1)*NS + 8*S*S1**(-1) - 128*TG**(-3)*NS*MS2*MG2**2 + 128
     +    *TG**(-3)*NS*MG2**3 + 128*TG**(-3)*MS2*MG2**2 - 128*TG**(-3)*
     +    MG2**3 )
     +
      M2GGSV = M2GGSV + SK1B0C(2)*N*CO * (  - 176*TG**(-2)*NS*MS2*MG2
     +     + 192*TG**(-2)*NS*MG2**2 + 176*TG**(-2)*MS2*MG2 - 192*
     +    TG**(-2)*MG2**2 - 192*TG**(-1)*S1**(-2)*NS*MS2*MG2**2 + 192*
     +    TG**(-1)*S1**(-2)*MS2*MG2**2 - 16*TG**(-1)*S1**(-1)*NS*MS2*
     +    MG2 + 16*TG**(-1)*S1**(-1)*MS2*MG2 - 48*TG**(-1)*NS*MS2 + 128
     +    *TG**(-1)*NS*MG2 + 48*TG**(-1)*MS2 - 128*TG**(-1)*MG2 - 192*
     +    TG*S1**(-2)*NS*MS2 + 192*TG*S1**(-2)*MS2 - 64*TG*S1**(-1)*NS*
     +    MS2*MG2**(-1) + 64*TG*S1**(-1)*MS2*MG2**(-1) - 48*TG**2*
     +    S1**(-2)*NS*MS2*MG2**(-1) + 48*TG**2*S1**(-2)*MS2*MG2**(-1)
     +     - 28*TG**2*S1**(-1)*NS*MS2*MG2**(-2) + 28*TG**2*S1**(-1)*MS2
     +    *MG2**(-2) - 128*UG**(-3)*NS*MS2*MG2**2 + 128*UG**(-3)*NS*
     +    MG2**3 + 128*UG**(-3)*MS2*MG2**2 - 128*UG**(-3)*MG2**3 - 176*
     +    UG**(-2)*NS*MS2*MG2 + 192*UG**(-2)*NS*MG2**2 + 176*UG**(-2)*
     +    MS2*MG2 - 192*UG**(-2)*MG2**2 - 192*UG**(-1)*S1**(-2)*NS*MS2*
     +    MG2**2 + 192*UG**(-1)*S1**(-2)*MS2*MG2**2 - 16*UG**(-1)*
     +    S1**(-1)*NS*MS2*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0C(2)*N*CO * ( 16*UG**(-1)*S1**(-1)*MS2*MG2
     +     - 48*UG**(-1)*NS*MS2 + 128*UG**(-1)*NS*MG2 + 48*UG**(-1)*MS2
     +     - 128*UG**(-1)*MG2 - 384*S1**(-2)*NS*MS2*MG2 + 384*S1**(-2)*
     +    MS2*MG2 - 80*S1**(-1)*NS*MS2 + 32*S1**(-1)*NS*MG2 + 80*
     +    S1**(-1)*MS2 - 32*S1**(-1)*MG2 + 48*NS*MS2*MG2**(-1) + 40*NS
     +     - 48*MS2*MG2**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0C(3)*N*CO * ( 40 - 128*S**(-2)*TG**(-1)*
     +    MS2*MG2**2 + 128*S**(-2)*TG**(-1)*MG2**2*MT2 + 128*S**(-2)*
     +    TG**(-1)*MG2**3 - 32*S**(-2)*TG**2*MS2*MG2**(-1) + 32*S**(-2)
     +    *TG**2*MG2**(-1)*MT2 + 32*S**(-2)*TG**2 - 128*S**(-2)*
     +    UG**(-1)*MS2*MG2**2 + 128*S**(-2)*UG**(-1)*MG2**2*MT2 + 128*
     +    S**(-2)*UG**(-1)*MG2**3 + 64*S**(-1)*TG**(-2)*MS2*MG2**2 - 64
     +    *S**(-1)*TG**(-2)*MG2**2*MT2 - 64*S**(-1)*TG**(-2)*MG2**3 + 
     +    64*S**(-1)*TG**(-1)*MS2*MG2 - 64*S**(-1)*TG**(-1)*MG2*MT2 - 
     +    96*S**(-1)*TG**(-1)*MG2**2 - 32*S**(-1)*TG*MS2*MG2**(-1) + 32
     +    *S**(-1)*TG*MG2**(-1)*MT2 + 32*S**(-1)*TG - 28*S**(-1)*TG**2*
     +    MS2*MG2**(-2) + 28*S**(-1)*TG**2*MG2**(-2)*MT2 + 64*S**(-1)*
     +    UG**(-2)*MS2*MG2**2 - 64*S**(-1)*UG**(-2)*MG2**2*MT2 - 64*
     +    S**(-1)*UG**(-2)*MG2**3 + 64*S**(-1)*UG**(-1)*MS2*MG2 - 64*
     +    S**(-1)*UG**(-1)*MG2*MT2 - 96*S**(-1)*UG**(-1)*MG2**2 - 96*
     +    S**(-1)*MS2 + 96*S**(-1)*MG2 + 96*S**(-1)*MT2 - 32*S*TG**(-3)
     +    *MS2*MG2 )
     +
      M2GGSV = M2GGSV + SK1B0C(3)*N*CO * ( 32*S*TG**(-3)*MG2*MT2 + 16*S
     +    *TG**(-2)*MS2 + 16*S*TG**(-2)*MG2 - 16*S*TG**(-2)*MT2 + 16*S*
     +    TG**(-1)*MS2*MG2**(-1) - 16*S*TG**(-1)*MG2**(-1)*MT2 + 16*S*
     +    TG**(-1) - 32*S*UG**(-3)*MS2*MG2 + 32*S*UG**(-3)*MG2*MT2 + 16
     +    *S*UG**(-2)*MS2 + 16*S*UG**(-2)*MG2 - 16*S*UG**(-2)*MT2 + 16*
     +    S*UG**(-1)*MS2*MG2**(-1) - 16*S*UG**(-1)*MG2**(-1)*MT2 + 16*S
     +    *UG**(-1) - 8*S*S1**(-1) - 128*TG**(-3)*MS2*MG2**2 + 128*
     +    TG**(-3)*MG2**2*MT2 + 128*TG**(-3)*MG2**3 - 176*TG**(-2)*MS2*
     +    MG2 + 176*TG**(-2)*MG2*MT2 + 192*TG**(-2)*MG2**2 - 192*
     +    TG**(-1)*S1**(-2)*MS2*MG2**2 + 192*TG**(-1)*S1**(-2)*MG2**2*
     +    MT2 - 16*TG**(-1)*S1**(-1)*MS2*MG2 + 16*TG**(-1)*S1**(-1)*MG2
     +    *MT2 - 48*TG**(-1)*MS2 + 128*TG**(-1)*MG2 + 48*TG**(-1)*MT2
     +     - 192*TG*S1**(-2)*MS2 + 192*TG*S1**(-2)*MT2 - 64*TG*S1**(-1)
     +    *MS2*MG2**(-1) + 64*TG*S1**(-1)*MG2**(-1)*MT2 - 48*TG**2*
     +    S1**(-2)*MS2*MG2**(-1) + 48*TG**2*S1**(-2)*MG2**(-1)*MT2 - 28
     +    *TG**2*S1**(-1)*MS2*MG2**(-2) )
     +
      M2GGSV = M2GGSV + SK1B0C(3)*N*CO * ( 28*TG**2*S1**(-1)*MG2**(-2)*
     +    MT2 - 128*UG**(-3)*MS2*MG2**2 + 128*UG**(-3)*MG2**2*MT2 + 128
     +    *UG**(-3)*MG2**3 - 176*UG**(-2)*MS2*MG2 + 176*UG**(-2)*MG2*
     +    MT2 + 192*UG**(-2)*MG2**2 - 192*UG**(-1)*S1**(-2)*MS2*MG2**2
     +     + 192*UG**(-1)*S1**(-2)*MG2**2*MT2 - 16*UG**(-1)*S1**(-1)*
     +    MS2*MG2 + 16*UG**(-1)*S1**(-1)*MG2*MT2 - 48*UG**(-1)*MS2 + 
     +    128*UG**(-1)*MG2 + 48*UG**(-1)*MT2 - 384*S1**(-2)*MS2*MG2 + 
     +    384*S1**(-2)*MG2*MT2 - 80*S1**(-1)*MS2 + 32*S1**(-1)*MG2 + 80
     +    *S1**(-1)*MT2 + 48*MS2*MG2**(-1) - 48*MG2**(-1)*MT2 )
     +
      M2GGSV = M2GGSV + SK1B0D(1,1)*N**2*CO * ( 72 + 64*S**(-2)*
     +    TG**(-1)*MG2**3 + 64*S**(-2)*TG**(-1)*MG2**4*T**(-1) + 64*
     +    S**(-2)*UG**(-1)*MG2**3 + 64*S**(-2)*UG**(-1)*MG2**4*T**(-1)
     +     - 64*S**(-1)*TG**(-2)*MG2**3 - 64*S**(-1)*TG**(-2)*MG2**4*
     +    T**(-1) - 80*S**(-1)*TG**(-1)*MG2**2 - 64*S**(-1)*TG**(-1)*
     +    MG2**3*T**(-1) - 8*S**(-1)*TG*MG2*T**(-1) + 24*S**(-1)*TG - 
     +    144*S**(-1)*UG**(-1)*MG2**2 - 64*S**(-1)*UG**(-1)*MG2**3*
     +    T**(-1) + 80*S**(-1)*MG2 - 16*S**(-1)*MG2**2*T**(-1) - 32*S*
     +    TG**(-3)*MG2**3*T**(-1) + 16*S*TG**(-2)*MG2 - 16*S*TG**(-2)*
     +    MG2**2*T**(-1) + 16*S*TG**(-1)*MG2*T**(-1) + 48*S*TG**(-1) - 
     +    8*S*UG**(-1)*MG2*T**(-1) + 128*TG**(-3)*MG2**3 + 128*TG**(-3)
     +    *MG2**4*T**(-1) + 384*TG**(-2)*MG2**2 + 144*TG**(-2)*MG2**3*
     +    T**(-1) + 232*TG**(-1)*MG2 + 56*TG**(-1)*MG2**2*T**(-1) + 40*
     +    UG**(-1)*MG2 + 24*UG**(-1)*MG2**2*T**(-1) + 16*MG2*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(1,2)*N**2*CO * ( 48 + 64*S**(-2)*
     +    TG**(-1)*MG2**3 + 64*S**(-2)*TG**(-1)*MG2**4*U**(-1) + 64*
     +    S**(-2)*UG**(-1)*MG2**3 + 64*S**(-2)*UG**(-1)*MG2**4*U**(-1)
     +     - 144*S**(-1)*TG**(-1)*MG2**2 - 64*S**(-1)*TG**(-1)*MG2**3*
     +    U**(-1) + 8*S**(-1)*TG*MG2*U**(-1) - 24*S**(-1)*TG - 64*
     +    S**(-1)*UG**(-2)*MG2**3 - 64*S**(-1)*UG**(-2)*MG2**4*U**(-1)
     +     - 80*S**(-1)*UG**(-1)*MG2**2 - 64*S**(-1)*UG**(-1)*MG2**3*
     +    U**(-1) + 80*S**(-1)*MG2 - 16*S**(-1)*MG2**2*U**(-1) - 8*S*
     +    TG**(-1)*MG2*U**(-1) - 32*S*UG**(-3)*MG2**3*U**(-1) + 16*S*
     +    UG**(-2)*MG2 - 16*S*UG**(-2)*MG2**2*U**(-1) + 16*S*UG**(-1)*
     +    MG2*U**(-1) + 48*S*UG**(-1) + 40*TG**(-1)*MG2 + 24*TG**(-1)*
     +    MG2**2*U**(-1) + 128*UG**(-3)*MG2**3 + 128*UG**(-3)*MG2**4*
     +    U**(-1) + 384*UG**(-2)*MG2**2 + 144*UG**(-2)*MG2**3*U**(-1)
     +     + 232*UG**(-1)*MG2 + 56*UG**(-1)*MG2**2*U**(-1) + 24*MG2*
     +    U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(2,1)*N*CO * ( 24 + 128*S**(-2)*TG**(-1)*
     +    NS*MS2*MG2**2 - 64*S**(-2)*TG**(-1)*NS*MS2*MG2**3*T**(-1) - 
     +    64*S**(-2)*TG**(-1)*NS*MG2**3 - 128*S**(-2)*TG**(-1)*MS2*
     +    MG2**2 + 64*S**(-2)*TG**(-1)*MS2*MG2**3*T**(-1) + 64*S**(-2)*
     +    TG**(-1)*MG2**3 + 128*S**(-2)*UG**(-1)*NS*MS2*MG2**2 - 64*
     +    S**(-2)*UG**(-1)*NS*MS2*MG2**3*T**(-1) - 64*S**(-2)*UG**(-1)*
     +    NS*MG2**3 - 128*S**(-2)*UG**(-1)*MS2*MG2**2 + 64*S**(-2)*
     +    UG**(-1)*MS2*MG2**3*T**(-1) + 64*S**(-2)*UG**(-1)*MG2**3 - 
     +    128*S**(-1)*TG**(-2)*NS*MS2*MG2**2 + 64*S**(-1)*TG**(-2)*NS*
     +    MS2*MG2**3*T**(-1) + 64*S**(-1)*TG**(-2)*NS*MG2**3 + 128*
     +    S**(-1)*TG**(-2)*MS2*MG2**2 - 64*S**(-1)*TG**(-2)*MS2*MG2**3*
     +    T**(-1) - 64*S**(-1)*TG**(-2)*MG2**3 - 16*S**(-1)*TG**(-1)*NS
     +    *MS2*MG2 + 64*S**(-1)*TG**(-1)*NS*MS2*MG2**2*T**(-1) + 32*
     +    S**(-1)*TG**(-1)*NS*MG2**2 + 16*S**(-1)*TG**(-1)*MS2*MG2 - 64
     +    *S**(-1)*TG**(-1)*MS2*MG2**2*T**(-1) - 32*S**(-1)*TG**(-1)*
     +    MG2**2 )
     +
      M2GGSV = M2GGSV + SK1B0D(2,1)*N*CO * ( 8*S**(-1)*TG*NS*MS2*
     +    T**(-1) - 8*S**(-1)*TG*NS - 8*S**(-1)*TG*MS2*T**(-1) + 8*
     +    S**(-1)*TG - 48*S**(-1)*UG**(-1)*NS*MS2*MG2 + 64*S**(-1)*
     +    UG**(-1)*NS*MS2*MG2**2*T**(-1) + 64*S**(-1)*UG**(-1)*NS*
     +    MG2**2 + 48*S**(-1)*UG**(-1)*MS2*MG2 - 64*S**(-1)*UG**(-1)*
     +    MS2*MG2**2*T**(-1) - 64*S**(-1)*UG**(-1)*MG2**2 + 16*S**(-1)*
     +    NS*MS2*MG2*T**(-1) + 16*S**(-1)*NS*MS2 - 32*S**(-1)*NS*MG2 - 
     +    16*S**(-1)*MS2*MG2*T**(-1) - 16*S**(-1)*MS2 + 32*S**(-1)*MG2
     +     + 32*S*TG**(-3)*NS*MS2*MG2**2*T**(-1) - 32*S*TG**(-3)*MS2*
     +    MG2**2*T**(-1) + 16*S*TG**(-2)*NS*MS2*MG2*T**(-1) + 32*S*
     +    TG**(-2)*NS*MS2 - 16*S*TG**(-2)*NS*MG2 - 16*S*TG**(-2)*MS2*
     +    MG2*T**(-1) - 32*S*TG**(-2)*MS2 + 16*S*TG**(-2)*MG2 - 16*S*
     +    TG**(-1)*NS*MS2*T**(-1) - 16*S*TG**(-1)*NS + 16*S*TG**(-1)*
     +    MS2*T**(-1) + 16*S*TG**(-1) + 8*S*UG**(-1)*NS*MS2*T**(-1) - 8
     +    *S*UG**(-1)*MS2*T**(-1) + 256*TG**(-3)*NS*MS2*MG2**2 - 128*
     +    TG**(-3)*NS*MS2*MG2**3*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(2,1)*N*CO * (  - 128*TG**(-3)*NS*MG2**3
     +     - 256*TG**(-3)*MS2*MG2**2 + 128*TG**(-3)*MS2*MG2**3*T**(-1)
     +     + 128*TG**(-3)*MG2**3 + 192*TG**(-2)*NS*MS2*MG2 - 144*
     +    TG**(-2)*NS*MS2*MG2**2*T**(-1) - 192*TG**(-2)*NS*MG2**2 - 192
     +    *TG**(-2)*MS2*MG2 + 144*TG**(-2)*MS2*MG2**2*T**(-1) + 192*
     +    TG**(-2)*MG2**2 - 56*TG**(-1)*NS*MS2*MG2*T**(-1) + 80*
     +    TG**(-1)*NS*MS2 - 104*TG**(-1)*NS*MG2 + 56*TG**(-1)*MS2*MG2*
     +    T**(-1) - 80*TG**(-1)*MS2 + 104*TG**(-1)*MG2 - 24*UG**(-1)*NS
     +    *MS2*MG2*T**(-1) + 8*UG**(-1)*NS*MS2 - 16*UG**(-1)*NS*MG2 + 
     +    24*UG**(-1)*MS2*MG2*T**(-1) - 8*UG**(-1)*MS2 + 16*UG**(-1)*
     +    MG2 - 16*NS*MS2*T**(-1) - 24*NS + 16*MS2*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(2,2)*N*CO * ( 16 + 128*S**(-2)*TG**(-1)*
     +    NS*MS2*MG2**2 - 64*S**(-2)*TG**(-1)*NS*MS2*MG2**3*U**(-1) - 
     +    64*S**(-2)*TG**(-1)*NS*MG2**3 - 128*S**(-2)*TG**(-1)*MS2*
     +    MG2**2 + 64*S**(-2)*TG**(-1)*MS2*MG2**3*U**(-1) + 64*S**(-2)*
     +    TG**(-1)*MG2**3 + 128*S**(-2)*UG**(-1)*NS*MS2*MG2**2 - 64*
     +    S**(-2)*UG**(-1)*NS*MS2*MG2**3*U**(-1) - 64*S**(-2)*UG**(-1)*
     +    NS*MG2**3 - 128*S**(-2)*UG**(-1)*MS2*MG2**2 + 64*S**(-2)*
     +    UG**(-1)*MS2*MG2**3*U**(-1) + 64*S**(-2)*UG**(-1)*MG2**3 - 48
     +    *S**(-1)*TG**(-1)*NS*MS2*MG2 + 64*S**(-1)*TG**(-1)*NS*MS2*
     +    MG2**2*U**(-1) + 64*S**(-1)*TG**(-1)*NS*MG2**2 + 48*S**(-1)*
     +    TG**(-1)*MS2*MG2 - 64*S**(-1)*TG**(-1)*MS2*MG2**2*U**(-1) - 
     +    64*S**(-1)*TG**(-1)*MG2**2 - 8*S**(-1)*TG*NS*MS2*U**(-1) + 8*
     +    S**(-1)*TG*NS + 8*S**(-1)*TG*MS2*U**(-1) - 8*S**(-1)*TG - 128
     +    *S**(-1)*UG**(-2)*NS*MS2*MG2**2 + 64*S**(-1)*UG**(-2)*NS*MS2*
     +    MG2**3*U**(-1) + 64*S**(-1)*UG**(-2)*NS*MG2**3 + 128*S**(-1)*
     +    UG**(-2)*MS2*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1B0D(2,2)*N*CO * (  - 64*S**(-1)*UG**(-2)*MS2
     +    *MG2**3*U**(-1) - 64*S**(-1)*UG**(-2)*MG2**3 - 16*S**(-1)*
     +    UG**(-1)*NS*MS2*MG2 + 64*S**(-1)*UG**(-1)*NS*MS2*MG2**2*
     +    U**(-1) + 32*S**(-1)*UG**(-1)*NS*MG2**2 + 16*S**(-1)*UG**(-1)
     +    *MS2*MG2 - 64*S**(-1)*UG**(-1)*MS2*MG2**2*U**(-1) - 32*
     +    S**(-1)*UG**(-1)*MG2**2 + 16*S**(-1)*NS*MS2*MG2*U**(-1) + 16*
     +    S**(-1)*NS*MS2 - 32*S**(-1)*NS*MG2 - 16*S**(-1)*MS2*MG2*
     +    U**(-1) - 16*S**(-1)*MS2 + 32*S**(-1)*MG2 + 8*S*TG**(-1)*NS*
     +    MS2*U**(-1) - 8*S*TG**(-1)*MS2*U**(-1) + 32*S*UG**(-3)*NS*MS2
     +    *MG2**2*U**(-1) - 32*S*UG**(-3)*MS2*MG2**2*U**(-1) + 16*S*
     +    UG**(-2)*NS*MS2*MG2*U**(-1) + 32*S*UG**(-2)*NS*MS2 - 16*S*
     +    UG**(-2)*NS*MG2 - 16*S*UG**(-2)*MS2*MG2*U**(-1) - 32*S*
     +    UG**(-2)*MS2 + 16*S*UG**(-2)*MG2 - 16*S*UG**(-1)*NS*MS2*
     +    U**(-1) - 16*S*UG**(-1)*NS + 16*S*UG**(-1)*MS2*U**(-1) + 16*S
     +    *UG**(-1) - 24*TG**(-1)*NS*MS2*MG2*U**(-1) + 8*TG**(-1)*NS*
     +    MS2 )
     +
      M2GGSV = M2GGSV + SK1B0D(2,2)*N*CO * (  - 16*TG**(-1)*NS*MG2 + 24
     +    *TG**(-1)*MS2*MG2*U**(-1) - 8*TG**(-1)*MS2 + 16*TG**(-1)*MG2
     +     + 256*UG**(-3)*NS*MS2*MG2**2 - 128*UG**(-3)*NS*MS2*MG2**3*
     +    U**(-1) - 128*UG**(-3)*NS*MG2**3 - 256*UG**(-3)*MS2*MG2**2 + 
     +    128*UG**(-3)*MS2*MG2**3*U**(-1) + 128*UG**(-3)*MG2**3 + 192*
     +    UG**(-2)*NS*MS2*MG2 - 144*UG**(-2)*NS*MS2*MG2**2*U**(-1) - 
     +    192*UG**(-2)*NS*MG2**2 - 192*UG**(-2)*MS2*MG2 + 144*UG**(-2)*
     +    MS2*MG2**2*U**(-1) + 192*UG**(-2)*MG2**2 - 56*UG**(-1)*NS*MS2
     +    *MG2*U**(-1) + 80*UG**(-1)*NS*MS2 - 104*UG**(-1)*NS*MG2 + 56*
     +    UG**(-1)*MS2*MG2*U**(-1) - 80*UG**(-1)*MS2 + 104*UG**(-1)*MG2
     +     - 24*NS*MS2*U**(-1) - 16*NS + 24*MS2*U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,1)*N*CO * (  - 24 + 128*S**(-2)*
     +    TG**(-1)*MS2*MG2**2 - 64*S**(-2)*TG**(-1)*MS2*MG2**3*T**(-1)
     +     - 128*S**(-2)*TG**(-1)*MG2**2*MT2 + 64*S**(-2)*TG**(-1)*
     +    MG2**3*MT2*T**(-1) - 64*S**(-2)*TG**(-1)*MG2**3 + 128*S**(-2)
     +    *UG**(-1)*MS2*MG2**2 - 64*S**(-2)*UG**(-1)*MS2*MG2**3*T**(-1)
     +     - 128*S**(-2)*UG**(-1)*MG2**2*MT2 + 64*S**(-2)*UG**(-1)*
     +    MG2**3*MT2*T**(-1) - 64*S**(-2)*UG**(-1)*MG2**3 - 128*S**(-1)
     +    *TG**(-2)*MS2*MG2**2 + 64*S**(-1)*TG**(-2)*MS2*MG2**3*T**(-1)
     +     + 128*S**(-1)*TG**(-2)*MG2**2*MT2 - 64*S**(-1)*TG**(-2)*
     +    MG2**3*MT2*T**(-1) + 64*S**(-1)*TG**(-2)*MG2**3 - 16*S**(-1)*
     +    TG**(-1)*MS2*MG2 + 64*S**(-1)*TG**(-1)*MS2*MG2**2*T**(-1) + 
     +    16*S**(-1)*TG**(-1)*MG2*MT2 - 64*S**(-1)*TG**(-1)*MG2**2*MT2*
     +    T**(-1) + 32*S**(-1)*TG**(-1)*MG2**2 + 8*S**(-1)*TG*MS2*
     +    T**(-1) - 8*S**(-1)*TG*MT2*T**(-1) - 8*S**(-1)*TG - 48*
     +    S**(-1)*UG**(-1)*MS2*MG2 + 64*S**(-1)*UG**(-1)*MS2*MG2**2*
     +    T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,1)*N*CO * ( 48*S**(-1)*UG**(-1)*MG2*
     +    MT2 - 64*S**(-1)*UG**(-1)*MG2**2*MT2*T**(-1) + 64*S**(-1)*
     +    UG**(-1)*MG2**2 + 16*S**(-1)*MS2*MG2*T**(-1) + 16*S**(-1)*MS2
     +     - 16*S**(-1)*MG2*MT2*T**(-1) - 32*S**(-1)*MG2 - 16*S**(-1)*
     +    MT2 + 32*S*TG**(-3)*MS2*MG2**2*T**(-1) - 32*S*TG**(-3)*MG2**2
     +    *MT2*T**(-1) + 16*S*TG**(-2)*MS2*MG2*T**(-1) + 32*S*TG**(-2)*
     +    MS2 - 16*S*TG**(-2)*MG2*MT2*T**(-1) - 16*S*TG**(-2)*MG2 - 32*
     +    S*TG**(-2)*MT2 - 16*S*TG**(-1)*MS2*T**(-1) + 16*S*TG**(-1)*
     +    MT2*T**(-1) - 16*S*TG**(-1) + 8*S*UG**(-1)*MS2*T**(-1) - 8*S*
     +    UG**(-1)*MT2*T**(-1) + 256*TG**(-3)*MS2*MG2**2 - 128*TG**(-3)
     +    *MS2*MG2**3*T**(-1) - 256*TG**(-3)*MG2**2*MT2 + 128*TG**(-3)*
     +    MG2**3*MT2*T**(-1) - 128*TG**(-3)*MG2**3 + 192*TG**(-2)*MS2*
     +    MG2 - 144*TG**(-2)*MS2*MG2**2*T**(-1) - 192*TG**(-2)*MG2*MT2
     +     + 144*TG**(-2)*MG2**2*MT2*T**(-1) - 192*TG**(-2)*MG2**2 - 56
     +    *TG**(-1)*MS2*MG2*T**(-1) + 80*TG**(-1)*MS2 + 56*TG**(-1)*MG2
     +    *MT2*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,1)*N*CO * (  - 104*TG**(-1)*MG2 - 80*
     +    TG**(-1)*MT2 - 24*UG**(-1)*MS2*MG2*T**(-1) + 8*UG**(-1)*MS2
     +     + 24*UG**(-1)*MG2*MT2*T**(-1) - 16*UG**(-1)*MG2 - 8*UG**(-1)
     +    *MT2 - 16*MS2*T**(-1) + 16*MT2*T**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,2)*N*CO * (  - 16 + 128*S**(-2)*
     +    TG**(-1)*MS2*MG2**2 - 64*S**(-2)*TG**(-1)*MS2*MG2**3*U**(-1)
     +     - 128*S**(-2)*TG**(-1)*MG2**2*MT2 + 64*S**(-2)*TG**(-1)*
     +    MG2**3*MT2*U**(-1) - 64*S**(-2)*TG**(-1)*MG2**3 + 128*S**(-2)
     +    *UG**(-1)*MS2*MG2**2 - 64*S**(-2)*UG**(-1)*MS2*MG2**3*U**(-1)
     +     - 128*S**(-2)*UG**(-1)*MG2**2*MT2 + 64*S**(-2)*UG**(-1)*
     +    MG2**3*MT2*U**(-1) - 64*S**(-2)*UG**(-1)*MG2**3 - 48*S**(-1)*
     +    TG**(-1)*MS2*MG2 + 64*S**(-1)*TG**(-1)*MS2*MG2**2*U**(-1) + 
     +    48*S**(-1)*TG**(-1)*MG2*MT2 - 64*S**(-1)*TG**(-1)*MG2**2*MT2*
     +    U**(-1) + 64*S**(-1)*TG**(-1)*MG2**2 - 8*S**(-1)*TG*MS2*
     +    U**(-1) + 8*S**(-1)*TG*MT2*U**(-1) + 8*S**(-1)*TG - 128*
     +    S**(-1)*UG**(-2)*MS2*MG2**2 + 64*S**(-1)*UG**(-2)*MS2*MG2**3*
     +    U**(-1) + 128*S**(-1)*UG**(-2)*MG2**2*MT2 - 64*S**(-1)*
     +    UG**(-2)*MG2**3*MT2*U**(-1) + 64*S**(-1)*UG**(-2)*MG2**3 - 16
     +    *S**(-1)*UG**(-1)*MS2*MG2 + 64*S**(-1)*UG**(-1)*MS2*MG2**2*
     +    U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,2)*N*CO * ( 16*S**(-1)*UG**(-1)*MG2*
     +    MT2 - 64*S**(-1)*UG**(-1)*MG2**2*MT2*U**(-1) + 32*S**(-1)*
     +    UG**(-1)*MG2**2 + 16*S**(-1)*MS2*MG2*U**(-1) + 16*S**(-1)*MS2
     +     - 16*S**(-1)*MG2*MT2*U**(-1) - 32*S**(-1)*MG2 - 16*S**(-1)*
     +    MT2 + 8*S*TG**(-1)*MS2*U**(-1) - 8*S*TG**(-1)*MT2*U**(-1) + 
     +    32*S*UG**(-3)*MS2*MG2**2*U**(-1) - 32*S*UG**(-3)*MG2**2*MT2*
     +    U**(-1) + 16*S*UG**(-2)*MS2*MG2*U**(-1) + 32*S*UG**(-2)*MS2
     +     - 16*S*UG**(-2)*MG2*MT2*U**(-1) - 16*S*UG**(-2)*MG2 - 32*S*
     +    UG**(-2)*MT2 - 16*S*UG**(-1)*MS2*U**(-1) + 16*S*UG**(-1)*MT2*
     +    U**(-1) - 16*S*UG**(-1) - 24*TG**(-1)*MS2*MG2*U**(-1) + 8*
     +    TG**(-1)*MS2 + 24*TG**(-1)*MG2*MT2*U**(-1) - 16*TG**(-1)*MG2
     +     - 8*TG**(-1)*MT2 + 256*UG**(-3)*MS2*MG2**2 - 128*UG**(-3)*
     +    MS2*MG2**3*U**(-1) - 256*UG**(-3)*MG2**2*MT2 + 128*UG**(-3)*
     +    MG2**3*MT2*U**(-1) - 128*UG**(-3)*MG2**3 + 192*UG**(-2)*MS2*
     +    MG2 - 144*UG**(-2)*MS2*MG2**2*U**(-1) - 192*UG**(-2)*MG2*MT2
     +     + 144*UG**(-2)*MG2**2*MT2*U**(-1) )
     +
      M2GGSV = M2GGSV + SK1B0D(4,2)*N*CO * (  - 192*UG**(-2)*MG2**2 - 
     +    56*UG**(-1)*MS2*MG2*U**(-1) + 80*UG**(-1)*MS2 + 56*UG**(-1)*
     +    MG2*MT2*U**(-1) - 104*UG**(-1)*MG2 - 80*UG**(-1)*MT2 - 24*MS2
     +    *U**(-1) + 24*MT2*U**(-1) )
     +
      M2GGSV = M2GGSV + SK1BP(1)*N**2*CO * (  - 128*S**(-2)*TG**2*MG2
     +     + 256*S**(-1)*TG**(-1)*MG2**3 - 128*S**(-1)*TG*MG2 + 256*
     +    S**(-1)*UG**(-1)*MG2**3 - 256*S**(-1)*MG2**2 - 64*S*TG**(-1)*
     +    MG2 - 64*S*UG**(-1)*MG2 - 256*TG**(-2)*MG2**3 - 256*TG**(-1)*
     +    MG2**2 - 256*UG**(-2)*MG2**3 - 256*UG**(-1)*MG2**2 - 192*MG2
     +     )
     +
      M2GGSV = M2GGSV + SK1BP(2)*N*CO * (  - 64*S**(-2)*TG**2*NS*MS2 + 
     +    64*S**(-2)*TG**2*NS*MG2 + 64*S**(-2)*TG**2*MS2 - 64*S**(-2)*
     +    TG**2*MG2 + 128*S**(-1)*TG**(-1)*NS*MS2*MG2**2 - 128*S**(-1)*
     +    TG**(-1)*NS*MG2**3 - 128*S**(-1)*TG**(-1)*MS2*MG2**2 + 128*
     +    S**(-1)*TG**(-1)*MG2**3 - 64*S**(-1)*TG*NS*MS2 + 64*S**(-1)*
     +    TG*NS*MG2 + 64*S**(-1)*TG*MS2 - 64*S**(-1)*TG*MG2 + 128*
     +    S**(-1)*UG**(-1)*NS*MS2*MG2**2 - 128*S**(-1)*UG**(-1)*NS*
     +    MG2**3 - 128*S**(-1)*UG**(-1)*MS2*MG2**2 + 128*S**(-1)*
     +    UG**(-1)*MG2**3 - 128*S**(-1)*NS*MS2*MG2 + 128*S**(-1)*NS*
     +    MG2**2 + 128*S**(-1)*MS2*MG2 - 128*S**(-1)*MG2**2 - 32*S*
     +    TG**(-1)*NS*MS2 + 32*S*TG**(-1)*NS*MG2 + 32*S*TG**(-1)*MS2 - 
     +    32*S*TG**(-1)*MG2 - 32*S*UG**(-1)*NS*MS2 + 32*S*UG**(-1)*NS*
     +    MG2 + 32*S*UG**(-1)*MS2 - 32*S*UG**(-1)*MG2 - 128*TG**(-2)*NS
     +    *MS2*MG2**2 + 128*TG**(-2)*NS*MG2**3 + 128*TG**(-2)*MS2*
     +    MG2**2 - 128*TG**(-2)*MG2**3 - 128*TG**(-1)*NS*MS2*MG2 + 128*
     +    TG**(-1)*NS*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1BP(2)*N*CO * ( 128*TG**(-1)*MS2*MG2 - 128*
     +    TG**(-1)*MG2**2 - 128*UG**(-2)*NS*MS2*MG2**2 + 128*UG**(-2)*
     +    NS*MG2**3 + 128*UG**(-2)*MS2*MG2**2 - 128*UG**(-2)*MG2**3 - 
     +    128*UG**(-1)*NS*MS2*MG2 + 128*UG**(-1)*NS*MG2**2 + 128*
     +    UG**(-1)*MS2*MG2 - 128*UG**(-1)*MG2**2 - 96*NS*MS2 + 96*NS*
     +    MG2 + 96*MS2 - 96*MG2 )
     +
      M2GGSV = M2GGSV + SK1BP(5)*N*CO * (  - 64*S**(-2)*TG**2*MS2 + 64*
     +    S**(-2)*TG**2*MG2 + 64*S**(-2)*TG**2*MT2 + 128*S**(-1)*
     +    TG**(-1)*MS2*MG2**2 - 128*S**(-1)*TG**(-1)*MG2**2*MT2 - 128*
     +    S**(-1)*TG**(-1)*MG2**3 - 64*S**(-1)*TG*MS2 + 64*S**(-1)*TG*
     +    MG2 + 64*S**(-1)*TG*MT2 + 128*S**(-1)*UG**(-1)*MS2*MG2**2 - 
     +    128*S**(-1)*UG**(-1)*MG2**2*MT2 - 128*S**(-1)*UG**(-1)*MG2**3
     +     - 128*S**(-1)*MS2*MG2 + 128*S**(-1)*MG2*MT2 + 128*S**(-1)*
     +    MG2**2 - 32*S*TG**(-1)*MS2 + 32*S*TG**(-1)*MG2 + 32*S*
     +    TG**(-1)*MT2 - 32*S*UG**(-1)*MS2 + 32*S*UG**(-1)*MG2 + 32*S*
     +    UG**(-1)*MT2 - 128*TG**(-2)*MS2*MG2**2 + 128*TG**(-2)*MG2**2*
     +    MT2 + 128*TG**(-2)*MG2**3 - 128*TG**(-1)*MS2*MG2 + 128*
     +    TG**(-1)*MG2*MT2 + 128*TG**(-1)*MG2**2 - 128*UG**(-2)*MS2*
     +    MG2**2 + 128*UG**(-2)*MG2**2*MT2 + 128*UG**(-2)*MG2**3 - 128*
     +    UG**(-1)*MS2*MG2 + 128*UG**(-1)*MG2*MT2 + 128*UG**(-1)*MG2**2
     +     - 96*MS2 + 96*MG2 + 96*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0A(1)*N*CO * (  - 4*S*TG**(-1)*NS*MG2 + 4*S
     +    *TG**(-1)*MG2 - 4*S*UG**(-1)*NS*MG2 + 4*S*UG**(-1)*MG2 + 4*S*
     +    NS - 4*S + 16*TG**(-1)*NS*MS2*MG2 - 8*TG**(-1)*NS*MS2**2 - 8*
     +    TG**(-1)*NS*MG2**2 - 16*TG**(-1)*MS2*MG2 + 8*TG**(-1)*MS2**2
     +     + 8*TG**(-1)*MG2**2 + 16*UG**(-1)*NS*MS2*MG2 - 8*UG**(-1)*NS
     +    *MS2**2 - 8*UG**(-1)*NS*MG2**2 - 16*UG**(-1)*MS2*MG2 + 8*
     +    UG**(-1)*MS2**2 + 8*UG**(-1)*MG2**2 + 16*NS*MS2 - 16*NS*MG2
     +     - 16*MS2 + 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0A(1)*N**2*CO * ( 16*S*TG**(-1)*MG2 + 16*S*
     +    UG**(-1)*MG2 + 8*S + 4*S**2*TG**(-1) + 4*S**2*UG**(-1) + 32*
     +    MG2 )
     +
      M2GGSV = M2GGSV + SK1C0A(2)*N**2*CO * (  - 64*S**(-1)*MG2**2 + 8*
     +    S*TG**(-1)*MG2 + 8*S*UG**(-1)*MG2 + 4*S - 4*S**2*TG**(-1) - 4
     +    *S**2*UG**(-1) + 32*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0A(3)*N*CO * ( 64*S**(-1)*NS*MS2*MG2 - 4*S*
     +    TG**(-1)*NS*MG2 + 4*S*TG**(-1)*MT2 - 4*S*UG**(-1)*NS*MG2 + 4*
     +    S*UG**(-1)*MT2 - 8*S*NS + 32*TG**(-1)*NS*MS2*MG2 + 8*TG**(-1)
     +    *NS*MS2**2 - 8*TG**(-1)*NS*MG2**2 - 16*TG**(-1)*MS2*MT2 + 8*
     +    TG**(-1)*MT2**2 + 32*UG**(-1)*NS*MS2*MG2 + 8*UG**(-1)*NS*
     +    MS2**2 - 8*UG**(-1)*NS*MG2**2 - 16*UG**(-1)*MS2*MT2 + 8*
     +    UG**(-1)*MT2**2 + 16*NS*MS2 - 16*NS*MG2 - 16*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0A(4)*N*CO * (  - 64*S**(-1)*MG2*MT2 - 4*S*
     +    TG**(-1)*MG2 - 4*S*TG**(-1)*MT2 - 4*S*UG**(-1)*MG2 - 4*S*
     +    UG**(-1)*MT2 + 4*S + 16*TG**(-1)*MS2*MG2 + 16*TG**(-1)*MS2*
     +    MT2 - 8*TG**(-1)*MS2**2 - 48*TG**(-1)*MG2*MT2 - 8*TG**(-1)*
     +    MG2**2 - 8*TG**(-1)*MT2**2 + 16*UG**(-1)*MS2*MG2 + 16*
     +    UG**(-1)*MS2*MT2 - 8*UG**(-1)*MS2**2 - 48*UG**(-1)*MG2*MT2 - 
     +    8*UG**(-1)*MG2**2 - 8*UG**(-1)*MT2**2 + 16*MS2 - 16*MG2 - 16*
     +    MT2 )
     +
      M2GGSV = M2GGSV + SK1C0B(1)*N**2*CO * (  - 64*S**(-2)*TG**2*MG2
     +     - 64*S**(-1)*TG*MG2 + 32*S**(-1)*TG**2 - 192*S**(-1)*MG2**2
     +     + 8*S*TG**(-1)*MG2 + 8*S*UG**(-1)*MG2 + 36*S + 4*S**2*
     +    TG**(-1) + 4*S**2*UG**(-1) - 32*TG**(-1)*MG2**2 + 32*TG - 32*
     +    UG**(-1)*MG2**2 - 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(2)*N*CO * (  - 16*S**(-2)*TG**2*NS*
     +    MS2**2*MG2**(-1) + 16*S**(-2)*TG**2*NS*MG2 + 16*S**(-2)*TG**2
     +    *MS2**2*MG2**(-1) - 16*S**(-2)*TG**2*MG2 - 16*S**(-1)*TG*NS*
     +    MS2**2*MG2**(-1) + 16*S**(-1)*TG*NS*MG2 + 16*S**(-1)*TG*
     +    MS2**2*MG2**(-1) - 16*S**(-1)*TG*MG2 + 12*S**(-1)*TG**2*NS*
     +    MS2*MG2**(-1) - 10*S**(-1)*TG**2*NS*MS2**2*MG2**(-2) - 2*
     +    S**(-1)*TG**2*NS - 12*S**(-1)*TG**2*MS2*MG2**(-1) + 10*
     +    S**(-1)*TG**2*MS2**2*MG2**(-2) + 2*S**(-1)*TG**2 - 48*S**(-1)
     +    *NS*MS2**2 + 48*S**(-1)*NS*MG2**2 + 48*S**(-1)*MS2**2 - 48*
     +    S**(-1)*MG2**2 - 4*S*TG**(-1)*NS*MG2 + 4*S*TG**(-1)*MG2 - 4*S
     +    *UG**(-1)*NS*MG2 + 4*S*UG**(-1)*MG2 - 8*S*NS + 8*S + 192*
     +    TG**(-1)*S1**(-2)*NS*MS2*MG2**3 - 96*TG**(-1)*S1**(-2)*NS*
     +    MS2**2*MG2**2 - 96*TG**(-1)*S1**(-2)*NS*MG2**4 - 192*TG**(-1)
     +    *S1**(-2)*MS2*MG2**3 + 96*TG**(-1)*S1**(-2)*MS2**2*MG2**2 + 
     +    96*TG**(-1)*S1**(-2)*MG2**4 - 80*TG**(-1)*S1**(-1)*NS*MS2*
     +    MG2**2 )
     +
      M2GGSV = M2GGSV + SK1C0B(2)*N*CO * ( 8*TG**(-1)*S1**(-1)*NS*
     +    MS2**2*MG2 + 72*TG**(-1)*S1**(-1)*NS*MG2**3 + 80*TG**(-1)*
     +    S1**(-1)*MS2*MG2**2 - 8*TG**(-1)*S1**(-1)*MS2**2*MG2 - 72*
     +    TG**(-1)*S1**(-1)*MG2**3 + 16*TG**(-1)*NS*MS2*MG2 - 8*
     +    TG**(-1)*NS*MS2**2 - 8*TG**(-1)*NS*MG2**2 - 16*TG**(-1)*MS2*
     +    MG2 + 8*TG**(-1)*MS2**2 + 8*TG**(-1)*MG2**2 + 192*TG*S1**(-2)
     +    *NS*MS2*MG2 - 96*TG*S1**(-2)*NS*MS2**2 - 96*TG*S1**(-2)*NS*
     +    MG2**2 - 192*TG*S1**(-2)*MS2*MG2 + 96*TG*S1**(-2)*MS2**2 + 96
     +    *TG*S1**(-2)*MG2**2 - 16*TG*S1**(-1)*NS*MS2**2*MG2**(-1) + 16
     +    *TG*S1**(-1)*NS*MG2 + 16*TG*S1**(-1)*MS2**2*MG2**(-1) - 16*TG
     +    *S1**(-1)*MG2 + 48*TG**2*S1**(-2)*NS*MS2 - 24*TG**2*S1**(-2)*
     +    NS*MS2**2*MG2**(-1) - 24*TG**2*S1**(-2)*NS*MG2 - 48*TG**2*
     +    S1**(-2)*MS2 + 24*TG**2*S1**(-2)*MS2**2*MG2**(-1) + 24*TG**2*
     +    S1**(-2)*MG2 + 12*TG**2*S1**(-1)*NS*MS2*MG2**(-1) - 10*TG**2*
     +    S1**(-1)*NS*MS2**2*MG2**(-2) - 2*TG**2*S1**(-1)*NS - 12*TG**2
     +    *S1**(-1)*MS2*MG2**(-1) )
     +
      M2GGSV = M2GGSV + SK1C0B(2)*N*CO * ( 10*TG**2*S1**(-1)*MS2**2*
     +    MG2**(-2) + 2*TG**2*S1**(-1) + 192*UG**(-1)*S1**(-2)*NS*MS2*
     +    MG2**3 - 96*UG**(-1)*S1**(-2)*NS*MS2**2*MG2**2 - 96*UG**(-1)*
     +    S1**(-2)*NS*MG2**4 - 192*UG**(-1)*S1**(-2)*MS2*MG2**3 + 96*
     +    UG**(-1)*S1**(-2)*MS2**2*MG2**2 + 96*UG**(-1)*S1**(-2)*MG2**4
     +     - 80*UG**(-1)*S1**(-1)*NS*MS2*MG2**2 + 8*UG**(-1)*S1**(-1)*
     +    NS*MS2**2*MG2 + 72*UG**(-1)*S1**(-1)*NS*MG2**3 + 80*UG**(-1)*
     +    S1**(-1)*MS2*MG2**2 - 8*UG**(-1)*S1**(-1)*MS2**2*MG2 - 72*
     +    UG**(-1)*S1**(-1)*MG2**3 + 16*UG**(-1)*NS*MS2*MG2 - 8*
     +    UG**(-1)*NS*MS2**2 - 8*UG**(-1)*NS*MG2**2 - 16*UG**(-1)*MS2*
     +    MG2 + 8*UG**(-1)*MS2**2 + 8*UG**(-1)*MG2**2 + 384*S1**(-2)*NS
     +    *MS2*MG2**2 - 192*S1**(-2)*NS*MS2**2*MG2 - 192*S1**(-2)*NS*
     +    MG2**3 - 384*S1**(-2)*MS2*MG2**2 + 192*S1**(-2)*MS2**2*MG2 + 
     +    192*S1**(-2)*MG2**3 - 80*S1**(-1)*NS*MS2*MG2 - 8*S1**(-1)*NS*
     +    MS2**2 + 88*S1**(-1)*NS*MG2**2 + 80*S1**(-1)*MS2*MG2 + 8*
     +    S1**(-1)*MS2**2 )
     +
      M2GGSV = M2GGSV + SK1C0B(2)*N*CO * (  - 88*S1**(-1)*MG2**2 + 16*
     +    NS*MS2 - 16*MS2 )
     +
      M2GGSV = M2GGSV + SK1C0B(3)*N**2*CO * (  - 48*S**(-1)*TG**2 - 8*S
     +    *TG**(-1)*MG2 - 8*S*UG**(-1)*MG2 - 32*S*S1**(-1)*MG2 - 24*S
     +     - 4*S**2*TG**(-1) - 4*S**2*UG**(-1) - 384*TG**(-1)*S1**(-2)*
     +    MG2**4 + 192*TG**(-1)*S1**(-1)*MG2**3 - 8*TG**(-1)*MG2**2 - 
     +    384*TG*S1**(-2)*MG2**2 + 32*TG*S1**(-1)*MG2 - 32*TG - 96*
     +    TG**2*S1**(-2)*MG2 - 16*TG**2*S1**(-1) - 384*UG**(-1)*
     +    S1**(-2)*MG2**4 + 192*UG**(-1)*S1**(-1)*MG2**3 - 8*UG**(-1)*
     +    MG2**2 - 768*S1**(-2)*MG2**3 + 352*S1**(-1)*MG2**2 - 72*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(4)*N*CO * (  - 32*S**(-2)*TG**2*NS*MS2
     +     + 16*S**(-2)*TG**2*NS*MS2**2*MG2**(-1) + 16*S**(-2)*TG**2*NS
     +    *MG2 + 32*S**(-2)*TG**2*MS2 - 16*S**(-2)*TG**2*MS2**2*
     +    MG2**(-1) - 16*S**(-2)*TG**2*MG2 - 32*S**(-1)*TG*NS*MS2 + 16*
     +    S**(-1)*TG*NS*MS2**2*MG2**(-1) + 16*S**(-1)*TG*NS*MG2 + 32*
     +    S**(-1)*TG*MS2 - 16*S**(-1)*TG*MS2**2*MG2**(-1) - 16*S**(-1)*
     +    TG*MG2 + 4*S**(-1)*TG**2*NS*MS2*MG2**(-1) + 10*S**(-1)*TG**2*
     +    NS*MS2**2*MG2**(-2) + 2*S**(-1)*TG**2*NS - 4*S**(-1)*TG**2*
     +    MS2*MG2**(-1) - 10*S**(-1)*TG**2*MS2**2*MG2**(-2) - 2*S**(-1)
     +    *TG**2 - 96*S**(-1)*NS*MS2*MG2 + 48*S**(-1)*NS*MS2**2 + 48*
     +    S**(-1)*NS*MG2**2 + 96*S**(-1)*MS2*MG2 - 48*S**(-1)*MS2**2 - 
     +    48*S**(-1)*MG2**2 + 4*S*TG**(-1)*NS*MG2 - 4*S*TG**(-1)*MG2 + 
     +    4*S*UG**(-1)*NS*MG2 - 4*S*UG**(-1)*MG2 + 8*S*S1**(-1)*NS*MS2
     +     + 8*S*S1**(-1)*NS*MG2 - 8*S*S1**(-1)*MS2 - 8*S*S1**(-1)*MG2
     +     + 4*S*NS - 4*S + 192*TG**(-1)*S1**(-2)*NS*MS2*MG2**3 + 96*
     +    TG**(-1)*S1**(-2)*NS*MS2**2*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1C0B(4)*N*CO * ( 96*TG**(-1)*S1**(-2)*NS*
     +    MG2**4 - 192*TG**(-1)*S1**(-2)*MS2*MG2**3 - 96*TG**(-1)*
     +    S1**(-2)*MS2**2*MG2**2 - 96*TG**(-1)*S1**(-2)*MG2**4 - 112*
     +    TG**(-1)*S1**(-1)*NS*MS2*MG2**2 - 8*TG**(-1)*S1**(-1)*NS*
     +    MS2**2*MG2 - 72*TG**(-1)*S1**(-1)*NS*MG2**3 + 112*TG**(-1)*
     +    S1**(-1)*MS2*MG2**2 + 8*TG**(-1)*S1**(-1)*MS2**2*MG2 + 72*
     +    TG**(-1)*S1**(-1)*MG2**3 + 8*TG**(-1)*NS*MS2**2 + 16*TG**(-1)
     +    *NS*MG2**2 - 8*TG**(-1)*MS2**2 - 16*TG**(-1)*MG2**2 + 192*TG*
     +    S1**(-2)*NS*MS2*MG2 + 96*TG*S1**(-2)*NS*MS2**2 + 96*TG*
     +    S1**(-2)*NS*MG2**2 - 192*TG*S1**(-2)*MS2*MG2 - 96*TG*S1**(-2)
     +    *MS2**2 - 96*TG*S1**(-2)*MG2**2 - 32*TG*S1**(-1)*NS*MS2 + 16*
     +    TG*S1**(-1)*NS*MS2**2*MG2**(-1) - 16*TG*S1**(-1)*NS*MG2 + 32*
     +    TG*S1**(-1)*MS2 - 16*TG*S1**(-1)*MS2**2*MG2**(-1) + 16*TG*
     +    S1**(-1)*MG2 + 48*TG**2*S1**(-2)*NS*MS2 + 24*TG**2*S1**(-2)*
     +    NS*MS2**2*MG2**(-1) + 24*TG**2*S1**(-2)*NS*MG2 - 48*TG**2*
     +    S1**(-2)*MS2 )
     +
      M2GGSV = M2GGSV + SK1C0B(4)*N*CO * (  - 24*TG**2*S1**(-2)*MS2**2*
     +    MG2**(-1) - 24*TG**2*S1**(-2)*MG2 + 4*TG**2*S1**(-1)*NS*MS2*
     +    MG2**(-1) + 10*TG**2*S1**(-1)*NS*MS2**2*MG2**(-2) + 2*TG**2*
     +    S1**(-1)*NS - 4*TG**2*S1**(-1)*MS2*MG2**(-1) - 10*TG**2*
     +    S1**(-1)*MS2**2*MG2**(-2) - 2*TG**2*S1**(-1) + 192*UG**(-1)*
     +    S1**(-2)*NS*MS2*MG2**3 + 96*UG**(-1)*S1**(-2)*NS*MS2**2*
     +    MG2**2 + 96*UG**(-1)*S1**(-2)*NS*MG2**4 - 192*UG**(-1)*
     +    S1**(-2)*MS2*MG2**3 - 96*UG**(-1)*S1**(-2)*MS2**2*MG2**2 - 96
     +    *UG**(-1)*S1**(-2)*MG2**4 - 112*UG**(-1)*S1**(-1)*NS*MS2*
     +    MG2**2 - 8*UG**(-1)*S1**(-1)*NS*MS2**2*MG2 - 72*UG**(-1)*
     +    S1**(-1)*NS*MG2**3 + 112*UG**(-1)*S1**(-1)*MS2*MG2**2 + 8*
     +    UG**(-1)*S1**(-1)*MS2**2*MG2 + 72*UG**(-1)*S1**(-1)*MG2**3 + 
     +    8*UG**(-1)*NS*MS2**2 + 16*UG**(-1)*NS*MG2**2 - 8*UG**(-1)*
     +    MS2**2 - 16*UG**(-1)*MG2**2 + 384*S1**(-2)*NS*MS2*MG2**2 + 
     +    192*S1**(-2)*NS*MS2**2*MG2 + 192*S1**(-2)*NS*MG2**3 - 384*
     +    S1**(-2)*MS2*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1C0B(4)*N*CO * (  - 192*S1**(-2)*MS2**2*MG2
     +     - 192*S1**(-2)*MG2**3 - 176*S1**(-1)*NS*MS2*MG2 + 8*S1**(-1)
     +    *NS*MS2**2 - 120*S1**(-1)*NS*MG2**2 + 176*S1**(-1)*MS2*MG2 - 
     +    8*S1**(-1)*MS2**2 + 120*S1**(-1)*MG2**2 + 24*NS*MS2 + 16*NS*
     +    MG2 - 24*MS2 - 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(5)*N*CO * (  - 32*S**(-2)*TG**2*MS2*
     +    MG2**(-1)*MT2 - 32*S**(-2)*TG**2*MS2 + 16*S**(-2)*TG**2*
     +    MS2**2*MG2**(-1) + 16*S**(-2)*TG**2*MG2**(-1)*MT2**2 + 16*
     +    S**(-2)*TG**2*MG2 + 32*S**(-2)*TG**2*MT2 - 32*S**(-1)*TG*MS2*
     +    MG2**(-1)*MT2 - 32*S**(-1)*TG*MS2 + 16*S**(-1)*TG*MS2**2*
     +    MG2**(-1) + 16*S**(-1)*TG*MG2**(-1)*MT2**2 + 16*S**(-1)*TG*
     +    MG2 + 32*S**(-1)*TG*MT2 - 20*S**(-1)*TG**2*MS2*MG2**(-2)*MT2
     +     + 4*S**(-1)*TG**2*MS2*MG2**(-1) + 10*S**(-1)*TG**2*MS2**2*
     +    MG2**(-2) + 10*S**(-1)*TG**2*MG2**(-2)*MT2**2 - 12*S**(-1)*
     +    TG**2*MG2**(-1)*MT2 + 2*S**(-1)*TG**2 - 96*S**(-1)*MS2*MG2 - 
     +    96*S**(-1)*MS2*MT2 + 48*S**(-1)*MS2**2 + 96*S**(-1)*MG2*MT2
     +     + 48*S**(-1)*MG2**2 + 48*S**(-1)*MT2**2 + 4*S*TG**(-1)*MG2
     +     + 4*S*TG**(-1)*MT2 + 4*S*UG**(-1)*MG2 + 4*S*UG**(-1)*MT2 + 8
     +    *S*S1**(-1)*MS2 + 8*S*S1**(-1)*MG2 - 8*S*S1**(-1)*MT2 + 4*S
     +     - 192*TG**(-1)*S1**(-2)*MS2*MG2**2*MT2 + 192*TG**(-1)*
     +    S1**(-2)*MS2*MG2**3 )
     +
      M2GGSV = M2GGSV + SK1C0B(5)*N*CO * ( 96*TG**(-1)*S1**(-2)*MS2**2*
     +    MG2**2 + 96*TG**(-1)*S1**(-2)*MG2**2*MT2**2 - 192*TG**(-1)*
     +    S1**(-2)*MG2**3*MT2 + 96*TG**(-1)*S1**(-2)*MG2**4 + 16*
     +    TG**(-1)*S1**(-1)*MS2*MG2*MT2 - 112*TG**(-1)*S1**(-1)*MS2*
     +    MG2**2 - 8*TG**(-1)*S1**(-1)*MS2**2*MG2 - 8*TG**(-1)*S1**(-1)
     +    *MG2*MT2**2 + 80*TG**(-1)*S1**(-1)*MG2**2*MT2 - 72*TG**(-1)*
     +    S1**(-1)*MG2**3 - 16*TG**(-1)*MS2*MT2 + 8*TG**(-1)*MS2**2 + 8
     +    *TG**(-1)*MG2*MT2 + 16*TG**(-1)*MG2**2 + 8*TG**(-1)*MT2**2 + 
     +    192*TG*S1**(-2)*MS2*MG2 - 192*TG*S1**(-2)*MS2*MT2 + 96*TG*
     +    S1**(-2)*MS2**2 - 192*TG*S1**(-2)*MG2*MT2 + 96*TG*S1**(-2)*
     +    MG2**2 + 96*TG*S1**(-2)*MT2**2 - 32*TG*S1**(-1)*MS2*MG2**(-1)
     +    *MT2 - 32*TG*S1**(-1)*MS2 + 16*TG*S1**(-1)*MS2**2*MG2**(-1)
     +     + 16*TG*S1**(-1)*MG2**(-1)*MT2**2 - 16*TG*S1**(-1)*MG2 - 48*
     +    TG**2*S1**(-2)*MS2*MG2**(-1)*MT2 + 48*TG**2*S1**(-2)*MS2 + 24
     +    *TG**2*S1**(-2)*MS2**2*MG2**(-1) + 24*TG**2*S1**(-2)*
     +    MG2**(-1)*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1C0B(5)*N*CO * ( 24*TG**2*S1**(-2)*MG2 - 48*
     +    TG**2*S1**(-2)*MT2 - 20*TG**2*S1**(-1)*MS2*MG2**(-2)*MT2 + 4*
     +    TG**2*S1**(-1)*MS2*MG2**(-1) + 10*TG**2*S1**(-1)*MS2**2*
     +    MG2**(-2) + 10*TG**2*S1**(-1)*MG2**(-2)*MT2**2 - 12*TG**2*
     +    S1**(-1)*MG2**(-1)*MT2 + 2*TG**2*S1**(-1) - 192*UG**(-1)*
     +    S1**(-2)*MS2*MG2**2*MT2 + 192*UG**(-1)*S1**(-2)*MS2*MG2**3 + 
     +    96*UG**(-1)*S1**(-2)*MS2**2*MG2**2 + 96*UG**(-1)*S1**(-2)*
     +    MG2**2*MT2**2 - 192*UG**(-1)*S1**(-2)*MG2**3*MT2 + 96*
     +    UG**(-1)*S1**(-2)*MG2**4 + 16*UG**(-1)*S1**(-1)*MS2*MG2*MT2
     +     - 112*UG**(-1)*S1**(-1)*MS2*MG2**2 - 8*UG**(-1)*S1**(-1)*
     +    MS2**2*MG2 - 8*UG**(-1)*S1**(-1)*MG2*MT2**2 + 80*UG**(-1)*
     +    S1**(-1)*MG2**2*MT2 - 72*UG**(-1)*S1**(-1)*MG2**3 - 16*
     +    UG**(-1)*MS2*MT2 + 8*UG**(-1)*MS2**2 + 8*UG**(-1)*MG2*MT2 + 
     +    16*UG**(-1)*MG2**2 + 8*UG**(-1)*MT2**2 - 384*S1**(-2)*MS2*MG2
     +    *MT2 + 384*S1**(-2)*MS2*MG2**2 + 192*S1**(-2)*MS2**2*MG2 + 
     +    192*S1**(-2)*MG2*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1C0B(5)*N*CO * (  - 384*S1**(-2)*MG2**2*MT2
     +     + 192*S1**(-2)*MG2**3 - 176*S1**(-1)*MS2*MG2 - 16*S1**(-1)*
     +    MS2*MT2 + 8*S1**(-1)*MS2**2 + 112*S1**(-1)*MG2*MT2 - 120*
     +    S1**(-1)*MG2**2 + 8*S1**(-1)*MT2**2 + 24*MS2 + 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0B(6)*N*CO * ( 32*S**(-2)*TG**2*MS2*
     +    MG2**(-1)*MT2 - 16*S**(-2)*TG**2*MS2**2*MG2**(-1) - 16*
     +    S**(-2)*TG**2*MG2**(-1)*MT2**2 + 16*S**(-2)*TG**2*MG2 + 32*
     +    S**(-1)*TG*MS2*MG2**(-1)*MT2 - 16*S**(-1)*TG*MS2**2*MG2**(-1)
     +     - 16*S**(-1)*TG*MG2**(-1)*MT2**2 + 16*S**(-1)*TG*MG2 + 20*
     +    S**(-1)*TG**2*MS2*MG2**(-2)*MT2 + 12*S**(-1)*TG**2*MS2*
     +    MG2**(-1) - 10*S**(-1)*TG**2*MS2**2*MG2**(-2) - 10*S**(-1)*
     +    TG**2*MG2**(-2)*MT2**2 - 4*S**(-1)*TG**2*MG2**(-1)*MT2 - 2*
     +    S**(-1)*TG**2 + 96*S**(-1)*MS2*MT2 - 48*S**(-1)*MS2**2 + 48*
     +    S**(-1)*MG2**2 - 48*S**(-1)*MT2**2 - 4*S*TG**(-1)*MG2 - 4*S*
     +    TG**(-1)*MT2 - 4*S*UG**(-1)*MG2 - 4*S*UG**(-1)*MT2 - 8*S + 
     +    192*TG**(-1)*S1**(-2)*MS2*MG2**2*MT2 + 192*TG**(-1)*S1**(-2)*
     +    MS2*MG2**3 - 96*TG**(-1)*S1**(-2)*MS2**2*MG2**2 - 96*TG**(-1)
     +    *S1**(-2)*MG2**2*MT2**2 - 192*TG**(-1)*S1**(-2)*MG2**3*MT2 - 
     +    96*TG**(-1)*S1**(-2)*MG2**4 - 16*TG**(-1)*S1**(-1)*MS2*MG2*
     +    MT2 )
     +
      M2GGSV = M2GGSV + SK1C0B(6)*N*CO * (  - 80*TG**(-1)*S1**(-1)*MS2*
     +    MG2**2 + 8*TG**(-1)*S1**(-1)*MS2**2*MG2 + 8*TG**(-1)*S1**(-1)
     +    *MG2*MT2**2 + 112*TG**(-1)*S1**(-1)*MG2**2*MT2 + 72*TG**(-1)*
     +    S1**(-1)*MG2**3 + 16*TG**(-1)*MS2*MG2 + 16*TG**(-1)*MS2*MT2
     +     - 8*TG**(-1)*MS2**2 - 24*TG**(-1)*MG2*MT2 - 8*TG**(-1)*
     +    MG2**2 - 8*TG**(-1)*MT2**2 + 192*TG*S1**(-2)*MS2*MG2 + 192*TG
     +    *S1**(-2)*MS2*MT2 - 96*TG*S1**(-2)*MS2**2 - 192*TG*S1**(-2)*
     +    MG2*MT2 - 96*TG*S1**(-2)*MG2**2 - 96*TG*S1**(-2)*MT2**2 + 32*
     +    TG*S1**(-1)*MS2*MG2**(-1)*MT2 - 16*TG*S1**(-1)*MS2**2*
     +    MG2**(-1) - 16*TG*S1**(-1)*MG2**(-1)*MT2**2 + 16*TG*S1**(-1)*
     +    MG2 + 32*TG*S1**(-1)*MT2 + 48*TG**2*S1**(-2)*MS2*MG2**(-1)*
     +    MT2 + 48*TG**2*S1**(-2)*MS2 - 24*TG**2*S1**(-2)*MS2**2*
     +    MG2**(-1) - 24*TG**2*S1**(-2)*MG2**(-1)*MT2**2 - 24*TG**2*
     +    S1**(-2)*MG2 - 48*TG**2*S1**(-2)*MT2 + 20*TG**2*S1**(-1)*MS2*
     +    MG2**(-2)*MT2 + 12*TG**2*S1**(-1)*MS2*MG2**(-1) - 10*TG**2*
     +    S1**(-1)*MS2**2*MG2**(-2) )
     +
      M2GGSV = M2GGSV + SK1C0B(6)*N*CO * (  - 10*TG**2*S1**(-1)*
     +    MG2**(-2)*MT2**2 - 4*TG**2*S1**(-1)*MG2**(-1)*MT2 - 2*TG**2*
     +    S1**(-1) + 192*UG**(-1)*S1**(-2)*MS2*MG2**2*MT2 + 192*
     +    UG**(-1)*S1**(-2)*MS2*MG2**3 - 96*UG**(-1)*S1**(-2)*MS2**2*
     +    MG2**2 - 96*UG**(-1)*S1**(-2)*MG2**2*MT2**2 - 192*UG**(-1)*
     +    S1**(-2)*MG2**3*MT2 - 96*UG**(-1)*S1**(-2)*MG2**4 - 16*
     +    UG**(-1)*S1**(-1)*MS2*MG2*MT2 - 80*UG**(-1)*S1**(-1)*MS2*
     +    MG2**2 + 8*UG**(-1)*S1**(-1)*MS2**2*MG2 + 8*UG**(-1)*S1**(-1)
     +    *MG2*MT2**2 + 112*UG**(-1)*S1**(-1)*MG2**2*MT2 + 72*UG**(-1)*
     +    S1**(-1)*MG2**3 + 16*UG**(-1)*MS2*MG2 + 16*UG**(-1)*MS2*MT2
     +     - 8*UG**(-1)*MS2**2 - 24*UG**(-1)*MG2*MT2 - 8*UG**(-1)*
     +    MG2**2 - 8*UG**(-1)*MT2**2 + 384*S1**(-2)*MS2*MG2*MT2 + 384*
     +    S1**(-2)*MS2*MG2**2 - 192*S1**(-2)*MS2**2*MG2 - 192*S1**(-2)*
     +    MG2*MT2**2 - 384*S1**(-2)*MG2**2*MT2 - 192*S1**(-2)*MG2**3 - 
     +    80*S1**(-1)*MS2*MG2 + 16*S1**(-1)*MS2*MT2 - 8*S1**(-1)*MS2**2
     +     + 144*S1**(-1)*MG2*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0B(6)*N*CO * ( 88*S1**(-1)*MG2**2 - 8*
     +    S1**(-1)*MT2**2 + 16*MS2 - 40*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0C(1,1)*N**2*CO * ( 32*S**(-1)*TG*MG2 - 8*
     +    S**(-1)*TG**2 + 64*S**(-1)*MG2**2 - 32*S*TG**(-2)*MG2**2 - 16
     +    *S*UG**(-1)*MG2 - 8*S + 8*S**2*UG**(-1) + 16*TG**(-1)*MG2**2
     +     - 16*TG + 16*UG**(-1)*MG2**2 + 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(1,2)*N**2*CO * (  - 32*S**(-1)*TG*MG2 - 
     +    8*S**(-1)*TG**2 + 64*S**(-1)*MG2**2 - 16*S*TG**(-1)*MG2 - 32*
     +    S*UG**(-2)*MG2**2 + 8*S**2*TG**(-1) + 16*TG**(-1)*MG2**2 + 16
     +    *UG**(-1)*MG2**2 - 16*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(2,1)*N*CO * ( 16*S**(-1)*TG*NS*MS2 - 16*
     +    S**(-1)*TG*NS*MG2 - 16*S**(-1)*TG*MS2 + 16*S**(-1)*TG*MG2 + 
     +    16*S**(-1)*NS*MS2**2 - 16*S**(-1)*NS*MG2**2 - 16*S**(-1)*
     +    MS2**2 + 16*S**(-1)*MG2**2 + 32*S*TG**(-2)*NS*MS2*MG2 - 32*S*
     +    TG**(-2)*MS2*MG2 + 8*S*UG**(-1)*NS*MG2 - 8*S*UG**(-1)*MG2 - 
     +    16*TG**(-1)*NS*MS2*MG2 + 16*TG**(-1)*MS2*MG2 - 8*TG*NS + 8*TG
     +     + 16*UG**(-1)*NS*MS2*MG2 - 16*UG**(-1)*NS*MS2**2 - 16*
     +    UG**(-1)*NS*MG2**2 - 16*UG**(-1)*MS2*MG2 + 16*UG**(-1)*MS2**2
     +     + 16*UG**(-1)*MG2**2 - 8*NS*MG2 + 8*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(2,2)*N*CO * (  - 16*S**(-1)*TG*NS*MS2 + 
     +    16*S**(-1)*TG*NS*MG2 + 16*S**(-1)*TG*MS2 - 16*S**(-1)*TG*MG2
     +     + 16*S**(-1)*NS*MS2**2 - 16*S**(-1)*NS*MG2**2 - 16*S**(-1)*
     +    MS2**2 + 16*S**(-1)*MG2**2 + 8*S*TG**(-1)*NS*MG2 - 8*S*
     +    TG**(-1)*MG2 + 32*S*UG**(-2)*NS*MS2*MG2 - 32*S*UG**(-2)*MS2*
     +    MG2 + 8*S*NS - 8*S + 16*TG**(-1)*NS*MS2*MG2 - 16*TG**(-1)*NS*
     +    MS2**2 - 16*TG**(-1)*NS*MG2**2 - 16*TG**(-1)*MS2*MG2 + 16*
     +    TG**(-1)*MS2**2 + 16*TG**(-1)*MG2**2 + 8*TG*NS - 8*TG - 16*
     +    UG**(-1)*NS*MS2*MG2 + 16*UG**(-1)*MS2*MG2 - 16*NS*MS2 + 8*NS*
     +    MG2 + 16*MS2 - 8*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(3,1)*N**2*CO * ( 32*S**(-1)*TG*MG2 + 32*
     +    S**(-1)*TG**2 - 32*S*UG**(-1)*MG2 + 8*S - 8*S**2*UG**(-1) + 
     +    40*TG + 64*UG**(-1)*MG2**2 + 32*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(3,2)*N**2*CO * (  - 32*S**(-1)*TG*MG2 + 
     +    32*S**(-1)*TG**2 - 32*S*TG**(-1)*MG2 - 8*S**2*TG**(-1) + 64*
     +    TG**(-1)*MG2**2 + 24*TG )
     +
      M2GGSV = M2GGSV + SK1C0C(4,1)*N*CO * ( 16*S**(-1)*TG*NS*MS2 - 16*
     +    S**(-1)*TG*NS*MG2 - 16*S**(-1)*TG*MS2 + 16*S**(-1)*TG*MG2 - 8
     +    *S**(-1)*TG**2*NS + 8*S**(-1)*TG**2 + 32*S**(-1)*NS*MS2*MG2
     +     - 16*S**(-1)*NS*MS2**2 - 16*S**(-1)*NS*MG2**2 - 32*S**(-1)*
     +    MS2*MG2 + 16*S**(-1)*MS2**2 + 16*S**(-1)*MG2**2 + 8*S*
     +    UG**(-1)*NS*MG2 - 8*S*UG**(-1)*MG2 + 16*UG**(-1)*NS*MS2**2 - 
     +    16*UG**(-1)*NS*MG2**2 - 16*UG**(-1)*MS2**2 + 16*UG**(-1)*
     +    MG2**2 - 8*NS*MG2 + 8*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(4,2)*N*CO * (  - 16*S**(-1)*TG*NS*MS2 + 
     +    16*S**(-1)*TG*NS*MG2 + 16*S**(-1)*TG*MS2 - 16*S**(-1)*TG*MG2
     +     - 8*S**(-1)*TG**2*NS + 8*S**(-1)*TG**2 + 32*S**(-1)*NS*MS2*
     +    MG2 - 16*S**(-1)*NS*MS2**2 - 16*S**(-1)*NS*MG2**2 - 32*
     +    S**(-1)*MS2*MG2 + 16*S**(-1)*MS2**2 + 16*S**(-1)*MG2**2 + 8*S
     +    *TG**(-1)*NS*MG2 - 8*S*TG**(-1)*MG2 - 8*S*NS + 8*S + 16*
     +    TG**(-1)*NS*MS2**2 - 16*TG**(-1)*NS*MG2**2 - 16*TG**(-1)*
     +    MS2**2 + 16*TG**(-1)*MG2**2 - 16*TG*NS + 16*TG - 16*NS*MS2 + 
     +    8*NS*MG2 + 16*MS2 - 8*MG2 )
     +
      M2GGSV = M2GGSV + SK1C0C(7,1)*N*CO * ( 16*S**(-1)*TG*MS2 - 16*
     +    S**(-1)*TG*MG2 - 16*S**(-1)*TG*MT2 - 8*S**(-1)*TG**2 + 32*
     +    S**(-1)*MS2*MG2 + 32*S**(-1)*MS2*MT2 - 16*S**(-1)*MS2**2 - 32
     +    *S**(-1)*MG2*MT2 - 16*S**(-1)*MG2**2 - 16*S**(-1)*MT2**2 - 32
     +    *S*TG**(-2)*MG2*MT2 + 8*S*UG**(-1)*MG2 + 8*S*UG**(-1)*MT2 + 
     +    16*TG**(-1)*MG2*MT2 - 32*UG**(-1)*MS2*MT2 + 16*UG**(-1)*
     +    MS2**2 + 16*UG**(-1)*MG2*MT2 - 16*UG**(-1)*MG2**2 + 16*
     +    UG**(-1)*MT2**2 - 8*MG2 - 8*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0C(7,2)*N*CO * (  - 16*S**(-1)*TG*MS2 + 16*
     +    S**(-1)*TG*MG2 + 16*S**(-1)*TG*MT2 - 8*S**(-1)*TG**2 + 32*
     +    S**(-1)*MS2*MG2 + 32*S**(-1)*MS2*MT2 - 16*S**(-1)*MS2**2 - 32
     +    *S**(-1)*MG2*MT2 - 16*S**(-1)*MG2**2 - 16*S**(-1)*MT2**2 + 8*
     +    S*TG**(-1)*MG2 + 8*S*TG**(-1)*MT2 - 32*S*UG**(-2)*MG2*MT2 - 8
     +    *S - 32*TG**(-1)*MS2*MT2 + 16*TG**(-1)*MS2**2 + 16*TG**(-1)*
     +    MG2*MT2 - 16*TG**(-1)*MG2**2 + 16*TG**(-1)*MT2**2 - 16*TG + 
     +    16*UG**(-1)*MG2*MT2 - 16*MS2 + 8*MG2 + 8*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0C(8,1)*N*CO * ( 16*S**(-1)*TG*MS2 - 16*
     +    S**(-1)*TG*MG2 - 16*S**(-1)*TG*MT2 - 32*S**(-1)*MS2*MT2 + 16*
     +    S**(-1)*MS2**2 - 16*S**(-1)*MG2**2 + 16*S**(-1)*MT2**2 + 32*S
     +    *TG**(-2)*MS2*MG2 + 8*S*UG**(-1)*MG2 - 8*S*UG**(-1)*MT2 - 16*
     +    TG**(-1)*MS2*MG2 - 8*TG + 16*UG**(-1)*MS2*MG2 + 32*UG**(-1)*
     +    MS2*MT2 - 16*UG**(-1)*MS2**2 - 32*UG**(-1)*MG2*MT2 - 16*
     +    UG**(-1)*MG2**2 - 16*UG**(-1)*MT2**2 - 8*MG2 + 8*MT2 )
     +
      M2GGSV = M2GGSV + SK1C0C(8,2)*N*CO * (  - 16*S**(-1)*TG*MS2 + 16*
     +    S**(-1)*TG*MG2 + 16*S**(-1)*TG*MT2 - 32*S**(-1)*MS2*MT2 + 16*
     +    S**(-1)*MS2**2 - 16*S**(-1)*MG2**2 + 16*S**(-1)*MT2**2 + 8*S*
     +    TG**(-1)*MG2 - 8*S*TG**(-1)*MT2 + 32*S*UG**(-2)*MS2*MG2 + 8*S
     +     + 16*TG**(-1)*MS2*MG2 + 32*TG**(-1)*MS2*MT2 - 16*TG**(-1)*
     +    MS2**2 - 32*TG**(-1)*MG2*MT2 - 16*TG**(-1)*MG2**2 - 16*
     +    TG**(-1)*MT2**2 + 8*TG - 16*UG**(-1)*MS2*MG2 - 16*MS2 + 8*MG2
     +     + 24*MT2 )
     +
      M2GGSV = M2GGSV + SK1D0(1,1)*N**2*CO * ( 16*S**(-1)*TG**3 + 32*S*
     +    TG**(-1)*MG2**2 + 12*S*TG + 16*S*MG2 + 4*S**2 + 16*TG*MG2 + 
     +    16*TG**2 )
     +
      M2GGSV = M2GGSV + SK1D0(1,2)*N**2*CO * (  - 16*S**(-1)*TG**3 - 28
     +    *S*TG + 32*S*UG**(-1)*MG2**2 - 8*S**2 - 16*TG*MG2 - 32*TG**2
     +     )
     +
      M2GGSV = M2GGSV + SK1D0(2,1)*N**2*CO * ( 32*S**(-1)*TG*MG2**2 + 
     +    32*S*TG**(-1)*MG2**2 + 8*S*MG2 + 4*S**2 - 64*TG**(-1)*MG2**3
     +     + 8*TG*MG2 + 4*TG**2 - 32*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(2,2)*N**2*CO * (  - 32*S**(-1)*TG*MG2**2
     +     + 8*S*TG + 32*S*UG**(-1)*MG2**2 + 8*S**2 - 8*TG*MG2 + 4*
     +    TG**2 - 64*UG**(-1)*MG2**3 - 64*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(3,1)*N**2*CO * (  - 64*S*TG**(-1)*MG2**2
     +     - 16*S*TG - 64*S*UG**(-1)*MG2**2 - 32*S*MG2 - 8*S**2 - 16*
     +    TG**2 - 64*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(4,1)*N*CO * (  - 4*S*TG**(-1)*NS*MS2*MG2
     +     + 4*S*TG**(-1)*NS*MG2**2 + 4*S*TG**(-1)*MS2*MG2 - 4*S*
     +    TG**(-1)*MG2**2 + 4*S*NS*MG2 - 4*S*MG2 - 24*TG**(-1)*NS*MS2*
     +    MG2**2 + 24*TG**(-1)*NS*MS2**2*MG2 - 8*TG**(-1)*NS*MS2**3 + 8
     +    *TG**(-1)*NS*MG2**3 + 24*TG**(-1)*MS2*MG2**2 - 24*TG**(-1)*
     +    MS2**2*MG2 + 8*TG**(-1)*MS2**3 - 8*TG**(-1)*MG2**3 - 12*TG*NS
     +    *MS2 + 12*TG*NS*MG2 + 12*TG*MS2 - 12*TG*MG2 + 4*TG**2*NS - 4*
     +    TG**2 - 32*NS*MS2*MG2 + 16*NS*MS2**2 + 16*NS*MG2**2 + 32*MS2*
     +    MG2 - 16*MS2**2 - 16*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(4,2)*N*CO * ( 8*S*TG*NS - 8*S*TG - 4*S*
     +    UG**(-1)*NS*MS2*MG2 + 4*S*UG**(-1)*NS*MG2**2 + 4*S*UG**(-1)*
     +    MS2*MG2 - 4*S*UG**(-1)*MG2**2 + 12*S*NS*MS2 - 8*S*NS*MG2 - 12
     +    *S*MS2 + 8*S*MG2 + 4*S**2*NS - 4*S**2 + 12*TG*NS*MS2 - 12*TG*
     +    NS*MG2 - 12*TG*MS2 + 12*TG*MG2 + 4*TG**2*NS - 4*TG**2 - 24*
     +    UG**(-1)*NS*MS2*MG2**2 + 24*UG**(-1)*NS*MS2**2*MG2 - 8*
     +    UG**(-1)*NS*MS2**3 + 8*UG**(-1)*NS*MG2**3 + 24*UG**(-1)*MS2*
     +    MG2**2 - 24*UG**(-1)*MS2**2*MG2 + 8*UG**(-1)*MS2**3 - 8*
     +    UG**(-1)*MG2**3 - 32*NS*MS2*MG2 + 16*NS*MS2**2 + 16*NS*MG2**2
     +     + 32*MS2*MG2 - 16*MS2**2 - 16*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(5,1)*N*CO * (  - 16*S**(-1)*TG*NS*MS2*MG2
     +     + 16*S**(-1)*TG*NS*MS2**2 + 16*S**(-1)*TG*MS2*MG2 - 16*
     +    S**(-1)*TG*MS2**2 - 4*S*TG**(-1)*NS*MS2*MG2 + 4*S*TG**(-1)*NS
     +    *MG2**2 + 4*S*TG**(-1)*MS2*MG2 - 4*S*TG**(-1)*MG2**2 + 4*S*TG
     +    *NS - 4*S*TG - 4*S*NS*MS2 + 8*S*NS*MG2 + 4*S*MS2 - 8*S*MG2 + 
     +    8*TG**(-1)*NS*MS2*MG2**2 - 8*TG**(-1)*NS*MS2**2*MG2 - 8*
     +    TG**(-1)*NS*MS2**3 + 8*TG**(-1)*NS*MG2**3 - 8*TG**(-1)*MS2*
     +    MG2**2 + 8*TG**(-1)*MS2**2*MG2 + 8*TG**(-1)*MS2**3 - 8*
     +    TG**(-1)*MG2**3 - 16*TG*NS*MS2 + 8*TG*NS*MG2 + 16*TG*MS2 - 8*
     +    TG*MG2 - 16*NS*MS2*MG2 + 16*NS*MG2**2 + 16*MS2*MG2 - 16*
     +    MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(5,2)*N*CO * ( 16*S**(-1)*TG*NS*MS2*MG2 - 
     +    16*S**(-1)*TG*NS*MS2**2 - 16*S**(-1)*TG*MS2*MG2 + 16*S**(-1)*
     +    TG*MS2**2 - 4*S*TG*NS + 4*S*TG - 4*S*UG**(-1)*NS*MS2*MG2 + 4*
     +    S*UG**(-1)*NS*MG2**2 + 4*S*UG**(-1)*MS2*MG2 - 4*S*UG**(-1)*
     +    MG2**2 + 12*S*NS*MS2 - 12*S*MS2 - 4*S**2*NS + 4*S**2 + 16*TG*
     +    NS*MS2 - 8*TG*NS*MG2 - 16*TG*MS2 + 8*TG*MG2 + 8*UG**(-1)*NS*
     +    MS2*MG2**2 - 8*UG**(-1)*NS*MS2**2*MG2 - 8*UG**(-1)*NS*MS2**3
     +     + 8*UG**(-1)*NS*MG2**3 - 8*UG**(-1)*MS2*MG2**2 + 8*UG**(-1)*
     +    MS2**2*MG2 + 8*UG**(-1)*MS2**3 - 8*UG**(-1)*MG2**3 - 16*NS*
     +    MS2**2 + 16*NS*MG2**2 + 16*MS2**2 - 16*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(6,1)*N*CO * ( 8*S*TG**(-1)*NS*MS2*MG2 - 8
     +    *S*TG**(-1)*NS*MG2**2 - 8*S*TG**(-1)*MS2*MG2 + 8*S*TG**(-1)*
     +    MG2**2 + 8*S*UG**(-1)*NS*MS2*MG2 - 8*S*UG**(-1)*NS*MG2**2 - 8
     +    *S*UG**(-1)*MS2*MG2 + 8*S*UG**(-1)*MG2**2 - 8*S*NS*MG2 + 8*S*
     +    MG2 - 16*TG**(-1)*NS*MS2*MG2**2 - 16*TG**(-1)*NS*MS2**2*MG2
     +     + 16*TG**(-1)*NS*MS2**3 + 16*TG**(-1)*NS*MG2**3 + 16*
     +    TG**(-1)*MS2*MG2**2 + 16*TG**(-1)*MS2**2*MG2 - 16*TG**(-1)*
     +    MS2**3 - 16*TG**(-1)*MG2**3 - 16*UG**(-1)*NS*MS2*MG2**2 - 16*
     +    UG**(-1)*NS*MS2**2*MG2 + 16*UG**(-1)*NS*MS2**3 + 16*UG**(-1)*
     +    NS*MG2**3 + 16*UG**(-1)*MS2*MG2**2 + 16*UG**(-1)*MS2**2*MG2
     +     - 16*UG**(-1)*MS2**3 - 16*UG**(-1)*MG2**3 - 16*NS*MS2**2 + 
     +    16*NS*MG2**2 + 16*MS2**2 - 16*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(10,1)*N*CO * ( 16*S**(-1)*TG*MS2*MT2 - 16
     +    *S**(-1)*TG*MG2*MT2 - 16*S**(-1)*TG*MT2**2 - 4*S*TG**(-1)*MS2
     +    *MG2 - 4*S*TG**(-1)*MS2*MT2 - 8*S*TG**(-1)*MG2*MT2 + 4*S*
     +    TG**(-1)*MG2**2 + 4*S*TG**(-1)*MT2**2 + 4*S*MG2 + 4*S*MT2 - 
     +    48*TG**(-1)*MS2*MG2*MT2 - 24*TG**(-1)*MS2*MG2**2 - 24*
     +    TG**(-1)*MS2*MT2**2 + 24*TG**(-1)*MS2**2*MG2 + 24*TG**(-1)*
     +    MS2**2*MT2 - 8*TG**(-1)*MS2**3 + 24*TG**(-1)*MG2*MT2**2 + 24*
     +    TG**(-1)*MG2**2*MT2 + 8*TG**(-1)*MG2**3 + 8*TG**(-1)*MT2**3
     +     - 12*TG*MS2 + 12*TG*MG2 + 12*TG*MT2 + 4*TG**2 - 32*MS2*MG2
     +     - 16*MS2*MT2 + 16*MS2**2 + 16*MG2*MT2 + 16*MG2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(10,2)*N*CO * (  - 16*S**(-1)*TG*MS2*MT2
     +     + 16*S**(-1)*TG*MG2*MT2 + 16*S**(-1)*TG*MT2**2 + 8*S*TG - 4*
     +    S*UG**(-1)*MS2*MG2 - 4*S*UG**(-1)*MS2*MT2 - 8*S*UG**(-1)*MG2*
     +    MT2 + 4*S*UG**(-1)*MG2**2 + 4*S*UG**(-1)*MT2**2 + 12*S*MS2 - 
     +    8*S*MG2 - 8*S*MT2 + 4*S**2 + 12*TG*MS2 - 12*TG*MG2 - 12*TG*
     +    MT2 + 4*TG**2 - 48*UG**(-1)*MS2*MG2*MT2 - 24*UG**(-1)*MS2*
     +    MG2**2 - 24*UG**(-1)*MS2*MT2**2 + 24*UG**(-1)*MS2**2*MG2 + 24
     +    *UG**(-1)*MS2**2*MT2 - 8*UG**(-1)*MS2**3 + 24*UG**(-1)*MG2*
     +    MT2**2 + 24*UG**(-1)*MG2**2*MT2 + 8*UG**(-1)*MG2**3 + 8*
     +    UG**(-1)*MT2**3 - 32*MS2*MG2 - 32*MS2*MT2 + 16*MS2**2 + 32*
     +    MG2*MT2 + 16*MG2**2 + 16*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(11,1)*N*CO * (  - 16*S**(-1)*TG*MS2*MG2
     +     - 16*S**(-1)*TG*MS2*MT2 + 16*S**(-1)*TG*MS2**2 - 4*S*
     +    TG**(-1)*MS2*MG2 - 4*S*TG**(-1)*MS2*MT2 - 8*S*TG**(-1)*MG2*
     +    MT2 + 4*S*TG**(-1)*MG2**2 + 4*S*TG**(-1)*MT2**2 + 4*S*TG - 4*
     +    S*MS2 + 8*S*MG2 - 8*S*MT2 + 16*TG**(-1)*MS2*MG2*MT2 + 8*
     +    TG**(-1)*MS2*MG2**2 - 24*TG**(-1)*MS2*MT2**2 - 8*TG**(-1)*
     +    MS2**2*MG2 + 24*TG**(-1)*MS2**2*MT2 - 8*TG**(-1)*MS2**3 - 8*
     +    TG**(-1)*MG2*MT2**2 - 8*TG**(-1)*MG2**2*MT2 + 8*TG**(-1)*
     +    MG2**3 + 8*TG**(-1)*MT2**3 - 16*TG*MS2 + 8*TG*MG2 + 8*TG*MT2
     +     - 16*MS2*MG2 + 16*MS2*MT2 + 16*MG2**2 - 16*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(11,2)*N*CO * ( 16*S**(-1)*TG*MS2*MG2 + 16
     +    *S**(-1)*TG*MS2*MT2 - 16*S**(-1)*TG*MS2**2 - 4*S*TG - 4*S*
     +    UG**(-1)*MS2*MG2 - 4*S*UG**(-1)*MS2*MT2 - 8*S*UG**(-1)*MG2*
     +    MT2 + 4*S*UG**(-1)*MG2**2 + 4*S*UG**(-1)*MT2**2 + 12*S*MS2 - 
     +    16*S*MT2 - 4*S**2 + 16*TG*MS2 - 8*TG*MG2 - 8*TG*MT2 + 16*
     +    UG**(-1)*MS2*MG2*MT2 + 8*UG**(-1)*MS2*MG2**2 - 24*UG**(-1)*
     +    MS2*MT2**2 - 8*UG**(-1)*MS2**2*MG2 + 24*UG**(-1)*MS2**2*MT2
     +     - 8*UG**(-1)*MS2**3 - 8*UG**(-1)*MG2*MT2**2 - 8*UG**(-1)*
     +    MG2**2*MT2 + 8*UG**(-1)*MG2**3 + 8*UG**(-1)*MT2**3 + 32*MS2*
     +    MT2 - 16*MS2**2 + 16*MG2**2 - 16*MT2**2 )
     +
      M2GGSV = M2GGSV + SK1D0(12,1)*N*CO * ( 8*S*TG**(-1)*MS2*MG2 + 8*S
     +    *TG**(-1)*MS2*MT2 + 16*S*TG**(-1)*MG2*MT2 - 8*S*TG**(-1)*
     +    MG2**2 - 8*S*TG**(-1)*MT2**2 + 8*S*UG**(-1)*MS2*MG2 + 8*S*
     +    UG**(-1)*MS2*MT2 + 16*S*UG**(-1)*MG2*MT2 - 8*S*UG**(-1)*
     +    MG2**2 - 8*S*UG**(-1)*MT2**2 - 8*S*MG2 + 8*S*MT2 + 32*
     +    TG**(-1)*MS2*MG2*MT2 - 16*TG**(-1)*MS2*MG2**2 + 48*TG**(-1)*
     +    MS2*MT2**2 - 16*TG**(-1)*MS2**2*MG2 - 48*TG**(-1)*MS2**2*MT2
     +     + 16*TG**(-1)*MS2**3 - 16*TG**(-1)*MG2*MT2**2 + 16*TG**(-1)*
     +    MG2**2*MT2 + 16*TG**(-1)*MG2**3 - 16*TG**(-1)*MT2**3 + 32*
     +    UG**(-1)*MS2*MG2*MT2 - 16*UG**(-1)*MS2*MG2**2 + 48*UG**(-1)*
     +    MS2*MT2**2 - 16*UG**(-1)*MS2**2*MG2 - 48*UG**(-1)*MS2**2*MT2
     +     + 16*UG**(-1)*MS2**3 - 16*UG**(-1)*MG2*MT2**2 + 16*UG**(-1)*
     +    MG2**2*MT2 + 16*UG**(-1)*MG2**3 - 16*UG**(-1)*MT2**3 - 16*
     +    MS2**2 + 32*MG2*MT2 + 16*MG2**2 + 16*MT2**2 )
     +
ctp ms2 does not appear below this line
      M2GGSV = M2GGSV + SOF1(1)*N**2*CO * ( 256*S**(-2)*TG**2*MG2 + 256
     +    *S**(-1)*TG*MG2 - 128*S**(-1)*TG**2 + 512*S**(-1)*MG2**2 - 
     +    128*S*TG**(-2)*MG2**2 - 64*S*TG**(-1)*MG2 - 128*S*UG**(-2)*
     +    MG2**2 - 64*S*UG**(-1)*MG2 - 128*S - 32*S**2*TG**(-1) - 32*
     +    S**2*UG**(-1) + 256*TG**(-2)*MG2**3 + 256*TG**(-1)*MG2**2 - 
     +    128*TG + 256*UG**(-2)*MG2**3 + 256*UG**(-1)*MG2**2 )
     +
      M2GGSV = M2GGSV + SOF1(2)*N**2*CO * ( 256*S**(-2)*TG**2*MG2 + 256
     +    *S**(-1)*TG*MG2 + 512*S**(-1)*MG2**2 + 128*S*TG**(-1)*MG2 + 
     +    128*S*UG**(-1)*MG2 + 512*TG**(-2)*MG2**3 + 512*TG**(-1)*
     +    UG**(-1)*MG2**3 + 512*TG**(-1)*MG2**2 + 512*UG**(-2)*MG2**3
     +     + 512*UG**(-1)*MG2**2 + 384*MG2 )
     +
      M2GGSV = M2GGSV + SOF1(3)*N**2*CO * ( 256*S**(-2)*TG**2*MG2 + 256
     +    *S**(-1)*TG*MG2 + 512*S**(-1)*MG2**2 + 128*S*TG**(-1)*MG2 + 
     +    128*S*UG**(-1)*MG2 + 512*TG**(-2)*MG2**3 + 512*TG**(-1)*
     +    UG**(-1)*MG2**3 + 512*TG**(-1)*MG2**2 + 512*UG**(-2)*MG2**3
     +     + 512*UG**(-1)*MG2**2 + 384*MG2 )
     +
      M2GGSV = M2GGSV + SOF1(4)*N**2*CO * ( 64*S**(-2)*TG**3 + 128*
     +    S**(-1)*TG*MG2 + 64*S**(-1)*TG**2 + 128*S*TG**(-2)*MG2**2 + 
     +    128*S*TG**(-1)*MG2 + 64*S + 32*S**2*TG**(-1) - 128*TG**(-1)*
     +    MG2**2 + 96*TG - 256*UG**(-1)*MG2**2 )
     +
      M2GGSV = M2GGSV + SOF1(5)*N**2*CO * (  - 64*S**(-2)*TG**3 - 128*
     +    S**(-1)*TG*MG2 - 128*S**(-1)*TG**2 + 128*S*UG**(-2)*MG2**2 + 
     +    128*S*UG**(-1)*MG2 - 32*S + 32*S**2*UG**(-1) - 256*TG**(-1)*
     +    MG2**2 - 160*TG - 128*UG**(-1)*MG2**2 - 128*MG2 )
     +
      M2GGSV = M2GGSV + SOF1(6)*N**2*CO * (  - 64*S**(-2)*TG**3 - 128*
     +    S**(-1)*TG*MG2 - 128*S**(-1)*TG**2 + 128*S*UG**(-2)*MG2**2 + 
     +    128*S*UG**(-1)*MG2 - 32*S + 32*S**2*UG**(-1) - 256*TG**(-1)*
     +    MG2**2 - 160*TG - 128*UG**(-1)*MG2**2 - 128*MG2 )
     +
      M2GGSV = M2GGSV + SOF1(7)*N**2*CO * ( 64*S**(-2)*TG**3 + 128*
     +    S**(-1)*TG*MG2 + 64*S**(-1)*TG**2 + 128*S*TG**(-2)*MG2**2 + 
     +    128*S*TG**(-1)*MG2 + 64*S + 32*S**2*TG**(-1) - 128*TG**(-1)*
     +    MG2**2 + 96*TG - 256*UG**(-1)*MG2**2 )
     +
      M2GGSV = M2GGSV + SOF1(8)*N**2*CO * (  - 128*S**(-1)*TG**2 - 128*
     +    S*TG**(-2)*MG2**2 - 128*S*TG**(-1)*MG2 - 128*S*UG**(-2)*
     +    MG2**2 - 128*S*UG**(-1)*MG2 - 128*S - 32*S**2*TG**(-1) - 32*
     +    S**2*UG**(-1) - 128*TG - 256*MG2 )

      END IF

      DGGGGV = 
     +     0.5D0 * ALPHAS**3 * AVG *  M2GGSV /4.D0 /S**2 *CONV
     +    + ALPHAS/PI*DGGGGB(ALPHAS,S,TG,MS,MG) 
     +    * (LOG(MS2/MG2)*(-1.D0) + LOG(MT2/MG2)*(-1.D0/3.D0))
C***  CHANGES TO SUBTRACTED MSBAR 
      RETURN
      END



      REAL*8 FUNCTION DGGGGH(ALPHAS,S,TG,S4G,MS,MG)
C***  HARD CROSS SECTION FOR G + G -> GL + GL +G
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4G,TG,UG,MS,MG,MS2,MG2,M2
      REAL*8 M2GGH
      REAL*8 NS,CONV,N,CO,AVG
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 AHP1P1, ABP1P1, ABP1M1, ABP1P2, A4P2P2, A4P1P2, A4P1P1
      REAL*8 A4M1P2, A4M1P1, A4P0P2, A4P1P0,A4P2M2, A4M2P1,ABP2P2
      REAL*8 ABP2P1, ABP2P0, ABP1M2,A4M1P0
      REAL*8 ANG4(1:117), COLO1(1:9)
      
      CONV = 389379660.D0
      NS = 6.D0

      N = 3.D0
      CO = N*(N**2 -1.D0)

      AVG = (1.D0/2.D0)**2 * (1.D0/(N**2 -1.D0))**2

      MS2 = MS**2
      MG2 = MG**2
      M2 = MG2 - MS2
      UG = S4G -S -TG


      ANGDEF(1) = 2.D0*SQRT(S4G +MG2)
      ANGDEF(2) = (S +UG)/ANGDEF(1)
      ANGDEF(3) = (S +TG)/ANGDEF(1)
      ANGDEF(4) = S4G/ANGDEF(1)
      ANGDEF(5) = (S4G +2.D0*MG2)/ANGDEF(1)
      ANGDEF(6) = -(TG +UG +2.D0*MG2)/ANGDEF(1)
      ANGDEF(7) = SQRT((TG +UG)**2 -4.D0*MG2*S)/ANGDEF(1)
      ANGDEF(8) = 
     +  (TG*S4G -S*(UG+2.D0*MG2))/(S+TG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     +  (UG*S4G -S*(TG+2.D0*MG2))/(S+UG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(1,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)
      ANC(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(1,2) = -ANB(1,1)
      ANC(1,2) = -ANC(1,1)
      ANA(1,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(1,3) = -ANA(1,3)
      ANC(1,3) =  0.D0
      ANA(1,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(1,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)-2.D0*ANGDEF(3)*ANGDEF(4)
      ANC(1,4) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(1,5) = -ANB(1,3)
      ANC(1,5) = -ANC(1,3)
      ANA(1,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(1,6) = -ANB(1,4)
      ANC(1,6) = -ANC(1,4)
      ANA(1,7) = +ANA(1,1) +M2
      ANB(1,7) = +ANB(1,1)
      ANC(1,7) = +ANC(1,1)
      ANA(1,8) = +ANA(1,5) +M2
      ANB(1,8) = +ANB(1,5)
      ANC(1,8) = +ANC(1,5)
      ANA(1,9) = +ANA(1,6) +M2
      ANB(1,9) = +ANB(1,6)
      ANC(1,9) = +ANC(1,6)


      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)
      ANA(2,7) = +ANA(2,1) +M2
      ANB(2,7) = +ANB(2,1)
      ANC(2,7) = +ANC(2,1)
      ANA(2,8) = +ANA(2,5) +M2
      ANB(2,8) = +ANB(2,5)
      ANC(2,8) = +ANC(2,5)
      ANA(2,9) = +ANA(2,6) +M2
      ANB(2,9) = +ANB(2,6)
      ANC(2,9) = +ANC(2,6)


      ANA(3,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10)
      ANC(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(3,2) = -ANB(3,1)
      ANC(3,2) = -ANC(3,1)
      ANA(3,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(3,3) = 
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10) -2.D0*ANGDEF(2)*ANGDEF(4)
      ANC(3,3) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(3,4) = -ANA(3,4)
      ANC(3,4) =  0.D0
      ANA(3,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(3,5) = -ANB(3,3)
      ANC(3,5) = -ANC(3,3)
      ANA(3,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(3,6) = -ANB(3,4)
      ANC(3,6) = -ANC(3,4)
      ANA(3,7) = +ANA(3,1) +M2
      ANB(3,7) = +ANB(3,1)
      ANC(3,7) = +ANC(3,1)
      ANA(3,8) = +ANA(3,5) +M2
      ANB(3,8) = +ANB(3,5)
      ANC(3,8) = +ANC(3,5)
      ANA(3,9) = +ANA(3,6) +M2
      ANB(3,9) = +ANB(3,6)
      ANC(3,9) = +ANC(3,6)


      ANG4(1) = A4P2P2(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
      ANG4(2) = A4P1P2(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
      ANG4(3) = A4P1P2(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(4) = A4P1P1(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
      ANG4(5) = A4P2P2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(6) = A4P1P2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(7) = A4P1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(8) = A4P1P1(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(9) = A4P2M2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(10) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))

      ANG4(11) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(12) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(13) =A4P2M2(ANA(2,2),ANB(2,2),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(14) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(15) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(16) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(17) =A4P1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(18) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(19) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(20) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))

      ANG4(21) =A4M1P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(22) =A4M1P2(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(23) =A4M2P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(24) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(25) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(26) =A4P1P2(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(27) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(28) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(29) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(30) =A4P1P2(ANA(3,9),ANB(3,9),ANA(3,7),ANB(3,7),ANC(3,7))

C$$$      ANG4(31) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(32) =A4M1P2(ANA(3,9),ANB(3,9),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(33) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(34) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(35) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
      ANG4(36) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(37) =A4P1P0(ANA(2,1),ANB(2,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(38) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(39) =A4P1P0(ANA(2,2),ANB(2,2),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(40) =A4P0P2(ANA(1,1),ANB(1,1),ANA(2,5),ANB(2,5),ANC(2,5))

      ANG4(41) =A4P1P0(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(42) =A4M1P0(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(43) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(44) =A4P1P0(ANA(3,6),ANB(3,6),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(45) =A4M1P0(ANA(3,6),ANB(3,6),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(46) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(47) =A4P1P0(ANA(2,7),ANB(2,7),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(48) =AHP1P1(ANA(1,3),ANB(1,3),ANA(1,4),ANB(1,4),ANC(1,4))
      ANG4(49) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(50) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,1),ANB(3,1),ANC(3,1))

      ANG4(51) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(52) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(53) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(54) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(55) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(56) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(57) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(58) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(59) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(60) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))

      ANG4(61) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(62) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(63) =ABP1M1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(64) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(65) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(66) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(67) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(68) =ABP1M1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(69) =ABP1M2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(70) =ABP2P0(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))

      ANG4(71) =ABP2P0(ANA(3,4),ANB(3,4),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(72) =A4P2P2(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(73) =A4P1P2(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(74) =A4P1P2(ANA(3,9),ANB(3,9),ANA(3,1),ANB(3,1),ANC(3,1))
C$$$      ANG4(75) =A4P1P1(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(76) =A4P1P1(ANA(3,9),ANB(3,9),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(77) =A4M1P2(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(78) =A4M1P1(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(79) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(80) =A4P1P0(ANA(3,9),ANB(3,9),ANA(1,1),ANB(1,1),ANC(1,1))

C$$$      ANG4(81) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(82) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(83) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(84) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(85) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(86) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(87) =A4P2P2(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(88) =A4P1P2(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(89) =A4P1P2(ANA(1,8),ANB(1,8),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(90) =A4P1P1(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))

C$$$      ANG4(91) =A4P0P2(ANA(1,1),ANB(1,1),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(92) =A4P1P0(ANA(1,8),ANB(1,8),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(93) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(94) =A4P1P1(ANA(1,8),ANB(1,8),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(95) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(96) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(97) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(98) =A4P1P2(ANA(1,8),ANB(1,8),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(99) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))

C$$$      ANG4(100)=A4P2P2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(101)=A4P1P2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(102)=A4P1P2(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(103)=A4P1P1(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(104)=A4P1P1(ANA(1,8),ANB(1,8),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(105)=A4M2P1(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(106)=A4M1P2(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(107)=ABP1M2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(108)=A4P1P1(ANA(1,8),ANB(1,8),ANA(1,2),ANB(1,2),ANC(1,2))
C$$$      ANG4(109)=A4M1P1(ANA(2,2),ANB(2,2),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(110)=A4M1P1(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))

C$$$      ANG4(111)=A4M1P2(ANA(1,3),ANB(1,3),ANA(1,8),ANB(1,8),ANC(1,8))
C$$$      ANG4(112)=A4M1P1(ANA(1,3),ANB(1,3),ANA(1,8),ANB(1,8),ANC(1,8))
C$$$      ANG4(113)=A4M1P2(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(114)=A4M1P1(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(115)=A4M1P2(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(116)=A4P2M2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(117)=A4P2M2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))


      COLO1(9) = LOG(S4G**2/MG2/(S4G+MG2))

      M2GGH = 0.D0
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * (  - 64*S**(-2)*TG**(-1)*
     +    UG**2*S4G**(-1) + 32*S**(-2)*TG**(-1)*UG**3*(TG+UG)**(-1)*
     +    S4G**(-1) + 32*S**(-2)*TG**(-1)*UG**3*S4G**(-2) + 128*S**(-2)
     +    *TG*UG**(-2)*(S+TG)**2*S4G**(-1) - 128*S**(-2)*TG*UG**(-1)*
     +    (S+TG)**2*S4G**(-2) + 384*S**(-2)*TG*UG*S4G**(-2) + 128*
     +    S**(-2)*TG*UG**2*(S+UG)**(-2)*S4G**(-1) - 512*S**(-2)*TG*
     +    S4G**(-1) - 256*S**(-2)*TG**2*UG**(-1)*S4G**(-1) + 256*
     +    S**(-2)*TG**2*S4G**(-2) - 128*S**(-2)*TG**3*UG**(-2)*
     +    S4G**(-1) + 128*S**(-2)*TG**3*UG**(-1)*S4G**(-2) + 256*
     +    S**(-2)*UG**(-1)*(S+TG)**2*S4G**(-1) - 256*S**(-2)*UG*
     +    S4G**(-1) - 32*S**(-2)*UG**2*(TG+UG)**(-1)*S4G**(-1) + 128*
     +    S**(-2)*UG**2*(S+UG)**(-1)*S4G**(-1) + 224*S**(-2)*UG**2*
     +    S4G**(-2) + 128*S**(-2)*(S+TG)*S4G**(-1) + 512*S**(-1)*
     +    TG**(-3)*UG*MG2 - 256*S**(-1)*TG**(-3)*UG**2*MG2*S4G**(-1) - 
     +    256*S**(-1)*TG**(-2)*UG*MG2*S4G**(-1) + 32*S**(-1)*TG**(-2)*
     +    UG**2*S4G**(-1) )
     +
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * (  - 28*S**(-1)*TG**(-1)*UG*
     +    S4G**(-1) + 28*S**(-1)*TG**(-1)*UG**2*(TG+UG)**(-1)*S4G**(-1)
     +     + 32*S**(-1)*TG**(-1)*UG**2*(S+TG)**(-1)*S4G**(-1) + 34*
     +    S**(-1)*TG**(-1)*UG**2*(S+UG)**(-1)*S4G**(-1) - 96*S**(-1)*
     +    TG**(-1)*UG**2*S4G**(-2) + 4*S**(-1)*TG**(-1)*UG**3*
     +    (TG+UG)**(-1)*(S+UG)**(-1)*S4G**(-1) - 32*S**(-1)*TG**(-1)*
     +    UG**3*(TG+UG)**(-1)*S4G**(-2) - 64*S**(-1)*TG**(-1)*UG**3*
     +    (S+TG)**(-1)*S4G**(-2) - 6*S**(-1)*TG**(-1)*UG**3*
     +    (S+UG)**(-1)*S4G**(-2) + 512*S**(-1)*TG*UG**(-3)*MG2 - 256*
     +    S**(-1)*TG*UG**(-2)*MG2*S4G**(-1) - 128*S**(-1)*TG*UG**(-2)*
     +    (S+TG)*S4G**(-1) + 128*S**(-1)*TG*UG**(-1)*(S+TG)*S4G**(-2)
     +     - 256*S**(-1)*TG*UG**(-1)*S4G**(-1) + 16*S**(-1)*TG*UG*MG2*
     +    (S+UG)**(-2)*S4G**(-2) - 24*S**(-1)*TG*UG*(S+TG)**(-2)*
     +    S4G**(-1) + 128*S**(-1)*TG*UG*(S+UG)**(-2)*S4G**(-1) + 24*
     +    S**(-1)*TG*UG**2*(S+TG)**(-2)*S4G**(-2) - 2*S**(-1)*TG*UG**2*
     +    (S+UG)**(-2)*S4G**(-2) )
     +
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * ( 16*S**(-1)*TG*UG**3*
     +    (S+UG)**(-3)*S4G**(-2) + 24*S**(-1)*TG*(S+TG)**(-1)*S4G**(-1)
     +     + 96*S**(-1)*TG*(S+UG)**(-1)*S4G**(-1) + 576*S**(-1)*TG*
     +    S4G**(-2) - 256*S**(-1)*TG**2*UG**(-3)*MG2*S4G**(-1) - 224*
     +    S**(-1)*TG**2*UG**(-2)*S4G**(-1) + 32*S**(-1)*TG**2*UG**(-1)*
     +    (S+TG)**(-1)*S4G**(-1) + 32*S**(-1)*TG**2*UG**(-1)*
     +    (S+UG)**(-1)*S4G**(-1) + 96*S**(-1)*TG**2*UG**(-1)*S4G**(-2)
     +     + 16*S**(-1)*TG**2*UG*(S+TG)**(-3)*S4G**(-1) + 16*S**(-1)*
     +    TG**2*UG**2*(S+TG)**(-3)*S4G**(-2) + 32*S**(-1)*TG**2*UG**2*
     +    (S+UG)**(-3)*S4G**(-2) + 56*S**(-1)*TG**2*(S+TG)**(-2)*
     +    S4G**(-1) + 64*S**(-1)*TG**2*(S+UG)**(-1)*S4G**(-2) - 64*
     +    S**(-1)*TG**3*UG**(-1)*(S+UG)**(-1)*S4G**(-2) + 128*S**(-1)*
     +    UG**(-2)*(S+TG)**2*S4G**(-1) - 256*S**(-1)*UG**(-1)*(S+TG)*
     +    S4G**(-1) - 128*S**(-1)*UG**(-1)*(S+TG)**2*S4G**(-2) - 16*
     +    S**(-1)*UG*MG2*(S+UG)**(-2)*S4G**(-1) + 28*S**(-1)*UG*
     +    (TG+UG)**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * (  - 20*S**(-1)*UG*
     +    (S+TG)**(-1)*S4G**(-1) + 164*S**(-1)*UG*(S+UG)**(-1)*
     +    S4G**(-1) + 448*S**(-1)*UG*S4G**(-2) + 16*S**(-1)*UG**2*MG2*
     +    (S+UG)**(-2)*S4G**(-2) - 4*S**(-1)*UG**2*(TG+UG)**(-1)*
     +    (S+TG)**(-1)*S4G**(-1) + 32*S**(-1)*UG**2*(TG+UG)**(-1)*
     +    S4G**(-2) + 56*S**(-1)*UG**2*(S+TG)**(-1)*S4G**(-2) + 34*
     +    S**(-1)*UG**2*(S+UG)**(-2)*S4G**(-1) - 14*S**(-1)*UG**2*
     +    (S+UG)**(-1)*S4G**(-2) + 22*S**(-1)*UG**3*(S+UG)**(-2)*
     +    S4G**(-2) - 612*S**(-1)*S4G**(-1) - 256*S*TG**(-4)*MG2**2*
     +    S4G**(-1) + 512*S*TG**(-3)*UG**(-1)*MG2 - 256*S*TG**(-3)*
     +    UG**(-1)*MG2**2*S4G**(-1) - 256*S*TG**(-2)*UG**(-1)*MG2*
     +    S4G**(-1) + 128*S*TG**(-2)*UG**(-1)*(S+UG)*S4G**(-1) + 128*S*
     +    TG**(-2)*UG*(S+UG)**(-1)*S4G**(-1) - 128*S*TG**(-2)*MG2*
     +    (S+UG)**(-1)*S4G**(-1) - 256*S*TG**(-2)*S4G**(-1) + 512*S*
     +    TG**(-1)*UG**(-3)*MG2 - 256*S*TG**(-1)*UG**(-3)*MG2**2*
     +    S4G**(-1) )
     +
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * (  - 256*S*TG**(-1)*UG**(-2)*
     +    MG2*S4G**(-1) + 128*S*TG**(-1)*UG**(-2)*(S+TG)*S4G**(-1) - 
     +    128*S*TG**(-1)*UG**(-1)*(S+TG)*S4G**(-2) - 128*S*TG**(-1)*
     +    UG**(-1)*(S+UG)*S4G**(-2) - 288*S*TG**(-1)*UG**(-1)*S4G**(-1)
     +     - 56*S*TG**(-1)*UG*(TG+UG)**(-1)*S4G**(-2) - 8*S*TG**(-1)*UG
     +    *(S+TG)**(-1)*S4G**(-2) - 128*S*TG**(-1)*UG*(S+UG)**(-1)*
     +    S4G**(-2) + 4*S*TG**(-1)*UG**2*(TG+UG)**(-1)*(S+TG)**(-1)*
     +    S4G**(-2) + 16*S*TG**(-1)*(TG+UG)**(-1)*S4G**(-1) + 16*S*
     +    TG**(-1)*(S+TG)**(-1)*S4G**(-1) + 192*S*TG**(-1)*S4G**(-2) + 
     +    128*S*TG*UG**(-2)*(S+TG)**(-1)*S4G**(-1) - 128*S*TG*UG**(-1)*
     +    (S+TG)**(-1)*S4G**(-2) - 4*S*TG*UG**(-1)*(S+UG)**(-1)*
     +    S4G**(-2) - 256*S*UG**(-4)*MG2**2*S4G**(-1) - 128*S*UG**(-2)*
     +    MG2*(S+TG)**(-1)*S4G**(-1) - 256*S*UG**(-2)*S4G**(-1) + 16*S*
     +    UG**(-1)*(TG+UG)**(-1)*S4G**(-1) + 16*S*UG**(-1)*(S+UG)**(-1)
     +    *S4G**(-1) + 136*S*UG**(-1)*S4G**(-2) + 4*S*UG*(TG+UG)**(-1)*
     +    (S+UG)**(-1)*S4G**(-2) )
     +
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * ( 56*S*(TG+UG)**(-1)*
     +    S4G**(-2) + 24*S*(S+TG)**(-2)*S4G**(-1) + 32*S*(S+TG)**(-1)*
     +    S4G**(-2) + 24*S*(S+UG)**(-2)*S4G**(-1) + 28*S*(S+UG)**(-1)*
     +    S4G**(-2) - 768*S**2*TG**(-4)*UG**(-2)*MG2**2 + 256*S**2*
     +    TG**(-4)*UG**(-1)*MG2**2*S4G**(-1) + 512*S**2*TG**(-3)*
     +    UG**(-2)*MG2**2*S4G**(-1) - 256*S**2*TG**(-3)*UG**(-1)*MG2*
     +    S4G**(-1) - 768*S**2*TG**(-2)*UG**(-4)*MG2**2 + 512*S**2*
     +    TG**(-2)*UG**(-3)*MG2**2*S4G**(-1) - 128*S**2*TG**(-2)*
     +    UG**(-1)*S4G**(-1) + 256*S**2*TG**(-1)*UG**(-4)*MG2**2*
     +    S4G**(-1) - 256*S**2*TG**(-1)*UG**(-3)*MG2*S4G**(-1) - 128*
     +    S**2*TG**(-1)*UG**(-2)*S4G**(-1) - 16*S**2*TG**(-1)*UG**(-1)*
     +    (S+TG)**(-1)*S4G**(-1) - 16*S**2*TG**(-1)*UG**(-1)*
     +    (S+UG)**(-1)*S4G**(-1) + 32*S**2*TG**(-1)*UG**(-1)*S4G**(-2)
     +     + 4*S**2*TG**(-1)*UG*(TG+UG)**(-1)*(S+TG)**(-1)*S4G**(-2) + 
     +    20*S**2*TG**(-1)*(TG+UG)**(-1)*S4G**(-2) - 20*S**2*TG**(-1)*
     +    (S+TG)**(-1)*S4G**(-2) )
     +
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * ( 20*S**2*UG**(-1)*
     +    (TG+UG)**(-1)*S4G**(-2) - 16*S**2*UG**(-1)*(S+UG)**(-1)*
     +    S4G**(-2) - 4*S**2*(TG+UG)**(-1)*(S+UG)**(-1)*S4G**(-2) + 512
     +    *S**3*TG**(-4)*UG**(-2)*MG2**2*S4G**(-1) + 512*S**3*TG**(-2)*
     +    UG**(-4)*MG2**2*S4G**(-1) - 4*S**3*TG**(-1)*(TG+UG)**(-1)*
     +    (S+TG)**(-1)*S4G**(-2) - 4*S**3*UG**(-1)*(TG+UG)**(-1)*
     +    (S+UG)**(-1)*S4G**(-2) - 256*TG**(-4)*MG2**2 - 128*TG**(-2)*
     +    UG*MG2*(S+UG)**(-1)*S4G**(-1) - 256*TG**(-2)*UG*S4G**(-1) - 
     +    32*TG**(-2)*UG**2*(S+TG)**(-1)*S4G**(-1) + 128*TG**(-2)*UG**2
     +    *(S+UG)**(-1)*S4G**(-1) + 384*TG**(-2)*MG2*S4G**(-1) + 128*
     +    TG**(-2)*(S+UG)*S4G**(-1) + 256*TG**(-1)*UG**(-1)*(S+TG)*
     +    S4G**(-1) + 256*TG**(-1)*UG**(-1)*(S+UG)*S4G**(-1) + 56*
     +    TG**(-1)*UG*(TG+UG)**(-1)*S4G**(-1) + 96*TG**(-1)*UG*
     +    (S+TG)**(-1)*S4G**(-1) + 124*TG**(-1)*UG*(S+UG)**(-1)*
     +    S4G**(-1) + 96*TG**(-1)*UG*S4G**(-2) + 4*TG**(-1)*UG**2*
     +    (TG+UG)**(-1)*(S+UG)**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * ( 28*TG**(-1)*UG**2*
     +    (TG+UG)**(-1)*S4G**(-2) - 28*TG**(-1)*UG**2*(S+TG)**(-1)*
     +    S4G**(-2) - 134*TG**(-1)*UG**2*(S+UG)**(-1)*S4G**(-2) - 4*
     +    TG**(-1)*UG**3*(TG+UG)**(-1)*(S+TG)**(-1)*S4G**(-2) - 128*
     +    TG**(-1)*(S+UG)*S4G**(-2) - 416*TG**(-1)*S4G**(-1) - 128*TG*
     +    UG**(-2)*MG2*(S+TG)**(-1)*S4G**(-1) - 384*TG*UG**(-2)*
     +    S4G**(-1) + 128*TG*UG**(-1)*(S+TG)**(-1)*S4G**(-1) + 96*TG*
     +    UG**(-1)*(S+UG)**(-1)*S4G**(-1) + 252*TG*UG**(-1)*S4G**(-2)
     +     + 48*TG*UG*(S+TG)**(-3)*S4G**(-1) + 48*TG*UG*(S+UG)**(-3)*
     +    S4G**(-1) - 24*TG*UG*(S+UG)**(-2)*S4G**(-2) - 16*TG*UG**2*
     +    (S+TG)**(-3)*S4G**(-2) + 16*TG*UG**2*(S+UG)**(-3)*S4G**(-2)
     +     + 48*TG*(S+TG)**(-2)*S4G**(-1) + 40*TG*(S+UG)**(-2)*
     +    S4G**(-1) + 28*TG*(S+UG)**(-1)*S4G**(-2) + 128*TG**2*UG**(-2)
     +    *(S+TG)**(-1)*S4G**(-1) - 32*TG**2*UG**(-2)*(S+UG)**(-1)*
     +    S4G**(-1) - 128*TG**2*UG**(-1)*(S+TG)**(-1)*S4G**(-2) - 32*
     +    TG**2*UG**(-1)*(S+UG)**(-1)*S4G**(-2) )
     +
      M2GGH = M2GGH + N**2*CO*(S4G+MG2) * (  - 16*TG**2*UG*(S+UG)**(-3)
     +    *S4G**(-2) - 8*TG**2*(S+UG)**(-2)*S4G**(-2) - 256*UG**(-4)*
     +    MG2**2 + 384*UG**(-2)*MG2*S4G**(-1) - 360*UG**(-1)*S4G**(-1)
     +     + 16*UG*MG2*(S+UG)**(-2)*S4G**(-2) + 4*UG*(TG+UG)**(-1)*
     +    (S+TG)**(-1)*S4G**(-1) + 28*UG*(TG+UG)**(-1)*S4G**(-2) + 40*
     +    UG*(S+TG)**(-2)*S4G**(-1) + 16*UG*(S+TG)**(-1)*S4G**(-2) + 48
     +    *UG*(S+UG)**(-2)*S4G**(-1) - 12*UG*(S+UG)**(-1)*S4G**(-2) + 4
     +    *UG**2*(TG+UG)**(-1)*(S+UG)**(-1)*S4G**(-2) - 8*UG**2*
     +    (S+TG)**(-2)*S4G**(-2) + 22*UG**2*(S+UG)**(-2)*S4G**(-2) - 56
     +    *(TG+UG)**(-1)*S4G**(-1) + 4*(S+UG)**(-1)*S4G**(-1) + 628*
     +    S4G**(-2) )
     +
      M2GGH = M2GGH + N**2*CO * ( 256*S**(-2)*TG**(-1)*UG**(-1)*MG2**3
     +     - 256*S**(-2)*TG**(-1)*MG2**3*S4G**(-1) - 256*S**(-2)*
     +    UG**(-1)*MG2**3*S4G**(-1) + 128*S**(-2)*UG**2*MG2*S4G**(-2)
     +     + 256*S**(-1)*TG**(-1)*UG**(-1)*MG2**2 - 78*S**(-1)*TG**(-1)
     +    *UG*MG2*S4G**(-1) - 8*S**(-1)*TG**(-1)*UG + 48*S**(-1)*
     +    TG**(-1)*UG**2*MG2*S4G**(-2) - 8*S**(-1)*TG**(-1)*UG**2*
     +    S4G**(-1) - 34*S**(-1)*TG**(-1)*MG2 - 256*S**(-1)*TG**(-1)*
     +    MG2**2*S4G**(-1) - 256*S**(-1)*TG**(-1)*MG2**3*S4G**(-2) - 32
     +    *S**(-1)*TG*UG**(-1) - 128*S**(-1)*UG**(-1)*MG2 - 384*S**(-1)
     +    *UG**(-1)*MG2**2*S4G**(-1) - 256*S**(-1)*UG**(-1)*MG2**3*
     +    S4G**(-2) + 176*S**(-1)*UG*MG2*S4G**(-2) - 24*S**(-1)*UG*
     +    S4G**(-1) + 226*S**(-1)*MG2*S4G**(-1) + 256*S**(-1)*MG2**2*
     +    S4G**(-2) + 8*S**(-1) - 48*S*TG**(-1)*UG**(-1) + 64*TG**(-2)*
     +    MG2 + 256*TG**(-2)*MG2**2*S4G**(-1) + 256*TG**(-2)*MG2**3*
     +    S4G**(-2) - 32*TG**(-1)*UG**(-1)*MG2 - 16*TG**(-1)*UG*MG2*
     +    S4G**(-2) )
     +
      M2GGH = M2GGH + N**2*CO * (  - 8*TG**(-1)*UG*S4G**(-1) + 418*
     +    TG**(-1)*MG2*S4G**(-1) + 256*TG**(-1)*MG2**2*S4G**(-2) + 48*
     +    TG**(-1) - 64*TG*UG**(-1)*MG2*S4G**(-2) - 8*TG*UG**(-1)*
     +    S4G**(-1) + 64*UG**(-2)*MG2 + 256*UG**(-2)*MG2**2*S4G**(-1)
     +     + 256*UG**(-2)*MG2**3*S4G**(-2) + 448*UG**(-1)*MG2*S4G**(-1)
     +     + 256*UG**(-1)*MG2**2*S4G**(-2) + 48*UG**(-1) + 64*MG2*
     +    S4G**(-2) )
     +
      M2GGH = M2GGH + COLO1(9)*N**2*CO*(S4G+MG2) * (  - 128*S**(-2)*
     +    TG**(-2)*UG**3*S4G**(-1) - 256*S**(-2)*TG**(-1)*UG**2*
     +    S4G**(-1) + 128*S**(-2)*TG**(-1)*UG**3*S4G**(-2) - 128*
     +    S**(-2)*TG*UG**(-2)*(S+TG)**2*S4G**(-1) + 128*S**(-2)*TG*
     +    UG**(-1)*(S+TG)**2*S4G**(-2) - 128*S**(-2)*TG*UG**2*
     +    (S+UG)**(-2)*S4G**(-1) - 256*S**(-2)*UG**(-1)*(S+TG)**2*
     +    S4G**(-1) - 128*S**(-2)*UG*S4G**(-1) - 128*S**(-2)*UG**2*
     +    (S+UG)**(-1)*S4G**(-1) - 128*S**(-2)*(S+TG)*S4G**(-1) + 256*
     +    S**(-1)*TG**(-3)*UG*MG2*(S+UG)*S4G**(-1) - 256*S**(-1)*
     +    TG**(-2)*UG*MG2*(S+UG)*S4G**(-2) - 256*S**(-1)*TG**(-2)*UG**2
     +    *S4G**(-1) + 512*S**(-1)*TG**(-2)*MG2*(S+UG)*S4G**(-1) - 256*
     +    S**(-1)*TG**(-1)*UG*S4G**(-1) + 256*S**(-1)*TG**(-1)*UG**2*
     +    S4G**(-2) + 256*S**(-1)*TG**(-1)*MG2*S4G**(-1) + 256*S**(-1)*
     +    TG*UG**(-3)*MG2*(S+TG)*S4G**(-1) - 256*S**(-1)*TG*UG**(-2)*
     +    MG2*(S+TG)*S4G**(-2) + 128*S**(-1)*TG*UG**(-2)*(S+TG)*
     +    S4G**(-1) )
     +
      M2GGH = M2GGH + COLO1(9)*N**2*CO*(S4G+MG2) * (  - 128*S**(-1)*TG*
     +    UG**(-1)*(S+TG)*S4G**(-2) - 128*S**(-1)*TG*UG*(S+UG)**(-2)*
     +    S4G**(-1) + 512*S**(-1)*UG**(-2)*MG2*(S+TG)*S4G**(-1) - 128*
     +    S**(-1)*UG**(-2)*(S+TG)**2*S4G**(-1) + 256*S**(-1)*UG**(-1)*
     +    MG2*S4G**(-1) + 256*S**(-1)*UG**(-1)*(S+TG)*S4G**(-1) + 128*
     +    S**(-1)*UG**(-1)*(S+TG)**2*S4G**(-2) + 128*S**(-1)*UG*
     +    (S+TG)**(-1)*S4G**(-1) - 128*S**(-1)*UG*(S+UG)**(-1)*
     +    S4G**(-1) + 256*S**(-1)*MG2*(S+TG)**(-1)*S4G**(-1) + 256*
     +    S**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) + 128*S**(-1)*S4G**(-1) - 
     +    256*S*TG**(-4)*UG**(-2)*MG2**2*(S+UG)**2*S4G**(-1) + 256*S*
     +    TG**(-4)*UG**(-1)*MG2**2*(S+UG)*S4G**(-1) - 256*S*TG**(-4)*
     +    MG2**2*S4G**(-1) + 256*S*TG**(-3)*UG**(-2)*MG2**2*(S+UG)**2*
     +    S4G**(-2) + 256*S*TG**(-3)*UG**(-1)*MG2*(S+UG)*S4G**(-1) - 
     +    256*S*TG**(-3)*UG**(-1)*MG2**2*(S+UG)*S4G**(-2) - 256*S*
     +    TG**(-3)*MG2*S4G**(-1) + 256*S*TG**(-3)*MG2**2*S4G**(-2) - 
     +    256*S*TG**(-2)*UG**(-4)*MG2**2*(S+TG)**2*S4G**(-1) )
     +
      M2GGH = M2GGH + COLO1(9)*N**2*CO*(S4G+MG2) * ( 256*S*TG**(-2)*
     +    UG**(-3)*MG2**2*(S+TG)**2*S4G**(-2) - 256*S*TG**(-2)*UG**(-1)
     +    *MG2*(S+UG)*S4G**(-2) - 64*S*TG**(-2)*UG**(-1)*(S+UG)*
     +    S4G**(-1) - 64*S*TG**(-2)*UG*(S+UG)**(-1)*S4G**(-1) + 256*S*
     +    TG**(-2)*MG2*S4G**(-2) - 64*S*TG**(-2)*S4G**(-1) + 256*S*
     +    TG**(-1)*UG**(-4)*MG2**2*(S+TG)*S4G**(-1) + 256*S*TG**(-1)*
     +    UG**(-3)*MG2*(S+TG)*S4G**(-1) - 256*S*TG**(-1)*UG**(-3)*
     +    MG2**2*(S+TG)*S4G**(-2) - 256*S*TG**(-1)*UG**(-2)*MG2*(S+TG)*
     +    S4G**(-2) - 64*S*TG**(-1)*UG**(-2)*(S+TG)*S4G**(-1) + 64*S*
     +    TG**(-1)*UG**(-1)*(S+TG)*S4G**(-2) + 64*S*TG**(-1)*UG**(-1)*
     +    (S+UG)*S4G**(-2) + 64*S*TG**(-1)*UG*(S+UG)**(-1)*S4G**(-2) + 
     +    64*S*TG**(-1)*S4G**(-2) - 64*S*TG*UG**(-2)*(S+TG)**(-1)*
     +    S4G**(-1) + 64*S*TG*UG**(-1)*(S+TG)**(-1)*S4G**(-2) - 256*S*
     +    UG**(-4)*MG2**2*S4G**(-1) - 256*S*UG**(-3)*MG2*S4G**(-1) + 
     +    256*S*UG**(-3)*MG2**2*S4G**(-2) + 256*S*UG**(-2)*MG2*
     +    S4G**(-2) )
     +
      M2GGH = M2GGH + COLO1(9)*N**2*CO*(S4G+MG2) * (  - 64*S*UG**(-2)*
     +    S4G**(-1) + 64*S*UG**(-1)*S4G**(-2) - 256*TG**(-4)*UG**(-1)*
     +    MG2**2*(S+UG)**2*S4G**(-1) - 256*TG**(-4)*UG*MG2**2*S4G**(-1)
     +     + 256*TG**(-4)*MG2**2*(S+UG)*S4G**(-1) - 512*TG**(-3)*
     +    UG**(-2)*MG2**2*(S+UG)**2*S4G**(-1) + 512*TG**(-3)*UG**(-1)*
     +    MG2**2*(S+UG)*S4G**(-1) + 256*TG**(-3)*UG**(-1)*MG2**2*
     +    (S+UG)**2*S4G**(-2) - 256*TG**(-3)*UG*MG2*S4G**(-1) + 256*
     +    TG**(-3)*UG*MG2**2*S4G**(-2) + 512*TG**(-3)*MG2*(S+UG)*
     +    S4G**(-1) - 256*TG**(-3)*MG2**2*(S+UG)*S4G**(-2) - 512*
     +    TG**(-3)*MG2**2*S4G**(-1) - 512*TG**(-2)*UG**(-3)*MG2**2*
     +    (S+TG)**2*S4G**(-1) - 256*TG**(-2)*UG**(-2)*MG2**2*(S+TG)*
     +    S4G**(-1) - 256*TG**(-2)*UG**(-2)*MG2**2*(S+UG)*S4G**(-1) + 
     +    512*TG**(-2)*UG**(-1)*MG2*(S+UG)*S4G**(-1) + 256*TG**(-2)*UG*
     +    MG2*S4G**(-2) - 192*TG**(-2)*UG*S4G**(-1) - 64*TG**(-2)*UG**2
     +    *(S+UG)**(-1)*S4G**(-1) - 512*TG**(-2)*MG2*(S+UG)*S4G**(-2)
     +     - 512*TG**(-2)*MG2*S4G**(-1) )
     +
      M2GGH = M2GGH + COLO1(9)*N**2*CO*(S4G+MG2) * (  - 256*TG**(-2)*
     +    MG2**2*(S+UG)**(-1)*S4G**(-1) - 64*TG**(-2)*(S+UG)*S4G**(-1)
     +     - 256*TG**(-1)*UG**(-4)*MG2**2*(S+TG)**2*S4G**(-1) + 512*
     +    TG**(-1)*UG**(-3)*MG2**2*(S+TG)*S4G**(-1) + 256*TG**(-1)*
     +    UG**(-3)*MG2**2*(S+TG)**2*S4G**(-2) + 512*TG**(-1)*UG**(-2)*
     +    MG2*(S+TG)*S4G**(-1) + 512*TG**(-1)*UG**(-1)*MG2*S4G**(-1) + 
     +    256*TG**(-1)*UG**(-1)*MG2**2*(S+TG)**(-1)*S4G**(-1) + 256*
     +    TG**(-1)*UG**(-1)*MG2**2*(S+UG)**(-1)*S4G**(-1) - 128*
     +    TG**(-1)*UG**(-1)*(S+TG)*S4G**(-1) - 128*TG**(-1)*UG**(-1)*
     +    (S+UG)*S4G**(-1) - 64*TG**(-1)*UG*(S+TG)**(-1)*S4G**(-1) - 
     +    128*TG**(-1)*UG*(S+UG)**(-1)*S4G**(-1) + 192*TG**(-1)*UG*
     +    S4G**(-2) + 64*TG**(-1)*UG**2*(S+UG)**(-1)*S4G**(-2) + 256*
     +    TG**(-1)*MG2*(S+TG)**(-1)*S4G**(-1) - 256*TG**(-1)*MG2*
     +    (S+UG)**(-1)*S4G**(-1) - 256*TG**(-1)*MG2**2*(S+UG)**(-2)*
     +    S4G**(-1) + 64*TG**(-1)*(S+UG)*S4G**(-2) - 192*TG**(-1)*
     +    S4G**(-1) )
     +
      M2GGH = M2GGH + COLO1(9)*N**2*CO*(S4G+MG2) * (  - 256*TG*UG**(-4)
     +    *MG2**2*S4G**(-1) - 256*TG*UG**(-3)*MG2*S4G**(-1) + 256*TG*
     +    UG**(-3)*MG2**2*S4G**(-2) + 256*TG*UG**(-2)*MG2*S4G**(-2) - 
     +    64*TG*UG**(-2)*S4G**(-1) - 128*TG*UG**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) - 64*TG*UG**(-1)*(S+UG)**(-1)*S4G**(-1) + 64*TG*
     +    UG**(-1)*S4G**(-2) - 64*TG*UG*(S+TG)**(-3)*S4G**(-1) - 64*TG*
     +    UG*(S+UG)**(-3)*S4G**(-1) - 64*TG*(S+TG)**(-2)*S4G**(-1) - 64
     +    *TG*(S+UG)**(-2)*S4G**(-1) - 64*TG**2*UG**(-2)*(S+TG)**(-1)*
     +    S4G**(-1) + 64*TG**2*UG**(-1)*(S+TG)**(-1)*S4G**(-2) + 256*
     +    UG**(-4)*MG2**2*(S+TG)*S4G**(-1) + 512*UG**(-3)*MG2*(S+TG)*
     +    S4G**(-1) - 256*UG**(-3)*MG2**2*(S+TG)*S4G**(-2) - 512*
     +    UG**(-3)*MG2**2*S4G**(-1) - 512*UG**(-2)*MG2*(S+TG)*S4G**(-2)
     +     - 512*UG**(-2)*MG2*S4G**(-1) - 256*UG**(-2)*MG2**2*
     +    (S+TG)**(-1)*S4G**(-1) + 64*UG**(-2)*(S+TG)*S4G**(-1) - 256*
     +    UG**(-1)*MG2*(S+TG)**(-1)*S4G**(-1) + 256*UG**(-1)*MG2*
     +    (S+UG)**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + COLO1(9)*N**2*CO*(S4G+MG2) * (  - 256*UG**(-1)*
     +    MG2**2*(S+TG)**(-2)*S4G**(-1) - 64*UG**(-1)*(S+TG)*S4G**(-2)
     +     - 192*UG**(-1)*S4G**(-1) - 64*UG*(S+TG)**(-2)*S4G**(-1) - 64
     +    *UG*(S+UG)**(-2)*S4G**(-1) - 256*MG2*(S+TG)**(-2)*S4G**(-1)
     +     - 256*MG2*(S+UG)**(-2)*S4G**(-1) - 64*(S+TG)**(-1)*S4G**(-1)
     +     - 64*(S+UG)**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(1)*N**2*CO * ( 128*MG2**3 )
     +
      M2GGH = M2GGH + ANG4(2)*N**2*CO * ( 128*UG**(-1)*MG2**3 - 32*UG*
     +    MG2 + 128*MG2**2 )
     +
      M2GGH = M2GGH + ANG4(3)*N**2*CO * (  - 128*S**(-1)*MG2**3 + 32*S*
     +    MG2 + 128*MG2**2 )
     +
      M2GGH = M2GGH + ANG4(4)*N**2*CO * (  - 128*S**(-2)*MG2**3 - 64*
     +    S**(-1)*TG**(-1)*UG*MG2**2 - 64*S**(-1)*TG**(-1)*MG2**3 - 128
     +    *S**(-1)*TG*UG**(-1)*MG2**2 + 16*S**(-1)*TG*MG2 - 64*S**(-1)*
     +    UG**(-1)*MG2**3 + 16*S**(-1)*UG*MG2 - 32*S**(-1)*UG*MG2**2*
     +    (TG+UG)**(-1) - 32*S**(-1)*UG*MG2**2*S4G**(-1) - 128*S**(-1)*
     +    MG2**2 - 32*S*TG**(-1)*UG**(-1)*MG2**2 + 8*S*TG**(-1)*MG2 - 
     +    32*S*UG**(-1)*MG2**2*(TG+UG)**(-1) - 32*S*UG**(-1)*MG2**2*
     +    (S+TG)**(-1) + 12*S*UG*MG2*(TG+UG)**(-1)*(S+TG)**(-1) - 6*S*
     +    UG*(TG+UG)**(-1) + 6*S*UG*(S+TG)**(-1) - 4*S*UG**2*
     +    (TG+UG)**(-1)*(S+TG)**(-1) - 24*S*MG2*(S+TG)**(-1) - 4*S - 4*
     +    S**2*TG**(-1) + 8*S**2*UG*(TG+UG)**(-1)*(S+TG)**(-1) - 8*S**2
     +    *MG2*(TG+UG)**(-1)*(S+TG)**(-1) - 2*S**2*(TG+UG)**(-1) - 6*
     +    S**2*(S+TG)**(-1) - 2*S**3*(TG+UG)**(-1)*(S+TG)**(-1) + 8*
     +    TG**(-1)*UG*MG2 + 32*TG**(-1)*UG*MG2**2*(S+TG)**(-1) - 4*
     +    TG**(-1)*UG**2 + 32*TG**(-1)*MG2**2 - 16*TG*UG**(-1)*MG2 + 32
     +    *TG*UG**(-1)*MG2**2*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(4)*N**2*CO * (  - 8*TG*UG*S4G**(-1) + 8*TG*
     +    MG2*S4G**(-1) + 4*TG - 4*TG**2*S4G**(-1) - 32*UG**(-1)*MG2**2
     +     + 64*UG**(-1)*MG2**3*S4G**(-1) + 4*UG*MG2*(TG+UG)**(-1) + 20
     +    *UG*MG2*(S+TG)**(-1) + 4*UG - 4*UG**2*MG2*(TG+UG)**(-1)*
     +    (S+TG)**(-1) - 6*UG**2*(TG+UG)**(-1) - 2*UG**2*(S+TG)**(-1)
     +     - 8*UG**2*S4G**(-1) - 2*UG**3*(TG+UG)**(-1)*(S+TG)**(-1) + 
     +    184*MG2 + 32*MG2**2*(TG+UG)**(-1) + 32*MG2**2*(S+TG)**(-1) + 
     +    64*MG2**2*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(5)*N**2*CO * ( 128*MG2**3 )
     +
      M2GGH = M2GGH + ANG4(6)*N**2*CO * ( 128*TG**(-1)*MG2**3 - 32*TG*
     +    MG2 + 128*MG2**2 )
     +
      M2GGH = M2GGH + ANG4(7)*N**2*CO * (  - 128*S**(-1)*MG2**3 + 32*S*
     +    MG2 + 128*MG2**2 )
     +
      M2GGH = M2GGH + ANG4(8)*N**2*CO * (  - 128*S**(-2)*MG2**3 - 128*
     +    S**(-1)*TG**(-1)*UG*MG2**2 - 64*S**(-1)*TG**(-1)*MG2**3 - 64*
     +    S**(-1)*TG*UG**(-1)*MG2**2 + 16*S**(-1)*TG*MG2 - 64*S**(-1)*
     +    UG**(-1)*MG2**3 + 16*S**(-1)*UG*MG2 + 32*S**(-1)*UG*MG2**2*
     +    (TG+UG)**(-1) + 32*S**(-1)*UG*MG2**2*S4G**(-1) - 192*S**(-1)*
     +    MG2**2 - 64*S*TG**(-1)*UG**(-1)*MG2**2 - 32*S*TG**(-1)*MG2**2
     +    *(S+UG)**(-1) + 2*S*TG*(S+UG)**(-1) + 8*S*UG**(-1)*MG2 + 32*S
     +    *UG**(-1)*MG2**2*(TG+UG)**(-1) - 12*S*UG*MG2*(TG+UG)**(-1)*
     +    (S+UG)**(-1) + 6*S*UG*(TG+UG)**(-1) + 4*S*UG*(S+UG)**(-1) - 4
     +    *S*UG**2*(TG+UG)**(-1)*(S+UG)**(-1) - 12*S*MG2*(S+UG)**(-1)
     +     - 10*S - 4*S**2*UG**(-1) - 8*S**2*UG*(TG+UG)**(-1)*
     +    (S+UG)**(-1) - 8*S**2*MG2*(TG+UG)**(-1)*(S+UG)**(-1) - 2*S**2
     +    *(TG+UG)**(-1) + 2*S**2*(S+UG)**(-1) - 2*S**3*(TG+UG)**(-1)*
     +    (S+UG)**(-1) - 16*TG**(-1)*UG*MG2 + 32*TG**(-1)*UG*MG2**2*
     +    S4G**(-1) - 32*TG**(-1)*MG2**2 + 64*TG**(-1)*MG2**3*S4G**(-1)
     +     + 8*TG*UG**(-1)*MG2 )
     +
      M2GGH = M2GGH + ANG4(8)*N**2*CO * ( 32*TG*UG**(-1)*MG2**2*
     +    (S+UG)**(-1) + 2*TG*UG*(S+UG)**(-1) - 8*TG*UG*S4G**(-1) + 16*
     +    TG*MG2*(S+UG)**(-1) - 2*TG - 4*TG**2*UG**(-1) - 4*TG**2*
     +    (S+UG)**(-1) - 8*TG**2*S4G**(-1) + 32*UG**(-1)*MG2**2 - 4*UG*
     +    MG2*(TG+UG)**(-1) + 4*UG*MG2*(S+UG)**(-1) + 8*UG*MG2*
     +    S4G**(-1) + 10*UG - 4*UG**2*MG2*(TG+UG)**(-1)*(S+UG)**(-1) - 
     +    6*UG**2*(TG+UG)**(-1) - 2*UG**2*(S+UG)**(-1) - 4*UG**2*
     +    S4G**(-1) + 2*UG**3*(TG+UG)**(-1)*(S+UG)**(-1) + 188*MG2 + 32
     +    *MG2**2*(TG+UG)**(-1) + 32*MG2**2*(S+UG)**(-1) + 96*MG2**2*
     +    S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(9)*N**2*CO * ( 64*S**(-2)*MG2 )
     +
      M2GGH = M2GGH + ANG4(10)*N**2*CO * ( 64*S**(-1)*MG2 )
     +
      M2GGH = M2GGH + ANG4(11)*N**2*CO * (  - 64*S**(-2)*MG2*
     +    (TG+UG)**(-1) + 4*S**(-1)*TG**(-1)*UG*S4G**(-1) + 4*S**(-1)*
     +    UG**(-1) - 12*S**(-1)*S4G**(-1) - 4*UG**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(12)*N**2*CO * (  - 64*S**(-2)*UG*MG2*
     +    (TG+UG)**(-1) - 64*S**(-2)*UG*MG2*S4G**(-1) + 2*S**(-1)*
     +    TG**(-1)*UG*MG2*S4G**(-1) - 12*S**(-1)*TG**(-1)*UG + 12*
     +    S**(-1)*TG**(-1)*UG**2*S4G**(-1) - 18*S**(-1)*TG**(-1)*MG2 - 
     +    32*S**(-1)*TG**(-1)*MG2**2*S4G**(-1) + 16*S**(-1)*UG**(-1)*
     +    MG2 + 32*S**(-1)*UG**(-1)*MG2**2*S4G**(-1) - 16*S**(-1)*UG*
     +    (TG+UG)**(-1) + 12*S**(-1)*UG*S4G**(-1) - 64*S**(-1)*MG2*
     +    (TG+UG)**(-1) - 30*S**(-1)*MG2*S4G**(-1) + 8*S**(-1) + 12*
     +    TG**(-1)*UG*S4G**(-1) - 6*TG**(-1)*MG2*S4G**(-1) + 8*TG*
     +    UG**(-1)*S4G**(-1) + 8*UG**(-1)*MG2*S4G**(-1) - 8*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(13)*N**2*CO * ( 64*S**(-2)*MG2 )
     +
      M2GGH = M2GGH + ANG4(14)*N**2*CO * ( 128*S**(-2)*UG*MG2 + 64*
     +    S**(-1)*MG2 )
     +
      M2GGH = M2GGH + ANG4(15)*N**2*CO * (  - 64*S**(-2)*MG2*
     +    (TG+UG)**(-1) - 4*S**(-1)*TG**(-1)*UG*S4G**(-1) - 4*S**(-1)*
     +    UG**(-1) + 12*S**(-1)*S4G**(-1) + 4*UG**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(16)*N**2*CO * (  - 64*S**(-2)*UG*MG2*
     +    (TG+UG)**(-1) + 64*S**(-2)*UG*MG2*S4G**(-1) + 4*S**(-1)*
     +    TG**(-1)*UG + 16*S**(-1)*TG**(-1)*MG2 + 32*S**(-1)*TG**(-1)*
     +    MG2**2*S4G**(-1) - 12*S**(-1)*TG*UG**(-1) - 16*S**(-1)*
     +    UG**(-1)*MG2 - 32*S**(-1)*UG**(-1)*MG2**2*S4G**(-1) - 16*
     +    S**(-1)*UG*(TG+UG)**(-1) - 16*S**(-1)*UG*S4G**(-1) - 64*
     +    S**(-1)*MG2*(TG+UG)**(-1) + 32*S**(-1)*MG2*S4G**(-1) + 24*
     +    S**(-1) - 8*TG**(-1)*MG2*S4G**(-1) + 8*UG**(-1)*MG2*S4G**(-1)
     +     - 8*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(17)*N**2*CO * ( 28*S**(-1)*TG*UG + 16*
     +    S**(-1)*TG*MG2 + 32*S**(-1)*TG**2 + 16*S**(-1)*TG**3*UG**(-1)
     +     + 32*S**(-1)*UG*MG2**2*(TG+UG)**(-1) + 8*S**(-1)*UG**2 + 32*
     +    S*TG**(-1)*UG**(-1)*MG2**2 + 8*S*TG**(-1)*UG - 8*S*TG**(-1)*
     +    MG2 - 32*S*TG**(-1)*MG2**2*(S+UG)**(-1) - 64*S*TG*UG**(-2)*
     +    MG2 + 48*S*TG*UG**(-1) - 10*S*TG*(S+UG)**(-1) - 32*S*UG**(-1)
     +    *MG2 + 32*S*UG**(-1)*MG2**2*(TG+UG)**(-1) - 18*S*UG*MG2*
     +    (TG+UG)**(-1)*(S+UG)**(-1) + 2*S*UG*(TG+UG)**(-1) + 2*S*MG2*
     +    (TG+UG)**(-1) - 8*S*MG2*(S+UG)**(-1) + 34*S + 4*S**2*TG**(-1)
     +     + 16*S**2*UG**(-1) - 2*S**2*UG*(TG+UG)**(-1)*(S+UG)**(-1) - 
     +    10*S**2*MG2*(TG+UG)**(-1)*(S+UG)**(-1) - 4*S**2*(TG+UG)**(-1)
     +     + 6*S**2*(S+UG)**(-1) + 8*TG**(-1)*UG**2 + 32*TG**(-1)*
     +    MG2**2 - 32*TG*UG**(-1)*MG2 + 2*TG*UG*(S+UG)**(-1) + 16*TG*
     +    MG2*(S+UG)**(-1) + 98*TG + 64*TG**2*UG**(-1) + 16*TG**2*
     +    (S+UG)**(-1) + 16*TG**3*UG**(-1)*(S+UG)**(-1) + 8*UG*MG2*
     +    (S+UG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(17)*N**2*CO * ( 58*UG - 8*UG**2*MG2*
     +    (TG+UG)**(-1)*(S+UG)**(-1) - 6*UG**2*(TG+UG)**(-1) - 2*UG**2*
     +    (S+UG)**(-1) + 2*UG**3*(TG+UG)**(-1)*(S+UG)**(-1) + 8*MG2 + 
     +    32*MG2**2*(TG+UG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(18)*N**2*CO * ( 16*S**(-1)*TG**(-1)*UG**3 + 
     +    28*S**(-1)*TG*UG + 8*S**(-1)*TG**2 + 16*S**(-1)*UG*MG2 - 32*
     +    S**(-1)*UG*MG2**2*(TG+UG)**(-1) + 32*S**(-1)*UG**2 + 32*
     +    S**(-1)*MG2**2 - 64*S*TG**(-2)*UG*MG2 + 64*S*TG**(-1)*
     +    UG**(-1)*MG2**2 + 48*S*TG**(-1)*UG - 32*S*TG**(-1)*MG2 + 8*S*
     +    TG*UG**(-1) - 8*S*UG**(-1)*MG2 - 32*S*UG**(-1)*MG2**2*
     +    (TG+UG)**(-1) - 32*S*UG**(-1)*MG2**2*(S+TG)**(-1) + 18*S*UG*
     +    MG2*(TG+UG)**(-1)*(S+TG)**(-1) - 2*S*UG*(TG+UG)**(-1) - 10*S*
     +    UG*(S+TG)**(-1) + 2*S*MG2*(TG+UG)**(-1) - 26*S*MG2*
     +    (S+TG)**(-1) + 36*S + 16*S**2*TG**(-1) + 4*S**2*UG**(-1) + 2*
     +    S**2*UG*(TG+UG)**(-1)*(S+TG)**(-1) - 10*S**2*MG2*
     +    (TG+UG)**(-1)*(S+TG)**(-1) - 4*S**2*(TG+UG)**(-1) + 4*S**2*
     +    (S+TG)**(-1) - 32*TG**(-1)*UG*MG2 + 64*TG**(-1)*UG**2 + 16*
     +    TG**(-1)*UG**3*(S+TG)**(-1) + 52*TG + 8*TG**2*UG**(-1) + 32*
     +    UG**(-1)*MG2**2 + 24*UG*MG2*(S+TG)**(-1) + 104*UG - 8*UG**2*
     +    MG2*(TG+UG)**(-1)*(S+TG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(18)*N**2*CO * (  - 6*UG**2*(TG+UG)**(-1) + 
     +    18*UG**2*(S+TG)**(-1) - 2*UG**3*(TG+UG)**(-1)*(S+TG)**(-1) + 
     +    8*MG2 + 32*MG2**2*(TG+UG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(19)*N**2*CO * ( 128*S**(-2)*MG2**3 + 64*
     +    S**(-1)*TG**(-1)*UG*MG2**2 + 64*S**(-1)*TG**(-1)*MG2**3 + 64*
     +    S**(-1)*TG*UG**(-1)*MG2**2 - 16*S**(-1)*TG*MG2 + 64*S**(-1)*
     +    UG**(-1)*MG2**3 - 16*S**(-1)*UG*MG2 + 128*S**(-1)*MG2**2 - 8*
     +    S*TG**(-1)*UG + 32*S*TG**(-1)*MG2**2*(S+UG)**(-1) - 8*S*TG*
     +    UG**(-1) + 32*S*UG**(-1)*MG2**2*(S+TG)**(-1) + 16*S*MG2*
     +    (S+TG)**(-1) + 16*S*MG2*(S+UG)**(-1) - 24*S - 8*S**2*TG**(-1)
     +     - 8*S**2*UG**(-1) - 4*S**2*(S+TG)**(-1) - 4*S**2*
     +    (S+UG)**(-1) + 8*TG**(-1)*UG*MG2 - 32*TG**(-1)*UG*MG2**2*
     +    (S+TG)**(-1) - 4*TG**(-1)*UG**2 + 64*TG**(-1)*MG2**2 + 8*TG*
     +    UG**(-1)*MG2 - 32*TG*UG**(-1)*MG2**2*(S+UG)**(-1) + 16*TG*MG2
     +    *(S+UG)**(-1) - 24*TG - 4*TG**2*UG**(-1) - 4*TG**2*
     +    (S+UG)**(-1) + 64*UG**(-1)*MG2**2 + 16*UG*MG2*(S+TG)**(-1) - 
     +    24*UG - 4*UG**2*(S+TG)**(-1) - 16*MG2 + 32*MG2**2*
     +    (S+TG)**(-1) + 32*MG2**2*(S+UG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(20)*N**2*CO * ( 32*S**(-1)*TG**(-1)*UG**(-1)
     +    *MG2**2 - 32*S**(-1)*TG**(-1)*MG2**2*S4G**(-1) - 16*S**(-1)*
     +    UG**(-1)*MG2 - 64*S**(-1)*UG**(-1)*MG2**2*S4G**(-1) - 16*
     +    S**(-1)*MG2*S4G**(-1) - 8*S*TG**(-1)*UG**(-1) + 8*TG**(-1)*
     +    UG**(-1)*MG2 + 8*TG**(-1)*MG2*S4G**(-1) + 8*TG**(-1) - 16*
     +    UG**(-1)*MG2*S4G**(-1) - 16*(S+TG)**(-1) - 8*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(21)*N**2*CO * ( 32*S**(-1)*TG**(-1)*UG**(-1)
     +    *MG2**2 - 4*S**(-1)*TG**(-1)*UG*MG2*S4G**(-1) - 12*S**(-1)*
     +    TG**(-1)*MG2 - 64*S**(-1)*TG**(-1)*MG2**2*S4G**(-1) - 32*
     +    S**(-1)*UG**(-1)*MG2**2*S4G**(-1) - 20*S**(-1)*MG2*S4G**(-1)
     +     - 8*S*TG**(-1)*UG**(-1) + 8*TG**(-1)*UG**(-1)*MG2 - 20*
     +    TG**(-1)*MG2*S4G**(-1) + 8*UG**(-1)*MG2*S4G**(-1) + 8*
     +    UG**(-1) - 16*(S+UG)**(-1) - 8*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(22)*N**2*CO * (  - 32*TG**(-1)*MG2 )
     +
      M2GGH = M2GGH + ANG4(23)*N**2*CO * ( 4*S**(-1)*TG**(-1)*UG*
     +    S4G**(-1) + 8*S**(-1)*S4G**(-1) - 4*TG**(-1)*UG**(-1) + 4*
     +    TG**(-1)*S4G**(-1) - 4*UG**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(36)*N**2*CO * ( 128*S**(-1)*MG2**2 + 96*MG2
     +     )
     +
      M2GGH = M2GGH + ANG4(37)*N**2*CO * (  - 8 - 30*S**(-1)*TG**(-1)*
     +    UG*MG2 - 40*S**(-1)*TG**(-1)*UG*MG2**2*S4G**(-1) + 14*S**(-1)
     +    *TG**(-1)*UG**2*MG2*S4G**(-1) - 12*S**(-1)*TG**(-1)*UG**2 + 
     +    16*S**(-1)*TG**(-1)*UG**3*S4G**(-1) + 8*S**(-1)*TG**(-1)*
     +    MG2**2 - 16*S**(-1)*TG*UG**(-1)*MG2 - 4*S**(-1)*TG + 4*
     +    S**(-1)*TG**2*UG**(-1) - 32*S**(-1)*UG**(-1)*MG2**2 - 32*
     +    S**(-1)*UG*MG2*(TG+UG)**(-1) - 18*S**(-1)*UG*MG2*S4G**(-1) - 
     +    4*S**(-1)*UG + 16*S**(-1)*UG**2*(TG+UG)**(-1) + 128*S**(-1)*
     +    MG2 + 64*S**(-1)*MG2**2*(TG+UG)**(-1) + 216*S**(-1)*MG2**2*
     +    S4G**(-1) + 22*TG**(-1)*UG*MG2*S4G**(-1) + 4*TG**(-1)*UG + 12
     +    *TG**(-1)*UG**2*S4G**(-1) - 24*TG**(-1)*MG2 - 8*TG**(-1)*
     +    MG2**2*S4G**(-1) + 8*TG*UG**(-1) + 20*TG*S4G**(-1) - 8*TG**2*
     +    UG**(-1)*S4G**(-1) + 64*UG**(-1)*MG2**2*S4G**(-1) - 8*UG*
     +    (TG+UG)**(-1) + 8*UG*S4G**(-1) - 16*MG2*(TG+UG)**(-1) + 8*MG2
     +    *S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(38)*N**2*CO * ( 64*S**(-2)*UG**2*MG2 + 64*
     +    S**(-1)*UG*MG2 + 192*MG2 )
     +
      M2GGH = M2GGH + ANG4(39)*N**2*CO * ( 28 + 64*S**(-2)*UG**2*MG2*
     +    S4G**(-1) + 32*S**(-1)*TG**(-1)*UG*MG2**2*S4G**(-1) - 18*
     +    S**(-1)*TG**(-1)*UG**2 + 10*S**(-1)*TG**(-1)*UG**3*S4G**(-1)
     +     - 16*S**(-1)*TG*UG**(-1)*MG2 + 40*S**(-1)*TG - 16*S**(-1)*
     +    TG**2*UG**(-1) - 32*S**(-1)*UG*MG2*(TG+UG)**(-1) + 64*S**(-1)
     +    *UG*MG2*S4G**(-1) - 16*S**(-1)*UG + 16*S**(-1)*UG**2*
     +    (TG+UG)**(-1) + 42*S**(-1)*UG**2*S4G**(-1) + 112*S**(-1)*MG2
     +     + 64*S**(-1)*MG2**2*(TG+UG)**(-1) - 32*S**(-1)*MG2**2*
     +    S4G**(-1) - 8*TG**(-1)*UG*MG2*S4G**(-1) - 8*TG**(-1)*UG + 14*
     +    TG**(-1)*UG**2*S4G**(-1) + 32*TG**(-1)*MG2 - 8*TG*UG**(-1)*
     +    MG2*S4G**(-1) - 16*TG*UG**(-1) - 12*TG*S4G**(-1) + 4*TG**2*
     +    UG**(-1)*S4G**(-1) + 24*UG**(-1)*MG2 - 32*UG**(-1)*MG2**2*
     +    S4G**(-1) - 8*UG*(TG+UG)**(-1) + 20*UG*S4G**(-1) - 16*MG2*
     +    (TG+UG)**(-1) + 32*MG2*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(40)*N**2*CO * (  - 32*S*UG**(-1)*MG2 + 128*
     +    UG**(-2)*MG2**3 + 128*UG**(-1)*MG2**2 + 32*MG2 )
     +
      M2GGH = M2GGH + ANG4(41)*N**2*CO * ( 24 + 64*S**(-1)*TG**(-1)*
     +    UG**(-1)*MG2**3 - 64*S**(-1)*TG**(-1)*MG2**3*S4G**(-1) - 16*
     +    S**(-1)*TG*UG**(-1)*MG2 + 12*S**(-1)*TG + 4*S**(-1)*TG**2*
     +    UG**(-1) - 32*S**(-1)*UG**(-1)*MG2**2 - 64*S**(-1)*UG**(-1)*
     +    MG2**3*S4G**(-1) - 16*S**(-1)*UG*MG2*S4G**(-1) + 12*S**(-1)*
     +    UG + 4*S**(-1)*UG**2*S4G**(-1) - 16*S**(-1)*MG2 - 32*S**(-1)*
     +    MG2**2*S4G**(-1) - 12*S*TG**(-1) - 32*S*UG**(-2)*MG2 - 12*S*
     +    UG**(-1) - 8*S*(S+TG)**(-1) - 8*S**2*TG**(-1)*UG**(-1) + 64*
     +    TG**(-1)*UG**(-1)*MG2**2 - 8*TG**(-1)*UG*MG2*S4G**(-1) - 20*
     +    TG**(-1)*UG - 4*TG**(-1)*UG**2*S4G**(-1) + 40*TG**(-1)*MG2 + 
     +    32*TG**(-1)*MG2**2*S4G**(-1) - 32*TG*UG**(-2)*MG2 + 8*TG*
     +    UG**(-1) - 8*TG*S4G**(-1) + 128*UG**(-2)*MG2**2 + 128*
     +    UG**(-2)*MG2**3*S4G**(-1) + 104*UG**(-1)*MG2 + 64*UG**(-1)*
     +    MG2**2*(S+TG)**(-1) + 64*UG**(-1)*MG2**2*S4G**(-1) + 16*UG*
     +    (S+TG)**(-1) - 4*UG*S4G**(-1) + 64*MG2*(S+TG)**(-1) - 24*MG2*
     +    S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(42)*N**2*CO * (  - 16*S**(-1)*TG**(-1)*
     +    UG**(-1)*MG2 - 32*S**(-1)*TG**(-1)*UG*MG2*S4G**(-2) + 6*
     +    S**(-1)*TG**(-1)*UG*S4G**(-1) + 48*S**(-1)*TG**(-1)*MG2*
     +    S4G**(-1) + 10*S**(-1)*TG**(-1) + 16*S**(-1)*UG**(-1)*MG2*
     +    S4G**(-1) + 16*S**(-1)*UG**(-1) - 32*S**(-1)*MG2*S4G**(-2) - 
     +    10*S**(-1)*S4G**(-1) - 24*TG**(-1)*UG**(-1) - 32*TG**(-1)*MG2
     +    *S4G**(-2) + 6*TG**(-1)*S4G**(-1) - 32*UG**(-2)*MG2*S4G**(-1)
     +     - 8*UG**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(43)*N**2*CO * (  - 32*S*TG**(-1)*MG2 + 128*
     +    TG**(-2)*MG2**3 + 128*TG**(-1)*MG2**2 + 32*MG2 )
     +
      M2GGH = M2GGH + ANG4(44)*N**2*CO * ( 24 + 64*S**(-1)*TG**(-1)*
     +    UG**(-1)*MG2**3 - 24*S**(-1)*TG**(-1)*UG*MG2 + 8*S**(-1)*
     +    TG**(-1)*UG**2*MG2*S4G**(-1) + 6*S**(-1)*TG**(-1)*UG**2 - 2*
     +    S**(-1)*TG**(-1)*UG**3*S4G**(-1) - 32*S**(-1)*TG**(-1)*MG2**2
     +     - 64*S**(-1)*TG**(-1)*MG2**3*S4G**(-1) + 16*S**(-1)*TG - 64*
     +    S**(-1)*UG**(-1)*MG2**3*S4G**(-1) + 24*S**(-1)*UG*MG2*
     +    S4G**(-1) + 8*S**(-1)*UG + 2*S**(-1)*UG**2*S4G**(-1) - 32*
     +    S**(-1)*MG2 - 32*S**(-1)*MG2**2*S4G**(-1) - 32*S*TG**(-2)*MG2
     +     - 12*S*TG**(-1) - 12*S*UG**(-1) - 8*S*(S+UG)**(-1) - 8*S**2*
     +    TG**(-1)*UG**(-1) - 32*TG**(-2)*UG*MG2 + 128*TG**(-2)*MG2**2
     +     + 128*TG**(-2)*MG2**3*S4G**(-1) + 64*TG**(-1)*UG**(-1)*
     +    MG2**2 + 8*TG**(-1)*UG*MG2*S4G**(-1) + 8*TG**(-1)*UG - 2*
     +    TG**(-1)*UG**2*S4G**(-1) + 104*TG**(-1)*MG2 + 64*TG**(-1)*
     +    MG2**2*(S+UG)**(-1) + 64*TG**(-1)*MG2**2*S4G**(-1) - 8*TG*
     +    UG**(-1)*MG2*S4G**(-1) - 20*TG*UG**(-1) + 16*TG*(S+UG)**(-1)
     +     - 8*TG*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(44)*N**2*CO * (  - 4*TG**2*UG**(-1)*
     +    S4G**(-1) + 40*UG**(-1)*MG2 + 32*UG**(-1)*MG2**2*S4G**(-1) - 
     +    4*UG*S4G**(-1) + 64*MG2*(S+UG)**(-1) - 8*MG2*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(45)*N**2*CO * (  - 16*S**(-1)*TG**(-1)*
     +    UG**(-1)*MG2 - 16*S**(-1)*TG**(-1)*UG*MG2*S4G**(-2) - 5*
     +    S**(-1)*TG**(-1)*UG*S4G**(-1) + 32*S**(-1)*TG**(-1)*MG2*
     +    S4G**(-1) + 13*S**(-1)*TG**(-1) + 16*S**(-1)*UG**(-1)*MG2*
     +    S4G**(-1) + 8*S**(-1)*UG**(-1) - 16*S**(-1)*MG2*S4G**(-2) + 
     +    11*S**(-1)*S4G**(-1) - 32*TG**(-2)*MG2*S4G**(-1) - 24*
     +    TG**(-1)*UG**(-1) - 16*TG**(-1)*MG2*S4G**(-2) - 5*TG**(-1)*
     +    S4G**(-1) + 8*UG**(-1)*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(48)*N**2*CO * ( 32*S**(-1)*TG**(-1)*UG**3 + 
     +    96*S**(-1)*TG*UG + 64*S**(-1)*TG**2 + 32*S**(-1)*TG**3*
     +    UG**(-1) + 64*S**(-1)*UG**2 + 28*S*TG**(-1)*UG + 32*S*
     +    TG**(-1)*MG2**2*(S+UG)**(-1) + 28*S*TG*UG**(-1) + 12*S*TG*
     +    (S+UG)**(-1) + 32*S*UG**(-1)*MG2**2*(S+TG)**(-1) + 12*S*UG*
     +    (S+TG)**(-1) + 16*S*MG2*(S+TG)**(-1) + 16*S*MG2*(S+UG)**(-1)
     +     + 64*S + 8*S**2*TG**(-1) + 8*S**2*UG**(-1) + 4*S**2*
     +    (S+TG)**(-1) + 4*S**2*(S+UG)**(-1) + 16*TG**(-1)*UG*MG2 + 32*
     +    TG**(-1)*UG**2 - 16*TG**(-1)*UG**3*(S+TG)**(-1) + 16*TG*
     +    UG**(-1)*MG2 + 16*TG*MG2*(S+UG)**(-1) + 112*TG + 32*TG**2*
     +    UG**(-1) + 16*TG**2*(S+UG)**(-1) - 16*TG**3*UG**(-1)*
     +    (S+UG)**(-1) + 16*UG*MG2*(S+TG)**(-1) + 112*UG + 16*UG**2*
     +    (S+TG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(49)*N**2*CO * ( 32*S**(-1)*TG**(-1)*UG*
     +    MG2**2 - 12*S**(-1)*TG*UG + 8*S**(-1)*TG**2 + 16*S**(-1)*UG*
     +    MG2 + 12*S**(-1)*UG**2 - 16*S**(-1)*UG**3*(TG+UG)**(-1) + 32*
     +    S**(-1)*MG2**2 + 64*S*TG**(-1)*UG**(-1)*MG2**2 + 8*S*TG*
     +    UG**(-1) + 16*S*UG**(-1)*MG2 - 32*S*UG**(-1)*MG2**2*
     +    (TG+UG)**(-1) - 32*S*UG**(-1)*MG2**2*(S+TG)**(-1) + 12*S*UG*
     +    MG2*(TG+UG)**(-1)*(S+TG)**(-1) - 18*S*UG*(TG+UG)**(-1) + 6*S*
     +    UG*(S+TG)**(-1) - 4*S*UG**2*(TG+UG)**(-1)*(S+TG)**(-1) + 24*S
     +    *MG2*(TG+UG)**(-1) - 24*S*MG2*(S+TG)**(-1) + 16*S + 4*S**2*
     +    UG**(-1) + 8*S**2*UG*(TG+UG)**(-1)*(S+TG)**(-1) - 8*S**2*MG2*
     +    (TG+UG)**(-1)*(S+TG)**(-1) + 6*S**2*(TG+UG)**(-1) - 6*S**2*
     +    (S+TG)**(-1) - 2*S**3*(TG+UG)**(-1)*(S+TG)**(-1) + 32*
     +    TG**(-1)*UG*MG2**2*(S+TG)**(-1) + 64*TG**(-1)*MG2**2 + 12*TG
     +     + 8*TG**2*UG**(-1) + 32*UG**(-1)*MG2**2 - 20*UG*MG2*
     +    (TG+UG)**(-1) + 20*UG*MG2*(S+TG)**(-1) - 16*UG - 4*UG**2*MG2*
     +    (TG+UG)**(-1)*(S+TG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(49)*N**2*CO * ( 14*UG**2*(TG+UG)**(-1) - 2*
     +    UG**2*(S+TG)**(-1) - 2*UG**3*(TG+UG)**(-1)*(S+TG)**(-1) + 32*
     +    MG2 + 32*MG2**2*(S+TG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(50)*N**2*CO * ( 32*S**(-1)*TG*UG**(-1)*
     +    MG2**2 + 4*S**(-1)*TG*UG + 16*S**(-1)*TG*MG2 - 4*S**(-1)*
     +    TG**2 - 8*S**(-1)*UG**2 + 16*S**(-1)*UG**3*(TG+UG)**(-1) + 32
     +    *S**(-1)*MG2**2 + 32*S*TG**(-1)*UG**(-1)*MG2**2 + 8*S*
     +    TG**(-1)*UG + 16*S*TG**(-1)*MG2 - 32*S*TG**(-1)*MG2**2*
     +    (S+UG)**(-1) + 2*S*TG*(S+UG)**(-1) + 32*S*UG**(-1)*MG2**2*
     +    (TG+UG)**(-1) - 12*S*UG*MG2*(TG+UG)**(-1)*(S+UG)**(-1) + 18*S
     +    *UG*(TG+UG)**(-1) + 4*S*UG*(S+UG)**(-1) - 4*S*UG**2*
     +    (TG+UG)**(-1)*(S+UG)**(-1) + 24*S*MG2*(TG+UG)**(-1) - 12*S*
     +    MG2*(S+UG)**(-1) - 2*S + 4*S**2*TG**(-1) - 8*S**2*UG*
     +    (TG+UG)**(-1)*(S+UG)**(-1) - 8*S**2*MG2*(TG+UG)**(-1)*
     +    (S+UG)**(-1) + 6*S**2*(TG+UG)**(-1) + 2*S**2*(S+UG)**(-1) - 2
     +    *S**3*(TG+UG)**(-1)*(S+UG)**(-1) + 8*TG**(-1)*UG**2 + 32*
     +    TG**(-1)*MG2**2 + 32*TG*UG**(-1)*MG2**2*(S+UG)**(-1) + 2*TG*
     +    UG*(S+UG)**(-1) + 16*TG*MG2*(S+UG)**(-1) - 2*TG - 4*TG**2*
     +    (S+UG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(50)*N**2*CO * ( 64*UG**(-1)*MG2**2 + 20*UG*
     +    MG2*(TG+UG)**(-1) + 4*UG*MG2*(S+UG)**(-1) - 2*UG - 4*UG**2*
     +    MG2*(TG+UG)**(-1)*(S+UG)**(-1) + 14*UG**2*(TG+UG)**(-1) - 2*
     +    UG**2*(S+UG)**(-1) + 2*UG**3*(TG+UG)**(-1)*(S+UG)**(-1) + 12*
     +    MG2 + 32*MG2**2*(S+UG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(51)*N**2*CO * ( 64*S**2*MG2 )
     +
      M2GGH = M2GGH + ANG4(52)*N**2*CO * ( 64*S*MG2 )
     +
      M2GGH = M2GGH + ANG4(53)*N**2*CO * ( 128*S*TG*UG**(-1)*MG2 + 64*
     +    S**2*UG**(-1)*MG2 )
     +
      M2GGH = M2GGH + ANG4(54)*N**2*CO * (  - 32*S**(-1)*TG**(-1)*UG**3
     +     - 160*S**(-1)*TG*UG - 96*S**(-1)*TG**2 - 64*S**(-1)*TG**3*
     +    UG**(-1) - 64*S**(-1)*UG**2 - 16*S**(-1)*UG**3*(TG+UG)**(-1)
     +     - 16*S**(-1)*UG**3*S4G**(-1) - 32*S*TG**(-1)*UG**(-1)*MG2**2
     +     - 12*S*TG**(-1)*UG + 16*S*TG**(-1)*MG2 + 64*S*TG*UG**(-2)*
     +    MG2 - 64*S*TG*UG**(-1) + 96*S*UG**(-1)*MG2 - 32*S*UG**(-1)*
     +    MG2**2*(TG+UG)**(-1) - 32*S*UG**(-1)*MG2**2*(S+TG)**(-1) + 18
     +    *S*UG*MG2*(TG+UG)**(-1)*(S+TG)**(-1) - 14*S*UG*(TG+UG)**(-1)
     +     - 10*S*UG*(S+TG)**(-1) + 26*S*MG2*(TG+UG)**(-1) - 26*S*MG2*
     +    (S+TG)**(-1) - 36*S - 4*S**2*TG**(-1) - 16*S**2*UG**(-1) + 2*
     +    S**2*UG*(TG+UG)**(-1)*(S+TG)**(-1) - 10*S**2*MG2*
     +    (TG+UG)**(-1)*(S+TG)**(-1) + 4*S**2*(TG+UG)**(-1) + 4*S**2*
     +    (S+TG)**(-1) + 16*TG**(-1)*UG*MG2 - 16*TG**(-1)*UG**2 + 16*
     +    TG**(-1)*UG**3*(S+TG)**(-1) + 64*TG*UG**(-1)*MG2 + 32*TG*
     +    UG**(-1)*MG2**2*S4G**(-1) + 4*TG*UG*S4G**(-1) + 16*TG*MG2*
     +    S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(54)*N**2*CO * (  - 92*TG - 96*TG**2*UG**(-1)
     +     - 4*TG**2*S4G**(-1) - 32*UG**(-1)*MG2**2 - 24*UG*MG2*
     +    (TG+UG)**(-1) + 24*UG*MG2*(S+TG)**(-1) - 88*UG - 8*UG**2*MG2*
     +    (TG+UG)**(-1)*(S+TG)**(-1) + 14*UG**2*(TG+UG)**(-1) + 18*
     +    UG**2*(S+TG)**(-1) - 8*UG**2*S4G**(-1) - 2*UG**3*
     +    (TG+UG)**(-1)*(S+TG)**(-1) + 176*MG2 + 32*MG2**2*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(55)*N**2*CO * ( 64*S**2*MG2 )
     +
      M2GGH = M2GGH + ANG4(56)*N**2*CO * ( 64*S*MG2 )
     +
      M2GGH = M2GGH + ANG4(57)*N**2*CO * ( 128*S*TG**(-1)*UG*MG2 + 64*
     +    S**2*TG**(-1)*MG2 )
     +
      M2GGH = M2GGH + ANG4(58)*N**2*CO * (  - 64*S**(-1)*TG**(-1)*UG**3
     +     - 128*S**(-1)*TG*UG - 96*S**(-1)*TG**2 - 32*S**(-1)*TG**3*
     +    UG**(-1) - 128*S**(-1)*UG**2 + 16*S**(-1)*UG**3*(TG+UG)**(-1)
     +     + 16*S**(-1)*UG**3*S4G**(-1) + 64*S*TG**(-2)*UG*MG2 - 64*S*
     +    TG**(-1)*UG**(-1)*MG2**2 - 64*S*TG**(-1)*UG + 96*S*TG**(-1)*
     +    MG2 - 32*S*TG**(-1)*MG2**2*(S+UG)**(-1) - 12*S*TG*UG**(-1) - 
     +    10*S*TG*(S+UG)**(-1) + 16*S*UG**(-1)*MG2 + 32*S*UG**(-1)*
     +    MG2**2*(TG+UG)**(-1) - 18*S*UG*MG2*(TG+UG)**(-1)*(S+UG)**(-1)
     +     + 14*S*UG*(TG+UG)**(-1) + 26*S*MG2*(TG+UG)**(-1) - 8*S*MG2*
     +    (S+UG)**(-1) - 50*S - 16*S**2*TG**(-1) - 4*S**2*UG**(-1) - 2*
     +    S**2*UG*(TG+UG)**(-1)*(S+UG)**(-1) - 10*S**2*MG2*
     +    (TG+UG)**(-1)*(S+UG)**(-1) + 4*S**2*(TG+UG)**(-1) + 6*S**2*
     +    (S+UG)**(-1) + 64*TG**(-1)*UG*MG2 + 32*TG**(-1)*UG*MG2**2*
     +    S4G**(-1) - 96*TG**(-1)*UG**2 - 32*TG**(-1)*MG2**2 + 16*TG*
     +    UG**(-1)*MG2 + 2*TG*UG*(S+UG)**(-1) - 12*TG*UG*S4G**(-1) + 16
     +    *TG*MG2*(S+UG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(58)*N**2*CO * (  - 74*TG - 16*TG**2*UG**(-1)
     +     + 16*TG**2*(S+UG)**(-1) + 8*TG**2*S4G**(-1) + 16*TG**3*
     +    UG**(-1)*(S+UG)**(-1) + 24*UG*MG2*(TG+UG)**(-1) + 8*UG*MG2*
     +    (S+UG)**(-1) + 16*UG*MG2*S4G**(-1) - 106*UG - 8*UG**2*MG2*
     +    (TG+UG)**(-1)*(S+UG)**(-1) + 14*UG**2*(TG+UG)**(-1) - 2*UG**2
     +    *(S+UG)**(-1) + 12*UG**2*S4G**(-1) + 2*UG**3*(TG+UG)**(-1)*
     +    (S+UG)**(-1) + 152*MG2 + 32*MG2**2*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(59)*N**2*CO * ( 64*TG**2*MG2 )
     +
      M2GGH = M2GGH + ANG4(60)*N**2*CO * ( 64*TG*MG2 + 128*MG2**2 )
     +
      M2GGH = M2GGH + ANG4(61)*N**2*CO * ( 128*S*TG*UG**(-1)*MG2 + 64*
     +    TG**2*UG**(-1)*MG2 )
     +
      M2GGH = M2GGH + ANG4(62)*N**2*CO * (  - 32*S**(-1)*TG**(-1)*UG*
     +    MG2**2 - 12*S**(-1)*TG*UG + 16*S**(-1)*TG*MG2 - 16*S**(-1)*
     +    TG**2 - 16*S**(-1)*TG**3*UG**(-1) + 16*S**(-1)*UG*MG2 - 4*
     +    S**(-1)*UG**2 - 128*S*TG**(-1)*UG**(-1)*MG2**2 + 32*S*
     +    TG**(-1)*MG2**2*(S+UG)**(-1) + 64*S*TG*UG**(-2)*MG2 - 80*S*TG
     +    *UG**(-1) + 12*S*TG*(S+UG)**(-1) + 64*S*UG**(-1)*MG2 + 32*S*
     +    UG**(-1)*MG2**2*(S+TG)**(-1) + 16*S*MG2*(S+TG)**(-1) + 16*S*
     +    MG2*(S+UG)**(-1) - 32*S - 32*S**2*UG**(-1) - 4*S**2*
     +    (S+TG)**(-1) + 4*S**2*(S+UG)**(-1) - 32*TG**(-1)*UG*MG2**2*
     +    (S+TG)**(-1) - 32*TG**(-1)*UG*MG2**2*S4G**(-1) - 96*TG**(-1)*
     +    MG2**2 + 96*TG*UG**(-1)*MG2 - 32*TG*UG**(-1)*MG2**2*S4G**(-1)
     +     + 16*TG*MG2*(S+UG)**(-1) - 16*TG*MG2*S4G**(-1) - 56*TG - 96*
     +    TG**2*UG**(-1) + 16*TG**2*(S+UG)**(-1) + 4*TG**2*S4G**(-1) - 
     +    16*TG**3*UG**(-1)*(S+UG)**(-1) + 160*UG**(-1)*MG2**2 + 16*UG*
     +    MG2*(S+TG)**(-1) - 16*UG*MG2*S4G**(-1) - 36*UG - 4*UG**2*
     +    (S+TG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(62)*N**2*CO * ( 4*UG**2*S4G**(-1) + 160*MG2
     +     + 32*MG2**2*(S+TG)**(-1) - 32*MG2**2*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(63)*N**2*CO * (  - 32*S**(-1)*TG**(-1)*
     +    UG**(-1)*MG2**2 + 32*S**(-1)*TG**(-1)*MG2**2*S4G**(-1) + 12*
     +    S**(-1)*TG*UG**(-1) + 16*S**(-1)*UG**(-1)*MG2 + 64*S**(-1)*
     +    UG**(-1)*MG2**2*S4G**(-1) + 4*S**(-1)*UG*S4G**(-1) + 16*
     +    S**(-1)*MG2*S4G**(-1) + 4*S**(-1) - 16*TG**(-1)*UG**(-1)*MG2
     +     - 16*TG**(-1)*MG2*S4G**(-1) - 20*UG**(-1) - 16*(S+TG)**(-1)
     +     )
     +
      M2GGH = M2GGH + ANG4(64)*N**2*CO * ( 64*UG**2*MG2 )
     +
      M2GGH = M2GGH + ANG4(65)*N**2*CO * ( 64*UG*MG2 + 128*MG2**2 )
     +
      M2GGH = M2GGH + ANG4(66)*N**2*CO * ( 128*S*TG**(-1)*UG*MG2 + 64*
     +    TG**(-1)*UG**2*MG2 )
     +
      M2GGH = M2GGH + ANG4(67)*N**2*CO * (  - 16*S**(-1)*TG**(-1)*UG**3
     +     - 32*S**(-1)*TG*UG**(-1)*MG2**2 - 12*S**(-1)*TG*UG + 16*
     +    S**(-1)*TG*MG2 - 4*S**(-1)*TG**2 + 16*S**(-1)*UG*MG2 - 16*
     +    S**(-1)*UG**2 + 64*S*TG**(-2)*UG*MG2 - 128*S*TG**(-1)*
     +    UG**(-1)*MG2**2 - 80*S*TG**(-1)*UG + 64*S*TG**(-1)*MG2 + 32*S
     +    *TG**(-1)*MG2**2*(S+UG)**(-1) + 32*S*UG**(-1)*MG2**2*
     +    (S+TG)**(-1) + 12*S*UG*(S+TG)**(-1) + 16*S*MG2*(S+TG)**(-1)
     +     + 16*S*MG2*(S+UG)**(-1) - 32*S - 32*S**2*TG**(-1) + 4*S**2*
     +    (S+TG)**(-1) - 4*S**2*(S+UG)**(-1) + 96*TG**(-1)*UG*MG2 - 32*
     +    TG**(-1)*UG*MG2**2*S4G**(-1) - 96*TG**(-1)*UG**2 - 16*
     +    TG**(-1)*UG**3*(S+TG)**(-1) + 160*TG**(-1)*MG2**2 - 32*TG*
     +    UG**(-1)*MG2**2*(S+UG)**(-1) - 32*TG*UG**(-1)*MG2**2*
     +    S4G**(-1) + 16*TG*MG2*(S+UG)**(-1) - 16*TG*MG2*S4G**(-1) - 36
     +    *TG - 4*TG**2*(S+UG)**(-1) + 4*TG**2*S4G**(-1) - 96*UG**(-1)*
     +    MG2**2 + 16*UG*MG2*(S+TG)**(-1) - 16*UG*MG2*S4G**(-1) - 56*UG
     +     + 16*UG**2*(S+TG)**(-1) )
     +
      M2GGH = M2GGH + ANG4(67)*N**2*CO * ( 4*UG**2*S4G**(-1) + 160*MG2
     +     + 32*MG2**2*(S+UG)**(-1) - 32*MG2**2*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(68)*N**2*CO * (  - 32*S**(-1)*TG**(-1)*
     +    UG**(-1)*MG2**2 + 15*S**(-1)*TG**(-1)*UG*MG2*S4G**(-1) + 8*
     +    S**(-1)*TG**(-1)*UG + 4*S**(-1)*TG**(-1)*UG**2*S4G**(-1) + 
     +    S**(-1)*TG**(-1)*MG2 + 64*S**(-1)*TG**(-1)*MG2**2*S4G**(-1)
     +     + 32*S**(-1)*UG**(-1)*MG2**2*S4G**(-1) + 31*S**(-1)*MG2*
     +    S4G**(-1) + 8*S**(-1) - 16*TG**(-1)*UG**(-1)*MG2 + 4*TG**(-1)
     +    *UG*S4G**(-1) + 15*TG**(-1)*MG2*S4G**(-1) - 20*TG**(-1) - 16*
     +    UG**(-1)*MG2*S4G**(-1) - 16*(S+UG)**(-1) - 4*S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(69)*N**2*CO * (  - 3*S**(-1)*TG**(-1)*UG*
     +    S4G**(-1) - S**(-1)*TG**(-1) - 7*S**(-1)*S4G**(-1) + 4*
     +    TG**(-1)*UG**(-1) - 3*TG**(-1)*S4G**(-1) + 4*UG**(-1)*
     +    S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(70)*N**2*CO * ( 128*S*TG*UG**(-2)*MG2 + 64*
     +    S**2*UG**(-2)*MG2 + 64*TG**2*UG**(-2)*MG2 )
     +
      M2GGH = M2GGH + ANG4(71)*N**2*CO * ( 128*S*TG**(-2)*UG*MG2 + 64*
     +    S**2*TG**(-2)*MG2 + 64*TG**(-2)*UG**2*MG2 )
     +
      M2GGH = M2GGH + ANG4(105)*N**2*CO * ( 4*S**(-1)*UG**(-1) + 4*
     +    S**(-1)*S4G**(-1) - 4*TG**(-1)*UG**(-1) - 4*TG**(-1)*
     +    S4G**(-1) )
     +
      M2GGH = M2GGH + ANG4(106)*N**2*CO * (  - 32*UG**(-1)*MG2 )
     +
      M2GGH = M2GGH + ANG4(107)*N**2*CO * (  - 4*S**(-1)*UG**(-1) - 4*
     +    S**(-1)*S4G**(-1) + 4*TG**(-1)*UG**(-1) + 4*TG**(-1)*
     +    S4G**(-1) )


      DGGGGH = S4G/(S4G+MG2)/2.D0 *
     +     0.5D0 * ALPHAS**3 * AVG * M2GGH /4.D0 /S**2 *CONV
      RETURN
      END


      REAL*8 FUNCTION DGGGGD(ALPHAS,S,TG,S4G,MS,MG,DEL,S4GMAX)
C***  LOG(DEL) PART OF CROSS SECTION FOR G +G -> GL + GL +G 
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4G,TG,SBG,MS,MG,MG2
      REAL*8 M2GGD,CO
      REAL*8 NS,CONV,N,AVG,BETA,XG,DEL,S4GMAX,DLDEL1,DLDEL2
      REAL*8 COLO1(1:9)

      NS = 6.D0
      CONV = 389379660.D0
      N = 3.D0
      CO = N*(N**2 -1.D0)
      AVG = (1.D0/2.D0)**2 * (1.D0/(N**2 -1.D0))**2

      MG2 = MG**2
      SBG = S*SQRT(1 -4.D0*MG2/S)
      BETA = SQRT(1 -4*MG2/S)
      XG = (1.D0 -BETA)/(1.D0 +BETA)

      DLDEL1 = LOG(S4GMAX/MG2) -(S4GMAX-DEL)/S4G
      DLDEL2 = LOG(S4GMAX/MG2)**2 -2.D0*(S4GMAX-DEL)/S4G*LOG(S4G/MG2)

      COLO1(1) = LOG(XG)
      COLO1(3) = LOG(S/MG2)
      COLO1(4) = LOG(-TG/MG2)
      COLO1(8) = LOG((S+TG)/MG2)

      M2GGD = 0.D0
      M2GGD = M2GGD + N**2*CO*DLDEL1 * ( 192 + 128*S**(-2)*TG**2 + 
     +    128*S**(-1)*TG + 256*S**(-1)*MG2 + 64*S*TG**(-1) - 64*S*
     +    (S+TG)**(-1) + 256*TG**(-2)*MG2**2 + 256*TG**(-1)*MG2 - 256*
     +    TG**(-1)*MG2**2*(S+TG)**(-1) - 256*MG2*(S+TG)**(-1) + 256*
     +    MG2**2*(S+TG)**(-2) )
     +
      M2GGD = M2GGD + N**2*CO*DLDEL2 * (  - 192 - 128*S**(-2)*TG**2
     +     - 128*S**(-1)*TG - 256*S**(-1)*MG2 - 64*S*TG**(-1) + 64*S*
     +    (S+TG)**(-1) - 256*TG**(-2)*MG2**2 - 256*TG**(-1)*MG2 + 256*
     +    TG**(-1)*MG2**2*(S+TG)**(-1) + 256*MG2*(S+TG)**(-1) - 256*
     +    MG2**2*(S+TG)**(-2) )
     +
      M2GGD = M2GGD + COLO1(1)*N**2*CO*DLDEL1 * (  - 128*S**(-2)*
     +    TG**2*SBG**(-1)*MG2 - 128*S**(-1)*TG*SBG**(-1)*MG2 + 64*
     +    S**(-1)*TG**2*SBG**(-1) - 256*S**(-1)*SBG**(-1)*MG2**2 + 64*S
     +    *TG**(-2)*SBG**(-1)*MG2**2 + 32*S*TG**(-1)*SBG**(-1)*MG2 - 32
     +    *S*SBG**(-1)*MG2*(S+TG)**(-1) + 64*S*SBG**(-1)*MG2**2*
     +    (S+TG)**(-2) + 64*S*SBG**(-1) + 16*S**2*TG**(-1)*SBG**(-1) - 
     +    16*S**2*SBG**(-1)*(S+TG)**(-1) - 128*TG**(-2)*SBG**(-1)*
     +    MG2**3 - 128*TG**(-1)*SBG**(-1)*MG2**2 + 64*TG*SBG**(-1) + 
     +    128*SBG**(-1)*MG2**2*(S+TG)**(-1) - 128*SBG**(-1)*MG2**3*
     +    (S+TG)**(-2) )
     +
      M2GGD = M2GGD + COLO1(3)*N**2*CO*DLDEL1 * (  - 64 - 64*
     +    S**(-2)*TG**2 - 64*S**(-1)*TG - 128*S**(-1)*MG2 - 16*S*
     +    TG**(-1) + 16*S*(S+TG)**(-1) - 64*TG**(-2)*MG2**2 - 64*
     +    TG**(-1)*MG2 + 64*MG2*(S+TG)**(-1) - 64*MG2**2*(S+TG)**(-2) )
     +
      M2GGD = M2GGD + COLO1(4)*N**2*CO*DLDEL1 * ( 32 + 64*S**(-2)*
     +    TG**2 + 128*S**(-1)*MG2 - 32*S*(S+TG)**(-1) - 128*MG2*
     +    (S+TG)**(-1) + 128*MG2**2*(S+TG)**(-2) )
     +
      M2GGD = M2GGD + COLO1(8)*N**2*CO*DLDEL1 * ( 96 + 64*S**(-2)*
     +    TG**2 + 128*S**(-1)*TG + 128*S**(-1)*MG2 + 32*S*TG**(-1) + 
     +    128*TG**(-2)*MG2**2 + 128*TG**(-1)*MG2 )


      DGGGGD = 0.5D0* ALPHAS**3 * AVG * M2GGD /4.D0 /S**2 *CONV
      RETURN
      END



      REAL*8 FUNCTION DGGQB1(ALPHAS,S,TG,MS,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF VIRTUAL
C***  SCA = Q**2/MG**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,TG,UG,MS,MG,SCA,PI,BETAL,PQQ,DGGQBB,NS
      PI = 4.D0*ATAN(1.D0)
      NS = 6.D0
      UG = -S -TG
      BETAL = -11.D0 + 2.D0/3.D0*(NS -1.D0)
      PQQ = 4.D0/3.D0*(-2.D0*LOG(-TG/MG**2) -2*LOG(-UG/MG**2) +3.D0)
      DGGQB1 = DGGQBB(ALPHAS,S,TG,MS,MG)*
     +     ALPHAS/2.D0/PI*LOG(1.D0/SCA)*( BETAL +PQQ)
      RETURN
      END


      REAL*8 FUNCTION DGGQB2(ALPHAS,S,TG,S4G,MS,MG,DEL,S4GMAX,SCA)
C***  GIVES THE SCALE DEPENDENCE OF LOG(DEL)
C***  SCA = Q**2/MG**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,TG,S4G,S4GMAX,MS,MG,SCA,PI,DGGQBB,DLDEL1,DEL
      PI = 4.D0*ATAN(1.D0)
      DLDEL1 = LOG(S4GMAX/MG**2) -(S4GMAX -DEL)/S4G
      DGGQB2 = 16.D0/3.D0*DLDEL1*DGGQBB(ALPHAS,S,TG,MS,MG)
     +     * ALPHAS/2.D0/PI*LOG(1.D0/SCA)
      RETURN
      END


      REAL*8 FUNCTION DGGQB3(ALPHAS,S,TG,S4G,MS,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF HARD
C***  SCA = Q**2/MG**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,TG,UG,S4G,MS,MG,PI
      REAL*8 DGGQBB,PQQ1,PQQ2,SCA,X1,X2
      PI = 4.D0*ATAN(1.D0)
      UG = S4G -S -TG
      X1 = -UG/(S+TG)
      X2 = -TG/(S+UG)
      PQQ1 = 4.D0/3.D0*(1.D0 +X1**2)/(1.D0 -X1)
      PQQ2 = 4.D0/3.D0*(1.D0 +X2**2)/(1.D0 -X2)
      DGGQB3 = ALPHAS/2.D0/PI*LOG(1.D0/SCA) *
     +     (-1/UG*DGGQBB(ALPHAS,X1*S,X1*TG,MS,MG)*PQQ1*X1**2
     +      -1/TG*DGGQBB(ALPHAS,X2*S,TG,MS,MG)*PQQ2*X2**2 )
      RETURN
      END

      REAL*8 FUNCTION DGGQBR(ALPHAS,S,TG,MS,MG)
C***  GIVES THE CHANGE FROM MSBAR TO DRBAR FOR THE YUKAWA COUPLINGS
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,TG,U1,UG,MS,MG,MS2,MG2
      REAL*8 BORN0,BORN2,BORN4,BORNDR
      REAL*8 DRMS0, DRMS2, DRMS4
      REAL*8 NS,CONV,PI,N,CO,CK,AVG
      NS = 6.D0
      CONV = 389379660.D0
      PI = 4.D0*ATAN(1.D0)
      N = 3.D0
      CO = (N**2 -1.D0)*N
      CK = (N**2 -1.D0)/N
      AVG = (1.D0/2.D0)**2 * (1.D0/N)**2
      UG = -S -TG
      T1 = TG +MG**2 -MS**2
      U1 = UG +MG**2 -MS**2
      MG2 = MG**2
      MS2 = MS**2

      BORN0 = 0.D0
      BORN0 = BORN0 + CO * ( 4*S**(-2)*TG**2 + 4*S**(-2)*UG**2 + 8*
     +    S**(-1)*MG2 )

      BORN2 = 0.D0
      BORN2 = BORN2 + CO * ( 4*S**(-1)*TG**2*T1**(-1) + 4*S**(-1)*UG**2
     +    *U1**(-1) + 4*T1**(-1)*MG2 + 4*U1**(-1)*MG2 )

      BORN4 = 0.D0
      BORN4 = BORN4 + CO * ( 2*TG**2*T1**(-2) + 2*UG**2*U1**(-2) )
     +
      BORN4 = BORN4 + CK * ( 4*S*T1**(-1)*U1**(-1)*MG2 - 2*TG**2*
     +    T1**(-2) - 2*UG**2*U1**(-2) )

      DRMS0 = 0.D0
      DRMS2 = ALPHAS * 2.D0 /3.D0 /PI
      DRMS4 = ALPHAS * 4.D0 /3.D0 /PI

      BORNDR = DRMS0 * BORN0 + DRMS2 *BORN2 + DRMS4 *BORN4
      DGGQBR = 0.5D0* ALPHAS**2*AVG*PI*BORNDR/S**2*CONV
      RETURN
      END


      REAL*8 FUNCTION DGGQBB(ALPHAS,S,TG,MS,MG)
C***  BORN CROSS SECTION FOR Q + QB -> GL + GL
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T1,TG,U1,UG,MS,MG,MS2,MG2
      REAL*8 M2QBB
      REAL*8 NS,CONV,PI,N,CO,CK,AVG

      NS = 6.D0
      CONV = 389379660.D0
      PI = 4.D0*ATAN(1.D0)
      N = 3.D0
      CO = (N**2 -1.D0)*N
      CK = (N**2 -1.D0)/N
      AVG = (1.D0/2.D0)**2 * (1.D0/N)**2
      UG = -S -TG
      T1 = TG +MG**2 -MS**2
      U1 = UG +MG**2 -MS**2
      MG2 = MG**2
      MS2 = MS**2

      M2QBB = 0.D0
      M2QBB = M2QBB + CO * ( 4*S**(-2)*TG**2 + 4*S**(-2)*UG**2 + 4*
     +    S**(-1)*TG**2*T1**(-1) + 4*S**(-1)*UG**2*U1**(-1) + 8*S**(-1)
     +    *MG2 + 2*TG**2*T1**(-2) + 2*UG**2*U1**(-2) + 4*T1**(-1)*MG2
     +     + 4*U1**(-1)*MG2 )
     +
      M2QBB = M2QBB + CK * ( 4*S*T1**(-1)*U1**(-1)*MG2 - 2*TG**2*
     +    T1**(-2) - 2*UG**2*U1**(-2) )

      DGGQBB = 0.5D0* ALPHAS**2*AVG*M2QBB *PI/S**2 *CONV
      RETURN
      END


      REAL*8 FUNCTION DGGQBV(ALPHAS,S,TG,MS,MG,MT)
C***  VIRTUAL+SOFT CROSS SECTION FOR Q + QB -> GL + GL
      IMPLICIT NONE
      REAL*8 ALPHAS,S,T,TG,U,UG,T1,U1,SBG,S1,MS,MG,MT,MS2,MG2,MT2,M2
      REAL*8 NS,CONV,PI,ZETA2,N,CO,CK,CQED,AVG,BETA,XG,SPENCE,THREE
      REAL*8 SK1B0A(1:3), SK1B0B(1:4), SK1B0C(1:3), SK1B0D(1:4,1:2)
      REAL*8 SK1B0E(1:3), SK1BP(1:5), SK1C0A(1:6), SK1C0B(1:6)
      REAL*8 SK1C0C(1:8,1:2), SK1D0(1:12,1:2)
      REAL*8 SL1B0A, SL1B0B, SL1B0C, SL1B0D,SL1B0E
      REAL*8 SL1BP, SL1C0A, SL1C0B
      REAL*8 SL1C0C, SL1D0
      REAL*8 SOF1(1:8)
      REAL*8 M2QBSV,DGGQBB,DGGQBR

      COMPLEX*16 KBETAS,KXS,KBETAT,KXT            
      PI = 4.D0*ATAN(1.D0)
      ZETA2 = PI**2/6.D0
      CONV = 389379660.D0

      NS = 6
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      CQED = (N**4 -1.D0)/N**2
      AVG = (1.D0/2.D0)**2 /N**2
      THREE = 3.D0

      MS2 = MS**2
      MG2 = MG**2
      MT2 = MT**2
      M2 = MG2 - MS2
      UG = -S -TG
      T = TG +MG2
      U = UG +MG2
      T1 = T -MS2
      U1 = U -MS2
      S1 = 4*MG2 -S

      BETA = SQRT(1.D0 - 4.D0*MG2/S)
      XG = (1.D0 -BETA)*(1.D0+BETA)**(-1)
      SBG = S*BETA


      KBETAS = SQRT( DCMPLX(1.D0 - 4.D0*MS2/S)) 
      KXS = (1.D0 -KBETAS)/(1.D0+KBETAS)
      KBETAT = SQRT( DCMPLX(1.D0 - 4.D0*MT2/S)) 
      KXT = (1.D0 -KBETAT)/(1.D0+KBETAT)

ctp
ctp      if ( (ms>1.D4).and.(ms.gt.20.D0*mg) ) then 
ctp         kbetas = 0.D0
ctp         kxs = 1.D0
ctp      end if 

      SK1B0A(1) = SL1B0A(MG2,MS2,MT2,1)
      SK1B0A(2) = SL1B0A(MG2,MS2,MT2,2)
      SK1B0A(3) = SL1B0A(MG2,MS2,MT2,3)

      SK1B0B(1) = SL1B0B(MG2,MS2,MT2,S,BETA,XG,KBETAS,KXS,KBETAT,KXT,1)
      SK1B0B(2) = SL1B0B(MG2,MS2,MT2,S,BETA,XG,KBETAS,KXS,KBETAT,KXT,2)
      SK1B0B(3) = SL1B0B(MG2,MS2,MT2,S,BETA,XG,KBETAS,KXS,KBETAT,KXT,3)
      SK1B0B(4) = SL1B0B(MG2,MS2,MT2,S,BETA,XG,KBETAS,KXS,KBETAT,KXT,4)

      SK1B0C(1) = SL1B0C(MG2,MS2,MT2,1)
      SK1B0C(2) = SL1B0C(MG2,MS2,MT2,2)
      SK1B0C(3) = SL1B0C(MG2,MS2,MT2,3)

      SK1B0D(1,1) = SL1B0D(MG2,MS2,MT2,T,1)
      SK1B0D(2,1) = SL1B0D(MG2,MS2,MT2,T,2)
      SK1B0D(3,1) = SL1B0D(MG2,MS2,MT2,T,3)
      SK1B0D(4,1) = SL1B0D(MG2,MS2,MT2,T,4)
      SK1B0D(1,2) = SL1B0D(MG2,MS2,MT2,U,1)
      SK1B0D(2,2) = SL1B0D(MG2,MS2,MT2,U,2)
      SK1B0D(3,2) = SL1B0D(MG2,MS2,MT2,U,3)
      SK1B0D(4,2) = SL1B0D(MG2,MS2,MT2,U,4)

      SK1B0E(1) = SL1B0E(MG2,MS2,MT2,1)
      SK1B0E(2) = SL1B0E(MG2,MS2,MT2,2)
      SK1B0E(3) = SL1B0E(MG2,MS2,MT2,3)

      SK1BP(1) = SL1BP(MG2,MS2,MT2,1)
      SK1BP(2) = SL1BP(MG2,MS2,MT2,2)
      SK1BP(3) = SL1BP(MG2,MS2,MT2,3)
      SK1BP(4) = SL1BP(MG2,MS2,MT2,4)
      SK1BP(5) = SL1BP(MG2,MS2,MT2,5)


      SK1C0A(1) = SL1C0A(MG2,MS2,MT2,S,XG,ZETA2,KXS,KXT,1)
C$$$      SK1C0A(2) = SL1C0A(MG2,MS2,MT2,S,XG,ZETA2,KXS,KXT,2)
C$$$      SK1C0A(3) = SL1C0A(MG2,MS2,MT2,S,XG,ZETA2,KXS,KXT,3)
C$$$      SK1C0A(4) = SL1C0A(MG2,MS2,MT2,S,XG,ZETA2,KXS,KXT,4)
      SK1C0A(5) = SL1C0A(MG2,MS2,MT2,S,XG,ZETA2,KXS,KXT,5)
      SK1C0A(6) = SL1C0A(MG2,MS2,MT2,S,XG,ZETA2,KXS,KXT,6)

      SK1C0B(1) = SL1C0B(MG2,MS2,MT2,S,XG,ZETA2,SBG,1)
      SK1C0B(2) = SL1C0B(MG2,MS2,MT2,S,XG,ZETA2,SBG,2)
      SK1C0B(3) = SL1C0B(MG2,MS2,MT2,S,XG,ZETA2,SBG,3)
      SK1C0B(4) = SL1C0B(MG2,MS2,MT2,S,XG,ZETA2,SBG,4)
      SK1C0B(5) = SL1C0B(MG2,MS2,MT2,S,XG,ZETA2,SBG,5)
      SK1C0B(6) = SL1C0B(MG2,MS2,MT2,S,XG,ZETA2,SBG,6)

C$$$      SK1C0C(1,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,1)
C$$$      SK1C0C(2,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,2)
      SK1C0C(3,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,3)
      SK1C0C(4,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,4)
      SK1C0C(5,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,5)
      SK1C0C(6,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,6)
C$$$      SK1C0C(7,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,7)
C$$$      SK1C0C(8,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,8)

C$$$      SK1C0C(1,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,1)
C$$$      SK1C0C(2,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,2)
      SK1C0C(3,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,3)
      SK1C0C(4,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,4)
      SK1C0C(5,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,5)
      SK1C0C(6,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,6)
C$$$      SK1C0C(7,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,7)
C$$$      SK1C0C(8,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,8)


      SK1D0(1,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,1)
C$$$      SK1D0(2,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,2)
C$$$      SK1D0(3,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,3)
      SK1D0(4,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,4)
C$$$      SK1D0(5,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,5)
C$$$      SK1D0(6,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,6)
      SK1D0(7,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,7)
      SK1D0(8,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,8)
      SK1D0(9,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,9)
C$$$      SK1D0(10,1)= SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,10)
C$$$      SK1D0(11,1)= SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,11)
C$$$      SK1D0(12,1)= SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,12)

      SK1D0(1,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,1)
C$$$      SK1D0(2,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,2)
C$$$      SK1D0(3,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,3)
      SK1D0(4,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,4)
C$$$      SK1D0(5,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,5)
C$$$      SK1D0(6,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,6)
      SK1D0(7,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,7)
      SK1D0(8,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,8)
      SK1D0(9,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,9)
C$$$      SK1D0(10,2)= SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,10)
C$$$      SK1D0(11,2)= SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,11)
C$$$      SK1D0(12,2)= SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,12)


      SOF1(1) = 0.125D0/SBG * ( +4*SPENCE(XG) +4*SPENCE(-XG) 
     +     +4*LOG(XG)*LOG(1-XG**2)-2*LOG(XG)**2 -2*ZETA2 )
      SOF1(2) = 0.125D0/MG2* (+2*(S -2*MG2)/SBG*LOG(XG))
      SOF1(3) = 0.125D0/MG2*(-2)
      SOF1(4) = 0.125D0/UG*(-1.5D0*ZETA2)
      SOF1(5) = 0.125D0/TG*(-1.5D0*ZETA2)
      SOF1(6) = 0.125D0/TG*(-2*LOG(XG)**2 +LOG(XG*UG/TG)**2 
     +     +2*SPENCE(1 -TG/XG/UG) -2*SPENCE(1 -UG/XG/TG) -1.5D0*ZETA2 )
      SOF1(7) = 0.125D0/UG*(-2*LOG(XG)**2 +LOG(XG*TG/UG)**2 
     +     +2*SPENCE(1 -UG/XG/TG) -2*SPENCE(1 -TG/XG/UG) -1.5D0*ZETA2)
      SOF1(8) = 0.125D0/S*(LOG(TG*UG/MG2/S)**2
     +     +2*SPENCE(1 -MG2*S/TG/UG) -3*ZETA2 )


      IF (MG.EQ.MS) THEN

      SK1C0A(2) = SL1C0A(MG2,MS2,MT2,S,XG,ZETA2,KXS,KXT,2)

      SK1C0C(1,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,1)
      SK1C0C(2,1) = SL1C0C(MG2,MS2,MT2,T,ZETA2,2)

      SK1C0C(1,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,1)
      SK1C0C(2,2) = SL1C0C(MG2,MS2,MT2,U,ZETA2,2)

      SK1D0(2,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,2)
      SK1D0(3,1) = SL1D0(MG2,MS2,MT2,S,T,U,SBG,XG,ZETA2,3)

      SK1D0(2,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,2)
      SK1D0(3,2) = SL1D0(MG2,MS2,MT2,S,U,T,SBG,XG,ZETA2,3)

         
      M2QBSV = 0.D0
      M2QBSV = M2QBSV + N*CO*THREE**(-1) * (  - 38 - 8*S**(-2)*TG**2 - 
     +    8*S**(-1)*TG + 48*S**(-1)*TG**2*S1**(-1) - 8*S**(-1)*MG2 + 12
     +    *S*TG**(-1)*S1**(-1)*MG2 - 26*TG**(-1)*MG2 + 48*TG*S1**(-1)
     +     + 48*UG**(-1)*S1**(-1)*MG2**2 - 38*UG**(-1)*MG2 + 96*
     +    S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + N*CK*THREE**(-1) * ( 54 + 24*S**(-2)*TG**2 + 24
     +    *S**(-1)*TG + 24*S**(-1)*MG2 + 54*TG**(-1)*MG2 + 54*UG**(-1)*
     +    MG2 )
     +
      M2QBSV = M2QBSV + CO*THREE**(-1) * ( 96*S**(-2)*TG**2*S1**(-1)*
     +    MT2 - 24*S**(-2)*TG**2*MG2**(-1)*MT2 + 96*S**(-1)*TG*S1**(-1)
     +    *MT2 - 24*S**(-1)*TG*MG2**(-1)*MT2 - 48*S**(-1)*TG**2*
     +    S1**(-1)*NS + 24*S**(-1)*TG**2*S1**(-1)*MG2**(-1)*MT2 - 12*S*
     +    TG**(-1)*S1**(-1)*NS*MG2 + 12*S*TG**(-1)*S1**(-1)*MT2 + 12*
     +    TG**(-1)*NS*MG2 - 12*TG**(-1)*MT2 - 48*TG*S1**(-1)*NS + 24*TG
     +    *S1**(-1)*MG2**(-1)*MT2 - 48*UG**(-1)*S1**(-1)*NS*MG2**2 + 48
     +    *UG**(-1)*S1**(-1)*MG2*MT2 + 24*UG**(-1)*NS*MG2 - 24*UG**(-1)
     +    *MT2 - 96*S1**(-1)*NS*MG2 + 96*S1**(-1)*MT2 + 24*NS - 24*
     +    MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + CK*THREE**(-1) * (  - 24*TG**(-1)*NS*MG2 + 24*
     +    TG**(-1)*MT2 - 24*UG**(-1)*NS*MG2 + 24*UG**(-1)*MT2 - 24*NS
     +     + 24*MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0A(1)*CO*THREE**(-1) * (  - 48*S**(-2)*
     +    TG**2 - 48*S**(-1)*TG - 48*S**(-1)*TG**2*S1**(-1) - 48*
     +    S**(-1)*MG2 - 12*S*TG**(-1)*S1**(-1)*MG2 - 12*TG**(-1)*MG2 - 
     +    48*TG*S1**(-1) - 48*UG**(-1)*S1**(-1)*MG2**2 - 96*S1**(-1)*
     +    MG2 )
     +
      M2QBSV = M2QBSV + SK1B0A(2)*CO*THREE**(-1) * ( 64*S**(-3)*TG**2*
     +    MT2 + 64*S**(-2)*TG*MT2 + 96*S**(-2)*TG**2*S1**(-1)*MT2 - 24*
     +    S**(-2)*TG**2*MG2**(-1)*MT2 + 64*S**(-2)*MG2*MT2 + 16*S**(-1)
     +    *TG**(-1)*MG2*MT2 + 96*S**(-1)*TG*S1**(-1)*MT2 - 24*S**(-1)*
     +    TG*MG2**(-1)*MT2 + 24*S**(-1)*TG**2*S1**(-1)*MG2**(-1)*MT2 + 
     +    16*S**(-1)*UG**(-1)*MG2*MT2 + 16*S**(-1)*MT2 + 12*S*TG**(-1)*
     +    S1**(-1)*MT2 - 12*TG**(-1)*MT2 + 24*TG*S1**(-1)*MG2**(-1)*MT2
     +     + 48*UG**(-1)*S1**(-1)*MG2*MT2 - 24*UG**(-1)*MT2 + 96*
     +    S1**(-1)*MT2 - 24*MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0A(2)*CK*THREE**(-1) * ( 24*TG**(-1)*MT2 + 
     +    24*UG**(-1)*MT2 + 24*MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*N*CO*THREE**(-1) * ( 20 + 56*S**(-2)*
     +    TG**2 + 56*S**(-1)*TG + 96*S**(-1)*TG**2*S1**(-1) + 56*
     +    S**(-1)*MG2 - 48*S*TG**(-1)*S1**(-2)*MG2**2 + 21*S*TG**(-1)*
     +    S1**(-1)*MG2 + 144*S*TG*S1**(-2) - 258*S*S1**(-2)*MG2 + 72*S*
     +    S1**(-1) + 30*S**2*TG**(-1)*S1**(-2)*MG2 + 72*S**2*S1**(-2)
     +     + 12*TG**(-1)*S1**(-1)*MG2**2 + 11*TG**(-1)*MG2 - 288*TG*
     +    S1**(-2)*MG2 + 168*TG*S1**(-1) + 72*TG**2*S1**(-2) + 288*
     +    UG**(-1)*S1**(-2)*MG2**3 - 96*UG**(-1)*S1**(-1)*MG2**2 + 20*
     +    UG**(-1)*MG2 + 456*S1**(-2)*MG2**2 - 42*S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*N*CK*THREE**(-1) * ( 24 + 72*S**(-2)*
     +    TG**2 + 72*S**(-1)*TG + 72*S**(-1)*MG2 + 12*S*TG**(-1)*
     +    S1**(-1)*MG2 - 6*S*TG**(-1) - 6*S*S1**(-1) - 6*S**2*TG**(-1)*
     +    S1**(-1) + 18*TG**(-1)*MG2 - 48*UG**(-1)*S1**(-1)*MG2**2 + 30
     +    *UG**(-1)*MG2 - 24*S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CO*THREE**(-1) * ( 2 - 32*S**(-2)*
     +    TG**2*NS + 32*S**(-2)*TG**2 - 32*S**(-1)*TG*NS + 32*S**(-1)*
     +    TG - 96*S**(-1)*TG**2*S1**(-1)*NS + 96*S**(-1)*TG**2*S1**(-1)
     +     - 32*S**(-1)*NS*MG2 + 32*S**(-1)*MG2 + 48*S*TG**(-1)*
     +    S1**(-2)*NS*MG2**2 - 48*S*TG**(-1)*S1**(-2)*MG2**2 - 36*S*
     +    TG**(-1)*S1**(-1)*NS*MG2 + 36*S*TG**(-1)*S1**(-1)*MG2 - 144*S
     +    *TG*S1**(-2)*NS + 144*S*TG*S1**(-2) + 258*S*S1**(-2)*NS*MG2
     +     - 258*S*S1**(-2)*MG2 - 72*S*S1**(-1)*NS + 72*S*S1**(-1) - 30
     +    *S**2*TG**(-1)*S1**(-2)*NS*MG2 + 30*S**2*TG**(-1)*S1**(-2)*
     +    MG2 - 72*S**2*S1**(-2)*NS + 72*S**2*S1**(-2) - 8*TG**(-1)*NS*
     +    MG2 + 8*TG**(-1)*MG2 + 288*TG*S1**(-2)*NS*MG2 - 288*TG*
     +    S1**(-2)*MG2 - 168*TG*S1**(-1)*NS + 168*TG*S1**(-1) - 72*
     +    TG**2*S1**(-2)*NS + 72*TG**2*S1**(-2) - 288*UG**(-1)*S1**(-2)
     +    *NS*MG2**3 + 288*UG**(-1)*S1**(-2)*MG2**3 + 48*UG**(-1)*
     +    S1**(-1)*NS*MG2**2 - 48*UG**(-1)*S1**(-1)*MG2**2 - 2*UG**(-1)
     +    *NS*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CO*THREE**(-1) * ( 2*UG**(-1)*MG2 - 
     +    456*S1**(-2)*NS*MG2**2 + 456*S1**(-2)*MG2**2 - 6*S1**(-1)*NS*
     +    MG2 + 6*S1**(-1)*MG2 - 2*NS )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CQED*THREE**(-1) * (  - 18 + 6*S*
     +    TG**(-1) + 6*S*S1**(-1) + 6*S**2*TG**(-1)*S1**(-1) + 96*
     +    UG**(-1)*S1**(-1)*MG2**2 - 24*UG**(-1)*MG2 + 72*S1**(-1)*MG2
     +     )
     +
      M2QBSV = M2QBSV + SK1B0B(2)*N*CO*THREE**(-1) * (  - 26 - 64*
     +    S**(-3)*TG**2*MG2 - 64*S**(-2)*TG*MG2 - 56*S**(-2)*TG**2 - 64
     +    *S**(-2)*MG2**2 - 16*S**(-1)*TG**(-1)*MG2**2 - 56*S**(-1)*TG
     +     + 24*S**(-1)*TG**2*S1**(-1) - 16*S**(-1)*UG**(-1)*MG2**2 - 
     +    72*S**(-1)*MG2 + 120*S*TG**(-1)*S1**(-2)*MG2**2 - 36*S*
     +    TG**(-1)*S1**(-1)*MG2 + 6*S*TG**(-1) - 30*S*S1**(-2)*MG2 + 6*
     +    S*S1**(-1) - 30*S**2*TG**(-1)*S1**(-2)*MG2 + 6*S**2*TG**(-1)*
     +    S1**(-1) - 14*TG**(-1)*MG2 + 24*TG*S1**(-1) + 72*UG**(-1)*
     +    S1**(-1)*MG2**2 - 32*UG**(-1)*MG2 + 120*S1**(-2)*MG2**2 + 42*
     +    S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(2)*N*CK*THREE**(-1) * (  - 18 - 24*
     +    S**(-2)*TG**2 - 24*S**(-1)*TG - 24*S**(-1)*MG2 + 12*S*
     +    TG**(-1)*S1**(-1)*MG2 - 6*TG**(-1)*MG2 + 48*UG**(-1)*S1**(-1)
     +    *MG2**2 - 18*UG**(-1)*MG2 + 48*S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(2)*CO*THREE**(-1) * (  - 6 + 64*S**(-3)*
     +    TG**2*NS*MG2 + 64*S**(-2)*TG*NS*MG2 - 16*S**(-2)*TG**2*NS + 
     +    64*S**(-2)*NS*MG2**2 + 16*S**(-1)*TG**(-1)*NS*MG2**2 - 16*
     +    S**(-1)*TG*NS - 24*S**(-1)*TG**2*S1**(-1)*NS + 24*S**(-1)*
     +    TG**2*S1**(-1) + 16*S**(-1)*UG**(-1)*NS*MG2**2 - 120*S*
     +    TG**(-1)*S1**(-2)*NS*MG2**2 + 120*S*TG**(-1)*S1**(-2)*MG2**2
     +     + 30*S*TG**(-1)*S1**(-1)*NS*MG2 - 30*S*TG**(-1)*S1**(-1)*MG2
     +     + 30*S*S1**(-2)*NS*MG2 - 30*S*S1**(-2)*MG2 + 30*S**2*
     +    TG**(-1)*S1**(-2)*NS*MG2 - 30*S**2*TG**(-1)*S1**(-2)*MG2 - 24
     +    *TG**(-1)*S1**(-1)*NS*MG2**2 + 24*TG**(-1)*S1**(-1)*MG2**2 + 
     +    2*TG**(-1)*NS*MG2 - 6*TG**(-1)*MG2 - 24*TG*S1**(-1)*NS + 24*
     +    TG*S1**(-1) - 24*UG**(-1)*S1**(-1)*NS*MG2**2 + 24*UG**(-1)*
     +    S1**(-1)*MG2**2 + 2*UG**(-1)*NS*MG2 - 6*UG**(-1)*MG2 - 120*
     +    S1**(-2)*NS*MG2**2 + 120*S1**(-2)*MG2**2 - 18*S1**(-1)*NS*MG2
     +     + 18*S1**(-1)*MG2 + 2*NS )
     +
      M2QBSV = M2QBSV + SK1B0B(2)*CQED*THREE**(-1) * ( 18 - 6*S*
     +    TG**(-1) - 6*S*S1**(-1) - 6*S**2*TG**(-1)*S1**(-1) - 96*
     +    UG**(-1)*S1**(-1)*MG2**2 + 24*UG**(-1)*MG2 - 72*S1**(-1)*MG2
     +     )
     +
      M2QBSV = M2QBSV + SK1B0B(3)*CO*THREE**(-1) * ( 6 + 96*S**(-2)*
     +    TG**2*S1**(-1)*MT2 + 96*S**(-1)*TG*S1**(-1)*MT2 + 144*S**(-1)
     +    *TG**2*S1**(-2)*MT2 - 24*S**(-1)*TG**2*S1**(-1) + 24*S**(-1)*
     +    MT2 + 36*S*TG**(-1)*S1**(-2)*MG2*MT2 - 120*S*TG**(-1)*
     +    S1**(-2)*MG2**2 + 30*S*TG**(-1)*S1**(-1)*MG2 + 30*S*S1**(-2)*
     +    MG2 + 30*S**2*TG**(-1)*S1**(-2)*MG2 + 24*TG**(-1)*S1**(-1)*
     +    MG2*MT2 - 24*TG**(-1)*S1**(-1)*MG2**2 + 6*TG**(-1)*MG2 + 144*
     +    TG*S1**(-2)*MT2 - 24*TG*S1**(-1) + 144*UG**(-1)*S1**(-2)*
     +    MG2**2*MT2 - 12*UG**(-1)*S1**(-1)*MG2*MT2 - 24*UG**(-1)*
     +    S1**(-1)*MG2**2 + 6*UG**(-1)*MG2 + 288*S1**(-2)*MG2*MT2 - 120
     +    *S1**(-2)*MG2**2 - 18*S1**(-1)*MG2 + 12*S1**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0B(4)*CO*THREE**(-1) * (  - 2 - 64*S**(-3)*
     +    TG**2*MT2 - 64*S**(-2)*TG*MT2 + 96*S**(-2)*TG**2*S1**(-1)*MT2
     +     - 32*S**(-2)*TG**2 - 64*S**(-2)*MG2*MT2 - 16*S**(-1)*
     +    TG**(-1)*MG2*MT2 + 96*S**(-1)*TG*S1**(-1)*MT2 - 32*S**(-1)*TG
     +     + 144*S**(-1)*TG**2*S1**(-2)*MT2 - 96*S**(-1)*TG**2*S1**(-1)
     +     - 16*S**(-1)*UG**(-1)*MG2*MT2 - 32*S**(-1)*MG2 + 8*S**(-1)*
     +    MT2 + 36*S*TG**(-1)*S1**(-2)*MG2*MT2 + 48*S*TG**(-1)*S1**(-2)
     +    *MG2**2 - 36*S*TG**(-1)*S1**(-1)*MG2 - 144*S*TG*S1**(-2) + 
     +    258*S*S1**(-2)*MG2 - 72*S*S1**(-1) - 30*S**2*TG**(-1)*
     +    S1**(-2)*MG2 - 72*S**2*S1**(-2) + 24*TG**(-1)*S1**(-1)*MG2*
     +    MT2 - 8*TG**(-1)*MG2 + 288*TG*S1**(-2)*MG2 + 144*TG*S1**(-2)*
     +    MT2 - 168*TG*S1**(-1) - 72*TG**2*S1**(-2) + 144*UG**(-1)*
     +    S1**(-2)*MG2**2*MT2 - 288*UG**(-1)*S1**(-2)*MG2**3 - 12*
     +    UG**(-1)*S1**(-1)*MG2*MT2 + 48*UG**(-1)*S1**(-1)*MG2**2 - 2*
     +    UG**(-1)*MG2 + 288*S1**(-2)*MG2*MT2 - 456*S1**(-2)*MG2**2 - 6
     +    *S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(4)*CO*THREE**(-1) * ( 12*S1**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0C(1)*N*CO * ( 30 + 32*S**(-2)*TG**2 + 32*
     +    S**(-1)*TG - 56*S**(-1)*TG**2*S1**(-1) + 64*S**(-1)*MG2 - 24*
     +    S*TG**(-1)*S1**(-2)*MG2**2 + S*TG**(-1)*S1**(-1)*MG2 - 2*S*
     +    TG**(-1) - 48*S*TG*S1**(-2) + 96*S*S1**(-2)*MG2 - 26*S*
     +    S1**(-1) - 2*S**2*TG**(-1)*S1**(-1) - 24*S**2*S1**(-2) + 16*
     +    TG**(-2)*MG2**2 - 4*TG**(-1)*S1**(-1)*MG2**2 + 41*TG**(-1)*
     +    MG2 + 96*TG*S1**(-2)*MG2 - 80*TG*S1**(-1) - 24*TG**2*S1**(-2)
     +     + 16*UG**(-2)*MG2**2 - 96*UG**(-1)*S1**(-2)*MG2**3 - 8*
     +    UG**(-1)*S1**(-1)*MG2**2 + 48*UG**(-1)*MG2 - 192*S1**(-2)*
     +    MG2**2 - 32*S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0C(1)*N*CK * (  - 30 - 32*S**(-1)*MG2 - 8*S
     +    *TG**(-1)*S1**(-1)*MG2 + 2*S*TG**(-1) + 2*S*S1**(-1) + 2*S**2
     +    *TG**(-1)*S1**(-1) - 48*TG**(-2)*MG2**2 - 64*TG**(-1)*
     +    UG**(-1)*MG2**2 - 80*TG**(-1)*MG2 - 48*UG**(-2)*MG2**2 - 80*
     +    UG**(-1)*MG2 - 8*S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0C(1)*CO * ( 16 + 56*S**(-1)*TG**2*S1**(-1)
     +    *NS - 56*S**(-1)*TG**2*S1**(-1) + 24*S*TG**(-1)*S1**(-2)*NS*
     +    MG2**2 - 24*S*TG**(-1)*S1**(-2)*MG2**2 + 6*S*TG**(-1)*
     +    S1**(-1)*NS*MG2 - 6*S*TG**(-1)*S1**(-1)*MG2 + 48*S*TG*
     +    S1**(-2)*NS - 48*S*TG*S1**(-2) - 96*S*S1**(-2)*NS*MG2 + 96*S*
     +    S1**(-2)*MG2 + 24*S*S1**(-1)*NS - 24*S*S1**(-1) + 24*S**2*
     +    S1**(-2)*NS - 24*S**2*S1**(-2) + 8*TG**(-1)*S1**(-1)*NS*
     +    MG2**2 - 8*TG**(-1)*S1**(-1)*MG2**2 - 10*TG**(-1)*NS*MG2 + 10
     +    *TG**(-1)*MG2 - 96*TG*S1**(-2)*NS*MG2 + 96*TG*S1**(-2)*MG2 + 
     +    80*TG*S1**(-1)*NS - 80*TG*S1**(-1) + 24*TG**2*S1**(-2)*NS - 
     +    24*TG**2*S1**(-2) + 96*UG**(-1)*S1**(-2)*NS*MG2**3 - 96*
     +    UG**(-1)*S1**(-2)*MG2**3 + 8*UG**(-1)*S1**(-1)*NS*MG2**2 - 8*
     +    UG**(-1)*S1**(-1)*MG2**2 - 16*UG**(-1)*NS*MG2 + 16*UG**(-1)*
     +    MG2 + 192*S1**(-2)*NS*MG2**2 - 192*S1**(-2)*MG2**2 + 40*
     +    S1**(-1)*NS*MG2 - 40*S1**(-1)*MG2 - 16*NS )
     +
      M2QBSV = M2QBSV + SK1B0C(1)*CK * (  - 16 + 16*TG**(-1)*NS*MG2 - 
     +    16*TG**(-1)*MG2 + 16*UG**(-1)*NS*MG2 - 16*UG**(-1)*MG2 + 16*
     +    NS )
     +
      M2QBSV = M2QBSV + SK1B0C(1)*CQED * ( 16*TG**(-2)*MG2**2 + 32*
     +    TG**(-1)*UG**(-1)*MG2**2 + 16*TG**(-1)*MG2 + 16*UG**(-2)*
     +    MG2**2 + 16*UG**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0C(3)*CO * (  - 16 - 96*S**(-2)*TG**2*
     +    S1**(-1)*MT2 + 8*S**(-2)*TG**2*MG2**(-1)*MT2 - 96*S**(-1)*TG*
     +    S1**(-1)*MT2 + 8*S**(-1)*TG*MG2**(-1)*MT2 - 96*S**(-1)*TG**2*
     +    S1**(-2)*MT2 - 8*S**(-1)*TG**2*S1**(-1)*MG2**(-1)*MT2 + 56*
     +    S**(-1)*TG**2*S1**(-1) - 16*S**(-1)*MT2 - 24*S*TG**(-1)*
     +    S1**(-2)*MG2*MT2 + 24*S*TG**(-1)*S1**(-2)*MG2**2 + 6*S*
     +    TG**(-1)*S1**(-1)*MG2 - 4*S*TG**(-1)*S1**(-1)*MT2 + 48*S*TG*
     +    S1**(-2) - 96*S*S1**(-2)*MG2 + 24*S*S1**(-1) + 24*S**2*
     +    S1**(-2) - 16*TG**(-1)*S1**(-1)*MG2*MT2 + 8*TG**(-1)*S1**(-1)
     +    *MG2**2 - 10*TG**(-1)*MG2 + 4*TG**(-1)*MT2 - 96*TG*S1**(-2)*
     +    MG2 - 96*TG*S1**(-2)*MT2 - 8*TG*S1**(-1)*MG2**(-1)*MT2 + 80*
     +    TG*S1**(-1) + 24*TG**2*S1**(-2) - 96*UG**(-1)*S1**(-2)*MG2**2
     +    *MT2 + 96*UG**(-1)*S1**(-2)*MG2**3 - 8*UG**(-1)*S1**(-1)*MG2*
     +    MT2 + 8*UG**(-1)*S1**(-1)*MG2**2 - 16*UG**(-1)*MG2 + 8*
     +    UG**(-1)*MT2 - 192*S1**(-2)*MG2*MT2 + 192*S1**(-2)*MG2**2 + 
     +    40*S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0C(3)*CO * (  - 40*S1**(-1)*MT2 + 8*
     +    MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0C(3)*CK * ( 16 + 16*TG**(-1)*MG2 - 8*
     +    TG**(-1)*MT2 + 16*UG**(-1)*MG2 - 8*UG**(-1)*MT2 - 8*MG2**(-1)
     +    *MT2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,1)*N*CO * (  - 4 - 4*S**(-1)*TG - 8*
     +    S**(-1)*MG2 - 8*TG**(-2)*MG2**2 - 12*TG**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,1)*N*CK * ( 12 + 4*S**(-1)*TG + 8*
     +    S**(-1)*MG2 + 24*TG**(-2)*MG2**2 + 16*TG**(-1)*UG**(-1)*
     +    MG2**2 + 36*TG**(-1)*MG2 + 8*UG**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,1)*CQED * (  - 4 - 8*TG**(-2)*MG2**2
     +     - 8*TG**(-1)*UG**(-1)*MG2**2 - 12*TG**(-1)*MG2 - 4*UG**(-1)*
     +    MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,2)*N*CO * ( 4*S**(-1)*TG - 8*S**(-1)*
     +    MG2 - 8*UG**(-2)*MG2**2 - 12*UG**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,2)*N*CK * ( 8 - 4*S**(-1)*TG + 8*
     +    S**(-1)*MG2 + 16*TG**(-1)*UG**(-1)*MG2**2 + 8*TG**(-1)*MG2 + 
     +    24*UG**(-2)*MG2**2 + 36*UG**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,2)*CQED * (  - 4 - 8*TG**(-1)*UG**(-1)
     +    *MG2**2 - 4*TG**(-1)*MG2 - 8*UG**(-2)*MG2**2 - 12*UG**(-1)*
     +    MG2 )
     +
      M2QBSV = M2QBSV + SK1B0E(1)*N*CO * (  - 16*S**(-1)*MG2 - 8*
     +    TG**(-2)*MG2**2 - 8*TG**(-1)*MG2 - 8*UG**(-2)*MG2**2 - 8*
     +    UG**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0E(1)*N*CK * ( 16*S**(-1)*MG2 + 24*TG**(-2)
     +    *MG2**2 + 32*TG**(-1)*UG**(-1)*MG2**2 + 24*TG**(-1)*MG2 + 24*
     +    UG**(-2)*MG2**2 + 24*UG**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0E(1)*CQED * (  - 8*TG**(-2)*MG2**2 - 16*
     +    TG**(-1)*UG**(-1)*MG2**2 - 8*TG**(-1)*MG2 - 8*UG**(-2)*MG2**2
     +     - 8*UG**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1BP(1)*N*CO * ( 64*S**(-2)*TG**2*MG2 + 64*
     +    S**(-1)*TG*MG2 + 64*S**(-1)*MG2**2 + 32*TG**(-1)*MG2**2 + 32*
     +    UG**(-1)*MG2**2 + 32*MG2 )
     +
      M2QBSV = M2QBSV + SK1BP(1)*N*CK * (  - 32*TG**(-1)*MG2**2 - 32*
     +    UG**(-1)*MG2**2 - 32*MG2 )
     +
      M2QBSV = M2QBSV + SK1BP(5)*CO * (  - 32*S**(-2)*TG**2*MT2 - 32*
     +    S**(-1)*TG*MT2 - 32*S**(-1)*MG2*MT2 - 16*TG**(-1)*MG2*MT2 - 
     +    16*UG**(-1)*MG2*MT2 - 16*MT2 )
     +
      M2QBSV = M2QBSV + SK1BP(5)*CK * ( 16*TG**(-1)*MG2*MT2 + 16*
     +    UG**(-1)*MG2*MT2 + 16*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0A(1)*N*CO * ( 16*S**(-1)*TG**2 + 2*S*
     +    TG**(-1)*MG2 + 2*S*UG**(-1)*MG2 + 4*S + 16*TG + 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0A(1)*N*CK * ( 16*S**(-1)*TG**2 + 4*S*
     +    TG**(-1)*MG2 + 4*S*UG**(-1)*MG2 + 6*S + 16*TG + 16*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0A(1)*CQED * (  - 4*S )
     +
      M2QBSV = M2QBSV + SK1C0A(2)*N*CO * (  - 16*S**(-2)*TG**2*MG2 - 16
     +    *S**(-1)*TG*MG2 - 16*S**(-1)*MG2**2 + 2*S - 4*TG**(-1)*MG2**2
     +     - 4*UG**(-1)*MG2**2 - 12*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0A(2)*N*CK * (  - 16*S**(-2)*TG**2*MG2 - 16
     +    *S**(-1)*TG*MG2 - 16*S**(-1)*MG2**2 - 2*S*TG**(-1)*MG2 - 2*S*
     +    UG**(-1)*MG2 - 4*S - 4*TG**(-1)*MG2**2 - 4*UG**(-1)*MG2**2 - 
     +    4*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0A(2)*CQED * ( 4*S*TG**(-1)*MG2 + 4*S*
     +    UG**(-1)*MG2 - 2*S**2*TG**(-1) - 2*S**2*UG**(-1) )
     +
      M2QBSV = M2QBSV + SK1C0B(1)*N*CO * ( 32*S**(-2)*TG**2*MG2 + 32*
     +    S**(-1)*TG*MG2 - 16*S**(-1)*TG**2 + 32*S**(-1)*MG2**2 - 80*S*
     +    TG**(-1)*S1**(-2)*MG2**3 + 36*S*TG**(-1)*S1**(-1)*MG2**2 - 8*
     +    S*TG**(-1)*MG2 - 4*S*TG*S1**(-2)*MG2 + 2*S*TG*S1**(-1) - 4*S*
     +    UG**(-1)*MG2 + 52*S*S1**(-2)*MG2**2 - 28*S*S1**(-1)*MG2 - 2*S
     +     + 36*S**2*TG**(-1)*S1**(-2)*MG2**2 - 16*S**2*TG**(-1)*
     +    S1**(-1)*MG2 + 2*S**2*TG**(-1) - 8*S**2*S1**(-2)*MG2 + 4*S**2
     +    *S1**(-1) - 4*S**3*TG**(-1)*S1**(-2)*MG2 + 2*S**3*TG**(-1)*
     +    S1**(-1) + 8*TG**(-1)*MG2**2 + 16*TG*S1**(-2)*MG2**2 - 12*TG*
     +    S1**(-1)*MG2 - 14*TG + 8*UG**(-1)*MG2**2 - 80*S1**(-2)*MG2**3
     +     + 36*S1**(-1)*MG2**2 - 4*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(1)*N*CK * (  - 16*S*TG**(-1)*S1**(-1)*
     +    MG2**2 + 2*S*TG**(-1)*MG2 - 2*S*UG**(-1)*MG2 + 4*S*S1**(-1)*
     +    MG2 - 4*S + 4*S**2*TG**(-1)*S1**(-1)*MG2 - 16*S1**(-1)*MG2**2
     +     + 12*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(1)*CO * ( 80*S*TG**(-1)*S1**(-2)*NS*
     +    MG2**3 - 80*S*TG**(-1)*S1**(-2)*MG2**3 - 32*S*TG**(-1)*
     +    S1**(-1)*NS*MG2**2 + 32*S*TG**(-1)*S1**(-1)*MG2**2 + 2*S*
     +    TG**(-1)*NS*MG2 - 2*S*TG**(-1)*MG2 + 4*S*TG*S1**(-2)*NS*MG2
     +     - 4*S*TG*S1**(-2)*MG2 - 52*S*S1**(-2)*NS*MG2**2 + 52*S*
     +    S1**(-2)*MG2**2 + 10*S*S1**(-1)*NS*MG2 - 10*S*S1**(-1)*MG2 - 
     +    36*S**2*TG**(-1)*S1**(-2)*NS*MG2**2 + 36*S**2*TG**(-1)*
     +    S1**(-2)*MG2**2 + 6*S**2*TG**(-1)*S1**(-1)*NS*MG2 - 6*S**2*
     +    TG**(-1)*S1**(-1)*MG2 + 8*S**2*S1**(-2)*NS*MG2 - 8*S**2*
     +    S1**(-2)*MG2 + 4*S**3*TG**(-1)*S1**(-2)*NS*MG2 - 4*S**3*
     +    TG**(-1)*S1**(-2)*MG2 + 16*TG**(-1)*S1**(-1)*NS*MG2**3 - 16*
     +    TG**(-1)*S1**(-1)*MG2**3 - 4*TG**(-1)*NS*MG2**2 + 4*TG**(-1)*
     +    MG2**2 - 16*TG*S1**(-2)*NS*MG2**2 + 16*TG*S1**(-2)*MG2**2 + 4
     +    *TG*S1**(-1)*NS*MG2 - 4*TG*S1**(-1)*MG2 + 80*S1**(-2)*NS*
     +    MG2**3 - 80*S1**(-2)*MG2**3 - 28*S1**(-1)*NS*MG2**2 + 28*
     +    S1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(1)*CO * ( 2*NS*MG2 - 2*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(1)*CQED * ( 16*S*TG**(-1)*S1**(-1)*
     +    MG2**2 + 4*S*TG**(-1)*MG2 - 2*S*TG*S1**(-1) + 8*S*UG**(-1)*
     +    MG2 + 12*S*S1**(-1)*MG2 - 4*S + 4*S**2*TG**(-1)*S1**(-1)*MG2
     +     - 4*S**2*TG**(-1) - 2*S**2*UG**(-1) - 4*S**2*S1**(-1) - 2*
     +    S**3*TG**(-1)*S1**(-1) + 8*TG*S1**(-1)*MG2 - 2*TG + 16*
     +    S1**(-1)*MG2**2 - 4*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(3)*N*CO * ( 24*S**(-1)*TG**2 + 4*S*
     +    TG**(-1)*S1**(-1)*MG2**2 + S*TG**(-1)*MG2 + 100*S*TG*S1**(-2)
     +    *MG2 + 16*S*TG*S1**(-1) + 2*S*UG**(-1)*MG2 - 212*S*S1**(-2)*
     +    MG2**2 + 23*S*S1**(-1)*MG2 + 12*S - 4*S**2*TG**(-1)*S1**(-2)*
     +    MG2**2 + 3*S**2*TG**(-1)*S1**(-1)*MG2 + 56*S**2*S1**(-2)*MG2
     +     + 8*S**2*S1**(-1) + 4*S**3*TG**(-1)*S1**(-2)*MG2 - 208*TG*
     +    S1**(-2)*MG2**2 + 20*TG*S1**(-1)*MG2 + 32*TG + 48*TG**2*
     +    S1**(-2)*MG2 + 8*TG**2*S1**(-1) + 192*UG**(-1)*S1**(-2)*
     +    MG2**4 - 96*UG**(-1)*S1**(-1)*MG2**3 + 12*UG**(-1)*MG2**2 + 
     +    336*S1**(-2)*MG2**3 - 96*S1**(-1)*MG2**2 + 19*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(3)*N*CK * (  - 8*S*TG**(-1)*S1**(-1)*
     +    MG2**2 - 2*S*TG*S1**(-1) + 16*S*S1**(-1)*MG2 - 6*S + 8*S**2*
     +    TG**(-1)*S1**(-1)*MG2 - 2*S**2*TG**(-1) - 4*S**2*S1**(-1) - 2
     +    *S**3*TG**(-1)*S1**(-1) + 8*TG*S1**(-1)*MG2 - 2*TG - 32*
     +    UG**(-1)*S1**(-1)*MG2**3 + 8*UG**(-1)*MG2**2 - 32*S1**(-1)*
     +    MG2**2 + 16*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(3)*CO * (  - 8*S**(-1)*TG**2*NS + 8*
     +    S**(-1)*TG**2 - 8*S*TG**(-1)*S1**(-1)*NS*MG2**2 + 8*S*
     +    TG**(-1)*S1**(-1)*MG2**2 - 100*S*TG*S1**(-2)*NS*MG2 + 100*S*
     +    TG*S1**(-2)*MG2 - 16*S*TG*S1**(-1)*NS + 16*S*TG*S1**(-1) + 
     +    212*S*S1**(-2)*NS*MG2**2 - 212*S*S1**(-2)*MG2**2 - 24*S*
     +    S1**(-1)*NS*MG2 + 24*S*S1**(-1)*MG2 - 8*S*NS + 8*S + 4*S**2*
     +    TG**(-1)*S1**(-2)*NS*MG2**2 - 4*S**2*TG**(-1)*S1**(-2)*MG2**2
     +     - 4*S**2*TG**(-1)*S1**(-1)*NS*MG2 + 4*S**2*TG**(-1)*S1**(-1)
     +    *MG2 - 56*S**2*S1**(-2)*NS*MG2 + 56*S**2*S1**(-2)*MG2 - 8*
     +    S**2*S1**(-1)*NS + 8*S**2*S1**(-1) - 4*S**3*TG**(-1)*S1**(-2)
     +    *NS*MG2 + 4*S**3*TG**(-1)*S1**(-2)*MG2 + 208*TG*S1**(-2)*NS*
     +    MG2**2 - 208*TG*S1**(-2)*MG2**2 - 20*TG*S1**(-1)*NS*MG2 + 20*
     +    TG*S1**(-1)*MG2 - 16*TG*NS + 16*TG - 48*TG**2*S1**(-2)*NS*MG2
     +     + 48*TG**2*S1**(-2)*MG2 - 8*TG**2*S1**(-1)*NS + 8*TG**2*
     +    S1**(-1) - 192*UG**(-1)*S1**(-2)*NS*MG2**4 + 192*UG**(-1)*
     +    S1**(-2)*MG2**4 )
     +
      M2QBSV = M2QBSV + SK1C0B(3)*CO * ( 64*UG**(-1)*S1**(-1)*NS*MG2**3
     +     - 64*UG**(-1)*S1**(-1)*MG2**3 - 4*UG**(-1)*NS*MG2**2 + 4*
     +    UG**(-1)*MG2**2 - 336*S1**(-2)*NS*MG2**3 + 336*S1**(-2)*
     +    MG2**3 + 68*S1**(-1)*NS*MG2**2 - 68*S1**(-1)*MG2**2 - 4*NS*
     +    MG2 + 4*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(3)*CQED * ( 16*S*TG**(-1)*S1**(-1)*
     +    MG2**2 + 4*S*TG**(-1)*MG2 + 2*S*TG*S1**(-1) + 4*S*UG**(-1)*
     +    MG2 - 16*S*S1**(-1)*MG2 + 8*S - 8*S**2*TG**(-1)*S1**(-1)*MG2
     +     + 2*S**2*TG**(-1) + 4*S**2*S1**(-1) + 2*S**3*TG**(-1)*
     +    S1**(-1) - 8*TG*S1**(-1)*MG2 + 2*TG + 64*UG**(-1)*S1**(-1)*
     +    MG2**3 - 16*UG**(-1)*MG2**2 + 64*S1**(-1)*MG2**2 - 16*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * (  - 32*S**(-2)*TG**2*S1**(-1)*
     +    MT2**2 - 32*S**(-1)*TG*S1**(-1)*MT2**2 - 48*S**(-1)*TG**2*
     +    S1**(-2)*MT2**2 + 64*S**(-1)*TG**2*S1**(-1)*MT2 - 8*S**(-1)*
     +    TG**2 - 8*S**(-1)*MT2**2 - 12*S*TG**(-1)*S1**(-2)*MG2*MT2**2
     +     - 16*S*TG**(-1)*S1**(-2)*MG2**2*MT2 + 20*S*TG**(-1)*S1**(-1)
     +    *MG2*MT2 - 8*S*TG**(-1)*S1**(-1)*MG2**2 - 100*S*TG*S1**(-2)*
     +    MG2 + 96*S*TG*S1**(-2)*MT2 - 16*S*TG*S1**(-1) - 176*S*
     +    S1**(-2)*MG2*MT2 + 212*S*S1**(-2)*MG2**2 - 24*S*S1**(-1)*MG2
     +     + 48*S*S1**(-1)*MT2 - 8*S + 16*S**2*TG**(-1)*S1**(-2)*MG2*
     +    MT2 + 4*S**2*TG**(-1)*S1**(-2)*MG2**2 - 4*S**2*TG**(-1)*
     +    S1**(-1)*MG2 - 56*S**2*S1**(-2)*MG2 + 48*S**2*S1**(-2)*MT2 - 
     +    8*S**2*S1**(-1) - 4*S**3*TG**(-1)*S1**(-2)*MG2 - 8*TG**(-1)*
     +    S1**(-1)*MG2*MT2**2 - 192*TG*S1**(-2)*MG2*MT2 + 208*TG*
     +    S1**(-2)*MG2**2 - 48*TG*S1**(-2)*MT2**2 - 20*TG*S1**(-1)*MG2
     +     + 112*TG*S1**(-1)*MT2 - 16*TG - 48*TG**2*S1**(-2)*MG2 + 48*
     +    TG**2*S1**(-2)*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * (  - 8*TG**2*S1**(-1) - 48*
     +    UG**(-1)*S1**(-2)*MG2**2*MT2**2 + 192*UG**(-1)*S1**(-2)*
     +    MG2**3*MT2 - 192*UG**(-1)*S1**(-2)*MG2**4 + 4*UG**(-1)*
     +    S1**(-1)*MG2*MT2**2 - 32*UG**(-1)*S1**(-1)*MG2**2*MT2 + 64*
     +    UG**(-1)*S1**(-1)*MG2**3 - 4*UG**(-1)*MG2*MT2 - 4*UG**(-1)*
     +    MG2**2 - 96*S1**(-2)*MG2*MT2**2 + 320*S1**(-2)*MG2**2*MT2 - 
     +    336*S1**(-2)*MG2**3 + 68*S1**(-1)*MG2**2 - 4*S1**(-1)*MT2**2
     +     - 4*MG2 - 4*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * ( 32*S**(-2)*TG**2*S1**(-1)*
     +    MT2**2 - 16*S**(-2)*TG**2*MT2 + 32*S**(-1)*TG*S1**(-1)*MT2**2
     +     - 16*S**(-1)*TG*MT2 + 48*S**(-1)*TG**2*S1**(-2)*MT2**2 - 32*
     +    S**(-1)*TG**2*S1**(-1)*MT2 - 16*S**(-1)*MG2*MT2 + 8*S**(-1)*
     +    MT2**2 + 12*S*TG**(-1)*S1**(-2)*MG2*MT2**2 - 64*S*TG**(-1)*
     +    S1**(-2)*MG2**2*MT2 + 80*S*TG**(-1)*S1**(-2)*MG2**3 + 14*S*
     +    TG**(-1)*S1**(-1)*MG2*MT2 - 32*S*TG**(-1)*S1**(-1)*MG2**2 + 2
     +    *S*TG**(-1)*MG2 + 4*S*TG*S1**(-2)*MG2 + 16*S*S1**(-2)*MG2*MT2
     +     - 52*S*S1**(-2)*MG2**2 + 10*S*S1**(-1)*MG2 + 16*S**2*
     +    TG**(-1)*S1**(-2)*MG2*MT2 - 36*S**2*TG**(-1)*S1**(-2)*MG2**2
     +     + 6*S**2*TG**(-1)*S1**(-1)*MG2 + 8*S**2*S1**(-2)*MG2 + 4*
     +    S**3*TG**(-1)*S1**(-2)*MG2 + 8*TG**(-1)*S1**(-1)*MG2*MT2**2
     +     - 24*TG**(-1)*S1**(-1)*MG2**2*MT2 + 16*TG**(-1)*S1**(-1)*
     +    MG2**3 + 2*TG**(-1)*MG2*MT2 - 4*TG**(-1)*MG2**2 - 16*TG*
     +    S1**(-2)*MG2**2 + 48*TG*S1**(-2)*MT2**2 + 4*TG*S1**(-1)*MG2
     +     - 32*TG*S1**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * ( 48*UG**(-1)*S1**(-2)*MG2**2*
     +    MT2**2 - 4*UG**(-1)*S1**(-1)*MG2*MT2**2 - 32*UG**(-1)*
     +    S1**(-1)*MG2**2*MT2 + 4*UG**(-1)*MG2*MT2 + 96*S1**(-2)*MG2*
     +    MT2**2 - 64*S1**(-2)*MG2**2*MT2 + 80*S1**(-2)*MG2**3 - 48*
     +    S1**(-1)*MG2*MT2 - 28*S1**(-1)*MG2**2 + 4*S1**(-1)*MT2**2 + 2
     +    *MG2 + 4*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0C(1,1)*N*CO * ( 4*S**(-1)*TG**2 + 8*
     +    TG**(-1)*MG2**2 + 4*TG + 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(1,1)*N*CK * ( 8*S**(-1)*TG*MG2 + 4*S*
     +    UG**(-1)*MG2 + 8*TG**(-1)*MG2**2 - 12*TG + 4*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(1,1)*CQED * (  - 4*S*UG**(-1)*MG2 + 4*S
     +     + 4*S**2*UG**(-1) - 8*TG**(-1)*MG2**2 - 8*UG**(-1)*MG2**2 - 
     +    8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(1,2)*N*CO * ( 4*S**(-1)*TG**2 + 4*TG + 8
     +    *UG**(-1)*MG2**2 + 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(1,2)*N*CK * (  - 8*S**(-1)*TG*MG2 + 4*S*
     +    TG**(-1)*MG2 + 12*S + 12*TG + 8*UG**(-1)*MG2**2 - 4*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(1,2)*CQED * (  - 4*S*TG**(-1)*MG2 + 4*S
     +     + 4*S**2*TG**(-1) - 8*TG**(-1)*MG2**2 - 8*UG**(-1)*MG2**2 - 
     +    8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(3,1)*N*CO * (  - 8*S**(-1)*TG*MG2 - 16*
     +    S**(-1)*TG**2 - 12*TG - 12*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(3,1)*N*CK * (  - 4*S**(-1)*TG**2 - 4*S*
     +    UG**(-1)*MG2 + 4*TG - 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(3,1)*CQED * (  - 8*S*UG**(-1)*MG2 + 4*TG
     +     )
     +
      M2QBSV = M2QBSV + SK1C0C(3,2)*N*CO * ( 8*S**(-1)*TG*MG2 - 16*
     +    S**(-1)*TG**2 - 4*S - 20*TG - 4*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(3,2)*N*CK * (  - 4*S**(-1)*TG**2 - 4*S*
     +    TG**(-1)*MG2 - 8*S - 12*TG - 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(3,2)*CQED * (  - 8*S*TG**(-1)*MG2 - 4*S
     +     - 4*TG )
     +
      M2QBSV = M2QBSV + SK1D0(1,1)*N*CO * (  - 8*S**(-1)*TG**3 - 2*S*TG
     +     - 2*S*MG2 - 4*TG*MG2 - 8*TG**2 )
     +
      M2QBSV = M2QBSV + SK1D0(1,1)*N*CK * ( 2*S*TG + 4*S*MG2 + 2*TG**2
     +     )
     +
      M2QBSV = M2QBSV + SK1D0(1,1)*CQED * (  - 2*S*TG + 4*S**2*UG**(-1)
     +    *MG2 )
     +
      M2QBSV = M2QBSV + SK1D0(1,2)*N*CO * ( 8*S**(-1)*TG**3 + 10*S*TG
     +     + 2*S*MG2 + 2*S**2 + 4*TG*MG2 + 16*TG**2 )
     +
      M2QBSV = M2QBSV + SK1D0(1,2)*N*CK * ( 2*S*TG + 4*S*MG2 + 2*TG**2
     +     )
     +
      M2QBSV = M2QBSV + SK1D0(1,2)*CQED * ( 2*S*TG + 4*S**2*TG**(-1)*
     +    MG2 + 2*S**2 )
     +
      M2QBSV = M2QBSV + SK1D0(2,1)*N*CO * (  - 2*S*TG - 4*S*MG2 - 2*
     +    TG**2 + 8*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(2,1)*N*CK * ( 2*S*TG + 2*S*MG2 - 4*TG*MG2
     +     )
     +
      M2QBSV = M2QBSV + SK1D0(2,1)*CQED * ( 4*S*MG2 + 6*S**2*UG**(-1)*
     +    MG2 - 2*S**2 - 2*S**3*UG**(-1) )
     +
      M2QBSV = M2QBSV + SK1D0(2,2)*N*CO * (  - 2*S*TG - 4*S*MG2 - 2*
     +    TG**2 + 8*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(2,2)*N*CK * (  - 2*S*TG + 6*S*MG2 - 2*
     +    S**2 + 4*TG*MG2 )
     +
      M2QBSV = M2QBSV + SK1D0(2,2)*CQED * ( 4*S*MG2 + 6*S**2*TG**(-1)*
     +    MG2 - 2*S**2 - 2*S**3*TG**(-1) )
     +
      M2QBSV = M2QBSV + SK1D0(3,1)*N*CK * (  - 8*S*TG - 12*S*MG2 - 8*
     +    TG**2 )
     +
      M2QBSV = M2QBSV + SOF1(1)*N*CO * (  - 128*S**(-2)*TG**2*MG2 - 128
     +    *S**(-1)*TG*MG2 + 64*S**(-1)*TG**2 - 128*S**(-1)*MG2**2 + 32*
     +    S*TG**(-1)*MG2 + 32*S*UG**(-1)*MG2 + 32*S - 64*TG**(-1)*
     +    MG2**2 + 64*TG - 64*UG**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SOF1(2)*N*CO * (  - 128*S**(-2)*TG**2*MG2 - 128
     +    *S**(-1)*TG*MG2 - 128*S**(-1)*MG2**2 - 64*TG**(-1)*MG2**2 - 
     +    64*UG**(-1)*MG2**2 - 64*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(2)*N*CK * ( 64*TG**(-1)*MG2**2 + 64*
     +    UG**(-1)*MG2**2 + 64*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(3)*N*CO * (  - 128*S**(-2)*TG**2*MG2 - 128
     +    *S**(-1)*TG*MG2 - 128*S**(-1)*MG2**2 - 64*TG**(-1)*MG2**2 - 
     +    64*UG**(-1)*MG2**2 - 64*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(3)*N*CK * ( 64*TG**(-1)*MG2**2 + 64*
     +    UG**(-1)*MG2**2 + 64*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(4)*N*CO * (  - 32*S**(-2)*TG**3 - 32*
     +    S**(-1)*TG*MG2 - 32*S**(-1)*TG**2 )
     +
      M2QBSV = M2QBSV + SOF1(4)*N*CK * ( 32*S*TG**(-1)*MG2 + 32*S + 32*
     +    TG )
     +
      M2QBSV = M2QBSV + SOF1(5)*N*CO * ( 32*S**(-2)*TG**3 + 32*S**(-1)*
     +    TG*MG2 + 64*S**(-1)*TG**2 + 32*TG + 32*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(5)*N*CK * ( 32*S*UG**(-1)*MG2 - 32*TG )
     +
      M2QBSV = M2QBSV + SOF1(6)*N*CO * ( 32*S**(-2)*TG**3 + 32*S**(-1)*
     +    TG*MG2 + 64*S**(-1)*TG**2 + 32*TG + 32*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(6)*N*CK * ( 32*S*UG**(-1)*MG2 - 32*TG )
     +
      M2QBSV = M2QBSV + SOF1(7)*N*CO * (  - 32*S**(-2)*TG**3 - 32*
     +    S**(-1)*TG*MG2 - 32*S**(-1)*TG**2 )
     +
      M2QBSV = M2QBSV + SOF1(7)*N*CK * ( 32*S*TG**(-1)*MG2 + 32*S + 32*
     +    TG )
     +
      M2QBSV = M2QBSV + SOF1(8)*N*CK * (  - 64*S**(-1)*TG**2 - 32*S*
     +    TG**(-1)*MG2 - 32*S*UG**(-1)*MG2 - 32*S - 64*TG - 64*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(8)*CQED * ( 32*S*TG**(-1)*MG2 + 32*S*
     +    UG**(-1)*MG2 + 32*S )


      ELSE

      M2QBSV = 0.D0
      M2QBSV = M2QBSV + N*CO*THREE**(-1) * (  - 28 - 8*S**(-2)*TG**2 - 
     +    8*S**(-1)*TG + 48*S**(-1)*TG**2*S1**(-1) - 26*S**(-1)*TG**2*
     +    T1**(-1) - 26*S**(-1)*TG**2*U1**(-1) - 8*S**(-1)*MG2 + 24*S*
     +    TG*S1**(-1)*T1**(-1) + 24*S*TG*S1**(-1)*U1**(-1) - 48*S*TG*
     +    U1**(-2) - 48*S*S1**(-1)*T1**(-1)*MG2 - 48*S*S1**(-1)*
     +    U1**(-1)*MG2 + 12*S*T1**(-1) - 26*S*U1**(-1) + 12*S**2*
     +    S1**(-1)*T1**(-1) + 12*S**2*S1**(-1)*U1**(-1) - 24*S**2*
     +    U1**(-2) - 48*TG*S1**(-1)*T1**(-1)*MG2 - 48*TG*S1**(-1)*
     +    U1**(-1)*MG2 + 48*TG*S1**(-1) + 24*TG*T1**(-1) - 52*TG*
     +    U1**(-1) + 12*TG**2*S1**(-1)*T1**(-1) + 12*TG**2*S1**(-1)*
     +    U1**(-1) - 24*TG**2*T1**(-2) - 24*TG**2*U1**(-2) + 48*
     +    S1**(-1)*T1**(-1)*MG2**2 + 48*S1**(-1)*U1**(-1)*MG2**2 + 48*
     +    S1**(-1)*MG2 - 38*T1**(-1)*MG2 - 38*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + N*CK*THREE**(-1) * ( 12 + 24*S**(-2)*TG**2 + 24
     +    *S**(-1)*TG + 6*S**(-1)*TG**2*T1**(-1) + 6*S**(-1)*TG**2*
     +    U1**(-1) + 24*S**(-1)*MG2 + 48*S*TG*U1**(-2) - 48*S*T1**(-1)*
     +    U1**(-1)*MG2 + 6*S*U1**(-1) + 24*S**2*U1**(-2) + 12*TG*
     +    U1**(-1) + 24*TG**2*T1**(-2) + 24*TG**2*U1**(-2) + 6*T1**(-1)
     +    *MG2 + 6*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + CO*THREE**(-1) * (  - 96*S**(-2)*TG**2*S1**(-1)
     +    *NS*MS2 + 96*S**(-2)*TG**2*S1**(-1)*MT2 + 24*S**(-2)*TG**2*NS
     +    *MG2**(-1)*MS2 - 24*S**(-2)*TG**2*MG2**(-1)*MT2 - 96*S**(-1)*
     +    TG*S1**(-1)*NS*MS2 + 96*S**(-1)*TG*S1**(-1)*MT2 + 24*S**(-1)*
     +    TG*NS*MG2**(-1)*MS2 - 24*S**(-1)*TG*MG2**(-1)*MT2 - 24*
     +    S**(-1)*TG**2*S1**(-1)*T1**(-1)*NS*MS2 + 24*S**(-1)*TG**2*
     +    S1**(-1)*T1**(-1)*MT2 - 24*S**(-1)*TG**2*S1**(-1)*U1**(-1)*NS
     +    *MS2 + 24*S**(-1)*TG**2*S1**(-1)*U1**(-1)*MT2 - 24*S**(-1)*
     +    TG**2*S1**(-1)*NS*MG2**(-1)*MS2 + 24*S**(-1)*TG**2*S1**(-1)*
     +    MG2**(-1)*MT2 + 18*S**(-1)*TG**2*T1**(-1)*NS*MG2**(-1)*MS2 - 
     +    18*S**(-1)*TG**2*T1**(-1)*MG2**(-1)*MT2 + 18*S**(-1)*TG**2*
     +    U1**(-1)*NS*MG2**(-1)*MS2 - 18*S**(-1)*TG**2*U1**(-1)*
     +    MG2**(-1)*MT2 - 12*S*TG*S1**(-1)*T1**(-1)*NS*MG2**(-1)*MS2 + 
     +    12*S*TG*S1**(-1)*T1**(-1)*MG2**(-1)*MT2 - 12*S*TG*S1**(-1)*
     +    U1**(-1)*NS*MG2**(-1)*MS2 + 12*S*TG*S1**(-1)*U1**(-1)*
     +    MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + CO*THREE**(-1) * ( 24*S*TG*U1**(-2)*NS*
     +    MG2**(-1)*MS2 - 24*S*TG*U1**(-2)*MG2**(-1)*MT2 + 24*S*
     +    S1**(-1)*T1**(-1)*NS*MS2 - 24*S*S1**(-1)*T1**(-1)*MT2 + 24*S*
     +    S1**(-1)*U1**(-1)*NS*MS2 - 24*S*S1**(-1)*U1**(-1)*MT2 - 6*S*
     +    T1**(-1)*NS*MG2**(-1)*MS2 + 6*S*T1**(-1)*MG2**(-1)*MT2 + 18*S
     +    *U1**(-1)*NS*MG2**(-1)*MS2 - 18*S*U1**(-1)*MG2**(-1)*MT2 - 6*
     +    S**2*S1**(-1)*T1**(-1)*NS*MG2**(-1)*MS2 + 6*S**2*S1**(-1)*
     +    T1**(-1)*MG2**(-1)*MT2 - 6*S**2*S1**(-1)*U1**(-1)*NS*
     +    MG2**(-1)*MS2 + 6*S**2*S1**(-1)*U1**(-1)*MG2**(-1)*MT2 + 12*
     +    S**2*U1**(-2)*NS*MG2**(-1)*MS2 - 12*S**2*U1**(-2)*MG2**(-1)*
     +    MT2 - 24*TG*S1**(-1)*NS*MG2**(-1)*MS2 + 24*TG*S1**(-1)*
     +    MG2**(-1)*MT2 - 12*TG*T1**(-1)*NS*MG2**(-1)*MS2 + 12*TG*
     +    T1**(-1)*MG2**(-1)*MT2 + 36*TG*U1**(-1)*NS*MG2**(-1)*MS2 - 36
     +    *TG*U1**(-1)*MG2**(-1)*MT2 - 6*TG**2*S1**(-1)*T1**(-1)*NS*
     +    MG2**(-1)*MS2 + 6*TG**2*S1**(-1)*T1**(-1)*MG2**(-1)*MT2 - 6*
     +    TG**2*S1**(-1)*U1**(-1)*NS*MG2**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + CO*THREE**(-1) * ( 6*TG**2*S1**(-1)*U1**(-1)*
     +    MG2**(-1)*MT2 + 12*TG**2*T1**(-2)*NS*MG2**(-1)*MS2 - 12*TG**2
     +    *T1**(-2)*MG2**(-1)*MT2 + 12*TG**2*U1**(-2)*NS*MG2**(-1)*MS2
     +     - 12*TG**2*U1**(-2)*MG2**(-1)*MT2 - 48*S1**(-1)*T1**(-1)*NS*
     +    MG2*MS2 + 48*S1**(-1)*T1**(-1)*MG2*MT2 - 48*S1**(-1)*U1**(-1)
     +    *NS*MG2*MS2 + 48*S1**(-1)*U1**(-1)*MG2*MT2 - 48*S1**(-1)*NS*
     +    MS2 + 48*S1**(-1)*MT2 + 24*T1**(-1)*NS*MS2 - 24*T1**(-1)*MT2
     +     + 24*U1**(-1)*NS*MS2 - 24*U1**(-1)*MT2 + 24*NS*MG2**(-1)*MS2
     +     - 24*MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + CK*THREE**(-1) * (  - 24*S*TG*U1**(-2)*NS*
     +    MG2**(-1)*MS2 + 24*S*TG*U1**(-2)*MG2**(-1)*MT2 + 24*S*
     +    T1**(-1)*U1**(-1)*NS*MS2 - 24*S*T1**(-1)*U1**(-1)*MT2 - 12*
     +    S**2*U1**(-2)*NS*MG2**(-1)*MS2 + 12*S**2*U1**(-2)*MG2**(-1)*
     +    MT2 - 12*TG**2*T1**(-2)*NS*MG2**(-1)*MS2 + 12*TG**2*T1**(-2)*
     +    MG2**(-1)*MT2 - 12*TG**2*U1**(-2)*NS*MG2**(-1)*MS2 + 12*TG**2
     +    *U1**(-2)*MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0A(1)*CO*THREE**(-1) * (  - 64*S**(-3)*
     +    TG**2*NS*MS2 - 64*S**(-2)*TG*NS*MS2 - 96*S**(-2)*TG**2*
     +    S1**(-1)*NS*MS2 - 16*S**(-2)*TG**2*T1**(-1)*NS*MS2 - 16*
     +    S**(-2)*TG**2*U1**(-1)*NS*MS2 + 24*S**(-2)*TG**2*NS*MG2**(-1)
     +    *MS2 - 64*S**(-2)*NS*MG2*MS2 - 96*S**(-1)*TG*S1**(-1)*NS*MS2
     +     - 32*S**(-1)*TG*U1**(-1)*NS*MS2 + 24*S**(-1)*TG*NS*MG2**(-1)
     +    *MS2 - 24*S**(-1)*TG**2*S1**(-1)*T1**(-1)*NS*MS2 - 24*S**(-1)
     +    *TG**2*S1**(-1)*U1**(-1)*NS*MS2 - 24*S**(-1)*TG**2*S1**(-1)*
     +    NS*MG2**(-1)*MS2 + 18*S**(-1)*TG**2*T1**(-1)*NS*MG2**(-1)*MS2
     +     + 18*S**(-1)*TG**2*U1**(-1)*NS*MG2**(-1)*MS2 - 16*S**(-1)*
     +    T1**(-1)*NS*MG2*MS2 - 16*S**(-1)*U1**(-1)*NS*MG2*MS2 - 32*
     +    S**(-1)*NS*MS2 - 12*S*TG*S1**(-1)*T1**(-1)*NS*MG2**(-1)*MS2
     +     - 12*S*TG*S1**(-1)*U1**(-1)*NS*MG2**(-1)*MS2 + 24*S*TG*
     +    U1**(-2)*NS*MG2**(-1)*MS2 + 24*S*S1**(-1)*T1**(-1)*NS*MS2 + 
     +    24*S*S1**(-1)*U1**(-1)*NS*MS2 - 6*S*T1**(-1)*NS*MG2**(-1)*MS2
     +     + 18*S*U1**(-1)*NS*MG2**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0A(1)*CO*THREE**(-1) * (  - 6*S**2*S1**(-1)
     +    *T1**(-1)*NS*MG2**(-1)*MS2 - 6*S**2*S1**(-1)*U1**(-1)*NS*
     +    MG2**(-1)*MS2 + 12*S**2*U1**(-2)*NS*MG2**(-1)*MS2 - 24*TG*
     +    S1**(-1)*NS*MG2**(-1)*MS2 - 12*TG*T1**(-1)*NS*MG2**(-1)*MS2
     +     + 36*TG*U1**(-1)*NS*MG2**(-1)*MS2 - 6*TG**2*S1**(-1)*
     +    T1**(-1)*NS*MG2**(-1)*MS2 - 6*TG**2*S1**(-1)*U1**(-1)*NS*
     +    MG2**(-1)*MS2 + 12*TG**2*T1**(-2)*NS*MG2**(-1)*MS2 + 12*TG**2
     +    *U1**(-2)*NS*MG2**(-1)*MS2 - 48*S1**(-1)*T1**(-1)*NS*MG2*MS2
     +     - 48*S1**(-1)*U1**(-1)*NS*MG2*MS2 - 48*S1**(-1)*NS*MS2 + 24*
     +    T1**(-1)*NS*MS2 + 8*U1**(-1)*NS*MS2 + 24*NS*MG2**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0A(1)*CK*THREE**(-1) * (  - 24*S*TG*
     +    U1**(-2)*NS*MG2**(-1)*MS2 + 24*S*T1**(-1)*U1**(-1)*NS*MS2 - 
     +    12*S**2*U1**(-2)*NS*MG2**(-1)*MS2 - 12*TG**2*T1**(-2)*NS*
     +    MG2**(-1)*MS2 - 12*TG**2*U1**(-2)*NS*MG2**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0A(2)*CO*THREE**(-1) * ( 64*S**(-3)*TG**2*
     +    MT2 + 64*S**(-2)*TG*MT2 + 96*S**(-2)*TG**2*S1**(-1)*MT2 + 16*
     +    S**(-2)*TG**2*T1**(-1)*MT2 + 16*S**(-2)*TG**2*U1**(-1)*MT2 - 
     +    24*S**(-2)*TG**2*MG2**(-1)*MT2 + 64*S**(-2)*MG2*MT2 + 96*
     +    S**(-1)*TG*S1**(-1)*MT2 + 32*S**(-1)*TG*U1**(-1)*MT2 - 24*
     +    S**(-1)*TG*MG2**(-1)*MT2 + 24*S**(-1)*TG**2*S1**(-1)*T1**(-1)
     +    *MT2 + 24*S**(-1)*TG**2*S1**(-1)*U1**(-1)*MT2 + 24*S**(-1)*
     +    TG**2*S1**(-1)*MG2**(-1)*MT2 - 18*S**(-1)*TG**2*T1**(-1)*
     +    MG2**(-1)*MT2 - 18*S**(-1)*TG**2*U1**(-1)*MG2**(-1)*MT2 + 16*
     +    S**(-1)*T1**(-1)*MG2*MT2 + 16*S**(-1)*U1**(-1)*MG2*MT2 + 32*
     +    S**(-1)*MT2 + 12*S*TG*S1**(-1)*T1**(-1)*MG2**(-1)*MT2 + 12*S*
     +    TG*S1**(-1)*U1**(-1)*MG2**(-1)*MT2 - 24*S*TG*U1**(-2)*
     +    MG2**(-1)*MT2 - 24*S*S1**(-1)*T1**(-1)*MT2 - 24*S*S1**(-1)*
     +    U1**(-1)*MT2 + 6*S*T1**(-1)*MG2**(-1)*MT2 - 18*S*U1**(-1)*
     +    MG2**(-1)*MT2 + 6*S**2*S1**(-1)*T1**(-1)*MG2**(-1)*MT2 + 6*
     +    S**2*S1**(-1)*U1**(-1)*MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0A(2)*CO*THREE**(-1) * (  - 12*S**2*
     +    U1**(-2)*MG2**(-1)*MT2 + 24*TG*S1**(-1)*MG2**(-1)*MT2 + 12*TG
     +    *T1**(-1)*MG2**(-1)*MT2 - 36*TG*U1**(-1)*MG2**(-1)*MT2 + 6*
     +    TG**2*S1**(-1)*T1**(-1)*MG2**(-1)*MT2 + 6*TG**2*S1**(-1)*
     +    U1**(-1)*MG2**(-1)*MT2 - 12*TG**2*T1**(-2)*MG2**(-1)*MT2 - 12
     +    *TG**2*U1**(-2)*MG2**(-1)*MT2 + 48*S1**(-1)*T1**(-1)*MG2*MT2
     +     + 48*S1**(-1)*U1**(-1)*MG2*MT2 + 48*S1**(-1)*MT2 - 24*
     +    T1**(-1)*MT2 - 8*U1**(-1)*MT2 - 24*MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0A(2)*CK*THREE**(-1) * ( 24*S*TG*U1**(-2)*
     +    MG2**(-1)*MT2 - 24*S*T1**(-1)*U1**(-1)*MT2 + 12*S**2*U1**(-2)
     +    *MG2**(-1)*MT2 + 12*TG**2*T1**(-2)*MG2**(-1)*MT2 + 12*TG**2*
     +    U1**(-2)*MG2**(-1)*MT2 )
     +
      M2QBSV = M2QBSV + SK1B0A(3)*N*CO * (  - 4 - 16*S**(-3)*TG**2*MG2
     +     + 16*S**(-3)*TG**2*MS2 - 16*S**(-2)*TG*MG2 + 16*S**(-2)*TG*
     +    MS2 - 4*S**(-2)*TG**2*T1**(-1)*MG2 + 4*S**(-2)*TG**2*T1**(-1)
     +    *MS2 - 4*S**(-2)*TG**2*U1**(-1)*MG2 + 4*S**(-2)*TG**2*
     +    U1**(-1)*MS2 - 8*S**(-2)*TG**2 + 16*S**(-2)*MG2*MS2 - 16*
     +    S**(-2)*MG2**2 - 8*S**(-1)*TG*U1**(-1)*MG2 + 8*S**(-1)*TG*
     +    U1**(-1)*MS2 - 8*S**(-1)*TG - 4*S**(-1)*TG**2*T1**(-1) - 4*
     +    S**(-1)*TG**2*U1**(-1) + 4*S**(-1)*T1**(-1)*MG2*MS2 - 4*
     +    S**(-1)*T1**(-1)*MG2**2 + 4*S**(-1)*U1**(-1)*MG2*MS2 - 4*
     +    S**(-1)*U1**(-1)*MG2**2 - 16*S**(-1)*MG2 + 8*S**(-1)*MS2 - 4*
     +    S*TG*U1**(-2) - 4*S*U1**(-1) - 2*S**2*U1**(-2) - 8*TG*
     +    U1**(-1) - 2*TG**2*T1**(-2) - 2*TG**2*U1**(-2) - 4*T1**(-1)*
     +    MG2 - 8*U1**(-1)*MG2 + 4*U1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0A(3)*N*CK * ( 4 + 16*S**(-3)*TG**2*MG2 - 
     +    16*S**(-3)*TG**2*MS2 + 16*S**(-2)*TG*MG2 - 16*S**(-2)*TG*MS2
     +     + 4*S**(-2)*TG**2*T1**(-1)*MG2 - 4*S**(-2)*TG**2*T1**(-1)*
     +    MS2 + 4*S**(-2)*TG**2*U1**(-1)*MG2 - 4*S**(-2)*TG**2*U1**(-1)
     +    *MS2 + 8*S**(-2)*TG**2 - 16*S**(-2)*MG2*MS2 + 16*S**(-2)*
     +    MG2**2 + 8*S**(-1)*TG*U1**(-1)*MG2 - 8*S**(-1)*TG*U1**(-1)*
     +    MS2 + 8*S**(-1)*TG + 4*S**(-1)*TG**2*T1**(-1) + 4*S**(-1)*
     +    TG**2*U1**(-1) - 4*S**(-1)*T1**(-1)*MG2*MS2 + 4*S**(-1)*
     +    T1**(-1)*MG2**2 - 4*S**(-1)*U1**(-1)*MG2*MS2 + 4*S**(-1)*
     +    U1**(-1)*MG2**2 + 16*S**(-1)*MG2 - 8*S**(-1)*MS2 + 12*S*TG*
     +    U1**(-2) - 8*S*T1**(-1)*U1**(-1)*MG2 + 4*S*U1**(-1) + 6*S**2*
     +    U1**(-2) + 8*TG*U1**(-1) + 6*TG**2*T1**(-2) + 6*TG**2*
     +    U1**(-2) + 4*T1**(-1)*MG2 + 8*U1**(-1)*MG2 - 4*U1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0A(3)*CQED * (  - 4*S*TG*U1**(-2) + 4*S*
     +    T1**(-1)*U1**(-1)*MG2 - 2*S**2*U1**(-2) - 2*TG**2*T1**(-2) - 
     +    2*TG**2*U1**(-2) )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*N*CO*THREE**(-1) * ( 28 + 56*S**(-2)*
     +    TG**2 + 56*S**(-1)*TG + 96*S**(-1)*TG**2*S1**(-1) + 14*
     +    S**(-1)*TG**2*T1**(-1) + 14*S**(-1)*TG**2*U1**(-1) + 56*
     +    S**(-1)*MG2 + 144*S*TG*S1**(-2)*T1**(-1)*MG2 + 144*S*TG*
     +    S1**(-2)*U1**(-1)*MG2 + 144*S*TG*S1**(-2) + 12*S*TG*S1**(-1)*
     +    T1**(-1) + 12*S*TG*S1**(-1)*U1**(-1) - 288*S*S1**(-2)*
     +    T1**(-1)*MG2**2 - 288*S*S1**(-2)*U1**(-1)*MG2**2 - 288*S*
     +    S1**(-2)*MG2 + 48*S*S1**(-1)*T1**(-1)*MG2 + 48*S*S1**(-1)*
     +    U1**(-1)*MG2 + 72*S*S1**(-1) + 6*S*T1**(-1) + 14*S*U1**(-1)
     +     + 72*S**2*S1**(-2)*T1**(-1)*MG2 + 72*S**2*S1**(-2)*U1**(-1)*
     +    MG2 + 72*S**2*S1**(-2) + 6*S**2*S1**(-1)*T1**(-1) + 6*S**2*
     +    S1**(-1)*U1**(-1) - 288*TG*S1**(-2)*T1**(-1)*MG2**2 - 288*TG*
     +    S1**(-2)*U1**(-1)*MG2**2 - 288*TG*S1**(-2)*MG2 + 48*TG*
     +    S1**(-1)*T1**(-1)*MG2 + 48*TG*S1**(-1)*U1**(-1)*MG2 + 168*TG*
     +    S1**(-1) + 12*TG*T1**(-1) + 28*TG*U1**(-1) + 72*TG**2*
     +    S1**(-2)*T1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*N*CO*THREE**(-1) * ( 72*TG**2*
     +    S1**(-2)*U1**(-1)*MG2 + 72*TG**2*S1**(-2) + 6*TG**2*S1**(-1)*
     +    T1**(-1) + 6*TG**2*S1**(-1)*U1**(-1) + 288*S1**(-2)*T1**(-1)*
     +    MG2**3 + 288*S1**(-2)*U1**(-1)*MG2**3 + 288*S1**(-2)*MG2**2
     +     - 96*S1**(-1)*T1**(-1)*MG2**2 - 96*S1**(-1)*U1**(-1)*MG2**2
     +     - 24*S1**(-1)*MG2 + 20*T1**(-1)*MG2 + 20*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*N*CK*THREE**(-1) * ( 24 + 72*S**(-2)*
     +    TG**2 + 72*S**(-1)*TG + 18*S**(-1)*TG**2*T1**(-1) + 18*
     +    S**(-1)*TG**2*U1**(-1) + 72*S**(-1)*MG2 - 24*S*S1**(-1)*
     +    T1**(-1)*MG2 + 24*S*S1**(-1)*U1**(-1)*MG2 + 6*S*U1**(-1) - 24
     +    *TG*S1**(-1)*T1**(-1)*MG2 + 24*TG*S1**(-1)*U1**(-1)*MG2 + 12*
     +    TG*T1**(-1) + 24*TG*U1**(-1) + 48*S1**(-1)*T1**(-1)*MG2**2 - 
     +    48*S1**(-1)*U1**(-1)*MG2**2 + 6*T1**(-1)*MG2 + 30*U1**(-1)*
     +    MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CO*THREE**(-1) * ( 4 - 96*S**(-2)*
     +    TG**2*S1**(-1)*NS*MS2 + 96*S**(-2)*TG**2*S1**(-1)*MS2 - 8*
     +    S**(-2)*TG**2*NS + 8*S**(-2)*TG**2 - 96*S**(-1)*TG*S1**(-1)*
     +    NS*MS2 + 96*S**(-1)*TG*S1**(-1)*MS2 - 8*S**(-1)*TG*NS + 8*
     +    S**(-1)*TG - 144*S**(-1)*TG**2*S1**(-2)*NS*MS2 + 144*S**(-1)*
     +    TG**2*S1**(-2)*MS2 - 24*S**(-1)*TG**2*S1**(-1)*T1**(-1)*NS*
     +    MS2 + 24*S**(-1)*TG**2*S1**(-1)*T1**(-1)*MS2 - 24*S**(-1)*
     +    TG**2*S1**(-1)*U1**(-1)*NS*MS2 + 24*S**(-1)*TG**2*S1**(-1)*
     +    U1**(-1)*MS2 - 36*S**(-1)*TG**2*S1**(-1)*NS + 36*S**(-1)*
     +    TG**2*S1**(-1) - 2*S**(-1)*TG**2*T1**(-1)*NS + 2*S**(-1)*
     +    TG**2*T1**(-1) - 2*S**(-1)*TG**2*U1**(-1)*NS + 2*S**(-1)*
     +    TG**2*U1**(-1) - 8*S**(-1)*NS*MG2 - 24*S**(-1)*NS*MS2 + 8*
     +    S**(-1)*MG2 + 24*S**(-1)*MS2 - 72*S*TG*S1**(-2)*T1**(-1)*NS*
     +    MG2 - 72*S*TG*S1**(-2)*T1**(-1)*NS*MS2 + 72*S*TG*S1**(-2)*
     +    T1**(-1)*MG2 + 72*S*TG*S1**(-2)*T1**(-1)*MS2 - 72*S*TG*
     +    S1**(-2)*U1**(-1)*NS*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CO*THREE**(-1) * (  - 72*S*TG*
     +    S1**(-2)*U1**(-1)*NS*MS2 + 72*S*TG*S1**(-2)*U1**(-1)*MG2 + 72
     +    *S*TG*S1**(-2)*U1**(-1)*MS2 - 72*S*TG*S1**(-2)*NS + 72*S*TG*
     +    S1**(-2) + 144*S*S1**(-2)*T1**(-1)*NS*MG2*MS2 + 144*S*
     +    S1**(-2)*T1**(-1)*NS*MG2**2 - 144*S*S1**(-2)*T1**(-1)*MG2*MS2
     +     - 144*S*S1**(-2)*T1**(-1)*MG2**2 + 144*S*S1**(-2)*U1**(-1)*
     +    NS*MG2*MS2 + 144*S*S1**(-2)*U1**(-1)*NS*MG2**2 - 144*S*
     +    S1**(-2)*U1**(-1)*MG2*MS2 - 144*S*S1**(-2)*U1**(-1)*MG2**2 + 
     +    144*S*S1**(-2)*NS*MG2 - 144*S*S1**(-2)*MG2 - 48*S*S1**(-1)*
     +    T1**(-1)*NS*MG2 - 48*S*S1**(-1)*T1**(-1)*NS*MS2 + 48*S*
     +    S1**(-1)*T1**(-1)*MG2 + 48*S*S1**(-1)*T1**(-1)*MS2 - 24*S*
     +    S1**(-1)*U1**(-1)*NS*MG2 - 24*S*S1**(-1)*U1**(-1)*NS*MS2 + 24
     +    *S*S1**(-1)*U1**(-1)*MG2 + 24*S*S1**(-1)*U1**(-1)*MS2 - 36*S*
     +    S1**(-1)*NS + 36*S*S1**(-1) - 2*S*U1**(-1)*NS + 2*S*U1**(-1)
     +     - 36*S**2*S1**(-2)*T1**(-1)*NS*MG2 - 36*S**2*S1**(-2)*
     +    T1**(-1)*NS*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CO*THREE**(-1) * ( 36*S**2*S1**(-2)*
     +    T1**(-1)*MG2 + 36*S**2*S1**(-2)*T1**(-1)*MS2 - 36*S**2*
     +    S1**(-2)*U1**(-1)*NS*MG2 - 36*S**2*S1**(-2)*U1**(-1)*NS*MS2
     +     + 36*S**2*S1**(-2)*U1**(-1)*MG2 + 36*S**2*S1**(-2)*U1**(-1)*
     +    MS2 - 36*S**2*S1**(-2)*NS + 36*S**2*S1**(-2) + 144*TG*
     +    S1**(-2)*T1**(-1)*NS*MG2*MS2 + 144*TG*S1**(-2)*T1**(-1)*NS*
     +    MG2**2 - 144*TG*S1**(-2)*T1**(-1)*MG2*MS2 - 144*TG*S1**(-2)*
     +    T1**(-1)*MG2**2 + 144*TG*S1**(-2)*U1**(-1)*NS*MG2*MS2 + 144*
     +    TG*S1**(-2)*U1**(-1)*NS*MG2**2 - 144*TG*S1**(-2)*U1**(-1)*MG2
     +    *MS2 - 144*TG*S1**(-2)*U1**(-1)*MG2**2 + 144*TG*S1**(-2)*NS*
     +    MG2 - 144*TG*S1**(-2)*NS*MS2 - 144*TG*S1**(-2)*MG2 + 144*TG*
     +    S1**(-2)*MS2 - 48*TG*S1**(-1)*T1**(-1)*NS*MG2 - 72*TG*
     +    S1**(-1)*T1**(-1)*NS*MS2 + 48*TG*S1**(-1)*T1**(-1)*MG2 + 72*
     +    TG*S1**(-1)*T1**(-1)*MS2 - 24*TG*S1**(-1)*U1**(-1)*NS*MG2 - 
     +    48*TG*S1**(-1)*U1**(-1)*NS*MS2 + 24*TG*S1**(-1)*U1**(-1)*MG2
     +     + 48*TG*S1**(-1)*U1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CO*THREE**(-1) * (  - 72*TG*S1**(-1)*
     +    NS + 72*TG*S1**(-1) - 4*TG*U1**(-1)*NS + 4*TG*U1**(-1) - 36*
     +    TG**2*S1**(-2)*T1**(-1)*NS*MG2 - 36*TG**2*S1**(-2)*T1**(-1)*
     +    NS*MS2 + 36*TG**2*S1**(-2)*T1**(-1)*MG2 + 36*TG**2*S1**(-2)*
     +    T1**(-1)*MS2 - 36*TG**2*S1**(-2)*U1**(-1)*NS*MG2 - 36*TG**2*
     +    S1**(-2)*U1**(-1)*NS*MS2 + 36*TG**2*S1**(-2)*U1**(-1)*MG2 + 
     +    36*TG**2*S1**(-2)*U1**(-1)*MS2 - 36*TG**2*S1**(-2)*NS + 36*
     +    TG**2*S1**(-2) - 144*S1**(-2)*T1**(-1)*NS*MG2**2*MS2 - 144*
     +    S1**(-2)*T1**(-1)*NS*MG2**3 + 144*S1**(-2)*T1**(-1)*MG2**2*
     +    MS2 + 144*S1**(-2)*T1**(-1)*MG2**3 - 144*S1**(-2)*U1**(-1)*NS
     +    *MG2**2*MS2 - 144*S1**(-2)*U1**(-1)*NS*MG2**3 + 144*S1**(-2)*
     +    U1**(-1)*MG2**2*MS2 + 144*S1**(-2)*U1**(-1)*MG2**3 - 144*
     +    S1**(-2)*NS*MG2*MS2 - 144*S1**(-2)*NS*MG2**2 + 144*S1**(-2)*
     +    MG2*MS2 + 144*S1**(-2)*MG2**2 + 60*S1**(-1)*T1**(-1)*NS*MG2*
     +    MS2 + 84*S1**(-1)*T1**(-1)*NS*MG2**2 - 60*S1**(-1)*T1**(-1)*
     +    MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CO*THREE**(-1) * (  - 84*S1**(-1)*
     +    T1**(-1)*MG2**2 + 12*S1**(-1)*U1**(-1)*NS*MG2*MS2 + 36*
     +    S1**(-1)*U1**(-1)*NS*MG2**2 - 12*S1**(-1)*U1**(-1)*MG2*MS2 - 
     +    36*S1**(-1)*U1**(-1)*MG2**2 + 24*S1**(-1)*NS*MG2 - 24*
     +    S1**(-1)*MG2 - 14*T1**(-1)*NS*MG2 - 12*T1**(-1)*NS*MS2 + 14*
     +    T1**(-1)*MG2 + 12*T1**(-1)*MS2 - 2*U1**(-1)*NS*MG2 + 2*
     +    U1**(-1)*MG2 - 4*NS )
     +
      M2QBSV = M2QBSV + SK1B0B(1)*CQED*THREE**(-1) * ( 48*S*S1**(-1)*
     +    T1**(-1)*MG2 - 48*S*S1**(-1)*U1**(-1)*MG2 + 12*S*U1**(-1) + 
     +    48*TG*S1**(-1)*T1**(-1)*MG2 - 48*TG*S1**(-1)*U1**(-1)*MG2 - 
     +    12*TG*T1**(-1) + 12*TG*U1**(-1) - 96*S1**(-1)*T1**(-1)*MG2**2
     +     + 96*S1**(-1)*U1**(-1)*MG2**2 + 24*T1**(-1)*MG2 - 24*
     +    U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(2)*N*CO*THREE**(-1) * (  - 28 - 16*
     +    S**(-3)*TG**2*MG2 - 48*S**(-3)*TG**2*MS2 - 16*S**(-2)*TG*MG2
     +     - 48*S**(-2)*TG*MS2 - 4*S**(-2)*TG**2*T1**(-1)*MG2 - 12*
     +    S**(-2)*TG**2*T1**(-1)*MS2 - 4*S**(-2)*TG**2*U1**(-1)*MG2 - 
     +    12*S**(-2)*TG**2*U1**(-1)*MS2 - 56*S**(-2)*TG**2 - 48*S**(-2)
     +    *MG2*MS2 - 16*S**(-2)*MG2**2 - 8*S**(-1)*TG*U1**(-1)*MG2 - 24
     +    *S**(-1)*TG*U1**(-1)*MS2 - 56*S**(-1)*TG + 24*S**(-1)*TG**2*
     +    S1**(-1) - 14*S**(-1)*TG**2*T1**(-1) - 14*S**(-1)*TG**2*
     +    U1**(-1) - 12*S**(-1)*T1**(-1)*MG2*MS2 - 4*S**(-1)*T1**(-1)*
     +    MG2**2 - 12*S**(-1)*U1**(-1)*MG2*MS2 - 4*S**(-1)*U1**(-1)*
     +    MG2**2 - 64*S**(-1)*MG2 - 24*S**(-1)*MS2 + 12*S*TG*S1**(-1)*
     +    T1**(-1) + 12*S*TG*S1**(-1)*U1**(-1) - 48*S*S1**(-1)*U1**(-1)
     +    *MG2 + 6*S*T1**(-1) - 2*S*U1**(-1) + 6*S**2*S1**(-1)*T1**(-1)
     +     + 6*S**2*S1**(-1)*U1**(-1) - 48*TG*S1**(-1)*U1**(-1)*MG2 + 
     +    24*TG*S1**(-1) - 16*TG*U1**(-1) + 6*TG**2*S1**(-1)*T1**(-1)
     +     + 6*TG**2*S1**(-1)*U1**(-1) )
     +
      M2QBSV = M2QBSV + SK1B0B(2)*N*CO*THREE**(-1) * (  - 24*S1**(-1)*
     +    T1**(-1)*MG2**2 + 72*S1**(-1)*U1**(-1)*MG2**2 + 24*S1**(-1)*
     +    MG2 - 8*T1**(-1)*MG2 - 36*U1**(-1)*MG2 - 12*U1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(3)*N*CK*THREE**(-1) * (  - 24 - 48*
     +    S**(-3)*TG**2*MG2 + 48*S**(-3)*TG**2*MS2 - 48*S**(-2)*TG*MG2
     +     + 48*S**(-2)*TG*MS2 - 12*S**(-2)*TG**2*T1**(-1)*MG2 + 12*
     +    S**(-2)*TG**2*T1**(-1)*MS2 - 12*S**(-2)*TG**2*U1**(-1)*MG2 + 
     +    12*S**(-2)*TG**2*U1**(-1)*MS2 - 24*S**(-2)*TG**2 + 48*S**(-2)
     +    *MG2*MS2 - 48*S**(-2)*MG2**2 - 24*S**(-1)*TG*U1**(-1)*MG2 + 
     +    24*S**(-1)*TG*U1**(-1)*MS2 - 24*S**(-1)*TG - 6*S**(-1)*TG**2*
     +    T1**(-1) - 6*S**(-1)*TG**2*U1**(-1) + 12*S**(-1)*T1**(-1)*MG2
     +    *MS2 - 12*S**(-1)*T1**(-1)*MG2**2 + 12*S**(-1)*U1**(-1)*MG2*
     +    MS2 - 12*S**(-1)*U1**(-1)*MG2**2 - 48*S**(-1)*MG2 + 24*
     +    S**(-1)*MS2 + 24*S*S1**(-1)*T1**(-1)*MG2 - 24*S*S1**(-1)*
     +    U1**(-1)*MG2 - 6*S*U1**(-1) + 24*TG*S1**(-1)*T1**(-1)*MG2 - 
     +    24*TG*S1**(-1)*U1**(-1)*MG2 - 12*TG*U1**(-1) - 48*S1**(-1)*
     +    T1**(-1)*MG2**2 + 48*S1**(-1)*U1**(-1)*MG2**2 + 6*T1**(-1)*
     +    MG2 - 30*U1**(-1)*MG2 + 12*U1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(3)*CO*THREE**(-1) * ( 64*S**(-3)*TG**2*
     +    NS*MS2 + 64*S**(-2)*TG*NS*MS2 - 96*S**(-2)*TG**2*S1**(-1)*NS*
     +    MS2 + 96*S**(-2)*TG**2*S1**(-1)*MT2 + 16*S**(-2)*TG**2*
     +    T1**(-1)*NS*MS2 + 16*S**(-2)*TG**2*U1**(-1)*NS*MS2 + 8*
     +    S**(-2)*TG**2*NS + 64*S**(-2)*NS*MG2*MS2 - 96*S**(-1)*TG*
     +    S1**(-1)*NS*MS2 + 96*S**(-1)*TG*S1**(-1)*MT2 + 32*S**(-1)*TG*
     +    U1**(-1)*NS*MS2 + 8*S**(-1)*TG*NS - 144*S**(-1)*TG**2*
     +    S1**(-2)*NS*MS2 + 144*S**(-1)*TG**2*S1**(-2)*MT2 - 24*S**(-1)
     +    *TG**2*S1**(-1)*T1**(-1)*NS*MS2 + 24*S**(-1)*TG**2*S1**(-1)*
     +    T1**(-1)*MT2 - 24*S**(-1)*TG**2*S1**(-1)*U1**(-1)*NS*MS2 + 24
     +    *S**(-1)*TG**2*S1**(-1)*U1**(-1)*MT2 + 36*S**(-1)*TG**2*
     +    S1**(-1)*NS + 2*S**(-1)*TG**2*T1**(-1)*NS + 2*S**(-1)*TG**2*
     +    U1**(-1)*NS + 16*S**(-1)*T1**(-1)*NS*MG2*MS2 + 16*S**(-1)*
     +    U1**(-1)*NS*MG2*MS2 + 8*S**(-1)*NS*MG2 + 8*S**(-1)*NS*MS2 + 
     +    24*S**(-1)*MT2 + 72*S*TG*S1**(-2)*T1**(-1)*NS*MG2 - 72*S*TG*
     +    S1**(-2)*T1**(-1)*NS*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(3)*CO*THREE**(-1) * ( 72*S*TG*S1**(-2)*
     +    T1**(-1)*MT2 + 72*S*TG*S1**(-2)*U1**(-1)*NS*MG2 - 72*S*TG*
     +    S1**(-2)*U1**(-1)*NS*MS2 + 72*S*TG*S1**(-2)*U1**(-1)*MT2 + 72
     +    *S*TG*S1**(-2)*NS + 144*S*S1**(-2)*T1**(-1)*NS*MG2*MS2 - 144*
     +    S*S1**(-2)*T1**(-1)*NS*MG2**2 - 144*S*S1**(-2)*T1**(-1)*MG2*
     +    MT2 + 144*S*S1**(-2)*U1**(-1)*NS*MG2*MS2 - 144*S*S1**(-2)*
     +    U1**(-1)*NS*MG2**2 - 144*S*S1**(-2)*U1**(-1)*MG2*MT2 - 144*S*
     +    S1**(-2)*NS*MG2 + 48*S*S1**(-1)*T1**(-1)*NS*MG2 - 48*S*
     +    S1**(-1)*T1**(-1)*NS*MS2 + 48*S*S1**(-1)*T1**(-1)*MT2 + 24*S*
     +    S1**(-1)*U1**(-1)*NS*MG2 - 24*S*S1**(-1)*U1**(-1)*NS*MS2 + 24
     +    *S*S1**(-1)*U1**(-1)*MT2 + 36*S*S1**(-1)*NS + 2*S*U1**(-1)*NS
     +     + 36*S**2*S1**(-2)*T1**(-1)*NS*MG2 - 36*S**2*S1**(-2)*
     +    T1**(-1)*NS*MS2 + 36*S**2*S1**(-2)*T1**(-1)*MT2 + 36*S**2*
     +    S1**(-2)*U1**(-1)*NS*MG2 - 36*S**2*S1**(-2)*U1**(-1)*NS*MS2
     +     + 36*S**2*S1**(-2)*U1**(-1)*MT2 + 36*S**2*S1**(-2)*NS + 144*
     +    TG*S1**(-2)*T1**(-1)*NS*MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(3)*CO*THREE**(-1) * (  - 144*TG*S1**(-2)
     +    *T1**(-1)*NS*MG2**2 - 144*TG*S1**(-2)*T1**(-1)*MG2*MT2 + 144*
     +    TG*S1**(-2)*U1**(-1)*NS*MG2*MS2 - 144*TG*S1**(-2)*U1**(-1)*NS
     +    *MG2**2 - 144*TG*S1**(-2)*U1**(-1)*MG2*MT2 - 144*TG*S1**(-2)*
     +    NS*MG2 - 144*TG*S1**(-2)*NS*MS2 + 144*TG*S1**(-2)*MT2 + 48*TG
     +    *S1**(-1)*T1**(-1)*NS*MG2 - 72*TG*S1**(-1)*T1**(-1)*NS*MS2 + 
     +    72*TG*S1**(-1)*T1**(-1)*MT2 + 24*TG*S1**(-1)*U1**(-1)*NS*MG2
     +     - 48*TG*S1**(-1)*U1**(-1)*NS*MS2 + 48*TG*S1**(-1)*U1**(-1)*
     +    MT2 + 72*TG*S1**(-1)*NS + 4*TG*U1**(-1)*NS + 36*TG**2*
     +    S1**(-2)*T1**(-1)*NS*MG2 - 36*TG**2*S1**(-2)*T1**(-1)*NS*MS2
     +     + 36*TG**2*S1**(-2)*T1**(-1)*MT2 + 36*TG**2*S1**(-2)*
     +    U1**(-1)*NS*MG2 - 36*TG**2*S1**(-2)*U1**(-1)*NS*MS2 + 36*
     +    TG**2*S1**(-2)*U1**(-1)*MT2 + 36*TG**2*S1**(-2)*NS - 144*
     +    S1**(-2)*T1**(-1)*NS*MG2**2*MS2 + 144*S1**(-2)*T1**(-1)*NS*
     +    MG2**3 + 144*S1**(-2)*T1**(-1)*MG2**2*MT2 - 144*S1**(-2)*
     +    U1**(-1)*NS*MG2**2*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(3)*CO*THREE**(-1) * ( 144*S1**(-2)*
     +    U1**(-1)*NS*MG2**3 + 144*S1**(-2)*U1**(-1)*MG2**2*MT2 - 144*
     +    S1**(-2)*NS*MG2*MS2 + 144*S1**(-2)*NS*MG2**2 + 144*S1**(-2)*
     +    MG2*MT2 + 60*S1**(-1)*T1**(-1)*NS*MG2*MS2 - 84*S1**(-1)*
     +    T1**(-1)*NS*MG2**2 - 60*S1**(-1)*T1**(-1)*MG2*MT2 + 12*
     +    S1**(-1)*U1**(-1)*NS*MG2*MS2 - 36*S1**(-1)*U1**(-1)*NS*MG2**2
     +     - 12*S1**(-1)*U1**(-1)*MG2*MT2 - 24*S1**(-1)*NS*MG2 + 14*
     +    T1**(-1)*NS*MG2 - 12*T1**(-1)*NS*MS2 + 12*T1**(-1)*MT2 + 2*
     +    U1**(-1)*NS*MG2 + 16*U1**(-1)*NS*MS2 + 4*NS )
     +
      M2QBSV = M2QBSV + SK1B0B(3)*CQED*THREE**(-1) * (  - 48*S*S1**(-1)
     +    *T1**(-1)*MG2 + 48*S*S1**(-1)*U1**(-1)*MG2 - 12*S*U1**(-1) - 
     +    48*TG*S1**(-1)*T1**(-1)*MG2 + 48*TG*S1**(-1)*U1**(-1)*MG2 + 
     +    12*TG*T1**(-1) - 12*TG*U1**(-1) + 96*S1**(-1)*T1**(-1)*MG2**2
     +     - 96*S1**(-1)*U1**(-1)*MG2**2 - 24*T1**(-1)*MG2 + 24*
     +    U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(4)*CO*THREE**(-1) * (  - 4 - 64*S**(-3)*
     +    TG**2*MT2 - 64*S**(-2)*TG*MT2 - 96*S**(-2)*TG**2*S1**(-1)*MS2
     +     + 96*S**(-2)*TG**2*S1**(-1)*MT2 - 16*S**(-2)*TG**2*T1**(-1)*
     +    MT2 - 16*S**(-2)*TG**2*U1**(-1)*MT2 - 8*S**(-2)*TG**2 - 64*
     +    S**(-2)*MG2*MT2 - 96*S**(-1)*TG*S1**(-1)*MS2 + 96*S**(-1)*TG*
     +    S1**(-1)*MT2 - 32*S**(-1)*TG*U1**(-1)*MT2 - 8*S**(-1)*TG - 
     +    144*S**(-1)*TG**2*S1**(-2)*MS2 + 144*S**(-1)*TG**2*S1**(-2)*
     +    MT2 - 24*S**(-1)*TG**2*S1**(-1)*T1**(-1)*MS2 + 24*S**(-1)*
     +    TG**2*S1**(-1)*T1**(-1)*MT2 - 24*S**(-1)*TG**2*S1**(-1)*
     +    U1**(-1)*MS2 + 24*S**(-1)*TG**2*S1**(-1)*U1**(-1)*MT2 - 36*
     +    S**(-1)*TG**2*S1**(-1) - 2*S**(-1)*TG**2*T1**(-1) - 2*S**(-1)
     +    *TG**2*U1**(-1) - 16*S**(-1)*T1**(-1)*MG2*MT2 - 16*S**(-1)*
     +    U1**(-1)*MG2*MT2 - 8*S**(-1)*MG2 - 24*S**(-1)*MS2 - 8*S**(-1)
     +    *MT2 - 72*S*TG*S1**(-2)*T1**(-1)*MG2 - 72*S*TG*S1**(-2)*
     +    T1**(-1)*MS2 + 72*S*TG*S1**(-2)*T1**(-1)*MT2 - 72*S*TG*
     +    S1**(-2)*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0B(4)*CO*THREE**(-1) * (  - 72*S*TG*
     +    S1**(-2)*U1**(-1)*MS2 + 72*S*TG*S1**(-2)*U1**(-1)*MT2 - 72*S*
     +    TG*S1**(-2) + 144*S*S1**(-2)*T1**(-1)*MG2*MS2 - 144*S*
     +    S1**(-2)*T1**(-1)*MG2*MT2 + 144*S*S1**(-2)*T1**(-1)*MG2**2 + 
     +    144*S*S1**(-2)*U1**(-1)*MG2*MS2 - 144*S*S1**(-2)*U1**(-1)*MG2
     +    *MT2 + 144*S*S1**(-2)*U1**(-1)*MG2**2 + 144*S*S1**(-2)*MG2 - 
     +    48*S*S1**(-1)*T1**(-1)*MG2 - 48*S*S1**(-1)*T1**(-1)*MS2 + 48*
     +    S*S1**(-1)*T1**(-1)*MT2 - 24*S*S1**(-1)*U1**(-1)*MG2 - 24*S*
     +    S1**(-1)*U1**(-1)*MS2 + 24*S*S1**(-1)*U1**(-1)*MT2 - 36*S*
     +    S1**(-1) - 2*S*U1**(-1) - 36*S**2*S1**(-2)*T1**(-1)*MG2 - 36*
     +    S**2*S1**(-2)*T1**(-1)*MS2 + 36*S**2*S1**(-2)*T1**(-1)*MT2 - 
     +    36*S**2*S1**(-2)*U1**(-1)*MG2 - 36*S**2*S1**(-2)*U1**(-1)*MS2
     +     + 36*S**2*S1**(-2)*U1**(-1)*MT2 - 36*S**2*S1**(-2) + 144*TG*
     +    S1**(-2)*T1**(-1)*MG2*MS2 - 144*TG*S1**(-2)*T1**(-1)*MG2*MT2
     +     + 144*TG*S1**(-2)*T1**(-1)*MG2**2 + 144*TG*S1**(-2)*U1**(-1)
     +    *MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(4)*CO*THREE**(-1) * (  - 144*TG*S1**(-2)
     +    *U1**(-1)*MG2*MT2 + 144*TG*S1**(-2)*U1**(-1)*MG2**2 + 144*TG*
     +    S1**(-2)*MG2 - 144*TG*S1**(-2)*MS2 + 144*TG*S1**(-2)*MT2 - 48
     +    *TG*S1**(-1)*T1**(-1)*MG2 - 72*TG*S1**(-1)*T1**(-1)*MS2 + 72*
     +    TG*S1**(-1)*T1**(-1)*MT2 - 24*TG*S1**(-1)*U1**(-1)*MG2 - 48*
     +    TG*S1**(-1)*U1**(-1)*MS2 + 48*TG*S1**(-1)*U1**(-1)*MT2 - 72*
     +    TG*S1**(-1) - 4*TG*U1**(-1) - 36*TG**2*S1**(-2)*T1**(-1)*MG2
     +     - 36*TG**2*S1**(-2)*T1**(-1)*MS2 + 36*TG**2*S1**(-2)*
     +    T1**(-1)*MT2 - 36*TG**2*S1**(-2)*U1**(-1)*MG2 - 36*TG**2*
     +    S1**(-2)*U1**(-1)*MS2 + 36*TG**2*S1**(-2)*U1**(-1)*MT2 - 36*
     +    TG**2*S1**(-2) - 144*S1**(-2)*T1**(-1)*MG2**2*MS2 + 144*
     +    S1**(-2)*T1**(-1)*MG2**2*MT2 - 144*S1**(-2)*T1**(-1)*MG2**3
     +     - 144*S1**(-2)*U1**(-1)*MG2**2*MS2 + 144*S1**(-2)*U1**(-1)*
     +    MG2**2*MT2 - 144*S1**(-2)*U1**(-1)*MG2**3 - 144*S1**(-2)*MG2*
     +    MS2 + 144*S1**(-2)*MG2*MT2 - 144*S1**(-2)*MG2**2 + 60*
     +    S1**(-1)*T1**(-1)*MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0B(4)*CO*THREE**(-1) * (  - 60*S1**(-1)*
     +    T1**(-1)*MG2*MT2 + 84*S1**(-1)*T1**(-1)*MG2**2 + 12*S1**(-1)*
     +    U1**(-1)*MG2*MS2 - 12*S1**(-1)*U1**(-1)*MG2*MT2 + 36*S1**(-1)
     +    *U1**(-1)*MG2**2 + 24*S1**(-1)*MG2 - 14*T1**(-1)*MG2 - 12*
     +    T1**(-1)*MS2 + 12*T1**(-1)*MT2 - 2*U1**(-1)*MG2 - 16*U1**(-1)
     +    *MT2 )
     +
      M2QBSV = M2QBSV + SK1B0C(1)*N*CO * ( 32 + 32*S**(-2)*TG**2 + 16*
     +    S**(-1)*TG*T1**(-1)*MG2 - 16*S**(-1)*TG*U1**(-1)*MG2 + 32*
     +    S**(-1)*TG - 56*S**(-1)*TG**2*S1**(-1) + 24*S**(-1)*TG**2*
     +    T1**(-1) + 24*S**(-1)*TG**2*U1**(-1) + 32*S**(-1)*MG2 - 48*S*
     +    TG*S1**(-2)*T1**(-1)*MG2 - 48*S*TG*S1**(-2)*U1**(-1)*MG2 - 48
     +    *S*TG*S1**(-2) - 16*S*TG*S1**(-1)*T1**(-1) - 16*S*TG*S1**(-1)
     +    *U1**(-1) + 32*S*TG*U1**(-2) + 96*S*S1**(-2)*T1**(-1)*MG2**2
     +     + 96*S*S1**(-2)*U1**(-1)*MG2**2 + 96*S*S1**(-2)*MG2 + 16*S*
     +    S1**(-1)*U1**(-1)*MG2 - 24*S*S1**(-1) - 8*S*T1**(-1) - 16*S*
     +    U1**(-2)*MG2 + 24*S*U1**(-1) - 24*S**2*S1**(-2)*T1**(-1)*MG2
     +     - 24*S**2*S1**(-2)*U1**(-1)*MG2 - 24*S**2*S1**(-2) - 8*S**2*
     +    S1**(-1)*T1**(-1) - 8*S**2*S1**(-1)*U1**(-1) + 16*S**2*
     +    U1**(-2) + 16*TG**(-1)*T1**(-1)*MG2**2 + 8*TG**(-1)*MG2 + 96*
     +    TG*S1**(-2)*T1**(-1)*MG2**2 + 96*TG*S1**(-2)*U1**(-1)*MG2**2
     +     + 96*TG*S1**(-2)*MG2 + 16*TG*S1**(-1)*U1**(-1)*MG2 - 80*TG*
     +    S1**(-1) )
     +
      M2QBSV = M2QBSV + SK1B0C(1)*N*CO * ( 16*TG*T1**(-2)*MG2 - 16*TG*
     +    T1**(-1) - 16*TG*U1**(-2)*MG2 + 48*TG*U1**(-1) - 24*TG**2*
     +    S1**(-2)*T1**(-1)*MG2 - 24*TG**2*S1**(-2)*U1**(-1)*MG2 - 24*
     +    TG**2*S1**(-2) - 8*TG**2*S1**(-1)*T1**(-1) - 8*TG**2*S1**(-1)
     +    *U1**(-1) + 16*TG**2*T1**(-2) + 16*TG**2*U1**(-2) + 16*
     +    UG**(-1)*U1**(-1)*MG2**2 + 8*UG**(-1)*MG2 - 96*S1**(-2)*
     +    T1**(-1)*MG2**3 - 96*S1**(-2)*U1**(-1)*MG2**3 - 96*S1**(-2)*
     +    MG2**2 + 24*S1**(-1)*T1**(-1)*MG2**2 - 8*S1**(-1)*U1**(-1)*
     +    MG2**2 - 16*S1**(-1)*MG2 + 16*T1**(-1)*MG2 + 8*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0C(1)*N*CK * ( 16*S*TG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2 + 8*S*TG**(-1)*U1**(-1)*MG2 - 32*S*TG*
     +    U1**(-2) + 16*S*UG**(-1)*T1**(-1)*U1**(-1)*MG2**2 + 8*S*
     +    UG**(-1)*T1**(-1)*MG2 + 32*S*T1**(-1)*U1**(-1)*MG2 + 16*S*
     +    U1**(-2)*MG2 - 16*S**2*U1**(-2) - 16*TG*T1**(-2)*MG2 + 16*TG*
     +    U1**(-2)*MG2 - 16*TG**2*T1**(-2) - 16*TG**2*U1**(-2) + 16*
     +    T1**(-1)*MG2 + 16*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0C(2)*N*CK * (  - 16*S**(-1)*TG*T1**(-1)*
     +    MG2 + 16*S**(-1)*TG*U1**(-1)*MG2 + 16*S*TG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2 + 8*S*TG**(-1)*U1**(-1)*MG2 + 16*S*UG**(-1)*
     +    T1**(-1)*U1**(-1)*MG2**2 + 8*S*UG**(-1)*T1**(-1)*MG2 + 32*S*
     +    U1**(-2)*MG2 - 16*TG**(-1)*T1**(-1)*MG2**2 - 8*TG**(-1)*MG2
     +     - 32*TG*T1**(-2)*MG2 + 32*TG*U1**(-2)*MG2 - 16*UG**(-1)*
     +    U1**(-1)*MG2**2 - 8*UG**(-1)*MG2 + 24*T1**(-1)*MG2 + 40*
     +    U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0C(2)*CO * ( 8 + 96*S**(-2)*TG**2*S1**(-1)*
     +    NS*MS2 - 96*S**(-2)*TG**2*S1**(-1)*MS2 - 8*S**(-2)*TG**2*NS*
     +    MG2**(-1)*MS2 - 16*S**(-2)*TG**2*NS + 8*S**(-2)*TG**2*
     +    MG2**(-1)*MS2 + 16*S**(-2)*TG**2 + 96*S**(-1)*TG*S1**(-1)*NS*
     +    MS2 - 96*S**(-1)*TG*S1**(-1)*MS2 - 8*S**(-1)*TG*NS*MG2**(-1)*
     +    MS2 - 16*S**(-1)*TG*NS + 8*S**(-1)*TG*MG2**(-1)*MS2 + 16*
     +    S**(-1)*TG + 96*S**(-1)*TG**2*S1**(-2)*NS*MS2 - 96*S**(-1)*
     +    TG**2*S1**(-2)*MS2 + 24*S**(-1)*TG**2*S1**(-1)*T1**(-1)*NS*
     +    MS2 - 24*S**(-1)*TG**2*S1**(-1)*T1**(-1)*MS2 + 24*S**(-1)*
     +    TG**2*S1**(-1)*U1**(-1)*NS*MS2 - 24*S**(-1)*TG**2*S1**(-1)*
     +    U1**(-1)*MS2 + 8*S**(-1)*TG**2*S1**(-1)*NS*MG2**(-1)*MS2 - 8*
     +    S**(-1)*TG**2*S1**(-1)*MG2**(-1)*MS2 - 6*S**(-1)*TG**2*
     +    T1**(-1)*NS*MG2**(-1)*MS2 - 8*S**(-1)*TG**2*T1**(-1)*NS + 6*
     +    S**(-1)*TG**2*T1**(-1)*MG2**(-1)*MS2 + 8*S**(-1)*TG**2*
     +    T1**(-1) - 6*S**(-1)*TG**2*U1**(-1)*NS*MG2**(-1)*MS2 - 8*
     +    S**(-1)*TG**2*U1**(-1)*NS )
     +
      M2QBSV = M2QBSV + SK1B0C(2)*CO * ( 6*S**(-1)*TG**2*U1**(-1)*
     +    MG2**(-1)*MS2 + 8*S**(-1)*TG**2*U1**(-1) - 16*S**(-1)*NS*MG2
     +     + 16*S**(-1)*NS*MS2 + 16*S**(-1)*MG2 - 16*S**(-1)*MS2 + 48*S
     +    *TG*S1**(-2)*T1**(-1)*NS*MS2 - 48*S*TG*S1**(-2)*T1**(-1)*MS2
     +     + 48*S*TG*S1**(-2)*U1**(-1)*NS*MS2 - 48*S*TG*S1**(-2)*
     +    U1**(-1)*MS2 + 4*S*TG*S1**(-1)*T1**(-1)*NS*MG2**(-1)*MS2 - 4*
     +    S*TG*S1**(-1)*T1**(-1)*MG2**(-1)*MS2 + 4*S*TG*S1**(-1)*
     +    U1**(-1)*NS*MG2**(-1)*MS2 - 4*S*TG*S1**(-1)*U1**(-1)*
     +    MG2**(-1)*MS2 - 8*S*TG*U1**(-2)*NS*MG2**(-1)*MS2 - 8*S*TG*
     +    U1**(-2)*NS + 8*S*TG*U1**(-2)*MG2**(-1)*MS2 + 8*S*TG*U1**(-2)
     +     - 96*S*S1**(-2)*T1**(-1)*NS*MG2*MS2 + 96*S*S1**(-2)*T1**(-1)
     +    *MG2*MS2 - 96*S*S1**(-2)*U1**(-1)*NS*MG2*MS2 + 96*S*S1**(-2)*
     +    U1**(-1)*MG2*MS2 + 24*S*S1**(-1)*T1**(-1)*NS*MS2 - 24*S*
     +    S1**(-1)*T1**(-1)*MS2 + 8*S*S1**(-1)*U1**(-1)*NS*MS2 - 8*S*
     +    S1**(-1)*U1**(-1)*MS2 + 2*S*T1**(-1)*NS*MG2**(-1)*MS2 - 2*S*
     +    T1**(-1)*MG2**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0C(2)*CO * (  - 6*S*U1**(-1)*NS*MG2**(-1)*
     +    MS2 - 8*S*U1**(-1)*NS + 6*S*U1**(-1)*MG2**(-1)*MS2 + 8*S*
     +    U1**(-1) + 24*S**2*S1**(-2)*T1**(-1)*NS*MS2 - 24*S**2*
     +    S1**(-2)*T1**(-1)*MS2 + 24*S**2*S1**(-2)*U1**(-1)*NS*MS2 - 24
     +    *S**2*S1**(-2)*U1**(-1)*MS2 + 2*S**2*S1**(-1)*T1**(-1)*NS*
     +    MG2**(-1)*MS2 - 2*S**2*S1**(-1)*T1**(-1)*MG2**(-1)*MS2 + 2*
     +    S**2*S1**(-1)*U1**(-1)*NS*MG2**(-1)*MS2 - 2*S**2*S1**(-1)*
     +    U1**(-1)*MG2**(-1)*MS2 - 4*S**2*U1**(-2)*NS*MG2**(-1)*MS2 - 4
     +    *S**2*U1**(-2)*NS + 4*S**2*U1**(-2)*MG2**(-1)*MS2 + 4*S**2*
     +    U1**(-2) - 96*TG*S1**(-2)*T1**(-1)*NS*MG2*MS2 + 96*TG*
     +    S1**(-2)*T1**(-1)*MG2*MS2 - 96*TG*S1**(-2)*U1**(-1)*NS*MG2*
     +    MS2 + 96*TG*S1**(-2)*U1**(-1)*MG2*MS2 + 96*TG*S1**(-2)*NS*MS2
     +     - 96*TG*S1**(-2)*MS2 + 48*TG*S1**(-1)*T1**(-1)*NS*MS2 - 48*
     +    TG*S1**(-1)*T1**(-1)*MS2 + 32*TG*S1**(-1)*U1**(-1)*NS*MS2 - 
     +    32*TG*S1**(-1)*U1**(-1)*MS2 + 8*TG*S1**(-1)*NS*MG2**(-1)*MS2
     +     - 8*TG*S1**(-1)*MG2**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0C(2)*CO * ( 4*TG*T1**(-1)*NS*MG2**(-1)*MS2
     +     - 4*TG*T1**(-1)*MG2**(-1)*MS2 - 12*TG*U1**(-1)*NS*MG2**(-1)*
     +    MS2 - 16*TG*U1**(-1)*NS + 12*TG*U1**(-1)*MG2**(-1)*MS2 + 16*
     +    TG*U1**(-1) + 24*TG**2*S1**(-2)*T1**(-1)*NS*MS2 - 24*TG**2*
     +    S1**(-2)*T1**(-1)*MS2 + 24*TG**2*S1**(-2)*U1**(-1)*NS*MS2 - 
     +    24*TG**2*S1**(-2)*U1**(-1)*MS2 + 2*TG**2*S1**(-1)*T1**(-1)*NS
     +    *MG2**(-1)*MS2 - 2*TG**2*S1**(-1)*T1**(-1)*MG2**(-1)*MS2 + 2*
     +    TG**2*S1**(-1)*U1**(-1)*NS*MG2**(-1)*MS2 - 2*TG**2*S1**(-1)*
     +    U1**(-1)*MG2**(-1)*MS2 - 4*TG**2*T1**(-2)*NS*MG2**(-1)*MS2 - 
     +    4*TG**2*T1**(-2)*NS + 4*TG**2*T1**(-2)*MG2**(-1)*MS2 + 4*
     +    TG**2*T1**(-2) - 4*TG**2*U1**(-2)*NS*MG2**(-1)*MS2 - 4*TG**2*
     +    U1**(-2)*NS + 4*TG**2*U1**(-2)*MG2**(-1)*MS2 + 4*TG**2*
     +    U1**(-2) + 96*S1**(-2)*T1**(-1)*NS*MG2**2*MS2 - 96*S1**(-2)*
     +    T1**(-1)*MG2**2*MS2 + 96*S1**(-2)*U1**(-1)*NS*MG2**2*MS2 - 96
     +    *S1**(-2)*U1**(-1)*MG2**2*MS2 + 96*S1**(-2)*NS*MG2*MS2 - 96*
     +    S1**(-2)*MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0C(2)*CO * (  - 24*S1**(-1)*T1**(-1)*NS*MG2
     +    *MS2 + 24*S1**(-1)*T1**(-1)*MG2*MS2 + 8*S1**(-1)*U1**(-1)*NS*
     +    MG2*MS2 - 8*S1**(-1)*U1**(-1)*MG2*MS2 + 16*S1**(-1)*NS*MS2 - 
     +    16*S1**(-1)*MS2 - 8*T1**(-1)*NS*MG2 + 8*T1**(-1)*MG2 - 8*
     +    U1**(-1)*NS*MG2 - 8*U1**(-1)*NS*MS2 + 8*U1**(-1)*MG2 + 8*
     +    U1**(-1)*MS2 - 8*NS*MG2**(-1)*MS2 - 8*NS + 8*MG2**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0C(2)*CK * ( 8*S*TG*U1**(-2)*NS*MG2**(-1)*
     +    MS2 + 8*S*TG*U1**(-2)*NS - 8*S*TG*U1**(-2)*MG2**(-1)*MS2 - 8*
     +    S*TG*U1**(-2) - 8*S*T1**(-1)*U1**(-1)*NS*MG2 - 8*S*T1**(-1)*
     +    U1**(-1)*NS*MS2 + 8*S*T1**(-1)*U1**(-1)*MG2 + 8*S*T1**(-1)*
     +    U1**(-1)*MS2 + 4*S**2*U1**(-2)*NS*MG2**(-1)*MS2 + 4*S**2*
     +    U1**(-2)*NS - 4*S**2*U1**(-2)*MG2**(-1)*MS2 - 4*S**2*U1**(-2)
     +     + 4*TG**2*T1**(-2)*NS*MG2**(-1)*MS2 + 4*TG**2*T1**(-2)*NS - 
     +    4*TG**2*T1**(-2)*MG2**(-1)*MS2 - 4*TG**2*T1**(-2) + 4*TG**2*
     +    U1**(-2)*NS*MG2**(-1)*MS2 + 4*TG**2*U1**(-2)*NS - 4*TG**2*
     +    U1**(-2)*MG2**(-1)*MS2 - 4*TG**2*U1**(-2) )
     +
      M2QBSV = M2QBSV + SK1B0C(2)*CQED * (  - 16*S*TG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2 - 8*S*TG**(-1)*U1**(-1)*MG2 - 16*S*UG**(-1)*
     +    T1**(-1)*U1**(-1)*MG2**2 - 8*S*UG**(-1)*T1**(-1)*MG2 - 16*S*
     +    U1**(-2)*MG2 + 16*TG*T1**(-2)*MG2 - 16*TG*U1**(-2)*MG2 - 16*
     +    T1**(-1)*MG2 - 16*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0C(3)*CO * (  - 8 + 96*S**(-2)*TG**2*
     +    S1**(-1)*MS2 - 96*S**(-2)*TG**2*S1**(-1)*MT2 - 8*S**(-2)*
     +    TG**2*MG2**(-1)*MS2 + 8*S**(-2)*TG**2*MG2**(-1)*MT2 - 16*
     +    S**(-2)*TG**2 + 96*S**(-1)*TG*S1**(-1)*MS2 - 96*S**(-1)*TG*
     +    S1**(-1)*MT2 - 8*S**(-1)*TG*MG2**(-1)*MS2 + 8*S**(-1)*TG*
     +    MG2**(-1)*MT2 - 16*S**(-1)*TG + 96*S**(-1)*TG**2*S1**(-2)*MS2
     +     - 96*S**(-1)*TG**2*S1**(-2)*MT2 + 24*S**(-1)*TG**2*S1**(-1)*
     +    T1**(-1)*MS2 - 24*S**(-1)*TG**2*S1**(-1)*T1**(-1)*MT2 + 24*
     +    S**(-1)*TG**2*S1**(-1)*U1**(-1)*MS2 - 24*S**(-1)*TG**2*
     +    S1**(-1)*U1**(-1)*MT2 + 8*S**(-1)*TG**2*S1**(-1)*MG2**(-1)*
     +    MS2 - 8*S**(-1)*TG**2*S1**(-1)*MG2**(-1)*MT2 - 6*S**(-1)*
     +    TG**2*T1**(-1)*MG2**(-1)*MS2 + 6*S**(-1)*TG**2*T1**(-1)*
     +    MG2**(-1)*MT2 - 8*S**(-1)*TG**2*T1**(-1) - 6*S**(-1)*TG**2*
     +    U1**(-1)*MG2**(-1)*MS2 + 6*S**(-1)*TG**2*U1**(-1)*MG2**(-1)*
     +    MT2 - 8*S**(-1)*TG**2*U1**(-1) - 16*S**(-1)*MG2 + 16*S**(-1)*
     +    MS2 )
     +
      M2QBSV = M2QBSV + SK1B0C(3)*CO * (  - 16*S**(-1)*MT2 + 48*S*TG*
     +    S1**(-2)*T1**(-1)*MS2 - 48*S*TG*S1**(-2)*T1**(-1)*MT2 + 48*S*
     +    TG*S1**(-2)*U1**(-1)*MS2 - 48*S*TG*S1**(-2)*U1**(-1)*MT2 + 4*
     +    S*TG*S1**(-1)*T1**(-1)*MG2**(-1)*MS2 - 4*S*TG*S1**(-1)*
     +    T1**(-1)*MG2**(-1)*MT2 + 4*S*TG*S1**(-1)*U1**(-1)*MG2**(-1)*
     +    MS2 - 4*S*TG*S1**(-1)*U1**(-1)*MG2**(-1)*MT2 - 8*S*TG*
     +    U1**(-2)*MG2**(-1)*MS2 + 8*S*TG*U1**(-2)*MG2**(-1)*MT2 - 8*S*
     +    TG*U1**(-2) - 96*S*S1**(-2)*T1**(-1)*MG2*MS2 + 96*S*S1**(-2)*
     +    T1**(-1)*MG2*MT2 - 96*S*S1**(-2)*U1**(-1)*MG2*MS2 + 96*S*
     +    S1**(-2)*U1**(-1)*MG2*MT2 + 24*S*S1**(-1)*T1**(-1)*MS2 - 24*S
     +    *S1**(-1)*T1**(-1)*MT2 + 8*S*S1**(-1)*U1**(-1)*MS2 - 8*S*
     +    S1**(-1)*U1**(-1)*MT2 + 2*S*T1**(-1)*MG2**(-1)*MS2 - 2*S*
     +    T1**(-1)*MG2**(-1)*MT2 - 6*S*U1**(-1)*MG2**(-1)*MS2 + 6*S*
     +    U1**(-1)*MG2**(-1)*MT2 - 8*S*U1**(-1) + 24*S**2*S1**(-2)*
     +    T1**(-1)*MS2 - 24*S**2*S1**(-2)*T1**(-1)*MT2 + 24*S**2*
     +    S1**(-2)*U1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0C(3)*CO * (  - 24*S**2*S1**(-2)*U1**(-1)*
     +    MT2 + 2*S**2*S1**(-1)*T1**(-1)*MG2**(-1)*MS2 - 2*S**2*
     +    S1**(-1)*T1**(-1)*MG2**(-1)*MT2 + 2*S**2*S1**(-1)*U1**(-1)*
     +    MG2**(-1)*MS2 - 2*S**2*S1**(-1)*U1**(-1)*MG2**(-1)*MT2 - 4*
     +    S**2*U1**(-2)*MG2**(-1)*MS2 + 4*S**2*U1**(-2)*MG2**(-1)*MT2
     +     - 4*S**2*U1**(-2) - 96*TG*S1**(-2)*T1**(-1)*MG2*MS2 + 96*TG*
     +    S1**(-2)*T1**(-1)*MG2*MT2 - 96*TG*S1**(-2)*U1**(-1)*MG2*MS2
     +     + 96*TG*S1**(-2)*U1**(-1)*MG2*MT2 + 96*TG*S1**(-2)*MS2 - 96*
     +    TG*S1**(-2)*MT2 + 48*TG*S1**(-1)*T1**(-1)*MS2 - 48*TG*
     +    S1**(-1)*T1**(-1)*MT2 + 32*TG*S1**(-1)*U1**(-1)*MS2 - 32*TG*
     +    S1**(-1)*U1**(-1)*MT2 + 8*TG*S1**(-1)*MG2**(-1)*MS2 - 8*TG*
     +    S1**(-1)*MG2**(-1)*MT2 + 4*TG*T1**(-1)*MG2**(-1)*MS2 - 4*TG*
     +    T1**(-1)*MG2**(-1)*MT2 - 12*TG*U1**(-1)*MG2**(-1)*MS2 + 12*TG
     +    *U1**(-1)*MG2**(-1)*MT2 - 16*TG*U1**(-1) + 24*TG**2*S1**(-2)*
     +    T1**(-1)*MS2 - 24*TG**2*S1**(-2)*T1**(-1)*MT2 + 24*TG**2*
     +    S1**(-2)*U1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0C(3)*CO * (  - 24*TG**2*S1**(-2)*U1**(-1)*
     +    MT2 + 2*TG**2*S1**(-1)*T1**(-1)*MG2**(-1)*MS2 - 2*TG**2*
     +    S1**(-1)*T1**(-1)*MG2**(-1)*MT2 + 2*TG**2*S1**(-1)*U1**(-1)*
     +    MG2**(-1)*MS2 - 2*TG**2*S1**(-1)*U1**(-1)*MG2**(-1)*MT2 - 4*
     +    TG**2*T1**(-2)*MG2**(-1)*MS2 + 4*TG**2*T1**(-2)*MG2**(-1)*MT2
     +     - 4*TG**2*T1**(-2) - 4*TG**2*U1**(-2)*MG2**(-1)*MS2 + 4*
     +    TG**2*U1**(-2)*MG2**(-1)*MT2 - 4*TG**2*U1**(-2) + 96*S1**(-2)
     +    *T1**(-1)*MG2**2*MS2 - 96*S1**(-2)*T1**(-1)*MG2**2*MT2 + 96*
     +    S1**(-2)*U1**(-1)*MG2**2*MS2 - 96*S1**(-2)*U1**(-1)*MG2**2*
     +    MT2 + 96*S1**(-2)*MG2*MS2 - 96*S1**(-2)*MG2*MT2 - 24*S1**(-1)
     +    *T1**(-1)*MG2*MS2 + 24*S1**(-1)*T1**(-1)*MG2*MT2 + 8*S1**(-1)
     +    *U1**(-1)*MG2*MS2 - 8*S1**(-1)*U1**(-1)*MG2*MT2 + 16*S1**(-1)
     +    *MS2 - 16*S1**(-1)*MT2 - 8*T1**(-1)*MG2 - 8*U1**(-1)*MG2 - 8*
     +    U1**(-1)*MS2 + 8*U1**(-1)*MT2 - 8*MG2**(-1)*MS2 + 8*MG2**(-1)
     +    *MT2 )
     +
      M2QBSV = M2QBSV + SK1B0C(3)*CK * ( 8*S*TG*U1**(-2)*MG2**(-1)*MS2
     +     - 8*S*TG*U1**(-2)*MG2**(-1)*MT2 + 8*S*TG*U1**(-2) - 8*S*
     +    T1**(-1)*U1**(-1)*MG2 - 8*S*T1**(-1)*U1**(-1)*MS2 + 8*S*
     +    T1**(-1)*U1**(-1)*MT2 + 4*S**2*U1**(-2)*MG2**(-1)*MS2 - 4*
     +    S**2*U1**(-2)*MG2**(-1)*MT2 + 4*S**2*U1**(-2) + 4*TG**2*
     +    T1**(-2)*MG2**(-1)*MS2 - 4*TG**2*T1**(-2)*MG2**(-1)*MT2 + 4*
     +    TG**2*T1**(-2) + 4*TG**2*U1**(-2)*MG2**(-1)*MS2 - 4*TG**2*
     +    U1**(-2)*MG2**(-1)*MT2 + 4*TG**2*U1**(-2) )
     +
      M2QBSV = M2QBSV + SK1B0D(1,1)*N*CO * (  - 4 - 8*S**(-1)*TG*
     +    T1**(-1)*MG2 - 4*S**(-1)*TG - 4*S**(-1)*TG**3*T1**(-2) - 8*
     +    TG**(-1)*T1**(-1)*MG2**2 - 8*TG**(-1)*MG2 - 12*TG*T1**(-2)*
     +    MG2 - 4*TG**3*T1**(-3) + 4*T1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,1)*N*CK * ( 4 + 8*S**(-1)*TG*T1**(-1)*
     +    MG2 + 4*S**(-1)*TG + 4*S**(-1)*TG**3*T1**(-2) - 16*S*TG**(-1)
     +    *T1**(-1)*U1**(-1)*MG2**2 - 16*S*TG**(-1)*U1**(-1)*MG2 - 8*S*
     +    TG*T1**(-2)*U1**(-1)*MG2 - 8*S*U1**(-1) + 8*TG**(-1)*T1**(-1)
     +    *MG2**2 + 8*TG**(-1)*MG2 + 28*TG*T1**(-2)*MG2 - 8*TG*U1**(-1)
     +     + 12*TG**3*T1**(-3) - 12*T1**(-1)*MG2 - 8*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,1)*CQED * ( 8*S*TG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2 + 8*S*TG**(-1)*U1**(-1)*MG2 + 4*S*TG*T1**(-2)
     +    *U1**(-1)*MG2 + 4*S*U1**(-1) - 8*TG*T1**(-2)*MG2 + 4*TG*
     +    U1**(-1) - 4*TG**3*T1**(-3) + 4*T1**(-1)*MG2 + 4*U1**(-1)*MG2
     +     )
     +
      M2QBSV = M2QBSV + SK1B0D(1,2)*N*CO * ( 8*S**(-1)*TG*U1**(-1)*MG2
     +     + 4*S**(-1)*TG + 4*S**(-1)*TG**3*U1**(-2) + 12*S*TG*U1**(-2)
     +     + 12*S*TG**2*U1**(-3) + 12*S*U1**(-2)*MG2 + 12*S**2*TG*
     +    U1**(-3) + 4*S**2*U1**(-2) + 4*S**3*U1**(-3) + 12*TG*U1**(-2)
     +    *MG2 + 12*TG**2*U1**(-2) + 4*TG**3*U1**(-3) - 8*UG**(-1)*
     +    U1**(-1)*MG2**2 - 8*UG**(-1)*MG2 + 12*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,2)*N*CK * (  - 8*S**(-1)*TG*U1**(-1)*
     +    MG2 - 4*S**(-1)*TG - 4*S**(-1)*TG**3*U1**(-2) + 8*S*TG*
     +    T1**(-1)*U1**(-2)*MG2 - 12*S*TG*U1**(-2) - 36*S*TG**2*
     +    U1**(-3) - 16*S*UG**(-1)*T1**(-1)*U1**(-1)*MG2**2 - 16*S*
     +    UG**(-1)*T1**(-1)*MG2 - 28*S*U1**(-2)*MG2 - 36*S**2*TG*
     +    U1**(-3) + 8*S**2*T1**(-1)*U1**(-2)*MG2 - 4*S**2*U1**(-2) - 
     +    12*S**3*U1**(-3) + 8*TG*T1**(-1) - 28*TG*U1**(-2)*MG2 - 12*
     +    TG**2*U1**(-2) - 12*TG**3*U1**(-3) + 8*UG**(-1)*U1**(-1)*
     +    MG2**2 + 8*UG**(-1)*MG2 - 8*T1**(-1)*MG2 - 20*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(1,2)*CQED * (  - 4*S*TG*T1**(-1)*
     +    U1**(-2)*MG2 + 12*S*TG**2*U1**(-3) + 8*S*UG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2 + 8*S*UG**(-1)*T1**(-1)*MG2 + 8*S*U1**(-2)*
     +    MG2 + 12*S**2*TG*U1**(-3) - 4*S**2*T1**(-1)*U1**(-2)*MG2 + 4*
     +    S**3*U1**(-3) - 4*TG*T1**(-1) + 8*TG*U1**(-2)*MG2 + 4*TG**3*
     +    U1**(-3) + 4*T1**(-1)*MG2 + 4*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(2,1)*N*CO * (  - 8*S**(-1)*TG*T1**(-1)*
     +    MG2 + 4*S**(-1)*TG + 4*S**(-1)*TG**2*T1**(-2)*MG2 + 4*S**(-1)
     +    *TG**2*T1**(-2)*MS2 - 4*S**(-1)*TG**2*T1**(-1) + 4*S**(-1)*
     +    TG**3*T1**(-2) - 8*TG**(-1)*T1**(-1)*MG2**2 - 4*TG*T1**(-2)*
     +    MG2 + 4*TG*T1**(-1) + 4*TG**2*T1**(-3)*MG2 + 4*TG**2*T1**(-3)
     +    *MS2 - 4*TG**2*T1**(-2) + 4*TG**3*T1**(-3) + 4*T1**(-2)*MG2*
     +    MS2 + 4*T1**(-2)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1B0D(2,1)*N*CK * ( 8*S**(-1)*TG*T1**(-1)*MG2
     +     - 4*S**(-1)*TG - 4*S**(-1)*TG**2*T1**(-2)*MG2 - 4*S**(-1)*
     +    TG**2*T1**(-2)*MS2 + 4*S**(-1)*TG**2*T1**(-1) - 4*S**(-1)*
     +    TG**3*T1**(-2) - 16*S*TG**(-1)*T1**(-1)*U1**(-1)*MG2**2 + 8*S
     +    *TG*T1**(-2)*U1**(-1)*MG2 + 8*S*T1**(-2)*U1**(-1)*MG2*MS2 + 8
     +    *S*T1**(-2)*U1**(-1)*MG2**2 - 8*S*T1**(-1)*U1**(-1)*MG2 + 8*
     +    TG**(-1)*T1**(-1)*MG2**2 + 20*TG*T1**(-2)*MG2 - 12*TG*
     +    T1**(-1) - 12*TG**2*T1**(-3)*MG2 - 12*TG**2*T1**(-3)*MS2 + 12
     +    *TG**2*T1**(-2) - 12*TG**3*T1**(-3) - 4*T1**(-2)*MG2*MS2 - 4*
     +    T1**(-2)*MG2**2 - 8*T1**(-1)*MG2 - 8*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(2,1)*CQED * ( 8*S*TG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2 - 4*S*TG*T1**(-2)*U1**(-1)*MG2 - 4*S*T1**(-2)
     +    *U1**(-1)*MG2*MS2 - 4*S*T1**(-2)*U1**(-1)*MG2**2 + 4*S*
     +    T1**(-1)*U1**(-1)*MG2 - 8*TG*T1**(-2)*MG2 + 4*TG*T1**(-1) + 4
     +    *TG**2*T1**(-3)*MG2 + 4*TG**2*T1**(-3)*MS2 - 4*TG**2*T1**(-2)
     +     + 4*TG**3*T1**(-3) + 4*T1**(-1)*MG2 + 4*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(2,2)*N*CO * (  - 4 + 8*S**(-1)*TG*
     +    U1**(-1)*MG2 - 4*S**(-1)*TG + 4*S**(-1)*TG**2*U1**(-2)*MG2 + 
     +    4*S**(-1)*TG**2*U1**(-2)*MS2 - 4*S**(-1)*TG**2*U1**(-1) - 4*
     +    S**(-1)*TG**3*U1**(-2) + 8*S*TG*U1**(-3)*MG2 + 8*S*TG*
     +    U1**(-3)*MS2 - 20*S*TG*U1**(-2) - 12*S*TG**2*U1**(-3) + 8*S*
     +    U1**(-2)*MG2 + 4*S*U1**(-2)*MS2 - 8*S*U1**(-1) - 12*S**2*TG*
     +    U1**(-3) + 4*S**2*U1**(-3)*MG2 + 4*S**2*U1**(-3)*MS2 - 8*S**2
     +    *U1**(-2) - 4*S**3*U1**(-3) + 12*TG*U1**(-2)*MG2 + 8*TG*
     +    U1**(-2)*MS2 - 12*TG*U1**(-1) + 4*TG**2*U1**(-3)*MG2 + 4*
     +    TG**2*U1**(-3)*MS2 - 16*TG**2*U1**(-2) - 4*TG**3*U1**(-3) - 8
     +    *UG**(-1)*U1**(-1)*MG2**2 + 4*U1**(-2)*MG2*MS2 + 4*U1**(-2)*
     +    MG2**2 + 8*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(2,2)*N*CK * ( 4 - 8*S**(-1)*TG*U1**(-1)*
     +    MG2 + 4*S**(-1)*TG - 4*S**(-1)*TG**2*U1**(-2)*MG2 - 4*S**(-1)
     +    *TG**2*U1**(-2)*MS2 + 4*S**(-1)*TG**2*U1**(-1) + 4*S**(-1)*
     +    TG**3*U1**(-2) - 8*S*TG*T1**(-1)*U1**(-2)*MG2 - 24*S*TG*
     +    U1**(-3)*MG2 - 24*S*TG*U1**(-3)*MS2 + 36*S*TG*U1**(-2) + 36*S
     +    *TG**2*U1**(-3) - 16*S*UG**(-1)*T1**(-1)*U1**(-1)*MG2**2 + 8*
     +    S*T1**(-1)*U1**(-2)*MG2*MS2 + 8*S*T1**(-1)*U1**(-2)*MG2**2 - 
     +    8*S*T1**(-1)*U1**(-1)*MG2 - 24*S*U1**(-2)*MG2 - 4*S*U1**(-2)*
     +    MS2 + 16*S*U1**(-1) + 36*S**2*TG*U1**(-3) - 8*S**2*T1**(-1)*
     +    U1**(-2)*MG2 - 12*S**2*U1**(-3)*MG2 - 12*S**2*U1**(-3)*MS2 + 
     +    16*S**2*U1**(-2) + 12*S**3*U1**(-3) - 28*TG*U1**(-2)*MG2 - 8*
     +    TG*U1**(-2)*MS2 + 20*TG*U1**(-1) - 12*TG**2*U1**(-3)*MG2 - 12
     +    *TG**2*U1**(-3)*MS2 + 24*TG**2*U1**(-2) + 12*TG**3*U1**(-3)
     +     + 8*UG**(-1)*U1**(-1)*MG2**2 - 8*T1**(-1)*MG2 - 4*U1**(-2)*
     +    MG2*MS2 - 4*U1**(-2)*MG2**2 - 16*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0D(2,2)*CQED * ( 4*S*TG*T1**(-1)*U1**(-2)*
     +    MG2 + 8*S*TG*U1**(-3)*MG2 + 8*S*TG*U1**(-3)*MS2 - 8*S*TG*
     +    U1**(-2) - 12*S*TG**2*U1**(-3) + 8*S*UG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2 - 4*S*T1**(-1)*U1**(-2)*MG2*MS2 - 4*S*
     +    T1**(-1)*U1**(-2)*MG2**2 + 4*S*T1**(-1)*U1**(-1)*MG2 + 8*S*
     +    U1**(-2)*MG2 - 4*S*U1**(-1) - 12*S**2*TG*U1**(-3) + 4*S**2*
     +    T1**(-1)*U1**(-2)*MG2 + 4*S**2*U1**(-3)*MG2 + 4*S**2*U1**(-3)
     +    *MS2 - 4*S**2*U1**(-2) - 4*S**3*U1**(-3) + 8*TG*U1**(-2)*MG2
     +     - 4*TG*U1**(-1) + 4*TG**2*U1**(-3)*MG2 + 4*TG**2*U1**(-3)*
     +    MS2 - 4*TG**2*U1**(-2) - 4*TG**3*U1**(-3) + 4*T1**(-1)*MG2 + 
     +    4*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1B0E(1)*N*CO * (  - 8*S**(-1)*TG**2*T1**(-2)*
     +    MS2 - 8*S**(-1)*TG**2*U1**(-2)*MS2 - 16*S*TG*U1**(-3)*MS2 - 8
     +    *S*U1**(-2)*MS2 - 8*S**2*U1**(-3)*MS2 - 16*TG*U1**(-2)*MS2 - 
     +    8*TG**2*T1**(-3)*MS2 - 8*TG**2*U1**(-3)*MS2 - 8*T1**(-2)*MG2*
     +    MS2 - 8*U1**(-2)*MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0E(1)*N*CK * ( 8*S**(-1)*TG**2*T1**(-2)*MS2
     +     + 8*S**(-1)*TG**2*U1**(-2)*MS2 + 48*S*TG*U1**(-3)*MS2 - 16*S
     +    *T1**(-2)*U1**(-1)*MG2*MS2 - 16*S*T1**(-1)*U1**(-2)*MG2*MS2
     +     + 8*S*U1**(-2)*MS2 + 24*S**2*U1**(-3)*MS2 + 16*TG*U1**(-2)*
     +    MS2 + 24*TG**2*T1**(-3)*MS2 + 24*TG**2*U1**(-3)*MS2 + 8*
     +    T1**(-2)*MG2*MS2 + 8*U1**(-2)*MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0E(1)*CQED * (  - 16*S*TG*U1**(-3)*MS2 + 8*
     +    S*T1**(-2)*U1**(-1)*MG2*MS2 + 8*S*T1**(-1)*U1**(-2)*MG2*MS2
     +     - 8*S**2*U1**(-3)*MS2 - 8*TG**2*T1**(-3)*MS2 - 8*TG**2*
     +    U1**(-3)*MS2 )
     +
      M2QBSV = M2QBSV + SK1B0E(2)*N*CO * (  - 4*S**(-1)*TG**2*T1**(-2)*
     +    MG2 + 4*S**(-1)*TG**2*T1**(-2)*MS2 - 4*S**(-1)*TG**2*U1**(-2)
     +    *MG2 + 4*S**(-1)*TG**2*U1**(-2)*MS2 - 8*S*TG*U1**(-3)*MG2 + 8
     +    *S*TG*U1**(-3)*MS2 - 4*S*U1**(-2)*MG2 + 4*S*U1**(-2)*MS2 - 4*
     +    S**2*U1**(-3)*MG2 + 4*S**2*U1**(-3)*MS2 - 8*TG*U1**(-2)*MG2
     +     + 8*TG*U1**(-2)*MS2 - 4*TG**2*T1**(-3)*MG2 + 4*TG**2*
     +    T1**(-3)*MS2 - 4*TG**2*U1**(-3)*MG2 + 4*TG**2*U1**(-3)*MS2 + 
     +    4*T1**(-2)*MG2*MS2 - 4*T1**(-2)*MG2**2 + 4*U1**(-2)*MG2*MS2
     +     - 4*U1**(-2)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1B0E(2)*N*CK * ( 4*S**(-1)*TG**2*T1**(-2)*MG2
     +     - 4*S**(-1)*TG**2*T1**(-2)*MS2 + 4*S**(-1)*TG**2*U1**(-2)*
     +    MG2 - 4*S**(-1)*TG**2*U1**(-2)*MS2 + 24*S*TG*U1**(-3)*MG2 - 
     +    24*S*TG*U1**(-3)*MS2 + 8*S*T1**(-2)*U1**(-1)*MG2*MS2 - 8*S*
     +    T1**(-2)*U1**(-1)*MG2**2 + 8*S*T1**(-1)*U1**(-2)*MG2*MS2 - 8*
     +    S*T1**(-1)*U1**(-2)*MG2**2 + 4*S*U1**(-2)*MG2 - 4*S*U1**(-2)*
     +    MS2 + 12*S**2*U1**(-3)*MG2 - 12*S**2*U1**(-3)*MS2 + 8*TG*
     +    U1**(-2)*MG2 - 8*TG*U1**(-2)*MS2 + 12*TG**2*T1**(-3)*MG2 - 12
     +    *TG**2*T1**(-3)*MS2 + 12*TG**2*U1**(-3)*MG2 - 12*TG**2*
     +    U1**(-3)*MS2 - 4*T1**(-2)*MG2*MS2 + 4*T1**(-2)*MG2**2 - 4*
     +    U1**(-2)*MG2*MS2 + 4*U1**(-2)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1B0E(2)*CQED * (  - 8*S*TG*U1**(-3)*MG2 + 8*S
     +    *TG*U1**(-3)*MS2 - 4*S*T1**(-2)*U1**(-1)*MG2*MS2 + 4*S*
     +    T1**(-2)*U1**(-1)*MG2**2 - 4*S*T1**(-1)*U1**(-2)*MG2*MS2 + 4*
     +    S*T1**(-1)*U1**(-2)*MG2**2 - 4*S**2*U1**(-3)*MG2 + 4*S**2*
     +    U1**(-3)*MS2 - 4*TG**2*T1**(-3)*MG2 + 4*TG**2*T1**(-3)*MS2 - 
     +    4*TG**2*U1**(-3)*MG2 + 4*TG**2*U1**(-3)*MS2 )
     +
      M2QBSV = M2QBSV + SK1BP(1)*N*CO * ( 64*S**(-2)*TG**2*MG2 + 64*
     +    S**(-1)*TG*MG2 + 32*S**(-1)*TG**2*T1**(-1)*MG2 + 32*S**(-1)*
     +    TG**2*U1**(-1)*MG2 + 64*S**(-1)*MG2**2 + 32*S*TG*U1**(-2)*MG2
     +     + 32*S*U1**(-1)*MG2 + 16*S**2*U1**(-2)*MG2 + 64*TG*U1**(-1)*
     +    MG2 + 16*TG**2*T1**(-2)*MG2 + 16*TG**2*U1**(-2)*MG2 + 32*
     +    T1**(-1)*MG2**2 + 32*U1**(-1)*MG2**2 + 32*MG2 )
     +
      M2QBSV = M2QBSV + SK1BP(1)*N*CK * (  - 32*S*TG*U1**(-2)*MG2 + 32*
     +    S*T1**(-1)*U1**(-1)*MG2**2 - 16*S**2*U1**(-2)*MG2 - 16*TG**2*
     +    T1**(-2)*MG2 - 16*TG**2*U1**(-2)*MG2 )
     +
      M2QBSV = M2QBSV + SK1BP(2)*CO * (  - 32*S**(-2)*TG**2*NS*MG2 + 32
     +    *S**(-2)*TG**2*NS*MS2 + 32*S**(-2)*TG**2*MG2 - 32*S**(-2)*
     +    TG**2*MS2 - 32*S**(-1)*TG*NS*MG2 + 32*S**(-1)*TG*NS*MS2 + 32*
     +    S**(-1)*TG*MG2 - 32*S**(-1)*TG*MS2 - 16*S**(-1)*TG**2*
     +    T1**(-1)*NS*MG2 + 16*S**(-1)*TG**2*T1**(-1)*NS*MS2 + 16*
     +    S**(-1)*TG**2*T1**(-1)*MG2 - 16*S**(-1)*TG**2*T1**(-1)*MS2 - 
     +    16*S**(-1)*TG**2*U1**(-1)*NS*MG2 + 16*S**(-1)*TG**2*U1**(-1)*
     +    NS*MS2 + 16*S**(-1)*TG**2*U1**(-1)*MG2 - 16*S**(-1)*TG**2*
     +    U1**(-1)*MS2 + 32*S**(-1)*NS*MG2*MS2 - 32*S**(-1)*NS*MG2**2
     +     - 32*S**(-1)*MG2*MS2 + 32*S**(-1)*MG2**2 - 16*S*TG*U1**(-2)*
     +    NS*MG2 + 16*S*TG*U1**(-2)*NS*MS2 + 16*S*TG*U1**(-2)*MG2 - 16*
     +    S*TG*U1**(-2)*MS2 - 16*S*U1**(-1)*NS*MG2 + 16*S*U1**(-1)*NS*
     +    MS2 + 16*S*U1**(-1)*MG2 - 16*S*U1**(-1)*MS2 - 8*S**2*U1**(-2)
     +    *NS*MG2 + 8*S**2*U1**(-2)*NS*MS2 + 8*S**2*U1**(-2)*MG2 - 8*
     +    S**2*U1**(-2)*MS2 - 32*TG*U1**(-1)*NS*MG2 + 32*TG*U1**(-1)*NS
     +    *MS2 )
     +
      M2QBSV = M2QBSV + SK1BP(2)*CO * ( 32*TG*U1**(-1)*MG2 - 32*TG*
     +    U1**(-1)*MS2 - 8*TG**2*T1**(-2)*NS*MG2 + 8*TG**2*T1**(-2)*NS*
     +    MS2 + 8*TG**2*T1**(-2)*MG2 - 8*TG**2*T1**(-2)*MS2 - 8*TG**2*
     +    U1**(-2)*NS*MG2 + 8*TG**2*U1**(-2)*NS*MS2 + 8*TG**2*U1**(-2)*
     +    MG2 - 8*TG**2*U1**(-2)*MS2 + 16*T1**(-1)*NS*MG2*MS2 - 16*
     +    T1**(-1)*NS*MG2**2 - 16*T1**(-1)*MG2*MS2 + 16*T1**(-1)*MG2**2
     +     + 16*U1**(-1)*NS*MG2*MS2 - 16*U1**(-1)*NS*MG2**2 - 16*
     +    U1**(-1)*MG2*MS2 + 16*U1**(-1)*MG2**2 - 16*NS*MG2 + 16*NS*MS2
     +     + 16*MG2 - 16*MS2 )
     +
      M2QBSV = M2QBSV + SK1BP(2)*CK * ( 16*S*TG*U1**(-2)*NS*MG2 - 16*S*
     +    TG*U1**(-2)*NS*MS2 - 16*S*TG*U1**(-2)*MG2 + 16*S*TG*U1**(-2)*
     +    MS2 + 16*S*T1**(-1)*U1**(-1)*NS*MG2*MS2 - 16*S*T1**(-1)*
     +    U1**(-1)*NS*MG2**2 - 16*S*T1**(-1)*U1**(-1)*MG2*MS2 + 16*S*
     +    T1**(-1)*U1**(-1)*MG2**2 + 8*S**2*U1**(-2)*NS*MG2 - 8*S**2*
     +    U1**(-2)*NS*MS2 - 8*S**2*U1**(-2)*MG2 + 8*S**2*U1**(-2)*MS2
     +     + 8*TG**2*T1**(-2)*NS*MG2 - 8*TG**2*T1**(-2)*NS*MS2 - 8*
     +    TG**2*T1**(-2)*MG2 + 8*TG**2*T1**(-2)*MS2 + 8*TG**2*U1**(-2)*
     +    NS*MG2 - 8*TG**2*U1**(-2)*NS*MS2 - 8*TG**2*U1**(-2)*MG2 + 8*
     +    TG**2*U1**(-2)*MS2 )
     +
      M2QBSV = M2QBSV + SK1BP(3)*N*CO * (  - 8*S**(-2)*TG**2*MG2 + 8*
     +    S**(-2)*TG**2*MS2 - 8*S**(-1)*TG*MG2 + 8*S**(-1)*TG*MS2 - 4*
     +    S**(-1)*TG**2*T1**(-1)*MG2 + 4*S**(-1)*TG**2*T1**(-1)*MS2 - 4
     +    *S**(-1)*TG**2*U1**(-1)*MG2 + 4*S**(-1)*TG**2*U1**(-1)*MS2 + 
     +    8*S**(-1)*MG2*MS2 - 8*S**(-1)*MG2**2 - 4*S*TG*U1**(-2)*MG2 + 
     +    4*S*TG*U1**(-2)*MS2 - 4*S*U1**(-1)*MG2 + 4*S*U1**(-1)*MS2 - 2
     +    *S**2*U1**(-2)*MG2 + 2*S**2*U1**(-2)*MS2 - 8*TG*U1**(-1)*MG2
     +     + 8*TG*U1**(-1)*MS2 - 2*TG**2*T1**(-2)*MG2 + 2*TG**2*
     +    T1**(-2)*MS2 - 2*TG**2*U1**(-2)*MG2 + 2*TG**2*U1**(-2)*MS2 + 
     +    4*T1**(-1)*MG2*MS2 - 4*T1**(-1)*MG2**2 + 4*U1**(-1)*MG2*MS2
     +     - 4*U1**(-1)*MG2**2 - 4*MG2 + 4*MS2 )
     +
      M2QBSV = M2QBSV + SK1BP(3)*N*CK * ( 8*S**(-2)*TG**2*MG2 - 8*
     +    S**(-2)*TG**2*MS2 + 8*S**(-1)*TG*MG2 - 8*S**(-1)*TG*MS2 + 4*
     +    S**(-1)*TG**2*T1**(-1)*MG2 - 4*S**(-1)*TG**2*T1**(-1)*MS2 + 4
     +    *S**(-1)*TG**2*U1**(-1)*MG2 - 4*S**(-1)*TG**2*U1**(-1)*MS2 - 
     +    8*S**(-1)*MG2*MS2 + 8*S**(-1)*MG2**2 + 12*S*TG*U1**(-2)*MG2
     +     - 12*S*TG*U1**(-2)*MS2 + 8*S*T1**(-1)*U1**(-1)*MG2*MS2 - 8*S
     +    *T1**(-1)*U1**(-1)*MG2**2 + 4*S*U1**(-1)*MG2 - 4*S*U1**(-1)*
     +    MS2 + 6*S**2*U1**(-2)*MG2 - 6*S**2*U1**(-2)*MS2 + 8*TG*
     +    U1**(-1)*MG2 - 8*TG*U1**(-1)*MS2 + 6*TG**2*T1**(-2)*MG2 - 6*
     +    TG**2*T1**(-2)*MS2 + 6*TG**2*U1**(-2)*MG2 - 6*TG**2*U1**(-2)*
     +    MS2 - 4*T1**(-1)*MG2*MS2 + 4*T1**(-1)*MG2**2 - 4*U1**(-1)*MG2
     +    *MS2 + 4*U1**(-1)*MG2**2 + 4*MG2 - 4*MS2 )
     +
      M2QBSV = M2QBSV + SK1BP(3)*CQED * (  - 4*S*TG*U1**(-2)*MG2 + 4*S*
     +    TG*U1**(-2)*MS2 - 4*S*T1**(-1)*U1**(-1)*MG2*MS2 + 4*S*
     +    T1**(-1)*U1**(-1)*MG2**2 - 2*S**2*U1**(-2)*MG2 + 2*S**2*
     +    U1**(-2)*MS2 - 2*TG**2*T1**(-2)*MG2 + 2*TG**2*T1**(-2)*MS2 - 
     +    2*TG**2*U1**(-2)*MG2 + 2*TG**2*U1**(-2)*MS2 )
     +
      M2QBSV = M2QBSV + SK1BP(5)*CO * (  - 32*S**(-2)*TG**2*MG2 + 32*
     +    S**(-2)*TG**2*MS2 - 32*S**(-2)*TG**2*MT2 - 32*S**(-1)*TG*MG2
     +     + 32*S**(-1)*TG*MS2 - 32*S**(-1)*TG*MT2 - 16*S**(-1)*TG**2*
     +    T1**(-1)*MG2 + 16*S**(-1)*TG**2*T1**(-1)*MS2 - 16*S**(-1)*
     +    TG**2*T1**(-1)*MT2 - 16*S**(-1)*TG**2*U1**(-1)*MG2 + 16*
     +    S**(-1)*TG**2*U1**(-1)*MS2 - 16*S**(-1)*TG**2*U1**(-1)*MT2 + 
     +    32*S**(-1)*MG2*MS2 - 32*S**(-1)*MG2*MT2 - 32*S**(-1)*MG2**2
     +     - 16*S*TG*U1**(-2)*MG2 + 16*S*TG*U1**(-2)*MS2 - 16*S*TG*
     +    U1**(-2)*MT2 - 16*S*U1**(-1)*MG2 + 16*S*U1**(-1)*MS2 - 16*S*
     +    U1**(-1)*MT2 - 8*S**2*U1**(-2)*MG2 + 8*S**2*U1**(-2)*MS2 - 8*
     +    S**2*U1**(-2)*MT2 - 32*TG*U1**(-1)*MG2 + 32*TG*U1**(-1)*MS2
     +     - 32*TG*U1**(-1)*MT2 - 8*TG**2*T1**(-2)*MG2 + 8*TG**2*
     +    T1**(-2)*MS2 - 8*TG**2*T1**(-2)*MT2 - 8*TG**2*U1**(-2)*MG2 + 
     +    8*TG**2*U1**(-2)*MS2 - 8*TG**2*U1**(-2)*MT2 + 16*T1**(-1)*MG2
     +    *MS2 - 16*T1**(-1)*MG2*MT2 - 16*T1**(-1)*MG2**2 + 16*U1**(-1)
     +    *MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1BP(5)*CO * (  - 16*U1**(-1)*MG2*MT2 - 16*
     +    U1**(-1)*MG2**2 - 16*MG2 + 16*MS2 - 16*MT2 )
     +
      M2QBSV = M2QBSV + SK1BP(5)*CK * ( 16*S*TG*U1**(-2)*MG2 - 16*S*TG*
     +    U1**(-2)*MS2 + 16*S*TG*U1**(-2)*MT2 + 16*S*T1**(-1)*U1**(-1)*
     +    MG2*MS2 - 16*S*T1**(-1)*U1**(-1)*MG2*MT2 - 16*S*T1**(-1)*
     +    U1**(-1)*MG2**2 + 8*S**2*U1**(-2)*MG2 - 8*S**2*U1**(-2)*MS2
     +     + 8*S**2*U1**(-2)*MT2 + 8*TG**2*T1**(-2)*MG2 - 8*TG**2*
     +    T1**(-2)*MS2 + 8*TG**2*T1**(-2)*MT2 + 8*TG**2*U1**(-2)*MG2 - 
     +    8*TG**2*U1**(-2)*MS2 + 8*TG**2*U1**(-2)*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0A(1)*N*CO * ( 16*S**(-1)*TG**2 + 8*S*TG*
     +    U1**(-1) + 2*S*T1**(-1)*MG2 + 2*S*U1**(-1)*MG2 + 8*S + 4*S**2
     +    *U1**(-1) + 16*TG + 4*TG**2*T1**(-1) + 4*TG**2*U1**(-1) + 8*
     +    MG2 )
     +
      M2QBSV = M2QBSV + SK1C0A(1)*N*CK * ( 16*S**(-1)*TG**2 + 2*S*TG*
     +    T1**(-1) + 6*S*TG*U1**(-1) + 2*S*T1**(-1)*MG2 + 2*S*T1**(-1)*
     +    MS2 + 2*S*U1**(-1)*MG2 + 2*S*U1**(-1)*MS2 + 6*S + 2*S**2*
     +    U1**(-1) + 16*TG + 4*TG**2*T1**(-1) + 4*TG**2*U1**(-1) + 12*
     +    MG2 + 4*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0A(1)*CQED * (  - 2*S*TG*T1**(-1) + 2*S*TG*
     +    U1**(-1) + 2*S*T1**(-1)*MG2 - 2*S*T1**(-1)*MS2 + 2*S*U1**(-1)
     +    *MG2 - 2*S*U1**(-1)*MS2 + 2*S**2*U1**(-1) )
     +
      M2QBSV = M2QBSV + SK1C0A(5)*N*CO * ( 32*S**(-3)*TG**2*MG2*MS2 - 
     +    16*S**(-3)*TG**2*MG2**2 - 16*S**(-3)*TG**2*MS2**2 + 32*
     +    S**(-2)*TG*MG2*MS2 - 16*S**(-2)*TG*MG2**2 - 16*S**(-2)*TG*
     +    MS2**2 + 8*S**(-2)*TG**2*T1**(-1)*MG2*MS2 - 4*S**(-2)*TG**2*
     +    T1**(-1)*MG2**2 - 4*S**(-2)*TG**2*T1**(-1)*MS2**2 + 8*S**(-2)
     +    *TG**2*U1**(-1)*MG2*MS2 - 4*S**(-2)*TG**2*U1**(-1)*MG2**2 - 4
     +    *S**(-2)*TG**2*U1**(-1)*MS2**2 - 16*S**(-2)*TG**2*MG2 - 16*
     +    S**(-2)*MG2*MS2**2 + 32*S**(-2)*MG2**2*MS2 - 16*S**(-2)*
     +    MG2**3 + 16*S**(-1)*TG*U1**(-1)*MG2*MS2 - 8*S**(-1)*TG*
     +    U1**(-1)*MG2**2 - 8*S**(-1)*TG*U1**(-1)*MS2**2 - 16*S**(-1)*
     +    TG*MG2 - 4*S**(-1)*TG**2*T1**(-1)*MG2 - 4*S**(-1)*TG**2*
     +    U1**(-1)*MG2 - 4*S**(-1)*T1**(-1)*MG2*MS2**2 + 8*S**(-1)*
     +    T1**(-1)*MG2**2*MS2 - 4*S**(-1)*T1**(-1)*MG2**3 - 4*S**(-1)*
     +    U1**(-1)*MG2*MS2**2 + 8*S**(-1)*U1**(-1)*MG2**2*MS2 - 4*
     +    S**(-1)*U1**(-1)*MG2**3 + 16*S**(-1)*MG2*MS2 - 24*S**(-1)*
     +    MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0A(5)*N*CO * (  - 8*S**(-1)*MS2**2 + 2*S*TG
     +    *T1**(-1) - 2*S*TG*U1**(-1) - 2*S*T1**(-1)*MG2 + 2*S*T1**(-1)
     +    *MS2 - 6*S*U1**(-1)*MG2 + 2*S*U1**(-1)*MS2 - 2*S - 2*S**2*
     +    U1**(-1) - 8*TG*U1**(-1)*MG2 - 4*T1**(-1)*MG2**2 + 8*U1**(-1)
     +    *MG2*MS2 - 8*U1**(-1)*MG2**2 - 4*U1**(-1)*MS2**2 - 20*MG2 + 4
     +    *MS2 )
     +
      M2QBSV = M2QBSV + SK1C0A(6)*N*CK * ( 32*S**(-3)*TG**2*MG2*MS2 - 
     +    16*S**(-3)*TG**2*MG2**2 - 16*S**(-3)*TG**2*MS2**2 + 32*
     +    S**(-2)*TG*MG2*MS2 - 16*S**(-2)*TG*MG2**2 - 16*S**(-2)*TG*
     +    MS2**2 + 8*S**(-2)*TG**2*T1**(-1)*MG2*MS2 - 4*S**(-2)*TG**2*
     +    T1**(-1)*MG2**2 - 4*S**(-2)*TG**2*T1**(-1)*MS2**2 + 8*S**(-2)
     +    *TG**2*U1**(-1)*MG2*MS2 - 4*S**(-2)*TG**2*U1**(-1)*MG2**2 - 4
     +    *S**(-2)*TG**2*U1**(-1)*MS2**2 - 16*S**(-2)*TG**2*MG2 - 16*
     +    S**(-2)*MG2*MS2**2 + 32*S**(-2)*MG2**2*MS2 - 16*S**(-2)*
     +    MG2**3 + 16*S**(-1)*TG*U1**(-1)*MG2*MS2 - 8*S**(-1)*TG*
     +    U1**(-1)*MG2**2 - 8*S**(-1)*TG*U1**(-1)*MS2**2 - 16*S**(-1)*
     +    TG*MG2 - 4*S**(-1)*TG**2*T1**(-1)*MG2 - 4*S**(-1)*TG**2*
     +    U1**(-1)*MG2 - 4*S**(-1)*T1**(-1)*MG2*MS2**2 + 8*S**(-1)*
     +    T1**(-1)*MG2**2*MS2 - 4*S**(-1)*T1**(-1)*MG2**3 - 4*S**(-1)*
     +    U1**(-1)*MG2*MS2**2 + 8*S**(-1)*U1**(-1)*MG2**2*MS2 - 4*
     +    S**(-1)*U1**(-1)*MG2**3 + 16*S**(-1)*MG2*MS2 - 24*S**(-1)*
     +    MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0A(6)*N*CK * (  - 8*S**(-1)*MS2**2 - 2*S*
     +    T1**(-1)*MG2 - 6*S*U1**(-1)*MG2 - 4*S - 8*TG*U1**(-1)*MG2 - 4
     +    *T1**(-1)*MG2**2 + 8*U1**(-1)*MG2*MS2 - 8*U1**(-1)*MG2**2 - 4
     +    *U1**(-1)*MS2**2 - 16*MG2 + 8*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0A(6)*CQED * ( 4*S*T1**(-1)*MS2 + 4*S*
     +    U1**(-1)*MS2 - 2*S**2*T1**(-1) - 2*S**2*U1**(-1) )
     +
      M2QBSV = M2QBSV + SK1C0B(1)*N*CO * ( 32*S**(-2)*TG**2*MG2 + 32*
     +    S**(-1)*TG*MG2 + 8*S**(-1)*TG**2*T1**(-1)*MG2 + 8*S**(-1)*
     +    TG**2*U1**(-1)*MG2 - 16*S**(-1)*TG**2 + 32*S**(-1)*MG2**2 - 2
     +    *S*TG*T1**(-1) - 6*S*TG*U1**(-1) - 2*S*T1**(-1)*MG2 - 2*S*
     +    T1**(-1)*MS2 + 2*S*U1**(-1)*MG2 - 2*S*U1**(-1)*MS2 - 6*S - 2*
     +    S**2*U1**(-1) + 4*TG*T1**(-1)*MG2 + 12*TG*U1**(-1)*MG2 - 16*
     +    TG - 4*TG**2*T1**(-1) - 4*TG**2*U1**(-1) + 4*T1**(-1)*MG2*MS2
     +     + 4*T1**(-1)*MG2**2 + 4*U1**(-1)*MG2*MS2 + 4*U1**(-1)*MG2**2
     +     + 4*MG2 - 4*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*N*CK * (  - 8*S*S1**(-1)*T1**(-1)*MG2
     +    *MS2 + 8*S*S1**(-1)*T1**(-1)*MG2**2 + 8*S*S1**(-1)*U1**(-1)*
     +    MG2*MS2 - 8*S*S1**(-1)*U1**(-1)*MG2**2 - 2*S*T1**(-1)*MG2 - 2
     +    *S*U1**(-1)*MG2 - 4*S - 8*TG*S1**(-1)*T1**(-1)*MG2*MS2 + 8*TG
     +    *S1**(-1)*T1**(-1)*MG2**2 + 8*TG*S1**(-1)*U1**(-1)*MG2*MS2 - 
     +    8*TG*S1**(-1)*U1**(-1)*MG2**2 + 16*S1**(-1)*T1**(-1)*MG2**2*
     +    MS2 - 16*S1**(-1)*T1**(-1)*MG2**3 - 16*S1**(-1)*U1**(-1)*
     +    MG2**2*MS2 + 16*S1**(-1)*U1**(-1)*MG2**3 + 8*U1**(-1)*MG2*MS2
     +     - 8*U1**(-1)*MG2**2 + 8*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CO * ( 32*S**(-2)*TG**2*S1**(-1)*NS*
     +    MS2**2 - 32*S**(-2)*TG**2*S1**(-1)*MS2**2 - 8*S**(-2)*TG**2*
     +    NS*MG2 + 8*S**(-2)*TG**2*MG2 + 32*S**(-1)*TG*S1**(-1)*NS*
     +    MS2**2 - 32*S**(-1)*TG*S1**(-1)*MS2**2 - 8*S**(-1)*TG*NS*MG2
     +     + 8*S**(-1)*TG*MG2 + 48*S**(-1)*TG**2*S1**(-2)*NS*MS2**2 - 
     +    48*S**(-1)*TG**2*S1**(-2)*MS2**2 + 8*S**(-1)*TG**2*S1**(-1)*
     +    T1**(-1)*NS*MS2**2 - 8*S**(-1)*TG**2*S1**(-1)*T1**(-1)*MS2**2
     +     + 8*S**(-1)*TG**2*S1**(-1)*U1**(-1)*NS*MS2**2 - 8*S**(-1)*
     +    TG**2*S1**(-1)*U1**(-1)*MS2**2 - 24*S**(-1)*TG**2*S1**(-1)*NS
     +    *MS2 + 24*S**(-1)*TG**2*S1**(-1)*MS2 - 2*S**(-1)*TG**2*
     +    T1**(-1)*NS*MG2 + 2*S**(-1)*TG**2*T1**(-1)*MG2 - 2*S**(-1)*
     +    TG**2*U1**(-1)*NS*MG2 + 2*S**(-1)*TG**2*U1**(-1)*MG2 + 
     +    S**(-1)*TG**2*NS - S**(-1)*TG**2 - 8*S**(-1)*NS*MG2**2 + 8*
     +    S**(-1)*NS*MS2**2 + 8*S**(-1)*MG2**2 - 8*S**(-1)*MS2**2 - 48*
     +    S*TG*S1**(-2)*T1**(-1)*NS*MG2*MS2 + 24*S*TG*S1**(-2)*T1**(-1)
     +    *NS*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CO * ( 24*S*TG*S1**(-2)*T1**(-1)*NS*
     +    MS2**2 + 48*S*TG*S1**(-2)*T1**(-1)*MG2*MS2 - 24*S*TG*S1**(-2)
     +    *T1**(-1)*MG2**2 - 24*S*TG*S1**(-2)*T1**(-1)*MS2**2 - 48*S*TG
     +    *S1**(-2)*U1**(-1)*NS*MG2*MS2 + 24*S*TG*S1**(-2)*U1**(-1)*NS*
     +    MG2**2 + 24*S*TG*S1**(-2)*U1**(-1)*NS*MS2**2 + 48*S*TG*
     +    S1**(-2)*U1**(-1)*MG2*MS2 - 24*S*TG*S1**(-2)*U1**(-1)*MG2**2
     +     - 24*S*TG*S1**(-2)*U1**(-1)*MS2**2 + 24*S*TG*S1**(-2)*NS*MG2
     +     - 48*S*TG*S1**(-2)*NS*MS2 - 24*S*TG*S1**(-2)*MG2 + 48*S*TG*
     +    S1**(-2)*MS2 - 4*S*TG*S1**(-1)*T1**(-1)*NS*MG2 + 4*S*TG*
     +    S1**(-1)*T1**(-1)*MG2 - 4*S*TG*S1**(-1)*U1**(-1)*NS*MG2 + 4*S
     +    *TG*S1**(-1)*U1**(-1)*MG2 + 2*S*TG*S1**(-1)*NS - 2*S*TG*
     +    S1**(-1) - 48*S*S1**(-2)*T1**(-1)*NS*MG2*MS2**2 + 96*S*
     +    S1**(-2)*T1**(-1)*NS*MG2**2*MS2 - 48*S*S1**(-2)*T1**(-1)*NS*
     +    MG2**3 + 48*S*S1**(-2)*T1**(-1)*MG2*MS2**2 - 96*S*S1**(-2)*
     +    T1**(-1)*MG2**2*MS2 + 48*S*S1**(-2)*T1**(-1)*MG2**3 - 48*S*
     +    S1**(-2)*U1**(-1)*NS*MG2*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CO * ( 96*S*S1**(-2)*U1**(-1)*NS*
     +    MG2**2*MS2 - 48*S*S1**(-2)*U1**(-1)*NS*MG2**3 + 48*S*S1**(-2)
     +    *U1**(-1)*MG2*MS2**2 - 96*S*S1**(-2)*U1**(-1)*MG2**2*MS2 + 48
     +    *S*S1**(-2)*U1**(-1)*MG2**3 + 96*S*S1**(-2)*NS*MG2*MS2 - 48*S
     +    *S1**(-2)*NS*MG2**2 - 96*S*S1**(-2)*MG2*MS2 + 48*S*S1**(-2)*
     +    MG2**2 - 32*S*S1**(-1)*T1**(-1)*NS*MG2*MS2 + 24*S*S1**(-1)*
     +    T1**(-1)*NS*MG2**2 + 16*S*S1**(-1)*T1**(-1)*NS*MS2**2 + 32*S*
     +    S1**(-1)*T1**(-1)*MG2*MS2 - 24*S*S1**(-1)*T1**(-1)*MG2**2 - 
     +    16*S*S1**(-1)*T1**(-1)*MS2**2 - 16*S*S1**(-1)*U1**(-1)*NS*MG2
     +    *MS2 + 16*S*S1**(-1)*U1**(-1)*NS*MG2**2 + 8*S*S1**(-1)*
     +    U1**(-1)*NS*MS2**2 + 16*S*S1**(-1)*U1**(-1)*MG2*MS2 - 16*S*
     +    S1**(-1)*U1**(-1)*MG2**2 - 8*S*S1**(-1)*U1**(-1)*MS2**2 + 8*S
     +    *S1**(-1)*NS*MG2 - 24*S*S1**(-1)*NS*MS2 - 8*S*S1**(-1)*MG2 + 
     +    24*S*S1**(-1)*MS2 - 2*S*T1**(-1)*NS*MG2 + 2*S*T1**(-1)*MG2 - 
     +    2*S*U1**(-1)*NS*MG2 + 2*S*U1**(-1)*MG2 + S*NS - S - 24*S**2*
     +    S1**(-2)*T1**(-1)*NS*MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CO * ( 12*S**2*S1**(-2)*T1**(-1)*NS*
     +    MG2**2 + 12*S**2*S1**(-2)*T1**(-1)*NS*MS2**2 + 24*S**2*
     +    S1**(-2)*T1**(-1)*MG2*MS2 - 12*S**2*S1**(-2)*T1**(-1)*MG2**2
     +     - 12*S**2*S1**(-2)*T1**(-1)*MS2**2 - 24*S**2*S1**(-2)*
     +    U1**(-1)*NS*MG2*MS2 + 12*S**2*S1**(-2)*U1**(-1)*NS*MG2**2 + 
     +    12*S**2*S1**(-2)*U1**(-1)*NS*MS2**2 + 24*S**2*S1**(-2)*
     +    U1**(-1)*MG2*MS2 - 12*S**2*S1**(-2)*U1**(-1)*MG2**2 - 12*S**2
     +    *S1**(-2)*U1**(-1)*MS2**2 + 12*S**2*S1**(-2)*NS*MG2 - 24*S**2
     +    *S1**(-2)*NS*MS2 - 12*S**2*S1**(-2)*MG2 + 24*S**2*S1**(-2)*
     +    MS2 - 2*S**2*S1**(-1)*T1**(-1)*NS*MG2 + 2*S**2*S1**(-1)*
     +    T1**(-1)*MG2 - 2*S**2*S1**(-1)*U1**(-1)*NS*MG2 + 2*S**2*
     +    S1**(-1)*U1**(-1)*MG2 + S**2*S1**(-1)*NS - S**2*S1**(-1) - 48
     +    *TG*S1**(-2)*T1**(-1)*NS*MG2*MS2**2 + 96*TG*S1**(-2)*T1**(-1)
     +    *NS*MG2**2*MS2 - 48*TG*S1**(-2)*T1**(-1)*NS*MG2**3 + 48*TG*
     +    S1**(-2)*T1**(-1)*MG2*MS2**2 - 96*TG*S1**(-2)*T1**(-1)*MG2**2
     +    *MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CO * ( 48*TG*S1**(-2)*T1**(-1)*MG2**3
     +     - 48*TG*S1**(-2)*U1**(-1)*NS*MG2*MS2**2 + 96*TG*S1**(-2)*
     +    U1**(-1)*NS*MG2**2*MS2 - 48*TG*S1**(-2)*U1**(-1)*NS*MG2**3 + 
     +    48*TG*S1**(-2)*U1**(-1)*MG2*MS2**2 - 96*TG*S1**(-2)*U1**(-1)*
     +    MG2**2*MS2 + 48*TG*S1**(-2)*U1**(-1)*MG2**3 + 96*TG*S1**(-2)*
     +    NS*MG2*MS2 - 48*TG*S1**(-2)*NS*MG2**2 + 48*TG*S1**(-2)*NS*
     +    MS2**2 - 96*TG*S1**(-2)*MG2*MS2 + 48*TG*S1**(-2)*MG2**2 - 48*
     +    TG*S1**(-2)*MS2**2 - 32*TG*S1**(-1)*T1**(-1)*NS*MG2*MS2 + 24*
     +    TG*S1**(-1)*T1**(-1)*NS*MG2**2 + 24*TG*S1**(-1)*T1**(-1)*NS*
     +    MS2**2 + 32*TG*S1**(-1)*T1**(-1)*MG2*MS2 - 24*TG*S1**(-1)*
     +    T1**(-1)*MG2**2 - 24*TG*S1**(-1)*T1**(-1)*MS2**2 - 16*TG*
     +    S1**(-1)*U1**(-1)*NS*MG2*MS2 + 16*TG*S1**(-1)*U1**(-1)*NS*
     +    MG2**2 + 16*TG*S1**(-1)*U1**(-1)*NS*MS2**2 + 16*TG*S1**(-1)*
     +    U1**(-1)*MG2*MS2 - 16*TG*S1**(-1)*U1**(-1)*MG2**2 - 16*TG*
     +    S1**(-1)*U1**(-1)*MS2**2 + 8*TG*S1**(-1)*NS*MG2 - 48*TG*
     +    S1**(-1)*NS*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CO * (  - 8*TG*S1**(-1)*MG2 + 48*TG*
     +    S1**(-1)*MS2 - 4*TG*T1**(-1)*NS*MG2 + 4*TG*T1**(-1)*MG2 - 4*
     +    TG*U1**(-1)*NS*MG2 + 4*TG*U1**(-1)*MG2 + 2*TG*NS - 2*TG - 24*
     +    TG**2*S1**(-2)*T1**(-1)*NS*MG2*MS2 + 12*TG**2*S1**(-2)*
     +    T1**(-1)*NS*MG2**2 + 12*TG**2*S1**(-2)*T1**(-1)*NS*MS2**2 + 
     +    24*TG**2*S1**(-2)*T1**(-1)*MG2*MS2 - 12*TG**2*S1**(-2)*
     +    T1**(-1)*MG2**2 - 12*TG**2*S1**(-2)*T1**(-1)*MS2**2 - 24*
     +    TG**2*S1**(-2)*U1**(-1)*NS*MG2*MS2 + 12*TG**2*S1**(-2)*
     +    U1**(-1)*NS*MG2**2 + 12*TG**2*S1**(-2)*U1**(-1)*NS*MS2**2 + 
     +    24*TG**2*S1**(-2)*U1**(-1)*MG2*MS2 - 12*TG**2*S1**(-2)*
     +    U1**(-1)*MG2**2 - 12*TG**2*S1**(-2)*U1**(-1)*MS2**2 + 12*
     +    TG**2*S1**(-2)*NS*MG2 - 24*TG**2*S1**(-2)*NS*MS2 - 12*TG**2*
     +    S1**(-2)*MG2 + 24*TG**2*S1**(-2)*MS2 - 2*TG**2*S1**(-1)*
     +    T1**(-1)*NS*MG2 + 2*TG**2*S1**(-1)*T1**(-1)*MG2 - 2*TG**2*
     +    S1**(-1)*U1**(-1)*NS*MG2 + 2*TG**2*S1**(-1)*U1**(-1)*MG2 + 
     +    TG**2*S1**(-1)*NS )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CO * (  - TG**2*S1**(-1) + 48*
     +    S1**(-2)*T1**(-1)*NS*MG2**2*MS2**2 - 96*S1**(-2)*T1**(-1)*NS*
     +    MG2**3*MS2 + 48*S1**(-2)*T1**(-1)*NS*MG2**4 - 48*S1**(-2)*
     +    T1**(-1)*MG2**2*MS2**2 + 96*S1**(-2)*T1**(-1)*MG2**3*MS2 - 48
     +    *S1**(-2)*T1**(-1)*MG2**4 + 48*S1**(-2)*U1**(-1)*NS*MG2**2*
     +    MS2**2 - 96*S1**(-2)*U1**(-1)*NS*MG2**3*MS2 + 48*S1**(-2)*
     +    U1**(-1)*NS*MG2**4 - 48*S1**(-2)*U1**(-1)*MG2**2*MS2**2 + 96*
     +    S1**(-2)*U1**(-1)*MG2**3*MS2 - 48*S1**(-2)*U1**(-1)*MG2**4 + 
     +    48*S1**(-2)*NS*MG2*MS2**2 - 96*S1**(-2)*NS*MG2**2*MS2 + 48*
     +    S1**(-2)*NS*MG2**3 - 48*S1**(-2)*MG2*MS2**2 + 96*S1**(-2)*
     +    MG2**2*MS2 - 48*S1**(-2)*MG2**3 - 20*S1**(-1)*T1**(-1)*NS*MG2
     +    *MS2**2 + 56*S1**(-1)*T1**(-1)*NS*MG2**2*MS2 - 36*S1**(-1)*
     +    T1**(-1)*NS*MG2**3 + 20*S1**(-1)*T1**(-1)*MG2*MS2**2 - 56*
     +    S1**(-1)*T1**(-1)*MG2**2*MS2 + 36*S1**(-1)*T1**(-1)*MG2**3 - 
     +    4*S1**(-1)*U1**(-1)*NS*MG2*MS2**2 + 24*S1**(-1)*U1**(-1)*NS*
     +    MG2**2*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CO * (  - 20*S1**(-1)*U1**(-1)*NS*
     +    MG2**3 + 4*S1**(-1)*U1**(-1)*MG2*MS2**2 - 24*S1**(-1)*
     +    U1**(-1)*MG2**2*MS2 + 20*S1**(-1)*U1**(-1)*MG2**3 + 16*
     +    S1**(-1)*NS*MG2*MS2 - 16*S1**(-1)*NS*MG2**2 - 16*S1**(-1)*MG2
     +    *MS2 + 16*S1**(-1)*MG2**2 - 8*T1**(-1)*NS*MG2*MS2 + 4*
     +    T1**(-1)*NS*MG2**2 + 4*T1**(-1)*NS*MS2**2 + 8*T1**(-1)*MG2*
     +    MS2 - 4*T1**(-1)*MG2**2 - 4*T1**(-1)*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(2)*CQED * ( 16*S*S1**(-1)*T1**(-1)*MG2*
     +    MS2 - 16*S*S1**(-1)*T1**(-1)*MG2**2 - 16*S*S1**(-1)*U1**(-1)*
     +    MG2*MS2 + 16*S*S1**(-1)*U1**(-1)*MG2**2 + 4*S*T1**(-1)*MG2 + 
     +    4*S*T1**(-1)*MS2 + 4*S*U1**(-1)*MG2 + 4*S*U1**(-1)*MS2 - 2*
     +    S**2*T1**(-1) - 2*S**2*U1**(-1) + 16*TG*S1**(-1)*T1**(-1)*MG2
     +    *MS2 - 16*TG*S1**(-1)*T1**(-1)*MG2**2 - 16*TG*S1**(-1)*
     +    U1**(-1)*MG2*MS2 + 16*TG*S1**(-1)*U1**(-1)*MG2**2 - 32*
     +    S1**(-1)*T1**(-1)*MG2**2*MS2 + 32*S1**(-1)*T1**(-1)*MG2**3 + 
     +    32*S1**(-1)*U1**(-1)*MG2**2*MS2 - 32*S1**(-1)*U1**(-1)*MG2**3
     +     - 16*U1**(-1)*MG2*MS2 + 16*U1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(3)*N*CO * ( 24*S**(-1)*TG**2 + 96*S*TG*
     +    S1**(-2)*T1**(-1)*MG2**2 + 96*S*TG*S1**(-2)*U1**(-1)*MG2**2
     +     + 96*S*TG*S1**(-2)*MG2 - 8*S*TG*S1**(-1)*T1**(-1)*MG2 - 8*S*
     +    TG*S1**(-1)*U1**(-1)*MG2 + 16*S*TG*S1**(-1) + 8*S*TG*U1**(-1)
     +     - 192*S*S1**(-2)*T1**(-1)*MG2**3 - 192*S*S1**(-2)*U1**(-1)*
     +    MG2**3 - 192*S*S1**(-2)*MG2**2 + 64*S*S1**(-1)*T1**(-1)*
     +    MG2**2 + 64*S*S1**(-1)*U1**(-1)*MG2**2 + 16*S*S1**(-1)*MG2 - 
     +    2*S*T1**(-1)*MG2 - 6*S*U1**(-1)*MG2 + 16*S + 48*S**2*S1**(-2)
     +    *T1**(-1)*MG2**2 + 48*S**2*S1**(-2)*U1**(-1)*MG2**2 + 48*S**2
     +    *S1**(-2)*MG2 - 4*S**2*S1**(-1)*T1**(-1)*MG2 - 4*S**2*
     +    S1**(-1)*U1**(-1)*MG2 + 8*S**2*S1**(-1) + 4*S**2*U1**(-1) - 
     +    192*TG*S1**(-2)*T1**(-1)*MG2**3 - 192*TG*S1**(-2)*U1**(-1)*
     +    MG2**3 - 192*TG*S1**(-2)*MG2**2 + 64*TG*S1**(-1)*T1**(-1)*
     +    MG2**2 + 64*TG*S1**(-1)*U1**(-1)*MG2**2 + 16*TG*S1**(-1)*MG2
     +     - 8*TG*U1**(-1)*MG2 + 32*TG + 48*TG**2*S1**(-2)*T1**(-1)*
     +    MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(3)*N*CO * ( 48*TG**2*S1**(-2)*U1**(-1)*
     +    MG2**2 + 48*TG**2*S1**(-2)*MG2 - 4*TG**2*S1**(-1)*T1**(-1)*
     +    MG2 - 4*TG**2*S1**(-1)*U1**(-1)*MG2 + 8*TG**2*S1**(-1) + 4*
     +    TG**2*T1**(-1) + 4*TG**2*U1**(-1) + 192*S1**(-2)*T1**(-1)*
     +    MG2**4 + 192*S1**(-2)*U1**(-1)*MG2**4 + 192*S1**(-2)*MG2**3
     +     - 96*S1**(-1)*T1**(-1)*MG2**3 - 96*S1**(-1)*U1**(-1)*MG2**3
     +     - 48*S1**(-1)*MG2**2 + 12*T1**(-1)*MG2**2 + 12*U1**(-1)*
     +    MG2**2 + 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*N*CK * (  - 2*S*TG*T1**(-1) + 2*S*TG*
     +    U1**(-1) - 8*S*S1**(-1)*T1**(-1)*MG2*MS2 - 8*S*S1**(-1)*
     +    T1**(-1)*MG2**2 + 8*S*S1**(-1)*U1**(-1)*MG2*MS2 + 8*S*
     +    S1**(-1)*U1**(-1)*MG2**2 + 2*S*T1**(-1)*MG2 - 2*S*T1**(-1)*
     +    MS2 - 2*S*U1**(-1)*MG2 - 2*S*U1**(-1)*MS2 + 2*S + 2*S**2*
     +    U1**(-1) - 8*TG*S1**(-1)*T1**(-1)*MG2*MS2 - 8*TG*S1**(-1)*
     +    T1**(-1)*MG2**2 + 8*TG*S1**(-1)*U1**(-1)*MG2*MS2 + 8*TG*
     +    S1**(-1)*U1**(-1)*MG2**2 + 4*TG*T1**(-1)*MG2 - 4*TG*U1**(-1)*
     +    MG2 + 16*S1**(-1)*T1**(-1)*MG2**2*MS2 + 16*S1**(-1)*T1**(-1)*
     +    MG2**3 - 16*S1**(-1)*U1**(-1)*MG2**2*MS2 - 16*S1**(-1)*
     +    U1**(-1)*MG2**3 - 4*T1**(-1)*MG2*MS2 - 4*T1**(-1)*MG2**2 + 4*
     +    U1**(-1)*MG2*MS2 + 4*U1**(-1)*MG2**2 + 12*MG2 - 4*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * (  - 32*S**(-2)*TG**2*S1**(-1)*
     +    NS*MS2**2 + 32*S**(-2)*TG**2*S1**(-1)*MS2**2 - 8*S**(-2)*
     +    TG**2*NS*MG2 + 16*S**(-2)*TG**2*NS*MS2 + 8*S**(-2)*TG**2*MG2
     +     - 16*S**(-2)*TG**2*MS2 - 32*S**(-1)*TG*S1**(-1)*NS*MS2**2 + 
     +    32*S**(-1)*TG*S1**(-1)*MS2**2 - 8*S**(-1)*TG*NS*MG2 + 16*
     +    S**(-1)*TG*NS*MS2 + 8*S**(-1)*TG*MG2 - 16*S**(-1)*TG*MS2 - 48
     +    *S**(-1)*TG**2*S1**(-2)*NS*MS2**2 + 48*S**(-1)*TG**2*S1**(-2)
     +    *MS2**2 - 8*S**(-1)*TG**2*S1**(-1)*T1**(-1)*NS*MS2**2 + 8*
     +    S**(-1)*TG**2*S1**(-1)*T1**(-1)*MS2**2 - 8*S**(-1)*TG**2*
     +    S1**(-1)*U1**(-1)*NS*MS2**2 + 8*S**(-1)*TG**2*S1**(-1)*
     +    U1**(-1)*MS2**2 - 8*S**(-1)*TG**2*S1**(-1)*NS*MS2 + 8*S**(-1)
     +    *TG**2*S1**(-1)*MS2 - 2*S**(-1)*TG**2*T1**(-1)*NS*MG2 + 4*
     +    S**(-1)*TG**2*T1**(-1)*NS*MS2 + 2*S**(-1)*TG**2*T1**(-1)*MG2
     +     - 4*S**(-1)*TG**2*T1**(-1)*MS2 - 2*S**(-1)*TG**2*U1**(-1)*NS
     +    *MG2 + 4*S**(-1)*TG**2*U1**(-1)*NS*MS2 + 2*S**(-1)*TG**2*
     +    U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * (  - 4*S**(-1)*TG**2*U1**(-1)*
     +    MS2 - S**(-1)*TG**2*NS + S**(-1)*TG**2 + 16*S**(-1)*NS*MG2*
     +    MS2 - 8*S**(-1)*NS*MG2**2 - 8*S**(-1)*NS*MS2**2 - 16*S**(-1)*
     +    MG2*MS2 + 8*S**(-1)*MG2**2 + 8*S**(-1)*MS2**2 - 48*S*TG*
     +    S1**(-2)*T1**(-1)*NS*MG2*MS2 - 24*S*TG*S1**(-2)*T1**(-1)*NS*
     +    MG2**2 - 24*S*TG*S1**(-2)*T1**(-1)*NS*MS2**2 + 48*S*TG*
     +    S1**(-2)*T1**(-1)*MG2*MS2 + 24*S*TG*S1**(-2)*T1**(-1)*MG2**2
     +     + 24*S*TG*S1**(-2)*T1**(-1)*MS2**2 - 48*S*TG*S1**(-2)*
     +    U1**(-1)*NS*MG2*MS2 - 24*S*TG*S1**(-2)*U1**(-1)*NS*MG2**2 - 
     +    24*S*TG*S1**(-2)*U1**(-1)*NS*MS2**2 + 48*S*TG*S1**(-2)*
     +    U1**(-1)*MG2*MS2 + 24*S*TG*S1**(-2)*U1**(-1)*MG2**2 + 24*S*TG
     +    *S1**(-2)*U1**(-1)*MS2**2 - 24*S*TG*S1**(-2)*NS*MG2 - 48*S*TG
     +    *S1**(-2)*NS*MS2 + 24*S*TG*S1**(-2)*MG2 + 48*S*TG*S1**(-2)*
     +    MS2 + 4*S*TG*S1**(-1)*T1**(-1)*NS*MG2 + 8*S*TG*S1**(-1)*
     +    T1**(-1)*NS*MS2 - 4*S*TG*S1**(-1)*T1**(-1)*MG2 - 8*S*TG*
     +    S1**(-1)*T1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * ( 4*S*TG*S1**(-1)*U1**(-1)*NS*
     +    MG2 + 8*S*TG*S1**(-1)*U1**(-1)*NS*MS2 - 4*S*TG*S1**(-1)*
     +    U1**(-1)*MG2 - 8*S*TG*S1**(-1)*U1**(-1)*MS2 - 2*S*TG*S1**(-1)
     +    *NS + 2*S*TG*S1**(-1) + 48*S*S1**(-2)*T1**(-1)*NS*MG2*MS2**2
     +     + 96*S*S1**(-2)*T1**(-1)*NS*MG2**2*MS2 + 48*S*S1**(-2)*
     +    T1**(-1)*NS*MG2**3 - 48*S*S1**(-2)*T1**(-1)*MG2*MS2**2 - 96*S
     +    *S1**(-2)*T1**(-1)*MG2**2*MS2 - 48*S*S1**(-2)*T1**(-1)*MG2**3
     +     + 48*S*S1**(-2)*U1**(-1)*NS*MG2*MS2**2 + 96*S*S1**(-2)*
     +    U1**(-1)*NS*MG2**2*MS2 + 48*S*S1**(-2)*U1**(-1)*NS*MG2**3 - 
     +    48*S*S1**(-2)*U1**(-1)*MG2*MS2**2 - 96*S*S1**(-2)*U1**(-1)*
     +    MG2**2*MS2 - 48*S*S1**(-2)*U1**(-1)*MG2**3 + 96*S*S1**(-2)*NS
     +    *MG2*MS2 + 48*S*S1**(-2)*NS*MG2**2 - 96*S*S1**(-2)*MG2*MS2 - 
     +    48*S*S1**(-2)*MG2**2 - 48*S*S1**(-1)*T1**(-1)*NS*MG2*MS2 - 24
     +    *S*S1**(-1)*T1**(-1)*NS*MG2**2 - 16*S*S1**(-1)*T1**(-1)*NS*
     +    MS2**2 + 48*S*S1**(-1)*T1**(-1)*MG2*MS2 + 24*S*S1**(-1)*
     +    T1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * ( 16*S*S1**(-1)*T1**(-1)*MS2**2
     +     - 32*S*S1**(-1)*U1**(-1)*NS*MG2*MS2 - 16*S*S1**(-1)*U1**(-1)
     +    *NS*MG2**2 - 8*S*S1**(-1)*U1**(-1)*NS*MS2**2 + 32*S*S1**(-1)*
     +    U1**(-1)*MG2*MS2 + 16*S*S1**(-1)*U1**(-1)*MG2**2 + 8*S*
     +    S1**(-1)*U1**(-1)*MS2**2 - 8*S*S1**(-1)*NS*MG2 - 24*S*
     +    S1**(-1)*NS*MS2 + 8*S*S1**(-1)*MG2 + 24*S*S1**(-1)*MS2 + 2*S*
     +    T1**(-1)*NS*MG2 + 4*S*T1**(-1)*NS*MS2 - 2*S*T1**(-1)*MG2 - 4*
     +    S*T1**(-1)*MS2 - 2*S*U1**(-1)*NS*MG2 + 4*S*U1**(-1)*NS*MS2 + 
     +    2*S*U1**(-1)*MG2 - 4*S*U1**(-1)*MS2 - S*NS + S - 24*S**2*
     +    S1**(-2)*T1**(-1)*NS*MG2*MS2 - 12*S**2*S1**(-2)*T1**(-1)*NS*
     +    MG2**2 - 12*S**2*S1**(-2)*T1**(-1)*NS*MS2**2 + 24*S**2*
     +    S1**(-2)*T1**(-1)*MG2*MS2 + 12*S**2*S1**(-2)*T1**(-1)*MG2**2
     +     + 12*S**2*S1**(-2)*T1**(-1)*MS2**2 - 24*S**2*S1**(-2)*
     +    U1**(-1)*NS*MG2*MS2 - 12*S**2*S1**(-2)*U1**(-1)*NS*MG2**2 - 
     +    12*S**2*S1**(-2)*U1**(-1)*NS*MS2**2 + 24*S**2*S1**(-2)*
     +    U1**(-1)*MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * ( 12*S**2*S1**(-2)*U1**(-1)*
     +    MG2**2 + 12*S**2*S1**(-2)*U1**(-1)*MS2**2 - 12*S**2*S1**(-2)*
     +    NS*MG2 - 24*S**2*S1**(-2)*NS*MS2 + 12*S**2*S1**(-2)*MG2 + 24*
     +    S**2*S1**(-2)*MS2 + 2*S**2*S1**(-1)*T1**(-1)*NS*MG2 + 4*S**2*
     +    S1**(-1)*T1**(-1)*NS*MS2 - 2*S**2*S1**(-1)*T1**(-1)*MG2 - 4*
     +    S**2*S1**(-1)*T1**(-1)*MS2 + 2*S**2*S1**(-1)*U1**(-1)*NS*MG2
     +     + 4*S**2*S1**(-1)*U1**(-1)*NS*MS2 - 2*S**2*S1**(-1)*U1**(-1)
     +    *MG2 - 4*S**2*S1**(-1)*U1**(-1)*MS2 - S**2*S1**(-1)*NS + S**2
     +    *S1**(-1) + 48*TG*S1**(-2)*T1**(-1)*NS*MG2*MS2**2 + 96*TG*
     +    S1**(-2)*T1**(-1)*NS*MG2**2*MS2 + 48*TG*S1**(-2)*T1**(-1)*NS*
     +    MG2**3 - 48*TG*S1**(-2)*T1**(-1)*MG2*MS2**2 - 96*TG*S1**(-2)*
     +    T1**(-1)*MG2**2*MS2 - 48*TG*S1**(-2)*T1**(-1)*MG2**3 + 48*TG*
     +    S1**(-2)*U1**(-1)*NS*MG2*MS2**2 + 96*TG*S1**(-2)*U1**(-1)*NS*
     +    MG2**2*MS2 + 48*TG*S1**(-2)*U1**(-1)*NS*MG2**3 - 48*TG*
     +    S1**(-2)*U1**(-1)*MG2*MS2**2 - 96*TG*S1**(-2)*U1**(-1)*MG2**2
     +    *MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * (  - 48*TG*S1**(-2)*U1**(-1)*
     +    MG2**3 + 96*TG*S1**(-2)*NS*MG2*MS2 + 48*TG*S1**(-2)*NS*MG2**2
     +     - 48*TG*S1**(-2)*NS*MS2**2 - 96*TG*S1**(-2)*MG2*MS2 - 48*TG*
     +    S1**(-2)*MG2**2 + 48*TG*S1**(-2)*MS2**2 - 48*TG*S1**(-1)*
     +    T1**(-1)*NS*MG2*MS2 - 24*TG*S1**(-1)*T1**(-1)*NS*MG2**2 - 24*
     +    TG*S1**(-1)*T1**(-1)*NS*MS2**2 + 48*TG*S1**(-1)*T1**(-1)*MG2*
     +    MS2 + 24*TG*S1**(-1)*T1**(-1)*MG2**2 + 24*TG*S1**(-1)*
     +    T1**(-1)*MS2**2 - 32*TG*S1**(-1)*U1**(-1)*NS*MG2*MS2 - 16*TG*
     +    S1**(-1)*U1**(-1)*NS*MG2**2 - 16*TG*S1**(-1)*U1**(-1)*NS*
     +    MS2**2 + 32*TG*S1**(-1)*U1**(-1)*MG2*MS2 + 16*TG*S1**(-1)*
     +    U1**(-1)*MG2**2 + 16*TG*S1**(-1)*U1**(-1)*MS2**2 - 8*TG*
     +    S1**(-1)*NS*MG2 - 32*TG*S1**(-1)*NS*MS2 + 8*TG*S1**(-1)*MG2
     +     + 32*TG*S1**(-1)*MS2 + 4*TG*T1**(-1)*NS*MG2 + 8*TG*T1**(-1)*
     +    NS*MS2 - 4*TG*T1**(-1)*MG2 - 8*TG*T1**(-1)*MS2 - 4*TG*
     +    U1**(-1)*NS*MG2 + 8*TG*U1**(-1)*NS*MS2 + 4*TG*U1**(-1)*MG2 - 
     +    8*TG*U1**(-1)*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * (  - 2*TG*NS + 2*TG - 24*TG**2*
     +    S1**(-2)*T1**(-1)*NS*MG2*MS2 - 12*TG**2*S1**(-2)*T1**(-1)*NS*
     +    MG2**2 - 12*TG**2*S1**(-2)*T1**(-1)*NS*MS2**2 + 24*TG**2*
     +    S1**(-2)*T1**(-1)*MG2*MS2 + 12*TG**2*S1**(-2)*T1**(-1)*MG2**2
     +     + 12*TG**2*S1**(-2)*T1**(-1)*MS2**2 - 24*TG**2*S1**(-2)*
     +    U1**(-1)*NS*MG2*MS2 - 12*TG**2*S1**(-2)*U1**(-1)*NS*MG2**2 - 
     +    12*TG**2*S1**(-2)*U1**(-1)*NS*MS2**2 + 24*TG**2*S1**(-2)*
     +    U1**(-1)*MG2*MS2 + 12*TG**2*S1**(-2)*U1**(-1)*MG2**2 + 12*
     +    TG**2*S1**(-2)*U1**(-1)*MS2**2 - 12*TG**2*S1**(-2)*NS*MG2 - 
     +    24*TG**2*S1**(-2)*NS*MS2 + 12*TG**2*S1**(-2)*MG2 + 24*TG**2*
     +    S1**(-2)*MS2 + 2*TG**2*S1**(-1)*T1**(-1)*NS*MG2 + 4*TG**2*
     +    S1**(-1)*T1**(-1)*NS*MS2 - 2*TG**2*S1**(-1)*T1**(-1)*MG2 - 4*
     +    TG**2*S1**(-1)*T1**(-1)*MS2 + 2*TG**2*S1**(-1)*U1**(-1)*NS*
     +    MG2 + 4*TG**2*S1**(-1)*U1**(-1)*NS*MS2 - 2*TG**2*S1**(-1)*
     +    U1**(-1)*MG2 - 4*TG**2*S1**(-1)*U1**(-1)*MS2 - TG**2*S1**(-1)
     +    *NS )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * ( TG**2*S1**(-1) - 48*S1**(-2)*
     +    T1**(-1)*NS*MG2**2*MS2**2 - 96*S1**(-2)*T1**(-1)*NS*MG2**3*
     +    MS2 - 48*S1**(-2)*T1**(-1)*NS*MG2**4 + 48*S1**(-2)*T1**(-1)*
     +    MG2**2*MS2**2 + 96*S1**(-2)*T1**(-1)*MG2**3*MS2 + 48*S1**(-2)
     +    *T1**(-1)*MG2**4 - 48*S1**(-2)*U1**(-1)*NS*MG2**2*MS2**2 - 96
     +    *S1**(-2)*U1**(-1)*NS*MG2**3*MS2 - 48*S1**(-2)*U1**(-1)*NS*
     +    MG2**4 + 48*S1**(-2)*U1**(-1)*MG2**2*MS2**2 + 96*S1**(-2)*
     +    U1**(-1)*MG2**3*MS2 + 48*S1**(-2)*U1**(-1)*MG2**4 - 48*
     +    S1**(-2)*NS*MG2*MS2**2 - 96*S1**(-2)*NS*MG2**2*MS2 - 48*
     +    S1**(-2)*NS*MG2**3 + 48*S1**(-2)*MG2*MS2**2 + 96*S1**(-2)*
     +    MG2**2*MS2 + 48*S1**(-2)*MG2**3 + 20*S1**(-1)*T1**(-1)*NS*MG2
     +    *MS2**2 + 72*S1**(-1)*T1**(-1)*NS*MG2**2*MS2 + 36*S1**(-1)*
     +    T1**(-1)*NS*MG2**3 - 20*S1**(-1)*T1**(-1)*MG2*MS2**2 - 72*
     +    S1**(-1)*T1**(-1)*MG2**2*MS2 - 36*S1**(-1)*T1**(-1)*MG2**3 + 
     +    4*S1**(-1)*U1**(-1)*NS*MG2*MS2**2 + 40*S1**(-1)*U1**(-1)*NS*
     +    MG2**2*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CO * ( 20*S1**(-1)*U1**(-1)*NS*MG2**3
     +     - 4*S1**(-1)*U1**(-1)*MG2*MS2**2 - 40*S1**(-1)*U1**(-1)*
     +    MG2**2*MS2 - 20*S1**(-1)*U1**(-1)*MG2**3 + 32*S1**(-1)*NS*MG2
     +    *MS2 + 16*S1**(-1)*NS*MG2**2 - 32*S1**(-1)*MG2*MS2 - 16*
     +    S1**(-1)*MG2**2 - 8*T1**(-1)*NS*MG2*MS2 - 8*T1**(-1)*NS*
     +    MG2**2 - 4*T1**(-1)*NS*MS2**2 + 8*T1**(-1)*MG2*MS2 + 8*
     +    T1**(-1)*MG2**2 + 4*T1**(-1)*MS2**2 - 4*U1**(-1)*NS*MG2**2 + 
     +    4*U1**(-1)*MG2**2 - 8*NS*MG2 + 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(4)*CQED * ( 2*S*TG*T1**(-1) - 2*S*TG*
     +    U1**(-1) + 16*S*S1**(-1)*T1**(-1)*MG2*MS2 + 16*S*S1**(-1)*
     +    T1**(-1)*MG2**2 - 16*S*S1**(-1)*U1**(-1)*MG2*MS2 - 16*S*
     +    S1**(-1)*U1**(-1)*MG2**2 + 2*S*T1**(-1)*MG2 + 2*S*T1**(-1)*
     +    MS2 + 10*S*U1**(-1)*MG2 + 2*S*U1**(-1)*MS2 - 2*S**2*U1**(-1)
     +     + 16*TG*S1**(-1)*T1**(-1)*MG2*MS2 + 16*TG*S1**(-1)*T1**(-1)*
     +    MG2**2 - 16*TG*S1**(-1)*U1**(-1)*MG2*MS2 - 16*TG*S1**(-1)*
     +    U1**(-1)*MG2**2 - 8*TG*T1**(-1)*MG2 + 8*TG*U1**(-1)*MG2 - 32*
     +    S1**(-1)*T1**(-1)*MG2**2*MS2 - 32*S1**(-1)*T1**(-1)*MG2**3 + 
     +    32*S1**(-1)*U1**(-1)*MG2**2*MS2 + 32*S1**(-1)*U1**(-1)*MG2**3
     +     + 8*T1**(-1)*MG2*MS2 + 8*T1**(-1)*MG2**2 - 8*U1**(-1)*MG2*
     +    MS2 - 8*U1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * ( 64*S**(-2)*TG**2*S1**(-1)*MS2*
     +    MT2 - 32*S**(-2)*TG**2*S1**(-1)*MS2**2 - 32*S**(-2)*TG**2*
     +    S1**(-1)*MT2**2 - 8*S**(-2)*TG**2*MG2 + 16*S**(-2)*TG**2*MS2
     +     - 16*S**(-2)*TG**2*MT2 + 64*S**(-1)*TG*S1**(-1)*MS2*MT2 - 32
     +    *S**(-1)*TG*S1**(-1)*MS2**2 - 32*S**(-1)*TG*S1**(-1)*MT2**2
     +     - 8*S**(-1)*TG*MG2 + 16*S**(-1)*TG*MS2 - 16*S**(-1)*TG*MT2
     +     + 96*S**(-1)*TG**2*S1**(-2)*MS2*MT2 - 48*S**(-1)*TG**2*
     +    S1**(-2)*MS2**2 - 48*S**(-1)*TG**2*S1**(-2)*MT2**2 + 16*
     +    S**(-1)*TG**2*S1**(-1)*T1**(-1)*MS2*MT2 - 8*S**(-1)*TG**2*
     +    S1**(-1)*T1**(-1)*MS2**2 - 8*S**(-1)*TG**2*S1**(-1)*T1**(-1)*
     +    MT2**2 + 16*S**(-1)*TG**2*S1**(-1)*U1**(-1)*MS2*MT2 - 8*
     +    S**(-1)*TG**2*S1**(-1)*U1**(-1)*MS2**2 - 8*S**(-1)*TG**2*
     +    S1**(-1)*U1**(-1)*MT2**2 - 8*S**(-1)*TG**2*S1**(-1)*MS2 + 24*
     +    S**(-1)*TG**2*S1**(-1)*MT2 - 2*S**(-1)*TG**2*T1**(-1)*MG2 + 4
     +    *S**(-1)*TG**2*T1**(-1)*MS2 - 4*S**(-1)*TG**2*T1**(-1)*MT2 - 
     +    2*S**(-1)*TG**2*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * ( 4*S**(-1)*TG**2*U1**(-1)*MS2
     +     - 4*S**(-1)*TG**2*U1**(-1)*MT2 - S**(-1)*TG**2 + 16*S**(-1)*
     +    MG2*MS2 - 16*S**(-1)*MG2*MT2 - 8*S**(-1)*MG2**2 + 16*S**(-1)*
     +    MS2*MT2 - 8*S**(-1)*MS2**2 - 8*S**(-1)*MT2**2 - 48*S*TG*
     +    S1**(-2)*T1**(-1)*MG2*MS2 + 48*S*TG*S1**(-2)*T1**(-1)*MG2*MT2
     +     - 24*S*TG*S1**(-2)*T1**(-1)*MG2**2 + 48*S*TG*S1**(-2)*
     +    T1**(-1)*MS2*MT2 - 24*S*TG*S1**(-2)*T1**(-1)*MS2**2 - 24*S*TG
     +    *S1**(-2)*T1**(-1)*MT2**2 - 48*S*TG*S1**(-2)*U1**(-1)*MG2*MS2
     +     + 48*S*TG*S1**(-2)*U1**(-1)*MG2*MT2 - 24*S*TG*S1**(-2)*
     +    U1**(-1)*MG2**2 + 48*S*TG*S1**(-2)*U1**(-1)*MS2*MT2 - 24*S*TG
     +    *S1**(-2)*U1**(-1)*MS2**2 - 24*S*TG*S1**(-2)*U1**(-1)*MT2**2
     +     - 24*S*TG*S1**(-2)*MG2 - 48*S*TG*S1**(-2)*MS2 + 48*S*TG*
     +    S1**(-2)*MT2 + 4*S*TG*S1**(-1)*T1**(-1)*MG2 + 8*S*TG*S1**(-1)
     +    *T1**(-1)*MS2 + 4*S*TG*S1**(-1)*U1**(-1)*MG2 + 8*S*TG*
     +    S1**(-1)*U1**(-1)*MS2 - 2*S*TG*S1**(-1) - 96*S*S1**(-2)*
     +    T1**(-1)*MG2*MS2*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * ( 48*S*S1**(-2)*T1**(-1)*MG2*
     +    MS2**2 + 48*S*S1**(-2)*T1**(-1)*MG2*MT2**2 + 96*S*S1**(-2)*
     +    T1**(-1)*MG2**2*MS2 - 96*S*S1**(-2)*T1**(-1)*MG2**2*MT2 + 48*
     +    S*S1**(-2)*T1**(-1)*MG2**3 - 96*S*S1**(-2)*U1**(-1)*MG2*MS2*
     +    MT2 + 48*S*S1**(-2)*U1**(-1)*MG2*MS2**2 + 48*S*S1**(-2)*
     +    U1**(-1)*MG2*MT2**2 + 96*S*S1**(-2)*U1**(-1)*MG2**2*MS2 - 96*
     +    S*S1**(-2)*U1**(-1)*MG2**2*MT2 + 48*S*S1**(-2)*U1**(-1)*
     +    MG2**3 + 96*S*S1**(-2)*MG2*MS2 - 96*S*S1**(-2)*MG2*MT2 + 48*S
     +    *S1**(-2)*MG2**2 - 48*S*S1**(-1)*T1**(-1)*MG2*MS2 + 32*S*
     +    S1**(-1)*T1**(-1)*MG2*MT2 - 24*S*S1**(-1)*T1**(-1)*MG2**2 + 
     +    32*S*S1**(-1)*T1**(-1)*MS2*MT2 - 16*S*S1**(-1)*T1**(-1)*
     +    MS2**2 - 16*S*S1**(-1)*T1**(-1)*MT2**2 - 32*S*S1**(-1)*
     +    U1**(-1)*MG2*MS2 + 16*S*S1**(-1)*U1**(-1)*MG2*MT2 - 16*S*
     +    S1**(-1)*U1**(-1)*MG2**2 + 16*S*S1**(-1)*U1**(-1)*MS2*MT2 - 8
     +    *S*S1**(-1)*U1**(-1)*MS2**2 - 8*S*S1**(-1)*U1**(-1)*MT2**2 - 
     +    8*S*S1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * (  - 24*S*S1**(-1)*MS2 + 24*S*
     +    S1**(-1)*MT2 + 2*S*T1**(-1)*MG2 + 4*S*T1**(-1)*MS2 - 2*S*
     +    U1**(-1)*MG2 + 4*S*U1**(-1)*MS2 - 4*S*U1**(-1)*MT2 - S - 24*
     +    S**2*S1**(-2)*T1**(-1)*MG2*MS2 + 24*S**2*S1**(-2)*T1**(-1)*
     +    MG2*MT2 - 12*S**2*S1**(-2)*T1**(-1)*MG2**2 + 24*S**2*S1**(-2)
     +    *T1**(-1)*MS2*MT2 - 12*S**2*S1**(-2)*T1**(-1)*MS2**2 - 12*
     +    S**2*S1**(-2)*T1**(-1)*MT2**2 - 24*S**2*S1**(-2)*U1**(-1)*MG2
     +    *MS2 + 24*S**2*S1**(-2)*U1**(-1)*MG2*MT2 - 12*S**2*S1**(-2)*
     +    U1**(-1)*MG2**2 + 24*S**2*S1**(-2)*U1**(-1)*MS2*MT2 - 12*S**2
     +    *S1**(-2)*U1**(-1)*MS2**2 - 12*S**2*S1**(-2)*U1**(-1)*MT2**2
     +     - 12*S**2*S1**(-2)*MG2 - 24*S**2*S1**(-2)*MS2 + 24*S**2*
     +    S1**(-2)*MT2 + 2*S**2*S1**(-1)*T1**(-1)*MG2 + 4*S**2*S1**(-1)
     +    *T1**(-1)*MS2 + 2*S**2*S1**(-1)*U1**(-1)*MG2 + 4*S**2*
     +    S1**(-1)*U1**(-1)*MS2 - S**2*S1**(-1) - 96*TG*S1**(-2)*
     +    T1**(-1)*MG2*MS2*MT2 + 48*TG*S1**(-2)*T1**(-1)*MG2*MS2**2 + 
     +    48*TG*S1**(-2)*T1**(-1)*MG2*MT2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * ( 96*TG*S1**(-2)*T1**(-1)*MG2**2
     +    *MS2 - 96*TG*S1**(-2)*T1**(-1)*MG2**2*MT2 + 48*TG*S1**(-2)*
     +    T1**(-1)*MG2**3 - 96*TG*S1**(-2)*U1**(-1)*MG2*MS2*MT2 + 48*TG
     +    *S1**(-2)*U1**(-1)*MG2*MS2**2 + 48*TG*S1**(-2)*U1**(-1)*MG2*
     +    MT2**2 + 96*TG*S1**(-2)*U1**(-1)*MG2**2*MS2 - 96*TG*S1**(-2)*
     +    U1**(-1)*MG2**2*MT2 + 48*TG*S1**(-2)*U1**(-1)*MG2**3 + 96*TG*
     +    S1**(-2)*MG2*MS2 - 96*TG*S1**(-2)*MG2*MT2 + 48*TG*S1**(-2)*
     +    MG2**2 + 96*TG*S1**(-2)*MS2*MT2 - 48*TG*S1**(-2)*MS2**2 - 48*
     +    TG*S1**(-2)*MT2**2 - 48*TG*S1**(-1)*T1**(-1)*MG2*MS2 + 32*TG*
     +    S1**(-1)*T1**(-1)*MG2*MT2 - 24*TG*S1**(-1)*T1**(-1)*MG2**2 + 
     +    48*TG*S1**(-1)*T1**(-1)*MS2*MT2 - 24*TG*S1**(-1)*T1**(-1)*
     +    MS2**2 - 24*TG*S1**(-1)*T1**(-1)*MT2**2 - 32*TG*S1**(-1)*
     +    U1**(-1)*MG2*MS2 + 16*TG*S1**(-1)*U1**(-1)*MG2*MT2 - 16*TG*
     +    S1**(-1)*U1**(-1)*MG2**2 + 32*TG*S1**(-1)*U1**(-1)*MS2*MT2 - 
     +    16*TG*S1**(-1)*U1**(-1)*MS2**2 - 16*TG*S1**(-1)*U1**(-1)*
     +    MT2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * (  - 8*TG*S1**(-1)*MG2 - 32*TG*
     +    S1**(-1)*MS2 + 48*TG*S1**(-1)*MT2 + 4*TG*T1**(-1)*MG2 + 8*TG*
     +    T1**(-1)*MS2 - 4*TG*U1**(-1)*MG2 + 8*TG*U1**(-1)*MS2 - 8*TG*
     +    U1**(-1)*MT2 - 2*TG - 24*TG**2*S1**(-2)*T1**(-1)*MG2*MS2 + 24
     +    *TG**2*S1**(-2)*T1**(-1)*MG2*MT2 - 12*TG**2*S1**(-2)*T1**(-1)
     +    *MG2**2 + 24*TG**2*S1**(-2)*T1**(-1)*MS2*MT2 - 12*TG**2*
     +    S1**(-2)*T1**(-1)*MS2**2 - 12*TG**2*S1**(-2)*T1**(-1)*MT2**2
     +     - 24*TG**2*S1**(-2)*U1**(-1)*MG2*MS2 + 24*TG**2*S1**(-2)*
     +    U1**(-1)*MG2*MT2 - 12*TG**2*S1**(-2)*U1**(-1)*MG2**2 + 24*
     +    TG**2*S1**(-2)*U1**(-1)*MS2*MT2 - 12*TG**2*S1**(-2)*U1**(-1)*
     +    MS2**2 - 12*TG**2*S1**(-2)*U1**(-1)*MT2**2 - 12*TG**2*
     +    S1**(-2)*MG2 - 24*TG**2*S1**(-2)*MS2 + 24*TG**2*S1**(-2)*MT2
     +     + 2*TG**2*S1**(-1)*T1**(-1)*MG2 + 4*TG**2*S1**(-1)*T1**(-1)*
     +    MS2 + 2*TG**2*S1**(-1)*U1**(-1)*MG2 + 4*TG**2*S1**(-1)*
     +    U1**(-1)*MS2 - TG**2*S1**(-1) + 96*S1**(-2)*T1**(-1)*MG2**2*
     +    MS2*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * (  - 48*S1**(-2)*T1**(-1)*MG2**2
     +    *MS2**2 - 48*S1**(-2)*T1**(-1)*MG2**2*MT2**2 - 96*S1**(-2)*
     +    T1**(-1)*MG2**3*MS2 + 96*S1**(-2)*T1**(-1)*MG2**3*MT2 - 48*
     +    S1**(-2)*T1**(-1)*MG2**4 + 96*S1**(-2)*U1**(-1)*MG2**2*MS2*
     +    MT2 - 48*S1**(-2)*U1**(-1)*MG2**2*MS2**2 - 48*S1**(-2)*
     +    U1**(-1)*MG2**2*MT2**2 - 96*S1**(-2)*U1**(-1)*MG2**3*MS2 + 96
     +    *S1**(-2)*U1**(-1)*MG2**3*MT2 - 48*S1**(-2)*U1**(-1)*MG2**4
     +     + 96*S1**(-2)*MG2*MS2*MT2 - 48*S1**(-2)*MG2*MS2**2 - 48*
     +    S1**(-2)*MG2*MT2**2 - 96*S1**(-2)*MG2**2*MS2 + 96*S1**(-2)*
     +    MG2**2*MT2 - 48*S1**(-2)*MG2**3 - 40*S1**(-1)*T1**(-1)*MG2*
     +    MS2*MT2 + 20*S1**(-1)*T1**(-1)*MG2*MS2**2 + 20*S1**(-1)*
     +    T1**(-1)*MG2*MT2**2 + 72*S1**(-1)*T1**(-1)*MG2**2*MS2 - 56*
     +    S1**(-1)*T1**(-1)*MG2**2*MT2 + 36*S1**(-1)*T1**(-1)*MG2**3 - 
     +    8*S1**(-1)*U1**(-1)*MG2*MS2*MT2 + 4*S1**(-1)*U1**(-1)*MG2*
     +    MS2**2 + 4*S1**(-1)*U1**(-1)*MG2*MT2**2 + 40*S1**(-1)*
     +    U1**(-1)*MG2**2*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(5)*CO * (  - 24*S1**(-1)*U1**(-1)*MG2**2
     +    *MT2 + 20*S1**(-1)*U1**(-1)*MG2**3 + 32*S1**(-1)*MG2*MS2 - 16
     +    *S1**(-1)*MG2*MT2 + 16*S1**(-1)*MG2**2 - 8*T1**(-1)*MG2*MS2
     +     + 4*T1**(-1)*MG2*MT2 - 8*T1**(-1)*MG2**2 + 8*T1**(-1)*MS2*
     +    MT2 - 4*T1**(-1)*MS2**2 - 4*T1**(-1)*MT2**2 - 4*U1**(-1)*MG2*
     +    MT2 - 4*U1**(-1)*MG2**2 - 8*MG2 - 8*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * (  - 64*S**(-2)*TG**2*S1**(-1)*
     +    MS2*MT2 + 32*S**(-2)*TG**2*S1**(-1)*MS2**2 + 32*S**(-2)*TG**2
     +    *S1**(-1)*MT2**2 - 8*S**(-2)*TG**2*MG2 - 64*S**(-1)*TG*
     +    S1**(-1)*MS2*MT2 + 32*S**(-1)*TG*S1**(-1)*MS2**2 + 32*S**(-1)
     +    *TG*S1**(-1)*MT2**2 - 8*S**(-1)*TG*MG2 - 96*S**(-1)*TG**2*
     +    S1**(-2)*MS2*MT2 + 48*S**(-1)*TG**2*S1**(-2)*MS2**2 + 48*
     +    S**(-1)*TG**2*S1**(-2)*MT2**2 - 16*S**(-1)*TG**2*S1**(-1)*
     +    T1**(-1)*MS2*MT2 + 8*S**(-1)*TG**2*S1**(-1)*T1**(-1)*MS2**2
     +     + 8*S**(-1)*TG**2*S1**(-1)*T1**(-1)*MT2**2 - 16*S**(-1)*
     +    TG**2*S1**(-1)*U1**(-1)*MS2*MT2 + 8*S**(-1)*TG**2*S1**(-1)*
     +    U1**(-1)*MS2**2 + 8*S**(-1)*TG**2*S1**(-1)*U1**(-1)*MT2**2 - 
     +    24*S**(-1)*TG**2*S1**(-1)*MS2 + 8*S**(-1)*TG**2*S1**(-1)*MT2
     +     - 2*S**(-1)*TG**2*T1**(-1)*MG2 - 2*S**(-1)*TG**2*U1**(-1)*
     +    MG2 + S**(-1)*TG**2 - 8*S**(-1)*MG2**2 - 16*S**(-1)*MS2*MT2
     +     + 8*S**(-1)*MS2**2 + 8*S**(-1)*MT2**2 - 48*S*TG*S1**(-2)*
     +    T1**(-1)*MG2*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * ( 48*S*TG*S1**(-2)*T1**(-1)*MG2*
     +    MT2 + 24*S*TG*S1**(-2)*T1**(-1)*MG2**2 - 48*S*TG*S1**(-2)*
     +    T1**(-1)*MS2*MT2 + 24*S*TG*S1**(-2)*T1**(-1)*MS2**2 + 24*S*TG
     +    *S1**(-2)*T1**(-1)*MT2**2 - 48*S*TG*S1**(-2)*U1**(-1)*MG2*MS2
     +     + 48*S*TG*S1**(-2)*U1**(-1)*MG2*MT2 + 24*S*TG*S1**(-2)*
     +    U1**(-1)*MG2**2 - 48*S*TG*S1**(-2)*U1**(-1)*MS2*MT2 + 24*S*TG
     +    *S1**(-2)*U1**(-1)*MS2**2 + 24*S*TG*S1**(-2)*U1**(-1)*MT2**2
     +     + 24*S*TG*S1**(-2)*MG2 - 48*S*TG*S1**(-2)*MS2 + 48*S*TG*
     +    S1**(-2)*MT2 - 4*S*TG*S1**(-1)*T1**(-1)*MG2 - 8*S*TG*S1**(-1)
     +    *T1**(-1)*MT2 - 4*S*TG*S1**(-1)*U1**(-1)*MG2 - 8*S*TG*
     +    S1**(-1)*U1**(-1)*MT2 + 2*S*TG*S1**(-1) + 96*S*S1**(-2)*
     +    T1**(-1)*MG2*MS2*MT2 - 48*S*S1**(-2)*T1**(-1)*MG2*MS2**2 - 48
     +    *S*S1**(-2)*T1**(-1)*MG2*MT2**2 + 96*S*S1**(-2)*T1**(-1)*
     +    MG2**2*MS2 - 96*S*S1**(-2)*T1**(-1)*MG2**2*MT2 - 48*S*
     +    S1**(-2)*T1**(-1)*MG2**3 + 96*S*S1**(-2)*U1**(-1)*MG2*MS2*MT2
     +     - 48*S*S1**(-2)*U1**(-1)*MG2*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * (  - 48*S*S1**(-2)*U1**(-1)*MG2*
     +    MT2**2 + 96*S*S1**(-2)*U1**(-1)*MG2**2*MS2 - 96*S*S1**(-2)*
     +    U1**(-1)*MG2**2*MT2 - 48*S*S1**(-2)*U1**(-1)*MG2**3 + 96*S*
     +    S1**(-2)*MG2*MS2 - 96*S*S1**(-2)*MG2*MT2 - 48*S*S1**(-2)*
     +    MG2**2 - 32*S*S1**(-1)*T1**(-1)*MG2*MS2 + 48*S*S1**(-1)*
     +    T1**(-1)*MG2*MT2 + 24*S*S1**(-1)*T1**(-1)*MG2**2 - 32*S*
     +    S1**(-1)*T1**(-1)*MS2*MT2 + 16*S*S1**(-1)*T1**(-1)*MS2**2 + 
     +    16*S*S1**(-1)*T1**(-1)*MT2**2 - 16*S*S1**(-1)*U1**(-1)*MG2*
     +    MS2 + 32*S*S1**(-1)*U1**(-1)*MG2*MT2 + 16*S*S1**(-1)*U1**(-1)
     +    *MG2**2 - 16*S*S1**(-1)*U1**(-1)*MS2*MT2 + 8*S*S1**(-1)*
     +    U1**(-1)*MS2**2 + 8*S*S1**(-1)*U1**(-1)*MT2**2 + 8*S*S1**(-1)
     +    *MG2 - 24*S*S1**(-1)*MS2 + 24*S*S1**(-1)*MT2 - 2*S*T1**(-1)*
     +    MG2 - 4*S*T1**(-1)*MT2 - 2*S*U1**(-1)*MG2 + S - 24*S**2*
     +    S1**(-2)*T1**(-1)*MG2*MS2 + 24*S**2*S1**(-2)*T1**(-1)*MG2*MT2
     +     + 12*S**2*S1**(-2)*T1**(-1)*MG2**2 - 24*S**2*S1**(-2)*
     +    T1**(-1)*MS2*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * ( 12*S**2*S1**(-2)*T1**(-1)*
     +    MS2**2 + 12*S**2*S1**(-2)*T1**(-1)*MT2**2 - 24*S**2*S1**(-2)*
     +    U1**(-1)*MG2*MS2 + 24*S**2*S1**(-2)*U1**(-1)*MG2*MT2 + 12*
     +    S**2*S1**(-2)*U1**(-1)*MG2**2 - 24*S**2*S1**(-2)*U1**(-1)*MS2
     +    *MT2 + 12*S**2*S1**(-2)*U1**(-1)*MS2**2 + 12*S**2*S1**(-2)*
     +    U1**(-1)*MT2**2 + 12*S**2*S1**(-2)*MG2 - 24*S**2*S1**(-2)*MS2
     +     + 24*S**2*S1**(-2)*MT2 - 2*S**2*S1**(-1)*T1**(-1)*MG2 - 4*
     +    S**2*S1**(-1)*T1**(-1)*MT2 - 2*S**2*S1**(-1)*U1**(-1)*MG2 - 4
     +    *S**2*S1**(-1)*U1**(-1)*MT2 + S**2*S1**(-1) + 96*TG*S1**(-2)*
     +    T1**(-1)*MG2*MS2*MT2 - 48*TG*S1**(-2)*T1**(-1)*MG2*MS2**2 - 
     +    48*TG*S1**(-2)*T1**(-1)*MG2*MT2**2 + 96*TG*S1**(-2)*T1**(-1)*
     +    MG2**2*MS2 - 96*TG*S1**(-2)*T1**(-1)*MG2**2*MT2 - 48*TG*
     +    S1**(-2)*T1**(-1)*MG2**3 + 96*TG*S1**(-2)*U1**(-1)*MG2*MS2*
     +    MT2 - 48*TG*S1**(-2)*U1**(-1)*MG2*MS2**2 - 48*TG*S1**(-2)*
     +    U1**(-1)*MG2*MT2**2 + 96*TG*S1**(-2)*U1**(-1)*MG2**2*MS2 - 96
     +    *TG*S1**(-2)*U1**(-1)*MG2**2*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * (  - 48*TG*S1**(-2)*U1**(-1)*
     +    MG2**3 + 96*TG*S1**(-2)*MG2*MS2 - 96*TG*S1**(-2)*MG2*MT2 - 48
     +    *TG*S1**(-2)*MG2**2 - 96*TG*S1**(-2)*MS2*MT2 + 48*TG*S1**(-2)
     +    *MS2**2 + 48*TG*S1**(-2)*MT2**2 - 32*TG*S1**(-1)*T1**(-1)*MG2
     +    *MS2 + 48*TG*S1**(-1)*T1**(-1)*MG2*MT2 + 24*TG*S1**(-1)*
     +    T1**(-1)*MG2**2 - 48*TG*S1**(-1)*T1**(-1)*MS2*MT2 + 24*TG*
     +    S1**(-1)*T1**(-1)*MS2**2 + 24*TG*S1**(-1)*T1**(-1)*MT2**2 - 
     +    16*TG*S1**(-1)*U1**(-1)*MG2*MS2 + 32*TG*S1**(-1)*U1**(-1)*MG2
     +    *MT2 + 16*TG*S1**(-1)*U1**(-1)*MG2**2 - 32*TG*S1**(-1)*
     +    U1**(-1)*MS2*MT2 + 16*TG*S1**(-1)*U1**(-1)*MS2**2 + 16*TG*
     +    S1**(-1)*U1**(-1)*MT2**2 + 8*TG*S1**(-1)*MG2 - 48*TG*S1**(-1)
     +    *MS2 + 32*TG*S1**(-1)*MT2 - 4*TG*T1**(-1)*MG2 - 8*TG*T1**(-1)
     +    *MT2 - 4*TG*U1**(-1)*MG2 + 2*TG - 24*TG**2*S1**(-2)*T1**(-1)*
     +    MG2*MS2 + 24*TG**2*S1**(-2)*T1**(-1)*MG2*MT2 + 12*TG**2*
     +    S1**(-2)*T1**(-1)*MG2**2 - 24*TG**2*S1**(-2)*T1**(-1)*MS2*MT2
     +     + 12*TG**2*S1**(-2)*T1**(-1)*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * ( 12*TG**2*S1**(-2)*T1**(-1)*
     +    MT2**2 - 24*TG**2*S1**(-2)*U1**(-1)*MG2*MS2 + 24*TG**2*
     +    S1**(-2)*U1**(-1)*MG2*MT2 + 12*TG**2*S1**(-2)*U1**(-1)*MG2**2
     +     - 24*TG**2*S1**(-2)*U1**(-1)*MS2*MT2 + 12*TG**2*S1**(-2)*
     +    U1**(-1)*MS2**2 + 12*TG**2*S1**(-2)*U1**(-1)*MT2**2 + 12*
     +    TG**2*S1**(-2)*MG2 - 24*TG**2*S1**(-2)*MS2 + 24*TG**2*
     +    S1**(-2)*MT2 - 2*TG**2*S1**(-1)*T1**(-1)*MG2 - 4*TG**2*
     +    S1**(-1)*T1**(-1)*MT2 - 2*TG**2*S1**(-1)*U1**(-1)*MG2 - 4*
     +    TG**2*S1**(-1)*U1**(-1)*MT2 + TG**2*S1**(-1) - 96*S1**(-2)*
     +    T1**(-1)*MG2**2*MS2*MT2 + 48*S1**(-2)*T1**(-1)*MG2**2*MS2**2
     +     + 48*S1**(-2)*T1**(-1)*MG2**2*MT2**2 - 96*S1**(-2)*T1**(-1)*
     +    MG2**3*MS2 + 96*S1**(-2)*T1**(-1)*MG2**3*MT2 + 48*S1**(-2)*
     +    T1**(-1)*MG2**4 - 96*S1**(-2)*U1**(-1)*MG2**2*MS2*MT2 + 48*
     +    S1**(-2)*U1**(-1)*MG2**2*MS2**2 + 48*S1**(-2)*U1**(-1)*MG2**2
     +    *MT2**2 - 96*S1**(-2)*U1**(-1)*MG2**3*MS2 + 96*S1**(-2)*
     +    U1**(-1)*MG2**3*MT2 )
     +
      M2QBSV = M2QBSV + SK1C0B(6)*CO * ( 48*S1**(-2)*U1**(-1)*MG2**4 - 
     +    96*S1**(-2)*MG2*MS2*MT2 + 48*S1**(-2)*MG2*MS2**2 + 48*
     +    S1**(-2)*MG2*MT2**2 - 96*S1**(-2)*MG2**2*MS2 + 96*S1**(-2)*
     +    MG2**2*MT2 + 48*S1**(-2)*MG2**3 + 40*S1**(-1)*T1**(-1)*MG2*
     +    MS2*MT2 - 20*S1**(-1)*T1**(-1)*MG2*MS2**2 - 20*S1**(-1)*
     +    T1**(-1)*MG2*MT2**2 + 56*S1**(-1)*T1**(-1)*MG2**2*MS2 - 72*
     +    S1**(-1)*T1**(-1)*MG2**2*MT2 - 36*S1**(-1)*T1**(-1)*MG2**3 + 
     +    8*S1**(-1)*U1**(-1)*MG2*MS2*MT2 - 4*S1**(-1)*U1**(-1)*MG2*
     +    MS2**2 - 4*S1**(-1)*U1**(-1)*MG2*MT2**2 + 24*S1**(-1)*
     +    U1**(-1)*MG2**2*MS2 - 40*S1**(-1)*U1**(-1)*MG2**2*MT2 - 20*
     +    S1**(-1)*U1**(-1)*MG2**3 + 16*S1**(-1)*MG2*MS2 - 32*S1**(-1)*
     +    MG2*MT2 - 16*S1**(-1)*MG2**2 - 8*T1**(-1)*MG2*MS2 + 12*
     +    T1**(-1)*MG2*MT2 + 4*T1**(-1)*MG2**2 - 8*T1**(-1)*MS2*MT2 + 4
     +    *T1**(-1)*MS2**2 + 4*T1**(-1)*MT2**2 + 4*U1**(-1)*MG2*MT2 + 8
     +    *MT2 )
     +
      M2QBSV = M2QBSV + SK1C0C(3,1)*N*CO * (  - 8*S**(-1)*TG*MG2 - 8*
     +    S**(-1)*TG**2 - 8*S**(-1)*TG**3*T1**(-1) - 12*TG*T1**(-1)*MG2
     +     - 4*TG - 8*TG**3*T1**(-2) )
     +
      M2QBSV = M2QBSV + SK1C0C(3,1)*N*CK * (  - 8*S*TG*T1**(-1)*
     +    U1**(-1)*MG2 - 4*S*TG*U1**(-1) + 4*TG*T1**(-1)*MG2 - 4*TG*
     +    U1**(-1)*MG2 + 4*TG*U1**(-1)*MS2 - 4*TG**2*U1**(-1) + 8*TG**3
     +    *T1**(-2) )
     +
      M2QBSV = M2QBSV + SK1C0C(3,2)*N*CO * ( 8*S**(-1)*TG*MG2 - 8*
     +    S**(-1)*TG**2 + 8*S**(-1)*TG**3*U1**(-1) + 24*S*TG*U1**(-1)
     +     + 24*S*TG**2*U1**(-2) + 12*S*U1**(-1)*MG2 - 4*S + 24*S**2*TG
     +    *U1**(-2) + 8*S**2*U1**(-1) + 8*S**3*U1**(-2) + 12*TG*
     +    U1**(-1)*MG2 - 12*TG + 24*TG**2*U1**(-1) + 8*TG**3*U1**(-2)
     +     + 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(3,2)*N*CK * ( 8*S*TG*T1**(-1)*U1**(-1)*
     +    MG2 - 4*S*TG*T1**(-1) - 24*S*TG**2*U1**(-2) + 4*S*T1**(-1)*
     +    MG2 - 4*S*T1**(-1)*MS2 - 4*S*U1**(-1)*MG2 - 24*S**2*TG*
     +    U1**(-2) + 8*S**2*T1**(-1)*U1**(-1)*MG2 - 8*S**3*U1**(-2) + 4
     +    *TG*T1**(-1)*MG2 - 4*TG*T1**(-1)*MS2 - 4*TG*U1**(-1)*MG2 - 4*
     +    TG**2*T1**(-1) - 8*TG**3*U1**(-2) )
     +
      M2QBSV = M2QBSV + SK1C0C(4,1)*N*CK * (  - 4*S**(-1)*TG*MG2 + 4*
     +    S**(-1)*TG*MS2 + 8*S**(-1)*TG**2*T1**(-1)*MG2 - 8*S**(-1)*
     +    TG**2*T1**(-1)*MS2 - 4*S**(-1)*TG**2 + 8*S*T1**(-1)*U1**(-1)*
     +    MG2*MS2 - 8*S*T1**(-1)*U1**(-1)*MG2**2 + 8*S*U1**(-1)*MG2 - 8
     +    *TG*T1**(-1)*MG2 + 8*TG*T1**(-1)*MS2 + 4*TG*U1**(-1)*MG2 + 16
     +    *TG**2*T1**(-2)*MG2 - 16*TG**2*T1**(-2)*MS2 - 8*TG**2*
     +    T1**(-1) - 8*T1**(-1)*MG2*MS2 + 8*T1**(-1)*MG2**2 - 8*MG2 )
     +
      M2QBSV = M2QBSV + SK1C0C(4,1)*CQED * (  - 8*S*T1**(-1)*U1**(-1)*
     +    MG2*MS2 + 8*S*T1**(-1)*U1**(-1)*MG2**2 - 8*S*U1**(-1)*MG2 + 4
     +    *TG*T1**(-1)*MG2 - 4*TG*T1**(-1)*MS2 - 8*TG**2*T1**(-2)*MG2
     +     + 8*TG**2*T1**(-2)*MS2 + 4*TG**2*T1**(-1) )
     +
      M2QBSV = M2QBSV + SK1C0C(4,2)*N*CK * ( 4*S**(-1)*TG*MG2 - 4*
     +    S**(-1)*TG*MS2 + 8*S**(-1)*TG**2*U1**(-1)*MG2 - 8*S**(-1)*
     +    TG**2*U1**(-1)*MS2 - 4*S**(-1)*TG**2 + 32*S*TG*U1**(-2)*MG2
     +     - 32*S*TG*U1**(-2)*MS2 - 16*S*TG*U1**(-1) + 8*S*T1**(-1)*
     +    U1**(-1)*MG2*MS2 - 8*S*T1**(-1)*U1**(-1)*MG2**2 + 4*S*
     +    T1**(-1)*MG2 + 16*S*U1**(-1)*MG2 - 16*S*U1**(-1)*MS2 - 4*S + 
     +    16*S**2*U1**(-2)*MG2 - 16*S**2*U1**(-2)*MS2 - 8*S**2*U1**(-1)
     +     - 4*TG*T1**(-1)*MG2 + 24*TG*U1**(-1)*MG2 - 24*TG*U1**(-1)*
     +    MS2 - 8*TG + 16*TG**2*U1**(-2)*MG2 - 16*TG**2*U1**(-2)*MS2 - 
     +    8*TG**2*U1**(-1) - 8*U1**(-1)*MG2*MS2 + 8*U1**(-1)*MG2**2 - 4
     +    *MG2 - 4*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0C(4,2)*CQED * (  - 16*S*TG*U1**(-2)*MG2 + 
     +    16*S*TG*U1**(-2)*MS2 + 8*S*TG*U1**(-1) - 8*S*T1**(-1)*
     +    U1**(-1)*MG2*MS2 + 8*S*T1**(-1)*U1**(-1)*MG2**2 - 8*S*
     +    T1**(-1)*MG2 - 4*S*U1**(-1)*MG2 + 4*S*U1**(-1)*MS2 - 8*S**2*
     +    U1**(-2)*MG2 + 8*S**2*U1**(-2)*MS2 + 4*S**2*U1**(-1) - 4*TG*
     +    U1**(-1)*MG2 + 4*TG*U1**(-1)*MS2 - 8*TG**2*U1**(-2)*MG2 + 8*
     +    TG**2*U1**(-2)*MS2 + 4*TG**2*U1**(-1) )
     +
      M2QBSV = M2QBSV + SK1C0C(5,1)*N*CO * ( 8*S**(-1)*TG*T1**(-1)*MG2*
     +    MS2 - 8*S**(-1)*TG*T1**(-1)*MG2**2 - 4*S**(-1)*TG*MG2 - 4*
     +    S**(-1)*TG*MS2 + 8*S**(-1)*TG**2*T1**(-1)*MS2 + 4*S**(-1)*
     +    TG**2 + 8*TG**(-1)*T1**(-1)*MG2**2*MS2 - 8*TG**(-1)*T1**(-1)*
     +    MG2**3 + 8*TG*T1**(-2)*MG2*MS2 - 8*TG*T1**(-2)*MG2**2 + 4*TG*
     +    T1**(-1)*MG2 - 4*TG*T1**(-1)*MS2 + 8*TG**2*T1**(-2)*MS2 + 4*
     +    TG**2*T1**(-1) + 8*T1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0C(5,1)*N*CK * ( 8*S*TG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2*MS2 - 8*S*TG**(-1)*T1**(-1)*U1**(-1)*MG2**3
     +     + 8*S*T1**(-1)*U1**(-1)*MG2*MS2 - 8*TG*T1**(-2)*MG2*MS2 + 8*
     +    TG*T1**(-2)*MG2**2 - 4*TG*T1**(-1)*MG2 + 4*TG*T1**(-1)*MS2 - 
     +    4*TG*U1**(-1)*MG2 - 8*TG**2*T1**(-2)*MS2 - 4*TG**2*T1**(-1)
     +     + 8*T1**(-1)*MG2*MS2 - 8*T1**(-1)*MG2**2 + 8*U1**(-1)*MG2*
     +    MS2 - 8*U1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0C(5,2)*N*CO * (  - 8*S**(-1)*TG*U1**(-1)*
     +    MG2*MS2 + 8*S**(-1)*TG*U1**(-1)*MG2**2 + 4*S**(-1)*TG*MG2 + 4
     +    *S**(-1)*TG*MS2 + 8*S**(-1)*TG**2*U1**(-1)*MS2 + 4*S**(-1)*
     +    TG**2 + 16*S*TG*U1**(-2)*MS2 + 8*S*TG*U1**(-1) - 8*S*U1**(-2)
     +    *MG2*MS2 + 8*S*U1**(-2)*MG2**2 - 4*S*U1**(-1)*MG2 + 12*S*
     +    U1**(-1)*MS2 + 4*S + 8*S**2*U1**(-2)*MS2 + 4*S**2*U1**(-1) - 
     +    8*TG*U1**(-2)*MG2*MS2 + 8*TG*U1**(-2)*MG2**2 - 4*TG*U1**(-1)*
     +    MG2 + 20*TG*U1**(-1)*MS2 + 8*TG + 8*TG**2*U1**(-2)*MS2 + 4*
     +    TG**2*U1**(-1) + 8*UG**(-1)*U1**(-1)*MG2**2*MS2 - 8*UG**(-1)*
     +    U1**(-1)*MG2**3 - 8*U1**(-1)*MG2*MS2 + 16*U1**(-1)*MG2**2 + 4
     +    *MG2 + 4*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0C(5,2)*N*CK * (  - 16*S*TG*U1**(-2)*MS2 - 
     +    8*S*TG*U1**(-1) + 8*S*UG**(-1)*T1**(-1)*U1**(-1)*MG2**2*MS2
     +     - 8*S*UG**(-1)*T1**(-1)*U1**(-1)*MG2**3 + 8*S*T1**(-1)*
     +    U1**(-1)*MG2*MS2 + 4*S*T1**(-1)*MG2 + 8*S*U1**(-2)*MG2*MS2 - 
     +    8*S*U1**(-2)*MG2**2 + 4*S*U1**(-1)*MG2 - 4*S*U1**(-1)*MS2 - 8
     +    *S**2*U1**(-2)*MS2 - 4*S**2*U1**(-1) + 4*TG*T1**(-1)*MG2 + 8*
     +    TG*U1**(-2)*MG2*MS2 - 8*TG*U1**(-2)*MG2**2 + 4*TG*U1**(-1)*
     +    MG2 - 4*TG*U1**(-1)*MS2 - 8*TG**2*U1**(-2)*MS2 - 4*TG**2*
     +    U1**(-1) + 8*T1**(-1)*MG2*MS2 - 8*T1**(-1)*MG2**2 + 8*
     +    U1**(-1)*MG2*MS2 - 8*U1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0C(6,1)*N*CK * ( 8*S**(-1)*TG*T1**(-1)*MG2*
     +    MS2 - 8*S**(-1)*TG*T1**(-1)*MG2**2 - 8*S**(-1)*TG*MG2 + 8*
     +    S**(-1)*TG*MS2 + 8*S**(-1)*TG**2*T1**(-1)*MG2 - 8*S*TG**(-1)*
     +    T1**(-1)*U1**(-1)*MG2**2*MS2 + 8*S*TG**(-1)*T1**(-1)*U1**(-1)
     +    *MG2**3 - 8*S*TG**(-1)*U1**(-1)*MG2*MS2 + 8*S*TG**(-1)*
     +    U1**(-1)*MG2**2 + 4*S*TG*U1**(-1) - 8*S*T1**(-1)*U1**(-1)*
     +    MG2**2 + 8*TG**(-1)*T1**(-1)*MG2**2*MS2 - 8*TG**(-1)*T1**(-1)
     +    *MG2**3 + 8*TG**(-1)*MG2*MS2 - 8*TG**(-1)*MG2**2 + 16*TG*
     +    T1**(-2)*MG2*MS2 - 16*TG*T1**(-2)*MG2**2 - 8*TG*T1**(-1)*MG2
     +     + 4*TG*U1**(-1)*MG2 - 4*TG*U1**(-1)*MS2 - 4*TG + 16*TG**2*
     +    T1**(-2)*MG2 + 4*TG**2*U1**(-1) - 16*T1**(-1)*MG2*MS2 + 24*
     +    T1**(-1)*MG2**2 - 8*U1**(-1)*MG2*MS2 + 8*U1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0C(6,1)*CQED * ( 8*S*TG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2*MS2 - 8*S*TG**(-1)*T1**(-1)*U1**(-1)*MG2**3
     +     + 8*S*TG**(-1)*U1**(-1)*MG2*MS2 - 8*S*TG**(-1)*U1**(-1)*
     +    MG2**2 - 4*S*TG*U1**(-1) + 8*S*T1**(-1)*U1**(-1)*MG2**2 - 8*
     +    TG*T1**(-2)*MG2*MS2 + 8*TG*T1**(-2)*MG2**2 + 4*TG*T1**(-1)*
     +    MG2 - 4*TG*U1**(-1)*MG2 + 8*TG*U1**(-1)*MS2 - 8*TG**2*
     +    T1**(-2)*MG2 + 8*T1**(-1)*MG2*MS2 - 8*T1**(-1)*MG2**2 + 8*
     +    U1**(-1)*MG2*MS2 - 8*U1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1C0C(6,2)*N*CK * (  - 8*S**(-1)*TG*U1**(-1)*
     +    MG2*MS2 + 8*S**(-1)*TG*U1**(-1)*MG2**2 + 8*S**(-1)*TG*MG2 - 8
     +    *S**(-1)*TG*MS2 + 8*S**(-1)*TG**2*U1**(-1)*MG2 + 4*S*TG*
     +    T1**(-1) + 32*S*TG*U1**(-2)*MG2 - 8*S*UG**(-1)*T1**(-1)*
     +    U1**(-1)*MG2**2*MS2 + 8*S*UG**(-1)*T1**(-1)*U1**(-1)*MG2**3
     +     - 8*S*UG**(-1)*T1**(-1)*MG2*MS2 + 8*S*UG**(-1)*T1**(-1)*
     +    MG2**2 - 8*S*T1**(-1)*U1**(-1)*MG2**2 - 4*S*T1**(-1)*MG2 + 4*
     +    S*T1**(-1)*MS2 - 16*S*U1**(-2)*MG2*MS2 + 16*S*U1**(-2)*MG2**2
     +     + 16*S*U1**(-1)*MG2 + 4*S + 16*S**2*U1**(-2)*MG2 - 4*TG*
     +    T1**(-1)*MG2 + 4*TG*T1**(-1)*MS2 - 16*TG*U1**(-2)*MG2*MS2 + 
     +    16*TG*U1**(-2)*MG2**2 + 24*TG*U1**(-1)*MG2 + 4*TG + 4*TG**2*
     +    T1**(-1) + 16*TG**2*U1**(-2)*MG2 + 8*UG**(-1)*U1**(-1)*MG2**2
     +    *MS2 - 8*UG**(-1)*U1**(-1)*MG2**3 + 8*UG**(-1)*MG2*MS2 - 8*
     +    UG**(-1)*MG2**2 - 8*T1**(-1)*MG2*MS2 + 8*T1**(-1)*MG2**2 - 24
     +    *U1**(-1)*MG2*MS2 + 32*U1**(-1)*MG2**2 + 8*MG2 - 8*MS2 )
     +
      M2QBSV = M2QBSV + SK1C0C(6,2)*CQED * ( 4*S*TG*T1**(-1) - 16*S*TG*
     +    U1**(-2)*MG2 + 8*S*UG**(-1)*T1**(-1)*U1**(-1)*MG2**2*MS2 - 8*
     +    S*UG**(-1)*T1**(-1)*U1**(-1)*MG2**3 + 8*S*UG**(-1)*T1**(-1)*
     +    MG2*MS2 - 8*S*UG**(-1)*T1**(-1)*MG2**2 + 8*S*T1**(-1)*
     +    U1**(-1)*MG2**2 + 4*S*T1**(-1)*MG2 - 8*S*T1**(-1)*MS2 + 8*S*
     +    U1**(-2)*MG2*MS2 - 8*S*U1**(-2)*MG2**2 - 4*S*U1**(-1)*MG2 + 4
     +    *S**2*T1**(-1) - 8*S**2*U1**(-2)*MG2 + 4*TG*T1**(-1)*MG2 - 8*
     +    TG*T1**(-1)*MS2 + 8*TG*U1**(-2)*MG2*MS2 - 8*TG*U1**(-2)*
     +    MG2**2 - 4*TG*U1**(-1)*MG2 - 8*TG**2*U1**(-2)*MG2 + 8*
     +    T1**(-1)*MG2*MS2 - 8*T1**(-1)*MG2**2 + 8*U1**(-1)*MG2*MS2 - 8
     +    *U1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(1,1)*N*CO * (  - 8*S**(-1)*TG**3 - 2*S*TG
     +    *T1**(-1)*MG2 - 2*S*TG - 4*TG*MG2 - 4*TG**2 - 4*TG**3*
     +    T1**(-1) )
     +
      M2QBSV = M2QBSV + SK1D0(1,2)*N*CO * ( 8*S**(-1)*TG**3 + 2*S*TG*
     +    U1**(-1)*MG2 + 18*S*TG + 12*S*TG**2*U1**(-1) + 4*S*MG2 + 12*
     +    S**2*TG*U1**(-1) + 2*S**2*U1**(-1)*MG2 + 6*S**2 + 4*S**3*
     +    U1**(-1) + 4*TG*MG2 + 20*TG**2 + 4*TG**3*U1**(-1) )
     +
      M2QBSV = M2QBSV + SK1D0(4,1)*N*CK * ( 2*S*TG**2*T1**(-1) - 4*S*
     +    T1**(-1)*MG2*MS2 + 2*S*T1**(-1)*MG2**2 + 2*S*T1**(-1)*MS2**2
     +     + 4*S*MG2 + 2*TG**2 - 4*MG2*MS2 + 2*MG2**2 + 2*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(4,1)*CQED * (  - 2*S*TG**2*T1**(-1) + 4*S
     +    *T1**(-1)*MG2*MS2 - 2*S*T1**(-1)*MG2**2 - 2*S*T1**(-1)*MS2**2
     +     + 4*S**2*U1**(-1)*MG2 )
     +
      M2QBSV = M2QBSV + SK1D0(4,2)*N*CK * ( 4*S*TG + 2*S*TG**2*U1**(-1)
     +     - 4*S*U1**(-1)*MG2*MS2 + 2*S*U1**(-1)*MG2**2 + 2*S*U1**(-1)*
     +    MS2**2 + 4*S*MG2 + 4*S**2*TG*U1**(-1) + 2*S**2 + 2*S**3*
     +    U1**(-1) + 2*TG**2 - 4*MG2*MS2 + 2*MG2**2 + 2*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(4,2)*CQED * (  - 2*S*TG**2*U1**(-1) + 4*S
     +    *U1**(-1)*MG2*MS2 - 2*S*U1**(-1)*MG2**2 - 2*S*U1**(-1)*MS2**2
     +     - 4*S**2*TG*U1**(-1) + 4*S**2*T1**(-1)*MG2 - 2*S**3*U1**(-1)
     +     )
     +
      M2QBSV = M2QBSV + SK1D0(7,1)*N*CO * ( 8*S**(-1)*TG*MG2*MS2 - 8*
     +    S**(-1)*TG*MG2**2 - 2*S*TG**2*T1**(-1) + 4*S*T1**(-1)*MG2*MS2
     +     - 2*S*T1**(-1)*MG2**2 - 2*S*T1**(-1)*MS2**2 - 4*S*MG2 - 4*TG
     +    *MG2 + 4*TG**2*T1**(-1)*MG2 - 2*TG**2 + 4*T1**(-1)*MG2*MS2**2
     +     - 8*T1**(-1)*MG2**2*MS2 + 4*T1**(-1)*MG2**3 + 8*MG2*MS2 + 2*
     +    MG2**2 - 2*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(7,2)*N*CO * (  - 8*S**(-1)*TG*MG2*MS2 + 8
     +    *S**(-1)*TG*MG2**2 + 8*S*TG*U1**(-1)*MG2 - 4*S*TG - 2*S*TG**2
     +    *U1**(-1) + 4*S*U1**(-1)*MG2*MS2 - 2*S*U1**(-1)*MG2**2 - 2*S*
     +    U1**(-1)*MS2**2 - 4*S**2*TG*U1**(-1) + 4*S**2*U1**(-1)*MG2 - 
     +    2*S**2 - 2*S**3*U1**(-1) + 4*TG*MG2 + 4*TG**2*U1**(-1)*MG2 - 
     +    2*TG**2 + 4*U1**(-1)*MG2*MS2**2 - 8*U1**(-1)*MG2**2*MS2 + 4*
     +    U1**(-1)*MG2**3 + 10*MG2**2 - 2*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(8,1)*N*CK * ( 12*S*TG*U1**(-1)*MG2 - 4*S*
     +    TG**2*T1**(-1) + 8*S*T1**(-1)*MG2*MS2 - 4*S*T1**(-1)*MG2**2
     +     - 4*S*T1**(-1)*MS2**2 - 4*S*U1**(-1)*MG2*MS2 + 4*S*U1**(-1)*
     +    MG2**2 + 8*S**2*U1**(-1)*MG2 + 8*TG*T1**(-1)*MG2*MS2 - 4*TG*
     +    T1**(-1)*MG2**2 - 4*TG*T1**(-1)*MS2**2 - 4*TG*U1**(-1)*MG2*
     +    MS2 + 4*TG*U1**(-1)*MG2**2 + 4*TG**2*U1**(-1)*MG2 - 4*TG**3*
     +    T1**(-1) )
     +
      M2QBSV = M2QBSV + SK1D0(8,2)*N*CK * (  - 4*S*TG*T1**(-1)*MG2 + 8*
     +    S*TG**2*U1**(-1) + 4*S**2*TG*U1**(-1) + 4*TG*T1**(-1)*MG2*MS2
     +     - 4*TG*T1**(-1)*MG2**2 - 8*TG*U1**(-1)*MG2*MS2 + 4*TG*
     +    U1**(-1)*MG2**2 + 4*TG*U1**(-1)*MS2**2 + 4*TG**2*T1**(-1)*MG2
     +     + 4*TG**3*U1**(-1) )
     +
      M2QBSV = M2QBSV + SK1D0(9,1)*N*CK * (  - 8*S**(-1)*TG*MG2*MS2 + 4
     +    *S**(-1)*TG*MG2**2 + 4*S**(-1)*TG*MS2**2 + 2*S*TG*T1**(-1)*
     +    MG2 + 2*S*TG - 4*TG*T1**(-1)*MG2*MS2 + 4*TG*T1**(-1)*MG2**2
     +     + 4*TG*MG2 - 8*TG*MS2 - 4*T1**(-1)*MG2*MS2**2 + 8*T1**(-1)*
     +    MG2**2*MS2 - 4*T1**(-1)*MG2**3 + 4*MG2**2 - 4*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(9,1)*CQED * (  - 2*S*TG*T1**(-1)*MG2 + 2*
     +    S*TG*U1**(-1)*MG2 - 8*S*TG*U1**(-1)*MS2 + 4*S*U1**(-1)*MG2**2
     +     - 4*S*U1**(-1)*MS2**2 + 2*S**2*TG*U1**(-1) + 4*TG*T1**(-1)*
     +    MG2*MS2 - 4*TG*T1**(-1)*MG2**2 - 4*TG*U1**(-1)*MG2*MS2 + 4*TG
     +    *U1**(-1)*MS2**2 + 4*T1**(-1)*MG2*MS2**2 - 8*T1**(-1)*MG2**2*
     +    MS2 + 4*T1**(-1)*MG2**3 + 4*U1**(-1)*MG2*MS2**2 - 8*U1**(-1)*
     +    MG2**2*MS2 + 4*U1**(-1)*MG2**3 )
     +
      M2QBSV = M2QBSV + SK1D0(9,2)*N*CK * ( 8*S**(-1)*TG*MG2*MS2 - 4*
     +    S**(-1)*TG*MG2**2 - 4*S**(-1)*TG*MS2**2 - 2*S*TG*U1**(-1)*MG2
     +     - 2*S*TG + 4*S*U1**(-1)*MG2*MS2 - 4*S*U1**(-1)*MG2**2 - 4*S*
     +    MG2 + 8*S*MS2 - 2*S**2*U1**(-1)*MG2 - 2*S**2 + 4*TG*U1**(-1)*
     +    MG2*MS2 - 4*TG*U1**(-1)*MG2**2 - 4*TG*MG2 + 8*TG*MS2 - 4*
     +    U1**(-1)*MG2*MS2**2 + 8*U1**(-1)*MG2**2*MS2 - 4*U1**(-1)*
     +    MG2**3 + 8*MG2*MS2 - 8*MS2**2 )
     +
      M2QBSV = M2QBSV + SK1D0(9,2)*CQED * (  - 2*S*TG*T1**(-1)*MG2 + 8*
     +    S*TG*T1**(-1)*MS2 + 2*S*TG*U1**(-1)*MG2 + 4*S*T1**(-1)*MG2*
     +    MS2 + 4*S*T1**(-1)*MG2**2 - 8*S*T1**(-1)*MS2**2 - 4*S*
     +    U1**(-1)*MG2*MS2 + 4*S*U1**(-1)*MG2**2 - 2*S**2*TG*T1**(-1)
     +     - 2*S**2*T1**(-1)*MG2 + 8*S**2*T1**(-1)*MS2 + 2*S**2*
     +    U1**(-1)*MG2 - 2*S**3*T1**(-1) + 4*TG*T1**(-1)*MG2*MS2 - 4*TG
     +    *T1**(-1)*MS2**2 - 4*TG*U1**(-1)*MG2*MS2 + 4*TG*U1**(-1)*
     +    MG2**2 + 4*T1**(-1)*MG2*MS2**2 - 8*T1**(-1)*MG2**2*MS2 + 4*
     +    T1**(-1)*MG2**3 + 4*U1**(-1)*MG2*MS2**2 - 8*U1**(-1)*MG2**2*
     +    MS2 + 4*U1**(-1)*MG2**3 )
     +
      M2QBSV = M2QBSV + SOF1(1)*N*CO * (  - 128*S**(-2)*TG**2*MG2 - 128
     +    *S**(-1)*TG*MG2 - 64*S**(-1)*TG**2*T1**(-1)*MG2 - 64*S**(-1)*
     +    TG**2*U1**(-1)*MG2 + 64*S**(-1)*TG**2 - 128*S**(-1)*MG2**2 - 
     +    64*S*TG*U1**(-2)*MG2 + 64*S*TG*U1**(-1) + 16*S*TG**2*T1**(-2)
     +     + 16*S*TG**2*U1**(-2) + 32*S*T1**(-1)*MG2 - 32*S*U1**(-1)*
     +    MG2 + 32*S + 32*S**2*TG*U1**(-2) - 32*S**2*U1**(-2)*MG2 + 32*
     +    S**2*U1**(-1) + 16*S**3*U1**(-2) - 128*TG*U1**(-1)*MG2 + 64*
     +    TG - 32*TG**2*T1**(-2)*MG2 + 32*TG**2*T1**(-1) - 32*TG**2*
     +    U1**(-2)*MG2 + 32*TG**2*U1**(-1) - 64*T1**(-1)*MG2**2 - 64*
     +    U1**(-1)*MG2**2 )
     +
      M2QBSV = M2QBSV + SOF1(2)*N*CO * (  - 128*S**(-2)*TG**2*MG2 - 128
     +    *S**(-1)*TG*MG2 - 64*S**(-1)*TG**2*T1**(-1)*MG2 - 64*S**(-1)*
     +    TG**2*U1**(-1)*MG2 - 128*S**(-1)*MG2**2 - 64*S*TG*U1**(-2)*
     +    MG2 - 64*S*U1**(-1)*MG2 - 32*S**2*U1**(-2)*MG2 - 128*TG*
     +    U1**(-1)*MG2 - 32*TG**2*T1**(-2)*MG2 - 32*TG**2*U1**(-2)*MG2
     +     - 64*T1**(-1)*MG2**2 - 64*U1**(-1)*MG2**2 - 64*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(2)*N*CK * ( 64*S*TG*U1**(-2)*MG2 - 64*S*
     +    T1**(-1)*U1**(-1)*MG2**2 + 32*S**2*U1**(-2)*MG2 + 32*TG**2*
     +    T1**(-2)*MG2 + 32*TG**2*U1**(-2)*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(3)*N*CO * (  - 128*S**(-2)*TG**2*MG2 - 128
     +    *S**(-1)*TG*MG2 - 64*S**(-1)*TG**2*T1**(-1)*MG2 - 64*S**(-1)*
     +    TG**2*U1**(-1)*MG2 - 128*S**(-1)*MG2**2 - 64*S*TG*U1**(-2)*
     +    MG2 - 64*S*U1**(-1)*MG2 - 32*S**2*U1**(-2)*MG2 - 128*TG*
     +    U1**(-1)*MG2 - 32*TG**2*T1**(-2)*MG2 - 32*TG**2*U1**(-2)*MG2
     +     - 64*T1**(-1)*MG2**2 - 64*U1**(-1)*MG2**2 - 64*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(3)*N*CK * ( 64*S*TG*U1**(-2)*MG2 - 64*S*
     +    T1**(-1)*U1**(-1)*MG2**2 + 32*S**2*U1**(-2)*MG2 + 32*TG**2*
     +    T1**(-2)*MG2 + 32*TG**2*U1**(-2)*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(4)*N*CO * (  - 32*S**(-2)*TG**3 - 32*
     +    S**(-1)*TG*MG2 - 64*S**(-1)*TG**2 - 32*S**(-1)*TG**3*U1**(-1)
     +     - 96*S*TG*U1**(-1) - 48*S*TG**2*U1**(-2) - 32*S*U1**(-1)*MG2
     +     - 16*S - 48*S**2*TG*U1**(-2) - 32*S**2*U1**(-1) - 16*S**3*
     +    U1**(-2) - 32*TG*U1**(-1)*MG2 - 48*TG - 96*TG**2*U1**(-1) - 
     +    16*TG**3*U1**(-2) - 32*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(4)*N*CK * (  - 32*S*TG*T1**(-1)*U1**(-1)*
     +    MG2 + 16*S*TG**2*T1**(-2) + 48*S*TG**2*U1**(-2) + 48*S**2*TG*
     +    U1**(-2) - 32*S**2*T1**(-1)*U1**(-1)*MG2 + 16*S**3*U1**(-2)
     +     + 16*TG**3*T1**(-2) + 16*TG**3*U1**(-2) )
     +
      M2QBSV = M2QBSV + SOF1(5)*N*CO * ( 32*S**(-2)*TG**3 + 32*S**(-1)*
     +    TG*MG2 + 32*S**(-1)*TG**2 + 32*S**(-1)*TG**3*T1**(-1) + 32*TG
     +    *T1**(-1)*MG2 + 16*TG + 16*TG**3*T1**(-2) )
     +
      M2QBSV = M2QBSV + SOF1(5)*N*CK * ( 32*S*TG*T1**(-1)*U1**(-1)*MG2
     +     - 32*S*TG**2*U1**(-2) - 16*S**2*TG*U1**(-2) - 16*TG**3*
     +    T1**(-2) - 16*TG**3*U1**(-2) )
     +
      M2QBSV = M2QBSV + SOF1(6)*N*CO * ( 32*S**(-2)*TG**3 + 32*S**(-1)*
     +    TG*MG2 + 32*S**(-1)*TG**2 + 32*S**(-1)*TG**3*T1**(-1) + 32*TG
     +    *T1**(-1)*MG2 + 16*TG + 16*TG**3*T1**(-2) )
     +
      M2QBSV = M2QBSV + SOF1(6)*N*CK * ( 32*S*TG*T1**(-1)*U1**(-1)*MG2
     +     - 32*S*TG**2*U1**(-2) - 16*S**2*TG*U1**(-2) - 16*TG**3*
     +    T1**(-2) - 16*TG**3*U1**(-2) )
     +
      M2QBSV = M2QBSV + SOF1(7)*N*CO * (  - 32*S**(-2)*TG**3 - 32*
     +    S**(-1)*TG*MG2 - 64*S**(-1)*TG**2 - 32*S**(-1)*TG**3*U1**(-1)
     +     - 96*S*TG*U1**(-1) - 48*S*TG**2*U1**(-2) - 32*S*U1**(-1)*MG2
     +     - 16*S - 48*S**2*TG*U1**(-2) - 32*S**2*U1**(-1) - 16*S**3*
     +    U1**(-2) - 32*TG*U1**(-1)*MG2 - 48*TG - 96*TG**2*U1**(-1) - 
     +    16*TG**3*U1**(-2) - 32*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(7)*N*CK * (  - 32*S*TG*T1**(-1)*U1**(-1)*
     +    MG2 + 16*S*TG**2*T1**(-2) + 48*S*TG**2*U1**(-2) + 48*S**2*TG*
     +    U1**(-2) - 32*S**2*T1**(-1)*U1**(-1)*MG2 + 16*S**3*U1**(-2)
     +     + 16*TG**3*T1**(-2) + 16*TG**3*U1**(-2) )
     +
      M2QBSV = M2QBSV + SOF1(8)*N*CK * (  - 64*S**(-1)*TG**2 - 64*S*TG*
     +    U1**(-1) - 16*S*TG**2*T1**(-2) - 16*S*TG**2*U1**(-2) - 32*S*
     +    T1**(-1)*MG2 - 32*S*U1**(-1)*MG2 - 32*S - 32*S**2*TG*U1**(-2)
     +     - 32*S**2*U1**(-1) - 16*S**3*U1**(-2) - 64*TG - 32*TG**2*
     +    T1**(-1) - 32*TG**2*U1**(-1) - 64*MG2 )
     +
      M2QBSV = M2QBSV + SOF1(8)*CQED * ( 16*S*TG**2*T1**(-2) + 16*S*
     +    TG**2*U1**(-2) + 32*S**2*TG*U1**(-2) - 32*S**2*T1**(-1)*
     +    U1**(-1)*MG2 + 16*S**3*U1**(-2) )

      END IF


      DGGQBV = 
     +     0.5D0*ALPHAS**3 * AVG * M2QBSV /4.D0 /S**2 *CONV
     +    + ALPHAS/PI*DGGQBB(ALPHAS,S,TG,MS,MG) 
     +    * (LOG(MS2/MG2)*(-1.D0) + LOG(MT2/MG2)*(-1.D0/3.D0))
     +    +  DGGQBR(ALPHAS,S,TG,MS,MG)
C***  CHANGES TO SUBTRACTED MSBAR AND TO DRBAR FOR THE YUKAWA-COUPLING 
      RETURN
      END




      REAL*8 FUNCTION DGGQBH(ALPHAS,S,TG,S4G,MS,MG,EPS)
C***  HARD CROSS SECTION FOR Q + QB -> GL + GL +G
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4G,TG,UG,T1,U1,MS,MG,MS2,MG2,M2
      REAL*8 M2QBH
      REAL*8 NS,CONV,N,CO,CK,CQED,AVG,SYMBX,SYMBY,EPS
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 AHP1P1, ABP1P1, ABP1M1, ABP1P2, A4P2P2, A4P1P2, A4P1P1
      REAL*8 A4M1P2, A4M1P1, A4P0P2, A4P1P0, A4P2M2, A4M2P1
      REAL*8 A4M1P0
      REAL*8 ANG4(1:117), COLO1(1:9)
      
      CONV = 389379660.D0
      NS = 6.D0

      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      CQED = (N**4 -1.D0)/N**2

      AVG = (1.D0/2.D0)**2 /N**2

      MS2 = MS**2
      MG2 = MG**2
      M2 = MG2 - MS2
      UG = S4G -S -TG
      T1 = TG +M2
      U1 = UG +M2
      SYMBX = 1.D0/((UG-M2)**2 +EPS*MS**4)
      SYMBY = 1.D0/((TG-M2)**2 +EPS*MS**4)

      ANGDEF(1) = 2.D0*SQRT(S4G +MG2)
      ANGDEF(2) = (S +UG)/ANGDEF(1)
      ANGDEF(3) = (S +TG)/ANGDEF(1)
      ANGDEF(4) = S4G/ANGDEF(1)
      ANGDEF(5) = (S4G +2.D0*MG2)/ANGDEF(1)
      ANGDEF(6) = -(TG +UG +2.D0*MG2)/ANGDEF(1)
      ANGDEF(7) = SQRT((TG +UG)**2 -4.D0*MG2*S)/ANGDEF(1)
      ANGDEF(8) = 
     +  (TG*S4G -S*(UG+2.D0*MG2))/(S+TG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     +  (UG*S4G -S*(TG+2.D0*MG2))/(S+UG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(1,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)
      ANC(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(1,2) = -ANB(1,1)
      ANC(1,2) = -ANC(1,1)
      ANA(1,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(1,3) = -ANA(1,3)
      ANC(1,3) =  0.D0
      ANA(1,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(1,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)-2.D0*ANGDEF(3)*ANGDEF(4)
      ANC(1,4) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(1,5) = -ANB(1,3)
      ANC(1,5) = -ANC(1,3)
      ANA(1,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(1,6) = -ANB(1,4)
      ANC(1,6) = -ANC(1,4)
      ANA(1,7) = +ANA(1,1) +M2
      ANB(1,7) = +ANB(1,1)
      ANC(1,7) = +ANC(1,1)
      ANA(1,8) = +ANA(1,5) +M2
      ANB(1,8) = +ANB(1,5)
      ANC(1,8) = +ANC(1,5)
      ANA(1,9) = +ANA(1,6) +M2
      ANB(1,9) = +ANB(1,6)
      ANC(1,9) = +ANC(1,6)


      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)
      ANA(2,7) = +ANA(2,1) +M2
      ANB(2,7) = +ANB(2,1)
      ANC(2,7) = +ANC(2,1)
      ANA(2,8) = +ANA(2,5) +M2
      ANB(2,8) = +ANB(2,5)
      ANC(2,8) = +ANC(2,5)
      ANA(2,9) = +ANA(2,6) +M2
      ANB(2,9) = +ANB(2,6)
      ANC(2,9) = +ANC(2,6)


      ANA(3,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10)
      ANC(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(3,2) = -ANB(3,1)
      ANC(3,2) = -ANC(3,1)
      ANA(3,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(3,3) = 
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10) -2.D0*ANGDEF(2)*ANGDEF(4)
      ANC(3,3) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(3,4) = -ANA(3,4)
      ANC(3,4) =  0.D0
      ANA(3,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(3,5) = -ANB(3,3)
      ANC(3,5) = -ANC(3,3)
      ANA(3,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(3,6) = -ANB(3,4)
      ANC(3,6) = -ANC(3,4)
      ANA(3,7) = +ANA(3,1) +M2
      ANB(3,7) = +ANB(3,1)
      ANC(3,7) = +ANC(3,1)
      ANA(3,8) = +ANA(3,5) +M2
      ANB(3,8) = +ANB(3,5)
      ANC(3,8) = +ANC(3,5)
      ANA(3,9) = +ANA(3,6) +M2
      ANB(3,9) = +ANB(3,6)
      ANC(3,9) = +ANC(3,6)


C$$$      ANG4(1) = A4P2P2(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(2) = A4P1P2(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(3) = A4P1P2(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(4) = A4P1P1(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(5) = A4P2P2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(6) = A4P1P2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(7) = A4P1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
C$$$      ANG4(8) = A4P1P1(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(9) = A4P2M2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(10) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))

      ANG4(11) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(12) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(13) =A4P2M2(ANA(2,2),ANB(2,2),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(14) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(15) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(16) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(17) =A4P1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(18) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,2),ANB(1,2),ANC(1,2))
C$$$      ANG4(19) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(20) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))

C$$$      ANG4(21) =A4M1P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(22) =A4M1P2(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(23) =A4M2P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(24) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(25) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(26) =A4P1P2(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(27) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(28) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(29) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(30) =A4P1P2(ANA(3,9),ANB(3,9),ANA(3,7),ANB(3,7),ANC(3,7))

C$$$      ANG4(31) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(32) =A4M1P2(ANA(3,9),ANB(3,9),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(33) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(34) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(35) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
      ANG4(36) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(37) =A4P1P0(ANA(2,1),ANB(2,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(38) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(39) =A4P1P0(ANA(2,2),ANB(2,2),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(40) =A4P0P2(ANA(1,1),ANB(1,1),ANA(2,5),ANB(2,5),ANC(2,5))

C$$$      ANG4(41) =A4P1P0(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(42) =A4M1P0(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(43) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(44) =A4P1P0(ANA(3,6),ANB(3,6),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(45) =A4M1P0(ANA(3,6),ANB(3,6),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(46) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(47) =A4P1P0(ANA(2,7),ANB(2,7),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(48) =AHP1P1(ANA(1,3),ANB(1,3),ANA(1,4),ANB(1,4),ANC(1,4))
      ANG4(49) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(50) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,1),ANB(3,1),ANC(3,1))

C$$$      ANG4(51) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(52) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
C$$$      ANG4(53) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(54) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
C$$$      ANG4(55) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(56) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(57) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(58) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(59) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(60) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))

C$$$      ANG4(61) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(62) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(63) =ABP1M1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(64) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(65) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(66) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(67) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(68) =ABP1M1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(69) =ABP1M2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(70) =ABP2P0(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))

C$$$      ANG4(71) =ABP2P0(ANA(3,4),ANB(3,4),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(72) =A4P2P2(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
      ANG4(73) =A4P1P2(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
      ANG4(74) =A4P1P2(ANA(3,9),ANB(3,9),ANA(3,1),ANB(3,1),ANC(3,1))
      ANG4(75) =A4P1P1(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
      ANG4(76) =A4P1P1(ANA(3,9),ANB(3,9),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(77) =A4M1P2(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
      ANG4(78) =A4M1P1(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
      ANG4(79) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,9),ANB(1,9),ANC(1,9))
      ANG4(80) =A4P1P0(ANA(3,9),ANB(3,9),ANA(1,1),ANB(1,1),ANC(1,1))

      ANG4(81) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,9),ANB(1,9),ANC(1,9))
      ANG4(82) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(83) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(84) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,7),ANB(3,7),ANC(3,7))
      ANG4(85) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8)) 
      ANG4(86) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8)) 
      ANG4(87) =A4P2P2(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))
      ANG4(88) =A4P1P2(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))
      ANG4(89) =A4P1P2(ANA(1,8),ANB(1,8),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(90) =A4P1P1(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))

      ANG4(91) =A4P0P2(ANA(1,1),ANB(1,1),ANA(2,8),ANB(2,8),ANC(2,8))
      ANG4(92) =A4P1P0(ANA(1,8),ANB(1,8),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(93) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,8),ANB(3,8),ANC(3,8))
      ANG4(94) =A4P1P1(ANA(1,8),ANB(1,8),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(95) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(96) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(97) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(98) =A4P1P2(ANA(1,8),ANB(1,8),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(99) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))

C$$$      ANG4(100)=A4P2P2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(101)=A4P1P2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(102)=A4P1P2(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(103)=A4P1P1(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(104)=A4P1P1(ANA(1,8),ANB(1,8),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(105)=A4M2P1(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(106)=A4M1P2(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(107)=ABP1M2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(108)=A4P1P1(ANA(1,8),ANB(1,8),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(109)=A4M1P1(ANA(2,2),ANB(2,2),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(110)=A4M1P1(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))

C$$$      ANG4(111)=A4M1P2(ANA(1,3),ANB(1,3),ANA(1,8),ANB(1,8),ANC(1,8))
C$$$      ANG4(112)=A4M1P1(ANA(1,3),ANB(1,3),ANA(1,8),ANB(1,8),ANC(1,8))
C$$$      ANG4(113)=A4M1P2(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(114)=A4M1P1(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(115)=A4M1P2(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(116)=A4P2M2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(117)=A4P2M2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))

      COLO1(9) = LOG(S4G**2/MG2/(S4G+MG2))

      M2QBH = 0.D0
      M2QBH = M2QBH + N*CO*(S4G+MG2) * (  - 16*S**(-2)*TG**(-1)*UG**2*
     +    S4G**(-1) - 16*S**(-2)*TG*S4G**(-1) - 16*S**(-2)*TG**2*
     +    UG**(-1)*S4G**(-1) - 16*S**(-2)*UG*S4G**(-1) + 16*S**(-1)*
     +    TG**(-2)*UG*MG2*S4G**(-1) - 8*S**(-1)*TG**(-1)*UG*MG2*(TG-M2)
     +    *SYMBY*S4G**(-1) + 8*S**(-1)*TG**(-1)*UG*MS2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 24*S**(-1)*TG**(-1)*UG*S4G**(-1) + 4*S**(-1)*
     +    TG**(-1)*UG**2*U1**(-1)*(TG+UG)**(-1)*MG2*S4G**(-1) - 4*
     +    S**(-1)*TG**(-1)*UG**2*U1**(-1)*(TG+UG)**(-1)*MS2*S4G**(-1)
     +     - 4*S**(-1)*TG**(-1)*UG**2*U1**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*S**(-1)*TG**(-1)*UG**2*U1**(-1)*MS2*(TG-M2)*
     +    SYMBY*S4G**(-1) - 4*S**(-1)*TG**(-1)*UG**2*U1**(-1)*S4G**(-1)
     +     - 4*S**(-1)*TG**(-1)*UG**2*(TG+UG)**(-1)*S4G**(-1) + 4*
     +    S**(-1)*TG**(-1)*UG**3*U1**(-1)*(TG+UG)**(-1)*S4G**(-1) + 16*
     +    S**(-1)*TG**(-1)*MG2*S4G**(-1) + 16*S**(-1)*TG*UG**(-2)*MG2*
     +    S4G**(-1) - 16*S**(-1)*TG*UG**(-1)*S4G**(-1) + 4*S**(-1)*TG*
     +    UG*T1**(-1)*(S+UG)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * (  - 4*S**(-1)*TG*UG*T1**(-1)*
     +    (UG-M2)*SYMBX*S4G**(-1) + 4*S**(-1)*TG*UG*U1**(-1)*
     +    (S+TG)**(-1)*S4G**(-1) - 4*S**(-1)*TG*UG*U1**(-1)*(TG-M2)*
     +    SYMBY*S4G**(-1) + 6*S**(-1)*TG*UG*(S+TG)**(-2)*S4G**(-1) - 4*
     +    S**(-1)*TG*UG*(S+TG)**(-1)*(UG-M2)*SYMBX*S4G**(-1) - 2*
     +    S**(-1)*TG*UG*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*
     +    S**(-1)*TG*UG*(-M2*(S+UG)+TG*UG)**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*S**(-1)*TG*UG*(-M2*(S+UG)+TG*UG)**(-1)*MS2*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*S**(-1)*TG*UG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) + 4*
     +    S**(-1)*TG*UG*(-M2*(S+TG)+TG*UG)**(-1)*MS2*(UG-M2)*SYMBX*
     +    S4G**(-1) - 6*S**(-1)*TG*UG**2*(S+TG)**(-2)*S4G**(-2) + 6*
     +    S**(-1)*TG*UG**2*(S+UG)**(-2)*S4G**(-2) - 4*S**(-1)*TG*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*S**(-1)*
     +    TG*T1**(-1)*S4G**(-1) + 4*S**(-1)*TG*U1**(-1)*S4G**(-1) + 4*
     +    S**(-1)*TG*(S+TG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * (  - 4*S**(-1)*TG*(S+TG)**(-1)*
     +    MS2*(UG-M2)*SYMBX*S4G**(-1) + 14*S**(-1)*TG*(S+TG)**(-1)*
     +    S4G**(-1) - 8*S**(-1)*TG*(-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*
     +    (UG-M2)*SYMBX*S4G**(-1) + 4*S**(-1)*TG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*(UG-M2)*SYMBX*S4G**(-1) + 4*
     +    S**(-1)*TG*(-M2*(S+TG)+TG*UG)**(-1)*MS2**2*(UG-M2)*SYMBX*
     +    S4G**(-1) + 2*S**(-1)*TG*(TG-M2)*SYMBY*S4G**(-1) - 24*S**(-1)
     +    *TG*S4G**(-2) - 4*S**(-1)*TG**2*UG*(-M2*(S+TG)+TG*UG)**(-1)*
     +    (UG-M2)*SYMBX*S4G**(-1) - 4*S**(-1)*TG**2*T1**(-1)*(UG-M2)*
     +    SYMBX*S4G**(-1) + 4*S**(-1)*TG**2*U1**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) + 4*S**(-1)*TG**2*(-M2*(S+TG)+TG*UG)**(-1)*MG2*
     +    (UG-M2)*SYMBX*S4G**(-1) - 4*S**(-1)*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MS2*(UG-M2)*SYMBX*S4G**(-1) + 16*
     +    S**(-1)*UG**(-1)*MG2*S4G**(-1) + 4*S**(-1)*UG*T1**(-1)*
     +    S4G**(-1) - 4*S**(-1)*UG*U1**(-1)*MG2*S4G**(-2) + 4*S**(-1)*
     +    UG*U1**(-1)*MS2*S4G**(-2) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * ( 8*S**(-1)*UG*U1**(-1)*
     +    S4G**(-1) - 6*S**(-1)*UG*(S+TG)**(-1)*S4G**(-1) + 2*S**(-1)*
     +    UG*(S+UG)**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 2*S**(-1)*UG*
     +    (S+UG)**(-1)*MS2*(TG-M2)*SYMBY*S4G**(-1) + 6*S**(-1)*UG*
     +    (S+UG)**(-1)*S4G**(-1) - 8*S**(-1)*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*MS2*(TG-M2)*SYMBY*S4G**(-1) + 4*
     +    S**(-1)*UG*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*S**(-1)*UG*(-M2*(S+UG)+TG*UG)**(-1)*MS2**2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 8*S**(-1)*UG*(TG-M2)*SYMBY*
     +    S4G**(-1) - 4*S**(-1)*UG*(UG-M2)*SYMBX*S4G**(-1) - 20*S**(-1)
     +    *UG*S4G**(-2) + 4*S**(-1)*UG**2*T1**(-1)*(S+UG)**(-1)*
     +    S4G**(-1) - 4*S**(-1)*UG**2*U1**(-1)*S4G**(-2) + 6*S**(-1)*
     +    UG**2*(S+TG)**(-1)*S4G**(-2) + 6*S**(-1)*UG**2*(S+UG)**(-1)*
     +    S4G**(-2) + 4*S**(-1)*UG**2*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*S**(-1)*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * (  - 6*S**(-1)*MG2*(TG-M2)*SYMBY
     +    *S4G**(-1) + 6*S**(-1)*MS2*(TG-M2)*SYMBY*S4G**(-1) - 10*
     +    S**(-1)*S4G**(-1) + 6*S*TG**(-1)*UG*(TG+UG)**(-1)*S4G**(-2)
     +     - 6*S*TG**(-1)*S4G**(-2) - 4*S*TG*T1**(-2)*(S+UG)**(-1)*
     +    S4G**(-1) + 4*S*TG*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*
     +    (UG-M2)*SYMBX*S4G**(-1) + 4*S*TG*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*S*TG*(-M2*(S+TG)+TG*UG)**(-2)*MG2
     +    *S4G**(-1) + 4*S*TG*(-M2*(S+TG)+TG*UG)**(-2)*MS2*S4G**(-1) - 
     +    4*S*UG*U1**(-2)*(S+TG)**(-1)*S4G**(-1) + 4*S*UG*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 4*S*UG
     +    *(-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-1) + 4*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2*S4G**(-1) + 4*S*UG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*(UG-M2)*SYMBX*S4G**(-1) + 8*S*
     +    T1**(-1)*(S+UG)**(-1)*S4G**(-1) - 4*S*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*(UG-M2)*SYMBX*S4G**(-1) + 4*
     +    S*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2**2*(UG-M2)*SYMBX*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * ( 8*S*U1**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) - 4*S*U1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*MS2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 4*S*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*(TG-M2)*SYMBY*S4G**(-1) - 6*S
     +    *(TG+UG)**(-1)*S4G**(-2) + 8*S*(-M2*(S+UG)+TG*UG)**(-2)*MG2*
     +    MS2*S4G**(-1) - 4*S*(-M2*(S+UG)+TG*UG)**(-2)*MG2**2*S4G**(-1)
     +     - 4*S*(-M2*(S+UG)+TG*UG)**(-2)*MS2**2*S4G**(-1) + 4*S*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 4*S*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1) - 4*S*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2**2*S4G**(-1) - 4*S*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MS2**2*S4G**(-1) + 4*S*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) - 4*S*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) + 16*TG**(-2)*MG2*
     +    S4G**(-1) + 4*TG**(-1)*UG*U1**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * (  - 6*TG**(-1)*UG*(TG+UG)**(-1)
     +    *S4G**(-1) - 8*TG**(-1)*T1**(-1)*MG2*S4G**(-1) - 4*TG**(-1)*
     +    U1**(-1)*MG2*S4G**(-1) + 4*TG**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 10*TG**(-1)*S4G**(-1) + 4*TG*UG**(-1)*T1**(-1)*
     +    MG2*(UG-M2)*SYMBX*S4G**(-1) - 4*TG*UG*T1**(-2)*(S+UG)**(-1)*
     +    S4G**(-1) + 4*TG*UG*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*
     +    S4G**(-1) - 4*TG*UG*U1**(-2)*(S+TG)**(-1)*S4G**(-1) + 4*TG*UG
     +    *U1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 6*TG*UG*
     +    (S+UG)**(-2)*S4G**(-2) + 4*TG*UG*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) + 4*TG*UG*(-M2*(S+TG)+TG*UG)**(-1)*
     +    (UG-M2)*SYMBX*S4G**(-1) - 4*TG*UG**2*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*(UG-M2)*SYMBX*S4G**(-1) - 4*TG*
     +    T1**(-1)*(S+UG)**(-1)*S4G**(-1) - 8*TG*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 12*TG*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MS2*S4G**(-1) - 16*TG*T1**(-1)*
     +    S4G**(-2) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * ( 12*TG*U1**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) - 2*TG*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 2*TG*
     +    (S+UG)**(-1)*S4G**(-2) + 8*TG*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 8*TG*(-M2*(S+TG)+TG*UG)**(-2)*MG2*
     +    MS2*S4G**(-1) - 4*TG*(-M2*(S+TG)+TG*UG)**(-2)*MG2**2*
     +    S4G**(-1) - 4*TG*(-M2*(S+TG)+TG*UG)**(-2)*MS2**2*S4G**(-1) - 
     +    4*TG*(-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) + 4
     +    *TG*(-M2*(S+TG)+TG*UG)**(-1)*MS2*(UG-M2)*SYMBX*S4G**(-1) - 4*
     +    TG*(-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 4*TG**2*UG*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*TG**2*
     +    T1**(-2)*(S+UG)**(-1)*S4G**(-1) + 16*TG**2*T1**(-1)*
     +    (S+UG)**(-1)*S4G**(-2) - 4*TG**2*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) + 4*
     +    TG**2*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MS2*(UG-M2)*SYMBX*
     +    S4G**(-1) - 4*TG**2*(-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-1) + 
     +    4*TG**2*(-M2*(S+TG)+TG*UG)**(-2)*MS2*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * ( 16*UG**(-2)*MG2*S4G**(-1) - 4*
     +    UG**(-1)*T1**(-1)*MG2*S4G**(-1) - 8*UG**(-1)*U1**(-1)*MG2*
     +    S4G**(-1) + 4*UG**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) - 16*
     +    UG**(-1)*S4G**(-1) + 12*UG*T1**(-1)*(S+UG)**(-1)*S4G**(-1) + 
     +    4*UG*U1**(-1)*(TG+UG)**(-1)*MG2*S4G**(-2) - 4*UG*U1**(-1)*
     +    (TG+UG)**(-1)*MS2*S4G**(-2) - 4*UG*U1**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) - 8*UG*U1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) + 12*UG*U1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MS2*
     +    S4G**(-1) - 16*UG*U1**(-1)*S4G**(-2) - 4*UG*(TG+UG)**(-1)*
     +    S4G**(-2) + 4*UG*(S+TG)**(-1)*(UG-M2)*SYMBX*S4G**(-1) + 4*UG*
     +    (S+TG)**(-1)*S4G**(-2) + 6*UG*(S+UG)**(-1)*S4G**(-2) + 8*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1) - 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2**2*S4G**(-1) - 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2**2*S4G**(-1) - 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) + 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * (  - 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*UG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) - 4*
     +    UG**2*U1**(-2)*(S+TG)**(-1)*S4G**(-1) + 4*UG**2*U1**(-1)*
     +    (TG+UG)**(-1)*S4G**(-2) + 16*UG**2*U1**(-1)*(S+TG)**(-1)*
     +    S4G**(-2) - 4*UG**2*U1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 4*UG**2*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2*(TG-M2)*SYMBY*S4G**(-1) - 4*
     +    UG**2*(-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-1) + 4*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2*S4G**(-1) - 8*T1**(-1)*
     +    (S+UG)**(-1)*MG2*S4G**(-1) - 4*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*S4G**(-1) + 4*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-1) + 4*T1**(-1)*MG2*
     +    (UG-M2)*SYMBX*S4G**(-1) + 8*T1**(-1)*S4G**(-1) - 8*U1**(-1)*
     +    (S+TG)**(-1)*MG2*S4G**(-1) - 4*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*MS2*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * ( 4*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-1) + 4*U1**(-1)*MG2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 8*U1**(-1)*S4G**(-1) + 6*
     +    (TG+UG)**(-1)*S4G**(-1) - 4*(S+TG)**(-1)*MG2*(UG-M2)*SYMBX*
     +    S4G**(-1) + 4*(S+TG)**(-1)*MS2*(UG-M2)*SYMBX*S4G**(-1) + 4*
     +    (S+TG)**(-1)*S4G**(-1) + 2*(S+UG)**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 2*(S+UG)**(-1)*MS2*(TG-M2)*SYMBY*S4G**(-1) + 10*
     +    (S+UG)**(-1)*S4G**(-1) + 16*(-M2*(S+UG)+TG*UG)**(-1)*MG2*MS2*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) - 12*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 4*(-M2*(S+UG)+TG*UG)**(-1)*MS2**2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 16*(-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*(UG-M2)*SYMBX
     +    *S4G**(-1) - 4*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 12*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*(UG-M2)*SYMBX*S4G**(-1) - 4*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MS2**2*(UG-M2)*SYMBX*S4G**(-1) + 4*
     +    (TG-M2)*SYMBY*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO*(S4G+MG2) * ( 4*(UG-M2)*SYMBX*S4G**(-1) - 8*
     +    S4G**(-2) )
     +
      M2QBH = M2QBH + N*CO * (  - 64*S**(-2)*UG**2*MG2*S4G**(-2) - 4*
     +    S**(-1)*TG*UG**2*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) - 4*
     +    S**(-1)*TG*UG**2*(-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 2*
     +    S**(-1)*TG*(TG-M2)*SYMBY - 4*S**(-1)*TG**2*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) - 4*S**(-1)*TG**2*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S**(-1)*TG**2*UG**2*
     +    T1**(-1)*(S+UG)**(-2)*MG2*S4G**(-2) + 4*S**(-1)*TG**2*UG**2*
     +    T1**(-1)*(S+UG)**(-2)*S4G**(-1) + 4*S**(-1)*TG**2*UG**2*
     +    U1**(-1)*(S+TG)**(-2)*MG2*S4G**(-2) + 4*S**(-1)*TG**2*UG**2*
     +    U1**(-1)*(S+TG)**(-2)*S4G**(-1) + 4*S**(-1)*TG**2*UG**2*
     +    (S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) + 4*
     +    S**(-1)*TG**2*UG**2*(S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*
     +    S4G**(-1) + 4*S**(-1)*TG**2*UG**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) + 4*S**(-1)*TG**2*
     +    UG**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*
     +    S**(-1)*TG**2*T1**(-1)*MG2*S4G**(-2) )
     +
      M2QBH = M2QBH + N*CO * (  - 4*S**(-1)*TG**2*T1**(-1)*S4G**(-1) + 
     +    24*S**(-1)*UG*T1**(-1)*MG2*S4G**(-1) + 4*S**(-1)*UG*T1**(-1)
     +     + 4*S**(-1)*UG*U1**(-1)*MG2*S4G**(-1) + 8*S**(-1)*UG*
     +    U1**(-1) - 64*S**(-1)*UG*MG2*S4G**(-2) - 2*S**(-1)*UG*(UG-M2)
     +    *SYMBX + 8*S**(-1)*UG*S4G**(-1) - 32*S**(-1)*UG**2*T1**(-1)*
     +    MG2*S4G**(-2) - 8*S**(-1)*UG**2*T1**(-1)*S4G**(-1) - 36*
     +    S**(-1)*UG**2*U1**(-1)*MG2*S4G**(-2) - 12*S**(-1)*UG**2*
     +    U1**(-1)*S4G**(-1) + 8*S**(-1)*T1**(-1)*MG2 + 4*S**(-1)*
     +    U1**(-1)*MG2 + 2*S**(-1)*MG2*(TG-M2)*SYMBY + 2*S**(-1)*MG2*
     +    (UG-M2)*SYMBX - 64*S**(-1)*MG2*S4G**(-1) - 64*S**(-1)*MG2**2*
     +    S4G**(-2) - 2*S**(-1)*MS2*(TG-M2)*SYMBY - 2*S**(-1)*MS2*
     +    (UG-M2)*SYMBX - 8*S**(-1) + 8*S*TG**(-1)*MG2*S4G**(-2) + 8*S*
     +    TG**(-1)*S4G**(-1) - 8*S*TG*(-M2*(S+TG)+TG*UG)**(-1)*MG2*
     +    S4G**(-2) - 8*S*TG*(-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 4*S*
     +    TG**2*T1**(-1)*(S+UG)**(-2)*MG2*S4G**(-2) - 4*S*TG**2*
     +    T1**(-1)*(S+UG)**(-2)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO * ( 4*S*TG**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) + 4*S*TG**2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S*
     +    UG**(-1)*MG2*S4G**(-2) + 8*S*UG**(-1)*S4G**(-1) - 8*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) - 8*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S*UG**2*U1**(-1)*
     +    (S+TG)**(-2)*MG2*S4G**(-2) - 4*S*UG**2*U1**(-1)*(S+TG)**(-2)*
     +    S4G**(-1) + 4*S*UG**2*(S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*
     +    MG2*S4G**(-2) + 4*S*UG**2*(S+TG)**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 8*S*T1**(-1)*MG2*
     +    S4G**(-2) - 8*S*T1**(-1)*S4G**(-1) - 8*S*U1**(-1)*MG2*
     +    S4G**(-2) - 8*S*U1**(-1)*S4G**(-1) + 8*TG**(-1)*UG*MG2*
     +    S4G**(-2) + 8*TG**(-1)*UG*S4G**(-1) + 8*TG*UG**(-1)*MG2*
     +    S4G**(-2) + 8*TG*UG**(-1)*S4G**(-1) + 32*TG*T1**(-1)*MG2*
     +    S4G**(-2) + 12*TG*T1**(-1)*S4G**(-1) - 8*TG*U1**(-1)*MG2*
     +    S4G**(-2) )
     +
      M2QBH = M2QBH + N*CO * (  - 8*TG*U1**(-1)*S4G**(-1) + 8*TG*
     +    (S+UG)**(-1)*MG2*S4G**(-2) + 8*TG*(S+UG)**(-1)*S4G**(-1) - 16
     +    *TG**2*T1**(-2)*MG2*S4G**(-2) - 8*TG**2*T1**(-2)*S4G**(-1) - 
     +    4*TG**2*(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) - 4*TG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) - 8*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 40*UG*T1**(-1)*MG2*
     +    S4G**(-2) - 16*UG*T1**(-1)*S4G**(-1) + 8*UG*U1**(-1)*
     +    S4G**(-1) + 8*UG*(S+TG)**(-1)*MG2*S4G**(-2) + 8*UG*
     +    (S+TG)**(-1)*S4G**(-1) - 16*UG**2*U1**(-2)*MG2*S4G**(-2) - 8*
     +    UG**2*U1**(-2)*S4G**(-1) - 8*UG**2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    MG2*S4G**(-2) - 8*UG**2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 
     +    4*UG**2*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) - 4*UG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 32*T1**(-1)*MG2*
     +    S4G**(-1) - 32*T1**(-1)*MG2**2*S4G**(-2) - 24*U1**(-1)*MG2*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + N*CO * (  - 32*U1**(-1)*MG2**2*S4G**(-2) - 32*MG2
     +    *S4G**(-2) - 4*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 16*S**(-2)*TG**(-1)*UG**2*
     +    S4G**(-1) - 64*S**(-2)*TG*UG*S4G**(-2) + 48*S**(-2)*TG*
     +    S4G**(-1) + 16*S**(-2)*TG**2*UG**(-1)*S4G**(-1) - 32*S**(-2)*
     +    TG**2*S4G**(-2) + 48*S**(-2)*UG*S4G**(-1) - 32*S**(-2)*UG**2*
     +    S4G**(-2) - 16*S**(-1)*TG**(-2)*UG*MG2*S4G**(-1) + 12*S**(-1)
     +    *TG**(-1)*UG*MG2*(TG-M2)*SYMBY*S4G**(-1) - 12*S**(-1)*
     +    TG**(-1)*UG*MS2*(TG-M2)*SYMBY*S4G**(-1) + 28*S**(-1)*TG**(-1)
     +    *UG*S4G**(-1) - 16*S**(-1)*TG**(-1)*MG2*S4G**(-1) - 16*
     +    S**(-1)*TG*UG**(-2)*MG2*S4G**(-1) + 16*S**(-1)*TG*UG**(-1)*
     +    S4G**(-1) - 16*S**(-1)*TG*UG*T1**(-1)*S4G**(-2) + 4*S**(-1)*
     +    TG*UG*U1**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 16*S**(-1)*TG*UG*
     +    U1**(-1)*S4G**(-2) + 16*S**(-1)*TG*UG*(S+TG-M2)**(-1)*
     +    S4G**(-2) + 16*S**(-1)*TG*UG*(S+UG-M2)**(-1)*S4G**(-2) - 4*
     +    S**(-1)*TG*U1**(-1)*MG2*(S+TG-M2)**(-1)*S4G**(-1) + 4*S**(-1)
     +    *TG*U1**(-1)*MS2*(S+TG-M2)**(-1)*S4G**(-1) - 4*S**(-1)*TG*
     +    U1**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 8*S**(-1)*TG*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-2) - 8*S**(-1)*TG*MS2*(S+TG-M2)**(-1)*
     +    S4G**(-2) - 4*S**(-1)*TG*(S+TG-M2)**(-1)*S4G**(-1) - 4*
     +    S**(-1)*TG*(S+UG-M2)**(-1)*S4G**(-1) - 4*S**(-1)*TG*(TG-M2)*
     +    SYMBY*S4G**(-1) + 4*S**(-1)*TG*(UG-M2)*SYMBX*S4G**(-1) - 56*
     +    S**(-1)*TG*S4G**(-2) - 8*S**(-1)*TG**2*T1**(-1)*S4G**(-2) + 4
     +    *S**(-1)*TG**2*U1**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 8*S**(-1)
     +    *TG**2*U1**(-1)*S4G**(-2) + 8*S**(-1)*TG**2*(S+UG-M2)**(-1)*
     +    S4G**(-2) - 16*S**(-1)*UG**(-1)*MG2*S4G**(-1) - 4*S**(-1)*UG*
     +    U1**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) + 4*S**(-1)*UG*U1**(-1)*
     +    MS2*(TG-M2)*SYMBY*S4G**(-1) - 4*S**(-1)*UG*U1**(-1)*S4G**(-1)
     +     - 4*S**(-1)*UG*(S+TG-M2)**(-1)*S4G**(-1) - 4*S**(-1)*UG*
     +    (S+UG-M2)**(-1)*S4G**(-1) - 8*S**(-1)*UG*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*S**(-1)*UG*(UG-M2)*SYMBX*S4G**(-1) - 64*S**(-1)
     +    *UG*S4G**(-2) - 8*S**(-1)*UG**2*T1**(-1)*S4G**(-2) - 8*
     +    S**(-1)*UG**2*U1**(-1)*S4G**(-2) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 8*S**(-1)*UG**2*
     +    (S+TG-M2)**(-1)*S4G**(-2) + 8*S**(-1)*UG**2*(S+UG-M2)**(-1)*
     +    S4G**(-2) + 8*S**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 8*S**(-1)
     +    *MS2*(TG-M2)*SYMBY*S4G**(-1) + 40*S**(-1)*S4G**(-1) + 12*S*TG
     +    *T1**(-2)*(S+UG)**(-1)*S4G**(-1) + 8*S*TG*T1**(-1)*
     +    (S+UG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1) - 4*S*TG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 12*S*TG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-1) - 12*S*TG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MS2*S4G**(-1) + 4*S*TG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1) - 4*S*
     +    UG**(-1)*U1**(-1)*MG2*(S+TG-M2)**(-1)*S4G**(-1) + 4*S*UG*
     +    T1**(-1)*(S+TG)**(-1)*(UG-M2)*SYMBX*S4G**(-1) + 4*S*UG*
     +    T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1)
     +     - 4*S*UG*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MS2*(UG-M2)*SYMBX
     +    *S4G**(-1) + 12*S*UG*U1**(-2)*(S+TG)**(-1)*S4G**(-1) + 4*S*UG
     +    *U1**(-1)*(S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 12*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-1) - 12*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2*S4G**(-1) + 4*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 4*S*UG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*(UG-M2)*SYMBX*S4G**(-1) - 4*S*
     +    T1**(-1)*(S+TG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) + 4*S*
     +    T1**(-1)*(S+TG)**(-1)*MS2*(UG-M2)*SYMBX*S4G**(-1) - 4*S*
     +    T1**(-1)*(S+UG)**(-1)*S4G**(-1) - 16*S*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*S*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*(UG-M2)*SYMBX*S4G**(-1) - 4*
     +    S*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 4*S*
     +    T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2**2*(UG-M2)*SYMBX*
     +    S4G**(-1) + 4*S*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MS2*
     +    S4G**(-1) - 4*S*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MS2**2*
     +    (UG-M2)*SYMBX*S4G**(-1) - 8*S*T1**(-1)*S4G**(-2) - 4*S*
     +    U1**(-1)*(S+TG)**(-1)*MG2*(S+TG-M2)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * (  - 4*S*U1**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) + 4*S*U1**(-1)*(S+UG)**(-1)*S4G**(-1) - 16*S*
     +    U1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 8*S*
     +    U1**(-1)*S4G**(-2) - 4*S*(S+TG)**(-1)*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 4*S*(S+TG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1) - 8*S*
     +    (S+UG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1) - 24*S*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1) + 12*S*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2**2*S4G**(-1) + 12*S*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2**2*S4G**(-1) + 4*S*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*(S+TG-M2)**(-1)*S4G**(-1) - 8*S*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 4*S*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2*(S+TG-M2)**(-1)*S4G**(-1) - 24*S
     +    *(-M2*(S+TG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1) + 12*S*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2**2*S4G**(-1) + 12*S*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MS2**2*S4G**(-1) + 4*S*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*(S+UG-M2)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * (  - 8*S*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) - 4*S*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MS2*(S+UG-M2)**(-1)*S4G**(-1) + 16*S
     +    *(S+TG-M2)**(-1)*S4G**(-2) + 24*S*(S+UG-M2)**(-1)*S4G**(-2)
     +     + 4*S**2*(-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1)
     +     + 4*S**2*(-M2*(S+TG)+TG*UG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1)
     +     - 16*TG**(-2)*MG2*S4G**(-1) + 8*TG**(-1)*T1**(-1)*MG2*
     +    S4G**(-1) - 8*TG**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) + 16*
     +    TG**(-1)*S4G**(-1) - 4*TG*UG**(-1)*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 12*TG*UG*T1**(-2)*(S+UG)**(-1)*
     +    S4G**(-1) + 8*TG*UG*T1**(-1)*(S+TG)**(-1)*(UG-M2)*SYMBX*
     +    S4G**(-1) + 8*TG*UG*T1**(-1)*(S+UG)**(-1)*(S+UG-M2)**(-1)*
     +    S4G**(-1) + 8*TG*UG*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*
     +    (UG-M2)*SYMBX*S4G**(-1) - 8*TG*UG*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MS2*(UG-M2)*SYMBX*S4G**(-1) + 12*TG*
     +    UG*U1**(-2)*(S+TG)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 4*TG*UG*U1**(-1)*(S+TG)**(-1)*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 4*TG*UG*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*TG*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 8*TG*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*TG*UG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1) - 8*TG*UG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*(UG-M2)*SYMBX*S4G**(-1) - 8*TG*
     +    T1**(-1)*(S+TG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) + 8*TG*
     +    T1**(-1)*(S+TG)**(-1)*MS2*(UG-M2)*SYMBX*S4G**(-1) - 4*TG*
     +    T1**(-1)*(S+TG)**(-1)*S4G**(-1) - 8*TG*T1**(-1)*(S+UG)**(-1)*
     +    S4G**(-1) - 16*TG*T1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) + 16*TG*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*
     +    (UG-M2)*SYMBX*S4G**(-1) - 8*TG*T1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*(UG-M2)*SYMBX*S4G**(-1) - 8*
     +    TG*T1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MS2**2*(UG-M2)*SYMBX*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * (  - 4*TG*U1**(-1)*(S+TG)**(-1)*
     +    MG2*(S+TG-M2)**(-1)*S4G**(-1) - 4*TG*U1**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) + 4*TG*U1**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 16*TG*
     +    U1**(-1)*S4G**(-2) - 4*TG*(S+TG)**(-1)*(S+TG-M2)**(-1)*
     +    S4G**(-1) + 4*TG*(-M2*(S+UG)+TG*UG)**(-1)*MG2*(S+TG-M2)**(-1)
     +    *S4G**(-1) - 12*TG*(-M2*(S+UG)+TG*UG)**(-1)*MG2*(TG-M2)*SYMBY
     +    *S4G**(-1) - 4*TG*(-M2*(S+UG)+TG*UG)**(-1)*MS2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 4*TG*(-M2*(S+UG)+TG*UG)**(-1)*MS2
     +    *(TG-M2)*SYMBY*S4G**(-1) + 4*TG*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 24*TG*(-M2*(S+TG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1)
     +     + 12*TG*(-M2*(S+TG)+TG*UG)**(-2)*MG2**2*S4G**(-1) + 12*TG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MS2**2*S4G**(-1) + 4*TG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*(S+UG-M2)**(-1)*S4G**(-1) + 12*
     +    TG*(-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) - 4*
     +    TG*(-M2*(S+TG)+TG*UG)**(-1)*MS2*(S+UG-M2)**(-1)*S4G**(-1) - 
     +    12*TG*(-M2*(S+TG)+TG*UG)**(-1)*MS2*(UG-M2)*SYMBX*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 12*TG*(-M2*(S+TG)+TG*UG)**(-1)
     +    *S4G**(-1) + 16*TG*(S+TG-M2)**(-1)*S4G**(-2) + 16*TG*
     +    (S+UG-M2)**(-1)*S4G**(-2) + 4*TG**2*UG*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 12*TG**2*
     +    T1**(-2)*(S+UG)**(-1)*S4G**(-1) - 4*TG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 12*TG**2
     +    *(-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-1) - 12*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MS2*S4G**(-1) + 4*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1) - 16*
     +    UG**(-2)*MG2*S4G**(-1) - 4*UG**(-1)*U1**(-1)*MG2*MS2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 12*UG**(-1)*U1**(-1)*MG2*
     +    S4G**(-1) + 4*UG**(-1)*U1**(-1)*MG2**2*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 8*UG**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) + 16*
     +    UG**(-1)*S4G**(-1) - 4*UG*T1**(-1)*(S+UG)**(-1)*S4G**(-1) - 
     +    16*UG*T1**(-1)*S4G**(-2) + 4*UG*U1**(-1)*(S+TG)**(-1)*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * (  - 4*UG*U1**(-1)*(S+TG)**(-1)*
     +    MS2*(S+TG-M2)**(-1)*S4G**(-1) - 4*UG*U1**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) + 4*UG*U1**(-1)*(S+UG)**(-1)*S4G**(-1) + 8*UG*
     +    U1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*MS2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*UG*U1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) - 4*UG*U1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*UG*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2*S4G**(-1) - 4*UG*U1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2**2*(TG-M2)*SYMBY*S4G**(-1) - 16*
     +    UG*U1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 4*UG*
     +    (S+TG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1) - 8*UG*(S+TG)**(-1)*
     +    (UG-M2)*SYMBX*S4G**(-1) - 8*UG*(S+UG)**(-1)*(S+UG-M2)**(-1)*
     +    S4G**(-1) - 24*UG*(-M2*(S+UG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1)
     +     + 12*UG*(-M2*(S+UG)+TG*UG)**(-2)*MG2**2*S4G**(-1) + 12*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2**2*S4G**(-1) + 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*(S+TG-M2)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 12*UG*(-M2*(S+UG)+TG*UG)**(-1)
     +    *MG2*(TG-M2)*SYMBY*S4G**(-1) - 4*UG*(-M2*(S+UG)+TG*UG)**(-1)*
     +    MS2*(S+TG-M2)**(-1)*S4G**(-1) - 12*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2*(TG-M2)*SYMBY*S4G**(-1) + 12*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*UG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*(S+UG-M2)**(-1)*S4G**(-1) - 12*
     +    UG*(-M2*(S+TG)+TG*UG)**(-1)*MG2*(UG-M2)*SYMBX*S4G**(-1) - 4*
     +    UG*(-M2*(S+TG)+TG*UG)**(-1)*MS2*(S+UG-M2)**(-1)*S4G**(-1) + 4
     +    *UG*(-M2*(S+TG)+TG*UG)**(-1)*MS2*(UG-M2)*SYMBX*S4G**(-1) + 4*
     +    UG*(-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) + 16*UG*(S+TG-M2)**(-1)
     +    *S4G**(-2) + 32*UG*(S+UG-M2)**(-1)*S4G**(-2) + 12*UG**2*
     +    U1**(-2)*(S+TG)**(-1)*S4G**(-1) + 12*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-1) - 12*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2*S4G**(-1) + 4*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 4*UG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*(S+UG-M2)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 24*T1**(-1)*(S+UG)**(-1)*MG2*
     +    S4G**(-1) - 16*T1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*MS2*
     +    S4G**(-1) + 16*T1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-1) - 8*T1**(-1)*S4G**(-1) - 4*U1**(-1)*(S+TG)**(-1)*
     +    MG2*MS2*(S+TG-M2)**(-1)*S4G**(-1) + 28*U1**(-1)*(S+TG)**(-1)*
     +    MG2*S4G**(-1) + 4*U1**(-1)*(S+TG)**(-1)*MG2**2*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 16*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*S4G**(-1) + 16*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-1) - 8*U1**(-1)*
     +    S4G**(-1) - 4*(S+TG)**(-1)*MG2*(S+TG-M2)**(-1)*S4G**(-1) + 4*
     +    (S+TG)**(-1)*MG2*(S+UG-M2)**(-1)*S4G**(-1) + 8*(S+TG)**(-1)*
     +    MG2*(UG-M2)*SYMBX*S4G**(-1) + 4*(S+TG)**(-1)*MS2*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 4*(S+TG)**(-1)*MS2*
     +    (S+UG-M2)**(-1)*S4G**(-1) - 8*(S+TG)**(-1)*MS2*(UG-M2)*SYMBX*
     +    S4G**(-1) + 20*(S+TG)**(-1)*S4G**(-1) + 12*(S+UG)**(-1)*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * (  - 8*(-M2*(S+UG)+TG*UG)**(-1)*
     +    MG2*MS2*(S+TG-M2)**(-1)*S4G**(-1) - 24*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*MS2*(TG-M2)*SYMBY*S4G**(-1) + 20
     +    *(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 4*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*(S+TG-M2)**(-1)*S4G**(-1) + 
     +    16*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*(TG-M2)*SYMBY*S4G**(-1) - 
     +    20*(-M2*(S+UG)+TG*UG)**(-1)*MS2*S4G**(-1) + 4*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2**2*(S+TG-M2)**(-1)*S4G**(-1) + 8
     +    *(-M2*(S+UG)+TG*UG)**(-1)*MS2**2*(TG-M2)*SYMBY*S4G**(-1) - 8*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*(S+UG-M2)**(-1)*S4G**(-1) - 
     +    24*(-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*(UG-M2)*SYMBX*S4G**(-1)
     +     + 20*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 4*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*(S+UG-M2)**(-1)*S4G**(-1) + 
     +    16*(-M2*(S+TG)+TG*UG)**(-1)*MG2**2*(UG-M2)*SYMBX*S4G**(-1) - 
     +    20*(-M2*(S+TG)+TG*UG)**(-1)*MS2*S4G**(-1) + 4*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MS2**2*(S+UG-M2)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK*(S4G+MG2) * ( 8*(-M2*(S+TG)+TG*UG)**(-1)*
     +    MS2**2*(UG-M2)*SYMBX*S4G**(-1) + 8*MG2*(S+TG-M2)**(-1)*
     +    S4G**(-2) - 8*MS2*(S+TG-M2)**(-1)*S4G**(-2) - 4*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 4*(S+UG-M2)**(-1)*S4G**(-1) - 4*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*(UG-M2)*SYMBX*S4G**(-1) - 56*
     +    S4G**(-2) )
     +
      M2QBH = M2QBH + N*CK * ( 4*S**(-1)*TG*UG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) + 4*S**(-1)*TG*UG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) + 4*S**(-1)*TG**2*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) + 4*S**(-1)*TG**2*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S**(-1)*TG**2*UG**2*
     +    T1**(-1)*(S+UG)**(-2)*MG2*S4G**(-2) - 4*S**(-1)*TG**2*UG**2*
     +    T1**(-1)*(S+UG)**(-2)*S4G**(-1) - 4*S**(-1)*TG**2*UG**2*
     +    U1**(-1)*(S+TG)**(-2)*MG2*S4G**(-2) - 4*S**(-1)*TG**2*UG**2*
     +    U1**(-1)*(S+TG)**(-2)*S4G**(-1) - 4*S**(-1)*TG**2*UG**2*
     +    (S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) - 4*
     +    S**(-1)*TG**2*UG**2*(S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*
     +    S4G**(-1) - 4*S**(-1)*TG**2*UG**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) - 4*S**(-1)*TG**2*
     +    UG**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*
     +    S**(-1)*TG**2*T1**(-1)*MG2*S4G**(-2) + 4*S**(-1)*TG**2*
     +    T1**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK * ( 4*S**(-1)*UG**2*U1**(-1)*MG2*S4G**(-2)
     +     + 4*S**(-1)*UG**2*U1**(-1)*S4G**(-1) - 8*S*TG**(-1)*MG2*
     +    S4G**(-2) - 8*S*TG**(-1)*S4G**(-1) - 16*S*TG*T1**(-2)*
     +    (S+UG-M2)**(-1) + 8*S*TG*(-M2*(S+TG)+TG*UG)**(-1)*MG2*
     +    S4G**(-2) + 8*S*TG*(-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) + 4*S*
     +    TG**2*T1**(-1)*(S+UG)**(-2)*MG2*S4G**(-2) + 4*S*TG**2*
     +    T1**(-1)*(S+UG)**(-2)*S4G**(-1) - 4*S*TG**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) - 4*S*TG**2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*S*
     +    UG**(-1)*MG2*S4G**(-2) - 8*S*UG**(-1)*S4G**(-1) + 8*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) + 8*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S*UG**2*U1**(-1)*
     +    (S+TG)**(-2)*MG2*S4G**(-2) + 4*S*UG**2*U1**(-1)*(S+TG)**(-2)*
     +    S4G**(-1) - 4*S*UG**2*(S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*
     +    MG2*S4G**(-2) - 4*S*UG**2*(S+TG)**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK * ( 8*S*T1**(-1)*MG2*S4G**(-2) + 8*S*
     +    T1**(-1)*S4G**(-1) + 8*S*U1**(-1)*MG2*S4G**(-2) + 8*S*
     +    U1**(-1)*S4G**(-1) - 8*TG**(-1)*UG*MG2*S4G**(-2) - 8*TG**(-1)
     +    *UG*S4G**(-1) - 8*TG*UG**(-1)*MG2*S4G**(-2) - 8*TG*UG**(-1)*
     +    S4G**(-1) - 16*TG*UG*T1**(-2)*(S+UG-M2)**(-1) + 16*TG*
     +    T1**(-2)*MG2*(S+UG-M2)**(-1) - 16*TG*T1**(-2)*MS2*
     +    (S+UG-M2)**(-1) + 16*TG*T1**(-2) + 40*TG*T1**(-1)*U1**(-1)*
     +    MG2*S4G**(-1) + 32*TG*T1**(-1)*U1**(-1)*MG2**2*S4G**(-2) - 4*
     +    TG*T1**(-1)*S4G**(-1) + 8*TG*U1**(-1)*MG2*S4G**(-2) + 8*TG*
     +    U1**(-1)*S4G**(-1) - 8*TG*(S+UG)**(-1)*MG2*S4G**(-2) - 8*TG*
     +    (S+UG)**(-1)*S4G**(-1) + 16*TG**2*T1**(-2)*MG2*S4G**(-2) + 8*
     +    TG**2*T1**(-2)*S4G**(-1) + 4*TG**2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    MG2*S4G**(-2) + 4*TG**2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 
     +    8*TG**2*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) + 8*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) + 36*UG*T1**(-1)*U1**(-1)*
     +    MG2*S4G**(-1) )
     +
      M2QBH = M2QBH + N*CK * ( 32*UG*T1**(-1)*U1**(-1)*MG2**2*S4G**(-2)
     +     + 8*UG*T1**(-1)*MG2*S4G**(-2) - 4*UG*T1**(-1)*(UG-M2)*SYMBX
     +     + 8*UG*T1**(-1)*S4G**(-1) - 4*UG*U1**(-1)*S4G**(-1) - 8*UG*
     +    (S+TG)**(-1)*MG2*S4G**(-2) - 8*UG*(S+TG)**(-1)*S4G**(-1) + 16
     +    *UG**2*U1**(-2)*MG2*S4G**(-2) + 8*UG**2*U1**(-2)*S4G**(-1) + 
     +    8*UG**2*(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) + 8*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*UG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) + 4*UG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 28*T1**(-1)*U1**(-1)*MG2
     +     - 32*T1**(-1)*U1**(-1)*MG2**2*S4G**(-1) + 4*T1**(-1)*MG2*
     +    (UG-M2)*SYMBX - 16*T1**(-1)*MG2*S4G**(-1) - 4*T1**(-1)*MS2*
     +    (UG-M2)*SYMBX - 16*U1**(-1)*MG2*S4G**(-1) - 4*U1**(-1) )
     +
      M2QBH = M2QBH + CQED*(S4G+MG2) * (  - 4*S*TG*T1**(-2)*
     +    (S+UG)**(-1)*S4G**(-1) - 4*S*TG*(-M2*(S+TG)+TG*UG)**(-2)*MG2*
     +    S4G**(-1) + 4*S*TG*(-M2*(S+TG)+TG*UG)**(-2)*MS2*S4G**(-1) - 4
     +    *S*UG*U1**(-2)*(S+TG)**(-1)*S4G**(-1) - 4*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-1) + 4*S*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2*S4G**(-1) + 8*S*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*S*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*S*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1) - 4*S*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2**2*S4G**(-1) - 4*S*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2**2*S4G**(-1) + 8*S*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1) - 4*S*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2**2*S4G**(-1) - 4*S*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MS2**2*S4G**(-1) - 4*TG*UG*T1**(-2)*
     +    (S+UG)**(-1)*S4G**(-1) - 4*TG*UG*U1**(-2)*(S+TG)**(-1)*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + CQED*(S4G+MG2) * ( 8*TG*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*TG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1) - 4*TG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2**2*S4G**(-1) - 4*TG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MS2**2*S4G**(-1) - 4*TG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 4*TG**2*T1**(-2)*
     +    (S+UG)**(-1)*S4G**(-1) - 4*TG**2*(-M2*(S+TG)+TG*UG)**(-2)*MG2
     +    *S4G**(-1) + 4*TG**2*(-M2*(S+TG)+TG*UG)**(-2)*MS2*S4G**(-1)
     +     + 8*UG*U1**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*
     +    UG*(-M2*(S+UG)+TG*UG)**(-2)*MG2*MS2*S4G**(-1) - 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2**2*S4G**(-1) - 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MS2**2*S4G**(-1) - 4*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*UG**2*U1**(-2)*
     +    (S+TG)**(-1)*S4G**(-1) - 4*UG**2*(-M2*(S+UG)+TG*UG)**(-2)*MG2
     +    *S4G**(-1) + 4*UG**2*(-M2*(S+UG)+TG*UG)**(-2)*MS2*S4G**(-1)
     +     - 8*T1**(-1)*(S+UG)**(-1)*MG2*S4G**(-1) )
     +
      M2QBH = M2QBH + CQED*(S4G+MG2) * ( 8*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*MS2*S4G**(-1) - 8*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-1) - 8*U1**(-1)*
     +    (S+TG)**(-1)*MG2*S4G**(-1) + 8*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*MS2*S4G**(-1) - 8*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-1) - 4*(S+TG)**(-1)*
     +    S4G**(-1) - 4*(S+UG)**(-1)*S4G**(-1) - 8*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MS2*S4G**(-1) - 8*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MS2*S4G**(-1) )
     +
      M2QBH = M2QBH + CQED * ( 8*S*TG*T1**(-2)*(S+UG-M2)**(-1) + 8*TG*
     +    UG*T1**(-2)*(S+UG-M2)**(-1) - 8*TG*T1**(-2)*MG2*
     +    (S+UG-M2)**(-1) + 8*TG*T1**(-2)*MS2*(S+UG-M2)**(-1) - 8*TG*
     +    T1**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CO * (  - 16*S**(-2)*TG**(-1)*UG**3*
     +    MG2*S4G**(-2) - 16*S**(-2)*TG**(-1)*UG**3*S4G**(-1) - 16*
     +    S**(-2)*TG*UG*MG2*S4G**(-2) - 16*S**(-2)*TG*UG*S4G**(-1) - 8*
     +    S**(-2)*TG*UG**2*(S+UG)**(-1)*MG2*S4G**(-2) - 8*S**(-2)*TG*
     +    UG**2*(S+UG)**(-1)*S4G**(-1) - 8*S**(-2)*TG**2*UG*
     +    (S+TG)**(-1)*MG2*S4G**(-2) - 8*S**(-2)*TG**2*UG*(S+TG)**(-1)*
     +    S4G**(-1) - 16*S**(-2)*TG**3*UG**(-1)*MG2*S4G**(-2) - 16*
     +    S**(-2)*TG**3*UG**(-1)*S4G**(-1) + 16*S**(-1)*TG**(-2)*UG**2*
     +    MG2*S4G**(-1) + 16*S**(-1)*TG**(-2)*UG**2*MG2**2*S4G**(-2) - 
     +    32*S**(-1)*TG**(-1)*UG**2*MG2*S4G**(-2) - 32*S**(-1)*TG**(-1)
     +    *UG**2*S4G**(-1) - 8*S**(-1)*TG*MG2*S4G**(-2) - 8*S**(-1)*TG*
     +    S4G**(-1) + 16*S**(-1)*TG**2*UG**(-2)*MG2*S4G**(-1) + 16*
     +    S**(-1)*TG**2*UG**(-2)*MG2**2*S4G**(-2) - 32*S**(-1)*TG**2*
     +    UG**(-1)*MG2*S4G**(-2) - 32*S**(-1)*TG**2*UG**(-1)*S4G**(-1)
     +     - 8*S**(-1)*TG**2*UG**2*(S+TG)**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CO * (  - 8*S**(-1)*TG**2*UG**2*
     +    (S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 8*S**(-1)*
     +    TG**2*UG**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-2) - 8*S**(-1)*TG**2*UG**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S**(-1)*TG**2*T1**(-1)
     +    *MG2*S4G**(-2) + 8*S**(-1)*TG**2*T1**(-1)*S4G**(-1) + 8*
     +    S**(-1)*TG**2*U1**(-1)*MG2*S4G**(-2) + 8*S**(-1)*TG**2*
     +    U1**(-1)*S4G**(-1) - 8*S**(-1)*TG**3*(-M2*(S+TG)+TG*UG)**(-1)
     +    *MG2*S4G**(-2) - 8*S**(-1)*TG**3*(-M2*(S+TG)+TG*UG)**(-1)*
     +    S4G**(-1) - 8*S**(-1)*UG*MG2*S4G**(-2) - 8*S**(-1)*UG*
     +    S4G**(-1) + 8*S**(-1)*UG**2*T1**(-1)*MG2*S4G**(-2) + 8*
     +    S**(-1)*UG**2*T1**(-1)*S4G**(-1) + 8*S**(-1)*UG**2*U1**(-1)*
     +    MG2*S4G**(-2) + 8*S**(-1)*UG**2*U1**(-1)*S4G**(-1) - 8*
     +    S**(-1)*UG**3*(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) - 8*
     +    S**(-1)*UG**3*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 32*S**(-1)
     +    *MG2*S4G**(-1) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CO * ( 32*S**(-1)*MG2**2*S4G**(-2) + 
     +    16*S*TG**(-2)*MG2*S4G**(-1) + 16*S*TG**(-2)*MG2**2*S4G**(-2)
     +     + 16*S*TG**(-1)*UG*(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 
     +    16*S*TG**(-1)*UG*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 
     +    8*S*TG**(-1)*T1**(-1)*MG2*S4G**(-1) - 8*S*TG**(-1)*T1**(-1)*
     +    MG2**2*S4G**(-2) - 8*S*TG**(-1)*MG2*S4G**(-2) - 8*S*TG**(-1)*
     +    S4G**(-1) + 16*S*TG*UG**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) + 16*S*TG*UG**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-2) - 4*S*TG*UG**2*(-M2*(S+UG)+TG*UG)**(-2)*MG2*
     +    S4G**(-2) - 4*S*TG*UG**2*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1)
     +     - 4*S*TG*T1**(-2)*MG2*S4G**(-2) - 4*S*TG*T1**(-2)*S4G**(-1)
     +     - 4*S*TG**2*UG*(-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*S*
     +    TG**2*UG*(-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) + 16*S*UG**(-2)*
     +    MG2*S4G**(-1) + 16*S*UG**(-2)*MG2**2*S4G**(-2) - 8*S*UG**(-1)
     +    *U1**(-1)*MG2*S4G**(-1) - 8*S*UG**(-1)*U1**(-1)*MG2**2*
     +    S4G**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CO * (  - 8*S*UG**(-1)*MG2*S4G**(-2)
     +     - 8*S*UG**(-1)*S4G**(-1) - 4*S*UG*U1**(-2)*MG2*S4G**(-2) - 4
     +    *S*UG*U1**(-2)*S4G**(-1) + 8*S*T1**(-1)*MG2*S4G**(-2) + 8*S*
     +    T1**(-1)*S4G**(-1) + 8*S*U1**(-1)*MG2*S4G**(-2) + 8*S*
     +    U1**(-1)*S4G**(-1) + 8*S**2*TG**(-1)*(-M2*(S+UG)+TG*UG)**(-1)
     +    *MG2*S4G**(-1) + 8*S**2*TG**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    MG2**2*S4G**(-2) + 8*S**2*UG**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*
     +    MG2*S4G**(-1) + 8*S**2*UG**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*
     +    MG2**2*S4G**(-2) + 32*TG**(-2)*UG*MG2*S4G**(-1) + 32*TG**(-2)
     +    *UG*MG2**2*S4G**(-2) - 8*TG**(-1)*UG*T1**(-1)*MG2*S4G**(-1)
     +     - 8*TG**(-1)*UG*T1**(-1)*MG2**2*S4G**(-2) - 24*TG**(-1)*UG*
     +    MG2*S4G**(-2) - 24*TG**(-1)*UG*S4G**(-1) + 8*TG**(-1)*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*TG**(-1)*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-2) + 32*TG*UG**(-2)*
     +    MG2*S4G**(-1) + 32*TG*UG**(-2)*MG2**2*S4G**(-2) - 8*TG*
     +    UG**(-1)*U1**(-1)*MG2*S4G**(-1) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CO * (  - 8*TG*UG**(-1)*U1**(-1)*
     +    MG2**2*S4G**(-2) - 24*TG*UG**(-1)*MG2*S4G**(-2) - 24*TG*
     +    UG**(-1)*S4G**(-1) - 4*TG*UG*T1**(-2)*MG2*S4G**(-2) - 4*TG*UG
     +    *T1**(-2)*S4G**(-1) - 4*TG*UG*U1**(-2)*MG2*S4G**(-2) - 4*TG*
     +    UG*U1**(-2)*S4G**(-1) - 4*TG*UG**3*(-M2*(S+UG)+TG*UG)**(-2)*
     +    MG2*S4G**(-2) - 4*TG*UG**3*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1)
     +     - 8*TG*T1**(-1)*(S+UG)**(-1)*MG2*S4G**(-1) - 8*TG*T1**(-1)*
     +    (S+UG)**(-1)*MG2**2*S4G**(-2) + 16*TG*U1**(-1)*MG2*S4G**(-2)
     +     + 16*TG*U1**(-1)*S4G**(-1) + 8*TG*(-M2*(S+UG)+TG*UG)**(-1)*
     +    MG2*S4G**(-1) + 8*TG*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-2) + 8*TG**2*UG**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) + 8*TG**2*UG**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-2) - 4*TG**2*UG**3*(S+TG)**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*TG**2*UG**3*
     +    (S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) - 8*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CO * (  - 8*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) - 4*TG**3*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*TG**3*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) - 4*TG**3*UG**2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*TG**3
     +    *UG**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 4*
     +    TG**3*T1**(-2)*(S+UG)**(-1)*MG2*S4G**(-2) - 4*TG**3*T1**(-2)*
     +    (S+UG)**(-1)*S4G**(-1) + 16*UG*T1**(-1)*MG2*S4G**(-2) + 16*UG
     +    *T1**(-1)*S4G**(-1) - 8*UG*U1**(-1)*(S+TG)**(-1)*MG2*
     +    S4G**(-1) - 8*UG*U1**(-1)*(S+TG)**(-1)*MG2**2*S4G**(-2) + 8*
     +    UG*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*UG*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 8*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) - 8*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*UG**3*U1**(-2)*
     +    (S+TG)**(-1)*MG2*S4G**(-2) - 4*UG**3*U1**(-2)*(S+TG)**(-1)*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CK * ( 16*S**(-2)*TG**(-1)*UG**3*MG2*
     +    S4G**(-2) + 16*S**(-2)*TG**(-1)*UG**3*S4G**(-1) + 16*S**(-2)*
     +    TG*UG*MG2*S4G**(-2) + 16*S**(-2)*TG*UG*S4G**(-1) + 8*S**(-2)*
     +    TG*UG**2*(S+UG)**(-1)*MG2*S4G**(-2) + 8*S**(-2)*TG*UG**2*
     +    (S+UG)**(-1)*S4G**(-1) + 8*S**(-2)*TG**2*UG*(S+TG)**(-1)*MG2*
     +    S4G**(-2) + 8*S**(-2)*TG**2*UG*(S+TG)**(-1)*S4G**(-1) + 16*
     +    S**(-2)*TG**3*UG**(-1)*MG2*S4G**(-2) + 16*S**(-2)*TG**3*
     +    UG**(-1)*S4G**(-1) - 16*S**(-1)*TG**(-2)*UG**2*MG2*S4G**(-1)
     +     - 16*S**(-1)*TG**(-2)*UG**2*MG2**2*S4G**(-2) + 32*S**(-1)*
     +    TG**(-1)*UG**2*MG2*S4G**(-2) + 32*S**(-1)*TG**(-1)*UG**2*
     +    S4G**(-1) + 8*S**(-1)*TG*MG2*S4G**(-2) + 8*S**(-1)*TG*
     +    S4G**(-1) - 16*S**(-1)*TG**2*UG**(-2)*MG2*S4G**(-1) - 16*
     +    S**(-1)*TG**2*UG**(-2)*MG2**2*S4G**(-2) + 32*S**(-1)*TG**2*
     +    UG**(-1)*MG2*S4G**(-2) + 32*S**(-1)*TG**2*UG**(-1)*S4G**(-1)
     +     + 8*S**(-1)*TG**2*UG**2*(S+TG)**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CK * ( 8*S**(-1)*TG**2*UG**2*
     +    (S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) + 8*S**(-1)*
     +    TG**2*UG**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-2) + 8*S**(-1)*TG**2*UG**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*S**(-1)*TG**2*T1**(-1)
     +    *MG2*S4G**(-2) - 8*S**(-1)*TG**2*T1**(-1)*S4G**(-1) - 8*
     +    S**(-1)*TG**2*U1**(-1)*MG2*S4G**(-2) - 8*S**(-1)*TG**2*
     +    U1**(-1)*S4G**(-1) + 8*S**(-1)*TG**3*(-M2*(S+TG)+TG*UG)**(-1)
     +    *MG2*S4G**(-2) + 8*S**(-1)*TG**3*(-M2*(S+TG)+TG*UG)**(-1)*
     +    S4G**(-1) + 8*S**(-1)*UG*MG2*S4G**(-2) + 8*S**(-1)*UG*
     +    S4G**(-1) - 8*S**(-1)*UG**2*T1**(-1)*MG2*S4G**(-2) - 8*
     +    S**(-1)*UG**2*T1**(-1)*S4G**(-1) - 8*S**(-1)*UG**2*U1**(-1)*
     +    MG2*S4G**(-2) - 8*S**(-1)*UG**2*U1**(-1)*S4G**(-1) + 8*
     +    S**(-1)*UG**3*(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) + 8*
     +    S**(-1)*UG**3*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 32*S**(-1)
     +    *MG2*S4G**(-1) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CK * (  - 32*S**(-1)*MG2**2*S4G**(-2)
     +     - 16*S*TG**(-2)*MG2*S4G**(-1) - 16*S*TG**(-2)*MG2**2*
     +    S4G**(-2) - 16*S*TG**(-1)*UG*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) - 16*S*TG**(-1)*UG*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-2) + 8*S*TG**(-1)*T1**(-1)*MG2*S4G**(-1) + 8*S*
     +    TG**(-1)*T1**(-1)*MG2**2*S4G**(-2) + 8*S*TG**(-1)*MG2*
     +    S4G**(-2) + 8*S*TG**(-1)*S4G**(-1) - 16*S*TG*UG**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 16*S*TG*UG**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) + 12*S*TG*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-2) + 12*S*TG*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 12*S*TG*T1**(-2)*MG2*
     +    S4G**(-2) + 12*S*TG*T1**(-2)*S4G**(-1) - 16*S*TG*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 16*S*TG*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) + 12*S*TG**2*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-2) + 12*S*TG**2*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CK * (  - 16*S*TG**2*T1**(-1)*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) - 16*S*
     +    TG**2*T1**(-1)*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-2) - 16*S*UG**(-2)*MG2*S4G**(-1) - 16*S*UG**(-2)*
     +    MG2**2*S4G**(-2) + 8*S*UG**(-1)*U1**(-1)*MG2*S4G**(-1) + 8*S*
     +    UG**(-1)*U1**(-1)*MG2**2*S4G**(-2) + 8*S*UG**(-1)*MG2*
     +    S4G**(-2) + 8*S*UG**(-1)*S4G**(-1) - 16*S*UG*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) - 16*S*UG*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-2) + 12*S*UG*U1**(-2)*
     +    MG2*S4G**(-2) + 12*S*UG*U1**(-2)*S4G**(-1) - 16*S*UG**2*
     +    U1**(-1)*(S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1)
     +     - 16*S*UG**2*U1**(-1)*(S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*
     +    MG2**2*S4G**(-2) - 8*S*T1**(-1)*MG2*S4G**(-2) - 8*S*T1**(-1)*
     +    S4G**(-1) - 8*S*U1**(-1)*MG2*S4G**(-2) - 8*S*U1**(-1)*
     +    S4G**(-1) - 8*S**2*TG**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CK * (  - 8*S**2*TG**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 8*S**2*UG**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 8*S**2*UG**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 16*S**2*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) - 16*S**2*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 16*S**2*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 16*S**2*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 32*TG**(-2)*UG*
     +    MG2*S4G**(-1) - 32*TG**(-2)*UG*MG2**2*S4G**(-2) + 8*TG**(-1)*
     +    UG*T1**(-1)*MG2*S4G**(-1) + 8*TG**(-1)*UG*T1**(-1)*MG2**2*
     +    S4G**(-2) + 24*TG**(-1)*UG*MG2*S4G**(-2) + 24*TG**(-1)*UG*
     +    S4G**(-1) - 8*TG**(-1)*UG**2*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) - 8*TG**(-1)*UG**2*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-2) - 32*TG*UG**(-2)*MG2*S4G**(-1) - 32*TG*UG**(-2)*
     +    MG2**2*S4G**(-2) + 8*TG*UG**(-1)*U1**(-1)*MG2*S4G**(-1) + 8*
     +    TG*UG**(-1)*U1**(-1)*MG2**2*S4G**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CK * ( 24*TG*UG**(-1)*MG2*S4G**(-2) + 
     +    24*TG*UG**(-1)*S4G**(-1) + 12*TG*UG*T1**(-2)*MG2*S4G**(-2) + 
     +    12*TG*UG*T1**(-2)*S4G**(-1) + 12*TG*UG*U1**(-2)*MG2*S4G**(-2)
     +     + 12*TG*UG*U1**(-2)*S4G**(-1) + 12*TG*UG**3*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-2) + 12*TG*UG**3*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 8*TG*T1**(-1)*
     +    (S+UG)**(-1)*MG2*S4G**(-1) + 8*TG*T1**(-1)*(S+UG)**(-1)*
     +    MG2**2*S4G**(-2) - 16*TG*U1**(-1)*MG2*S4G**(-2) - 16*TG*
     +    U1**(-1)*S4G**(-1) - 8*TG*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) - 8*TG*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 
     +    8*TG**2*UG**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) - 8*
     +    TG**2*UG**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) + 12
     +    *TG**2*UG**3*(S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-2)*MG2*
     +    S4G**(-2) + 12*TG**2*UG**3*(S+TG)**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) + 8*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*N*CK * ( 8*TG**2*
     +    (-M2*(S+TG)+TG*UG)**(-1)*S4G**(-1) + 12*TG**3*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-2) + 12*TG**3*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) + 12*TG**3*UG**2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-2) + 12*
     +    TG**3*UG**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1)
     +     + 12*TG**3*T1**(-2)*(S+UG)**(-1)*MG2*S4G**(-2) + 12*TG**3*
     +    T1**(-2)*(S+UG)**(-1)*S4G**(-1) - 16*UG*T1**(-1)*MG2*
     +    S4G**(-2) - 16*UG*T1**(-1)*S4G**(-1) + 8*UG*U1**(-1)*
     +    (S+TG)**(-1)*MG2*S4G**(-1) + 8*UG*U1**(-1)*(S+TG)**(-1)*
     +    MG2**2*S4G**(-2) - 8*UG*(-M2*(S+TG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) - 8*UG*(-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) + 
     +    8*UG**2*(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-2) + 8*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 12*UG**3*U1**(-2)*
     +    (S+TG)**(-1)*MG2*S4G**(-2) + 12*UG**3*U1**(-2)*(S+TG)**(-1)*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + COLO1(9)*CQED * (  - 4*S*TG*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*S*TG*UG**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 4*S*TG*T1**(-2)*MG2*
     +    S4G**(-2) - 4*S*TG*T1**(-2)*S4G**(-1) + 8*S*TG*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*S*TG*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 4*S*TG**2*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*S*TG**2*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) + 8*S*TG**2*T1**(-1)*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*S*
     +    TG**2*T1**(-1)*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-2) + 8*S*UG*T1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2*
     +    S4G**(-1) + 8*S*UG*T1**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*MG2**2*
     +    S4G**(-2) - 4*S*UG*U1**(-2)*MG2*S4G**(-2) - 4*S*UG*U1**(-2)*
     +    S4G**(-1) + 8*S*UG**2*U1**(-1)*(S+TG)**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*S*UG**2*U1**(-1)*
     +    (S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*CQED * ( 8*S**2*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*S**2*T1**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*MG2**2*S4G**(-2) + 8*S**2*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2*S4G**(-1) + 8*S**2*U1**(-1)*
     +    (-M2*(S+TG)+TG*UG)**(-1)*MG2**2*S4G**(-2) - 4*TG*UG*T1**(-2)*
     +    MG2*S4G**(-2) - 4*TG*UG*T1**(-2)*S4G**(-1) - 4*TG*UG*U1**(-2)
     +    *MG2*S4G**(-2) - 4*TG*UG*U1**(-2)*S4G**(-1) - 4*TG*UG**3*
     +    (-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*TG*UG**3*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 4*TG**2*UG**3*
     +    (S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*TG**2
     +    *UG**3*(S+TG)**(-1)*(-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) - 4*
     +    TG**3*UG*(-M2*(S+TG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*TG**3*UG*
     +    (-M2*(S+TG)+TG*UG)**(-2)*S4G**(-1) - 4*TG**3*UG**2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-2)*MG2*S4G**(-2) - 4*TG**3
     +    *UG**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 4*
     +    TG**3*T1**(-2)*(S+UG)**(-1)*MG2*S4G**(-2) )
     +
      M2QBH = M2QBH + COLO1(9)*CQED * (  - 4*TG**3*T1**(-2)*
     +    (S+UG)**(-1)*S4G**(-1) - 4*UG**3*U1**(-2)*(S+TG)**(-1)*MG2*
     +    S4G**(-2) - 4*UG**3*U1**(-2)*(S+TG)**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(9)*N*CO * (  - 32*S**(-2)*MG2 )
     +
      M2QBH = M2QBH + ANG4(10)*N*CO * (  - 32*S**(-1)*MG2 )
     +
      M2QBH = M2QBH + ANG4(11)*N*CO * ( 32*S**(-2)*(TG+UG)**(-1)*MG2 - 
     +    2*S**(-1)*T1**(-1) - 2*S**(-1)*U1**(-1) + 8*S**(-1)*S4G**(-1)
     +     + 2*T1**(-1)*S4G**(-1) + 2*U1**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(12)*N*CO * ( 32*S**(-2)*UG*(TG+UG)**(-1)*MG2
     +     + 32*S**(-2)*UG*MG2*S4G**(-1) - 2*S**(-1)*TG*T1**(-1) + 8*
     +    S**(-1)*UG*T1**(-1)*MG2*S4G**(-1) + 8*S**(-1)*UG*U1**(-1)*MG2
     +    *S4G**(-1) + 2*S**(-1)*UG*U1**(-1) + 8*S**(-1)*UG*
     +    (TG+UG)**(-1) - 8*S**(-1)*T1**(-1)*MG2 + 32*S**(-1)*
     +    (TG+UG)**(-1)*MG2 + 16*S**(-1)*MG2*S4G**(-1) - 4*S**(-1) - 2*
     +    TG*T1**(-1)*S4G**(-1) - 2*TG*U1**(-1)*S4G**(-1) - 2*UG*
     +    T1**(-1)*S4G**(-1) - 2*UG*U1**(-1)*S4G**(-1) + 8*T1**(-1)*MG2
     +    *S4G**(-1) + 8*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(13)*N*CO * (  - 32*S**(-2)*MG2 )
     +
      M2QBH = M2QBH + ANG4(14)*N*CO * (  - 64*S**(-2)*UG*MG2 - 32*
     +    S**(-1)*MG2 )
     +
      M2QBH = M2QBH + ANG4(15)*N*CO * ( 32*S**(-2)*(TG+UG)**(-1)*MG2 + 
     +    2*S**(-1)*T1**(-1) + 2*S**(-1)*U1**(-1) - 8*S**(-1)*S4G**(-1)
     +     - 2*T1**(-1)*S4G**(-1) - 2*U1**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(16)*N*CO * ( 32*S**(-2)*UG*(TG+UG)**(-1)*MG2
     +     - 32*S**(-2)*UG*MG2*S4G**(-1) + 4*S**(-1)*TG*U1**(-1) - 8*
     +    S**(-1)*UG*T1**(-1)*MG2*S4G**(-1) - 8*S**(-1)*UG*U1**(-1)*MG2
     +    *S4G**(-1) + 4*S**(-1)*UG*U1**(-1) + 8*S**(-1)*UG*
     +    (TG+UG)**(-1) + 8*S**(-1)*UG*S4G**(-1) + 8*S**(-1)*T1**(-1)*
     +    MG2 + 32*S**(-1)*(TG+UG)**(-1)*MG2 - 16*S**(-1)*MG2*S4G**(-1)
     +     - 16*S**(-1) - 2*TG*T1**(-1)*S4G**(-1) + 2*UG*U1**(-1)*
     +    S4G**(-1) - 8*T1**(-1)*MG2*S4G**(-1) + 4*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(36)*N*CO * (  - 32*S**(-1)*MG2*MS2 - 16*MG2
     +     )
     +
      M2QBH = M2QBH + ANG4(36)*N*CK * ( 16*MG2 )
     +
      M2QBH = M2QBH + ANG4(37)*N*CO * ( 2*S**(-1)*TG*T1**(-1)*MG2 - 4*
     +    S**(-1)*TG*T1**(-1)*MS2 + 2*S**(-1)*TG*U1**(-1)*MG2 + 2*
     +    S**(-1)*UG*T1**(-1)*MG2 + 2*S**(-1)*UG*U1**(-1)*MG2 - 4*
     +    S**(-1)*UG*U1**(-1)*MS2 + 16*S**(-1)*UG*(TG+UG)**(-1)*MG2 + 
     +    16*S**(-1)*UG*MG2*S4G**(-1) - 8*S**(-1)*UG**2*(TG+UG)**(-1)
     +     + 8*S**(-1)*UG**2*S4G**(-1) - 4*S**(-1)*T1**(-1)*MG2*MS2 + 4
     +    *S**(-1)*T1**(-1)*MG2**2 - 4*S**(-1)*U1**(-1)*MG2*MS2 + 4*
     +    S**(-1)*U1**(-1)*MG2**2 + 16*S**(-1)*(TG+UG)**(-1)*MG2*MS2 - 
     +    16*S**(-1)*(TG+UG)**(-1)*MG2**2 - 24*S**(-1)*MG2 - 32*S**(-1)
     +    *MG2**2*S4G**(-1) + 8*S**(-1)*MS2 - 6*TG*T1**(-1)*MG2*
     +    S4G**(-1) - 2*TG*T1**(-1)*MS2*S4G**(-1) - 2*TG*T1**(-1) - 2*
     +    TG*U1**(-1)*MG2*S4G**(-1) - 2*TG*U1**(-1)*MS2*S4G**(-1) - 6*
     +    TG*S4G**(-1) + 2*TG**2*T1**(-1)*S4G**(-1) - 2*UG*T1**(-1)*MG2
     +    *S4G**(-1) - 2*UG*T1**(-1)*MS2*S4G**(-1) + 2*UG*U1**(-1)*MG2*
     +    S4G**(-1) - 2*UG*U1**(-1)*MS2*S4G**(-1) + 4*UG*(TG+UG)**(-1)
     +     + 2*UG*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(37)*N*CO * ( 2*UG**2*U1**(-1)*S4G**(-1) - 4*
     +    T1**(-1)*MG2*MS2*S4G**(-1) - 4*T1**(-1)*MG2**2*S4G**(-1) - 4*
     +    U1**(-1)*MG2*MS2*S4G**(-1) - 4*U1**(-1)*MG2**2*S4G**(-1) + 16
     +    *(TG+UG)**(-1)*MG2 + 12*MG2*S4G**(-1) + 4*MS2*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(37)*N*CK * (  - 8 + 2*S*UG*T1**(-1)*
     +    (S+UG-M2)**(-1) + 2*S*T1**(-1)*MG2*(S-2*M2)**(-1) + 2*TG*
     +    T1**(-1) + 2*TG*U1**(-1) - 2*UG*T1**(-1)*MG2*(S+UG-M2)**(-1)
     +     + 2*UG*T1**(-1)*MS2*(S+UG-M2)**(-1) + 2*UG*U1**(-1) + 2*
     +    UG**2*T1**(-1)*(S+UG-M2)**(-1) + 4*T1**(-1)*MG2*MS2*
     +    (S-2*M2)**(-1) - 2*T1**(-1)*MG2 - 4*T1**(-1)*MG2**2*
     +    (S-2*M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(38)*N*CO * (  - 32*S**(-2)*UG**2*MG2 - 32*
     +    S**(-1)*UG*MG2 - 32*MG2 )
     +
      M2QBH = M2QBH + ANG4(38)*N*CK * ( 16*MG2 )
     +
      M2QBH = M2QBH + ANG4(39)*N*CO * (  - 12 - 32*S**(-2)*UG**2*MG2*
     +    S4G**(-1) + 4*S**(-1)*TG*UG*U1**(-1) + 2*S**(-1)*TG*UG*
     +    (TG-M2)*SYMBY + 3*S**(-1)*TG*UG*(UG-M2)*SYMBX + S**(-1)*TG*
     +    MG2*(TG-M2)*SYMBY - 3*S**(-1)*TG*MG2*(UG-M2)*SYMBX - S**(-1)*
     +    TG*MS2*(TG-M2)*SYMBY + 3*S**(-1)*TG*MS2*(UG-M2)*SYMBX - 20*
     +    S**(-1)*TG + 2*S**(-1)*TG**2*T1**(-1) + 2*S**(-1)*TG**2*
     +    U1**(-1) - S**(-1)*TG**2*(TG-M2)*SYMBY + 8*S**(-1)*UG*
     +    T1**(-1)*MG2 + 16*S**(-1)*UG*(TG+UG)**(-1)*MG2 - 2*S**(-1)*UG
     +    *MG2*(TG-M2)*SYMBY + S**(-1)*UG*MG2*(UG-M2)*SYMBX - 32*
     +    S**(-1)*UG*MG2*S4G**(-1) + 2*S**(-1)*UG*MS2*(TG-M2)*SYMBY - 
     +    S**(-1)*UG*MS2*(UG-M2)*SYMBX + 13*S**(-1)*UG - 8*S**(-1)*
     +    UG**2*T1**(-1)*MG2*S4G**(-1) - 8*S**(-1)*UG**2*U1**(-1)*MG2*
     +    S4G**(-1) + 4*S**(-1)*UG**2*U1**(-1) - 8*S**(-1)*UG**2*
     +    (TG+UG)**(-1) - S**(-1)*UG**2*(UG-M2)*SYMBX - 16*S**(-1)*
     +    UG**2*S4G**(-1) + 16*S**(-1)*(TG+UG)**(-1)*MG2*MS2 - 16*
     +    S**(-1)*(TG+UG)**(-1)*MG2**2 )
     +
      M2QBH = M2QBH + ANG4(39)*N*CO * (  - 20*S**(-1)*MG2 + 4*S**(-1)*
     +    MS2 + 2*TG*T1**(-1)*MG2*S4G**(-1) + 2*TG*T1**(-1) + 2*TG*
     +    U1**(-1)*MG2*S4G**(-1) + 2*TG*U1**(-1) + 8*TG*S4G**(-1) - 4*
     +    TG**2*T1**(-1)*S4G**(-1) - 6*UG*T1**(-1)*MG2*S4G**(-1) - 6*UG
     +    *U1**(-1)*MG2*S4G**(-1) + 6*UG*U1**(-1) + 4*UG*(TG+UG)**(-1)
     +     - 8*UG*S4G**(-1) - 4*UG**2*U1**(-1)*S4G**(-1) - 4*T1**(-1)*
     +    MG2 - 4*U1**(-1)*MG2 + 16*(TG+UG)**(-1)*MG2 - 16*MG2*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(39)*N*CK * ( 8 - 4*S*TG*T1**(-1)*
     +    (S+UG-M2)**(-1) - 2*S*T1**(-1)*MG2*(S+UG-M2)**(-1) - 4*TG*UG*
     +    T1**(-1)*(S+UG-M2)**(-1) + 4*TG*UG*T1**(-1)*(UG-M2)*SYMBX + 4
     +    *TG*T1**(-1)*MG2*(S+UG-M2)**(-1) - 4*TG*T1**(-1)*MG2*(UG-M2)*
     +    SYMBX - 4*TG*T1**(-1)*MS2*(S+UG-M2)**(-1) + 4*TG*T1**(-1)*MS2
     +    *(UG-M2)*SYMBX - 2*TG*T1**(-1) - 2*TG*U1**(-1) - 2*UG*
     +    T1**(-1)*MG2*(S+UG-M2)**(-1) - 2*UG*T1**(-1)*MS2*(UG-M2)*
     +    SYMBX - 2*UG*U1**(-1) - 2*UG**2*T1**(-1)*(UG-M2)*SYMBX - 2*
     +    T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) - 2*T1**(-1)*MG2*MS2*(UG-M2)
     +    *SYMBX + 4*T1**(-1)*MG2 + 2*T1**(-1)*MG2**2*(S+UG-M2)**(-1)
     +     + 2*T1**(-1)*MG2**2*(UG-M2)*SYMBX )
     +
      M2QBH = M2QBH + ANG4(42)*N*CO * (  - 4*S**(-1)*UG*U1**(-1)*
     +    S4G**(-1) + 8*S**(-1)*S4G**(-1) - 4*UG*U1**(-2)*S4G**(-1) + 4
     +    *U1**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(42)*N*CK * ( 4*UG*U1**(-2)*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(45)*N*CO * ( 4*S**(-1)*UG*T1**(-1)*S4G**(-1)
     +     + 4*S**(-1)*U1**(-1) - 8*S**(-1)*S4G**(-1) - 4*TG*T1**(-2)*
     +    S4G**(-1) + 4*T1**(-1)*S4G**(-1) - 4*U1**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(45)*N*CK * ( 4*TG*T1**(-2)*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(48)*N*CK * (  - 8*S**(-1)*TG**2 - 8*S**(-1)*
     +    UG**2 + 2*S*TG*UG*U1**(-1)*(S+TG-M2)**(-1) + 2*S*TG*U1**(-1)*
     +    MG2*(S+TG-M2)**(-1) - 2*S*TG*U1**(-1)*MS2*(S+TG-M2)**(-1) - 2
     +    *S*TG*U1**(-1) + 2*S*TG**2*T1**(-1)*(S+UG-M2)**(-1) - 4*S*UG*
     +    T1**(-1) - 2*S*UG*U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*S*UG*
     +    U1**(-1)*MS2*(S+TG-M2)**(-1) - 2*S*UG*U1**(-1) + 2*S*UG*
     +    (S+TG-M2)**(-1) + 4*S*UG*(S+UG-M2)**(-1) + 2*S*UG**2*T1**(-1)
     +    *(S+UG-M2)**(-1) + 2*S*UG**2*U1**(-1)*(S+TG-M2)**(-1) - 4*S*
     +    T1**(-1)*MG2 - 4*S*U1**(-1)*MG2 + 6*S*MG2*(S+TG-M2)**(-1) + 4
     +    *S*MG2*(S+UG-M2)**(-1) - 2*S*MS2*(S+TG-M2)**(-1) - 6*S + 4*
     +    S**2*UG*T1**(-1)*(S+UG-M2)**(-1) + 2*S**2*UG*U1**(-1)*
     +    (S+TG-M2)**(-1) - 2*S**2*T1**(-1) + 2*S**2*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 2*S**2*U1**(-1)*MS2*(S+TG-M2)**(-1) + 2*
     +    S**2*(S+UG-M2)**(-1) + 2*S**3*T1**(-1)*(S+UG-M2)**(-1) + 2*TG
     +    *UG*(S+TG-M2)**(-1) + 2*TG*MG2*(S+TG-M2)**(-1) - 2*TG*MS2*
     +    (S+TG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(48)*N*CK * (  - 6*TG - 2*TG**2*T1**(-1) - 2*
     +    TG**2*U1**(-1) + 2*TG**2*(S+UG-M2)**(-1) - 2*UG*MG2*
     +    (S+TG-M2)**(-1) + 2*UG*MS2*(S+TG-M2)**(-1) - 10*UG - 2*UG**2*
     +    T1**(-1) - 2*UG**2*U1**(-1) + 2*UG**2*(S+TG-M2)**(-1) + 2*
     +    UG**2*(S+UG-M2)**(-1) - 16*MG2 )
     +
      M2QBH = M2QBH + ANG4(48)*CQED * (  - 2*S*TG*UG*U1**(-1)*
     +    (S+TG-M2)**(-1) - 2*S*TG*U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*S*
     +    TG*U1**(-1)*MS2*(S+TG-M2)**(-1) - 2*S*TG*U1**(-1) - 2*S*TG**2
     +    *T1**(-1)*(S+UG-M2)**(-1) + 2*S*UG*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 2*S*UG*U1**(-1)*MS2*(S+TG-M2)**(-1) + 2*S*
     +    UG*U1**(-1) - 2*S*UG**2*T1**(-1)*(S+UG-M2)**(-1) - 2*S*UG**2*
     +    U1**(-1)*(S+TG-M2)**(-1) - 4*S**2*UG*T1**(-1)*(S+UG-M2)**(-1)
     +     - 2*S**2*UG*U1**(-1)*(S+TG-M2)**(-1) - 4*S**2*T1**(-1)*
     +    U1**(-1)*MG2 - 2*S**2*U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*S**2*
     +    U1**(-1)*MS2*(S+TG-M2)**(-1) - 2*S**2*U1**(-1) - 4*S**2*MG2*
     +    (S+TG-M2)**(-1)*(S+UG-M2)**(-1) - 2*S**3*T1**(-1)*
     +    (S+UG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(49)*N*CO * (  - 2*S**(-1)*TG*UG*T1**(-1)*MG2
     +     + 6*S**(-1)*TG*UG + 4*S**(-1)*TG*MG2 - 2*S**(-1)*TG**2*
     +    T1**(-1)*MG2 - 6*S**(-1)*TG**2 + 4*S**(-1)*TG**3*T1**(-1) - 8
     +    *S**(-1)*UG**2 + 8*S**(-1)*UG**3*(TG+UG)**(-1) + 2*S*UG*
     +    T1**(-1)*(TG+UG)**(-1)*MG2 + 2*S*UG*(TG+UG)**(-1) - 2*S*
     +    T1**(-1)*MG2 - 2*S + 4*TG*UG*T1**(-1) + 4*TG*T1**(-1)*MG2 - 4
     +    *TG - 4*TG**2*T1**(-1) + 4*TG**3*T1**(-2) + 4*UG*
     +    (TG+UG)**(-1)*MG2 + 4*UG - 4*UG**2*T1**(-1) - 4*UG**2*
     +    (TG+UG)**(-1) + 4*UG**3*T1**(-1)*(TG+UG)**(-1) - 4*MG2 )
     +
      M2QBH = M2QBH + ANG4(49)*N*CK * ( 2*S*TG*UG*U1**(-1)*
     +    (S+TG-M2)**(-1) + 2*S*TG*T1**(-1)*U1**(-1)*MG2 - 2*S*TG*
     +    T1**(-1)*MG2*(S-2*M2)**(-1) + 2*S*TG*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 2*S*TG*U1**(-1)*MS2*(S+TG-M2)**(-1) + 2*S*
     +    TG*U1**(-1) + 2*S*TG*MG2*(S+TG-M2)**(-1)*(S-2*M2)**(-1) - 2*
     +    TG*UG*T1**(-1)*U1**(-1)*MG2 + 2*TG*UG*T1**(-1)*MG2*
     +    (S-2*M2)**(-1) - 2*TG*UG*U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*TG*
     +    UG*U1**(-1)*MS2*(S+TG-M2)**(-1) - 2*TG*UG*U1**(-1) - 2*TG*UG*
     +    MG2*(S+TG-M2)**(-1)*(S-2*M2)**(-1) + 2*TG*UG**2*U1**(-1)*
     +    (S+TG-M2)**(-1) + 2*TG**2*UG*U1**(-1)*(S+TG-M2)**(-1) - 2*
     +    TG**2*T1**(-1)*U1**(-1)*MG2 + 2*TG**2*T1**(-1)*MG2*
     +    (S-2*M2)**(-1) + 2*TG**2*U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*
     +    TG**2*U1**(-1)*MS2*(S+TG-M2)**(-1) + 2*TG**2*U1**(-1) - 2*
     +    TG**2*MG2*(S+TG-M2)**(-1)*(S-2*M2)**(-1) - 4*TG**3*T1**(-2) )
     +
      M2QBH = M2QBH + ANG4(50)*N*CO * (  - 2*S**(-1)*TG*UG*U1**(-1)*MG2
     +     - 2*S**(-1)*TG*UG + 4*S**(-1)*UG*MG2 - 6*S**(-1)*UG**2*
     +    U1**(-1)*MG2 + 4*S**(-1)*UG**2*U1**(-1)*MS2 + 6*S**(-1)*UG**2
     +     - 8*S**(-1)*UG**3*(TG+UG)**(-1) - 2*S*UG*U1**(-1)*
     +    (TG+UG)**(-1)*MG2 - 2*S*UG*(TG+UG)**(-1) + 4*UG*U1**(-1)*MG2
     +     - 4*UG*(TG+UG)**(-1)*MG2 - 4*UG**2*U1**(-2)*MG2 + 4*UG**2*
     +    U1**(-2)*MS2 + 4*UG**2*U1**(-1)*(TG+UG)**(-1)*MG2 - 4*UG**2*
     +    U1**(-1)*(TG+UG)**(-1)*MS2 + 4*UG**2*U1**(-1) - 8*UG**2*
     +    (TG+UG)**(-1) )
     +
      M2QBH = M2QBH + ANG4(50)*N*CK * ( 2*S*UG*T1**(-1)*U1**(-1)*MG2 - 
     +    2*S*UG*U1**(-1)*MG2*(S-2*M2)**(-1) + 2*S*UG*MG2*
     +    (S+UG-M2)**(-1)*(S-2*M2)**(-1) + 4*S*UG**2*T1**(-1)*
     +    (S+UG-M2)**(-1) + 2*S**2*UG*T1**(-1)*(S+UG-M2)**(-1) - 2*TG*
     +    UG*T1**(-1)*U1**(-1)*MG2 + 2*TG*UG*U1**(-1)*MG2*
     +    (S-2*M2)**(-1) - 2*TG*UG*MG2*(S+UG-M2)**(-1)*(S-2*M2)**(-1)
     +     + 2*TG**2*UG*T1**(-1)*(S+UG-M2)**(-1) - 2*UG**2*T1**(-1)*
     +    U1**(-1)*MG2 + 4*UG**2*U1**(-2)*MG2 - 4*UG**2*U1**(-2)*MS2 + 
     +    2*UG**2*U1**(-1)*MG2*(S-2*M2)**(-1) - 4*UG**2*U1**(-1) - 2*
     +    UG**2*MG2*(S+UG-M2)**(-1)*(S-2*M2)**(-1) + 2*UG**3*T1**(-1)*
     +    (S+UG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(52)*N*CO * (  - 8*S*MG2 )
     +
      M2QBH = M2QBH + ANG4(52)*N*CK * ( 8*S*MG2 )
     +
      M2QBH = M2QBH + ANG4(54)*N*CO * ( 8*S**(-1)*TG*UG - 8*S**(-1)*
     +    TG**2 - 16*S**(-1)*UG**2 + 8*S**(-1)*UG**3*(TG+UG)**(-1) + 8*
     +    S**(-1)*UG**3*S4G**(-1) + 2*S*TG*T1**(-1)*MG2*(UG-M2)*SYMBX
     +     + 2*S*UG*T1**(-1)*(TG+UG)**(-1)*MG2 + 2*S*UG*U1**(-1) + 2*S*
     +    UG*(TG+UG)**(-1) - 2*S*T1**(-1)*MG2 - 4*S*U1**(-1)*MG2 + 2*S*
     +    MG2*(UG-M2)*SYMBX - 4*S + 4*TG*UG*T1**(-1) - 2*TG*UG*U1**(-1)
     +    *MG2*S4G**(-1) + 2*TG*UG*U1**(-1) + 2*TG*UG*(UG-M2)*SYMBX - 2
     +    *TG*UG*S4G**(-1) - 8*TG - 4*TG**2*UG*T1**(-1)*(UG-M2)*SYMBX
     +     + 2*UG*U1**(-1)*MG2 + 4*UG*(TG+UG)**(-1)*MG2 + 4*UG*MG2*
     +    S4G**(-1) + 6*UG - 4*UG**2*T1**(-1) - 2*UG**2*U1**(-1)*MG2*
     +    S4G**(-1) - 2*UG**2*U1**(-1) - 4*UG**2*(TG+UG)**(-1) - 2*
     +    UG**2*(UG-M2)*SYMBX + 2*UG**2*S4G**(-1) + 4*UG**3*T1**(-1)*
     +    (TG+UG)**(-1) + 4*UG**3*U1**(-1)*S4G**(-1) - 8*MG2 )
     +
      M2QBH = M2QBH + ANG4(54)*N*CK * ( 8*S**(-1)*TG**2 + 8*S**(-1)*
     +    UG**2 + 4*S*TG*UG*U1**(-1)*(S+TG-M2)**(-1) + 2*S*UG*T1**(-1)*
     +    MG2*(UG-M2)*SYMBX - 4*S*UG*U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*S
     +    *UG*U1**(-1)*MS2*(S+TG-M2)**(-1) - 4*S*UG*U1**(-1) - 2*S*UG*
     +    (S+TG-M2)**(-1) + 2*S*UG**2*U1**(-1)*(S+TG-M2)**(-1) + 4*S*
     +    U1**(-1)*MG2 - 4*S*MG2*(UG-M2)*SYMBX + 4*S + 2*S**2*UG*
     +    U1**(-1)*(S+TG-M2)**(-1) + 2*TG*UG*T1**(-1) - 2*TG*UG*
     +    U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*TG*UG*U1**(-1)*MS2*
     +    (S+TG-M2)**(-1) - 4*TG*UG*U1**(-1) - 2*TG*UG*(S+TG-M2)**(-1)
     +     + 2*TG*UG*(UG-M2)*SYMBX - 4*TG*UG**2*T1**(-1)*(UG-M2)*SYMBX
     +     + 2*TG*UG**2*U1**(-1)*(S+TG-M2)**(-1) + 8*TG + 2*TG**2*UG*
     +    U1**(-1)*(S+TG-M2)**(-1) + 2*UG**2*T1**(-1) + 2*UG**2*
     +    U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*UG**2*U1**(-1)*MS2*
     +    (S+TG-M2)**(-1) - 2*UG**2*(S+TG-M2)**(-1) + 2*UG**2*(UG-M2)*
     +    SYMBX + 8*MG2 )
     +
      M2QBH = M2QBH + ANG4(56)*N*CO * (  - 8*S*MG2 )
     +
      M2QBH = M2QBH + ANG4(56)*N*CK * ( 8*S*MG2 )
     +
      M2QBH = M2QBH + ANG4(58)*N*CO * (  - 8*S**(-1)*TG*UG + 8*S**(-1)*
     +    UG**2 - 8*S**(-1)*UG**3*(TG+UG)**(-1) - 8*S**(-1)*UG**3*
     +    S4G**(-1) + 2*S*TG*T1**(-1) - 2*S*UG*U1**(-1)*(TG+UG)**(-1)*
     +    MG2 + 2*S*UG*U1**(-1)*MG2*(TG-M2)*SYMBY - 2*S*UG*
     +    (TG+UG)**(-1) - 4*S*T1**(-1)*MG2 + 2*S*MG2*(TG-M2)*SYMBY - 2*
     +    S - 2*TG*UG*T1**(-1)*MG2*S4G**(-1) + 2*TG*UG*T1**(-1) + 2*TG*
     +    UG*(TG-M2)*SYMBY + 6*TG*UG*S4G**(-1) + 2*TG*T1**(-1)*MG2 - TG
     +    *MG2*(TG-M2)*SYMBY + 4*TG*MG2*S4G**(-1) + TG*MS2*(TG-M2)*
     +    SYMBY + TG - 2*TG**2*T1**(-1)*MG2*S4G**(-1) - 2*TG**2*
     +    T1**(-1) - TG**2*(TG-M2)*SYMBY - 6*TG**2*S4G**(-1) + 4*TG**3*
     +    T1**(-1)*S4G**(-1) - 4*UG*(TG+UG)**(-1)*MG2 - 4*UG + 4*UG**2*
     +    U1**(-1)*(TG+UG)**(-1)*MG2 - 4*UG**2*U1**(-1)*(TG+UG)**(-1)*
     +    MS2 - 4*UG**2*U1**(-1)*MG2*(TG-M2)*SYMBY + 4*UG**2*U1**(-1)*
     +    MS2*(TG-M2)*SYMBY - 8*UG**2*(TG+UG)**(-1) - 8*UG**2*S4G**(-1)
     +     - 4*MG2 )
     +
      M2QBH = M2QBH + ANG4(58)*N*CK * ( 8*S**(-1)*TG**2 + 8*S**(-1)*
     +    UG**2 - 2*S*TG*T1**(-1)*MG2*(S+UG-M2)**(-1) - 2*S*TG*T1**(-1)
     +     + 2*S*TG*U1**(-1)*MG2*(TG-M2)*SYMBY - 2*S*TG*(S+UG-M2)**(-1)
     +     + 4*S*TG**2*T1**(-1)*(S+UG-M2)**(-1) + 4*S*T1**(-1)*MG2 - 4*
     +    S*MG2*(TG-M2)*SYMBY + 4*S - 2*TG*UG*T1**(-1) - 4*TG*UG*
     +    U1**(-1)*MG2*(TG-M2)*SYMBY + 4*TG*UG*U1**(-1)*MS2*(TG-M2)*
     +    SYMBY - 2*TG*UG*U1**(-1) - 2*TG*UG*(S+UG-M2)**(-1) - 2*TG*UG*
     +    (TG-M2)*SYMBY + 2*TG*MG2*(TG-M2)*SYMBY - 2*TG*MS2*(TG-M2)*
     +    SYMBY + 2*TG + 4*TG**2*UG*T1**(-1)*(S+UG-M2)**(-1) - 2*TG**2*
     +    T1**(-1) + 2*TG**2*U1**(-1) - 2*TG**2*(S+UG-M2)**(-1) + 4*UG*
     +    MG2*(TG-M2)*SYMBY - 4*UG*MS2*(TG-M2)*SYMBY + 12*UG + 8*MG2 )
     +
      M2QBH = M2QBH + ANG4(63)*N*CO * (  - 2*S**(-1)*UG*U1**(-1)*MG2*
     +    S4G**(-1) - 2*S**(-1)*UG*S4G**(-1) + 2*S**(-1)*U1**(-1)*MG2
     +     + 2*S**(-1) )
     +
      M2QBH = M2QBH + ANG4(63)*N*CK * (  - 2*UG*T1**(-1)*U1**(-1)*MG2*
     +    S4G**(-1) - 2*UG*T1**(-1)*S4G**(-1) + 2*T1**(-1)*U1**(-1)*MG2
     +     + 2*T1**(-1) )
     +
      M2QBH = M2QBH + ANG4(68)*N*CO * ( 2*S**(-1)*UG*T1**(-1)*MG2*
     +    S4G**(-1) + 2*S**(-1)*UG*S4G**(-1) + 2*T1**(-1)*MG2*S4G**(-1)
     +     + 2*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(68)*N*CK * (  - 2*TG*T1**(-1)*U1**(-1)*MG2*
     +    S4G**(-1) - 2*TG*U1**(-1)*S4G**(-1) + 2*T1**(-1)*U1**(-1)*MG2
     +     + 2*U1**(-1) )
     +
      M2QBH = M2QBH + ANG4(72)*N*CO * (  - 8*MG2*MS2**2 + 16*MG2**2*MS2
     +     - 8*MG2**3 )
     +
      M2QBH = M2QBH + ANG4(72)*N*CK * ( 8*MG2*MS2**2 - 16*MG2**2*MS2 + 
     +    8*MG2**3 )
     +
      M2QBH = M2QBH + ANG4(73)*N*CO * ( 4*TG*T1**(-1)*MG2*MS2 - 4*TG*
     +    T1**(-1)*MS2**2 + 4*TG**2*T1**(-1)*MG2 - 4*TG**2*T1**(-1)*MS2
     +     - 4*T1**(-1)*MG2*MS2**2 + 8*T1**(-1)*MG2**2*MS2 - 4*T1**(-1)
     +    *MG2**3 - 4*MG2*MS2 + 4*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(73)*N*CK * (  - 4*TG*T1**(-1)*MG2*MS2 + 4*TG
     +    *T1**(-1)*MS2**2 - 4*TG**2*T1**(-1)*MG2 + 4*TG**2*T1**(-1)*
     +    MS2 + 4*T1**(-1)*MG2*MS2**2 - 8*T1**(-1)*MG2**2*MS2 + 4*
     +    T1**(-1)*MG2**3 + 4*MG2*MS2 - 4*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(74)*N*CO * (  - 16*S**(-1)*MG2*MS2**2 + 32*
     +    S**(-1)*MG2**2*MS2 - 16*S**(-1)*MG2**3 - 16*MG2*MS2 )
     +
      M2QBH = M2QBH + ANG4(74)*N*CK * ( 16*S*MG2**2*(S-2*M2)**(-1) + 16
     +    *MG2*MS2 - 16*MG2**2 )
     +
      M2QBH = M2QBH + ANG4(75)*N*CO * ( 2*S**(-1)*TG*UG*T1**(-1)*MG2 + 
     +    8*S**(-1)*TG*T1**(-1)*MG2*MS2 - 4*S**(-1)*TG*T1**(-1)*MG2**2
     +     - 4*S**(-1)*TG*T1**(-1)*MS2**2 + 4*S**(-1)*TG**2*T1**(-1)*
     +    MG2 - 4*S**(-1)*TG**2*T1**(-1)*MS2 + 2*S**(-1)*UG*T1**(-1)*
     +    MG2*MS2 - 2*S**(-1)*UG*T1**(-1)*MG2**2 + 8*S**(-1)*UG*
     +    (TG+UG)**(-1)*MG2*MS2 - 8*S**(-1)*UG*(TG+UG)**(-1)*MG2**2 + 8
     +    *S**(-1)*UG*MG2*MS2*S4G**(-1) - 2*S**(-1)*UG*MG2 - 8*S**(-1)*
     +    UG*MG2**2*S4G**(-1) - 4*S**(-1)*T1**(-1)*MG2*MS2**2 + 8*
     +    S**(-1)*T1**(-1)*MG2**2*MS2 - 4*S**(-1)*T1**(-1)*MG2**3 + 8*
     +    S**(-1)*(TG+UG)**(-1)*MG2*MS2**2 - 16*S**(-1)*(TG+UG)**(-1)*
     +    MG2**2*MS2 + 8*S**(-1)*(TG+UG)**(-1)*MG2**3 - 4*S**(-1)*MG2*
     +    MS2 + 4*S**(-1)*MS2**2 - 2*S*UG*T1**(-1)*(TG+UG)**(-1)*MG2 + 
     +    2*S*T1**(-1)*MG2 + 4*TG*T1**(-1)*MG2*MS2*S4G**(-1) - 2*TG*
     +    T1**(-1)*MG2 - 2*TG*T1**(-1)*MG2**2*S4G**(-1) - 2*TG*T1**(-1)
     +    *MS2 - 2*TG*T1**(-1)*MS2**2*S4G**(-1) + 2*TG - 2*TG**2*UG*
     +    T1**(-1)*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(75)*N*CO * ( 4*TG**2*T1**(-2)*MG2 - 4*TG**2*
     +    T1**(-2)*MS2 - 4*TG**2*T1**(-1)*MG2*S4G**(-1) - 2*TG**2*
     +    T1**(-1) + 2*TG**2*S4G**(-1) - 2*TG**3*T1**(-1)*S4G**(-1) + 2
     +    *UG*T1**(-1)*(TG+UG)**(-1)*MG2*MS2 - 2*UG*T1**(-1)*
     +    (TG+UG)**(-1)*MG2**2 + 4*UG*T1**(-1)*MG2*MS2*S4G**(-1) + 2*UG
     +    *T1**(-1)*MG2 - 2*UG*T1**(-1)*MG2**2*S4G**(-1) - 4*UG*
     +    T1**(-1)*MS2 - 2*UG*T1**(-1)*MS2**2*S4G**(-1) + 2*UG*
     +    (TG+UG)**(-1)*MS2 - 4*UG*MG2*S4G**(-1) - 2*UG - 2*UG**2*
     +    T1**(-1)*(TG+UG)**(-1)*MG2 + 4*UG**2*T1**(-1)*(TG+UG)**(-1)*
     +    MS2 + 2*UG**2*(TG+UG)**(-1) - 10*T1**(-1)*MG2*MS2 - 4*
     +    T1**(-1)*MG2*MS2**2*S4G**(-1) + 8*T1**(-1)*MG2**2*MS2*
     +    S4G**(-1) + 2*T1**(-1)*MG2**2 - 4*T1**(-1)*MG2**3*S4G**(-1)
     +     + 8*(TG+UG)**(-1)*MG2*MS2 - 8*(TG+UG)**(-1)*MG2**2 - 10*MG2
     +     - 10*MG2**2*S4G**(-1) + 6*MS2 + 2*MS2**2*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(75)*N*CK * ( 2*S*TG*UG*T1**(-1)*
     +    (S+UG-M2)**(-1) - 2*S*TG*T1**(-1)*U1**(-1)*MG2 + 4*S*TG*
     +    T1**(-1)*MG2*(S-2*M2)**(-1) + 2*S*TG*U1**(-1)*MG2*
     +    (S-2*M2)**(-1) + 2*S*UG*T1**(-1)*MG2*(S-2*M2)**(-1) + 4*S*UG*
     +    U1**(-1)*MG2*(S-2*M2)**(-1) + 4*S*UG*MG2*(S+UG-M2)**(-1)*
     +    (S-2*M2)**(-1) + 6*S*T1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 2*S*
     +    T1**(-1)*MG2 + 2*S*T1**(-1)*MG2**2*(S-2*M2)**(-1) + 8*S*
     +    U1**(-1)*MG2**2*(S-2*M2)**(-1) + 8*S*MG2*(S-2*M2)**(-1) + 16*
     +    S*MG2**2*(S-2*M2)**(-2) + 2*S**2*T1**(-1)*MG2*(S-2*M2)**(-1)
     +     + 2*TG*UG*T1**(-1)*U1**(-1)*MG2 - 2*TG*UG*T1**(-1)*MG2*
     +    (S+UG-M2)**(-1) - 2*TG*UG*T1**(-1)*MG2*(S-2*M2)**(-1) + 2*TG*
     +    UG*T1**(-1)*MS2*(S+UG-M2)**(-1) - 2*TG*UG*T1**(-1) - 2*TG*UG*
     +    MG2*(S+UG-M2)**(-1)*(S-2*M2)**(-1) + 2*TG*UG**2*T1**(-1)*
     +    (S+UG-M2)**(-1) + 2*TG*T1**(-1)*U1**(-1)*MG2*MS2 - 2*TG*
     +    T1**(-1)*U1**(-1)*MG2**2 - 4*TG*T1**(-1)*MG2*MS2*
     +    (S-2*M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(75)*N*CK * (  - 6*TG*T1**(-1)*MG2 + 4*TG*
     +    T1**(-1)*MG2**2*(S-2*M2)**(-1) + 6*TG*T1**(-1)*MS2 + 2*TG*
     +    U1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 2*TG*U1**(-1)*MG2**2*
     +    (S-2*M2)**(-1) + 2*TG*MG2*(S-2*M2)**(-1) + 2*TG**2*UG*
     +    T1**(-1)*(S+UG-M2)**(-1) - 4*TG**2*T1**(-2)*MG2 + 4*TG**2*
     +    T1**(-2)*MS2 + 2*TG**2*T1**(-1) - 4*UG*T1**(-1)*MG2*MS2*
     +    (S+UG-M2)**(-1) + 2*UG*T1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 2*UG
     +    *T1**(-1)*MG2 + 2*UG*T1**(-1)*MG2**2*(S+UG-M2)**(-1) - 2*UG*
     +    T1**(-1)*MG2**2*(S-2*M2)**(-1) + 2*UG*T1**(-1)*MS2**2*
     +    (S+UG-M2)**(-1) + 2*UG*U1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 6*UG
     +    *U1**(-1)*MG2 - 2*UG*U1**(-1)*MG2**2*(S-2*M2)**(-1) + 2*UG*
     +    MG2*MS2*(S+UG-M2)**(-1)*(S-2*M2)**(-1) + 2*UG*MG2*
     +    (S-2*M2)**(-1) - 2*UG*MG2**2*(S+UG-M2)**(-1)*(S-2*M2)**(-1)
     +     + 6*T1**(-1)*MG2*MS2 + 4*T1**(-1)*MG2*MS2**2*(S-2*M2)**(-1)
     +     - 8*T1**(-1)*MG2**2*MS2*(S-2*M2)**(-1) - 6*T1**(-1)*MG2**2
     +     + 4*T1**(-1)*MG2**3*(S-2*M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(75)*N*CK * (  - 4*U1**(-1)*MG2*MS2 + 4*
     +    U1**(-1)*MG2**2 + 4*MG2 - 8*MS2 )
     +
      M2QBH = M2QBH + ANG4(76)*N*CO * (  - 4*S**(-1)*TG*UG*MG2*(UG-M2)*
     +    SYMBX + 4*S**(-1)*TG*UG*MS2*(UG-M2)*SYMBX - S**(-1)*TG*UG + 
     +    S**(-1)*TG*UG**2*(UG-M2)*SYMBX - 6*S**(-1)*TG*MG2*MS2*(UG-M2)
     +    *SYMBX + 3*S**(-1)*TG*MG2 + 3*S**(-1)*TG*MG2**2*(UG-M2)*SYMBX
     +     - 3*S**(-1)*TG*MS2 + 3*S**(-1)*TG*MS2**2*(UG-M2)*SYMBX + 2*
     +    S**(-1)*TG**2*UG*(UG-M2)*SYMBX - 2*S**(-1)*TG**2*MG2*(UG-M2)*
     +    SYMBX + 2*S**(-1)*TG**2*MS2*(UG-M2)*SYMBX + 8*S**(-1)*UG*
     +    (TG+UG)**(-1)*MG2*MS2 - 8*S**(-1)*UG*(TG+UG)**(-1)*MG2**2 + 2
     +    *S**(-1)*UG*MG2*MS2*(UG-M2)*SYMBX - S**(-1)*UG*MG2 - S**(-1)*
     +    UG*MG2**2*(UG-M2)*SYMBX + S**(-1)*UG*MS2 - S**(-1)*UG*MS2**2*
     +    (UG-M2)*SYMBX + 2*S**(-1)*UG**2*MG2*(UG-M2)*SYMBX - 2*S**(-1)
     +    *UG**2*MS2*(UG-M2)*SYMBX + S**(-1)*UG**2 - S**(-1)*UG**3*
     +    (UG-M2)*SYMBX + 8*S**(-1)*(TG+UG)**(-1)*MG2*MS2**2 - 16*
     +    S**(-1)*(TG+UG)**(-1)*MG2**2*MS2 + 8*S**(-1)*(TG+UG)**(-1)*
     +    MG2**3 - 4*S**(-1)*MG2*MS2 + 2*S**(-1)*MG2**2 + 2*S**(-1)*
     +    MS2**2 )
     +
      M2QBH = M2QBH + ANG4(76)*N*CO * (  - 2*S*TG*T1**(-1)*MG2*(UG-M2)*
     +    SYMBX - 2*S*UG*T1**(-1)*(TG+UG)**(-1)*MG2 + 2*S*T1**(-1)*MG2
     +     - 2*S*MG2*(UG-M2)*SYMBX + 2*TG*UG*T1**(-1)*MG2*(UG-M2)*SYMBX
     +     + 2*TG*UG*(UG-M2)*SYMBX + 2*TG*T1**(-1)*MG2*MS2*(UG-M2)*
     +    SYMBX - 4*TG*T1**(-1)*MG2 - 2*TG*T1**(-1)*MG2**2*(UG-M2)*
     +    SYMBX + 4*TG*T1**(-1)*MS2 - 4*TG*MG2*(UG-M2)*SYMBX + 4*TG*MS2
     +    *(UG-M2)*SYMBX + 4*TG**2*T1**(-1)*MG2*(UG-M2)*SYMBX - 4*TG**2
     +    *T1**(-1)*MS2*(UG-M2)*SYMBX + 2*UG*T1**(-1)*(TG+UG)**(-1)*MG2
     +    *MS2 - 2*UG*T1**(-1)*(TG+UG)**(-1)*MG2**2 + 2*UG*T1**(-1)*MG2
     +     - 4*UG*T1**(-1)*MS2 + 2*UG*(TG+UG)**(-1)*MS2 + 3*UG*MG2*
     +    (UG-M2)*SYMBX - 3*UG*MS2*(UG-M2)*SYMBX - UG - 2*UG**2*
     +    T1**(-1)*(TG+UG)**(-1)*MG2 + 4*UG**2*T1**(-1)*(TG+UG)**(-1)*
     +    MS2 + 2*UG**2*(TG+UG)**(-1) - UG**2*(UG-M2)*SYMBX - 2*
     +    T1**(-1)*MG2*MS2 + 2*T1**(-1)*MG2**2 + 8*(TG+UG)**(-1)*MG2*
     +    MS2 - 8*(TG+UG)**(-1)*MG2**2 - 4*MG2 )
     +
      M2QBH = M2QBH + ANG4(76)*N*CK * ( 2*S*TG*T1**(-1)*MG2*
     +    (S+UG-M2)**(-1) - 4*S*TG*T1**(-1)*MS2*(S+UG-M2)**(-1) - 2*S*
     +    TG*(S+UG-M2)**(-1) - 2*S*UG*T1**(-1)*MG2*(S+UG-M2)**(-1) + 2*
     +    S*UG*T1**(-1)*MG2*(UG-M2)*SYMBX - 4*S*T1**(-1)*MG2*MS2*
     +    (S+UG-M2)**(-1) + 4*S*T1**(-1)*MG2*MS2*(UG-M2)*SYMBX + 2*S*
     +    T1**(-1)*MG2 + 4*S*T1**(-1)*MG2**2*(S+UG-M2)**(-1) - 4*S*
     +    T1**(-1)*MG2**2*(UG-M2)*SYMBX + 4*S*MG2*(UG-M2)*SYMBX - 2*
     +    S**2*T1**(-1)*MG2*(S+UG-M2)**(-1) + 4*TG*UG*T1**(-1)*MG2*
     +    (S+UG-M2)**(-1) - 2*TG*UG*T1**(-1)*MG2*(UG-M2)*SYMBX - 4*TG*
     +    UG*T1**(-1)*MS2*(S+UG-M2)**(-1) - 2*TG*UG*(S+UG-M2)**(-1) + 8
     +    *TG*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) - 10*TG*T1**(-1)*MG2*MS2
     +    *(UG-M2)*SYMBX - 2*TG*T1**(-1)*MG2 - 4*TG*T1**(-1)*MG2**2*
     +    (S+UG-M2)**(-1) + 6*TG*T1**(-1)*MG2**2*(UG-M2)*SYMBX - 4*TG*
     +    T1**(-1)*MS2**2*(S+UG-M2)**(-1) + 4*TG*T1**(-1)*MS2**2*
     +    (UG-M2)*SYMBX - 2*TG*MG2*(UG-M2)*SYMBX + 2*TG*MS2*(UG-M2)*
     +    SYMBX )
     +
      M2QBH = M2QBH + ANG4(76)*N*CK * ( 4*TG**2*T1**(-1)*MG2*
     +    (S+UG-M2)**(-1) - 4*TG**2*T1**(-1)*MS2*(S+UG-M2)**(-1) - 2*
     +    TG**2*(S+UG-M2)**(-1) - 2*UG*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1)
     +     + 2*UG*T1**(-1)*MG2**2*(S+UG-M2)**(-1) + 2*UG*T1**(-1)*
     +    MG2**2*(UG-M2)*SYMBX + 2*UG*T1**(-1)*MS2 - 2*UG*T1**(-1)*
     +    MS2**2*(UG-M2)*SYMBX + 2*UG*MG2*(UG-M2)*SYMBX + 2*UG*MS2*
     +    (UG-M2)*SYMBX - 2*UG**2*T1**(-1)*MS2*(UG-M2)*SYMBX - 2*
     +    T1**(-1)*MG2*MS2**2*(S+UG-M2)**(-1) - 2*T1**(-1)*MG2*MS2**2*
     +    (UG-M2)*SYMBX + 4*T1**(-1)*MG2**2*MS2*(S+UG-M2)**(-1) + 4*
     +    T1**(-1)*MG2**2*MS2*(UG-M2)*SYMBX - 2*T1**(-1)*MG2**3*
     +    (S+UG-M2)**(-1) - 2*T1**(-1)*MG2**3*(UG-M2)*SYMBX + 4*MG2*MS2
     +    *(UG-M2)*SYMBX - 4*MG2**2*(UG-M2)*SYMBX )
     +
      M2QBH = M2QBH + ANG4(78)*N*CO * (  - 2*S**(-1)*UG*T1**(-1)*MG2*
     +    S4G**(-1) - 2*T1**(-1)*MG2*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(78)*N*CK * ( 2*TG*T1**(-1)*U1**(-1)*MG2*
     +    S4G**(-1) - 2*T1**(-1)*U1**(-1)*MG2 )
     +
      M2QBH = M2QBH + ANG4(79)*N*CO * ( 4*TG*T1**(-2)*MG2*MS2 - 4*TG*
     +    T1**(-2)*MS2**2 + 4*T1**(-1)*MG2*MS2 - 4*T1**(-1)*MG2**2 + 2*
     +    MG2 - 2*MS2 )
     +
      M2QBH = M2QBH + ANG4(79)*N*CK * (  - 12*TG*T1**(-2)*MG2*MS2 + 12*
     +    TG*T1**(-2)*MS2**2 - 12*T1**(-1)*MG2*MS2 + 12*T1**(-1)*MG2**2
     +     - 6*MG2 + 6*MS2 )
     +
      M2QBH = M2QBH + ANG4(79)*CQED * ( 4*TG*T1**(-2)*MG2*MS2 - 4*TG*
     +    T1**(-2)*MS2**2 + 4*T1**(-1)*MG2*MS2 - 4*T1**(-1)*MG2**2 + 2*
     +    MG2 - 2*MS2 )
     +
      M2QBH = M2QBH + ANG4(80)*N*CO * (  - 1 + 2*S**(-1)*UG*T1**(-1)*
     +    MG2*MS2*S4G**(-1) - 2*S**(-1)*UG*T1**(-1)*MG2 - 2*S**(-1)*UG*
     +    T1**(-1)*MG2**2*S4G**(-1) + 4*S**(-1)*UG*T1**(-1)*MS2 + 2*
     +    S**(-1)*UG*MG2*(UG-M2)*SYMBX - 2*S**(-1)*UG*MG2*S4G**(-1) - 2
     +    *S**(-1)*UG*MS2*(UG-M2)*SYMBX - 2*S**(-1)*UG*MS2*S4G**(-1) + 
     +    3*S**(-1)*UG - 4*S**(-1)*UG**2*T1**(-1)*MS2*S4G**(-1) - 
     +    S**(-1)*UG**2*(UG-M2)*SYMBX - 2*S**(-1)*UG**2*S4G**(-1) + 2*
     +    S**(-1)*T1**(-1)*MG2*MS2 - 2*S**(-1)*T1**(-1)*MG2**2 + 2*
     +    S**(-1)*MG2*MS2*(UG-M2)*SYMBX - S**(-1)*MG2 - S**(-1)*MG2**2*
     +    (UG-M2)*SYMBX + S**(-1)*MS2 - S**(-1)*MS2**2*(UG-M2)*SYMBX - 
     +    4*TG*T1**(-2)*MG2*MS2*S4G**(-1) + 4*TG*T1**(-2)*MG2 + 4*TG*
     +    T1**(-2)*MG2**2*S4G**(-1) - 4*TG*T1**(-2)*MS2 - 2*TG*T1**(-1)
     +    *MG2*S4G**(-1) + 6*TG*T1**(-1)*MS2*S4G**(-1) + 2*TG*T1**(-1)
     +     + 2*TG*S4G**(-1) - 4*TG**2*T1**(-2)*MS2*S4G**(-1) - 2*TG**2*
     +    T1**(-1)*S4G**(-1) - 4*UG*T1**(-1)*MS2*S4G**(-1) - UG*(UG-M2)
     +    *SYMBX )
     +
      M2QBH = M2QBH + ANG4(80)*N*CO * (  - 2*UG*S4G**(-1) + 4*T1**(-1)*
     +    MG2*MS2*S4G**(-1) - 6*T1**(-1)*MG2 - 12*T1**(-1)*MG2**2*
     +    S4G**(-1) + 2*T1**(-1)*MS2 + MG2*(UG-M2)*SYMBX - 2*MG2*
     +    S4G**(-1) - MS2*(UG-M2)*SYMBX - 2*MS2*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(80)*N*CK * ( 6 + 8*S*TG*T1**(-2)*MG2*
     +    (S+UG-M2)**(-1) - 8*S*TG*T1**(-2)*MS2*(S+UG-M2)**(-1) - 4*S*
     +    T1**(-1)*U1**(-1)*MG2 + 4*S*T1**(-1)*MG2*(S+UG-M2)**(-1) - 4*
     +    S*T1**(-1)*MS2*(S+UG-M2)**(-1) + 8*TG*UG*T1**(-2)*MG2*
     +    (S+UG-M2)**(-1) - 8*TG*UG*T1**(-2)*MS2*(S+UG-M2)**(-1) + 16*
     +    TG*T1**(-2)*MG2*MS2*(S+UG-M2)**(-1) + 4*TG*T1**(-2)*MG2*MS2*
     +    S4G**(-1) - 20*TG*T1**(-2)*MG2 - 8*TG*T1**(-2)*MG2**2*
     +    (S+UG-M2)**(-1) - 4*TG*T1**(-2)*MG2**2*S4G**(-1) + 20*TG*
     +    T1**(-2)*MS2 - 8*TG*T1**(-2)*MS2**2*(S+UG-M2)**(-1) + 4*TG*
     +    T1**(-1)*U1**(-1)*MG2*MS2*S4G**(-1) + 4*TG*T1**(-1)*U1**(-1)*
     +    MG2**2*S4G**(-1) - 4*TG*T1**(-1)*MG2*(S+UG-M2)**(-1) + 2*TG*
     +    T1**(-1)*MG2*S4G**(-1) + 4*TG*T1**(-1)*MS2*(S+UG-M2)**(-1) - 
     +    2*TG*T1**(-1)*MS2*S4G**(-1) - 6*TG*T1**(-1) + 2*TG*U1**(-1)*
     +    MG2*S4G**(-1) + 8*TG**2*T1**(-2)*MG2*(S+UG-M2)**(-1) - 8*
     +    TG**2*T1**(-2)*MS2*(S+UG-M2)**(-1) + 4*TG**2*T1**(-2)*MS2*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(80)*N*CK * ( 2*TG**2*T1**(-1)*S4G**(-1) + 2*
     +    UG*T1**(-1)*U1**(-1)*MG2*MS2*S4G**(-1) + 2*UG*T1**(-1)*
     +    U1**(-1)*MG2 + 6*UG*T1**(-1)*U1**(-1)*MG2**2*S4G**(-1) + 4*UG
     +    *T1**(-1)*MG2*(S+UG-M2)**(-1) + 2*UG*T1**(-1)*MG2*(UG-M2)*
     +    SYMBX - 4*UG*T1**(-1)*MS2*(S+UG-M2)**(-1) - 2*UG*T1**(-1)*MS2
     +    *(UG-M2)*SYMBX - 2*T1**(-1)*U1**(-1)*MG2*MS2 - 6*T1**(-1)*
     +    U1**(-1)*MG2**2 - 4*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) + 4*
     +    T1**(-1)*MG2*MS2*(UG-M2)*SYMBX - 4*T1**(-1)*MG2*MS2*S4G**(-1)
     +     - 8*T1**(-1)*MG2 + 4*T1**(-1)*MG2**2*(S+UG-M2)**(-1) - 2*
     +    T1**(-1)*MG2**2*(UG-M2)*SYMBX + 4*T1**(-1)*MG2**2*S4G**(-1)
     +     - 2*T1**(-1)*MS2**2*(UG-M2)*SYMBX - 4*U1**(-1)*MG2*MS2*
     +    S4G**(-1) - 2*U1**(-1)*MG2 + 4*U1**(-1)*MG2**2*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(80)*CQED * (  - 2 - 4*S*TG*T1**(-2)*MG2*
     +    (S+UG-M2)**(-1) + 4*S*TG*T1**(-2)*MS2*(S+UG-M2)**(-1) - 2*S*
     +    T1**(-1)*U1**(-1)*MG2 - 2*S*T1**(-1)*MG2*(S+UG-M2)**(-1) + 2*
     +    S*T1**(-1)*MS2*(S+UG-M2)**(-1) - 4*TG*UG*T1**(-2)*MG2*
     +    (S+UG-M2)**(-1) + 4*TG*UG*T1**(-2)*MS2*(S+UG-M2)**(-1) - 8*TG
     +    *T1**(-2)*MG2*MS2*(S+UG-M2)**(-1) + 8*TG*T1**(-2)*MG2 + 4*TG*
     +    T1**(-2)*MG2**2*(S+UG-M2)**(-1) - 8*TG*T1**(-2)*MS2 + 4*TG*
     +    T1**(-2)*MS2**2*(S+UG-M2)**(-1) + 2*TG*T1**(-1)*MG2*
     +    (S+UG-M2)**(-1) - 2*TG*T1**(-1)*MS2*(S+UG-M2)**(-1) + 2*TG*
     +    T1**(-1) - 4*TG**2*T1**(-2)*MG2*(S+UG-M2)**(-1) + 4*TG**2*
     +    T1**(-2)*MS2*(S+UG-M2)**(-1) - 2*UG*T1**(-1)*U1**(-1)*MG2 - 2
     +    *UG*T1**(-1)*MG2*(S+UG-M2)**(-1) + 2*UG*T1**(-1)*MS2*
     +    (S+UG-M2)**(-1) + 2*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) + 2*
     +    T1**(-1)*MG2 - 2*T1**(-1)*MG2**2*(S+UG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(81)*N*CO * (  - 2*TG*MG2 + 2*TG*MS2 + 4*
     +    TG**2*T1**(-1)*MG2 - 4*TG**2*T1**(-1)*MS2 - 4*MG2*MS2 + 2*
     +    MG2**2 + 2*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(81)*N*CK * (  - 16*TG*T1**(-1)*MG2*MS2 + 8*
     +    TG*T1**(-1)*MG2**2 + 8*TG*T1**(-1)*MS2**2 - 2*TG*MG2 + 2*TG*
     +    MS2 - 4*TG**2*T1**(-1)*MG2 + 4*TG**2*T1**(-1)*MS2 + 12*MG2*
     +    MS2 - 6*MG2**2 - 6*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(81)*CQED * ( 8*TG*T1**(-1)*MG2*MS2 - 4*TG*
     +    T1**(-1)*MG2**2 - 4*TG*T1**(-1)*MS2**2 + 2*TG*MG2 - 2*TG*MS2
     +     - 4*MG2*MS2 + 2*MG2**2 + 2*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(82)*N*CO * ( 2*S**(-1)*TG*UG*T1**(-1)*MG2 + 
     +    2*S**(-1)*TG*UG*MG2*(UG-M2)*SYMBX - 2*S**(-1)*TG*UG*MS2*
     +    (UG-M2)*SYMBX + 2*S**(-1)*TG*T1**(-1)*MG2*MS2 - 2*S**(-1)*TG*
     +    T1**(-1)*MG2**2 + 4*S**(-1)*TG*MG2*MS2*(UG-M2)*SYMBX - 4*
     +    S**(-1)*TG*MG2 - 2*S**(-1)*TG*MG2**2*(UG-M2)*SYMBX + 4*
     +    S**(-1)*TG*MS2 - 2*S**(-1)*TG*MS2**2*(UG-M2)*SYMBX - 2*
     +    S**(-1)*TG**2*UG*(UG-M2)*SYMBX + 4*S**(-1)*TG**2*T1**(-1)*MG2
     +     - 4*S**(-1)*TG**2*T1**(-1)*MS2 + 2*S**(-1)*TG**2*MG2*(UG-M2)
     +    *SYMBX - 2*S**(-1)*TG**2*MS2*(UG-M2)*SYMBX + 2*S*TG*T1**(-1)*
     +    MG2*(UG-M2)*SYMBX + 2*S*MG2*(UG-M2)*SYMBX - 2*TG*UG*T1**(-1)*
     +    MG2*(UG-M2)*SYMBX - 2*TG*T1**(-1)*MG2*MS2*(UG-M2)*SYMBX - 2*
     +    TG*T1**(-1)*MG2 + 2*TG*T1**(-1)*MG2**2*(UG-M2)*SYMBX + 2*TG*
     +    MG2*(UG-M2)*SYMBX - 2*TG*MS2*(UG-M2)*SYMBX + 2*TG + 4*TG**2*
     +    T1**(-2)*MG2 - 4*TG**2*T1**(-2)*MS2 - 4*TG**2*T1**(-1)*MG2*
     +    (UG-M2)*SYMBX + 4*TG**2*T1**(-1)*MS2*(UG-M2)*SYMBX - 4*TG**2*
     +    T1**(-1) )
     +
      M2QBH = M2QBH + ANG4(82)*N*CO * ( 4*MG2*MS2*(UG-M2)*SYMBX - 2*MG2
     +     - 2*MG2**2*(UG-M2)*SYMBX + 4*MS2 - 2*MS2**2*(UG-M2)*SYMBX )
     +
      M2QBH = M2QBH + ANG4(82)*N*CK * ( 2*S*TG*UG*T1**(-1)*
     +    (S+UG-M2)**(-1) - 2*S*TG*T1**(-1)*U1**(-1)*MG2 - 2*S*TG*
     +    T1**(-1)*MG2*(S+UG-M2)**(-1) + 2*S*TG*T1**(-1)*MG2*
     +    (S-2*M2)**(-1) + 2*S*TG*T1**(-1)*MS2*(S+UG-M2)**(-1) - 2*S*TG
     +    *T1**(-1) - 2*S*TG*MG2*(S+TG-M2)**(-1)*(S-2*M2)**(-1) + 2*S*
     +    TG*(S+UG-M2)**(-1) + 2*S*TG**2*T1**(-1)*(S+UG-M2)**(-1) + 4*S
     +    *UG*U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*S*T1**(-1)*U1**(-1)*MG2*
     +    MS2 + 2*S*T1**(-1)*U1**(-1)*MG2**2 - 4*S*T1**(-1)*MG2*MS2*
     +    (S+UG-M2)**(-1) - 2*S*T1**(-1)*MG2*MS2*(UG-M2)*SYMBX + 2*S*
     +    T1**(-1)*MG2**2*(S+UG-M2)**(-1) + 2*S*T1**(-1)*MG2**2*(UG-M2)
     +    *SYMBX + 2*S*T1**(-1)*MS2**2*(S+UG-M2)**(-1) + 2*S*U1**(-1)*
     +    MG2*MS2*(S+TG-M2)**(-1) - 6*S*U1**(-1)*MG2 - 2*S*U1**(-1)*
     +    MG2**2*(S+TG-M2)**(-1) - 2*S*MG2*(S+TG-M2)**(-1) + 4*S*MG2*
     +    (S+UG-M2)**(-1) - 4*S*MG2*(UG-M2)*SYMBX + 2*S**2*TG*T1**(-1)*
     +    (S+UG-M2)**(-1) + 4*TG*UG*T1**(-1)*U1**(-1)*MG2 + 2*TG*UG*
     +    T1**(-1)*MG2*(UG-M2)*SYMBX )
     +
      M2QBH = M2QBH + ANG4(82)*N*CK * (  - 2*TG*UG*T1**(-1)*MG2*
     +    (S-2*M2)**(-1) + 2*TG*UG*U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*TG*
     +    UG*U1**(-1)*MG2*S4G**(-1) + 2*TG*UG*MG2*(S+TG-M2)**(-1)*
     +    (S-2*M2)**(-1) + 2*TG*UG*(S+UG-M2)**(-1) - 2*TG*UG*(UG-M2)*
     +    SYMBX + 4*TG*T1**(-1)*U1**(-1)*MG2*MS2 - 4*TG*T1**(-1)*
     +    U1**(-1)*MG2**2 + 10*TG*T1**(-1)*MG2*MS2*(UG-M2)*SYMBX - 2*TG
     +    *T1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 12*TG*T1**(-1)*MG2 - 6*TG*
     +    T1**(-1)*MG2**2*(UG-M2)*SYMBX + 2*TG*T1**(-1)*MG2**2*
     +    (S-2*M2)**(-1) + 12*TG*T1**(-1)*MS2 - 4*TG*T1**(-1)*MS2**2*
     +    (UG-M2)*SYMBX + 2*TG*U1**(-1)*MG2*MS2*(S+TG-M2)**(-1) - 2*TG*
     +    U1**(-1)*MG2**2*(S+TG-M2)**(-1) + 2*TG*MG2*MS2*
     +    (S+TG-M2)**(-1)*(S-2*M2)**(-1) - 2*TG*MG2*(S+UG-M2)**(-1) + 4
     +    *TG*MG2*(UG-M2)*SYMBX - 2*TG*MG2**2*(S+TG-M2)**(-1)*
     +    (S-2*M2)**(-1) + 2*TG*MS2*(S+UG-M2)**(-1) - 4*TG*MS2*(UG-M2)*
     +    SYMBX + 2*TG - 2*TG**2*UG*T1**(-1)*S4G**(-1) - 4*TG**2*
     +    T1**(-2)*MG2 )
     +
      M2QBH = M2QBH + ANG4(82)*N*CK * ( 4*TG**2*T1**(-2)*MS2 + 2*TG**2*
     +    T1**(-1) + 2*TG**2*(S+UG-M2)**(-1) + 4*UG*T1**(-1)*MG2*MS2*
     +    S4G**(-1) - 2*UG*T1**(-1)*MG2**2*S4G**(-1) - 2*UG*T1**(-1)*
     +    MS2**2*S4G**(-1) - 2*UG*U1**(-1)*MG2*MS2*S4G**(-1) - 4*UG*
     +    U1**(-1)*MG2 + 2*UG*U1**(-1)*MG2**2*S4G**(-1) - 4*UG*MG2*
     +    (UG-M2)*SYMBX - 4*UG**2*U1**(-1)*MG2*S4G**(-1) - 4*T1**(-1)*
     +    MG2*MS2 + 2*T1**(-1)*MG2**2 + 2*T1**(-1)*MS2**2 - 6*U1**(-1)*
     +    MG2*MS2 + 6*U1**(-1)*MG2**2 - 4*MG2*MS2*(S+UG-M2)**(-1) - 8*
     +    MG2*MS2*(UG-M2)*SYMBX + 12*MG2 + 2*MG2**2*(S+UG-M2)**(-1) + 6
     +    *MG2**2*(UG-M2)*SYMBX - 12*MS2 + 2*MS2**2*(S+UG-M2)**(-1) + 2
     +    *MS2**2*(UG-M2)*SYMBX )
     +
      M2QBH = M2QBH + ANG4(82)*CQED * (  - 2*S*TG*UG*T1**(-1)*
     +    (S+UG-M2)**(-1) + 2*S*TG*T1**(-1)*MG2*(S+UG-M2)**(-1) - 2*S*
     +    TG*T1**(-1)*MS2*(S+UG-M2)**(-1) + 2*S*TG*T1**(-1) - 2*S*TG**2
     +    *T1**(-1)*(S+UG-M2)**(-1) - 4*S*UG*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) + 2*S*T1**(-1)*U1**(-1)*MG2*MS2 - 2*S*
     +    T1**(-1)*U1**(-1)*MG2**2 + 4*S*T1**(-1)*MG2*MS2*
     +    (S+UG-M2)**(-1) - 2*S*T1**(-1)*MG2**2*(S+UG-M2)**(-1) - 2*S*
     +    T1**(-1)*MS2**2*(S+UG-M2)**(-1) - 2*S*U1**(-1)*MG2*MS2*
     +    (S+TG-M2)**(-1) + 4*S*U1**(-1)*MG2 + 2*S*U1**(-1)*MG2**2*
     +    (S+TG-M2)**(-1) + 4*S*MG2*(S+TG-M2)**(-1) - 2*S**2*TG*
     +    T1**(-1)*(S+UG-M2)**(-1) - 4*S**2*MG2*(S+TG-M2)**(-1)*
     +    (S+UG-M2)**(-1) - 2*TG*UG*T1**(-1)*U1**(-1)*MG2 - 2*TG*UG*
     +    U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*TG*T1**(-1)*U1**(-1)*MG2*MS2
     +     + 2*TG*T1**(-1)*U1**(-1)*MG2**2 + 6*TG*T1**(-1)*MG2 - 6*TG*
     +    T1**(-1)*MS2 - 2*TG*U1**(-1)*MG2*MS2*(S+TG-M2)**(-1) + 2*TG*
     +    U1**(-1)*MG2**2*(S+TG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(82)*CQED * (  - 2*TG + 2*TG**2*T1**(-1) + 4*
     +    UG*U1**(-1)*MG2 + 4*U1**(-1)*MG2*MS2 - 4*U1**(-1)*MG2**2 - 4*
     +    MG2 + 4*MS2 )
     +
      M2QBH = M2QBH + ANG4(85)*N*CO * (  - 2*UG*MG2 + 2*UG*MS2 + 4*
     +    UG**2*U1**(-1)*MG2 - 4*UG**2*U1**(-1)*MS2 - 4*MG2*MS2 + 2*
     +    MG2**2 + 2*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(85)*N*CK * (  - 16*UG*U1**(-1)*MG2*MS2 + 8*
     +    UG*U1**(-1)*MG2**2 + 8*UG*U1**(-1)*MS2**2 - 2*UG*MG2 + 2*UG*
     +    MS2 - 4*UG**2*U1**(-1)*MG2 + 4*UG**2*U1**(-1)*MS2 + 12*MG2*
     +    MS2 - 6*MG2**2 - 6*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(85)*CQED * ( 8*UG*U1**(-1)*MG2*MS2 - 4*UG*
     +    U1**(-1)*MG2**2 - 4*UG*U1**(-1)*MS2**2 + 2*UG*MG2 - 2*UG*MS2
     +     - 4*MG2*MS2 + 2*MG2**2 + 2*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(86)*N*CO * ( 2*S**(-1)*TG*UG*U1**(-1)*MG2 + 
     +    2*S**(-1)*TG*UG*MG2*(TG-M2)*SYMBY - 2*S**(-1)*TG*UG*MS2*
     +    (TG-M2)*SYMBY - 2*S**(-1)*TG*UG**2*(TG-M2)*SYMBY + 2*S**(-1)*
     +    UG*U1**(-1)*MG2*MS2 - 2*S**(-1)*UG*U1**(-1)*MG2**2 + 4*
     +    S**(-1)*UG*MG2*MS2*(TG-M2)*SYMBY - 4*S**(-1)*UG*MG2 - 2*
     +    S**(-1)*UG*MG2**2*(TG-M2)*SYMBY + 4*S**(-1)*UG*MS2 - 2*
     +    S**(-1)*UG*MS2**2*(TG-M2)*SYMBY + 4*S**(-1)*UG**2*U1**(-1)*
     +    MG2 - 4*S**(-1)*UG**2*U1**(-1)*MS2 + 2*S**(-1)*UG**2*MG2*
     +    (TG-M2)*SYMBY - 2*S**(-1)*UG**2*MS2*(TG-M2)*SYMBY + 2*S*UG*
     +    U1**(-1)*MG2*(TG-M2)*SYMBY + 2*S*MG2*(TG-M2)*SYMBY - 2*TG*UG*
     +    U1**(-1)*MG2*(TG-M2)*SYMBY - 2*UG*U1**(-1)*MG2*MS2*(TG-M2)*
     +    SYMBY - 2*UG*U1**(-1)*MG2 + 2*UG*U1**(-1)*MG2**2*(TG-M2)*
     +    SYMBY + 2*UG*MG2*(TG-M2)*SYMBY - 2*UG*MS2*(TG-M2)*SYMBY + 2*
     +    UG + 4*UG**2*U1**(-2)*MG2 - 4*UG**2*U1**(-2)*MS2 - 4*UG**2*
     +    U1**(-1)*MG2*(TG-M2)*SYMBY + 4*UG**2*U1**(-1)*MS2*(TG-M2)*
     +    SYMBY )
     +
      M2QBH = M2QBH + ANG4(86)*N*CO * (  - 4*UG**2*U1**(-1) + 4*MG2*MS2
     +    *(TG-M2)*SYMBY - 2*MG2 - 2*MG2**2*(TG-M2)*SYMBY + 4*MS2 - 2*
     +    MS2**2*(TG-M2)*SYMBY )
     +
      M2QBH = M2QBH + ANG4(86)*N*CK * ( 2*S*TG*UG*U1**(-1)*
     +    (S+TG-M2)**(-1) + 4*S*TG*T1**(-1)*MG2*(S+UG-M2)**(-1) - 2*S*
     +    UG*T1**(-1)*U1**(-1)*MG2 - 2*S*UG*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) + 2*S*UG*U1**(-1)*MG2*(S-2*M2)**(-1) + 2*S*UG
     +    *U1**(-1)*MS2*(S+TG-M2)**(-1) - 2*S*UG*U1**(-1) - 2*S*UG*MG2*
     +    (S+UG-M2)**(-1)*(S-2*M2)**(-1) + 2*S*UG*(S+TG-M2)**(-1) + 2*S
     +    *UG**2*U1**(-1)*(S+TG-M2)**(-1) - 2*S*T1**(-1)*U1**(-1)*MG2*
     +    MS2 + 2*S*T1**(-1)*U1**(-1)*MG2**2 + 2*S*T1**(-1)*MG2*MS2*
     +    (S+UG-M2)**(-1) - 6*S*T1**(-1)*MG2 - 2*S*T1**(-1)*MG2**2*
     +    (S+UG-M2)**(-1) - 4*S*U1**(-1)*MG2*MS2*(S+TG-M2)**(-1) - 2*S*
     +    U1**(-1)*MG2*MS2*(TG-M2)*SYMBY + 2*S*U1**(-1)*MG2**2*
     +    (S+TG-M2)**(-1) + 2*S*U1**(-1)*MG2**2*(TG-M2)*SYMBY + 2*S*
     +    U1**(-1)*MS2**2*(S+TG-M2)**(-1) + 4*S*MG2*(S+TG-M2)**(-1) - 2
     +    *S*MG2*(S+UG-M2)**(-1) - 4*S*MG2*(TG-M2)*SYMBY + 2*S**2*UG*
     +    U1**(-1)*(S+TG-M2)**(-1) + 4*TG*UG*T1**(-1)*U1**(-1)*MG2 + 2*
     +    TG*UG*T1**(-1)*MG2*(S+UG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(86)*N*CK * (  - 2*TG*UG*T1**(-1)*MG2*
     +    S4G**(-1) + 2*TG*UG*U1**(-1)*MG2*(TG-M2)*SYMBY - 2*TG*UG*
     +    U1**(-1)*MG2*(S-2*M2)**(-1) + 2*TG*UG*MG2*(S+UG-M2)**(-1)*
     +    (S-2*M2)**(-1) + 2*TG*UG*(S+TG-M2)**(-1) - 2*TG*UG*(TG-M2)*
     +    SYMBY - 2*TG*UG**2*U1**(-1)*S4G**(-1) - 2*TG*T1**(-1)*MG2*MS2
     +    *S4G**(-1) - 4*TG*T1**(-1)*MG2 + 2*TG*T1**(-1)*MG2**2*
     +    S4G**(-1) + 4*TG*U1**(-1)*MG2*MS2*S4G**(-1) - 2*TG*U1**(-1)*
     +    MG2**2*S4G**(-1) - 2*TG*U1**(-1)*MS2**2*S4G**(-1) - 4*TG*MG2*
     +    (TG-M2)*SYMBY - 4*TG**2*T1**(-1)*MG2*S4G**(-1) + 4*UG*
     +    T1**(-1)*U1**(-1)*MG2*MS2 - 4*UG*T1**(-1)*U1**(-1)*MG2**2 + 2
     +    *UG*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) - 2*UG*T1**(-1)*MG2**2*
     +    (S+UG-M2)**(-1) + 10*UG*U1**(-1)*MG2*MS2*(TG-M2)*SYMBY - 2*UG
     +    *U1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 12*UG*U1**(-1)*MG2 - 6*UG*
     +    U1**(-1)*MG2**2*(TG-M2)*SYMBY + 2*UG*U1**(-1)*MG2**2*
     +    (S-2*M2)**(-1) + 12*UG*U1**(-1)*MS2 - 4*UG*U1**(-1)*MS2**2*
     +    (TG-M2)*SYMBY )
     +
      M2QBH = M2QBH + ANG4(86)*N*CK * ( 2*UG*MG2*MS2*(S+UG-M2)**(-1)*
     +    (S-2*M2)**(-1) - 2*UG*MG2*(S+TG-M2)**(-1) + 4*UG*MG2*(TG-M2)*
     +    SYMBY - 2*UG*MG2**2*(S+UG-M2)**(-1)*(S-2*M2)**(-1) + 2*UG*MS2
     +    *(S+TG-M2)**(-1) - 4*UG*MS2*(TG-M2)*SYMBY + 2*UG - 4*UG**2*
     +    U1**(-2)*MG2 + 4*UG**2*U1**(-2)*MS2 + 2*UG**2*U1**(-1) + 2*
     +    UG**2*(S+TG-M2)**(-1) - 6*T1**(-1)*MG2*MS2 + 6*T1**(-1)*
     +    MG2**2 - 4*U1**(-1)*MG2*MS2 + 2*U1**(-1)*MG2**2 + 2*U1**(-1)*
     +    MS2**2 - 4*MG2*MS2*(S+TG-M2)**(-1) - 8*MG2*MS2*(TG-M2)*SYMBY
     +     + 12*MG2 + 2*MG2**2*(S+TG-M2)**(-1) + 6*MG2**2*(TG-M2)*SYMBY
     +     - 12*MS2 + 2*MS2**2*(S+TG-M2)**(-1) + 2*MS2**2*(TG-M2)*SYMBY
     +     )
     +
      M2QBH = M2QBH + ANG4(86)*CQED * (  - 2*S*TG*UG*U1**(-1)*
     +    (S+TG-M2)**(-1) - 4*S*TG*T1**(-1)*MG2*(S+UG-M2)**(-1) + 2*S*
     +    UG*U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*S*UG*U1**(-1)*MS2*
     +    (S+TG-M2)**(-1) + 2*S*UG*U1**(-1) - 2*S*UG**2*U1**(-1)*
     +    (S+TG-M2)**(-1) + 2*S*T1**(-1)*U1**(-1)*MG2*MS2 - 2*S*
     +    T1**(-1)*U1**(-1)*MG2**2 - 2*S*T1**(-1)*MG2*MS2*
     +    (S+UG-M2)**(-1) + 4*S*T1**(-1)*MG2 + 2*S*T1**(-1)*MG2**2*
     +    (S+UG-M2)**(-1) + 4*S*U1**(-1)*MG2*MS2*(S+TG-M2)**(-1) - 2*S*
     +    U1**(-1)*MG2**2*(S+TG-M2)**(-1) - 2*S*U1**(-1)*MS2**2*
     +    (S+TG-M2)**(-1) + 4*S*MG2*(S+UG-M2)**(-1) - 2*S**2*UG*
     +    U1**(-1)*(S+TG-M2)**(-1) - 4*S**2*MG2*(S+TG-M2)**(-1)*
     +    (S+UG-M2)**(-1) - 2*TG*UG*T1**(-1)*U1**(-1)*MG2 - 2*TG*UG*
     +    T1**(-1)*MG2*(S+UG-M2)**(-1) + 4*TG*T1**(-1)*MG2 - 2*UG*
     +    T1**(-1)*U1**(-1)*MG2*MS2 + 2*UG*T1**(-1)*U1**(-1)*MG2**2 - 2
     +    *UG*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) + 2*UG*T1**(-1)*MG2**2*
     +    (S+UG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(86)*CQED * ( 6*UG*U1**(-1)*MG2 - 6*UG*
     +    U1**(-1)*MS2 - 2*UG + 2*UG**2*U1**(-1) + 4*T1**(-1)*MG2*MS2
     +     - 4*T1**(-1)*MG2**2 - 4*MG2 + 4*MS2 )
     +
      M2QBH = M2QBH + ANG4(87)*N*CO * (  - 8*MG2*MS2**2 + 16*MG2**2*MS2
     +     - 8*MG2**3 )
     +
      M2QBH = M2QBH + ANG4(87)*N*CK * ( 8*MG2*MS2**2 - 16*MG2**2*MS2 + 
     +    8*MG2**3 )
     +
      M2QBH = M2QBH + ANG4(88)*N*CO * ( 4*UG*U1**(-1)*MG2*MS2 - 4*UG*
     +    U1**(-1)*MS2**2 + 4*UG**2*U1**(-1)*MG2 - 4*UG**2*U1**(-1)*MS2
     +     - 4*U1**(-1)*MG2*MS2**2 + 8*U1**(-1)*MG2**2*MS2 - 4*U1**(-1)
     +    *MG2**3 - 4*MG2*MS2 + 4*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(88)*N*CK * (  - 4*UG*U1**(-1)*MG2*MS2 + 4*UG
     +    *U1**(-1)*MS2**2 - 4*UG**2*U1**(-1)*MG2 + 4*UG**2*U1**(-1)*
     +    MS2 + 4*U1**(-1)*MG2*MS2**2 - 8*U1**(-1)*MG2**2*MS2 + 4*
     +    U1**(-1)*MG2**3 + 4*MG2*MS2 - 4*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(89)*N*CO * (  - 16*S**(-1)*MG2*MS2**2 + 32*
     +    S**(-1)*MG2**2*MS2 - 16*S**(-1)*MG2**3 - 16*MG2*MS2 )
     +
      M2QBH = M2QBH + ANG4(89)*N*CK * ( 16*S*MG2**2*(S-2*M2)**(-1) + 16
     +    *MG2*MS2 - 16*MG2**2 )
     +
      M2QBH = M2QBH + ANG4(90)*N*CO * ( 2*S**(-1)*TG*UG*U1**(-1)*MG2 + 
     +    2*S**(-1)*TG*U1**(-1)*MG2*MS2 - 2*S**(-1)*TG*U1**(-1)*MG2**2
     +     - 2*S**(-1)*TG*MG2 + 8*S**(-1)*UG*U1**(-1)*MG2*MS2 - 4*
     +    S**(-1)*UG*U1**(-1)*MG2**2 - 4*S**(-1)*UG*U1**(-1)*MS2**2 - 8
     +    *S**(-1)*UG*(TG+UG)**(-1)*MG2*MS2 + 8*S**(-1)*UG*
     +    (TG+UG)**(-1)*MG2**2 - 8*S**(-1)*UG*MG2*MS2*S4G**(-1) + 8*
     +    S**(-1)*UG*MG2**2*S4G**(-1) + 4*S**(-1)*UG**2*U1**(-1)*MG2 - 
     +    4*S**(-1)*UG**2*U1**(-1)*MS2 - 4*S**(-1)*U1**(-1)*MG2*MS2**2
     +     + 8*S**(-1)*U1**(-1)*MG2**2*MS2 - 4*S**(-1)*U1**(-1)*MG2**3
     +     + 8*S**(-1)*(TG+UG)**(-1)*MG2*MS2**2 - 16*S**(-1)*
     +    (TG+UG)**(-1)*MG2**2*MS2 + 8*S**(-1)*(TG+UG)**(-1)*MG2**3 + 
     +    12*S**(-1)*MG2*MS2 - 16*S**(-1)*MG2**2 + 4*S**(-1)*MS2**2 + 2
     +    *S*UG*U1**(-1)*(TG+UG)**(-1)*MG2 - 2*TG*UG**2*U1**(-1)*
     +    S4G**(-1) + 4*TG*U1**(-1)*MG2*MS2*S4G**(-1) - 2*TG*U1**(-1)*
     +    MG2**2*S4G**(-1) - 2*TG*U1**(-1)*MS2**2*S4G**(-1) - 4*TG*MG2*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(90)*N*CO * (  - 2*UG*U1**(-1)*(TG+UG)**(-1)*
     +    MG2*MS2 + 2*UG*U1**(-1)*(TG+UG)**(-1)*MG2**2 + 4*UG*U1**(-1)*
     +    MG2*MS2*S4G**(-1) - 2*UG*U1**(-1)*MG2**2*S4G**(-1) - 6*UG*
     +    U1**(-1)*MS2 - 2*UG*U1**(-1)*MS2**2*S4G**(-1) - 2*UG*
     +    (TG+UG)**(-1)*MS2 + 4*UG**2*U1**(-2)*MG2 - 4*UG**2*U1**(-2)*
     +    MS2 - 2*UG**2*U1**(-1)*(TG+UG)**(-1)*MG2 + 4*UG**2*U1**(-1)*
     +    (TG+UG)**(-1)*MS2 - 4*UG**2*U1**(-1)*MG2*S4G**(-1) - 2*UG**2*
     +    U1**(-1) + 2*UG**2*(TG+UG)**(-1) + 2*UG**2*S4G**(-1) - 2*
     +    UG**3*U1**(-1)*S4G**(-1) - 8*U1**(-1)*MG2*MS2 - 4*U1**(-1)*
     +    MG2*MS2**2*S4G**(-1) + 8*U1**(-1)*MG2**2*MS2*S4G**(-1) - 4*
     +    U1**(-1)*MG2**3*S4G**(-1) + 8*(TG+UG)**(-1)*MG2*MS2 - 8*
     +    (TG+UG)**(-1)*MG2**2 - 8*MG2*MS2*S4G**(-1) - 10*MG2 - 2*
     +    MG2**2*S4G**(-1) + 8*MS2 + 2*MS2**2*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(90)*N*CK * ( 2*S*TG*UG*U1**(-1)*
     +    (S+TG-M2)**(-1) + 4*S*TG*T1**(-1)*MG2*(S-2*M2)**(-1) + 4*S*TG
     +    *MG2*(S+TG-M2)**(-1)*(S-2*M2)**(-1) - 2*S*UG*T1**(-1)*
     +    U1**(-1)*MG2 + 2*S*UG*T1**(-1)*MG2*(S-2*M2)**(-1) + 4*S*UG*
     +    U1**(-1)*MG2*(S-2*M2)**(-1) + 8*S*T1**(-1)*MG2**2*
     +    (S-2*M2)**(-1) + 8*S*U1**(-1)*MG2**2*(S-2*M2)**(-1) + 8*S*MG2
     +    *(S-2*M2)**(-1) + 16*S*MG2**2*(S-2*M2)**(-2) + 2*TG*UG*
     +    T1**(-1)*U1**(-1)*MG2 - 2*TG*UG*U1**(-1)*MG2*(S+TG-M2)**(-1)
     +     - 2*TG*UG*U1**(-1)*MG2*(S-2*M2)**(-1) + 2*TG*UG*U1**(-1)*MS2
     +    *(S+TG-M2)**(-1) - 2*TG*UG*U1**(-1) - 2*TG*UG*MG2*
     +    (S+TG-M2)**(-1)*(S-2*M2)**(-1) + 2*TG*UG**2*U1**(-1)*
     +    (S+TG-M2)**(-1) + 2*TG*T1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 6*TG
     +    *T1**(-1)*MG2 - 2*TG*T1**(-1)*MG2**2*(S-2*M2)**(-1) - 4*TG*
     +    U1**(-1)*MG2*MS2*(S+TG-M2)**(-1) - 2*TG*U1**(-1)*MG2*MS2*
     +    (S-2*M2)**(-1) + 2*TG*U1**(-1)*MG2**2*(S+TG-M2)**(-1) + 2*TG*
     +    U1**(-1)*MG2**2*(S-2*M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(90)*N*CK * ( 2*TG*U1**(-1)*MS2**2*
     +    (S+TG-M2)**(-1) + 2*TG*MG2*MS2*(S+TG-M2)**(-1)*(S-2*M2)**(-1)
     +     + 2*TG*MG2*(S-2*M2)**(-1) - 2*TG*MG2**2*(S+TG-M2)**(-1)*
     +    (S-2*M2)**(-1) + 2*TG**2*UG*U1**(-1)*(S+TG-M2)**(-1) + 2*UG*
     +    T1**(-1)*U1**(-1)*MG2*MS2 - 2*UG*T1**(-1)*U1**(-1)*MG2**2 + 2
     +    *UG*T1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 2*UG*T1**(-1)*MG2**2*
     +    (S-2*M2)**(-1) - 4*UG*U1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 6*UG*
     +    U1**(-1)*MG2 + 4*UG*U1**(-1)*MG2**2*(S-2*M2)**(-1) + 6*UG*
     +    U1**(-1)*MS2 + 2*UG*MG2*(S-2*M2)**(-1) - 4*UG**2*U1**(-2)*MG2
     +     + 4*UG**2*U1**(-2)*MS2 + 2*UG**2*U1**(-1) - 4*T1**(-1)*MG2*
     +    MS2 + 4*T1**(-1)*MG2**2 + 8*U1**(-1)*MG2*MS2 - 8*U1**(-1)*
     +    MG2**2 + 4*MG2 - 8*MS2 )
     +
      M2QBH = M2QBH + ANG4(91)*N*CO * (  - 4*UG*U1**(-2)*MG2*MS2 + 4*UG
     +    *U1**(-2)*MG2**2 - 4*UG*U1**(-1)*MG2 + 4*UG*U1**(-1)*MS2 + 4*
     +    UG**2*U1**(-2)*MG2 - 4*UG**2*U1**(-2)*MS2 + 4*U1**(-1)*MG2*
     +    MS2 - 4*U1**(-1)*MG2**2 + 2*MG2 - 2*MS2 )
     +
      M2QBH = M2QBH + ANG4(91)*N*CK * ( 12*UG*U1**(-2)*MG2*MS2 - 12*UG*
     +    U1**(-2)*MG2**2 + 12*UG*U1**(-1)*MG2 - 12*UG*U1**(-1)*MS2 - 
     +    12*UG**2*U1**(-2)*MG2 + 12*UG**2*U1**(-2)*MS2 - 12*U1**(-1)*
     +    MG2*MS2 + 12*U1**(-1)*MG2**2 - 6*MG2 + 6*MS2 )
     +
      M2QBH = M2QBH + ANG4(91)*CQED * (  - 4*UG*U1**(-2)*MG2*MS2 + 4*UG
     +    *U1**(-2)*MG2**2 - 4*UG*U1**(-1)*MG2 + 4*UG*U1**(-1)*MS2 + 4*
     +    UG**2*U1**(-2)*MG2 - 4*UG**2*U1**(-2)*MS2 + 4*U1**(-1)*MG2*
     +    MS2 - 4*U1**(-1)*MG2**2 + 2*MG2 - 2*MS2 )
     +
      M2QBH = M2QBH + ANG4(92)*N*CO * (  - 1 + 2*S**(-1)*TG*MG2*(TG-M2)
     +    *SYMBY - 2*S**(-1)*TG*MS2*(TG-M2)*SYMBY + S**(-1)*TG - 
     +    S**(-1)*TG**2*(TG-M2)*SYMBY - 4*S**(-1)*UG*U1**(-1)*MG2*MS2*
     +    S4G**(-1) + 4*S**(-1)*UG*U1**(-1)*MG2**2*S4G**(-1) + 4*
     +    S**(-1)*UG*U1**(-1)*MS2 + 2*S**(-1)*UG*MG2*S4G**(-1) + 2*
     +    S**(-1)*UG*MS2*S4G**(-1) + 2*S**(-1)*UG - 4*S**(-1)*UG**2*
     +    U1**(-1)*MS2*S4G**(-1) - 2*S**(-1)*UG**2*S4G**(-1) + 6*
     +    S**(-1)*U1**(-1)*MG2*MS2 - 6*S**(-1)*U1**(-1)*MG2**2 + 2*
     +    S**(-1)*MG2*MS2*(TG-M2)*SYMBY - 3*S**(-1)*MG2 - S**(-1)*
     +    MG2**2*(TG-M2)*SYMBY - S**(-1)*MS2 - S**(-1)*MS2**2*(TG-M2)*
     +    SYMBY - TG*(TG-M2)*SYMBY - 4*UG*U1**(-2)*MG2*MS2*S4G**(-1) + 
     +    4*UG*U1**(-2)*MG2**2*S4G**(-1) - 2*UG*U1**(-1)*MG2*S4G**(-1)
     +     + 2*UG*U1**(-1)*MS2*S4G**(-1) + 6*UG*U1**(-1) - 4*UG**2*
     +    U1**(-2)*MS2*S4G**(-1) - 4*UG**2*U1**(-2) - 2*UG**2*U1**(-1)*
     +    S4G**(-1) + 2*U1**(-1)*MG2*MS2*S4G**(-1) - 4*U1**(-1)*MG2 - 
     +    10*U1**(-1)*MG2**2*S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(92)*N*CO * ( 2*U1**(-1)*MS2 + MG2*(TG-M2)*
     +    SYMBY - MS2*(TG-M2)*SYMBY )
     +
      M2QBH = M2QBH + ANG4(92)*N*CK * ( 6 + 8*S*TG*UG*U1**(-2)*
     +    (S+TG-M2)**(-1) - 8*S*UG*U1**(-2)*MG2*(S+TG-M2)**(-1) + 8*S*
     +    UG*U1**(-2)*MS2*(S+TG-M2)**(-1) - 4*S*UG*U1**(-2) + 4*S*UG**2
     +    *U1**(-2)*(S+TG-M2)**(-1) - 2*S*T1**(-1)*U1**(-1)*MG2 + 8*S*
     +    U1**(-1)*MG2*(S+TG-M2)**(-1) - 4*S*U1**(-1)*MS2*
     +    (S+TG-M2)**(-1) + 4*S**2*UG*U1**(-2)*(S+TG-M2)**(-1) - 8*TG*
     +    UG*U1**(-2)*MG2*(S+TG-M2)**(-1) + 8*TG*UG*U1**(-2)*MS2*
     +    (S+TG-M2)**(-1) - 4*TG*UG*U1**(-2) + 4*TG*UG**2*U1**(-2)*
     +    (S+TG-M2)**(-1) + 2*TG*T1**(-1)*U1**(-1)*MG2*MS2*S4G**(-1) + 
     +    4*TG*T1**(-1)*U1**(-1)*MG2 + 6*TG*T1**(-1)*U1**(-1)*MG2**2*
     +    S4G**(-1) + 8*TG*U1**(-1)*MG2*(S+TG-M2)**(-1) - 4*TG*U1**(-1)
     +    *MS2*(S+TG-M2)**(-1) + 4*TG**2*UG*U1**(-2)*(S+TG-M2)**(-1) + 
     +    2*UG*T1**(-1)*U1**(-1)*MG2*MS2*S4G**(-1) + 6*UG*T1**(-1)*
     +    U1**(-1)*MG2**2*S4G**(-1) + 2*UG*T1**(-1)*MG2*S4G**(-1) - 8*
     +    UG*U1**(-2)*MG2*MS2*(S+TG-M2)**(-1) + 4*UG*U1**(-2)*MG2*MS2*
     +    S4G**(-1) )
     +
      M2QBH = M2QBH + ANG4(92)*N*CK * ( 4*UG*U1**(-2)*MG2 + 4*UG*
     +    U1**(-2)*MG2**2*(S+TG-M2)**(-1) - 4*UG*U1**(-2)*MG2**2*
     +    S4G**(-1) - 4*UG*U1**(-2)*MS2 + 4*UG*U1**(-2)*MS2**2*
     +    (S+TG-M2)**(-1) - 4*UG*U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*UG*
     +    U1**(-1)*MG2*S4G**(-1) + 4*UG*U1**(-1)*MS2*(S+TG-M2)**(-1) - 
     +    2*UG*U1**(-1)*MS2*S4G**(-1) - 18*UG*U1**(-1) + 4*UG**2*
     +    U1**(-2)*MG2*(S+TG-M2)**(-1) - 4*UG**2*U1**(-2)*MS2*
     +    (S+TG-M2)**(-1) + 4*UG**2*U1**(-2)*MS2*S4G**(-1) + 8*UG**2*
     +    U1**(-2) + 2*UG**2*U1**(-1)*S4G**(-1) - 8*T1**(-1)*U1**(-1)*
     +    MG2**2 - 4*T1**(-1)*MG2*MS2*S4G**(-1) - 2*T1**(-1)*MG2 + 4*
     +    T1**(-1)*MG2**2*S4G**(-1) - 4*U1**(-1)*MG2*MS2*S4G**(-1) - 10
     +    *U1**(-1)*MG2 + 4*U1**(-1)*MG2**2*S4G**(-1) - 2*U1**(-1)*MS2
     +     )
     +
      M2QBH = M2QBH + ANG4(92)*CQED * (  - 2 - 4*S*TG*UG*U1**(-2)*
     +    (S+TG-M2)**(-1) + 4*S*UG*U1**(-2)*MG2*(S+TG-M2)**(-1) - 4*S*
     +    UG*U1**(-2)*MS2*(S+TG-M2)**(-1) + 2*S*UG*U1**(-2) - 2*S*UG**2
     +    *U1**(-2)*(S+TG-M2)**(-1) - 2*S*T1**(-1)*U1**(-1)*MG2 - 4*S*
     +    U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*S*U1**(-1)*MS2*
     +    (S+TG-M2)**(-1) - 2*S**2*UG*U1**(-2)*(S+TG-M2)**(-1) + 4*TG*
     +    UG*U1**(-2)*MG2*(S+TG-M2)**(-1) - 4*TG*UG*U1**(-2)*MS2*
     +    (S+TG-M2)**(-1) + 2*TG*UG*U1**(-2) - 2*TG*UG**2*U1**(-2)*
     +    (S+TG-M2)**(-1) - 2*TG*T1**(-1)*U1**(-1)*MG2 - 4*TG*U1**(-1)*
     +    MG2*(S+TG-M2)**(-1) + 2*TG*U1**(-1)*MS2*(S+TG-M2)**(-1) - 2*
     +    TG**2*UG*U1**(-2)*(S+TG-M2)**(-1) + 4*UG*U1**(-2)*MG2*MS2*
     +    (S+TG-M2)**(-1) - 2*UG*U1**(-2)*MG2 - 2*UG*U1**(-2)*MG2**2*
     +    (S+TG-M2)**(-1) + 2*UG*U1**(-2)*MS2 - 2*UG*U1**(-2)*MS2**2*
     +    (S+TG-M2)**(-1) + 2*UG*U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*UG*
     +    U1**(-1)*MS2*(S+TG-M2)**(-1) + 6*UG*U1**(-1) - 2*UG**2*
     +    U1**(-2)*MG2*(S+TG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(92)*CQED * ( 2*UG**2*U1**(-2)*MS2*
     +    (S+TG-M2)**(-1) - 2*UG**2*U1**(-2) + 4*U1**(-1)*MG2 )
     +
      M2QBH = M2QBH + ANG4(94)*N*CK * ( 2*S*TG*T1**(-1)*MG2*
     +    (S+UG-M2)**(-1) - 2*S*TG*T1**(-1)*MG2*(S-2*M2)**(-1) - 2*S*TG
     +    *U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*S*TG*U1**(-1)*MG2*
     +    (S-2*M2)**(-1) - 2*S*TG*MG2*(S+TG-M2)**(-1)*(S-2*M2)**(-1) + 
     +    2*S*UG*T1**(-1)*MG2*(S+UG-M2)**(-1) - 2*S*UG*T1**(-1)*MG2*
     +    (S-2*M2)**(-1) + 4*S*UG*U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*S*UG
     +    *U1**(-1)*MG2*(S-2*M2)**(-1) - 2*S*UG*MG2*(S+UG-M2)**(-1)*
     +    (S-2*M2)**(-1) + 2*S*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) - 12*S*
     +    T1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 2*S*T1**(-1)*MG2**2*
     +    (S+UG-M2)**(-1) + 4*S*T1**(-1)*MG2**2*(S-2*M2)**(-1) - 2*S*
     +    U1**(-1)*MG2 - 8*S*U1**(-1)*MG2**2*(S-2*M2)**(-1) - 2*S*MG2*
     +    (S+TG-M2)**(-1) - 2*S*MG2*(S+UG-M2)**(-1) - 8*S*MG2*
     +    (S-2*M2)**(-1) - 16*S*MG2**2*(S-2*M2)**(-2) + 2*S**2*T1**(-1)
     +    *MG2*(S+UG-M2)**(-1) - 6*S**2*T1**(-1)*MG2*(S-2*M2)**(-1) - 2
     +    *S**2*U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*TG*UG*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(94)*N*CK * ( 2*TG*UG*MG2*(S+TG-M2)**(-1)*
     +    (S-2*M2)**(-1) + 2*TG*UG*MG2*(S+UG-M2)**(-1)*(S-2*M2)**(-1)
     +     - 2*TG*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) + 2*TG*T1**(-1)*MG2*
     +    MS2*(S-2*M2)**(-1) + 2*TG*T1**(-1)*MG2**2*(S+UG-M2)**(-1) - 2
     +    *TG*T1**(-1)*MG2**2*(S-2*M2)**(-1) + 2*TG*U1**(-1)*MG2*MS2*
     +    (S+TG-M2)**(-1) - 2*TG*U1**(-1)*MG2*MS2*(S-2*M2)**(-1) - 2*TG
     +    *U1**(-1)*MG2**2*(S+TG-M2)**(-1) + 2*TG*U1**(-1)*MG2**2*
     +    (S-2*M2)**(-1) + 2*TG*MG2*MS2*(S+TG-M2)**(-1)*(S-2*M2)**(-1)
     +     - 2*TG*MG2*(S-2*M2)**(-1) - 2*TG*MG2**2*(S+TG-M2)**(-1)*
     +    (S-2*M2)**(-1) - 2*UG*T1**(-1)*MG2*MS2*(S-2*M2)**(-1) + 2*UG*
     +    T1**(-1)*MG2**2*(S-2*M2)**(-1) + 2*UG*U1**(-1)*MG2*MS2*
     +    (S-2*M2)**(-1) - 2*UG*U1**(-1)*MG2 - 2*UG*U1**(-1)*MG2**2*
     +    (S-2*M2)**(-1) + 2*UG*MG2*MS2*(S+UG-M2)**(-1)*(S-2*M2)**(-1)
     +     - 2*UG*MG2*(S-2*M2)**(-1) - 2*UG*MG2**2*(S+UG-M2)**(-1)*
     +    (S-2*M2)**(-1) + 2*T1**(-1)*MG2*MS2 - 2*T1**(-1)*MG2*MS2**2*
     +    (S+UG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(94)*N*CK * ( 4*T1**(-1)*MG2**2*MS2*
     +    (S+UG-M2)**(-1) - 2*T1**(-1)*MG2**2 - 2*T1**(-1)*MG2**3*
     +    (S+UG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(94)*CQED * (  - 4*S*TG*T1**(-1)*U1**(-1)*MG2
     +     - 2*S*TG*T1**(-1)*MG2*(S+UG-M2)**(-1) + 2*S*TG*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 2*S*UG*T1**(-1)*MG2*(S+UG-M2)**(-1) - 4*S*
     +    UG*U1**(-1)*MG2*(S+TG-M2)**(-1) - 4*S*T1**(-1)*U1**(-1)*MG2*
     +    MS2 - 4*S*T1**(-1)*U1**(-1)*MG2**2 - 2*S*T1**(-1)*MG2*MS2*
     +    (S+UG-M2)**(-1) + 2*S*T1**(-1)*MG2**2*(S+UG-M2)**(-1) + 4*S*
     +    MG2*(S+TG-M2)**(-1) + 4*S*MG2*(S+UG-M2)**(-1) - 4*S**2*
     +    T1**(-1)*U1**(-1)*MG2 - 2*S**2*T1**(-1)*MG2*(S+UG-M2)**(-1)
     +     + 2*S**2*U1**(-1)*MG2*(S+TG-M2)**(-1) - 4*S**2*MG2*
     +    (S+TG-M2)**(-1)*(S+UG-M2)**(-1) - 2*TG*UG*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) + 2*TG*T1**(-1)*MG2*MS2*(S+UG-M2)**(-1) - 2*
     +    TG*T1**(-1)*MG2**2*(S+UG-M2)**(-1) - 2*TG*U1**(-1)*MG2*MS2*
     +    (S+TG-M2)**(-1) + 2*TG*U1**(-1)*MG2**2*(S+TG-M2)**(-1) + 2*UG
     +    *U1**(-1)*MG2 - 2*T1**(-1)*MG2*MS2 + 2*T1**(-1)*MG2*MS2**2*
     +    (S+UG-M2)**(-1) - 4*T1**(-1)*MG2**2*MS2*(S+UG-M2)**(-1) + 2*
     +    T1**(-1)*MG2**2 )
     +
      M2QBH = M2QBH + ANG4(94)*CQED * ( 2*T1**(-1)*MG2**3*
     +    (S+UG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(108)*N*CO * (  - 4*S**(-1)*TG*UG*MG2*(TG-M2)
     +    *SYMBY + 4*S**(-1)*TG*UG*MS2*(TG-M2)*SYMBY - S**(-1)*TG*UG + 
     +    2*S**(-1)*TG*UG**2*(TG-M2)*SYMBY + 2*S**(-1)*TG*MG2*MS2*
     +    (TG-M2)*SYMBY - S**(-1)*TG*MG2 - S**(-1)*TG*MG2**2*(TG-M2)*
     +    SYMBY + S**(-1)*TG*MS2 - S**(-1)*TG*MS2**2*(TG-M2)*SYMBY + 
     +    S**(-1)*TG**2*UG*(TG-M2)*SYMBY + 2*S**(-1)*TG**2*MG2*(TG-M2)*
     +    SYMBY - 2*S**(-1)*TG**2*MS2*(TG-M2)*SYMBY + S**(-1)*TG**2 - 
     +    S**(-1)*TG**3*(TG-M2)*SYMBY - 8*S**(-1)*UG*(TG+UG)**(-1)*MG2*
     +    MS2 + 8*S**(-1)*UG*(TG+UG)**(-1)*MG2**2 - 6*S**(-1)*UG*MG2*
     +    MS2*(TG-M2)*SYMBY + 3*S**(-1)*UG*MG2 + 3*S**(-1)*UG*MG2**2*
     +    (TG-M2)*SYMBY - 3*S**(-1)*UG*MS2 + 3*S**(-1)*UG*MS2**2*
     +    (TG-M2)*SYMBY - 2*S**(-1)*UG**2*MG2*(TG-M2)*SYMBY + 2*S**(-1)
     +    *UG**2*MS2*(TG-M2)*SYMBY + 8*S**(-1)*(TG+UG)**(-1)*MG2*MS2**2
     +     - 16*S**(-1)*(TG+UG)**(-1)*MG2**2*MS2 + 8*S**(-1)*
     +    (TG+UG)**(-1)*MG2**3 + 4*S**(-1)*MG2*MS2 - 6*S**(-1)*MG2**2
     +     + 2*S**(-1)*MS2**2 )
     +
      M2QBH = M2QBH + ANG4(108)*N*CO * ( 2*S*UG*U1**(-1)*(TG+UG)**(-1)*
     +    MG2 - 2*S*UG*U1**(-1)*MG2*(TG-M2)*SYMBY - 2*S*MG2*(TG-M2)*
     +    SYMBY + 2*TG*UG*U1**(-1)*MG2*(TG-M2)*SYMBY + 2*TG*UG*(TG-M2)*
     +    SYMBY + 3*TG*MG2*(TG-M2)*SYMBY - 3*TG*MS2*(TG-M2)*SYMBY + TG
     +     - TG**2*(TG-M2)*SYMBY - 2*UG*U1**(-1)*(TG+UG)**(-1)*MG2*MS2
     +     + 2*UG*U1**(-1)*(TG+UG)**(-1)*MG2**2 + 2*UG*U1**(-1)*MG2*MS2
     +    *(TG-M2)*SYMBY - 2*UG*U1**(-1)*MG2 - 2*UG*U1**(-1)*MG2**2*
     +    (TG-M2)*SYMBY - 2*UG*(TG+UG)**(-1)*MS2 - 4*UG*MG2*(TG-M2)*
     +    SYMBY + 4*UG*MS2*(TG-M2)*SYMBY - 2*UG - 2*UG**2*U1**(-1)*
     +    (TG+UG)**(-1)*MG2 + 4*UG**2*U1**(-1)*(TG+UG)**(-1)*MS2 + 4*
     +    UG**2*U1**(-1)*MG2*(TG-M2)*SYMBY - 4*UG**2*U1**(-1)*MS2*
     +    (TG-M2)*SYMBY + 2*UG**2*(TG+UG)**(-1) + 8*(TG+UG)**(-1)*MG2*
     +    MS2 - 8*(TG+UG)**(-1)*MG2**2 - 4*MG2 + 2*MS2 )
     +
      M2QBH = M2QBH + ANG4(108)*N*CK * ( 4*S*TG*UG*U1**(-1)*
     +    (S+TG-M2)**(-1) + 6*S*TG*U1**(-1)*MG2*(S+TG-M2)**(-1) - 2*S*
     +    TG*U1**(-1)*MG2*(TG-M2)*SYMBY - 6*S*UG*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) + 4*S*UG*U1**(-1)*MS2*(S+TG-M2)**(-1) - 2*S*
     +    UG*U1**(-1) - 2*S*UG*(S+TG-M2)**(-1) + 2*S*UG**2*U1**(-1)*
     +    (S+TG-M2)**(-1) + 4*S*U1**(-1)*MG2*MS2*(S+TG-M2)**(-1) - 4*S*
     +    U1**(-1)*MG2**2*(S+TG-M2)**(-1) + 4*S*MG2*(TG-M2)*SYMBY + 2*
     +    S**2*UG*U1**(-1)*(S+TG-M2)**(-1) + 4*S**2*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 4*TG*UG*U1**(-1)*MG2*(S+TG-M2)**(-1) + 2*TG
     +    *UG*U1**(-1)*MG2*(TG-M2)*SYMBY + 4*TG*UG*U1**(-1)*MS2*
     +    (S+TG-M2)**(-1) - 4*TG*UG*U1**(-1)*MS2*(TG-M2)*SYMBY - 2*TG*
     +    UG*U1**(-1) - 2*TG*UG*(S+TG-M2)**(-1) + 2*TG*UG**2*U1**(-1)*
     +    (S+TG-M2)**(-1) + 2*TG*U1**(-1)*MG2*MS2*(S+TG-M2)**(-1) - 2*
     +    TG*U1**(-1)*MG2 - 2*TG*U1**(-1)*MG2**2*(S+TG-M2)**(-1) + 2*TG
     +    *MG2*(TG-M2)*SYMBY + 2*TG*MS2*(TG-M2)*SYMBY + 2*TG**2*UG*
     +    U1**(-1)*(S+TG-M2)**(-1) )
     +
      M2QBH = M2QBH + ANG4(108)*N*CK * ( 2*TG**2*U1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 4*UG*U1**(-1)*MG2*MS2*(S+TG-M2)**(-1) - 2*
     +    UG*U1**(-1)*MG2*MS2*(TG-M2)*SYMBY + 2*UG*U1**(-1)*MG2**2*
     +    (S+TG-M2)**(-1) + 2*UG*U1**(-1)*MG2**2*(TG-M2)*SYMBY - 2*UG*
     +    U1**(-1)*MS2 + 2*UG*U1**(-1)*MS2**2*(S+TG-M2)**(-1) - 2*UG*
     +    MG2*(TG-M2)*SYMBY + 2*UG*MS2*(TG-M2)*SYMBY + 2*UG**2*U1**(-1)
     +    *MG2*(S+TG-M2)**(-1) - 2*UG**2*U1**(-1)*MS2*(S+TG-M2)**(-1)
     +     - 2*UG**2*U1**(-1) - 2*UG**2*(S+TG-M2)**(-1) - 4*U1**(-1)*
     +    MG2*MS2 + 4*U1**(-1)*MG2**2 + 4*MG2*MS2*(TG-M2)*SYMBY - 4*
     +    MG2**2*(TG-M2)*SYMBY )
     +
      M2QBH = M2QBH + ANG4(109)*N*CO * (  - 2*S**(-1)*UG*U1**(-1)*MG2*
     +    S4G**(-1) + 2*S**(-1)*U1**(-1)*MG2 )
     +
      M2QBH = M2QBH + ANG4(109)*N*CK * (  - 2*UG*T1**(-1)*U1**(-1)*MG2*
     +    S4G**(-1) + 2*T1**(-1)*U1**(-1)*MG2 )


      DGGQBH = S4G/(S4G+MG2)/2.D0 *
     +     0.5D0* ALPHAS**3 * AVG * M2QBH /4.D0 /S**2 *CONV
      RETURN
      END




      REAL*8 FUNCTION DGGQBD(ALPHAS,S,TG,S4G,MS,MG,DEL,S4GMAX)
C***  LOG(DEL) PART OF CROSS SECTION FOR Q +QB -> GL + GL +G 
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4G,TG,T1,SBG,MS,MG,MG2,M2
      REAL*8 M2QBD,CO,CK,CQED
      REAL*8 NS,CONV,N,AVG,BETA,XG,DEL,S4GMAX,DLDEL1,DLDEL2
      REAL*8 COLO1(1:9)

      NS = 6.D0
      CONV = 389379660.D0
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      CQED =(N**4 -1.D0)/N**2
      AVG = (1.D0/2.D0)**2 /N**2

      MG2 = MG**2
      M2 = MG2 -MS**2
      SBG = S*SQRT(1 -4.D0*MG2/S)
      BETA = SQRT(1 -4*MG2/S)
      XG = (1.D0 -BETA)/(1.D0 +BETA)
      T1 = TG +M2

      DLDEL1 = LOG(S4GMAX/MG2) -(S4GMAX-DEL)/S4G
      DLDEL2 = LOG(S4GMAX/MG2)**2 -2.D0*(S4GMAX-DEL)/S4G*LOG(S4G/MG2)

      COLO1(1) = LOG(XG)
      COLO1(3) = LOG(S/MG2)
      COLO1(4) = LOG(-TG/MG2)
      COLO1(8) = LOG((S+TG)/MG2)

      M2QBD = 0.D0
      M2QBD = M2QBD + N*CO*DLDEL1 * (  - 48 + 128*S**(-2)*T1*M2 - 64*
     +    S**(-2)*T1**2 - 64*S**(-2)*M2**2 - 32*S**(-1)*TG + 32*S**(-1)
     +    *TG**2*(S+TG-M2)**(-1) - 32*S**(-1)*T1**(-1)*M2**2 - 64*
     +    S**(-1)*T1 + 96*S**(-1)*M2 - 64*S**(-1)*MG2 + 32*TG*T1**(-1)
     +     + 32*TG*T1*(S+TG-M2)**(-2) + 32*TG*(S+TG-M2)**(-1) - 16*
     +    TG**2*T1**(-2) - 16*TG**2*(S+TG-M2)**(-2) + 32*T1**(-1)*M2 - 
     +    32*T1**(-1)*MG2 - 16*T1**2*(S+TG-M2)**(-2) + 32*MG2*
     +    (S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + N*CO*DLDEL2 * ( 24 - 64*S**(-2)*T1*M2 + 32*
     +    S**(-2)*T1**2 + 32*S**(-2)*M2**2 + 16*S**(-1)*TG - 16*S**(-1)
     +    *TG**2*(S+TG-M2)**(-1) + 16*S**(-1)*T1**(-1)*M2**2 + 32*
     +    S**(-1)*T1 - 48*S**(-1)*M2 + 32*S**(-1)*MG2 - 16*TG*T1**(-1)
     +     - 16*TG*T1*(S+TG-M2)**(-2) - 16*TG*(S+TG-M2)**(-1) + 8*TG**2
     +    *T1**(-2) + 8*TG**2*(S+TG-M2)**(-2) - 16*T1**(-1)*M2 + 16*
     +    T1**(-1)*MG2 + 8*T1**2*(S+TG-M2)**(-2) - 16*MG2*
     +    (S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + N*CK*DLDEL1 * ( 16 - 64*TG*T1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 32*TG*T1*(S+TG-M2)**(-2) - 32*TG*
     +    (S+TG-M2)**(-1) + 16*TG**2*T1**(-2) + 16*TG**2*
     +    (S+TG-M2)**(-2) + 32*T1**(-1)*MG2 + 32*T1*(S+TG-M2)**(-1) + 
     +    16*T1**2*(S+TG-M2)**(-2) + 32*MG2*(S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + N*CK*DLDEL2 * (  - 40 + 64*S**(-2)*T1*M2 - 32*
     +    S**(-2)*T1**2 - 32*S**(-2)*M2**2 - 16*S**(-1)*TG + 16*S**(-1)
     +    *TG**2*(S+TG-M2)**(-1) - 16*S**(-1)*T1**(-1)*M2**2 - 32*
     +    S**(-1)*T1 + 48*S**(-1)*M2 - 32*S**(-1)*MG2 + 64*TG*T1**(-1)*
     +    MG2*(S+TG-M2)**(-1) + 16*TG*T1**(-1) + 48*TG*T1*
     +    (S+TG-M2)**(-2) + 48*TG*(S+TG-M2)**(-1) - 24*TG**2*T1**(-2)
     +     - 24*TG**2*(S+TG-M2)**(-2) + 16*T1**(-1)*M2 - 48*T1**(-1)*
     +    MG2 - 32*T1*(S+TG-M2)**(-1) - 24*T1**2*(S+TG-M2)**(-2) - 16*
     +    MG2*(S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + CQED*DLDEL2 * ( 8 - 32*TG*T1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 16*TG*T1*(S+TG-M2)**(-2) - 16*TG*
     +    (S+TG-M2)**(-1) + 8*TG**2*T1**(-2) + 8*TG**2*(S+TG-M2)**(-2)
     +     + 16*T1**(-1)*MG2 + 16*T1*(S+TG-M2)**(-1) + 8*T1**2*
     +    (S+TG-M2)**(-2) + 16*MG2*(S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(1)*N*CO*DLDEL1 * (  - 128*S**(-2)*T1*
     +    SBG**(-1)*M2*MG2 + 64*S**(-2)*T1**2*SBG**(-1)*MG2 + 64*
     +    S**(-2)*SBG**(-1)*M2**2*MG2 + 32*S**(-1)*TG*SBG**(-1)*MG2 - 
     +    32*S**(-1)*TG**2*SBG**(-1)*MG2*(S+TG-M2)**(-1) + 32*S**(-1)*
     +    T1**(-1)*SBG**(-1)*M2**2*MG2 + 64*S**(-1)*T1*SBG**(-1)*M2 + 
     +    64*S**(-1)*T1*SBG**(-1)*MG2 - 32*S**(-1)*T1**2*SBG**(-1) - 96
     +    *S**(-1)*SBG**(-1)*M2*MG2 - 32*S**(-1)*SBG**(-1)*M2**2 + 64*
     +    S**(-1)*SBG**(-1)*MG2**2 - 8*S*TG**2*T1**(-2)*SBG**(-1) - 16*
     +    S*T1**(-1)*SBG**(-1)*MG2 - 8*S*SBG**(-1) - 16*TG*T1**(-1)*
     +    SBG**(-1)*MG2 - 32*TG*T1*SBG**(-1)*MG2*(S+TG-M2)**(-2) + 32*
     +    TG*T1*SBG**(-1)*(S+TG-M2)**(-1) + 32*TG*T1**2*SBG**(-1)*
     +    (S+TG-M2)**(-2) - 64*TG*SBG**(-1)*MG2*(S+TG-M2)**(-1) + 24*TG
     +    *SBG**(-1) + 8*TG**2*T1**(-2)*SBG**(-1)*M2 + 16*TG**2*
     +    T1**(-2)*SBG**(-1)*MG2 - 24*TG**2*T1**(-1)*SBG**(-1) - 40*
     +    TG**2*T1*SBG**(-1)*(S+TG-M2)**(-2) + 16*TG**2*SBG**(-1)*MG2*
     +    (S+TG-M2)**(-2) )
     +
      M2QBD = M2QBD + COLO1(1)*N*CO*DLDEL1 * (  - 24*TG**2*SBG**(-1)*
     +    (S+TG-M2)**(-1) + 8*TG**3*T1**(-2)*SBG**(-1) + 16*TG**3*
     +    SBG**(-1)*(S+TG-M2)**(-2) - 16*T1**(-1)*SBG**(-1)*M2*MG2 + 32
     +    *T1**(-1)*SBG**(-1)*MG2**2 + 16*T1*SBG**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 40*T1*SBG**(-1) + 16*T1**2*SBG**(-1)*MG2*
     +    (S+TG-M2)**(-2) - 8*T1**2*SBG**(-1)*(S+TG-M2)**(-1) - 8*T1**3
     +    *SBG**(-1)*(S+TG-M2)**(-2) + 40*SBG**(-1)*M2 + 16*SBG**(-1)*
     +    MG2 - 32*SBG**(-1)*MG2**2*(S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(3)*N*CK*DLDEL1 * (  - 24 + 64*S**(-2)*T1*M2
     +     - 32*S**(-2)*T1**2 - 32*S**(-2)*M2**2 - 16*S**(-1)*TG + 16*
     +    S**(-1)*TG**2*(S+TG-M2)**(-1) - 16*S**(-1)*T1**(-1)*M2**2 - 
     +    32*S**(-1)*T1 + 48*S**(-1)*M2 - 32*S**(-1)*MG2 + 16*TG*
     +    T1**(-1) + 16*TG*T1*(S+TG-M2)**(-2) + 16*TG*(S+TG-M2)**(-1)
     +     - 8*TG**2*T1**(-2) - 8*TG**2*(S+TG-M2)**(-2) + 16*T1**(-1)*
     +    M2 - 16*T1**(-1)*MG2 - 8*T1**2*(S+TG-M2)**(-2) + 16*MG2*
     +    (S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(3)*CQED*DLDEL1 * ( 8 - 32*TG*T1**(-1)*MG2*
     +    (S+TG-M2)**(-1) - 16*TG*T1*(S+TG-M2)**(-2) - 16*TG*
     +    (S+TG-M2)**(-1) + 8*TG**2*T1**(-2) + 8*TG**2*(S+TG-M2)**(-2)
     +     + 16*T1**(-1)*MG2 + 16*T1*(S+TG-M2)**(-1) + 8*T1**2*
     +    (S+TG-M2)**(-2) + 16*MG2*(S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(4)*N*CO*DLDEL1 * ( 24 - 16*S**(-1)*TG + 16*
     +    S**(-1)*TG**2*(S+TG-M2)**(-1) + 16*S**(-1)*T1**(-1)*M2**2 + 
     +    32*S**(-1)*T1 - 48*S**(-1)*M2 - 16*TG*T1**(-1) + 16*TG*T1*
     +    (S+TG-M2)**(-2) + 16*TG*(S+TG-M2)**(-1) + 8*TG**2*T1**(-2) - 
     +    8*TG**2*(S+TG-M2)**(-2) - 16*T1**(-1)*M2 + 16*T1**(-1)*MG2 - 
     +    8*T1**2*(S+TG-M2)**(-2) + 16*MG2*(S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(4)*N*CK*DLDEL1 * ( 24 - 64*S**(-2)*T1*M2 + 
     +    32*S**(-2)*T1**2 + 32*S**(-2)*M2**2 + 16*S**(-1)*TG - 16*
     +    S**(-1)*TG**2*(S+TG-M2)**(-1) + 16*S**(-1)*T1**(-1)*M2**2 + 
     +    32*S**(-1)*T1 - 48*S**(-1)*M2 + 32*S**(-1)*MG2 - 16*TG*
     +    T1**(-1) - 16*TG*T1*(S+TG-M2)**(-2) - 16*TG*(S+TG-M2)**(-1)
     +     + 8*TG**2*T1**(-2) + 8*TG**2*(S+TG-M2)**(-2) - 16*T1**(-1)*
     +    M2 + 16*T1**(-1)*MG2 + 8*T1**2*(S+TG-M2)**(-2) - 16*MG2*
     +    (S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(4)*CQED*DLDEL1 * (  - 8 + 32*TG*T1**(-1)*
     +    MG2*(S+TG-M2)**(-1) + 16*TG*T1*(S+TG-M2)**(-2) + 16*TG*
     +    (S+TG-M2)**(-1) - 8*TG**2*T1**(-2) - 8*TG**2*(S+TG-M2)**(-2)
     +     - 16*T1**(-1)*MG2 - 16*T1*(S+TG-M2)**(-1) - 8*T1**2*
     +    (S+TG-M2)**(-2) - 16*MG2*(S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(8)*N*CO*DLDEL1 * (  - 24 + 16*S**(-1)*TG - 
     +    16*S**(-1)*TG**2*(S+TG-M2)**(-1) - 16*S**(-1)*T1**(-1)*M2**2
     +     - 32*S**(-1)*T1 + 48*S**(-1)*M2 + 16*TG*T1**(-1) - 16*TG*T1*
     +    (S+TG-M2)**(-2) - 16*TG*(S+TG-M2)**(-1) - 8*TG**2*T1**(-2) + 
     +    8*TG**2*(S+TG-M2)**(-2) + 16*T1**(-1)*M2 - 16*T1**(-1)*MG2 + 
     +    8*T1**2*(S+TG-M2)**(-2) - 16*MG2*(S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(8)*N*CK*DLDEL1 * ( 24 - 64*S**(-2)*T1*M2 + 
     +    32*S**(-2)*T1**2 + 32*S**(-2)*M2**2 + 16*S**(-1)*TG - 16*
     +    S**(-1)*TG**2*(S+TG-M2)**(-1) + 16*S**(-1)*T1**(-1)*M2**2 + 
     +    32*S**(-1)*T1 - 48*S**(-1)*M2 + 32*S**(-1)*MG2 - 16*TG*
     +    T1**(-1) - 16*TG*T1*(S+TG-M2)**(-2) - 16*TG*(S+TG-M2)**(-1)
     +     + 8*TG**2*T1**(-2) + 8*TG**2*(S+TG-M2)**(-2) - 16*T1**(-1)*
     +    M2 + 16*T1**(-1)*MG2 + 8*T1**2*(S+TG-M2)**(-2) - 16*MG2*
     +    (S+TG-M2)**(-1) )
     +
      M2QBD = M2QBD + COLO1(8)*CQED*DLDEL1 * (  - 8 + 32*TG*T1**(-1)*
     +    MG2*(S+TG-M2)**(-1) + 16*TG*T1*(S+TG-M2)**(-2) + 16*TG*
     +    (S+TG-M2)**(-1) - 8*TG**2*T1**(-2) - 8*TG**2*(S+TG-M2)**(-2)
     +     - 16*T1**(-1)*MG2 - 16*T1*(S+TG-M2)**(-1) - 8*T1**2*
     +    (S+TG-M2)**(-2) - 16*MG2*(S+TG-M2)**(-1) )


      DGGQBD = 0.5D0* ALPHAS**3 * AVG * M2QBD /4.D0 /S**2 *CONV
      RETURN
      END



      REAL*8 FUNCTION DGGGB3(ALPHAS,S,TG,S4G,MS,MG,SCA)
C***  GIVES THE SCALE DEPENDENCE OF HARD
C***  SCA = Q**2/MG**2    
      IMPLICIT NONE
      REAL*8 ALPHAS,S,TG,UG,S4G,MS,MG,PI
      REAL*8 DGGQBB, DGGGGB,PQG2,PGQ1,SCA,X1,X2
      PI = 4.D0*ATAN(1.D0)
      UG = S4G -S -TG
      X1 = -UG/(S+TG)
      X2 = -TG/(S+UG)
      PGQ1 = 4.D0/3.D0* (1.D0 +(1.D0-X1)**2)/X1
      PQG2 = 1.D0/2.D0* (X2**2 + (1.D0-X2)**2)

      DGGGB3 = ALPHAS/2.D0/PI*LOG(1.D0/SCA) *
     +     (-1/UG*DGGGGB(ALPHAS,X1*S,X1*TG,MS,MG)*PGQ1*X1**2
     +      -1/TG*DGGQBB(ALPHAS,X2*S,TG,MS,MG)*PQG2*X2**2 )
      RETURN
      END


      REAL*8 FUNCTION DGGGBH(ALPHAS,S,TG,S4G,MS,MG,EPS)
C***  HARD CROSS SECTION FOR G + QB -> GL + GL +QB
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4,S4G,T1,TG,U1,UG,MS,MG,MS2,MG2,M2,EPS,DEL
      REAL*8 NS,CONV,N,CO,CK,CQED,AVG, S42,M2GBH,SYMBY,SYMBT,SYMBU
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 AHP1P1, ABP1P1, ABP1M1, ABP1P2, A4P1P2, A4P1P1
      REAL*8 A4M1P2, A4M1P1, A4P0P2, A4P1P0, ABP2P2
      REAL*8 ABP2P1, ABP2P0
      REAL*8 C4P1P2, C4P1P1, C4M1P1, C4P1P0, CBP1P1
      REAL*8 ANG4(1:117), COLO1(1:9)
      
      CONV = 389379660.D0
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      CQED = (N**4 -1.D0)/N**2
      NS = 6.D0
      AVG = (1.D0/2.D0)**2 /N/(N**2 -1.D0)

      MS2 = MS**2
      MG2 = MG**2
      M2 = MG2 - MS2
      UG = S4G -S -TG
      T1 = TG +M2
      U1 = UG +M2
      S4 = S4G +M2
      S42 = S4**2 + EPS*MS**4
      SYMBY = 1.D0/((TG-M2)**2 +EPS*MS**4)
      SYMBT = 
     +     (-M2*(S+TG)+TG*S4G)/((-M2*(S+TG)+TG*S4G)**2+(S+TG)*EPS*MS**4)
      SYMBU = 
     +     (-M2*(S+UG)+UG*S4G)/((-M2*(S+UG)+UG*S4G)**2+(S+UG)*EPS*MS**4)

      ANGDEF(1) = 2.D0*SQRT(S4G +MG2)
      ANGDEF(2) = (S +UG)/ANGDEF(1)
      ANGDEF(3) = (S +TG)/ANGDEF(1)
      ANGDEF(4) = S4G/ANGDEF(1)
      ANGDEF(5) = (S4G +2.D0*MG2)/ANGDEF(1)
      ANGDEF(6) = -(TG +UG +2.D0*MG2)/ANGDEF(1)
      ANGDEF(7) = SQRT((TG +UG)**2 -4.D0*MG2*S)/ANGDEF(1)
      ANGDEF(8) = 
     +  (TG*S4G -S*(UG+2.D0*MG2))/(S+TG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     +  (UG*S4G -S*(TG+2.D0*MG2))/(S+UG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(1,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)
      ANC(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(1,2) = -ANB(1,1)
      ANC(1,2) = -ANC(1,1)
      ANA(1,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(1,3) = -ANA(1,3)
      ANC(1,3) =  0.D0
      ANA(1,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(1,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)-2.D0*ANGDEF(3)*ANGDEF(4)
      ANC(1,4) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(1,5) = -ANB(1,3)
      ANC(1,5) = -ANC(1,3)
      ANA(1,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(1,6) = -ANB(1,4)
      ANC(1,6) = -ANC(1,4)
      ANA(1,7) = +ANA(1,1) +M2
      ANB(1,7) = +ANB(1,1)
      ANC(1,7) = +ANC(1,1)
      ANA(1,8) = +ANA(1,5) +M2
      ANB(1,8) = +ANB(1,5)
      ANC(1,8) = +ANC(1,5)
      ANA(1,9) = +ANA(1,6) +M2
      ANB(1,9) = +ANB(1,6)
      ANC(1,9) = +ANC(1,6)


      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)
      ANA(2,7) = +ANA(2,1) +M2
      ANB(2,7) = +ANB(2,1)
      ANC(2,7) = +ANC(2,1)
      ANA(2,8) = +ANA(2,5) +M2
      ANB(2,8) = +ANB(2,5)
      ANC(2,8) = +ANC(2,5)
      ANA(2,9) = +ANA(2,6) +M2
      ANB(2,9) = +ANB(2,6)
      ANC(2,9) = +ANC(2,6)


      ANA(3,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10)
      ANC(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(3,2) = -ANB(3,1)
      ANC(3,2) = -ANC(3,1)
      ANA(3,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(3,3) = 
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10) -2.D0*ANGDEF(2)*ANGDEF(4)
      ANC(3,3) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(3,4) = -ANA(3,4)
      ANC(3,4) =  0.D0
      ANA(3,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(3,5) = -ANB(3,3)
      ANC(3,5) = -ANC(3,3)
      ANA(3,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(3,6) = -ANB(3,4)
      ANC(3,6) = -ANC(3,4)
      ANA(3,7) = +ANA(3,1) +M2
      ANB(3,7) = +ANB(3,1)
      ANC(3,7) = +ANC(3,1)
      ANA(3,8) = +ANA(3,5) +M2
      ANB(3,8) = +ANB(3,5)
      ANC(3,8) = +ANC(3,5)
      ANA(3,9) = +ANA(3,6) +M2
      ANB(3,9) = +ANB(3,6)
      ANC(3,9) = +ANC(3,6)


C$$$      ANG4(1) = A4P2P2(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(2) = A4P1P2(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(3) = A4P1P2(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(4) = A4P1P1(ANA(2,1),ANB(2,1),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(5) = A4P2P2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(6) = A4P1P2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(7) = A4P1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
C$$$      ANG4(8) = A4P1P1(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(9) = A4P2M2(ANA(2,1),ANB(2,1),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(10) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))

C$$$      ANG4(11) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
C$$$      ANG4(12) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,1),ANB(3,1),ANC(3,1))
C$$$      ANG4(13) =A4P2M2(ANA(2,2),ANB(2,2),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(14) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(15) =A4M2P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(16) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(17) =A4P1P1(ANA(3,6),ANB(3,6),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(18) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,2),ANB(1,2),ANC(1,2))
C$$$      ANG4(19) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(20) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))

      ANG4(21) =A4M1P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(22) =A4M1P2(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(23) =A4M2P1(ANA(1,5),ANB(1,5),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(24) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(25) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(26) =A4P1P2(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(27) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(28) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(29) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(30) =A4P1P2(ANA(3,9),ANB(3,9),ANA(3,7),ANB(3,7),ANC(3,7))

C$$$      ANG4(31) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(32) =A4M1P2(ANA(3,9),ANB(3,9),ANA(3,7),ANB(3,7),ANC(3,7))
      ANG4(33) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
      ANG4(34) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
C$$$      ANG4(35) =A4P1P1(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(36) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(37) =A4P1P0(ANA(2,1),ANB(2,1),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(38) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(39) =A4P1P0(ANA(2,2),ANB(2,2),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(40) =A4P0P2(ANA(1,1),ANB(1,1),ANA(2,5),ANB(2,5),ANC(2,5))

C$$$      ANG4(41) =A4P1P0(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(42) =A4M1P0(ANA(1,5),ANB(1,5),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(43) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(44) =A4P1P0(ANA(3,6),ANB(3,6),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(45) =A4M1P0(ANA(3,6),ANB(3,6),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(46) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,7),ANB(1,7),ANC(1,7))
      ANG4(47) =A4P1P0(ANA(2,7),ANB(2,7),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(48) =AHP1P1(ANA(1,3),ANB(1,3),ANA(1,4),ANB(1,4),ANC(1,4))
C$$$      ANG4(49) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(50) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,1),ANB(3,1),ANC(3,1))

      ANG4(51) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(52) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(53) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(54) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,2),ANB(1,2),ANC(1,2))
      ANG4(55) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(56) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(57) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(58) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,2),ANB(3,2),ANC(3,2))
      ANG4(59) =ABP2P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(60) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))

      ANG4(61) =ABP2P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(62) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(63) =ABP1M1(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(64) =ABP2P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(65) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(66) =ABP2P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(67) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(68) =ABP1M1(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(69) =ABP1M2(ANA(3,4),ANB(3,4),ANA(3,5),ANB(3,5),ANC(3,5))
      ANG4(70) =ABP2P0(ANA(1,3),ANB(1,3),ANA(1,1),ANB(1,1),ANC(1,1))

C$$$      ANG4(71) =ABP2P0(ANA(3,4),ANB(3,4),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(72) =A4P2P2(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(73) =A4P1P2(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(74) =A4P1P2(ANA(3,9),ANB(3,9),ANA(3,1),ANB(3,1),ANC(3,1))
C$$$      ANG4(75) =A4P1P1(ANA(2,1),ANB(2,1),ANA(2,9),ANB(2,9),ANC(2,9))
C$$$      ANG4(76) =A4P1P1(ANA(3,9),ANB(3,9),ANA(3,2),ANB(3,2),ANC(3,2))
C$$$      ANG4(77) =A4M1P2(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(78) =A4M1P1(ANA(1,5),ANB(1,5),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(79) =A4P0P2(ANA(1,1),ANB(1,1),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(80) =A4P1P0(ANA(3,9),ANB(3,9),ANA(1,1),ANB(1,1),ANC(1,1))

C$$$      ANG4(81) =ABP1P2(ANA(1,3),ANB(1,3),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(82) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,9),ANB(1,9),ANC(1,9))
      ANG4(83) =ABP1P1(ANA(1,3),ANB(1,3),ANA(1,7),ANB(1,7),ANC(1,7))
      ANG4(84) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,7),ANB(3,7),ANC(3,7))
      ANG4(85) =ABP1P2(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8)) 
      ANG4(86) =ABP1P1(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8)) 
C$$$      ANG4(87) =A4P2P2(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(88) =A4P1P2(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(89) =A4P1P2(ANA(1,8),ANB(1,8),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(90) =A4P1P1(ANA(2,1),ANB(2,1),ANA(2,8),ANB(2,8),ANC(2,8))

      ANG4(91) =A4P0P2(ANA(1,1),ANB(1,1),ANA(2,8),ANB(2,8),ANC(2,8))
      ANG4(92) =A4P1P0(ANA(1,8),ANB(1,8),ANA(1,1),ANB(1,1),ANC(1,1))
C$$$      ANG4(93) =A4M1P1(ANA(3,6),ANB(3,6),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(94) =A4P1P1(ANA(1,8),ANB(1,8),ANA(1,9),ANB(1,9),ANC(1,9))
C$$$      ANG4(95) =A4M1P2(ANA(3,6),ANB(3,6),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(96) =A4P2P2(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
      ANG4(97) =A4P1P2(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
C$$$      ANG4(98) =A4P1P2(ANA(1,8),ANB(1,8),ANA(1,7),ANB(1,7),ANC(1,7))
      ANG4(99) =A4P1P1(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))

C$$$      ANG4(100)=A4P2P2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(101)=A4P1P2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
C$$$      ANG4(102)=A4P1P2(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
      ANG4(103)=A4P1P1(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
      ANG4(104)=A4P1P1(ANA(1,8),ANB(1,8),ANA(1,6),ANB(1,6),ANC(1,6))
C$$$      ANG4(105)=A4M2P1(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(106)=A4M1P2(ANA(3,6),ANB(3,6),ANA(3,5),ANB(3,5),ANC(3,5))
C$$$      ANG4(107)=ABP1M2(ANA(1,3),ANB(1,3),ANA(1,6),ANB(1,6),ANC(1,6))
      ANG4(108)=A4P1P1(ANA(1,8),ANB(1,8),ANA(1,2),ANB(1,2),ANC(1,2))
C$$$      ANG4(109)=A4M1P1(ANA(2,2),ANB(2,2),ANA(2,8),ANB(2,8),ANC(2,8))
      ANG4(110)=A4M1P1(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))

C$$$      ANG4(111)=A4M1P2(ANA(1,3),ANB(1,3),ANA(1,8),ANB(1,8),ANC(1,8))
C$$$      ANG4(112)=A4M1P1(ANA(1,3),ANB(1,3),ANA(1,8),ANB(1,8),ANC(1,8))
      ANG4(113)=A4M1P2(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8))
      ANG4(114)=A4M1P1(ANA(3,4),ANB(3,4),ANA(3,8),ANB(3,8),ANC(3,8))
C$$$      ANG4(115)=A4M1P2(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))
C$$$      ANG4(116)=A4P2M2(ANA(2,7),ANB(2,7),ANA(2,5),ANB(2,5),ANC(2,5))
C$$$      ANG4(117)=A4P2M2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))

      DEL = EPS * MS**4
      IF (MS.GT.MG) THEN
         ANG4(34) =C4M1P1(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
         ANG4(47) =C4P1P0(ANA(2,7),ANB(2,7),ANA(1,1),ANB(1,1),ANC(1,1))
      ANG4(83) =CBP1P1(ANA(1,3),ANB(1,3),ANA(1,7),ANB(1,7),ANC(1,7),DEL)
      ANG4(84) =CBP1P1(ANA(3,4),ANB(3,4),ANA(3,7),ANB(3,7),ANC(3,7),DEL)
         ANG4(97) =C4P1P2(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
         ANG4(99) =C4P1P1(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
         ANG4(101)=C4P1P2(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
         ANG4(103)=C4P1P1(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
         ANG4(110)=C4M1P1(ANA(1,5),ANB(1,5),ANA(1,7),ANB(1,7),ANC(1,7))
      END IF

      COLO1(9) = LOG(S4G**2/MG2/(S4G+MG2))

      M2GBH = 0D0
      M2GBH = M2GBH + S42**(-1)*N*CO*(S4G+MG2)*S4 * (  - 16*S**(-1)*
     +    UG**(-1)*M2*MG2*S4G**(-1) - 16*S**(-1)*UG**(-1)*M2**2*MG2*
     +    (S+TG)**(-1)*S4G**(-1) + 16*S**(-1)*UG**(-1)*M2**2*S4G**(-1)
     +     + 16*S**(-1)*UG**(-1)*M2**3*(S+TG)**(-1)*S4G**(-1) - 16*
     +    S**(-1)*T1**(-1)*M2*MG2*S4G**(-1) - 16*S**(-1)*T1**(-1)*M2**2
     +    *MG2*(S+TG)**(-1)*S4G**(-1) + 8*S**(-1)*T1**(-1)*M2**2*
     +    S4G**(-1) + 8*S**(-1)*T1**(-1)*M2**3*(S+TG)**(-1)*S4G**(-1)
     +     + 8*S**(-1)*T1*M2*MG2*(S+TG)**(-2)*S4G**(-1) - 8*S**(-1)*T1*
     +    M2*(S+TG)**(-1)*S4G**(-1) + 4*S**(-1)*T1*MG2*(S+TG)**(-1)*
     +    S4G**(-1) - 4*S**(-1)*T1**2*MG2*(S+TG)**(-2)*S4G**(-1) - 4*
     +    S**(-1)*M2*MG2*(S+TG)**(-1)*S4G**(-1) + 8*S**(-1)*M2*
     +    S4G**(-1) - 4*S**(-1)*M2**2*MG2*(S+TG)**(-2)*S4G**(-1) + 16*
     +    S**(-1)*M2**2*(S+TG)**(-1)*S4G**(-1) - 4*S*T1**(-1)*M2*MG2*
     +    (S+TG)**(-2)*S4G**(-1) - 4*S*T1**(-1)*M2*(S+TG)**(-1)*
     +    S4G**(-1) - 4*S*T1**(-1)*M2**2*(S+TG)**(-2)*S4G**(-1) - 4*S*
     +    T1**(-1)*MG2*(S+TG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + S42**(-1)*N*CO*(S4G+MG2)*S4 * ( 4*S*M2*
     +    (S+TG)**(-2)*S4G**(-1) + 4*S*MG2*(S+TG)**(-2)*S4G**(-1) + 8*S
     +    *(S+TG)**(-1)*S4G**(-1) + 4*S**2*T1**(-1)*M2*(S+TG)**(-2)*
     +    S4G**(-1) - 4*S**2*(S+TG)**(-2)*S4G**(-1) + 32*UG**(-2)*M2*
     +    MG2*S4G**(-1) + 32*UG**(-2)*M2**2*MG2*(S+TG)**(-1)*S4G**(-1)
     +     + 32*UG**(-1)*M2*MG2*(S+TG)**(-1)*S4G**(-1) + 16*UG**(-1)*M2
     +    *S4G**(-1) + 16*UG**(-1)*M2**2*(S+TG)**(-1)*S4G**(-1) + 24*
     +    T1**(-1)*M2*MG2*(S+TG)**(-1)*S4G**(-1) + 4*T1**(-1)*M2**2*MG2
     +    *(S+TG)**(-2)*S4G**(-1) - 8*T1**(-1)*M2**2*(S+TG)**(-1)*
     +    S4G**(-1) + 4*T1**(-1)*MG2*S4G**(-1) - 8*T1*M2*(S+TG)**(-2)*
     +    S4G**(-1) + 4*T1**2*(S+TG)**(-2)*S4G**(-1) - 4*M2*MG2*
     +    (S+TG)**(-2)*S4G**(-1) + 8*M2*(S+TG)**(-1)*S4G**(-1) + 4*
     +    M2**2*(S+TG)**(-2)*S4G**(-1) - 8*MG2*(S+TG)**(-1)*S4G**(-1)
     +     - 4*S4G**(-1) )
     +
      M2GBH = M2GBH + S42**(-1)*N*CO*S4 * (  - 8 - 16*S**(-2)*UG**(-1)*
     +    M2**2*MG2 + 8*S**(-2)*UG**(-1)*M2**3 - 16*S**(-2)*T1**(-1)*
     +    M2**2*MG2 + 8*S**(-2)*T1**(-1)*M2**3 + 40*S**(-1)*UG**(-1)*M2
     +    *MG2 - 40*S**(-1)*UG**(-1)*M2**2 - 16*S**(-1)*UG**(-1)*MG2**2
     +     + 24*S**(-1)*T1**(-1)*M2*MG2 - 16*S**(-1)*T1**(-1)*M2**2 - 
     +    16*S**(-1)*T1**(-1)*MG2**2 + 4*S**(-1)*T1 - 12*S**(-1)*M2 + 
     +    16*S**(-1)*MG2 - 8*S*UG**(-1) - 32*UG**(-2)*M2*MG2 + 32*
     +    UG**(-2)*MG2**2 - 28*UG**(-1)*M2 + 28*UG**(-1)*MG2 + 8*
     +    T1**(-2)*M2**2 )
     +
      M2GBH = M2GBH + S42**(-1)*N*CK*(S4G+MG2)*S4 * ( 8*S**(-1)*
     +    T1**(-1)*M2**2*S4G**(-1) + 8*S**(-1)*T1**(-1)*M2**3*
     +    (S+UG)**(-1)*S4G**(-1) + 8*S**(-1)*T1*M2*MG2*(S+UG)**(-2)*
     +    S4G**(-1) + 12*S**(-1)*T1*M2*(S+UG)**(-1)*S4G**(-1) - 24*
     +    S**(-1)*T1*M2**2*(S+UG)**(-2)*S4G**(-1) - 8*S**(-1)*T1*MG2*
     +    (S+UG)**(-1)*S4G**(-1) + 20*S**(-1)*T1**2*M2*(S+UG)**(-2)*
     +    S4G**(-1) - 8*S**(-1)*T1**2*MG2*(S+UG)**(-2)*S4G**(-1) - 4*
     +    S**(-1)*T1**2*(S+UG)**(-1)*S4G**(-1) - 4*S**(-1)*T1**3*
     +    (S+UG)**(-2)*S4G**(-1) + 8*S**(-1)*M2*MG2*(S+UG)**(-1)*
     +    S4G**(-1) - 8*S**(-1)*M2*S4G**(-1) - 16*S**(-1)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) + 8*S**(-1)*M2**3*(S+UG)**(-2)*
     +    S4G**(-1) - 4*S*UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 4*S*UG**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) - 4*S*
     +    T1**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*UG**(-1)*M2*MG2*
     +    (S+UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + S42**(-1)*N*CK*(S4G+MG2)*S4 * (  - 16*UG**(-1)*
     +    M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*T1**(-2)*
     +    M2**3*(S+UG)**(-1)*S4G**(-1) + 16*T1**(-1)*M2*MG2*
     +    (S+UG)**(-1)*S4G**(-1) + 16*T1**(-1)*M2**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 40*T1**(-1)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) + 16*T1**(-1)*M2**3*(S+UG)**(-2)*
     +    S4G**(-1) - 4*T1**(-1)*MG2*S4G**(-1) + 32*T1*M2*(S+UG)**(-2)*
     +    S4G**(-1) - 16*T1*MG2*(S+UG)**(-2)*S4G**(-1) + 8*T1*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*T1*(S+UG)**(-1)*
     +    S4G**(-1) - 8*T1**2*(S+UG)**(-2)*S4G**(-1) + 16*M2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) - 32*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 32*M2*(S+UG)**(-1)*S4G**(-1) - 40*M2**2*
     +    (S+UG)**(-2)*S4G**(-1) - 28*MG2*(S+UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + S42**(-1)*N*CK*S4 * ( 8 + 16*S**(-2)*UG**(-1)*
     +    M2**2*MG2 - 8*S**(-2)*UG**(-1)*M2**3 + 16*S**(-2)*T1**(-1)*
     +    M2**2*MG2 - 8*S**(-2)*T1**(-1)*M2**3 - 32*S**(-1)*UG**(-1)*M2
     +    *MG2 + 40*S**(-1)*UG**(-1)*M2**2 + 16*S**(-1)*UG**(-1)*MG2**2
     +     - 16*S**(-1)*T1**(-1)*M2*MG2 + 16*S**(-1)*T1**(-1)*MG2**2 - 
     +    4*S**(-1)*T1 + 12*S**(-1)*M2 - 8*S**(-1)*MG2 + 8*S*UG**(-1)
     +     + 32*UG**(-2)*M2*MG2 - 32*UG**(-2)*MG2**2 + 28*UG**(-1)*M2
     +     - 24*UG**(-1)*MG2 - 24*T1**(-2)*M2**2 + 8*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + S42**(-1)*CQED*(S4G+MG2)*S4 * (  - 8*S**(-1)*
     +    T1**(-1)*M2**3*(S+UG)**(-1)*S4G**(-1) - 8*S**(-1)*T1*M2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) + 32*S**(-1)*T1*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 12*S**(-1)*T1*M2*
     +    (S+UG)**(-1)*S4G**(-1) + 16*S**(-1)*T1*M2**2*(S+UG)**(-2)*
     +    S4G**(-1) + 16*S**(-1)*T1*MG2*(S+UG)**(-1)*S4G**(-1) - 12*
     +    S**(-1)*T1**2*M2*(S+UG)**(-2)*S4G**(-1) + 8*S**(-1)*T1**2*MG2
     +    *(S+UG)**(-2)*S4G**(-1) - 8*S**(-1)*T1**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S**(-1)*T1**2*
     +    (S+UG)**(-1)*S4G**(-1) + 4*S**(-1)*T1**3*(S+UG)**(-2)*
     +    S4G**(-1) - 24*S**(-1)*M2*MG2*(S+UG)**(-1)*S4G**(-1) - 32*
     +    S**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*
     +    S**(-1)*M2**2*(S+UG)**(-1)*S4G**(-1) - 8*S**(-1)*M2**3*
     +    (S+UG)**(-2)*S4G**(-1) + 4*S*T1**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + S42**(-1)*CQED*(S4G+MG2)*S4 * (  - 8*T1**(-2)*
     +    M2**3*(S+UG)**(-1)*S4G**(-1) - 8*T1**(-1)*M2*MG2*(S+UG)**(-1)
     +    *S4G**(-1) - 16*T1**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 16*T1**(-1)*M2**2*(S+UG)**(-1)*S4G**(-1) - 8*
     +    T1**(-1)*M2**3*(S+UG)**(-2)*S4G**(-1) - 12*T1*M2*(S+UG)**(-2)
     +    *S4G**(-1) + 8*T1*MG2*(S+UG)**(-2)*S4G**(-1) - 12*T1*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*T1*(S+UG)**(-1)*
     +    S4G**(-1) + 4*T1**2*(S+UG)**(-2)*S4G**(-1) - 8*M2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) + 32*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 12*M2*(S+UG)**(-1)*S4G**(-1) + 16*M2**2*
     +    (S+UG)**(-2)*S4G**(-1) + 12*MG2*(S+UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + S42**(-1)*CQED*S4 * ( 8*S**(-1)*T1**(-1)*M2**2 - 
     +    8*S**(-1)*MG2 + 8*T1**(-2)*M2**2 - 8*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2)*SYMBT * (  - 4 + 8*S**(-1)*T1*M2*
     +    MG2*(TG-M2)*SYMBY*S4G**(-1) - 16*S**(-1)*T1*M2*S4G**(-1) - 24
     +    *S**(-1)*T1*M2**2*(TG-M2)*SYMBY*S4G**(-1) + 4*S**(-1)*T1*MG2*
     +    (TG-M2)*SYMBY + 4*S**(-1)*T1*MG2*S4G**(-1) + 24*S**(-1)*T1**2
     +    *M2*(TG-M2)*SYMBY*S4G**(-1) - 4*S**(-1)*T1**2*MG2*(TG-M2)*
     +    SYMBY*S4G**(-1) + 8*S**(-1)*T1**2*S4G**(-1) - 8*S**(-1)*T1**3
     +    *(TG-M2)*SYMBY*S4G**(-1) - 4*S**(-1)*M2*MG2*(TG-M2)*SYMBY - 4
     +    *S**(-1)*M2*MG2*S4G**(-1) - 4*S**(-1)*M2**2*MG2*(TG-M2)*SYMBY
     +    *S4G**(-1) + 8*S**(-1)*M2**2*S4G**(-1) + 8*S**(-1)*M2**3*
     +    (TG-M2)*SYMBY*S4G**(-1) + 32*S*TG*UG**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 4*S*UG**(-1)*MG2*(S+TG-M2)**(-1) + 16*S*UG**(-1)*
     +    MG2*(TG+UG-M2)**(-1) - 12*S*T1*M2*(S+TG-M2)**(-1)*(TG-M2)*
     +    SYMBY*S4G**(-1) - 8*S*T1*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) - 4*S*T1*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 4*S*T1*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 4*S*T1*(TG-M2)*SYMBY*S4G**(-1) + 
     +    12*S*T1*(TG+UG-M2)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2)*SYMBT * ( 4*S*T1**2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*S*M2*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*S*M2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY + 4*S*M2*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 4*S*M2*(TG-M2)*SYMBY*S4G**(-1) - 12*S*M2*
     +    (TG+UG-M2)**(-1)*S4G**(-1) + 8*S*M2**2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) + 4*S*MG2*(S+TG-M2)**(-1)*(TG-M2)*
     +    SYMBY + 8*S*MG2*(S+TG-M2)**(-1)*S4G**(-1) + 16*S*MG2*(TG-M2)*
     +    SYMBY*S4G**(-1) + 4*S*(S+TG-M2)**(-1) - 12*S*(TG+UG-M2)**(-1)
     +     + 8*S*S4G**(-1) + 16*S**2*UG**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 16*S**2*UG**(-1)*MG2*(TG+UG-M2)**(-1)*S4G**(-1)
     +     + 4*S**2*T1*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*S**2
     +    *M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*S**2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 12*S**2*(TG+UG-M2)**(-1)*
     +    S4G**(-1) + 32*TG**2*UG**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) + 4
     +    *UG**(-1)*M2*MG2*(S+TG-M2)**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2)*SYMBT * ( 4*UG**(-1)*M2*MG2*
     +    S4G**(-1) - 4*UG**(-1)*M2*(S+TG-M2)**(-1)*S4G - 4*UG**(-1)*M2
     +     + 4*UG**(-1)*M2**2*MG2*(S+TG-M2)**(-1)*S4G**(-1) - 4*
     +    UG**(-1)*M2**2*(S+TG-M2)**(-1) + 8*UG**(-1)*MG2*
     +    (S+TG-M2)**(-1)*S4G - 16*UG**(-1)*MG2*(TG-M2)*SYMBY*S4G + 12*
     +    UG**(-1)*MG2 + 12*T1*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 12*T1*M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 4*T1*M2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 16*T1*M2*(TG-M2)*SYMBY*S4G**(-1)
     +     + 16*T1*M2**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*T1
     +    *MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 48*T1*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 8*T1*(S+TG-M2)**(-1) - 4*T1*(TG-M2)*SYMBY - 8*T1*
     +    (TG+UG-M2)**(-1) + 20*T1*S4G**(-1) - 8*T1**2*M2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*T1**2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY - 8*T1**2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 12*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 12*M2*
     +    MG2*(S+TG-M2)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2)*SYMBT * (  - 48*M2*MG2*(TG-M2)*
     +    SYMBY*S4G**(-1) - 8*M2*(S+TG-M2)**(-1) + 4*M2*(TG-M2)*SYMBY
     +     + 8*M2*(TG+UG-M2)**(-1) - 12*M2*S4G**(-1) - 12*M2**2*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*M2**2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY + 4*M2**2*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 8*M2**2*(TG-M2)*SYMBY*S4G**(-1) - 8*M2**3*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*MG2*
     +    (S+TG-M2)**(-1) + 12*MG2*(TG-M2)*SYMBY - 16*MG2*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 64*S**(-2)*TG**2*UG**(-1)*
     +    S4G**(-1) - 32*S**(-2)*TG**2*(S+TG)**(-1)*S4G**(-1) - 64*
     +    S**(-2)*TG**3*UG**(-2)*S4G**(-1) + 64*S**(-2)*UG**(-2)*S4G**2
     +     - 128*S**(-2)*UG**(-1)*S4G + 96*S**(-2) + 4*S**(-1)*TG**(-1)
     +    *T1*M2*(TG-M2)*SYMBY*S4G**(-1) + 4*S**(-1)*TG**(-1)*T1*
     +    S4G**(-1) - 4*S**(-1)*TG**(-1)*M2*(TG-M2)*SYMBY - 4*S**(-1)*
     +    TG**(-1)*M2*S4G**(-1) - 4*S**(-1)*TG**(-1)*M2**2*(TG-M2)*
     +    SYMBY*S4G**(-1) - 32*S**(-1)*TG**(-1)*MG2*S4G**(-1) - 4*
     +    S**(-1)*TG**(-1) + 256*S**(-1)*TG*UG**(-2)*MG2*S4G**(-1) - 64
     +    *S**(-1)*TG*UG**(-1)*S4G**(-1) - 8*S**(-1)*TG*UG*(S+UG)**(-2)
     +    *S4G**(-1) - 8*S**(-1)*TG*UG*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 8*S**(-1)*TG*UG**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*S**(-1)*TG*T1**(-1)*
     +    M2*(S+UG)**(-2) + 8*S**(-1)*TG*T1**(-1)*M2**2*(S+UG)**(-2)*
     +    S4G**(-1) + 8*S**(-1)*TG*T1**(-1)*(S+UG)**(-2)*S4G - 8*
     +    S**(-1)*TG*T1**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 8*S**(-1)*TG*M2*
     +    (S+UG)**(-2)*S4G**(-1) - 8*S**(-1)*TG*(S+UG)**(-2) + 256*
     +    S**(-1)*TG**2*UG**(-3)*MG2*S4G**(-1) - 128*S**(-1)*TG**2*
     +    UG**(-2)*S4G**(-1) - 8*S**(-1)*TG**2*UG*(S+UG)**(-3)*
     +    S4G**(-1) + 8*S**(-1)*TG**2*UG**2*(S+UG)**(-2)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*S**(-1)*TG**2*
     +    T1**(-1)*M2*(S+UG)**(-3) + 8*S**(-1)*TG**2*T1**(-1)*M2**2*
     +    (S+UG)**(-3)*S4G**(-1) + 8*S**(-1)*TG**2*T1**(-1)*
     +    (S+UG)**(-3)*S4G - 8*S**(-1)*TG**2*T1**(-1)*(S+UG)**(-1)*
     +    S4G**(-1) - 8*S**(-1)*TG**2*M2*(S+UG)**(-3)*S4G**(-1) - 8*
     +    S**(-1)*TG**2*(S+UG)**(-3) - 8*S**(-1)*TG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 128*S**(-1)*UG**(-3)*MG2
     +    *S4G + 2*S**(-1)*UG**(-2)*M2*(S+TG-M2)**(-1)*S4G + 128*
     +    S**(-1)*UG**(-2)*MG2 - 2*S**(-1)*UG**(-2)*(S+TG-M2)**(-1)*
     +    S4G**2 - 78*S**(-1)*UG**(-2)*S4G + 16*S**(-1)*UG**(-1)*M2*MG2
     +    *(S4-S)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * ( 8*S**(-1)*UG**(-1)*M2*
     +    (S+TG)**(-1) + 2*S**(-1)*UG**(-1)*M2*(S+TG-M2)**(-1) + 4*
     +    S**(-1)*UG**(-1)*M2*(TG-M2)*SYMBY - 16*S**(-1)*UG**(-1)*M2*
     +    S4G**(-1) + 16*S**(-1)*UG**(-1)*M2**2*MG2*(S+TG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) - 8*S**(-1)*UG**(-1)*M2**2*
     +    (S+TG)**(-1)*S4G**(-1) - 8*S**(-1)*UG**(-1)*M2**3*
     +    (S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 8*S**(-1)*UG**(-1)*MG2*
     +    (S+TG)**(-1) + 64*S**(-1)*UG**(-1)*MG2*S4G**(-1) - 16*S**(-1)
     +    *UG**(-1)*(S+TG)**(-1)*S4G + 16*S**(-1)*UG**(-1)*(S+UG)**(-1)
     +    *S4G + 8*S**(-1)*UG**(-1)*(S+TG-M2)**(-1)*S4G + 12*S**(-1)*
     +    UG**(-1)*(TG-M2)*SYMBY*S4G - 8*S**(-1)*UG**(-1)*
     +    (TG+UG-M2)**(-1)*S4G + 150*S**(-1)*UG**(-1) - 4*S**(-1)*UG*
     +    (S+UG)**(-1)*S4G**(-1) + 16*S**(-1)*T1**(-1)*M2*MG2*
     +    (S4-S)**(-1)*S4G**(-1) + 8*S**(-1)*T1**(-1)*M2*(S+UG)**(-1)
     +     + 12*S**(-1)*T1**(-1)*M2*S4G**(-1) + 16*S**(-1)*T1**(-1)*
     +    M2**2*MG2*(S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 4*S**(-1)*T1**(-1)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) - 16*S**(-1)*T1**(-1)*M2**2*S4G**(-2)
     +     - 8*S**(-1)*T1**(-1)*M2**3*(S+TG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) + 16*S**(-1)*T1**(-1)*M2**3*(S+UG)**(-1)*S4G**(-2)
     +     + 4*S**(-1)*T1**(-1)*(S+UG)**(-1)*S4G - 4*S**(-1)*T1**(-1)
     +     - 4*S**(-1)*T1*M2*(S+TG)**(-2)*S4G**(-1) + 144*S**(-1)*T1*M2
     +    *(S+UG)**(-1)*S4G**(-2) - 16*S**(-1)*T1*MG2*(S+UG)**(-1)*
     +    S4G**(-2) + 16*S**(-1)*T1*(S+TG)**(-1)*S4G**(-1) - 32*S**(-1)
     +    *T1*(S+UG)**(-1)*S4G**(-1) + 4*S**(-1)*T1*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 12*S**(-1)*T1*(TG-M2)*SYMBY*S4G**(-1) - 64*
     +    S**(-1)*T1*S4G**(-2) + 2*S**(-1)*T1**2*(S+TG)**(-2)*S4G**(-1)
     +     - 64*S**(-1)*T1**2*(S+UG)**(-1)*S4G**(-2) + 16*S**(-1)*M2*
     +    MG2*(S+UG)**(-1)*S4G**(-2) - 24*S**(-1)*M2*(S+TG)**(-1)*
     +    S4G**(-1) + 36*S**(-1)*M2*(S+UG)**(-1)*S4G**(-1) - 8*S**(-1)*
     +    M2*(S+TG-M2)**(-1)*S4G**(-1) + 12*S**(-1)*M2*(TG-M2)*SYMBY*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * ( 80*S**(-1)*M2*S4G**(-2) + 2*
     +    S**(-1)*M2**2*(S+TG)**(-2)*S4G**(-1) - 96*S**(-1)*M2**2*
     +    (S+UG)**(-1)*S4G**(-2) + 8*S**(-1)*MG2*(S+TG)**(-1)*S4G**(-1)
     +     - 8*S**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) - 4*S**(-1)*MG2*
     +    (TG-M2)*SYMBY*S4G**(-1) - 16*S**(-1)*MG2*S4G**(-2) + 16*
     +    S**(-1)*(S+TG)**(-1) - 20*S**(-1)*(S+UG)**(-1) - 6*S**(-1)*
     +    (S+TG-M2)**(-1) - 8*S**(-1)*(TG-M2)*SYMBY + 8*S**(-1)*
     +    (TG+UG-M2)**(-1) - 146*S**(-1)*S4G**(-1) + 64*S*TG**(-2)*
     +    UG**(-2)*MG2**2*S4G**(-1) - 256*S*TG**(-1)*UG**(-3)*MG2 - 128
     +    *S*TG**(-1)*UG**(-3)*MG2**2*S4G**(-1) - 4*S*TG**(-1)*UG**(-2)
     +    *M2*MG2*(S+TG-M2)**(-1)*S4G**(-1) + 380*S*TG**(-1)*UG**(-2)*
     +    MG2*S4G**(-1) + 4*S*TG**(-1)*UG**(-1)*M2*MG2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) + 128*S*TG**(-1)*UG**(-1)*MG2*
     +    (S+TG)**(-1)*S4G**(-1) + 4*S*TG**(-1)*UG**(-1)*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 4*S*TG**(-1)*UG**(-1)*MG2*(TG-M2)
     +    *SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 64*S*TG**(-1)*UG**(-1)*
     +    S4G**(-1) - 4*S*TG**(-1)*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 8*S*TG*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 8*S*TG**2*(S+UG)**(-2)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 384*S*UG**(-4)*MG2**2*S4G**(-1) + 640*S*UG**(-3)*
     +    MG2*S4G**(-1) + 4*S*UG**(-2)*MG2*(S+TG-M2)**(-1)*S4G**(-1) + 
     +    16*S*UG**(-2)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 16*S*UG**(-2)*MG2
     +    *(TG+UG-M2)**(-1)*S4G**(-1) - 32*S*UG**(-2)*(S+UG)**(-1) - 80
     +    *S*UG**(-2)*S4G**(-1) + 4*S*UG**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*S*
     +    UG**(-1)*M2*(S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 8*S*
     +    UG**(-1)*M2*(S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 4*S*
     +    UG**(-1)*M2*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*S*
     +    UG**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 4*S*
     +    UG**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S*UG**(-1)
     +    *M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * ( 8*S*UG**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 4*S*UG**(-1)*MG2*
     +    (S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 8*S*UG**(-1)*MG2*
     +    (S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*S*UG**(-1)*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1) - 4*S*UG**(-1)*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S*UG**(-1)*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*S*UG**(-1)*
     +    (S+TG)**(-1)*(S+TG-M2)**(-1) - 8*S*UG**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) + 130*S*UG**(-1)*(S+UG)**(-1)*S4G**(-1) - 4*S*
     +    UG**(-1)*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 32*S*UG**(-1)*
     +    S4G**(-2) - 4*S*T1**(-1)*M2*(S+TG)**(-2)*S4G**(-1) - 8*S*
     +    T1**(-1)*M2*(S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 4*S*
     +    T1**(-1)*MG2*(S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 4*S*
     +    T1**(-1)*(S+TG)**(-1)*S4G**(-1) - 4*S*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 8*S*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * ( 4*S*(S+TG)**(-2)*S4G**(-1) - 8
     +    *S*(S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 32*S*(S+UG)**(-1)
     +    *S4G**(-2) - 4*S*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 384*S**2*TG**(-2)*
     +    UG**(-4)*MG2**2 - 512*S**2*TG**(-2)*UG**(-3)*MG2**2*S4G**(-1)
     +     - 128*S**2*TG**(-2)*UG**(-2)*MG2**2*(S+TG)**(-1)*S4G**(-1)
     +     - 640*S**2*TG**(-1)*UG**(-4)*MG2**2*S4G**(-1) + 384*S**2*
     +    TG**(-1)*UG**(-3)*MG2*S4G**(-1) + 4*S**2*TG**(-1)*UG**(-2)*
     +    MG2*(S+TG-M2)**(-1)*S4G**(-1) - 4*S**2*TG**(-1)*UG**(-1)*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 64*S**2*TG**(-1)*
     +    UG**(-1)*(S+TG)**(-1)*S4G**(-1) + 32*S**2*TG**(-1)*
     +    (S+TG)**(-2)*S4G**(-1) + 16*S**2*UG**(-2)*(S+UG)**(-1)*
     +    S4G**(-1) + 4*S**2*UG**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 32*S**2*UG**(-1)*(S+UG)**(-1)*
     +    S4G**(-2) - 512*S**3*TG**(-2)*UG**(-4)*MG2**2*S4G**(-1) - 128
     +    *TG**(-1)*UG**(-2)*MG2**2*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 4*TG**(-1)*UG**(-1)*M2*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 68*TG**(-1)*UG**(-1)*MG2*
     +    S4G**(-1) + 4*TG**(-1)*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*TG**(-1)*M2*(TG-M2)*SYMBY*S4G**(-1) + 4*
     +    TG**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 44*TG**(-1)*S4G**(-1)
     +     - 256*TG*UG**(-4)*MG2**2*S4G**(-1) + 512*TG*UG**(-3)*MG2*
     +    S4G**(-1) - 128*TG*UG**(-2)*S4G**(-1) - 64*TG*UG**(-1)*
     +    (S+TG)**(-1)*S4G**(-1) - 16*TG*T1**(-1)*M2*(S+UG)**(-2)*
     +    S4G**(-1) - 16*TG*T1**(-1)*(S+UG)**(-2) - 32*TG*(S+TG)**(-2)*
     +    S4G**(-1) + 24*TG*(S+UG)**(-2)*S4G**(-1) - 8*TG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*TG**2*T1**(-1)*M2*
     +    (S+UG)**(-3)*S4G**(-1) - 16*TG**2*T1**(-1)*(S+UG)**(-3) + 8*
     +    TG**2*(S+UG)**(-3)*S4G**(-1) + 128*UG**(-4)*MG2**2 - 256*
     +    UG**(-3)*MG2**2*S4G**(-1) - 16*UG**(-2)*M2*MG2*(S+TG)**(-1)*
     +    (S+TG-M2)**(-1) - 32*UG**(-2)*M2*MG2*(S+TG)**(-1)*S4G**(-1)
     +     + 14*UG**(-2)*M2*MG2*(S+TG-M2)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 2*UG**(-2)*M2*
     +    (S+TG-M2)**(-1) - 16*UG**(-2)*MG2*(S+TG)**(-1)*
     +    (S+TG-M2)**(-1)*S4G + 80*UG**(-2)*MG2*(S+TG)**(-1) + 18*
     +    UG**(-2)*MG2*(S+TG-M2)**(-1) - 16*UG**(-2)*MG2*(TG-M2)*SYMBY
     +     + 16*UG**(-2)*MG2*(TG+UG-M2)**(-1) + 174*UG**(-2)*MG2*
     +    S4G**(-1) + 64*UG**(-2)*MG2**2*(S+TG)**(-1)*S4G**(-1) + 16*
     +    UG**(-2)*(S+UG)**(-1)*S4G + 2*UG**(-2)*(S+TG-M2)**(-1)*S4G + 
     +    94*UG**(-2) - 16*UG**(-1)*M2*MG2*(S+TG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) + 26*UG**(-1)*M2*MG2*(S+TG)**(-1)*(S+TG-M2)**(-1)*
     +    S4G**(-1) + 8*UG**(-1)*M2*MG2*(S+UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) - 8*UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY - 8*UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 8*UG**(-1)*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) - 12*UG**(-1)*M2*(S+TG)**(-1)*(S+TG-M2)**(-1) - 24*
     +    UG**(-1)*M2*(S+TG)**(-1)*S4G**(-1) - 4*UG**(-1)*M2*
     +    (S+UG)**(-1)*(S+TG-M2)**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 4*UG**(-1)*M2*(S+UG)**(-1)*
     +    (TG-M2)*SYMBY + 32*UG**(-1)*M2*(S+UG)**(-1)*S4G**(-1) + 4*
     +    UG**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G + 4*
     +    UG**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G - 8*
     +    UG**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1) + 8*UG**(-1)*M2*
     +    (S4-S)**(-1)*S4G**(-1) + 4*UG**(-1)*M2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY + 8*UG**(-1)*M2*(S+TG-M2)**(-1)*S4G**(-1) - 4*
     +    UG**(-1)*M2*(TG-M2)*SYMBY*S4G**(-1) + 8*UG**(-1)*M2**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 16*
     +    UG**(-1)*M2**2*(S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 8*
     +    UG**(-1)*M2**2*(S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 4*
     +    UG**(-1)*M2**2*(S+UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 4*
     +    UG**(-1)*M2**2*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 32*
     +    UG**(-1)*M2**2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*
     +    UG**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * ( 4*UG**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 14*
     +    UG**(-1)*MG2*(S+TG)**(-1)*(S+TG-M2)**(-1) - 6*UG**(-1)*MG2*
     +    (S+TG)**(-1)*S4G**(-1) - 8*UG**(-1)*MG2*(S+UG)**(-1)*(TG-M2)*
     +    SYMBY + 4*UG**(-1)*MG2*(S4-S)**(-1)*S4G**(-1) - 8*UG**(-1)*
     +    MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 2*UG**(-1)*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 20*UG**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 4*UG**(-1)*(S+TG)**(-1)*(S+TG-M2)**(-1)*S4G + 34*
     +    UG**(-1)*(S+TG)**(-1) - 112*UG**(-1)*(S+UG)**(-1) + 4*
     +    UG**(-1)*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G - 2*UG**(-1)*
     +    (S+TG-M2)**(-1) - 12*UG**(-1)*(TG-M2)*SYMBY + 8*UG**(-1)*
     +    (TG+UG-M2)**(-1) - 148*UG**(-1)*S4G**(-1) - 8*UG*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*T1**(-2)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) - 8*T1**(-2)*M2**3*(S+UG)**(-2)*
     +    S4G**(-1) - 16*T1**(-1)*M2*MG2*(S+TG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 16*T1**(-1)*M2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) + 8*T1**(-1)*M2*MG2*(S+UG)**(-1)*
     +    S4G**(-2) + 8*T1**(-1)*M2*(S+TG)**(-1)*S4G**(-1) - 36*
     +    T1**(-1)*M2*(S+UG)**(-1)*S4G**(-1) + 8*T1**(-1)*M2*
     +    (S4-S)**(-1)*S4G**(-1) + 4*T1**(-1)*M2**2*(S+TG)**(-2)*
     +    S4G**(-1) + 16*T1**(-1)*M2**2*(S+TG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) + 40*T1**(-1)*M2**2*(S+UG)**(-2)*S4G**(-1) - 8*
     +    T1**(-1)*M2**2*(S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 20*
     +    T1**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) + 4*T1**(-1)*MG2*
     +    (S4-S)**(-1)*S4G**(-1) - 8*T1**(-1)*MG2*S4G**(-2) - 4*
     +    T1**(-1)*(S+UG)**(-1) + 8*T1**(-1)*S4G**(-1) + 8*T1*M2*
     +    (S+TG)**(-2)*(S+TG-M2)**(-1)*S4G**(-1) - 4*T1*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 12*T1*M2
     +    *(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*T1*
     +    M2**2*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 12*T1*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * (  - 2*T1*(S+TG)**(-2)*S4G**(-1)
     +     - 8*T1*(S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 32*T1*
     +    (S+UG)**(-2)*S4G**(-1) + 36*T1*(S+UG)**(-1)*S4G**(-2) + 4*T1*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY - 8*T1*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*T1**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 32*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 2*M2*
     +    (S+TG)**(-2)*S4G**(-1) + 24*M2*(S+TG)**(-1)*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 64*M2*(S+UG)**(-2)*S4G**(-1) + 4*M2*(S+UG)**(-1)*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 4*M2*(S+UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) - 36*M2*(S+UG)**(-1)*S4G**(-2) + 4*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1) - 12*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 36*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*M2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 8*M2**2*(S+TG)**(-2)*
     +    (S+TG-M2)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CO*(S4G+MG2) * ( 8*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-2) + 12*M2**2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 12*M2**2*(-M2*(S+UG)+TG*UG)**(-1)
     +    *(TG-M2)*SYMBY*S4G**(-1) + 16*M2**3*(-M2*(S+UG)+TG*UG)**(-2)*
     +    S4G**(-1) + 2*MG2*(S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 16
     +    *MG2*(S+UG)**(-2)*S4G**(-1) + 8*MG2*(S+UG)**(-1)*(TG-M2)*
     +    SYMBY*S4G**(-1) - 8*MG2*(S+UG)**(-1)*S4G**(-2) - 4*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*(S+TG)**(-1)*
     +    (S+TG-M2)**(-1) + 60*(S+TG)**(-1)*S4G**(-1) + 126*
     +    (S+UG)**(-1)*S4G**(-1) - 4*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 4*
     +    (TG-M2)*SYMBY*S4G**(-1) - 12*(TG+UG-M2)**(-1)*S4G**(-1) + 36*
     +    S4G**(-2) )
     +
      M2GBH = M2GBH + N*CO * ( 16*S**(-2)*UG**(-1)*M2**2*MG2*
     +    (S4-S)**(-1) - 8*S**(-2)*UG**(-1)*M2**3*(S4-S)**(-1) + 16*
     +    S**(-2)*T1**(-1)*M2**2*MG2*(S4-S)**(-1) - 8*S**(-2)*T1**(-1)*
     +    M2**3*(S4-S)**(-1) - 24*S**(-1)*UG**(-1)*M2*MG2*(S4-S)**(-1)
     +     + 16*S**(-1)*UG**(-1)*M2 + 16*S**(-1)*UG**(-1)*M2**2*
     +    (S4-S)**(-1) - 16*S**(-1)*UG**(-1)*MG2 + 16*S**(-1)*UG**(-1)*
     +    MG2**2*(S4-S)**(-1) - 16*S**(-1)*UG**(-1)*S4G - 24*S**(-1)*
     +    T1**(-1)*M2*MG2*(S4-S)**(-1) + 16*S**(-1)*T1**(-1)*M2**2*
     +    (S4-S)**(-1) + 16*S**(-1)*T1**(-1)*MG2**2*(S4-S)**(-1) + 20*
     +    S**(-1) + 4*S*UG**(-1)*(S4-S)**(-1) + 4*S*T1**(-1)*
     +    (S4-S)**(-1) + 32*UG**(-2)*MG2 - 12*UG**(-1)*M2*(S4-S)**(-1)
     +     + 12*UG**(-1)*MG2*(S4-S)**(-1) + 32*UG**(-1) - 4*T1**(-2)*M2
     +     - 12*T1**(-1)*M2*(S4-S)**(-1) + 12*T1**(-1)*MG2*(S4-S)**(-1)
     +     + 4*T1**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2)*SYMBU * ( 8*S**(-1)*UG**(-1)*M2**2
     +     - 8*S**(-1)*UG**(-1)*M2**3*S4G**(-1) - 4*S**(-1)*T1*M2*
     +    S4G**(-1) - 4*S**(-1)*T1 - 8*S**(-1)*M2*MG2*S4G**(-1) - 8*
     +    S**(-1)*M2 + 12*S**(-1)*M2**2*S4G**(-1) + 8*S**(-1)*MG2 + 4*
     +    S**(-1)*S4G - 4*S*UG**(-1)*M2*MG2*(S4-S)**(-1)*S4G**(-1) + 4*
     +    S*UG**(-1)*M2*MG2*(TG-M2)*SYMBY*S4G**(-1) - 8*S*UG**(-1)*M2*
     +    (S+UG)**(-1) - 8*S*UG**(-1)*M2*(TG-M2)*SYMBY - 4*S*UG**(-1)*
     +    M2*S4G**(-1) - 8*S*UG**(-1)*M2**2*(S+UG)**(-1)*S4G**(-1) - 4*
     +    S*UG**(-1) + 4*S*T1**(-1)*M2*MG2*(S+UG)**(-1)*S4G**(-1) - 4*S
     +    *T1**(-1)*M2*MG2*(S4-S)**(-1)*S4G**(-1) - 4*S*T1**(-1)*MG2*
     +    S4G**(-1) - 4*S*T1*M2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*
     +    S4G**(-1) + 4*S*T1*MG2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*
     +    S4G**(-1) + 4*S*T1*(TG+UG-M2)**(-1)*S4G**(-1) + 4*S*T1**2*
     +    (TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G**(-1) - 4*S*M2*MG2*(TG-M2)
     +    *(TG+UG-M2)**(-1)*SYMBY*S4G**(-1) + 8*S*M2*(S+UG)**(-1)*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2)*SYMBU * ( 4*S*M2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 4*S*M2*(TG+UG-M2)**(-1)*S4G**(-1) - 4*S*MG2*
     +    (S+UG)**(-1)*S4G**(-1) + 8*S**2*UG**(-1)*M2*(S+UG)**(-1)*
     +    S4G**(-1) + 4*S**2*UG**(-1)*M2*(TG-M2)*SYMBY*S4G**(-1) + 4*
     +    S**2*UG**(-1)*(S+UG)**(-1) + 4*S**2*UG**(-1)*S4G**(-1) - 4*
     +    S**2*(S+UG)**(-1)*S4G**(-1) - 4*S**3*UG**(-1)*(S+UG)**(-1)*
     +    S4G**(-1) - 16*UG**(-2)*M2**3*S4G**(-1) - 8*UG**(-1)*M2*MG2*
     +    (TG-M2)*SYMBY - 8*UG**(-1)*M2*MG2*S4G**(-1) + 4*UG**(-1)*M2*
     +    (TG-M2)*SYMBY*S4G + 4*UG**(-1)*M2 + 16*UG**(-1)*M2**2*MG2*
     +    (S4-S)**(-1)*S4G**(-1) + 8*UG**(-1)*M2**2*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 8*UG**(-1)*M2**2*(S+UG)**(-1) + 28*UG**(-1)*M2**2
     +    *S4G**(-1) + 4*UG**(-1)*M2**3*(TG-M2)*SYMBY*S4G**(-1) - 24*
     +    T1**(-1)*M2*MG2*S4G**(-1) + 16*T1**(-1)*M2**2*MG2*
     +    (S+UG)**(-1)*S4G**(-1) + 16*T1**(-1)*M2**2*MG2*(S4-S)**(-1)*
     +    S4G**(-1) + 8*T1**(-1)*MG2 - 16*T1*M2*(S+UG)**(-1)*S4G**(-1)
     +     + 4*T1*M2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2)*SYMBU * (  - 8*T1*M2*(TG-M2)*SYMBY
     +    *S4G**(-1) + 8*T1*MG2*(S+UG)**(-1)*S4G**(-1) + 4*T1*MG2*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*T1*(TG+UG-M2)**(-1) + 4*T1*
     +    S4G**(-1) - 4*T1**2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY + 4*T1**2*
     +    (TG-M2)*SYMBY*S4G**(-1) - 24*M2*MG2*(S+UG)**(-1)*S4G**(-1) - 
     +    4*M2*(TG-M2)*SYMBY + 4*M2*(TG+UG-M2)**(-1) - 20*M2*S4G**(-1)
     +     + 8*M2**2*(S+UG)**(-1)*S4G**(-1) + 4*M2**2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 8*MG2*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * (  - 32*S**(-2) - 4*S**(-1)*
     +    TG**(-1)*T1*M2*(TG-M2)*SYMBY*S4G**(-1) - 4*S**(-1)*TG**(-1)*
     +    T1*S4G**(-1) + 4*S**(-1)*TG**(-1)*M2*(TG-M2)*SYMBY + 4*
     +    S**(-1)*TG**(-1)*M2*S4G**(-1) + 4*S**(-1)*TG**(-1)*M2**2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 32*S**(-1)*TG**(-1)*MG2*S4G**(-1)
     +     + 4*S**(-1)*TG**(-1) + 8*S**(-1)*TG*UG*(S+UG)**(-2)*
     +    S4G**(-1) + 8*S**(-1)*TG*UG*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 8*S**(-1)*TG*UG**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*S**(-1)*TG*T1**(-1)*
     +    M2*(S+UG)**(-2) - 8*S**(-1)*TG*T1**(-1)*M2**2*(S+UG)**(-2)*
     +    S4G**(-1) - 8*S**(-1)*TG*T1**(-1)*(S+UG)**(-2)*S4G + 8*
     +    S**(-1)*TG*T1**(-1)*S4G**(-1) + 8*S**(-1)*TG*M2*(S+UG)**(-2)*
     +    S4G**(-1) + 8*S**(-1)*TG*(S+UG)**(-2) + 8*S**(-1)*TG**2*UG*
     +    (S+UG)**(-3)*S4G**(-1) - 8*S**(-1)*TG**2*UG**2*(S+UG)**(-2)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*S**(-1)*TG**2*
     +    T1**(-1)*M2*(S+UG)**(-3) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * (  - 8*S**(-1)*TG**2*T1**(-1)*
     +    M2**2*(S+UG)**(-3)*S4G**(-1) - 8*S**(-1)*TG**2*T1**(-1)*
     +    (S+UG)**(-3)*S4G + 8*S**(-1)*TG**2*T1**(-1)*(S+UG)**(-1)*
     +    S4G**(-1) + 8*S**(-1)*TG**2*M2*(S+UG)**(-3)*S4G**(-1) + 8*
     +    S**(-1)*TG**2*(S+UG)**(-3) + 8*S**(-1)*TG**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*S**(-1)*UG**(-1)*M2**2
     +    *(-M2*(S+UG)+TG*UG)**(-1) + 8*S**(-1)*UG**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S**(-1)*UG*
     +    (S+UG)**(-1)*S4G**(-1) - 8*S**(-1)*T1**(-1)*M2*MG2*
     +    (S+UG)**(-2) + 8*S**(-1)*T1**(-1)*M2*MG2*(S+UG)**(-1)*
     +    S4G**(-1) - 4*S**(-1)*T1**(-1)*M2*(S+UG)**(-2)*S4G - 12*
     +    S**(-1)*T1**(-1)*M2*(S+UG)**(-1) - 4*S**(-1)*T1**(-1)*M2*
     +    S4G**(-1) - 8*S**(-1)*T1**(-1)*M2**2*MG2*(S+UG)**(-2)*
     +    S4G**(-1) + 8*S**(-1)*T1**(-1)*M2**2*(S+UG)**(-2) - 16*
     +    S**(-1)*T1**(-1)*M2**2*(S+UG)**(-1)*S4G**(-1) + 4*S**(-1)*
     +    T1**(-1)*M2**3*(S+UG)**(-2)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * (  - 4*S**(-1)*T1**(-1)*
     +    (S+UG)**(-1)*S4G + 4*S**(-1)*T1**(-1) - 32*S**(-1)*T1*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 40*S**(-1)
     +    *T1*M2*(S+UG)**(-2)*S4G**(-1) - 16*S**(-1)*T1*M2*(S+UG)**(-1)
     +    *(TG-M2)*SYMBY*S4G**(-1) - 8*S**(-1)*T1*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY - 36*S**(-1)*T1*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 48*S**(-1)*T1*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*S**(-1)*
     +    T1*MG2*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 20*S**(-1)*T1*
     +    (S+UG)**(-2) - 4*S**(-1)*T1*(S+UG)**(-1)*(TG-M2)*SYMBY - 12*
     +    S**(-1)*T1*(S+UG)**(-1)*S4G**(-1) - 4*S**(-1)*T1*
     +    (-M2*(S+UG)+TG*UG)**(-1) - 4*S**(-1)*T1*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY + 4*S**(-1)*T1*(TG-M2)*SYMBY*S4G**(-1)
     +     + 24*S**(-1)*T1**2*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY
     +    *S4G**(-1) + 8*S**(-1)*T1**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * (  - 20*S**(-1)*T1**2*
     +    (S+UG)**(-2)*S4G**(-1) + 4*S**(-1)*T1**2*(S+UG)**(-1)*(TG-M2)
     +    *SYMBY*S4G**(-1) + 8*S**(-1)*T1**2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 4*S**(-1)*T1**3*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*
     +    SYMBY*S4G**(-1) + 8*S**(-1)*M2*MG2*(S+UG)**(-2)*S4G**(-1) + 
     +    16*S**(-1)*M2*MG2*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 28*
     +    S**(-1)*M2*(S+UG)**(-2) + 8*S**(-1)*M2*(S+UG)**(-1)*(TG-M2)*
     +    SYMBY + 48*S**(-1)*M2*(S+UG)**(-1)*S4G**(-1) + 8*S**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1) - 4*S**(-1)*M2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 32*S**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 24*S**(-1)*M2**2*(S+UG)**(-2)*
     +    S4G**(-1) + 16*S**(-1)*M2**2*(S+UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 16*S**(-1)*M2**2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)
     +    *SYMBY + 48*S**(-1)*M2**2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1)
     +     + 32*S**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * ( 8*S**(-1)*MG2*(S+UG)**(-2) + 
     +    16*S**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) + 4*S**(-1)*
     +    (S+UG)**(-2)*S4G + 20*S**(-1)*(S+UG)**(-1) - 4*S**(-1)*
     +    (TG-M2)*SYMBY - 4*S**(-1)*(TG+UG-M2)**(-1) + 20*S**(-1)*
     +    S4G**(-1) - 8*S*TG*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 8*S*TG**2*(S+UG)**(-2)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 8*S*UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) - 4*S*UG**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*S*
     +    UG**(-1)*M2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1) + 8*S*
     +    UG**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 4*S*
     +    UG**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S*UG**(-1)
     +    *M2**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 24*S
     +    *UG**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 4*S*
     +    UG**(-1)*MG2*(S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 4*S*
     +    UG**(-1)*(-M2*(S+UG)+TG*UG)**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * (  - 4*S*T1**(-1)*M2*MG2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S*
     +    T1**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) + 4*S*T1**(-1)*MG2*(S+UG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) - 8*S*M2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 8*S*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*S*MG2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 8*S**2*UG**(-1)*M2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S**2*UG**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*S**2*
     +    UG**(-1)*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1) - 4*S**2*
     +    UG**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S**2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S**3*
     +    UG**(-1)*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*
     +    TG**(-1)*M2*(TG-M2)*SYMBY*S4G**(-1) - 4*TG**(-1)*S4G**(-1) + 
     +    16*TG*T1**(-1)*M2*(S+UG)**(-2)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * ( 16*TG*T1**(-1)*(S+UG)**(-2) - 
     +    24*TG*(S+UG)**(-2)*S4G**(-1) + 8*TG*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 16*TG**2*T1**(-1)*M2*(S+UG)**(-3)*S4G**(-1) + 16*
     +    TG**2*T1**(-1)*(S+UG)**(-3) - 8*TG**2*(S+UG)**(-3)*S4G**(-1)
     +     + 16*UG**(-2)*M2**3*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*
     +    UG**(-1)*M2*MG2*(S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 8*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 24*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*
     +    UG**(-1)*M2*(S+UG)**(-1)*S4G**(-1) - 4*UG**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G - 4*UG**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1) - 32*UG**(-1)*M2**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 8*UG**(-1)*
     +    M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 
     +    8*UG**(-1)*M2**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1) - 52*
     +    UG**(-1)*M2**2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*
     +    UG**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * ( 16*UG**(-1)*MG2*(S+UG)**(-1)*
     +    S4G**(-1) + 8*UG*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 24*
     +    T1**(-2)*M2**2*(S+UG)**(-1)*S4G**(-1) + 8*T1**(-2)*M2**3*
     +    (S+UG)**(-2)*S4G**(-1) + 32*T1**(-1)*M2*MG2*(S+UG)**(-2)*
     +    S4G**(-1) - 16*T1**(-1)*M2*MG2*(S+UG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) - 32*T1**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 8*T1**(-1)*M2*(S+UG)**(-2) + 60*T1**(-1)*M2*
     +    (S+UG)**(-1)*S4G**(-1) + 16*T1**(-1)*M2**2*MG2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 32*T1**(-1)*M2**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 40*T1**(-1)
     +    *M2**2*(S+UG)**(-2)*S4G**(-1) - 36*T1**(-1)*MG2*(S+UG)**(-1)*
     +    S4G**(-1) + 4*T1**(-1)*(S+UG)**(-1) - 4*T1**(-1)*S4G**(-1) + 
     +    16*T1*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 
     +    24*T1*M2**2*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 8*T1*MG2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 12*T1*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * (  - 48*T1*(S+UG)**(-2)*
     +    S4G**(-1) - 4*T1*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 8*
     +    T1*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*T1*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G**(-1) - 4*T1**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 24*M2*MG2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 32*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 80*M2*
     +    (S+UG)**(-2)*S4G**(-1) + 12*M2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY - 56*M2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*
     +    M2**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 24*
     +    M2**2*(-M2*(S+UG)+TG*UG)**(-2) - 20*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 48*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 32*MG2*(S+UG)**(-2)*
     +    S4G**(-1) + 16*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*MG2
     +    *(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G**(-1) - 8*(S+UG)**(-2) - 
     +    72*(S+UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK*(S4G+MG2) * ( 4*(TG+UG-M2)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + N*CK * (  - 16*S**(-2)*UG**(-1)*M2**2*MG2*
     +    (S4-S)**(-1) + 8*S**(-2)*UG**(-1)*M2**3*(S4-S)**(-1) - 16*
     +    S**(-2)*T1**(-1)*M2**2*MG2*(S4-S)**(-1) + 8*S**(-2)*T1**(-1)*
     +    M2**3*(S4-S)**(-1) + 24*S**(-1)*UG**(-1)*M2*MG2*(S4-S)**(-1)
     +     - 16*S**(-1)*UG**(-1)*M2 - 16*S**(-1)*UG**(-1)*M2**2*
     +    (S4-S)**(-1) + 8*S**(-1)*UG**(-1)*MG2 - 16*S**(-1)*UG**(-1)*
     +    MG2**2*(S4-S)**(-1) + 8*S**(-1)*UG**(-1)*S4G + 24*S**(-1)*
     +    T1**(-1)*M2*MG2*(S4-S)**(-1) + 8*S**(-1)*T1**(-1)*M2 - 16*
     +    S**(-1)*T1**(-1)*M2**2*(S4-S)**(-1) - 4*S**(-1)*T1**(-1)*MG2
     +     - 16*S**(-1)*T1**(-1)*MG2**2*(S4-S)**(-1) - 4*S**(-1)*T1*
     +    (TG-M2)*SYMBY + 8*S**(-1)*M2*(TG-M2)*SYMBY - 4*S*UG**(-1)*
     +    (S4-S)**(-1) - 4*S*T1**(-1)*(S4-S)**(-1) - 32*UG**(-2)*MG2 + 
     +    12*UG**(-1)*M2*(S4-S)**(-1) - 12*UG**(-1)*MG2*(S4-S)**(-1) - 
     +    24*UG**(-1) + 12*T1**(-2)*M2 + 12*T1**(-1)*M2*(S4-S)**(-1) - 
     +    12*T1**(-1)*MG2*(S4-S)**(-1) - 4*T1**(-1) )
     +
      M2GBH = M2GBH + CQED*(S4G+MG2)*SYMBU * ( 4 - 8*S**(-1)*UG**(-1)*
     +    M2**2 + 8*S**(-1)*UG**(-1)*M2**3*S4G**(-1) + 16*S**(-1)*
     +    T1**(-1)*M2*MG2 - 8*S**(-1)*T1**(-1)*M2**2*MG2*S4G**(-1) - 8*
     +    S**(-1)*T1**(-1)*MG2*S4G - 4*S**(-1)*T1*M2*S4G**(-1) + 4*
     +    S**(-1)*T1 + 8*S**(-1)*M2 - 4*S**(-1)*M2**2*S4G**(-1) - 4*
     +    S**(-1)*S4G + 4*S*UG**(-1)*M2*MG2*(S4-S)**(-1)*S4G**(-1) + 4*
     +    S*T1**(-1)*M2*MG2*(S4-S)**(-1)*S4G**(-1) + 8*UG**(-2)*M2**3*
     +    S4G**(-1) + 8*UG**(-1)*M2*MG2*S4G**(-1) - 16*UG**(-1)*M2**2*
     +    MG2*(S4-S)**(-1)*S4G**(-1) - 8*UG**(-1)*M2**2*S4G**(-1) + 4*
     +    T1**(-1)*M2*MG2*S4G**(-1) - 16*T1**(-1)*M2**2*MG2*
     +    (S4-S)**(-1)*S4G**(-1) + 4*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + CQED*(S4G+MG2) * ( 8*S**(-1)*UG**(-1)*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1) - 8*S**(-1)*UG**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S**(-1)*T1**(-1)*M2*
     +    MG2*(S+UG)**(-2) - 16*S**(-1)*T1**(-1)*M2*MG2*(S+UG)**(-1)*
     +    S4G**(-1) + 4*S**(-1)*T1**(-1)*M2*(S+UG)**(-2)*S4G - 4*
     +    S**(-1)*T1**(-1)*M2*(S+UG)**(-1) + 8*S**(-1)*T1**(-1)*M2**2*
     +    MG2*(S+UG)**(-2)*S4G**(-1) + 4*S**(-1)*T1**(-1)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) + 4*S**(-1)*T1**(-1)*M2**3*
     +    (S+UG)**(-2)*S4G**(-1) + 8*S**(-1)*T1**(-1)*MG2*(S+UG)**(-1)
     +     - 8*S**(-1)*T1*M2*(S+UG)**(-2)*S4G**(-1) + 20*S**(-1)*T1*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S**(-1)*T1*
     +    (S+UG)**(-2) + 8*S**(-1)*T1*(S+UG)**(-1)*S4G**(-1) + 4*
     +    S**(-1)*T1*(-M2*(S+UG)+TG*UG)**(-1) + 4*S**(-1)*T1**2*
     +    (S+UG)**(-2)*S4G**(-1) - 4*S**(-1)*T1**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*S**(-1)*M2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) )
     +
      M2GBH = M2GBH + CQED*(S4G+MG2) * ( 4*S**(-1)*M2*(S+UG)**(-2) - 28
     +    *S**(-1)*M2*(S+UG)**(-1)*S4G**(-1) - 8*S**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1) - 32*S**(-1)*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*S**(-1)*MG2*
     +    (S+UG)**(-2) + 8*S**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) - 4*
     +    S**(-1)*(S+UG)**(-2)*S4G + 4*S**(-1)*(S+UG)**(-1) - 4*S*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) + 8*S*UG**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-2)*
     +    S4G**(-1) - 4*S*T1**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) - 8*UG**(-2)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*UG**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*UG**(-1)*M2**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 8*UG**(-1)*
     +    M2**2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*T1**(-2)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) - 8*T1**(-1)*M2*MG2*(S+UG)**(-2)*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + CQED*(S4G+MG2) * ( 16*T1**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*T1**(-1)*M2*
     +    (S+UG)**(-2) - 12*T1**(-1)*M2*(S+UG)**(-1)*S4G**(-1) + 16*
     +    T1**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) + 4*T1**(-1)*M2**2*(S+UG)**(-2)*S4G**(-1) + 12*
     +    T1**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) - 8*T1*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 8*T1*(S+UG)**(-2)*
     +    S4G**(-1) - 4*T1*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 12*M2*
     +    (S+UG)**(-2)*S4G**(-1) + 20*M2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 8*M2**2*(-M2*(S+UG)+TG*UG)**(-2) + 16*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 8*MG2*(S+UG)**(-2)*
     +    S4G**(-1) - 8*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*
     +    (S+UG)**(-2) + 12*(S+UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + CQED * (  - 4*S**(-1)*T1**(-1)*M2 - 8*S**(-1) - 4
     +    *T1**(-2)*M2 )
     +
      M2GBH = M2GBH + ANG4(14)*N*CO * ( 8*S**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(14)*N*CK * (  - 8*S**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(16)*S42**(-1)*N*CO*S4 * ( 2*S**(-1)*UG**(-1)
     +    *M2*MG2 + 4*S**(-1)*MG2 + 2*UG**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(16)*S42**(-1)*N*CK*S4 * ( 2*S**(-1)*T1**(-1)
     +    *M2*MG2 - 4*S**(-1)*MG2 - 2*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(16)*N*CO * (  - 2*S**(-1)*UG**(-1)*MG2 - 2*
     +    S**(-1)*UG**(-1)*S4G - 4*S**(-1)*MG2*(TG+UG-M2)**(-1) - 2*
     +    S**(-1)*(TG+UG-M2)**(-1)*S4G + 4*S**(-1) + 2*UG**(-1) + 2*
     +    (TG+UG-M2)**(-1) )
     +
      M2GBH = M2GBH + ANG4(16)*N*CK * (  - 2*S**(-1)*T1**(-1)*MG2 + 4*
     +    S**(-1)*MG2*(TG+UG-M2)**(-1) + 2*S**(-1)*(TG+UG-M2)**(-1)*S4G
     +     - 4*S**(-1) - 2*(TG+UG-M2)**(-1) )
     +
      M2GBH = M2GBH + ANG4(17)*N*CO * ( 8*S**(-1)*UG**(-1)*S4G**3 + 2*
     +    S**(-1)*T1*MG2*(TG+UG-M2)**(-1)*S4G - 2*S**(-1)*T1*S4G - 2*
     +    S**(-1)*M2*MG2*(TG+UG-M2)**(-1)*S4G + 2*S**(-1)*M2*S4G - 2*
     +    S**(-1)*MG2*(TG+UG-M2)**(-1)*S4G**2 + 4*S**(-1)*MG2*S4G - 4*
     +    S**(-1)*(TG+UG-M2)**(-1)*S4G**3 - 2*S**(-1)*S4G**2 - 32*S*
     +    UG**(-2)*MG2*S4G + 8*S*UG**(-1)*M2*MG2*(S4-S)**(-1) + 8*S*
     +    UG**(-1)*MG2*(TG+UG-M2)**(-1)*S4G + 24*S*UG**(-1)*MG2 - 24*S*
     +    UG**(-1)*(S+UG)**(-1)*S4G**2 - 16*S*UG**(-1)*S4G + 2*S*
     +    T1**(-1)*M2*MG2*(S+UG)**(-1) + 8*S*T1**(-1)*M2*MG2*
     +    (S4-S)**(-1) - 2*S*T1**(-1)*MG2 + 6*S*T1*(S+UG)**(-1) - 6*S*
     +    M2*(S+UG)**(-1) - 2*S*MG2*(S+UG)**(-1) - 8*S*MG2*
     +    (TG+UG-M2)**(-1) + 16*S*(S+UG)**(-1)*S4G - 2*S*
     +    (TG+UG-M2)**(-1)*S4G + 6*S + 32*S**2*UG**(-2)*MG2 - 8*S**2*
     +    UG**(-1)*MG2*(TG+UG-M2)**(-1) + 24*S**2*UG**(-1)*(S+UG)**(-1)
     +    *S4G + 8*S**2*UG**(-1) - 8*S**2*(S+UG)**(-1) - 8*S**3*
     +    UG**(-1)*(S+UG)**(-1) )
     +
      M2GBH = M2GBH + ANG4(17)*N*CO * (  - 16*UG**(-1)*MG2*S4G + 8*
     +    UG**(-1)*(S+UG)**(-1)*S4G**3 + 8*UG**(-1)*S4G**2 - 2*T1**(-1)
     +    *M2*S4G + 4*T1**(-1)*M2**2 - 4*T1**(-1)*M2**3*(S+UG)**(-1) + 
     +    2*T1**(-1)*MG2*S4G + 2*T1**(-1)*S4G**2 - 4*T1*M2*(S+UG)**(-1)
     +     + 4*T1*MG2*(S+UG)**(-1) - 8*T1*(S+UG)**(-1)*S4G - 4*M2*MG2*
     +    (S+UG)**(-1) + 8*M2*(S+UG)**(-1)*S4G - 4*M2 + 8*M2**2*
     +    (S+UG)**(-1) + 10*MG2*(TG+UG-M2)**(-1)*S4G + 12*MG2 - 8*
     +    (S+UG)**(-1)*S4G**2 + 4*(TG+UG-M2)**(-1)*S4G**2 - 6*S4G )
     +
      M2GBH = M2GBH + ANG4(21)*S42**(-1)*N*CO*S4 * (  - 2 - 4*S**(-1)*
     +    UG**(-1)*M2**2 - 4*S**(-1)*T1**(-1)*M2**2 - 2*S*UG**(-1) - 4*
     +    UG**(-1)*M2 + 4*UG**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(21)*S42**(-1)*N*CK*S4 * ( 4*S**(-1)*T1**(-1)
     +    *M2**2 + 2*S**(-1)*T1 - 4*S**(-1)*M2 + 4*S**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(21)*N*CO * ( 4*S**(-1)*UG**(-1)*M2**2*
     +    (S4-S)**(-1) + 4*S**(-1)*T1**(-1)*M2**2*(S4-S)**(-1) + 2*S*
     +    UG**(-1)*(S4-S)**(-1) + 2*S*T1**(-1)*(S4-S)**(-1) - 4*
     +    UG**(-1)*M2*(S4-S)**(-1) + 4*UG**(-1)*MG2*(S4-S)**(-1) + 8*
     +    UG**(-1) - 4*T1**(-1)*M2*(S4-S)**(-1) + 4*T1**(-1)*MG2*
     +    (S4-S)**(-1) + 2*T1**(-1) )
     +
      M2GBH = M2GBH + ANG4(21)*N*CK * (  - 2*S**(-1)*T1**(-1)*M2 + 4*
     +    S**(-1)*T1**(-1)*MG2 + 2*S**(-1)*T1**(-1)*S4G + 4*S**(-1) )
     +
      M2GBH = M2GBH + ANG4(34)*S42**(-1)*N*CK*S4 * (  - 2*S**(-1)*
     +    UG**(-1)*M2*MG2 + 2*S**(-1)*T1**(-1)*M2*MG2 - 2*T1**(-1)*MG2
     +     )
     +
      M2GBH = M2GBH + ANG4(34)*S42**(-1)*CQED*S4 * (  - 2*S**(-1)*
     +    T1**(-1)*M2*MG2 + 2*S**(-1)*MG2 + 2*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(34)*N*CO * (  - 4*S**(-1)*MG2*
     +    (TG+UG-M2)**(-1) - 2*S**(-1)*(TG+UG-M2)**(-1)*S4G - 2*S**(-1)
     +     + 2*(TG+UG-M2)**(-1) )
     +
      M2GBH = M2GBH + ANG4(34)*N*CK * ( 2*S**(-1)*UG**(-1)*MG2 + 2*
     +    S**(-1)*UG**(-1)*S4G + 4*S**(-1)*MG2*(TG+UG-M2)**(-1) + 2*
     +    S**(-1)*(TG+UG-M2)**(-1)*S4G - 2*S**(-1) - 2*UG**(-1) - 2*
     +    (TG+UG-M2)**(-1) )
     +
      M2GBH = M2GBH + ANG4(34)*CQED * ( 2*S**(-1) )
     +
      M2GBH = M2GBH + ANG4(38)*N*CO * (  - 8*S**(-1)*T1*MG2 + 8*S**(-1)
     +    *M2*MG2 + 8*S**(-1)*MG2*S4G + 16*MG2 )
     +
      M2GBH = M2GBH + ANG4(38)*N*CK * ( 8*S**(-1)*T1*MG2 - 8*S**(-1)*M2
     +    *MG2 - 8*S**(-1)*MG2*S4G )
     +
      M2GBH = M2GBH + ANG4(39)*S42**(-1)*N*CO*S4 * ( 4*S**(-1)*UG**(-1)
     +    *M2**3 - 2*S**(-1)*T1*M2 - 4*S**(-1)*T1*MG2 + 2*S**(-1)*M2*
     +    MG2 + 4*S**(-1)*M2**2 + 6*S*UG**(-1)*M2 + 2*S + 2*S**2*
     +    UG**(-1) - 8*UG**(-1)*M2*MG2 + 8*UG**(-1)*M2**2 - 2*T1 + 6*M2
     +     )
     +
      M2GBH = M2GBH + ANG4(39)*S42**(-1)*N*CK*S4 * ( 4*S**(-1)*T1**(-1)
     +    *M2**3 + 2*S**(-1)*T1*M2 + 4*S**(-1)*T1*MG2 - 2*S**(-1)*M2*
     +    MG2 - 4*S**(-1)*M2**2 + 2*S*T1**(-1)*MG2 - 12*T1**(-1)*M2*MG2
     +     + 4*T1**(-1)*M2**2 + 2*T1 - 4*M2 + 8*MG2 )
     +
      M2GBH = M2GBH + ANG4(39)*N*CO * (  - 1 + 4*S**(-1)*UG**(-1)*M2*
     +    S4G - 4*S**(-1)*UG**(-1)*M2**2 - 4*S**(-1)*UG**(-1)*MG2*S4G
     +     - 8*S**(-1)*UG**(-1)*S4G**2 + 4*S**(-1)*T1*MG2*
     +    (TG+UG-M2)**(-1) + 6*S**(-1)*T1 - 4*S**(-1)*M2*MG2*
     +    (TG+UG-M2)**(-1) - 8*S**(-1)*M2 - 6*S**(-1)*MG2*
     +    (TG+UG-M2)**(-1)*S4G + 18*S**(-1)*MG2 - 4*S**(-1)*
     +    (TG+UG-M2)**(-1)*S4G**2 + 10*S**(-1)*S4G + S*UG**(-1)*M2*
     +    (S+TG-M2)**(-1) - S*UG**(-1)*(S+TG-M2)**(-1)*S4G - 5*S*
     +    UG**(-1) + 2*S*(TG+UG-M2)**(-1) - UG**(-1)*M2*(S+TG-M2)**(-1)
     +    *S4G - 8*UG**(-1)*M2 + 20*UG**(-1)*MG2 + UG**(-1)*
     +    (S+TG-M2)**(-1)*S4G**2 + 11*UG**(-1)*S4G - T1*(S+TG-M2)**(-1)
     +     + 2*T1*(TG+UG-M2)**(-1) + 2*M2*(S+TG-M2)**(-1) - 2*M2*
     +    (TG+UG-M2)**(-1) + 2*MG2*(TG+UG-M2)**(-1) - (S+TG-M2)**(-1)*
     +    S4G + 2*(TG+UG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + ANG4(39)*N*CK * ( 2*S**(-1)*T1**(-1)*M2*S4G - 4*
     +    S**(-1)*T1**(-1)*M2**2 - 2*S**(-1)*T1**(-1)*MG2*S4G - 2*
     +    S**(-1)*T1**(-1)*S4G**2 + 4*S**(-1)*T1*MG2*(TG-M2)*SYMBY - 4*
     +    S**(-1)*T1*MG2*(TG+UG-M2)**(-1) - 2*S**(-1)*T1*(TG-M2)*SYMBY*
     +    S4G - 6*S**(-1)*T1 - 8*S**(-1)*M2*MG2*(TG-M2)*SYMBY + 4*
     +    S**(-1)*M2*MG2*(TG+UG-M2)**(-1) + 4*S**(-1)*M2*(TG-M2)*SYMBY*
     +    S4G + 8*S**(-1)*M2 + 6*S**(-1)*MG2*(TG+UG-M2)**(-1)*S4G - 22*
     +    S**(-1)*MG2 + 4*S**(-1)*(TG+UG-M2)**(-1)*S4G**2 - 4*S**(-1)*
     +    S4G + 2*S*(TG+UG-M2)**(-1) - 2*T1**(-1)*M2 + 4*T1**(-1)*MG2
     +     + 2*T1**(-1)*S4G + 2*T1*(TG-M2)*SYMBY - 2*T1*
     +    (TG+UG-M2)**(-1) - 4*M2*(TG-M2)*SYMBY + 2*M2*(TG+UG-M2)**(-1)
     +     - 10*MG2*(TG+UG-M2)**(-1) - 6*(TG+UG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + ANG4(43)*N*CO * ( 8*T1**(-2)*M2**2*MG2 - 16*
     +    T1**(-1)*M2*MG2 + 16*T1**(-1)*MG2**2 + 16*MG2 )
     +
      M2GBH = M2GBH + ANG4(43)*N*CK * (  - 8*T1**(-2)*M2**2*MG2 + 16*
     +    T1**(-1)*M2*MG2 - 16*T1**(-1)*MG2**2 - 16*MG2 )
     +
      M2GBH = M2GBH + ANG4(44)*S42**(-1)*N*CO*S4 * (  - 8*S**(-1)*
     +    UG**(-1)*M2**2*MG2 + 4*S**(-1)*UG**(-1)*M2**3 - 8*S**(-1)*
     +    T1**(-1)*M2**2*MG2 + 4*S**(-1)*T1**(-1)*M2**3 - 2*S*UG**(-1)*
     +    M2 - 2*S - 2*S**2*UG**(-1) - 12*UG**(-1)*M2*MG2 + 8*UG**(-1)*
     +    MG2**2 + 8*T1**(-2)*M2**2*MG2 - 4*T1**(-2)*M2**3 - 12*
     +    T1**(-1)*M2*MG2 + 4*T1**(-1)*M2**2 + 8*T1**(-1)*MG2**2 + 2*T1
     +     - 4*M2 + 2*MG2 )
     +
      M2GBH = M2GBH + ANG4(44)*S42**(-1)*N*CK*S4 * ( 2*S**(-1)*T1*MG2
     +     - 8*S**(-1)*M2*MG2 - 8*T1**(-2)*M2**2*MG2 + 4*T1**(-2)*M2**3
     +     + 12*T1**(-1)*M2*MG2 - 4*T1**(-1)*M2**2 - 8*T1**(-1)*MG2**2
     +     + 2*M2 - 2*MG2 )
     +
      M2GBH = M2GBH + ANG4(44)*N*CO * ( 12 + 8*S**(-1)*UG**(-1)*M2**2*
     +    MG2*(S4-S)**(-1) - 4*S**(-1)*UG**(-1)*M2**3*(S4-S)**(-1) + 8*
     +    S**(-1)*T1**(-1)*M2**2*MG2*(S4-S)**(-1) - 4*S**(-1)*T1**(-1)*
     +    M2**3*(S4-S)**(-1) - 2*S*UG**(-1)*M2*(S4-S)**(-1) + 2*S*
     +    UG**(-1)*M2*(S+TG-M2)**(-1) + 4*S*UG**(-1)*MG2*(S4-S)**(-1)
     +     - 2*S*UG**(-1)*(S+TG-M2)**(-1)*S4G + 10*S*UG**(-1) - 2*S*
     +    T1**(-1)*M2*(S4-S)**(-1) + 4*S*T1**(-1)*MG2*(S4-S)**(-1) + 2*
     +    S*(S+TG-M2)**(-1) - 12*UG**(-1)*M2*MG2*(S4-S)**(-1) + 4*
     +    UG**(-1)*M2*(S+TG-M2)**(-1)*S4G - 4*UG**(-1)*M2 + 4*UG**(-1)*
     +    M2**2*(S4-S)**(-1) - 4*UG**(-1)*M2**2*(S+TG-M2)**(-1) + 16*
     +    UG**(-1)*MG2 + 8*UG**(-1)*MG2**2*(S4-S)**(-1) - 8*UG**(-1)*
     +    S4G - 4*T1**(-2)*M2*S4G + 4*T1**(-2)*M2**2 - 4*T1**(-2)*M2**3
     +    *(S+UG)**(-1) - 8*T1**(-1)*M2*MG2*(S+UG)**(-1) - 12*T1**(-1)*
     +    M2*MG2*(S4-S)**(-1) - 6*T1**(-1)*M2 + 12*T1**(-1)*M2**2*
     +    (S+UG)**(-1) + 4*T1**(-1)*M2**2*(S4-S)**(-1) + 14*T1**(-1)*
     +    MG2 )
     +
      M2GBH = M2GBH + ANG4(44)*N*CO * ( 8*T1**(-1)*MG2**2*(S4-S)**(-1)
     +     + 2*T1**(-1)*S4G + 8*T1*(S+UG)**(-1) - 16*M2*(S+UG)**(-1) - 
     +    4*M2*(S+TG-M2)**(-1) + 8*MG2*(S+UG)**(-1) )
     +
      M2GBH = M2GBH + ANG4(44)*N*CK * (  - 6 - 6*S**(-1)*T1**(-1)*M2*
     +    MG2 + 2*S**(-1)*T1**(-1)*MG2*S4G - 8*S**(-1)*M2 + 4*S**(-1)*
     +    MG2 + 4*T1**(-2)*M2*S4G - 4*T1**(-2)*M2**2 + 4*T1**(-2)*M2**3
     +    *(S+UG)**(-1) + 8*T1**(-1)*M2*MG2*(S+UG)**(-1) + 4*T1**(-1)*
     +    M2 - 12*T1**(-1)*M2**2*(S+UG)**(-1) - 10*T1**(-1)*MG2 - 2*
     +    T1**(-1)*S4G - 8*T1*(S+UG)**(-1) + 16*M2*(S+UG)**(-1) - 8*MG2
     +    *(S+UG)**(-1) )
     +
      M2GBH = M2GBH + ANG4(47)*S42**(-1)*N*CK*S4 * ( 4*S**(-1)*UG**(-1)
     +    *M2**2*MG2 - 4*S**(-1)*T1**(-1)*M2**2*MG2 - 8*S**(-1)*T1*MG2
     +     + 16*S**(-1)*M2*MG2 + 2*S*UG**(-1)*MG2 - 6*S*T1**(-1)*MG2 - 
     +    8*UG**(-1)*MG2**2 + 4*T1**(-1)*M2*MG2 + 8*T1**(-1)*MG2**2 - 8
     +    *MG2 )
     +
      M2GBH = M2GBH + ANG4(47)*S42**(-1)*CQED*S4 * ( 4*S**(-1)*T1**(-1)
     +    *M2**2*MG2 + 4*S**(-1)*T1*MG2 - 6*S**(-1)*M2*MG2 + 8*S*
     +    T1**(-1)*MG2 - 6*T1**(-1)*M2*MG2 - 8*T1**(-1)*MG2**2 + 10*MG2
     +     )
     +
      M2GBH = M2GBH + ANG4(47)*N*CO * (  - 2 + 4*S**(-1)*T1*MG2*
     +    (TG+UG-M2)**(-1) + 2*S**(-1)*T1 - 4*S**(-1)*M2*MG2*
     +    (TG+UG-M2)**(-1) - 4*S**(-1)*M2 - 6*S**(-1)*MG2*
     +    (TG+UG-M2)**(-1)*S4G + 8*S**(-1)*MG2 - 4*S**(-1)*
     +    (TG+UG-M2)**(-1)*S4G**2 + 4*S**(-1)*S4G + 2*S*
     +    (TG+UG-M2)**(-1) + 2*T1*(TG+UG-M2)**(-1) - 2*M2*
     +    (TG+UG-M2)**(-1) + 2*MG2*(TG+UG-M2)**(-1) + 2*
     +    (TG+UG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + ANG4(47)*N*CK * ( 4 - 4*S**(-1)*UG**(-1)*M2*MG2
     +     + 4*S**(-1)*UG**(-1)*MG2*S4G + 8*S**(-1)*T1**(-1)*M2*MG2 - 2
     +    *S**(-1)*T1**(-1)*MG2*S4G - 4*S**(-1)*T1*MG2*(TG+UG-M2)**(-1)
     +     - 2*S**(-1)*T1 + 4*S**(-1)*M2*MG2*(TG+UG-M2)**(-1) + 6*
     +    S**(-1)*M2 + 6*S**(-1)*MG2*(TG+UG-M2)**(-1)*S4G - 12*S**(-1)*
     +    MG2 + 4*S**(-1)*(TG+UG-M2)**(-1)*S4G**2 - 4*S**(-1)*S4G - 2*S
     +    *UG**(-1) + 2*S*(TG+UG-M2)**(-1) + 2*UG**(-1)*M2 - 4*UG**(-1)
     +    *MG2 + 2*UG**(-1)*S4G + 6*T1**(-1)*MG2 - 2*T1*
     +    (TG+UG-M2)**(-1) + 2*M2*(TG+UG-M2)**(-1) - 10*MG2*
     +    (TG+UG-M2)**(-1) - 6*(TG+UG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + ANG4(47)*CQED * ( 2 - 8*S**(-1)*T1**(-1)*M2*MG2
     +     + 4*S**(-1)*T1**(-1)*MG2*S4G - 2*S**(-1)*M2 + 2*S**(-1)*MG2
     +     + 2*S**(-1)*S4G - 2*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(48)*N*CO * ( 16*S**(-1)*UG**(-1)*S4G**3 - 8*
     +    S**(-1)*T1*S4G + 8*S**(-1)*M2*S4G - 8*S**(-1)*S4G**2 - 2*S*
     +    UG**(-1)*MG2*(S+TG-M2)**(-1)*S4G + 24*S*UG**(-1)*(S+UG)**(-1)
     +    *S4G**2 + 26*S*UG**(-1)*S4G - 2*S*T1**(-1)*M2*MG2*
     +    (S+UG)**(-1) + 2*S*T1**(-1)*MG2 - 6*S*T1*(S+UG)**(-1) + 6*S*
     +    M2*(S+UG)**(-1) + 2*S*MG2*(S+UG)**(-1) - 16*S*(S+UG)**(-1)*
     +    S4G - S*(S+TG-M2)**(-1)*S4G - 6*S - 24*S**2*UG**(-1)*
     +    (S+UG)**(-1)*S4G - 8*S**2*UG**(-1) + 8*S**2*(S+UG)**(-1) + 8*
     +    S**3*UG**(-1)*(S+UG)**(-1) - 4*UG**(-1)*M2*(S+TG-M2)**(-1)*
     +    S4G**2 + 4*UG**(-1)*MG2*S4G - 8*UG**(-1)*(S+UG)**(-1)*S4G**3
     +     - 32*UG**(-1)*S4G**2 - 2*T1**(-1)*M2*S4G + 4*T1**(-1)*M2**2
     +     - 4*T1**(-1)*M2**3*(S+UG)**(-1) + 2*T1**(-1)*S4G**2 - 36*T1*
     +    M2*(S+UG)**(-1) + 4*T1*MG2*(S+UG)**(-1) + 8*T1*(S+UG)**(-1)*
     +    S4G - T1*(S+TG-M2)**(-1)*S4G + 16*T1 + 16*T1**2*(S+UG)**(-1)
     +     - 4*M2*MG2*(S+UG)**(-1) - 8*M2*(S+UG)**(-1)*S4G + 4*M2*
     +    (S+TG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + ANG4(48)*N*CO * (  - 20*M2 + 24*M2**2*
     +    (S+UG)**(-1) + 4*MG2 + 8*(S+UG)**(-1)*S4G**2 - 2*
     +    (S+TG-M2)**(-1)*S4G**2 + 21*S4G )
     +
      M2GBH = M2GBH + ANG4(51)*N*CO * ( 32*S**2*MG2 )
     +
      M2GBH = M2GBH + ANG4(52)*N*CO * ( 32*S*MG2 )
     +
      M2GBH = M2GBH + ANG4(53)*N*CO * ( 64*S*UG**(-1)*MG2*S4G - 64*S*
     +    MG2 - 32*S**2*UG**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(54)*S42**(-1)*N*CO*S4 * (  - 8*S*UG**(-1)*M2
     +    *MG2 + 4*T1*M2 - 2*T1**2 - 4*M2**2 )
     +
      M2GBH = M2GBH + ANG4(54)*N*CO * (  - 32*S**(-1)*UG**(-1)*S4G**3
     +     - 16*S**(-1)*T1*M2 + 16*S**(-1)*T1*S4G + 8*S**(-1)*T1**2 - 
     +    16*S**(-1)*M2*S4G + 8*S**(-1)*M2**2 + 24*S**(-1)*S4G**2 + 32*
     +    S*UG**(-2)*MG2*S4G - 8*S*UG**(-1)*M2*MG2*(S4-S)**(-1) - 3*S*
     +    UG**(-1)*M2*MG2*(S+TG-M2)**(-1) + S*UG**(-1)*M2*
     +    (S+TG-M2)**(-1)*S4G - 5*S*UG**(-1)*MG2*(S+TG-M2)**(-1)*S4G - 
     +    8*S*UG**(-1)*MG2*(TG+UG-M2)**(-1)*S4G - 3*S*UG**(-1)*MG2 - S*
     +    UG**(-1)*(S+TG-M2)**(-1)*S4G**2 - 31*S*UG**(-1)*S4G - 8*S*
     +    T1**(-1)*M2*MG2*(S4-S)**(-1) - 2*S*T1*(S+TG-M2)**(-1) + 4*S*
     +    T1*(TG+UG-M2)**(-1) + 6*S*M2*(S+TG-M2)**(-1) - 4*S*M2*
     +    (TG+UG-M2)**(-1) + 5*S*MG2*(S+TG-M2)**(-1) - 2*S*
     +    (S+TG-M2)**(-1)*S4G - 4*S*(TG+UG-M2)**(-1)*S4G + 12*S - 32*
     +    S**2*UG**(-2)*MG2 + 8*S**2*UG**(-1)*MG2*(TG+UG-M2)**(-1) + 8*
     +    S**2*UG**(-1) + 4*S**2*(TG+UG-M2)**(-1) - UG**(-1)*M2*
     +    (S+TG-M2)**(-1)*S4G**2 + 32*UG**(-1)*MG2*S4G + UG**(-1)*
     +    (S+TG-M2)**(-1)*S4G**3 )
     +
      M2GBH = M2GBH + ANG4(54)*N*CO * ( 47*UG**(-1)*S4G**2 - 2*T1**(-1)
     +    *M2**2 - 2*T1**(-1)*S4G**2 + 2*T1*M2*(S+TG-M2)**(-1) - 4*T1*
     +    M2*(TG+UG-M2)**(-1) + T1*(S+TG-M2)**(-1)*S4G + 2*T1**2*
     +    (TG+UG-M2)**(-1) - 2*M2*(S+TG-M2)**(-1)*S4G + 4*M2 - 2*M2**2*
     +    (S+TG-M2)**(-1) + 2*M2**2*(TG+UG-M2)**(-1) - 16*MG2 + 
     +    (S+TG-M2)**(-1)*S4G**2 + 2*(TG+UG-M2)**(-1)*S4G**2 - 19*S4G )
     +
      M2GBH = M2GBH + ANG4(56)*N*CO * (  - 8*S*MG2 )
     +
      M2GBH = M2GBH + ANG4(56)*N*CK * ( 8*S*MG2 )
     +
      M2GBH = M2GBH + ANG4(58)*S42**(-1)*N*CK*S4 * (  - 2*S*T1**(-1)*M2
     +    *MG2 + 2*S*MG2 + 4*T1**(-1)*M2**3 + 6*T1*M2 - 2*T1**2 - 8*
     +    M2**2 )
     +
      M2GBH = M2GBH + ANG4(58)*N*CO * (  - 16*S**(-1)*UG**(-1)*S4G**3
     +     + 8*S**(-1)*T1*S4G - 8*S**(-1)*M2*S4G + 8*S**(-1)*S4G**2 + 8
     +    *S*UG**(-1)*M2*(TG-M2)*SYMBY*S4G + 2*S*UG**(-1)*MG2*(TG-M2)*
     +    SYMBY*S4G - 4*S*UG**(-1)*MG2 - 24*S*UG**(-1)*(S+UG)**(-1)*
     +    S4G**2 - 34*S*UG**(-1)*S4G + 2*S*T1**(-1)*M2*MG2*(S+UG)**(-1)
     +     - 4*S*T1**(-1)*MG2 + 6*S*T1*(S+UG)**(-1) - 2*S*T1*(TG-M2)*
     +    SYMBY - 6*S*M2*(S+UG)**(-1) + 2*S*M2*(TG-M2)*SYMBY - 2*S*MG2*
     +    (S+UG)**(-1) + 2*S*MG2*(TG-M2)*SYMBY + 16*S*(S+UG)**(-1)*S4G
     +     + 10*S - 4*S**2*UG**(-1)*M2*(TG-M2)*SYMBY - 2*S**2*UG**(-1)*
     +    MG2*(TG-M2)*SYMBY + 24*S**2*UG**(-1)*(S+UG)**(-1)*S4G + 10*
     +    S**2*UG**(-1) - 8*S**2*(S+UG)**(-1) - 8*S**3*UG**(-1)*
     +    (S+UG)**(-1) - 4*UG**(-1)*M2*(TG-M2)*SYMBY*S4G**2 + 4*
     +    UG**(-1)*MG2*S4G + 8*UG**(-1)*(S+UG)**(-1)*S4G**3 + 40*
     +    UG**(-1)*S4G**2 - 2*T1**(-1)*M2*S4G + 2*T1**(-1)*M2**2 - 4*
     +    T1**(-1)*M2**3*(S+UG)**(-1) - 4*T1*M2*(S+UG)**(-1) - T1*M2*
     +    (TG-M2)*SYMBY )
     +
      M2GBH = M2GBH + ANG4(58)*N*CO * ( 4*T1*MG2*(S+UG)**(-1) - 8*T1*
     +    (S+UG)**(-1)*S4G + 2*T1*(TG-M2)*SYMBY*S4G - 5*T1 + T1**2*
     +    (TG-M2)*SYMBY - 4*M2*MG2*(S+UG)**(-1) + 8*M2*(S+UG)**(-1)*S4G
     +     - 2*M2*(TG-M2)*SYMBY*S4G + 3*M2 + 8*M2**2*(S+UG)**(-1) + 12*
     +    MG2 - 8*(S+UG)**(-1)*S4G**2 - 18*S4G )
     +
      M2GBH = M2GBH + ANG4(58)*N*CK * (  - 16*S**(-1)*T1*M2 + 8*S**(-1)
     +    *T1**2 + 8*S**(-1)*M2**2 + 8*S**(-1)*S4G**2 + 4*S*T1**(-1)*
     +    MG2 - 4*S*T1*M2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY - 2*S*T1*MG2*
     +    (TG-M2)*(TG+UG-M2)**(-1)*SYMBY + 2*S*T1*(TG-M2)*SYMBY - 2*S*
     +    T1*(TG+UG-M2)**(-1) + 2*S*M2*MG2*(TG-M2)*(TG+UG-M2)**(-1)*
     +    SYMBY - 6*S*M2*(TG-M2)*SYMBY + 2*S*M2*(TG+UG-M2)**(-1) + 4*S*
     +    M2**2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY - 4*S*MG2*(TG-M2)*SYMBY
     +     + 2*T1**(-1)*M2*S4G - 2*T1**(-1)*M2**2 + 4*T1*M2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G - 2*T1*M2*(TG-M2)*SYMBY - 4*T1*M2*
     +    (TG+UG-M2)**(-1) - 2*T1*(TG-M2)*SYMBY*S4G + 2*T1*
     +    (TG+UG-M2)**(-1)*S4G - 2*T1 + 2*T1**2*(TG+UG-M2)**(-1) + 6*M2
     +    *(TG-M2)*SYMBY*S4G - 2*M2*(TG+UG-M2)**(-1)*S4G + 4*M2 - 4*
     +    M2**2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G + 2*M2**2*(TG-M2)*
     +    SYMBY + 2*M2**2*(TG+UG-M2)**(-1) - 16*MG2 - 6*S4G )
     +
      M2GBH = M2GBH + ANG4(59)*N*CO * (  - 64*T1*M2*MG2 + 32*T1**2*MG2
     +     + 32*M2**2*MG2 )
     +
      M2GBH = M2GBH + ANG4(60)*N*CO * ( 16*T1**(-1)*M2**2*MG2 + 32*T1*
     +    M2*MG2*(TG-M2)*SYMBY + 48*T1*MG2 - 16*T1**2*MG2*(TG-M2)*SYMBY
     +     - 64*M2*MG2 - 16*M2**2*MG2*(TG-M2)*SYMBY + 32*MG2**2 )
     +
      M2GBH = M2GBH + ANG4(61)*N*CO * (  - 32*S*MG2 - 32*S**2*UG**(-1)*
     +    MG2 + 32*UG**(-1)*MG2*S4G**2 - 32*T1*MG2 + 32*M2*MG2 - 32*MG2
     +    *S4G )
     +
      M2GBH = M2GBH + ANG4(62)*S42**(-1)*N*CO*S4 * ( 8*S*UG**(-1)*M2*
     +    MG2 - 2*S*T1**(-1)*M2*MG2 + 2*S*MG2 + 8*UG**(-1)*M2**2*MG2 + 
     +    8*T1**(-1)*M2**2*MG2 - 4*T1**(-1)*M2**3 - 6*T1*M2 + 2*T1*MG2
     +     + 2*T1**2 - 2*M2*MG2 + 8*M2**2 )
     +
      M2GBH = M2GBH + ANG4(62)*N*CO * (  - 8*S**(-1)*UG**(-1)*S4G**3 + 
     +    4*S**(-1)*T1*M2*MG2*(TG-M2)*SYMBY - 12*S**(-1)*T1*M2 - 12*
     +    S**(-1)*T1*M2**2*(TG-M2)*SYMBY + 2*S**(-1)*T1*MG2*(TG-M2)*
     +    SYMBY*S4G + 4*S**(-1)*T1*MG2 + 6*S**(-1)*T1*S4G + 12*S**(-1)*
     +    T1**2*M2*(TG-M2)*SYMBY - 2*S**(-1)*T1**2*MG2*(TG-M2)*SYMBY + 
     +    6*S**(-1)*T1**2 - 4*S**(-1)*T1**3*(TG-M2)*SYMBY - 2*S**(-1)*
     +    M2*MG2*(TG-M2)*SYMBY*S4G - 4*S**(-1)*M2*MG2 - 6*S**(-1)*M2*
     +    S4G - 2*S**(-1)*M2**2*MG2*(TG-M2)*SYMBY + 6*S**(-1)*M2**2 + 4
     +    *S**(-1)*M2**3*(TG-M2)*SYMBY + 8*S**(-1)*S4G**2 + 32*S*
     +    UG**(-2)*MG2*S4G - 16*S*UG**(-1)*M2*MG2*(S4-S)**(-1) + 6*S*
     +    UG**(-1)*M2*MG2*(S+TG-M2)**(-1) + 2*S*UG**(-1)*MG2*
     +    (S+TG-M2)**(-1)*S4G - 42*S*UG**(-1)*MG2 + 24*S*UG**(-1)*
     +    (S+UG)**(-1)*S4G**2 + 32*S*UG**(-1)*S4G - 2*S*T1**(-1)*M2*MG2
     +    *(S+UG)**(-1) - 16*S*T1**(-1)*M2*MG2*(S4-S)**(-1) - 6*S*T1*M2
     +    *(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 6*S*T1*MG2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY )
     +
      M2GBH = M2GBH + ANG4(62)*N*CO * (  - 6*S*T1*(S+UG)**(-1) + 2*S*T1
     +    *(S+TG-M2)**(-1) - 6*S*T1*(TG-M2)*SYMBY + 2*S*T1**2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY + 6*S*M2*MG2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY + 6*S*M2*(S+UG)**(-1) - 2*S*M2*(S+TG-M2)**(-1)
     +     + 6*S*M2*(TG-M2)*SYMBY + 4*S*M2**2*(S+TG-M2)**(-1)*(TG-M2)*
     +    SYMBY + 2*S*MG2*(S+UG)**(-1) + 8*S*MG2*(TG-M2)*SYMBY - 16*S*
     +    (S+UG)**(-1)*S4G - 8*S - 32*S**2*UG**(-2)*MG2 + 8*S**2*
     +    UG**(-1)*MG2*(TG-M2)*SYMBY - 24*S**2*UG**(-1)*(S+UG)**(-1)*
     +    S4G - 16*S**2*UG**(-1) + 2*S**2*T1*(S+TG-M2)**(-1)*(TG-M2)*
     +    SYMBY - 2*S**2*M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 8*S**2*
     +    (S+UG)**(-1) + 8*S**3*UG**(-1)*(S+UG)**(-1) - 8*UG**(-1)*M2*
     +    MG2*(S+TG-M2)**(-1)*S4G - 16*UG**(-1)*M2*MG2 + 8*UG**(-1)*
     +    M2**2*MG2*(S4-S)**(-1) - 8*UG**(-1)*MG2*(TG-M2)*SYMBY*S4G**2
     +     + 56*UG**(-1)*MG2*S4G + 32*UG**(-1)*MG2**2 - 8*UG**(-1)*
     +    (S+UG)**(-1)*S4G**3 - 24*UG**(-1)*S4G**2 + 4*T1**(-1)*M2*MG2
     +     - 4*T1**(-1)*M2*S4G )
     +
      M2GBH = M2GBH + ANG4(62)*N*CO * ( 8*T1**(-1)*M2**2*MG2*
     +    (S4-S)**(-1) + 4*T1**(-1)*M2**2 - 4*T1**(-1)*M2**3*
     +    (S+UG)**(-1) + 12*T1*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 
     +    32*T1*M2*MG2*SYMBY - 36*T1*M2*(S+UG)**(-1) + 16*T1*M2*(TG-M2)
     +    *SYMBY + 8*T1*M2**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 4*T1*MG2*
     +    (S+UG)**(-1) + 2*T1*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G - 2
     +    *T1*MG2*(S+TG-M2)**(-1) + 26*T1*MG2*(TG-M2)*SYMBY + 8*T1*
     +    (S+UG)**(-1)*S4G + 30*T1 - 4*T1**2*M2*(S+TG-M2)**(-1)*(TG-M2)
     +    *SYMBY - 2*T1**2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 16*T1**2
     +    *MG2*SYMBY + 16*T1**2*(S+UG)**(-1) - 8*T1**2*(TG-M2)*SYMBY - 
     +    4*M2*MG2*(S+UG)**(-1) - 2*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*
     +    SYMBY*S4G + 8*M2*MG2*(S+TG-M2)**(-1) - 26*M2*MG2*(TG-M2)*
     +    SYMBY - 8*M2*(S+UG)**(-1)*S4G - 34*M2 - 10*M2**2*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY - 16*M2**2*MG2*SYMBY + 24*M2**2
     +    *(S+UG)**(-1) - 8*M2**2*(TG-M2)*SYMBY - 4*M2**3*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY )
     +
      M2GBH = M2GBH + ANG4(62)*N*CO * ( 8*MG2*(TG-M2)*SYMBY*S4G - 30*
     +    MG2 + 8*(S+UG)**(-1)*S4G**2 + 28*S4G )
     +
      M2GBH = M2GBH + ANG4(63)*S42**(-1)*N*CO*S4 * (  - 4*S**(-1)*
     +    UG**(-1)*M2*MG2 - 2*S**(-1)*T1**(-1)*M2*MG2 - 2*S**(-1)*MG2
     +     + 2*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(63)*N*CO * ( 2*S**(-1)*UG**(-1)*M2*MG2*
     +    (S4-S)**(-1) + 2*S**(-1)*UG**(-1)*MG2 + 2*S**(-1)*UG**(-1)*
     +    S4G + 2*S**(-1)*T1**(-1)*M2*MG2*(S4-S)**(-1) - 2*S**(-1) + 8*
     +    UG**(-1)*M2*(S+TG-M2)**(-1) - 2*UG**(-1)*MG2*(S4-S)**(-1) - 4
     +    *UG**(-1)*(S+TG-M2)**(-1)*S4G - 2*T1**(-1)*MG2*(S4-S)**(-1)
     +     + 4*(S+TG-M2)**(-1) )
     +
      M2GBH = M2GBH + ANG4(68)*S42**(-1)*N*CK*S4 * (  - 2 - 4*S**(-1)*
     +    UG**(-1)*M2**2 - 8*S**(-1)*T1**(-1)*M2**2 - 2*S**(-1)*T1 + 4*
     +    S**(-1)*M2 - 4*S**(-1)*MG2 - 2*S*UG**(-1) - 4*UG**(-1)*M2 + 4
     +    *UG**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(68)*S42**(-1)*CQED*S4 * ( 4*S**(-1)*T1**(-1)
     +    *M2**2 + 2*S**(-1)*T1 - 4*S**(-1)*M2 + 4*S**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(68)*N*CK * ( 4*S**(-1)*UG**(-1)*M2**2*
     +    (S4-S)**(-1) + 2*S**(-1)*T1**(-1)*M2 + 4*S**(-1)*T1**(-1)*
     +    M2**2*(S4-S)**(-1) - 4*S**(-1)*T1**(-1)*MG2 - 2*S**(-1)*
     +    T1**(-1)*S4G - 4*S**(-1) + 2*S*UG**(-1)*(S4-S)**(-1) + 2*S*
     +    T1**(-1)*(S4-S)**(-1) - 4*UG**(-1)*M2*(S4-S)**(-1) + 4*
     +    UG**(-1)*MG2*(S4-S)**(-1) + 8*UG**(-1) - 4*T1**(-1)*M2*
     +    (S4-S)**(-1) + 4*T1**(-1)*MG2*(S4-S)**(-1) + 2*T1**(-1) )
     +
      M2GBH = M2GBH + ANG4(68)*CQED * (  - 2*S**(-1)*T1**(-1)*M2 + 4*
     +    S**(-1)*T1**(-1)*MG2 + 2*S**(-1)*T1**(-1)*S4G + 4*S**(-1) )
     +
      M2GBH = M2GBH + ANG4(70)*N*CO * ( 32*UG**(-2)*MG2*S4G**2 - 64*
     +    UG**(-1)*MG2*S4G + 32*MG2 )
     +
      M2GBH = M2GBH + ANG4(83)*N*CO * (  - 4*S**(-1)*T1*M2*MG2*(TG-M2)*
     +    SYMBY + 2*S**(-1)*T1*M2 + 12*S**(-1)*T1*M2**2*(TG-M2)*SYMBY
     +     - 2*S**(-1)*T1*MG2*(TG-M2)*SYMBY*S4G - 2*S**(-1)*T1*MG2 - 12
     +    *S**(-1)*T1**2*M2*(TG-M2)*SYMBY + 2*S**(-1)*T1**2*MG2*(TG-M2)
     +    *SYMBY - 2*S**(-1)*T1**2 + 4*S**(-1)*T1**3*(TG-M2)*SYMBY + 2*
     +    S**(-1)*M2*MG2*(TG-M2)*SYMBY*S4G + 2*S**(-1)*M2*MG2 + 2*
     +    S**(-1)*M2**2*MG2*(TG-M2)*SYMBY - 4*S**(-1)*M2**3*(TG-M2)*
     +    SYMBY + 2*S*UG**(-1)*MG2*(S+TG-M2)**(-1)*S4G - 8*S*UG**(-1)*
     +    MG2*(TG+UG-M2)**(-1)*S4G + 6*S*T1*M2*(S+TG-M2)**(-1)*(TG-M2)*
     +    SYMBY + 6*S*T1*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 2*S*T1*
     +    (S+TG-M2)**(-1) + 6*S*T1*(TG-M2)*SYMBY + 4*S*T1*
     +    (TG+UG-M2)**(-1) - 2*S*T1**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 
     +    6*S*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 2*S*M2*
     +    (S+TG-M2)**(-1) - 6*S*M2*(TG-M2)*SYMBY - 4*S*M2*
     +    (TG+UG-M2)**(-1) - 4*S*M2**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 
     +    6*S*MG2*(S+TG-M2)**(-1) )
     +
      M2GBH = M2GBH + ANG4(83)*N*CO * (  - 8*S*MG2*(TG-M2)*SYMBY - 4*S*
     +    (TG+UG-M2)**(-1)*S4G - 2*S - 8*S**2*UG**(-1)*MG2*(TG-M2)*
     +    SYMBY + 8*S**2*UG**(-1)*MG2*(TG+UG-M2)**(-1) - 2*S**2*T1*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY + 2*S**2*M2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY + 2*S**2*(S+TG-M2)**(-1) + 4*S**2*
     +    (TG+UG-M2)**(-1) - 2*UG**(-1)*M2*MG2*(S+TG-M2)**(-1)*S4G - 4*
     +    UG**(-1)*M2*MG2 + 2*UG**(-1)*M2*S4G - 4*UG**(-1)*M2**2*MG2*
     +    (S+TG-M2)**(-1) + 4*UG**(-1)*M2**2*(S+TG-M2)**(-1)*S4G - 2*
     +    UG**(-1)*MG2*(S+TG-M2)**(-1)*S4G**2 + 8*UG**(-1)*MG2*(TG-M2)*
     +    SYMBY*S4G**2 - 8*UG**(-1)*MG2*S4G + 2*UG**(-1)*S4G**2 - 12*T1
     +    *M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 32*T1*M2*MG2*SYMBY - 
     +    2*T1*M2*(S+TG-M2)**(-1) - 16*T1*M2*(TG-M2)*SYMBY - 4*T1*M2*
     +    (TG+UG-M2)**(-1) - 8*T1*M2**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY
     +     - 2*T1*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G - 2*T1*MG2*
     +    (S+TG-M2)**(-1) - 26*T1*MG2*(TG-M2)*SYMBY - 4*T1 + 4*T1**2*M2
     +    *(S+TG-M2)**(-1)*(TG-M2)*SYMBY )
     +
      M2GBH = M2GBH + ANG4(83)*N*CO * ( 2*T1**2*MG2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY + 16*T1**2*MG2*SYMBY + 8*T1**2*(TG-M2)*SYMBY + 
     +    2*T1**2*(TG+UG-M2)**(-1) + 2*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*
     +    SYMBY*S4G + 8*M2*MG2*(S+TG-M2)**(-1) + 26*M2*MG2*(TG-M2)*
     +    SYMBY - 2*M2 + 10*M2**2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 
     +    16*M2**2*MG2*SYMBY - 4*M2**2*(S+TG-M2)**(-1) + 8*M2**2*
     +    (TG-M2)*SYMBY + 2*M2**2*(TG+UG-M2)**(-1) + 4*M2**3*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY + 2*MG2*(S+TG-M2)**(-1)*S4G - 8
     +    *MG2*(TG-M2)*SYMBY*S4G + 10*MG2 + 2*(TG+UG-M2)**(-1)*S4G**2
     +     - 4*S4G )
     +
      M2GBH = M2GBH + ANG4(84)*N*CK * (  - 4*S**(-1)*UG**(-1)*M2**2*S4G
     +     + 4*S**(-1)*UG**(-1)*M2**3 - 2*S**(-1)*T1*M2 - 2*S**(-1)*T1*
     +    S4G + 2*S**(-1)*T1**2 + 4*S**(-1)*M2*MG2 + 4*S**(-1)*M2*S4G
     +     - 4*S**(-1)*MG2*S4G + 2*S*UG**(-1)*M2*MG2*(S4-S)**(-1) - 2*S
     +    *UG**(-1)*M2*MG2*(TG-M2)*SYMBY + 4*S*UG**(-1)*M2*(S+UG)**(-1)
     +    *S4G + 4*S*UG**(-1)*M2 + 4*S*UG**(-1)*M2**2*(S+UG)**(-1) + 2*
     +    S*UG**(-1)*S4G - 2*S*T1**(-1)*M2*MG2*(S+UG)**(-1) + 2*S*
     +    T1**(-1)*M2*MG2*(S4-S)**(-1) + 2*S*T1**(-1)*MG2 - 4*S*T1*M2*
     +    (TG-M2)*(TG+UG-M2)**(-1)*SYMBY - 2*S*T1*MG2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY - 2*S*T1*(TG+UG-M2)**(-1) + 2*S*M2*MG2
     +    *(TG-M2)*(TG+UG-M2)**(-1)*SYMBY - 4*S*M2*(S+UG)**(-1) + 2*S*
     +    M2*(TG+UG-M2)**(-1) + 4*S*M2**2*(TG-M2)*(TG+UG-M2)**(-1)*
     +    SYMBY + 2*S*MG2*(S+UG)**(-1) - 4*S**2*UG**(-1)*M2*
     +    (S+UG)**(-1) - 2*S**2*UG**(-1)*(S+UG)**(-1)*S4G - 2*S**2*
     +    UG**(-1) + 2*S**2*(S+UG)**(-1) + 2*S**3*UG**(-1)*(S+UG)**(-1)
     +     + 8*UG**(-2)*M2**3 )
     +
      M2GBH = M2GBH + ANG4(84)*N*CK * ( 4*UG**(-1)*M2*MG2*(TG-M2)*SYMBY
     +    *S4G + 4*UG**(-1)*M2*MG2 - 4*UG**(-1)*M2*S4G - 8*UG**(-1)*
     +    M2**2*MG2*(S4-S)**(-1) - 4*UG**(-1)*M2**2*MG2*(TG-M2)*SYMBY
     +     - 4*UG**(-1)*M2**2*(S+UG)**(-1)*S4G - 12*UG**(-1)*M2**2 - 4*
     +    UG**(-1)*M2**3*(TG-M2)*SYMBY + 12*T1**(-1)*M2*MG2 - 8*
     +    T1**(-1)*M2**2*MG2*(S+UG)**(-1) - 8*T1**(-1)*M2**2*MG2*
     +    (S4-S)**(-1) - 4*T1**(-1)*MG2*S4G + 8*T1*M2*(S+UG)**(-1) + 4*
     +    T1*M2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G - 4*T1*M2*(TG-M2)*
     +    SYMBY - 4*T1*M2*(TG+UG-M2)**(-1) - 4*T1*MG2*(S+UG)**(-1) - 2*
     +    T1*MG2*(TG-M2)*SYMBY + 2*T1*(TG+UG-M2)**(-1)*S4G - 2*T1 + 2*
     +    T1**2*(TG+UG-M2)**(-1) + 12*M2*MG2*(S+UG)**(-1) - 2*M2*
     +    (TG+UG-M2)**(-1)*S4G + 12*M2 - 4*M2**2*(S+UG)**(-1) - 4*M2**2
     +    *(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G + 4*M2**2*(TG-M2)*SYMBY
     +     + 2*M2**2*(TG+UG-M2)**(-1) - 4*MG2 - 2*S4G )
     +
      M2GBH = M2GBH + ANG4(84)*CQED * ( 4*S**(-1)*UG**(-1)*M2**2*S4G - 
     +    4*S**(-1)*UG**(-1)*M2**3 - 8*S**(-1)*T1**(-1)*M2*MG2*S4G + 4*
     +    S**(-1)*T1**(-1)*M2**2*MG2 + 4*S**(-1)*T1**(-1)*MG2*S4G**2 + 
     +    2*S**(-1)*T1*M2 - 2*S**(-1)*T1*S4G - 4*S**(-1)*M2*S4G + 2*
     +    S**(-1)*M2**2 + 2*S**(-1)*S4G**2 - 2*S*UG**(-1)*M2*MG2*
     +    (S4-S)**(-1) - 2*S*T1**(-1)*M2*MG2*(S4-S)**(-1) - 4*UG**(-2)*
     +    M2**3 - 4*UG**(-1)*M2*MG2 + 8*UG**(-1)*M2**2*MG2*(S4-S)**(-1)
     +     + 4*UG**(-1)*M2**2 - 2*T1**(-1)*M2*MG2 + 8*T1**(-1)*M2**2*
     +    MG2*(S4-S)**(-1) - 2*T1**(-1)*MG2*S4G - 2*S4G )
     +
      M2GBH = M2GBH + ANG4(85)*N*CO * (  - 2*S*M2 + 4*UG**(-1)*M2**3 - 
     +    2*T1*M2 + 2*M2*S4G + 6*M2**2 )
     +
      M2GBH = M2GBH + ANG4(85)*N*CK * ( 6*S*M2 - 12*UG**(-1)*M2**3 + 6*
     +    T1*M2 - 6*M2*S4G - 18*M2**2 )
     +
      M2GBH = M2GBH + ANG4(85)*CQED * (  - 2*S*M2 + 4*UG**(-1)*M2**3 - 
     +    2*T1*M2 + 2*M2*S4G + 6*M2**2 )
     +
      M2GBH = M2GBH + ANG4(86)*S42**(-1)*N*CK*S4 * ( 2*S*UG**(-1)*M2*
     +    MG2 + 2*S*T1**(-1)*M2*MG2 - 2*S*MG2 + 8*UG**(-1)*M2**2*MG2 - 
     +    8*T1**(-1)*M2**2*MG2 - 4*T1*MG2 + 16*M2*MG2 )
     +
      M2GBH = M2GBH + ANG4(86)*S42**(-1)*CQED*S4 * (  - 16*S**(-1)*T1*
     +    M2*MG2 + 4*S**(-1)*T1**2*MG2 + 16*S**(-1)*M2**2*MG2 - 2*S*
     +    T1**(-1)*M2*MG2 + 2*S*MG2 + 8*T1**(-1)*M2**2*MG2 + 6*T1*MG2
     +     - 16*M2*MG2 )
     +
      M2GBH = M2GBH + ANG4(86)*N*CO * (  - 2*S*UG**(-1)*M2*MG2*
     +    (S+TG-M2)**(-1) - 2*S*UG**(-1)*M2*MG2*(TG-M2)*SYMBY - 2*S*T1*
     +    (TG-M2)*SYMBY + S*M2*(S+TG-M2)**(-1) + 6*S*M2*(TG-M2)*SYMBY
     +     - 2*S*MG2*(S+TG-M2)**(-1) + 4*S*MG2*(TG-M2)*SYMBY + 2*S*
     +    (S+TG-M2)**(-1)*S4G + 2*S + 4*UG**(-1)*M2*MG2*(TG-M2)*SYMBY*
     +    S4G + 4*UG**(-1)*M2*MG2 - 4*UG**(-1)*M2**2*MG2*(TG-M2)*SYMBY
     +     - 12*UG**(-1)*M2**2 - 4*UG**(-1)*M2**3*(S+TG-M2)**(-1) - 4*
     +    UG**(-1)*M2**3*(TG-M2)*SYMBY + T1*M2*(S+TG-M2)**(-1) + 11*T1*
     +    M2*(TG-M2)*SYMBY + 6*T1*MG2*(TG-M2)*SYMBY + 2*T1*
     +    (S+TG-M2)**(-1)*S4G + 2*T1*(TG-M2)*SYMBY*S4G + 2*T1 - 2*T1**2
     +    *(TG-M2)*SYMBY - 16*M2*MG2*(TG-M2)*SYMBY - 6*M2*
     +    (S+TG-M2)**(-1)*S4G - 6*M2*(TG-M2)*SYMBY*S4G - 10*M2 - 6*
     +    M2**2*(S+TG-M2)**(-1) - 16*M2**2*(TG-M2)*SYMBY + 2*MG2 - 2*
     +    (S+TG-M2)**(-1)*S4G**2 - 2*S4G )
     +
      M2GBH = M2GBH + ANG4(86)*N*CK * ( 4*S**(-1)*UG**(-1)*M2**2*S4G - 
     +    4*S**(-1)*UG**(-1)*M2**3 + 16*S**(-1)*T1*M2*MG2*(TG-M2)*SYMBY
     +     + 16*S**(-1)*T1*M2*(TG-M2)*SYMBY*S4G + 10*S**(-1)*T1*M2 + 26
     +    *S**(-1)*T1*M2**2*(TG-M2)*SYMBY + 2*S**(-1)*T1*(TG-M2)*SYMBY*
     +    S4G**2 + 2*S**(-1)*T1*S4G - 12*S**(-1)*T1**2*M2*(TG-M2)*SYMBY
     +     - 4*S**(-1)*T1**2*MG2*(TG-M2)*SYMBY - 4*S**(-1)*T1**2*
     +    (TG-M2)*SYMBY*S4G - 2*S**(-1)*T1**2 + 2*S**(-1)*T1**3*(TG-M2)
     +    *SYMBY - 4*S**(-1)*M2*(TG-M2)*SYMBY*S4G**2 - 4*S**(-1)*M2*S4G
     +     - 16*S**(-1)*M2**2*MG2*(TG-M2)*SYMBY - 16*S**(-1)*M2**2*
     +    (TG-M2)*SYMBY*S4G - 16*S**(-1)*M2**2 - 20*S**(-1)*M2**3*
     +    (TG-M2)*SYMBY - 4*S*UG**(-1)*M2*MG2*(S4-S)**(-1) + 2*S*
     +    UG**(-1)*M2*MG2*(TG-M2)*SYMBY - 4*S*UG**(-1)*M2*(S+UG)**(-1)*
     +    S4G - 4*S*UG**(-1)*M2 - 4*S*UG**(-1)*M2**2*(S+UG)**(-1) - 2*S
     +    *UG**(-1)*S4G + 2*S*T1**(-1)*M2*MG2*(S+UG)**(-1) - 4*S*
     +    T1**(-1)*M2*MG2*(S4-S)**(-1) - 8*S*T1**(-1)*MG2 + 2*S*T1*
     +    (TG-M2)*SYMBY )
     +
      M2GBH = M2GBH + ANG4(86)*N*CK * ( 4*S*M2*(S+UG)**(-1) - 6*S*M2*
     +    (TG-M2)*SYMBY - 2*S*MG2*(S+UG)**(-1) - 4*S*MG2*(TG-M2)*SYMBY
     +     - 4*S + 4*S**2*UG**(-1)*M2*(S+UG)**(-1) + 2*S**2*UG**(-1)*
     +    (S+UG)**(-1)*S4G + 2*S**2*UG**(-1) - 2*S**2*(S+UG)**(-1) - 2*
     +    S**3*UG**(-1)*(S+UG)**(-1) - 8*UG**(-2)*M2**3 - 4*UG**(-1)*M2
     +    *MG2*(TG-M2)*SYMBY*S4G - 12*UG**(-1)*M2*MG2 + 4*UG**(-1)*M2*
     +    S4G + 16*UG**(-1)*M2**2*MG2*(S4-S)**(-1) + 4*UG**(-1)*M2**2*
     +    MG2*(TG-M2)*SYMBY + 4*UG**(-1)*M2**2*(S+UG)**(-1)*S4G + 24*
     +    UG**(-1)*M2**2 + 4*UG**(-1)*M2**3*(TG-M2)*SYMBY + 16*T1**(-1)
     +    *M2*MG2 - 8*T1**(-1)*M2**2*MG2*(S+UG)**(-1) + 16*T1**(-1)*
     +    M2**2*MG2*(S4-S)**(-1) - 18*T1*M2*(TG-M2)*SYMBY - 4*T1*MG2*
     +    (S+UG)**(-1) - 6*T1*MG2*(TG-M2)*SYMBY - 4*T1*(TG-M2)*SYMBY*
     +    S4G - 6*T1 + 4*T1**2*(TG-M2)*SYMBY + 12*M2*MG2*(S+UG)**(-1)
     +     + 16*M2*MG2*(TG-M2)*SYMBY + 10*M2*(TG-M2)*SYMBY*S4G + 24*M2
     +     - 4*M2**2*(S+UG)**(-1) + 22*M2**2*(TG-M2)*SYMBY - 8*MG2 + 6*
     +    S4G )
     +
      M2GBH = M2GBH + ANG4(86)*CQED * (  - 4*S**(-1)*UG**(-1)*M2**2*S4G
     +     + 4*S**(-1)*UG**(-1)*M2**3 - 10*S**(-1)*T1*M2 - 2*S**(-1)*T1
     +    *S4G + 2*S**(-1)*T1**2 + 4*S**(-1)*M2*S4G + 16*S**(-1)*M2**2
     +     + 2*S*UG**(-1)*M2*MG2*(S4-S)**(-1) + 2*S*T1**(-1)*M2*MG2*
     +    (S4-S)**(-1) + 4*S*T1**(-1)*MG2 + 2*S + 4*UG**(-2)*M2**3 + 4*
     +    UG**(-1)*M2*MG2 - 8*UG**(-1)*M2**2*MG2*(S4-S)**(-1) - 4*
     +    UG**(-1)*M2**2 - 8*T1**(-1)*M2*MG2 - 8*T1**(-1)*M2**2*MG2*
     +    (S4-S)**(-1) + 4*T1 - 12*M2 + 4*MG2 - 2*S4G )
     +
      M2GBH = M2GBH + ANG4(91)*N*CO * ( 8*UG**(-2)*M2**2*MG2 + 8*
     +    UG**(-1)*M2**2 + 4*M2 )
     +
      M2GBH = M2GBH + ANG4(91)*N*CK * (  - 8*UG**(-2)*M2**2*MG2 - 8*
     +    UG**(-1)*M2**2 - 4*M2 )
     +
      M2GBH = M2GBH + ANG4(92)*S42**(-1)*N*CK*S4 * (  - 16*S**(-1)*
     +    UG**(-1)*M2*MG2**2 + 16*S**(-1)*UG**(-1)*M2**2*MG2 - 16*
     +    S**(-1)*T1**(-1)*M2*MG2**2 + 8*S**(-1)*T1**(-1)*M2**2*MG2 - 4
     +    *S**(-1)*T1*MG2 + 14*S**(-1)*M2*MG2 - 2*S*T1**(-1)*MG2 + 32*
     +    UG**(-2)*M2*MG2**2 + 40*UG**(-1)*M2*MG2 + 16*UG**(-1)*MG2**2
     +     + 4*T1**(-1)*M2*MG2 + 8*T1**(-1)*MG2**2 + 10*MG2 )
     +
      M2GBH = M2GBH + ANG4(92)*S42**(-1)*CQED*S4 * (  - 2*S**(-1)*T1*
     +    MG2 + 2*S**(-1)*M2*MG2 - 2*S*T1**(-1)*MG2 + 2*T1**(-1)*M2*MG2
     +     - 4*MG2 )
     +
      M2GBH = M2GBH + ANG4(92)*N*CO * (  - 4 + 4*S*UG**(-1)*M2*
     +    (S+TG-M2)**(-1) - 4*S*UG**(-1)*M2*(TG-M2)*SYMBY - 4*S*
     +    UG**(-1)*(S+TG-M2)**(-1)*S4G + S*(S+TG-M2)**(-1) - 16*
     +    UG**(-2)*M2*MG2 - 16*UG**(-2)*M2**2*MG2*(S+TG-M2)**(-1) + 16*
     +    UG**(-2)*MG2**2 + UG**(-1)*M2*MG2*(S+TG-M2)**(-1) + 5*
     +    UG**(-1)*M2*(S+TG-M2)**(-1)*S4G + 4*UG**(-1)*M2*(TG-M2)*SYMBY
     +    *S4G - 19*UG**(-1)*M2 - 15*UG**(-1)*M2**2*(S+TG-M2)**(-1) - 4
     +    *UG**(-1)*M2**2*(TG-M2)*SYMBY - 5*UG**(-1)*MG2*
     +    (S+TG-M2)**(-1)*S4G + 17*UG**(-1)*MG2 + 2*UG**(-1)*
     +    (S+TG-M2)**(-1)*S4G**2 + 2*UG**(-1)*S4G + T1*(S+TG-M2)**(-1)
     +     + 3*T1*(TG-M2)*SYMBY - 13*M2*(S+TG-M2)**(-1) - 10*M2*(TG-M2)
     +    *SYMBY + 5*MG2*(S+TG-M2)**(-1) - 2*(S+TG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + ANG4(92)*N*CK * ( 6 - 8*S**(-1)*UG**(-1)*M2*MG2
     +     + 16*S**(-1)*UG**(-1)*M2*MG2**2*(S4-S)**(-1) - 4*S**(-1)*
     +    UG**(-1)*M2*S4G - 8*S**(-1)*UG**(-1)*M2**2*MG2*(S4-S)**(-1)
     +     + 4*S**(-1)*UG**(-1)*MG2*S4G + 16*S**(-1)*T1**(-1)*M2*MG2**2
     +    *(S4-S)**(-1) - 8*S**(-1)*T1**(-1)*M2**2*MG2*(S4-S)**(-1) + 8
     +    *S**(-1)*T1*M2*(TG-M2)*SYMBY - 2*S**(-1)*T1**2*(TG-M2)*SYMBY
     +     + 4*S**(-1)*M2 - 8*S**(-1)*M2**2*(TG-M2)*SYMBY - 4*S**(-1)*
     +    MG2 - 2*S*UG**(-1)*MG2*(S4-S)**(-1) - 2*S*T1**(-1)*MG2*
     +    (S4-S)**(-1) + 16*UG**(-2)*M2*MG2 - 16*UG**(-2)*MG2**2 + 4*
     +    UG**(-1)*M2*MG2*(S4-S)**(-1) + 14*UG**(-1)*M2 - 14*UG**(-1)*
     +    MG2 - 8*UG**(-1)*MG2**2*(S4-S)**(-1) + 4*T1**(-1)*M2*MG2*
     +    (S4-S)**(-1) - 8*T1**(-1)*MG2**2*(S4-S)**(-1) - 2*T1*(TG-M2)*
     +    SYMBY + 4*M2*(TG-M2)*SYMBY )
     +
      M2GBH = M2GBH + ANG4(92)*CQED * (  - 2 - 2*S**(-1)*T1 + 2*S**(-1)
     +    *M2 )
     +
      M2GBH = M2GBH + ANG4(97)*N*CO * ( 8*UG**(-1)*M2**2*MG2 - 4*
     +    UG**(-1)*M2**3 + 4*M2**2 )
     +
      M2GBH = M2GBH + ANG4(97)*N*CK * (  - 8*UG**(-1)*M2**2*MG2 - 4*
     +    UG**(-1)*M2**3 - 12*M2**2 )
     +
      M2GBH = M2GBH + ANG4(97)*CQED * ( 4*UG**(-1)*M2**3 + 4*M2**2 )
     +
      M2GBH = M2GBH + ANG4(99)*S42**(-1)*N*CK*S4 * ( 2*S**(-1)*T1*M2*
     +    MG2 - 8*S**(-1)*M2**2*MG2 - 2*S*UG**(-1)*M2*MG2 - 4*S*MG2 + 
     +    16*UG**(-1)*M2*MG2**2 - 8*UG**(-1)*M2**2*MG2 - 2*T1*MG2 + 6*
     +    M2*MG2 + 8*MG2**2 )
     +
      M2GBH = M2GBH + ANG4(99)*S42**(-1)*CQED*S4 * (  - 2*S**(-1)*T1*M2
     +    *MG2 + 8*S**(-1)*M2**2*MG2 - 8*S*T1**(-1)*M2*MG2 - 8*S*
     +    T1**(-1)*MG2**2 + 6*S*MG2 + 4*S**2*T1**(-1)*MG2 + 16*T1**(-1)
     +    *M2*MG2**2 + 2*T1*MG2 - 8*M2*MG2 - 8*MG2**2 )
     +
      M2GBH = M2GBH + ANG4(99)*N*CO * (  - 8*S**(-2)*M2**2*MG2 + 4*
     +    S**(-2)*M2**3 - 8*S**(-1)*UG**(-1)*M2**2*MG2 - 4*S**(-1)*
     +    UG**(-1)*M2**2*S4G + 4*S**(-1)*UG**(-1)*M2**3 + 4*S**(-1)*T1*
     +    M2*MG2*(S+TG-M2)**(-1) + 2*S**(-1)*T1*MG2*(S+TG-M2)**(-1)*S4G
     +     + 2*S**(-1)*T1*MG2 - 2*S**(-1)*T1**2*MG2*(S+TG-M2)**(-1) - 2
     +    *S**(-1)*M2*MG2*(S+TG-M2)**(-1)*S4G + 10*S**(-1)*M2*MG2 + 6*
     +    S**(-1)*M2**2*MG2*(S+TG-M2)**(-1) - 4*S**(-1)*M2**2 - 4*
     +    S**(-1)*M2**3*(S+TG-M2)**(-1) - 2*S**(-1)*MG2*S4G - 8*S**(-1)
     +    *MG2**2 + 2*S*UG**(-1)*M2*MG2*(S+TG-M2)**(-1) + 2*S*M2*
     +    (S+TG-M2)**(-1) - 12*UG**(-1)*M2*MG2 - 8*UG**(-1)*M2**2*MG2*
     +    (S+TG-M2)**(-1) + 8*UG**(-1)*M2**2 + 4*UG**(-1)*M2**3*
     +    (S+TG-M2)**(-1) + 8*UG**(-1)*MG2**2 + 2*T1*M2*(S+TG-M2)**(-1)
     +     - 4*T1*MG2*(S+TG-M2)**(-1) - 6*M2*MG2*(S+TG-M2)**(-1) - 2*M2
     +     + 4*MG2 )
     +
      M2GBH = M2GBH + ANG4(99)*N*CK * ( 8*S**(-2)*M2**2*MG2 - 4*S**(-2)
     +    *M2**3 + 12*S**(-1)*UG**(-1)*M2**2*S4G - 4*S**(-1)*UG**(-1)*
     +    M2**3 - 2*S**(-1)*T1**(-1)*M2*MG2*S4G - 16*S**(-1)*T1**(-1)*
     +    M2*MG2**2 + 6*S**(-1)*T1**(-1)*M2**2*MG2 + 2*S**(-1)*T1*MG2*
     +    (TG+UG-M2)**(-1)*S4G - 2*S**(-1)*T1*MG2 - 4*S**(-1)*M2*MG2*
     +    (TG+UG-M2)**(-1)*S4G - 2*S**(-1)*M2*MG2 - 4*S**(-1)*M2*
     +    (TG+UG-M2)**(-1)*S4G**2 + 4*S**(-1)*M2*S4G - 8*S**(-1)*M2**2
     +     + 8*S**(-1)*MG2**2 - 2*S*UG**(-1)*M2*MG2*(S4-S)**(-1) + 2*S*
     +    UG**(-1)*M2*MG2*(TG-M2)*SYMBY - 4*S*UG**(-1)*M2*(S+UG)**(-1)*
     +    S4G - 4*S*UG**(-1)*M2 - 2*S*UG**(-1)*S4G - 2*S*T1**(-1)*M2*
     +    MG2*(S4-S)**(-1) - 4*S*T1**(-1)*MG2 + 4*S*T1*M2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY + 2*S*T1*(S+UG)**(-1) + 2*S*M2*MG2*
     +    (TG-M2)*(TG+UG-M2)**(-1)*SYMBY + 2*S*M2*(S+UG)**(-1) - 4*S*M2
     +    *(TG+UG-M2)**(-1) - 4*S*M2**2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY
     +     - 8*S*MG2*(TG+UG-M2)**(-1) + 2*S + 4*S**2*UG**(-1)*M2*
     +    (S+UG)**(-1) )
     +
      M2GBH = M2GBH + ANG4(99)*N*CK * ( 2*S**2*UG**(-1)*(S+UG)**(-1)*
     +    S4G + 2*S**2*UG**(-1) - 2*S**2*(S+UG)**(-1) - 2*S**3*UG**(-1)
     +    *(S+UG)**(-1) - 8*UG**(-2)*M2**3 - 4*UG**(-1)*M2*MG2*(TG-M2)*
     +    SYMBY*S4G + 8*UG**(-1)*M2*MG2 + 4*UG**(-1)*M2*S4G + 8*
     +    UG**(-1)*M2**2*MG2*(S4-S)**(-1) + 4*UG**(-1)*M2**2*MG2*
     +    (TG-M2)*SYMBY + 4*UG**(-1)*M2**3*(TG-M2)*SYMBY - 8*UG**(-1)*
     +    MG2**2 + 8*T1**(-1)*M2*MG2 + 8*T1**(-1)*M2**2*MG2*
     +    (S4-S)**(-1) + 2*T1**(-1)*MG2*S4G + 8*T1**(-1)*MG2**2 - 6*T1*
     +    M2*MG2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY - 4*T1*M2*(S+UG)**(-1)
     +     - 4*T1*M2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G + 4*T1*M2*
     +    (TG-M2)*SYMBY + 2*T1*MG2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G
     +     - 2*T1*MG2*(TG-M2)*SYMBY - 6*T1*MG2*(TG+UG-M2)**(-1) + 2*
     +    T1**2*MG2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY - 4*M2*MG2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G + 8*M2*MG2*(TG-M2)*SYMBY + 16*M2*
     +    MG2*(TG+UG-M2)**(-1) + 8*M2*(TG+UG-M2)**(-1)*S4G - 8*M2 + 4*
     +    M2**2*MG2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY )
     +
      M2GBH = M2GBH + ANG4(99)*N*CK * ( 4*M2**2*(S+UG)**(-1) + 4*M2**2*
     +    (TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G - 4*M2**2*(TG-M2)*SYMBY + 
     +    4*MG2*(TG+UG-M2)**(-1)*S4G - 2*MG2 )
     +
      M2GBH = M2GBH + ANG4(99)*CQED * (  - 4*S**(-1)*UG**(-1)*M2**2*S4G
     +     + 4*S**(-1)*UG**(-1)*M2**3 - 2*S**(-1)*M2*MG2 + 8*S**(-1)*
     +    M2**2 + 2*S*UG**(-1)*M2*MG2*(S4-S)**(-1) + 2*S*T1**(-1)*M2*
     +    MG2*(S4-S)**(-1) - 2*S*T1**(-1)*MG2 + 4*UG**(-2)*M2**3 + 4*
     +    UG**(-1)*M2*MG2 - 8*UG**(-1)*M2**2*MG2*(S4-S)**(-1) - 4*
     +    UG**(-1)*M2**2 + 2*T1**(-1)*M2*MG2 - 8*T1**(-1)*M2**2*MG2*
     +    (S4-S)**(-1) - 2*MG2 )
     +
      M2GBH = M2GBH + ANG4(101)*N*CO * ( 32*T1*M2*MG2*(TG-M2)*SYMBY + 
     +    16*T1*MG2 - 16*T1**2*MG2*(TG-M2)*SYMBY - 16*M2*MG2 - 16*M2**2
     +    *MG2*(TG-M2)*SYMBY + 16*MG2**2 )
     +
      M2GBH = M2GBH + ANG4(101)*N*CK * ( 32*T1**(-1)*M2*MG2**2 + 16*M2*
     +    MG2 - 16*MG2**2 )
     +
      M2GBH = M2GBH + ANG4(103)*S42**(-1)*N*CK*S4 * (  - 2*S**(-1)*T1*
     +    M2*MG2 + 8*S**(-1)*M2**2*MG2 - 2*S*T1**(-1)*M2*MG2 + 2*S*MG2
     +     + 16*T1**(-1)*M2*MG2**2 - 8*T1**(-1)*M2**2*MG2 - 2*T1*MG2 + 
     +    4*M2*MG2 - 8*MG2**2 )
     +
      M2GBH = M2GBH + ANG4(103)*N*CO * (  - 8*S**(-2)*M2**2*MG2 + 4*
     +    S**(-2)*M2**3 - 8*S**(-1)*UG**(-1)*M2**2*MG2 - 4*S**(-1)*
     +    UG**(-1)*M2**2*S4G + 4*S**(-1)*UG**(-1)*M2**3 + 4*S**(-1)*T1*
     +    M2*MG2*(S+TG-M2)**(-1) + 4*S**(-1)*T1*M2*MG2*(TG-M2)*SYMBY - 
     +    4*S**(-1)*T1*M2 - 12*S**(-1)*T1*M2**2*(TG-M2)*SYMBY + 2*
     +    S**(-1)*T1*MG2*(S+TG-M2)**(-1)*S4G + 2*S**(-1)*T1*MG2*(TG-M2)
     +    *SYMBY*S4G + 2*S**(-1)*T1*MG2*(TG+UG-M2)**(-1)*S4G + 2*
     +    S**(-1)*T1*MG2 + 12*S**(-1)*T1**2*M2*(TG-M2)*SYMBY - 2*
     +    S**(-1)*T1**2*MG2*(S+TG-M2)**(-1) - 2*S**(-1)*T1**2*MG2*
     +    (TG-M2)*SYMBY + 4*S**(-1)*T1**2 - 4*S**(-1)*T1**3*(TG-M2)*
     +    SYMBY - 2*S**(-1)*M2*MG2*(S+TG-M2)**(-1)*S4G - 2*S**(-1)*M2*
     +    MG2*(TG-M2)*SYMBY*S4G - 2*S**(-1)*M2*MG2*(TG+UG-M2)**(-1)*S4G
     +     + 18*S**(-1)*M2*MG2 + 4*S**(-1)*M2*S4G + 6*S**(-1)*M2**2*MG2
     +    *(S+TG-M2)**(-1) - 2*S**(-1)*M2**2*MG2*(TG-M2)*SYMBY - 8*
     +    S**(-1)*M2**2 - 4*S**(-1)*M2**3*(S+TG-M2)**(-1) + 4*S**(-1)*
     +    M2**3*(TG-M2)*SYMBY )
     +
      M2GBH = M2GBH + ANG4(103)*N*CO * (  - 2*S**(-1)*MG2*
     +    (TG+UG-M2)**(-1)*S4G**2 - 2*S**(-1)*MG2*S4G - 8*S**(-1)*
     +    MG2**2 - 4*S**(-1)*(TG+UG-M2)**(-1)*S4G**3 + 4*S**(-1)*S4G**2
     +     + 2*S*UG**(-1)*M2 + 8*S*UG**(-1)*MG2*(TG+UG-M2)**(-1)*S4G - 
     +    4*S*UG**(-1)*MG2 - 2*S*UG**(-1)*S4G - 6*S*T1*M2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY - 6*S*T1*MG2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY - 2*S*T1*(S+TG-M2)**(-1) - 6*S*T1*(TG-M2)*SYMBY
     +     + 2*S*T1**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 6*S*M2*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY + 4*S*M2*(S+TG-M2)**(-1) + 6*S*
     +    M2*(TG-M2)*SYMBY + 4*S*M2**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 
     +    6*S*MG2*(S+TG-M2)**(-1) + 8*S*MG2*(TG-M2)*SYMBY - 8*S*MG2*
     +    (TG+UG-M2)**(-1) - 2*S*(TG+UG-M2)**(-1)*S4G + 6*S + 8*S**2*
     +    UG**(-1)*MG2*(TG-M2)*SYMBY - 8*S**2*UG**(-1)*MG2*
     +    (TG+UG-M2)**(-1) + 2*S**2*T1*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 
     +    2*S**2*M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 2*S**2*
     +    (S+TG-M2)**(-1) )
     +
      M2GBH = M2GBH + ANG4(103)*N*CO * (  - 4*UG**(-1)*M2*MG2 - 4*
     +    UG**(-1)*M2*S4G + 4*UG**(-1)*M2**2 - 8*UG**(-1)*MG2*(TG-M2)*
     +    SYMBY*S4G**2 + 12*UG**(-1)*MG2*S4G + 8*UG**(-1)*MG2**2 + 12*
     +    T1*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 32*T1*M2*MG2*SYMBY
     +     + 4*T1*M2*(S+TG-M2)**(-1) + 16*T1*M2*(TG-M2)*SYMBY + 8*T1*
     +    M2**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 2*T1*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G + 26*T1*MG2*(TG-M2)*SYMBY
     +     + 8*T1 - 4*T1**2*M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 2*T1**2*
     +    MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 16*T1**2*MG2*SYMBY - 8*
     +    T1**2*(TG-M2)*SYMBY - 2*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G - 14*M2*MG2*(S+TG-M2)**(-1) - 26*M2*MG2*(TG-M2)*SYMBY - 6
     +    *M2 - 10*M2**2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY - 16*M2**2*
     +    MG2*SYMBY - 8*M2**2*(TG-M2)*SYMBY - 4*M2**3*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY + 8*MG2*(TG-M2)*SYMBY*S4G + 10*MG2*
     +    (TG+UG-M2)**(-1)*S4G - 10*MG2 + 4*(TG+UG-M2)**(-1)*S4G**2 )
     +
      M2GBH = M2GBH + ANG4(103)*N*CK * ( 8*S**(-2)*M2**2*MG2 - 4*
     +    S**(-2)*M2**3 + 4*S**(-1)*UG**(-1)*M2**2*S4G - 4*S**(-1)*
     +    T1**(-1)*M2*MG2*S4G - 16*S**(-1)*T1**(-1)*M2*MG2**2 + 12*
     +    S**(-1)*T1**(-1)*M2**2*MG2 - 14*S**(-1)*M2*MG2 + 16*S**(-1)*
     +    M2**2 + 8*S**(-1)*MG2**2 + 4*S*UG**(-1)*M2**2*(S+UG)**(-1) - 
     +    2*S*T1**(-1)*M2*MG2*(S+UG)**(-1) + 2*S*T1*(S+UG)**(-1) - 2*S*
     +    M2*(S+UG)**(-1) + 2*S*MG2*(S+UG)**(-1) + 4*S - 4*UG**(-1)*
     +    M2**2*(S+UG)**(-1)*S4G - 4*UG**(-1)*M2**2 + 40*T1**(-1)*M2*
     +    MG2 - 8*T1**(-1)*M2**2*MG2*(S+UG)**(-1) + 16*T1**(-1)*MG2**2
     +     + 4*T1*M2*(S+UG)**(-1) - 4*T1*MG2*(S+UG)**(-1) + 12*M2*MG2*
     +    (S+UG)**(-1) + 14*M2 - 12*MG2 )
     +
      M2GBH = M2GBH + ANG4(104)*N*CO * ( 8*S**(-2)*M2**2*MG2 - 4*
     +    S**(-2)*M2**3 + 8*S**(-1)*UG**(-1)*M2**2*MG2 + 4*S**(-1)*
     +    UG**(-1)*M2**2*S4G - 4*S**(-1)*UG**(-1)*M2**3 - 4*S**(-1)*T1*
     +    M2*MG2*(S+TG-M2)**(-1) - 2*S**(-1)*T1*MG2*(S+TG-M2)**(-1)*S4G
     +     - 2*S**(-1)*T1*MG2 + 2*S**(-1)*T1**2*MG2*(S+TG-M2)**(-1) + 2
     +    *S**(-1)*M2*MG2*(S+TG-M2)**(-1)*S4G - 10*S**(-1)*M2*MG2 - 6*
     +    S**(-1)*M2**2*MG2*(S+TG-M2)**(-1) + 4*S**(-1)*M2**2 + 4*
     +    S**(-1)*M2**3*(S+TG-M2)**(-1) + 2*S**(-1)*MG2*S4G + 8*S**(-1)
     +    *MG2**2 + 12*S*UG**(-1)*M2*MG2*(S+TG-M2)**(-1) + 4*S*UG**(-1)
     +    *M2*(S+TG-M2)**(-1)*S4G - 2*S*UG**(-1)*M2 - 4*S*UG**(-1)*
     +    M2**2*(S+TG-M2)**(-1) - 4*S*UG**(-1)*MG2*(S+TG-M2)**(-1)*S4G
     +     + 4*S*UG**(-1)*MG2 + 2*S*UG**(-1)*S4G + 2*S*M2*
     +    (S+TG-M2)**(-1) + 2*S**2*UG**(-1)*M2*(S+TG-M2)**(-1) - 2*S**2
     +    *UG**(-1)*(S+TG-M2)**(-1)*S4G - 12*UG**(-1)*M2*MG2 - 4*
     +    UG**(-1)*M2*S4G - 8*UG**(-1)*M2**2*MG2*(S+TG-M2)**(-1) - 4*
     +    UG**(-1)*M2**2*(S+TG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + ANG4(104)*N*CO * ( 4*UG**(-1)*M2**2 + 4*UG**(-1)*
     +    M2**3*(S+TG-M2)**(-1) + 4*UG**(-1)*MG2*S4G + 8*UG**(-1)*
     +    MG2**2 - 2*T1*MG2*(S+TG-M2)**(-1) + 14*M2*MG2*(S+TG-M2)**(-1)
     +     - 2*M2 - 4*M2**2*(S+TG-M2)**(-1) + 4*MG2 )
     +
      M2GBH = M2GBH + ANG4(104)*N*CK * (  - 8*S**(-2)*M2**2*MG2 + 4*
     +    S**(-2)*M2**3 - 4*S**(-1)*UG**(-1)*M2**2*S4G + 2*S**(-1)*
     +    T1**(-1)*M2*MG2*S4G + 16*S**(-1)*T1**(-1)*M2*MG2**2 - 6*
     +    S**(-1)*T1**(-1)*M2**2*MG2 + 10*S**(-1)*M2*MG2 - 4*S**(-1)*
     +    M2**2 - 8*S**(-1)*MG2**2 - 4*S*UG**(-1)*M2**2*(S+UG)**(-1) + 
     +    2*S*T1**(-1)*M2*MG2*(S+UG)**(-1) - 2*S*T1**(-1)*MG2 - 2*S*T1*
     +    (S+UG)**(-1) + 2*S*M2*(S+UG)**(-1) - 2*S*MG2*(S+UG)**(-1) - 2
     +    *S + 4*UG**(-1)*M2**2*(S+UG)**(-1)*S4G + 4*UG**(-1)*M2**2 + 2
     +    *T1**(-1)*M2*MG2 - 8*T1**(-1)*M2**2*MG2*(S+UG)**(-1) - 2*
     +    T1**(-1)*MG2*S4G - 8*T1**(-1)*MG2**2 + 4*T1*M2*(S+UG)**(-1)
     +     - 4*T1*MG2*(S+UG)**(-1) + 12*M2*MG2*(S+UG)**(-1) + 6*M2 - 8*
     +    M2**2*(S+UG)**(-1) - 4*MG2 )
     +
      M2GBH = M2GBH + ANG4(108)*N*CO * (  - 6*S*UG**(-1)*M2*MG2*
     +    (S+TG-M2)**(-1) - 4*S*UG**(-1)*M2*MG2*(TG-M2)*SYMBY + 2*S*
     +    UG**(-1)*M2*(S+TG-M2)**(-1)*S4G - 8*S*UG**(-1)*M2*(TG-M2)*
     +    SYMBY*S4G + 4*S*UG**(-1)*M2 + 2*S*UG**(-1)*M2**2*
     +    (S+TG-M2)**(-1) - 2*S*UG**(-1)*MG2*(S+TG-M2)**(-1)*S4G + 6*S*
     +    UG**(-1)*MG2*(TG-M2)*SYMBY*S4G - 4*S*UG**(-1)*(S+TG-M2)**(-1)
     +    *S4G**2 + 2*S*M2*(S+TG-M2)**(-1) + 2*S*M2*(TG-M2)*SYMBY + S*
     +    MG2*(S+TG-M2)**(-1) - 6*S*MG2*(TG-M2)*SYMBY - 2*S**2*UG**(-1)
     +    *M2*(S+TG-M2)**(-1) + 4*S**2*UG**(-1)*M2*(TG-M2)*SYMBY - 2*
     +    S**2*UG**(-1)*MG2*(TG-M2)*SYMBY + 2*S**2*UG**(-1)*
     +    (S+TG-M2)**(-1)*S4G + 2*UG**(-1)*M2*MG2*(S+TG-M2)**(-1)*S4G
     +     + 4*UG**(-1)*M2*MG2*(TG-M2)*SYMBY*S4G - 3*UG**(-1)*M2*MG2 + 
     +    4*UG**(-1)*M2*(TG-M2)*SYMBY*S4G**2 - 4*UG**(-1)*M2*S4G - 3*
     +    UG**(-1)*M2**2*MG2*(S+TG-M2)**(-1) - 2*UG**(-1)*M2**2*
     +    (S+TG-M2)**(-1)*S4G + UG**(-1)*MG2*(S+TG-M2)**(-1)*S4G**2 - 4
     +    *UG**(-1)*MG2*(TG-M2)*SYMBY*S4G**2 )
     +
      M2GBH = M2GBH + ANG4(108)*N*CO * ( UG**(-1)*MG2*S4G + 2*UG**(-1)*
     +    (S+TG-M2)**(-1)*S4G**3 - 2*T1*M2*(TG-M2)*SYMBY - T1*MG2*
     +    (S+TG-M2)**(-1) - 2*T1*MG2*(TG-M2)*SYMBY - M2*MG2*
     +    (S+TG-M2)**(-1) + 4*M2*MG2*(TG-M2)*SYMBY - 2*M2*
     +    (S+TG-M2)**(-1)*S4G - 2*M2*(TG-M2)*SYMBY*S4G + 2*M2 + 2*M2**2
     +    *(S+TG-M2)**(-1) + 2*M2**2*(TG-M2)*SYMBY - MG2*
     +    (S+TG-M2)**(-1)*S4G + 4*MG2*(TG-M2)*SYMBY*S4G + 3*MG2 )
     +
      M2GBH = M2GBH + ANG4(108)*N*CK * (  - 16*S**(-1)*T1*M2*MG2*
     +    (TG-M2)*SYMBY + 2*S**(-1)*T1*M2 + 6*S**(-1)*T1*M2**2*(TG-M2)*
     +    SYMBY + 2*S**(-1)*T1*MG2*(TG+UG-M2)**(-1)*S4G - 4*S**(-1)*T1*
     +    MG2 - 2*S**(-1)*T1*(TG-M2)*SYMBY*S4G**2 - 2*S**(-1)*T1**2*M2*
     +    (TG-M2)*SYMBY + 4*S**(-1)*T1**2*MG2*(TG-M2)*SYMBY - 4*S**(-1)
     +    *M2*MG2*(TG+UG-M2)**(-1)*S4G + 8*S**(-1)*M2*MG2 + 4*S**(-1)*
     +    M2*(TG-M2)*SYMBY*S4G**2 - 4*S**(-1)*M2*(TG+UG-M2)**(-1)*
     +    S4G**2 + 2*S**(-1)*M2*S4G + 16*S**(-1)*M2**2*MG2*(TG-M2)*
     +    SYMBY - 2*S**(-1)*M2**2 - 4*S**(-1)*M2**3*(TG-M2)*SYMBY + 4*S
     +    *T1*M2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY + 2*S*M2*MG2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY + 2*S*M2*(TG-M2)*SYMBY - 4*S*M2*
     +    (TG+UG-M2)**(-1) - 4*S*M2**2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY
     +     + 4*S*MG2*(TG-M2)*SYMBY - 8*S*MG2*(TG+UG-M2)**(-1) - 6*T1*M2
     +    *MG2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY - 4*T1*M2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G + 2*T1*M2*(TG-M2)*SYMBY + 2*T1*MG2
     +    *(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G )
     +
      M2GBH = M2GBH + ANG4(108)*N*CK * ( 4*T1*MG2*(TG-M2)*SYMBY - 6*T1*
     +    MG2*(TG+UG-M2)**(-1) + 2*T1*(TG-M2)*SYMBY*S4G + 2*T1**2*MG2*
     +    (TG-M2)*(TG+UG-M2)**(-1)*SYMBY - 4*M2*MG2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G - 8*M2*MG2*(TG-M2)*SYMBY + 16*M2*
     +    MG2*(TG+UG-M2)**(-1) - 6*M2*(TG-M2)*SYMBY*S4G + 8*M2*
     +    (TG+UG-M2)**(-1)*S4G - 2*M2 + 4*M2**2*MG2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY + 4*M2**2*(TG-M2)*(TG+UG-M2)**(-1)*
     +    SYMBY*S4G - 2*M2**2*(TG-M2)*SYMBY + 4*MG2*(TG+UG-M2)**(-1)*
     +    S4G - 4*MG2 )
     +
      M2GBH = M2GBH + ANG4(110)*S42**(-1)*N*CK*S4 * (  - 4*S**(-1)*
     +    UG**(-1)*M2*MG2 + 4*S**(-1)*T1**(-1)*M2*MG2 - 8*S**(-1)*MG2
     +     - 2*UG**(-1)*MG2 - 4*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(110)*S42**(-1)*CQED*S4 * (  - 4*S**(-1)*
     +    T1**(-1)*M2*MG2 + 6*S**(-1)*MG2 + 4*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(110)*N*CO * (  - 4*S**(-1) )
     +
      M2GBH = M2GBH + ANG4(110)*N*CK * ( 4*S**(-1)*UG**(-1)*MG2 + 4*
     +    S**(-1)*UG**(-1)*S4G - 2*S**(-1)*T1**(-1)*MG2 - 4*S**(-1) - 4
     +    *UG**(-1) )
     +
      M2GBH = M2GBH + ANG4(110)*CQED * ( 2*S**(-1)*T1**(-1)*MG2 + 4*
     +    S**(-1) )
     +
      M2GBH = M2GBH + ANG4(113)*N*CO * ( 4*UG**(-1)*M2 )
     +
      M2GBH = M2GBH + ANG4(113)*N*CK * (  - 4*UG**(-1)*M2 )
     +
      M2GBH = M2GBH + ANG4(114)*S42**(-1)*N*CK*S4 * ( 4*S**(-1)*
     +    UG**(-1)*M2*MG2 + 2*S**(-1)*T1**(-1)*M2*MG2 + 2*S**(-1)*MG2
     +     - 2*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + ANG4(114)*N*CO * (  - 8*UG**(-1)*M2*
     +    (S+TG-M2)**(-1) + 4*UG**(-1)*(S+TG-M2)**(-1)*S4G - 4*UG**(-1)
     +     - 4*(S+TG-M2)**(-1) )
     +
      M2GBH = M2GBH + ANG4(114)*N*CK * (  - 2*S**(-1)*UG**(-1)*M2*MG2*
     +    (S4-S)**(-1) - 2*S**(-1)*UG**(-1)*MG2 - 2*S**(-1)*UG**(-1)*
     +    S4G - 2*S**(-1)*T1**(-1)*M2*MG2*(S4-S)**(-1) + 2*S**(-1) + 2*
     +    UG**(-1)*MG2*(S4-S)**(-1) + 4*UG**(-1) + 2*T1**(-1)*MG2*
     +    (S4-S)**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*S42**(-1)*N*CO*(S4G+MG2)*S4 * ( 16*
     +    S**(-1)*UG**(-1)*M2*MG2*S4G**(-1) + 16*S**(-1)*UG**(-1)*M2**2
     +    *MG2*(S+TG)**(-1)*S4G**(-1) - 16*S**(-1)*UG**(-1)*M2**2*
     +    S4G**(-1) - 16*S**(-1)*UG**(-1)*M2**3*(S+TG)**(-1)*S4G**(-1)
     +     + 16*S**(-1)*T1**(-1)*M2*MG2*S4G**(-1) + 16*S**(-1)*T1**(-1)
     +    *M2**2*MG2*(S+TG)**(-1)*S4G**(-1) - 8*S**(-1)*T1**(-1)*M2**2*
     +    S4G**(-1) - 8*S**(-1)*T1**(-1)*M2**3*(S+TG)**(-1)*S4G**(-1)
     +     - 8*S**(-1)*T1*M2*MG2*(S+TG)**(-2)*S4G**(-1) + 12*S**(-1)*T1
     +    *M2*(S+TG)**(-1)*S4G**(-1) - 4*S**(-1)*T1*MG2*(S+TG)**(-1)*
     +    S4G**(-1) + 4*S**(-1)*T1*S4G**(-1) + 4*S**(-1)*T1**2*MG2*
     +    (S+TG)**(-2)*S4G**(-1) - 4*S**(-1)*T1**2*(S+TG)**(-1)*
     +    S4G**(-1) + 4*S**(-1)*M2*MG2*(S+TG)**(-1)*S4G**(-1) - 8*
     +    S**(-1)*M2*S4G**(-1) + 4*S**(-1)*M2**2*MG2*(S+TG)**(-2)*
     +    S4G**(-1) - 16*S**(-1)*M2**2*(S+TG)**(-1)*S4G**(-1) - 8*S*
     +    UG**(-1)*M2*(S+TG)**(-1)*S4G**(-1) - 8*S*UG**(-1)*S4G**(-1)
     +     + 4*S*T1**(-1)*M2*MG2*(S+TG)**(-2)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*S42**(-1)*N*CO*(S4G+MG2)*S4 * ( 4*S*
     +    T1**(-1)*MG2*(S+TG)**(-1)*S4G**(-1) - 4*S*MG2*(S+TG)**(-2)*
     +    S4G**(-1) - 32*UG**(-2)*M2*MG2*S4G**(-1) - 32*UG**(-2)*M2**2*
     +    MG2*(S+TG)**(-1)*S4G**(-1) - 32*UG**(-1)*M2*MG2*(S+TG)**(-1)*
     +    S4G**(-1) - 16*UG**(-1)*M2*S4G**(-1) - 16*UG**(-1)*M2**2*
     +    (S+TG)**(-1)*S4G**(-1) - 24*T1**(-1)*M2*MG2*(S+TG)**(-1)*
     +    S4G**(-1) - 4*T1**(-1)*M2**2*MG2*(S+TG)**(-2)*S4G**(-1) + 8*
     +    T1**(-1)*M2**2*(S+TG)**(-1)*S4G**(-1) - 4*T1**(-1)*MG2*
     +    S4G**(-1) + 4*T1*(S+TG)**(-1)*S4G**(-1) + 4*M2*MG2*
     +    (S+TG)**(-2)*S4G**(-1) - 16*M2*(S+TG)**(-1)*S4G**(-1) + 8*MG2
     +    *(S+TG)**(-1)*S4G**(-1) - 8*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*S42**(-1)*N*CK*(S4G+MG2)*S4 * (  - 8*
     +    S**(-1)*T1**(-1)*M2**2*S4G**(-1) - 8*S**(-1)*T1**(-1)*M2**3*
     +    (S+UG)**(-1)*S4G**(-1) - 8*S**(-1)*T1*M2*MG2*(S+UG)**(-2)*
     +    S4G**(-1) - 4*S**(-1)*T1*M2*(S+UG)**(-1)*S4G**(-1) + 16*
     +    S**(-1)*T1*M2**2*(S+UG)**(-2)*S4G**(-1) + 8*S**(-1)*T1*MG2*
     +    (S+UG)**(-1)*S4G**(-1) - 4*S**(-1)*T1*S4G**(-1) - 12*S**(-1)*
     +    T1**2*M2*(S+UG)**(-2)*S4G**(-1) + 8*S**(-1)*T1**2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) + 4*S**(-1)*T1**3*(S+UG)**(-2)*
     +    S4G**(-1) - 8*S**(-1)*M2*MG2*(S+UG)**(-1)*S4G**(-1) + 8*
     +    S**(-1)*M2*S4G**(-1) + 8*S**(-1)*M2**2*(S+UG)**(-1)*S4G**(-1)
     +     - 8*S**(-1)*M2**3*(S+UG)**(-2)*S4G**(-1) + 4*S*UG**(-1)*M2*
     +    MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S*UG**(-1)*MG2*
     +    (S+UG)**(-1)*S4G**(-1) + 4*S*T1**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*UG**(-1)*M2*MG2*
     +    (S+UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*S42**(-1)*N*CK*(S4G+MG2)*S4 * ( 16*
     +    UG**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*
     +    T1**(-2)*M2**3*(S+UG)**(-1)*S4G**(-1) - 16*T1**(-1)*M2*MG2*
     +    (S+UG)**(-1)*S4G**(-1) - 16*T1**(-1)*M2**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 32*T1**(-1)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) - 16*T1**(-1)*M2**3*(S+UG)**(-2)*
     +    S4G**(-1) + 4*T1**(-1)*MG2*S4G**(-1) - 24*T1*M2*(S+UG)**(-2)*
     +    S4G**(-1) + 16*T1*MG2*(S+UG)**(-2)*S4G**(-1) - 8*T1*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*T1*(S+UG)**(-1)*
     +    S4G**(-1) + 8*T1**2*(S+UG)**(-2)*S4G**(-1) - 16*M2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) + 32*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 24*M2*(S+UG)**(-1)*S4G**(-1) + 32*M2**2*
     +    (S+UG)**(-2)*S4G**(-1) + 28*MG2*(S+UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*S42**(-1)*CQED*(S4G+MG2)*S4 * ( 8*
     +    S**(-1)*T1**(-1)*M2**3*(S+UG)**(-1)*S4G**(-1) + 8*S**(-1)*T1*
     +    M2*MG2*(S+UG)**(-2)*S4G**(-1) - 32*S**(-1)*T1*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 12*S**(-1)*T1*M2*
     +    (S+UG)**(-1)*S4G**(-1) - 16*S**(-1)*T1*M2**2*(S+UG)**(-2)*
     +    S4G**(-1) - 16*S**(-1)*T1*MG2*(S+UG)**(-1)*S4G**(-1) + 12*
     +    S**(-1)*T1**2*M2*(S+UG)**(-2)*S4G**(-1) - 8*S**(-1)*T1**2*MG2
     +    *(S+UG)**(-2)*S4G**(-1) + 8*S**(-1)*T1**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S**(-1)*T1**2*
     +    (S+UG)**(-1)*S4G**(-1) - 4*S**(-1)*T1**3*(S+UG)**(-2)*
     +    S4G**(-1) + 24*S**(-1)*M2*MG2*(S+UG)**(-1)*S4G**(-1) + 32*
     +    S**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*
     +    S**(-1)*M2**2*(S+UG)**(-1)*S4G**(-1) + 8*S**(-1)*M2**3*
     +    (S+UG)**(-2)*S4G**(-1) - 4*S*T1**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*S42**(-1)*CQED*(S4G+MG2)*S4 * ( 8*
     +    T1**(-2)*M2**3*(S+UG)**(-1)*S4G**(-1) + 8*T1**(-1)*M2*MG2*
     +    (S+UG)**(-1)*S4G**(-1) + 16*T1**(-1)*M2**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*T1**(-1)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) + 8*T1**(-1)*M2**3*(S+UG)**(-2)*
     +    S4G**(-1) + 12*T1*M2*(S+UG)**(-2)*S4G**(-1) - 8*T1*MG2*
     +    (S+UG)**(-2)*S4G**(-1) + 12*T1*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 4*T1*(S+UG)**(-1)*S4G**(-1) - 4*T1**2*
     +    (S+UG)**(-2)*S4G**(-1) + 8*M2*MG2*(S+UG)**(-2)*S4G**(-1) - 32
     +    *M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 12*M2*
     +    (S+UG)**(-1)*S4G**(-1) - 16*M2**2*(S+UG)**(-2)*S4G**(-1) - 12
     +    *MG2*(S+UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2)*SYMBT * (  - 8 - 8*
     +    S**(-1)*T1*M2*MG2*(TG-M2)*SYMBY*S4G**(-1) + 4*S**(-1)*T1*M2*
     +    S4G**(-1) + 24*S**(-1)*T1*M2**2*(TG-M2)*SYMBY*S4G**(-1) - 4*
     +    S**(-1)*T1*MG2*(TG-M2)*SYMBY - 4*S**(-1)*T1*MG2*S4G**(-1) - 
     +    24*S**(-1)*T1**2*M2*(TG-M2)*SYMBY*S4G**(-1) + 4*S**(-1)*T1**2
     +    *MG2*(TG-M2)*SYMBY*S4G**(-1) - 4*S**(-1)*T1**2*S4G**(-1) + 8*
     +    S**(-1)*T1**3*(TG-M2)*SYMBY*S4G**(-1) + 4*S**(-1)*M2*MG2*
     +    (TG-M2)*SYMBY + 4*S**(-1)*M2*MG2*S4G**(-1) + 4*S**(-1)*M2**2*
     +    MG2*(TG-M2)*SYMBY*S4G**(-1) - 8*S**(-1)*M2**3*(TG-M2)*SYMBY*
     +    S4G**(-1) - 32*S*TG*UG**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) + 4*
     +    S*UG**(-1)*MG2*(S+TG-M2)**(-1) - 16*S*UG**(-1)*MG2*
     +    (TG+UG-M2)**(-1) + 12*S*T1*M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 12*S*T1*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*S*T1*(S+TG-M2)**(-1)*S4G**(-1) + 12*S*T1*
     +    (TG-M2)*SYMBY*S4G**(-1) + 8*S*T1*(TG+UG-M2)**(-1)*S4G**(-1)
     +     - 4*S*T1**2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2)*SYMBT * (  - 12*S*M2*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*S*M2*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 12*S*M2*(TG-M2)*SYMBY*S4G**(-1)
     +     - 8*S*M2*(TG+UG-M2)**(-1)*S4G**(-1) - 8*S*M2**2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 12*S*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 16*S*MG2*(TG-M2)*SYMBY*S4G**(-1)
     +     - 8*S*(TG+UG-M2)**(-1) - 4*S*S4G**(-1) - 16*S**2*UG**(-1)*
     +    MG2*(TG-M2)*SYMBY*S4G**(-1) + 16*S**2*UG**(-1)*MG2*
     +    (TG+UG-M2)**(-1)*S4G**(-1) - 4*S**2*T1*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) + 4*S**2*M2*(S+TG-M2)**(-1)*(TG-M2)*
     +    SYMBY*S4G**(-1) + 4*S**2*(S+TG-M2)**(-1)*S4G**(-1) + 8*S**2*
     +    (TG+UG-M2)**(-1)*S4G**(-1) - 32*TG**2*UG**(-1)*MG2*(TG-M2)*
     +    SYMBY*S4G**(-1) - 4*UG**(-1)*M2*MG2*(S+TG-M2)**(-1) - 8*
     +    UG**(-1)*M2*MG2*S4G**(-1) + 4*UG**(-1)*M2 - 8*UG**(-1)*M2**2*
     +    MG2*(S+TG-M2)**(-1)*S4G**(-1) + 8*UG**(-1)*M2**2*
     +    (S+TG-M2)**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2)*SYMBT * (  - 4*UG**(-1)*
     +    MG2*(S+TG-M2)**(-1)*S4G + 16*UG**(-1)*MG2*(TG-M2)*SYMBY*S4G
     +     - 16*UG**(-1)*MG2 + 4*UG**(-1)*S4G - 24*T1*M2*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*T1*M2*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 32*T1*M2*(TG-M2)*SYMBY*S4G**(-1)
     +     - 8*T1*M2*(TG+UG-M2)**(-1)*S4G**(-1) - 16*T1*M2**2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*T1*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY - 4*T1*MG2*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 52*T1*MG2*(TG-M2)*SYMBY*S4G**(-1) - 8*T1*
     +    S4G**(-1) + 8*T1**2*M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*T1**2*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 16*T1**2*(TG-M2)*SYMBY*S4G**(-1) + 4*T1**2*
     +    (TG+UG-M2)**(-1)*S4G**(-1) + 4*M2*MG2*(S+TG-M2)**(-1)*(TG-M2)
     +    *SYMBY + 16*M2*MG2*(S+TG-M2)**(-1)*S4G**(-1) + 52*M2*MG2*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*M2*S4G**(-1) + 20*M2**2*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2)*SYMBT * (  - 8*M2**2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 16*M2**2*(TG-M2)*SYMBY*S4G**(-1)
     +     + 4*M2**2*(TG+UG-M2)**(-1)*S4G**(-1) + 8*M2**3*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*MG2*
     +    (S+TG-M2)**(-1) - 16*MG2*(TG-M2)*SYMBY + 20*MG2*S4G**(-1) + 4
     +    *(TG+UG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * ( 32*S**(-2)*TG**(-1)*
     +    T1*M2*S4G**(-1) + 32*S**(-2)*TG**(-1)*T1 - 16*S**(-2)*
     +    TG**(-1)*T1**2*S4G**(-1) - 32*S**(-2)*TG**(-1)*M2 - 16*
     +    S**(-2)*TG**(-1)*M2**2*S4G**(-1) - 16*S**(-2)*TG**(-1)*S4G - 
     +    64*S**(-2)*UG**(-2)*S4G**2 + 128*S**(-2)*UG**(-1)*S4G - 32*
     +    S**(-2)*T1*S4G**(-1) + 32*S**(-2)*M2*S4G**(-1) - 96*S**(-2)
     +     - 16*S**(-1)*TG**(-2)*T1*MG2*S4G**(-1) + 16*S**(-1)*TG**(-2)
     +    *M2*MG2*S4G**(-1) + 16*S**(-1)*TG**(-2)*MG2 + 8*S**(-1)*
     +    TG**(-1)*T1*M2*(TG-M2)*SYMBY*S4G**(-1) - 8*S**(-1)*TG**(-1)*
     +    T1*S4G**(-1) - 8*S**(-1)*TG**(-1)*M2*(TG-M2)*SYMBY + 8*
     +    S**(-1)*TG**(-1)*M2*S4G**(-1) - 8*S**(-1)*TG**(-1)*M2**2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 32*S**(-1)*TG**(-1)*MG2*S4G**(-1)
     +     + 8*S**(-1)*TG**(-1) + 128*S**(-1)*UG**(-3)*MG2*S4G - 2*
     +    S**(-1)*UG**(-2)*M2*(S+TG-M2)**(-1)*S4G - 128*S**(-1)*
     +    UG**(-2)*MG2 + 2*S**(-1)*UG**(-2)*(S+TG-M2)**(-1)*S4G**2 + 78
     +    *S**(-1)*UG**(-2)*S4G )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * (  - 16*S**(-1)*
     +    UG**(-1)*M2*MG2*(S4-S)**(-1)*S4G**(-1) - 8*S**(-1)*UG**(-1)*
     +    M2*(S+TG)**(-1) - 14*S**(-1)*UG**(-1)*M2*(S+TG-M2)**(-1) - 8*
     +    S**(-1)*UG**(-1)*M2*(TG-M2)*SYMBY + 16*S**(-1)*UG**(-1)*M2*
     +    S4G**(-1) - 16*S**(-1)*UG**(-1)*M2**2*MG2*(S+TG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) + 8*S**(-1)*UG**(-1)*M2**2*
     +    (S+TG)**(-1)*S4G**(-1) + 8*S**(-1)*UG**(-1)*M2**3*
     +    (S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 8*S**(-1)*UG**(-1)*MG2*
     +    (S+TG)**(-1) + 64*S**(-1)*UG**(-1)*MG2*S4G**(-1) + 16*S**(-1)
     +    *UG**(-1)*(S+TG)**(-1)*S4G - 16*S**(-1)*UG**(-1)*(S+UG)**(-1)
     +    *S4G + 4*S**(-1)*UG**(-1)*(S+TG-M2)**(-1)*S4G - 8*S**(-1)*
     +    UG**(-1)*(TG-M2)*SYMBY*S4G + 8*S**(-1)*UG**(-1)*
     +    (TG+UG-M2)**(-1)*S4G - 166*S**(-1)*UG**(-1) - 16*S**(-1)*
     +    T1**(-1)*M2*MG2*(S4-S)**(-1)*S4G**(-1) - 8*S**(-1)*T1**(-1)*
     +    M2*S4G**(-1) - 16*S**(-1)*T1**(-1)*M2**2*MG2*(S+TG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * ( 8*S**(-1)*T1**(-1)*
     +    M2**2*(S+UG)**(-1)*S4G**(-1) + 16*S**(-1)*T1**(-1)*M2**2*
     +    S4G**(-2) + 8*S**(-1)*T1**(-1)*M2**3*(S+TG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) - 16*S**(-1)*T1**(-1)*M2**3*
     +    (S+UG)**(-1)*S4G**(-2) + 8*S**(-1)*T1**(-1) - 8*S**(-1)*T1*M2
     +    *(S+TG)**(-2)*S4G**(-1) - 144*S**(-1)*T1*M2*(S+UG)**(-1)*
     +    S4G**(-2) + 16*S**(-1)*T1*MG2*(S+UG)**(-1)*S4G**(-2) - 8*
     +    S**(-1)*T1*(S+TG)**(-1)*S4G**(-1) + 32*S**(-1)*T1*
     +    (S+UG)**(-1)*S4G**(-1) - 4*S**(-1)*T1*(S+TG-M2)**(-1)*
     +    S4G**(-1) + 10*S**(-1)*T1*(TG-M2)*SYMBY*S4G**(-1) - 4*S**(-1)
     +    *T1*(TG+UG-M2)**(-1)*S4G**(-1) + 64*S**(-1)*T1*S4G**(-2) + 4*
     +    S**(-1)*T1**2*(S+TG)**(-2)*S4G**(-1) + 64*S**(-1)*T1**2*
     +    (S+UG)**(-1)*S4G**(-2) - 16*S**(-1)*M2*MG2*(S+UG)**(-1)*
     +    S4G**(-2) + 16*S**(-1)*M2*(S+TG)**(-1)*S4G**(-1) - 40*S**(-1)
     +    *M2*(S+UG)**(-1)*S4G**(-1) + 12*S**(-1)*M2*(S+TG-M2)**(-1)*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * (  - 16*S**(-1)*M2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 4*S**(-1)*M2*(TG+UG-M2)**(-1)*
     +    S4G**(-1) - 80*S**(-1)*M2*S4G**(-2) + 4*S**(-1)*M2**2*
     +    (S+TG)**(-2)*S4G**(-1) + 96*S**(-1)*M2**2*(S+UG)**(-1)*
     +    S4G**(-2) - 8*S**(-1)*MG2*(S+TG)**(-1)*S4G**(-1) + 8*S**(-1)*
     +    MG2*(S+UG)**(-1)*S4G**(-1) + 4*S**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) + 16*S**(-1)*MG2*S4G**(-2) - 16*S**(-1)*
     +    (S+TG)**(-1) + 16*S**(-1)*(S+UG)**(-1) - 10*S**(-1)*
     +    (S+TG-M2)**(-1) + 12*S**(-1)*(TG-M2)*SYMBY - 4*S**(-1)*
     +    (TG+UG-M2)**(-1) + 90*S**(-1)*S4G**(-1) - 64*S*TG**(-2)*
     +    UG**(-2)*MG2**2*S4G**(-1) + 256*S*TG**(-1)*UG**(-3)*MG2 - 128
     +    *S*TG**(-1)*UG**(-3)*MG2**2*S4G**(-1) - 4*S*TG**(-1)*UG**(-2)
     +    *M2*MG2*(S+TG-M2)**(-1)*S4G**(-1) - 132*S*TG**(-1)*UG**(-2)*
     +    MG2*S4G**(-1) + 4*S*TG**(-1)*UG**(-1)*MG2*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 32*S*TG**(-1)*UG**(-1)*S4G**(-1) - 128*S*UG**(-4)
     +    *MG2**2*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * (  - 128*S*UG**(-3)*MG2
     +    *S4G**(-1) + 4*S*UG**(-2)*MG2*(S+TG-M2)**(-1)*S4G**(-1) - 16*
     +    S*UG**(-2)*MG2*(TG-M2)*SYMBY*S4G**(-1) + 16*S*UG**(-2)*MG2*
     +    (TG+UG-M2)**(-1)*S4G**(-1) + 32*S*UG**(-2)*(S+UG)**(-1) + 16*
     +    S*UG**(-2)*S4G**(-1) - 4*S*UG**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 4*S*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 12*S*UG**(-1)*M2*(S+TG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) - 16*S*UG**(-1)*M2*(S+TG)**(-1)*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 8*S*UG**(-1)*M2*(S+UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 4*S*UG**(-1)*M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) - 8*S*UG**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-2)*
     +    S4G**(-1) + 4*S*UG**(-1)*MG2*(S+UG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) - 8*S*UG**(-1)*MG2*(S+UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) - 8*S*UG**(-1)*MG2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * ( 8*S*UG**(-1)*
     +    (S+TG)**(-1)*(S+TG-M2)**(-1) + 20*S*UG**(-1)*(S+TG)**(-1)*
     +    S4G**(-1) - 124*S*UG**(-1)*(S+UG)**(-1)*S4G**(-1) + 4*S*
     +    UG**(-1)*(S4-S)**(-1)*S4G**(-1) + 4*S*UG**(-1)*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY + 8*S*UG**(-1)*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 4*S*UG**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*S*
     +    UG**(-1)*(TG+UG-M2)**(-1)*S4G**(-1) - 32*S*UG**(-1)*S4G**(-2)
     +     + 12*S*T1**(-1)*M2*(S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 4*S
     +    *T1**(-1)*MG2*(S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 4*S*
     +    T1**(-1)*(S+TG)**(-1)*S4G**(-1) + 4*S*T1**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) - 4*S*T1*M2*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 8*
     +    S*T1*(S+TG)**(-2)*(S+TG-M2)**(-1)*S4G**(-1) - 4*S*T1*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*S*M2*
     +    (S+TG)**(-2)*(S+TG-M2)**(-1)*S4G**(-1) + 4*S*M2*
     +    (-M2*(S+UG)+TG*UG)**(-2) + 2*S*M2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (S+TG-M2)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * ( 12*S*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*S*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 4*S*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 8*S*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*S*
     +    (S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 32*S*(S+UG)**(-1)*
     +    S4G**(-2) + 4*S*(-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1) + 4*
     +    S*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 384*S**2*TG**(-2)*UG**(-4)*MG2**2
     +     + 256*S**2*TG**(-2)*UG**(-3)*MG2**2*S4G**(-1) + 128*S**2*
     +    TG**(-1)*UG**(-4)*MG2**2*S4G**(-1) - 128*S**2*TG**(-1)*
     +    UG**(-3)*MG2*S4G**(-1) + 4*S**2*TG**(-1)*UG**(-2)*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 32*S**2*TG**(-1)*UG**(-2)*
     +    S4G**(-1) - 16*S**2*UG**(-2)*(S+UG)**(-1)*S4G**(-1) - 4*S**2*
     +    UG**(-1)*(S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 32*S**2*
     +    UG**(-1)*(S+UG)**(-1)*S4G**(-2) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * (  - 4*S**2*T1**(-1)*
     +    (S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 256*S**3*TG**(-2)*
     +    UG**(-4)*MG2**2*S4G**(-1) - 4*TG**(-1)*UG**(-1)*M2*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 60*TG**(-1)*UG**(-1)*MG2*
     +    S4G**(-1) - 8*TG**(-1)*T1**(-1)*MG2*S4G**(-1) + 8*TG**(-1)*M2
     +    *(TG-M2)*SYMBY*S4G**(-1) + 8*TG**(-1)*MG2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 16*TG**(-1)*S4G**(-1) - 128*UG**(-4)*MG2**2 + 32*
     +    UG**(-2)*M2*MG2*(S+TG)**(-1)*(S+TG-M2)**(-1) + 32*UG**(-2)*M2
     +    *MG2*(S+TG)**(-1)*S4G**(-1) - 22*UG**(-2)*M2*MG2*
     +    (S+TG-M2)**(-1)*S4G**(-1) + 2*UG**(-2)*M2*(S+TG-M2)**(-1) - 
     +    64*UG**(-2)*MG2*(S+TG)**(-1) - 10*UG**(-2)*MG2*
     +    (S+TG-M2)**(-1) + 16*UG**(-2)*MG2*(TG-M2)*SYMBY - 16*UG**(-2)
     +    *MG2*(TG+UG-M2)**(-1) + 74*UG**(-2)*MG2*S4G**(-1) - 64*
     +    UG**(-2)*MG2**2*(S+TG)**(-1)*S4G**(-1) - 16*UG**(-2)*
     +    (S+UG)**(-1)*S4G - 2*UG**(-2)*(S+TG-M2)**(-1)*S4G - 126*
     +    UG**(-2) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * ( 16*UG**(-1)*M2*MG2*
     +    (S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 34*UG**(-1)*M2*MG2*
     +    (S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 8*UG**(-1)*M2*MG2*
     +    (S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*UG**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 8*UG**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*UG**(-1)*M2*MG2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 22*UG**(-1)*M2*
     +    (S+TG)**(-1)*(S+TG-M2)**(-1) + 24*UG**(-1)*M2*(S+TG)**(-1)*
     +    S4G**(-1) + 8*UG**(-1)*M2*(S+UG)**(-1)*(S+TG-M2)**(-1) + 8*
     +    UG**(-1)*M2*(S+UG)**(-1)*(TG-M2)*SYMBY - 24*UG**(-1)*M2*
     +    (S+UG)**(-1)*S4G**(-1) - 8*UG**(-1)*M2*(S4-S)**(-1)*S4G**(-1)
     +     - 8*UG**(-1)*M2*(S+TG-M2)**(-1)*(TG-M2)*SYMBY + 4*UG**(-1)*
     +    M2*(S+TG-M2)**(-1)*S4G**(-1) + 8*UG**(-1)*M2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 8*UG**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 16*UG**(-1)*M2**2*(S+TG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * ( 8*UG**(-1)*M2**2*
     +    (S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 8*UG**(-1)*M2**2*
     +    (S+UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 8*UG**(-1)*M2**2*
     +    (S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 24*UG**(-1)*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*UG**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 8*
     +    UG**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) + 10*UG**(-1)*MG2*(S+TG)**(-1)*(S+TG-M2)**(-1) - 2*
     +    UG**(-1)*MG2*(S+TG)**(-1)*S4G**(-1) + 8*UG**(-1)*MG2*
     +    (S+UG)**(-1)*(TG-M2)*SYMBY - 4*UG**(-1)*MG2*(S4-S)**(-1)*
     +    S4G**(-1) - 2*UG**(-1)*MG2*(S+TG-M2)**(-1)*S4G**(-1) + 28*
     +    UG**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 6*UG**(-1)*
     +    (S+TG)**(-1)*(S+TG-M2)**(-1)*S4G - 42*UG**(-1)*(S+TG)**(-1)
     +     + 112*UG**(-1)*(S+UG)**(-1) - 10*UG**(-1)*(S+TG-M2)**(-1) - 
     +    8*UG**(-1)*(TG+UG-M2)**(-1) + 172*UG**(-1)*S4G**(-1) + 4*
     +    T1**(-2)*M2*(S+UG)**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * (  - 4*T1**(-2)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) + 8*T1**(-2)*M2**3*(S+UG)**(-2)*
     +    S4G**(-1) + 16*T1**(-1)*M2*MG2*(S+TG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) + 16*T1**(-1)*M2*MG2*(S+UG)**(-2)*S4G**(-1) - 8*
     +    T1**(-1)*M2*MG2*(S+UG)**(-1)*S4G**(-2) + 4*T1**(-1)*M2*
     +    (S+TG)**(-1)*S4G**(-1) + 8*T1**(-1)*M2*(S+UG)**(-1)*S4G**(-1)
     +     - 8*T1**(-1)*M2*(S4-S)**(-1)*S4G**(-1) - 16*T1**(-1)*M2**2*
     +    (S+TG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 24*T1**(-1)*M2**2*
     +    (S+UG)**(-2)*S4G**(-1) + 8*T1**(-1)*M2**2*(S+UG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) - 20*T1**(-1)*MG2*(S+UG)**(-1)*
     +    S4G**(-1) - 4*T1**(-1)*MG2*(S4-S)**(-1)*S4G**(-1) + 8*
     +    T1**(-1)*MG2*S4G**(-2) - 4*T1**(-1)*(S+UG)**(-1) + 4*T1**(-1)
     +    *S4G**(-1) + 32*T1*M2*(S+TG)**(-2)*(S+TG-M2)**(-1)*S4G**(-1)
     +     + 8*T1*M2*(-M2*(S+UG)+TG*UG)**(-2) + 2*T1*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 22*T1*M2
     +    *(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * ( 16*T1*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 12*T1*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*T1*
     +    (S+TG)**(-2)*S4G**(-1) + 8*T1*(S+TG)**(-1)*(S+TG-M2)**(-1)*
     +    S4G**(-1) - 16*T1*(S+UG)**(-2)*S4G**(-1) - 24*T1*(S+UG)**(-1)
     +    *S4G**(-2) + 4*T1*(-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1) + 
     +    4*T1*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 4*T1*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*T1**2*M2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 8*T1**2*(S+TG)**(-2)*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 4*T1**2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 32*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*M2*(S+TG)**(-2)*S4G**(-1) - 32*M2
     +    *(S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) + 32*M2*(S+UG)**(-2)*
     +    S4G**(-1) - 8*M2*(S+UG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 8*
     +    M2*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 24*M2*(S+UG)**(-1)*
     +    S4G**(-2) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * (  - 4*M2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G - 12*M2*(-M2*(S+UG)+TG*UG)**(-1)
     +    *(S+TG-M2)**(-1) - 12*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*
     +    SYMBY - 20*M2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*M2*
     +    (S+TG-M2)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 24*M2**2*
     +    (S+TG)**(-2)*(S+TG-M2)**(-1)*S4G**(-1) - 16*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-2) - 12*M2**2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (S+TG-M2)**(-1)*S4G**(-1) - 32*M2**2*(-M2*(S+UG)+TG*UG)**(-1)
     +    *(TG-M2)*SYMBY*S4G**(-1) - 20*M2**3*(-M2*(S+UG)+TG*UG)**(-2)*
     +    S4G**(-1) - 10*MG2*(S+TG)**(-1)*(S+TG-M2)**(-1)*S4G**(-1) - 
     +    16*MG2*(S+UG)**(-2)*S4G**(-1) - 8*MG2*(S+UG)**(-1)*(TG-M2)*
     +    SYMBY*S4G**(-1) + 8*MG2*(S+UG)**(-1)*S4G**(-2) + 4*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*MG2*(S+TG-M2)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) + 6*(S+TG)**(-1)*(S+TG-M2)**(-1) + 16
     +    *(S+TG)**(-1)*S4G**(-1) - 96*(S+UG)**(-1)*S4G**(-1) - 4*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S+TG-M2)**(-1)*S4G )
     +
      M2GBH = M2GBH + COLO1(9)*N*CO*(S4G+MG2) * (  - 4*
     +    (-M2*(S+UG)+TG*UG)**(-1) + 4*(TG-M2)*SYMBY*S4G**(-1) - 4*
     +    (TG+UG-M2)**(-1)*S4G**(-1) - 24*S4G**(-2) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2)*SYMBU * (  - 4 - 8*
     +    S**(-1)*UG**(-1)*M2**2 + 8*S**(-1)*UG**(-1)*M2**3*S4G**(-1)
     +     - 4*S**(-1)*T1*M2*S4G**(-1) - 4*S**(-1)*T1 + 4*S**(-1)*T1**2
     +    *S4G**(-1) + 8*S**(-1)*M2*MG2*S4G**(-1) + 8*S**(-1)*M2 - 8*
     +    S**(-1)*MG2 + 4*S*UG**(-1)*M2*MG2*(S4-S)**(-1)*S4G**(-1) - 4*
     +    S*UG**(-1)*M2*MG2*(TG-M2)*SYMBY*S4G**(-1) + 8*S*UG**(-1)*M2*
     +    (S+UG)**(-1) + 8*S*UG**(-1)*M2*S4G**(-1) + 8*S*UG**(-1)*M2**2
     +    *(S+UG)**(-1)*S4G**(-1) + 4*S*UG**(-1) - 4*S*T1**(-1)*M2*MG2*
     +    (S+UG)**(-1)*S4G**(-1) + 4*S*T1**(-1)*M2*MG2*(S4-S)**(-1)*
     +    S4G**(-1) + 4*S*T1**(-1)*MG2*S4G**(-1) - 8*S*T1*M2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G**(-1) - 4*S*T1*MG2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G**(-1) - 4*S*T1*(TG+UG-M2)**(-1)*
     +    S4G**(-1) + 4*S*M2*MG2*(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*
     +    S4G**(-1) - 8*S*M2*(S+UG)**(-1)*S4G**(-1) + 4*S*M2*
     +    (TG+UG-M2)**(-1)*S4G**(-1) + 8*S*M2**2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2)*SYMBU * ( 4*S*MG2*
     +    (S+UG)**(-1)*S4G**(-1) - 8*S**2*UG**(-1)*M2*(S+UG)**(-1)*
     +    S4G**(-1) - 4*S**2*UG**(-1)*(S+UG)**(-1) - 4*S**2*UG**(-1)*
     +    S4G**(-1) + 4*S**2*(S+UG)**(-1)*S4G**(-1) + 4*S**3*UG**(-1)*
     +    (S+UG)**(-1)*S4G**(-1) + 16*UG**(-2)*M2**3*S4G**(-1) + 8*
     +    UG**(-1)*M2*MG2*(TG-M2)*SYMBY + 8*UG**(-1)*M2*MG2*S4G**(-1)
     +     - 8*UG**(-1)*M2 - 16*UG**(-1)*M2**2*MG2*(S4-S)**(-1)*
     +    S4G**(-1) - 8*UG**(-1)*M2**2*MG2*(TG-M2)*SYMBY*S4G**(-1) - 8*
     +    UG**(-1)*M2**2*(S+UG)**(-1) - 24*UG**(-1)*M2**2*S4G**(-1) - 8
     +    *UG**(-1)*M2**3*(TG-M2)*SYMBY*S4G**(-1) + 24*T1**(-1)*M2*MG2*
     +    S4G**(-1) - 16*T1**(-1)*M2**2*MG2*(S+UG)**(-1)*S4G**(-1) - 16
     +    *T1**(-1)*M2**2*MG2*(S4-S)**(-1)*S4G**(-1) - 8*T1**(-1)*MG2
     +     + 16*T1*M2*(S+UG)**(-1)*S4G**(-1) + 8*T1*M2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY - 8*T1*M2*(TG-M2)*SYMBY*S4G**(-1) - 8*
     +    T1*M2*(TG+UG-M2)**(-1)*S4G**(-1) - 8*T1*MG2*(S+UG)**(-1)*
     +    S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2)*SYMBU * (  - 4*T1*MG2*
     +    (TG-M2)*SYMBY*S4G**(-1) + 4*T1*(TG+UG-M2)**(-1) - 4*T1*
     +    S4G**(-1) + 4*T1**2*(TG+UG-M2)**(-1)*S4G**(-1) + 24*M2*MG2*
     +    (S+UG)**(-1)*S4G**(-1) - 4*M2*(TG+UG-M2)**(-1) + 24*M2*
     +    S4G**(-1) - 8*M2**2*(S+UG)**(-1)*S4G**(-1) - 8*M2**2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY + 8*M2**2*(TG-M2)*SYMBY*S4G**(-1) + 4*
     +    M2**2*(TG+UG-M2)**(-1)*S4G**(-1) - 8*MG2*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * (  - 32*S**(-2)*
     +    TG**(-1)*T1*M2*S4G**(-1) - 32*S**(-2)*TG**(-1)*T1 + 16*
     +    S**(-2)*TG**(-1)*T1**2*S4G**(-1) + 32*S**(-2)*TG**(-1)*M2 + 
     +    16*S**(-2)*TG**(-1)*M2**2*S4G**(-1) + 16*S**(-2)*TG**(-1)*S4G
     +     + 32*S**(-2) + 16*S**(-1)*TG**(-2)*T1*MG2*S4G**(-1) - 16*
     +    S**(-1)*TG**(-2)*M2*MG2*S4G**(-1) - 16*S**(-1)*TG**(-2)*MG2
     +     - 8*S**(-1)*TG**(-1)*T1*M2*(TG-M2)*SYMBY*S4G**(-1) + 8*
     +    S**(-1)*TG**(-1)*T1*S4G**(-1) + 8*S**(-1)*TG**(-1)*M2*(TG-M2)
     +    *SYMBY - 8*S**(-1)*TG**(-1)*M2*S4G**(-1) + 8*S**(-1)*TG**(-1)
     +    *M2**2*(TG-M2)*SYMBY*S4G**(-1) - 32*S**(-1)*TG**(-1)*MG2*
     +    S4G**(-1) - 8*S**(-1)*TG**(-1) + 8*S**(-1)*UG**(-1)*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1) - 8*S**(-1)*UG**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S**(-1)*T1**(-1)*M2*
     +    MG2*(S+UG)**(-2) - 8*S**(-1)*T1**(-1)*M2*MG2*(S+UG)**(-1)*
     +    S4G**(-1) + 4*S**(-1)*T1**(-1)*M2*(S+UG)**(-2)*S4G - 4*
     +    S**(-1)*T1**(-1)*M2*(S+UG)**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * ( 4*S**(-1)*T1**(-1)*M2
     +    *S4G**(-1) + 8*S**(-1)*T1**(-1)*M2**2*MG2*(S+UG)**(-2)*
     +    S4G**(-1) + 4*S**(-1)*T1**(-1)*M2**3*(S+UG)**(-2)*S4G**(-1)
     +     - 4*S**(-1)*T1**(-1)*(S+UG)**(-1)*S4G - 4*S**(-1)*T1**(-1)
     +     + 32*S**(-1)*T1*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*
     +    SYMBY*S4G**(-1) - 8*S**(-1)*T1*M2*(S+UG)**(-2)*S4G**(-1) + 20
     +    *S**(-1)*T1*M2*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 32*
     +    S**(-1)*T1*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 20*
     +    S**(-1)*T1*M2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 52*S**(-1)
     +    *T1*M2**2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 
     +    8*S**(-1)*T1*MG2*(S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 4*
     +    S**(-1)*T1*(S+UG)**(-2) + 4*S**(-1)*T1*(S+UG)**(-1)*(TG-M2)*
     +    SYMBY + 4*S**(-1)*T1*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G + 4*S**(-1)*T1*(-M2*(S+UG)+TG*UG)**(-1) + 4*S**(-1)*T1*
     +    (TG+UG-M2)**(-1)*S4G**(-1) - 24*S**(-1)*T1**2*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * (  - 8*S**(-1)*T1**2*
     +    MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*
     +    S**(-1)*T1**2*(S+UG)**(-2)*S4G**(-1) - 4*S**(-1)*T1**2*
     +    (S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*S**(-1)*T1**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY - 4*S**(-1)*T1**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S**(-1)*T1**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*S**(-1)*
     +    M2*MG2*(S+UG)**(-2)*S4G**(-1) - 16*S**(-1)*M2*MG2*
     +    (S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 4*S**(-1)*M2*
     +    (S+UG)**(-2) - 8*S**(-1)*M2*(S+UG)**(-1)*(TG-M2)*SYMBY - 4*
     +    S**(-1)*M2*(S+UG)**(-1)*S4G**(-1) - 8*S**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G - 8*S**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1) + 8*S**(-1)*M2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY + 4*S**(-1)*M2*(TG-M2)*SYMBY*S4G**(-1)
     +     - 4*S**(-1)*M2*(TG+UG-M2)**(-1)*S4G**(-1) - 32*S**(-1)*M2**2
     +    *MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * (  - 24*S**(-1)*M2**2*
     +    (S+UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 32*S**(-1)*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY - 32*S**(-1)*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 40*S**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 8*S**(-1)*
     +    MG2*(S+UG)**(-2) - 16*S**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) - 4*
     +    S**(-1)*(S+UG)**(-2)*S4G - 12*S**(-1)*(S+UG)**(-1) - 4*
     +    S**(-1)*(TG-M2)*SYMBY + 4*S**(-1)*(TG+UG-M2)**(-1) - 12*
     +    S**(-1)*S4G**(-1) - 8*S*UG**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 4*S*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) - 8*S*UG**(-1)*M2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1) - 8*S*UG**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*S*UG**(-1)*M2**2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 24*S*
     +    UG**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * (  - 4*S*UG**(-1)*MG2*
     +    (S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 4*S*UG**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1) + 4*S*T1**(-1)*M2*MG2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*S*T1**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 4*S*
     +    T1**(-1)*MG2*(S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 16*S*
     +    T1**(-1)*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 12*S*T1*M2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 4*S*T1*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 8*S*M2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 12*S*M2*
     +    (-M2*(S+UG)+TG*UG)**(-2) - 12*S*M2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY*S4G**(-1) - 12*S*M2**2*(-M2*(S+UG)+TG*UG)**(-2)
     +    *S4G**(-1) - 4*S*MG2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 8*S*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*
     +    S4G**(-1) - 8*S*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S**2*
     +    UG**(-1)*M2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * ( 4*S**2*UG**(-1)*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1) + 4*S**2*UG**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S**3*UG**(-1)*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*TG**(-1)*
     +    T1**(-1)*MG2*S4G**(-1) - 8*TG**(-1)*M2*(TG-M2)*SYMBY*
     +    S4G**(-1) - 8*TG**(-1)*MG2*(TG-M2)*SYMBY*S4G**(-1) - 16*
     +    UG**(-2)*M2**3*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*
     +    UG**(-1)*M2*MG2*(S+UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 8*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY - 24*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 16*
     +    UG**(-1)*M2*(S+UG)**(-1)*S4G**(-1) + 8*UG**(-1)*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1) + 32*UG**(-1)*M2**2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*S4G**(-1) + 8*UG**(-1)*
     +    M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 
     +    8*UG**(-1)*M2**2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * ( 48*UG**(-1)*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*UG**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 16*
     +    UG**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) - 12*T1**(-2)*M2*
     +    (S+UG)**(-1) + 12*T1**(-2)*M2**2*(S+UG)**(-1)*S4G**(-1) - 8*
     +    T1**(-2)*M2**3*(S+UG)**(-2)*S4G**(-1) - 32*T1**(-1)*M2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) + 16*T1**(-1)*M2*MG2*(S+UG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) + 32*T1**(-1)*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*T1**(-1)*M2*
     +    (S+UG)**(-2) - 16*T1**(-1)*M2*(S+UG)**(-1)*S4G**(-1) - 16*
     +    T1**(-1)*M2**2*MG2*(S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) + 32*T1**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) + 32*T1**(-1)*M2**2*(S+UG)**(-2)*
     +    S4G**(-1) + 36*T1**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) + 12*
     +    T1**(-1)*(S+UG)**(-1) - 24*T1*M2*(-M2*(S+UG)+TG*UG)**(-2) - 
     +    36*T1*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * (  - 48*T1*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 8*T1*MG2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 12*T1*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 32*T1*
     +    (S+UG)**(-2)*S4G**(-1) - 8*T1*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (TG-M2)*SYMBY - 12*T1*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 12
     +    *T1**2*M2*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 8*T1**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 24*M2*MG2*
     +    (S+UG)**(-1)*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 32*M2*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) - 56*M2*
     +    (S+UG)**(-2)*S4G**(-1) + 12*M2*(-M2*(S+UG)+TG*UG)**(-2)*S4G
     +     + 20*M2*(-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY + 48*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*M2*(TG-M2)*
     +    (TG+UG-M2)**(-1)*SYMBY*S4G**(-1) - 8*M2**2*(S+UG)**(-1)*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 48*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-2) )
     +
      M2GBH = M2GBH + COLO1(9)*N*CK*(S4G+MG2) * ( 44*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*(TG-M2)*SYMBY*S4G**(-1) + 60*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 32*MG2*(S+UG)**(-2)*
     +    S4G**(-1) - 16*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*MG2
     +    *(TG-M2)*(TG+UG-M2)**(-1)*SYMBY*S4G**(-1) + 8*(S+UG)**(-2) + 
     +    28*(S+UG)**(-1)*S4G**(-1) + 12*(-M2*(S+UG)+TG*UG)**(-1) + 4*
     +    (TG-M2)*SYMBY*S4G**(-1) - 4*(TG+UG-M2)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*CQED*(S4G+MG2)*SYMBU * (  - 4 + 8*
     +    S**(-1)*UG**(-1)*M2**2 - 8*S**(-1)*UG**(-1)*M2**3*S4G**(-1)
     +     - 16*S**(-1)*T1**(-1)*M2*MG2 + 8*S**(-1)*T1**(-1)*M2**2*MG2*
     +    S4G**(-1) + 8*S**(-1)*T1**(-1)*MG2*S4G + 4*S**(-1)*T1*M2*
     +    S4G**(-1) - 4*S**(-1)*T1 - 8*S**(-1)*M2 + 4*S**(-1)*M2**2*
     +    S4G**(-1) + 4*S**(-1)*S4G - 4*S*UG**(-1)*M2*MG2*(S4-S)**(-1)*
     +    S4G**(-1) - 4*S*T1**(-1)*M2*MG2*(S4-S)**(-1)*S4G**(-1) - 8*
     +    UG**(-2)*M2**3*S4G**(-1) - 8*UG**(-1)*M2*MG2*S4G**(-1) + 16*
     +    UG**(-1)*M2**2*MG2*(S4-S)**(-1)*S4G**(-1) + 8*UG**(-1)*M2**2*
     +    S4G**(-1) - 4*T1**(-1)*M2*MG2*S4G**(-1) + 16*T1**(-1)*M2**2*
     +    MG2*(S4-S)**(-1)*S4G**(-1) - 4*T1**(-1)*MG2 )
     +
      M2GBH = M2GBH + COLO1(9)*CQED*(S4G+MG2) * (  - 8*S**(-1)*UG**(-1)
     +    *M2**2*(-M2*(S+UG)+TG*UG)**(-1) + 8*S**(-1)*UG**(-1)*M2**3*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 8*S**(-1)*T1**(-1)*M2*
     +    MG2*(S+UG)**(-2) + 16*S**(-1)*T1**(-1)*M2*MG2*(S+UG)**(-1)*
     +    S4G**(-1) - 4*S**(-1)*T1**(-1)*M2*(S+UG)**(-2)*S4G + 4*
     +    S**(-1)*T1**(-1)*M2*(S+UG)**(-1) - 8*S**(-1)*T1**(-1)*M2**2*
     +    MG2*(S+UG)**(-2)*S4G**(-1) - 4*S**(-1)*T1**(-1)*M2**2*
     +    (S+UG)**(-1)*S4G**(-1) - 4*S**(-1)*T1**(-1)*M2**3*
     +    (S+UG)**(-2)*S4G**(-1) - 8*S**(-1)*T1**(-1)*MG2*(S+UG)**(-1)
     +     + 8*S**(-1)*T1*M2*(S+UG)**(-2)*S4G**(-1) - 20*S**(-1)*T1*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*S**(-1)*T1*
     +    (S+UG)**(-2) - 8*S**(-1)*T1*(S+UG)**(-1)*S4G**(-1) - 4*
     +    S**(-1)*T1*(-M2*(S+UG)+TG*UG)**(-1) - 4*S**(-1)*T1**2*
     +    (S+UG)**(-2)*S4G**(-1) + 4*S**(-1)*T1**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S**(-1)*M2*MG2*
     +    (S+UG)**(-2)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*CQED*(S4G+MG2) * (  - 4*S**(-1)*M2*
     +    (S+UG)**(-2) + 28*S**(-1)*M2*(S+UG)**(-1)*S4G**(-1) + 8*
     +    S**(-1)*M2*(-M2*(S+UG)+TG*UG)**(-1) + 32*S**(-1)*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*S**(-1)*MG2*
     +    (S+UG)**(-2) - 8*S**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) + 4*
     +    S**(-1)*(S+UG)**(-2)*S4G - 4*S**(-1)*(S+UG)**(-1) + 4*S*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*
     +    S4G**(-1) - 8*S*UG**(-1)*M2**3*(-M2*(S+UG)+TG*UG)**(-2)*
     +    S4G**(-1) + 4*S*T1**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) + 8*S*T1**(-1)*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*S*T1*M2*
     +    (-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 4*S*M2*
     +    (-M2*(S+UG)+TG*UG)**(-2) + 4*S*M2**2*(-M2*(S+UG)+TG*UG)**(-2)
     +    *S4G**(-1) + 4*S*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*
     +    UG**(-2)*M2**3*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 8*
     +    UG**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) )
     +
      M2GBH = M2GBH + COLO1(9)*CQED*(S4G+MG2) * (  - 16*UG**(-1)*M2**2*
     +    MG2*(-M2*(S+UG)+TG*UG)**(-1)*(S4-S)**(-1)*S4G**(-1) - 8*
     +    UG**(-1)*M2**2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*
     +    T1**(-2)*M2*(S+UG)**(-1) - 4*T1**(-2)*M2**2*(S+UG)**(-1)*
     +    S4G**(-1) + 8*T1**(-1)*M2*MG2*(S+UG)**(-2)*S4G**(-1) - 16*
     +    T1**(-1)*M2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) + 4*
     +    T1**(-1)*M2*(S+UG)**(-2) + 4*T1**(-1)*M2*(S+UG)**(-1)*
     +    S4G**(-1) - 16*T1**(-1)*M2**2*MG2*(-M2*(S+UG)+TG*UG)**(-1)*
     +    (S4-S)**(-1)*S4G**(-1) - 4*T1**(-1)*M2**2*(S+UG)**(-2)*
     +    S4G**(-1) - 12*T1**(-1)*MG2*(S+UG)**(-1)*S4G**(-1) - 4*
     +    T1**(-1)*(S+UG)**(-1) + 8*T1*M2*(-M2*(S+UG)+TG*UG)**(-2) + 16
     +    *T1*M2**2*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) - 8*T1*
     +    (S+UG)**(-2)*S4G**(-1) + 8*T1*(-M2*(S+UG)+TG*UG)**(-1)*
     +    S4G**(-1) - 4*T1**2*M2*(-M2*(S+UG)+TG*UG)**(-2)*S4G**(-1) + 
     +    12*M2*(S+UG)**(-2)*S4G**(-1) - 4*M2*(-M2*(S+UG)+TG*UG)**(-2)*
     +    S4G )
     +
      M2GBH = M2GBH + COLO1(9)*CQED*(S4G+MG2) * (  - 24*M2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 16*M2**2*
     +    (-M2*(S+UG)+TG*UG)**(-2) - 20*M2**3*(-M2*(S+UG)+TG*UG)**(-2)*
     +    S4G**(-1) - 8*MG2*(S+UG)**(-2)*S4G**(-1) + 8*MG2*
     +    (-M2*(S+UG)+TG*UG)**(-1)*S4G**(-1) - 4*(S+UG)**(-2) - 8*
     +    (S+UG)**(-1)*S4G**(-1) - 4*(-M2*(S+UG)+TG*UG)**(-1) )

      DGGGBH = S4G/(S4G+MG2)/2.D0 *
     +     0.5D0*ALPHAS**3 * AVG * M2GBH /4.D0 /S**2 *CONV
      RETURN
      END


      REAL*8 FUNCTION DGGGBS(ALPHAS,S,TG,S4G,MS,MG,EPS)
C***  DOUBLE-POLE PART OF CROSS SECTIONS FOR G +QB -> GL + GL +QB
C***  THE 1/S4**2 PART
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4G,T1,TG,U1,UG,MS,MG,MS2,MG2,M2,EPS
      REAL*8 NS,CONV,N,CO,CK,CQED,AVG,M2GBS

      CONV = 389379660.D0
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      CQED = (N**4 -1.D0)/N**2
      NS = 6.D0
      AVG = (1.D0/2.D0)**2 /N/(N**2 -1.D0)

      MS2 = MS**2
      MG2 = MG**2
      M2 = MG2 -MS2
      UG = S4G -S -TG
      T1 = TG +M2
      U1 = UG +M2

      M2GBS = 0.D0
      M2GBS = M2GBS + N*CO * (  - 16*S**(-1)*UG**(-1)*M2**2*MG2 + 16*
     +    S**(-1)*UG**(-1)*M2**3 - 16*S**(-1)*T1**(-1)*M2**2*MG2 + 8*
     +    S**(-1)*T1**(-1)*M2**3 - 4*S**(-1)*T1*M2 + 8*S**(-1)*M2**2 + 
     +    8*S*UG**(-1)*M2 + 16*UG**(-2)*M2**2*MG2 + 16*UG**(-1)*M2**2
     +     + 8*T1**(-2)*M2**2*MG2 - 8*T1**(-2)*M2**3 + 8*T1**(-1)*M2**2
     +     + 4*M2 )
     +
      M2GBS = M2GBS + N*CK * ( 16*S**(-1)*UG**(-1)*M2**2*MG2 - 16*
     +    S**(-1)*UG**(-1)*M2**3 + 16*S**(-1)*T1**(-1)*M2**2*MG2 + 8*
     +    S**(-1)*T1**(-1)*M2**3 + 12*S**(-1)*T1*M2 - 24*S**(-1)*M2**2
     +     - 8*S*UG**(-1)*M2 - 16*UG**(-2)*M2**2*MG2 - 16*UG**(-1)*
     +    M2**2 - 24*T1**(-2)*M2**2*MG2 + 24*T1**(-2)*M2**3 - 24*
     +    T1**(-1)*M2**2 + 4*M2 )
     +
      M2GBS = M2GBS + CQED * (  - 8*S**(-1)*T1**(-1)*M2**3 - 4*S**(-1)*
     +    T1*M2 + 8*S**(-1)*M2**2 + 8*T1**(-2)*M2**2*MG2 - 8*T1**(-2)*
     +    M2**3 + 8*T1**(-1)*M2**2 - 4*M2 )


      DGGGBS = 
     +     0.5D0*ALPHAS**3 *AVG *M2GBS *S4G/(S4G +MG2)/8.D0/S**2 *CONV
      RETURN
      END





      REAL*8 FUNCTION DGGGBT(ALPHAS,S,TG,S4G,S3,MS,MG,EPS)
C***  DOUBLE-POLE PART OF CROSS SECTIONS FOR G +QB -> GL + GL +QB
C***  THE 1/S3**2 PART
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4G,S3,T1,TG,U1,UG,MS,MG,MS2,MG2,M2,EPS
      REAL*8 M2GBT, NS,CONV,N,CO,CK,CQED,AVG
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 ANGS3(1:13),XX(5:9),YY2(5:9),XPHI

      CONV = 389379660.D0
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      CQED = (N**4 -1.D0)/N**2
      NS = 6.D0
      AVG = (1.D0/2.D0)**2 /N/(N**2 -1.D0)

      MS2 = MS**2
      MG2 = MG**2
      M2 = MG2 -MS2
      UG = S4G -S -TG
      T1 = TG +M2
      U1 = UG +M2

      ANGDEF(1) = 2.D0*SQRT(S4G +MG2)
      ANGDEF(2) = (S +UG)/ANGDEF(1)
      ANGDEF(3) = (S +TG)/ANGDEF(1)
      ANGDEF(4) = S4G/ANGDEF(1)
      ANGDEF(5) = (S4G +2.D0*MG2)/ANGDEF(1)
      ANGDEF(6) = -(TG +UG +2.D0*MG2)/ANGDEF(1)
      ANGDEF(7) = SQRT((TG +UG)**2 -4.D0*MG2*S)/ANGDEF(1)
      ANGDEF(8) = 
     +  (TG*S4G -S*(UG+2.D0*MG2))/(S+TG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     +  (UG*S4G -S*(TG+2.D0*MG2))/(S+UG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)
      ANA(2,7) = +ANA(2,1) +M2
      ANB(2,7) = +ANB(2,1)
      ANC(2,7) = +ANC(2,1)
      ANA(2,8) = +ANA(2,5) +M2
      ANB(2,8) = +ANB(2,5)
      ANC(2,8) = +ANC(2,5)
      ANA(2,9) = +ANA(2,6) +M2
      ANB(2,9) = +ANB(2,6)
      ANC(2,9) = +ANC(2,6)


      XPHI = (S3 -ANA(2,7))/ANB(2,7)

      XX(5) = (ANA(2,5) + ANB(2,5)*XPHI)
      YY2(5)= ANC(2,5)**2 * (1.D0-XPHI**2)
      XX(6) = (ANA(2,6) + ANB(2,6)*XPHI)
      YY2(6)= ANC(2,6)**2 * (1.D0-XPHI**2)
      XX(8) = (ANA(2,8) + ANB(2,8)*XPHI)
      YY2(8)= ANC(2,8)**2 * (1.D0-XPHI**2)
      XX(9) = (ANA(2,9) + ANB(2,9)*XPHI)
      YY2(9)= ANC(2,9)**2 * (1.D0-XPHI**2)

      ANGS3(1) = -XX(8)/(XX(8)**2 - YY2(8))**(1.5D0)
      ANGS3(2) = -1.D0/SQRT(XX(8)**2 - YY2(8))
      ANGS3(3) = -XX(6)/(XX(6)**2 - YY2(6))**(1.5D0)
      ANGS3(4) = -1.D0/SQRT(XX(6)**2 - YY2(6))
C$$$      ANGS3(5) = XX(6)
C$$$      ANGS3(6) = XX(9)
C$$$      ANGS3(7) = -XX(5)/(XX(5)**2 - YY2(5))**(1.5D0)
      ANGS3(8) = -1.D0/SQRT(XX(5)**2 - YY2(5))
C$$$      ANGS3(9) = -XX(9)/(XX(9)**2 - YY2(9))**(1.5D0)
C$$$      ANGS3(10)= -1.D0/SQRT(XX(9)**2 - YY2(9))
      ANGS3(11)= XX(5)
C$$$      ANGS3(12)= XX(5)**2 +0.5D0*YY2(5)
C$$$      ANGS3(13)= XX(6)**2 +0.5D0*YY2(6)

      M2GBT = 0D0
      M2GBT = M2GBT + N*CO * ( 2*S**(-1)*M2**2 + 2*M2 )
     +
      M2GBT = M2GBT + N*CK * (  - 6*S**(-1)*M2**2 + 2*M2 )
     +
      M2GBT = M2GBT + CQED * ( 2*S**(-1)*M2**2 - 2*M2 )
     +
      M2GBT = M2GBT + ANGS3(1)*N*CO * ( 4*M2**2*MG2 - 4*M2**3 )
     +
      M2GBT = M2GBT + ANGS3(1)*N*CK * (  - 12*M2**2*MG2 + 12*M2**3 )
     +
      M2GBT = M2GBT + ANGS3(1)*CQED * ( 4*M2**2*MG2 - 4*M2**3 )
     +
      M2GBT = M2GBT + ANGS3(2)*N*CO * (  - 8*S**(-1)*M2**2*MG2 + 4*
     +    S**(-1)*M2**3 + 4*M2**2 )
     +
      M2GBT = M2GBT + ANGS3(2)*N*CK * ( 8*S**(-1)*M2**2*MG2 + 4*S**(-1)
     +    *M2**3 - 12*M2**2 )
     +
      M2GBT = M2GBT + ANGS3(2)*CQED * (  - 4*S**(-1)*M2**3 + 4*M2**2 )
     +
      M2GBT = M2GBT + ANGS3(3)*N*CO * ( 8*M2**2*MG2 )
     +
      M2GBT = M2GBT + ANGS3(3)*N*CK * (  - 8*M2**2*MG2 )
     +
      M2GBT = M2GBT + ANGS3(4)*N*CO * (  - 8*S**(-1)*M2**2*MG2 + 8*
     +    S**(-1)*M2**3 + 4*S*M2 + 8*M2**2 )
     +
      M2GBT = M2GBT + ANGS3(4)*N*CK * ( 8*S**(-1)*M2**2*MG2 - 8*S**(-1)
     +    *M2**3 - 4*S*M2 - 8*M2**2 )
     +
      M2GBT = M2GBT + ANGS3(11)*N*CO * (  - 2*S**(-1)*M2 )
     +
      M2GBT = M2GBT + ANGS3(11)*N*CK * ( 6*S**(-1)*M2 )
     +
      M2GBT = M2GBT + ANGS3(11)*CQED * (  - 2*S**(-1)*M2 )

      DGGGBT = 
     +     0.5D0*ALPHAS**3 *AVG *M2GBT *S4G/(S4G +MG2)/8.D0/S**2 *CONV
      RETURN
      END



      REAL*8 FUNCTION DGGGBU(ALPHAS,S,TG,S4G,MS,MG,EPS)
C***  DOUBLE-POLE PART OF CROSS SECTIONS FOR G +QB -> GL + GL +QB
C***  THE 1/S3/S4 PART
      IMPLICIT NONE
      REAL*8 ALPHAS,S,S4G,T1,TG,U1,UG,MS,MG,MS2,MG2,M2,EPS
      REAL*8 ANGDEF(1:11), ANA(1:3,1:9), ANB(1:3,1:9), ANC(1:3,1:9)
      REAL*8 M2GBU, NS,CONV,N,CO,CK,CQED,AVG
      REAL*8 K4M1P1, K4P1P0, K4P1P1
      REAL*8 CANG4(1:5),KPI

      CONV = 389379660.D0
      N = 3.D0
      CO = N*(N**2 -1.D0)
      CK = (N**2 -1.D0)/N
      CQED = (N**4 -1.D0)/N**2
      NS = 6.D0
      AVG = (1.D0/2.D0)**2 /N/(N**2 -1.D0)

      KPI = - 4.D0*ATAN(1.D0)
      MS2 = MS**2
      MG2 = MG**2
      M2 = MG2 -MS2
      UG = S4G -S -TG
      T1 = TG +M2
      U1 = UG +M2

      ANGDEF(1) = 2.D0*SQRT(S4G +MG2)
      ANGDEF(2) = (S +UG)/ANGDEF(1)
      ANGDEF(3) = (S +TG)/ANGDEF(1)
      ANGDEF(4) = S4G/ANGDEF(1)
      ANGDEF(5) = (S4G +2.D0*MG2)/ANGDEF(1)
      ANGDEF(6) = -(TG +UG +2.D0*MG2)/ANGDEF(1)
      ANGDEF(7) = SQRT((TG +UG)**2 -4.D0*MG2*S)/ANGDEF(1)
      ANGDEF(8) = 
     +  (TG*S4G -S*(UG+2.D0*MG2))/(S+TG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(9) = SQRT(1 -ANGDEF(8)**2)
      ANGDEF(10) =
     +  (UG*S4G -S*(TG+2.D0*MG2))/(S+UG)/SQRT((TG+UG)**2-4.D0*MG2*S)
      ANGDEF(11) = SQRT(1 -ANGDEF(10)**2)

      ANA(1,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)
      ANC(1,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(1,2) = -ANB(1,1)
      ANC(1,2) = -ANC(1,1)
      ANA(1,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(1,3) = -ANA(1,3)
      ANC(1,3) =  0.D0
      ANA(1,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(1,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(8)-2.D0*ANGDEF(3)*ANGDEF(4)
      ANC(1,4) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(9)
      ANA(1,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(1,5) = -ANB(1,3)
      ANC(1,5) = -ANC(1,3)
      ANA(1,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(1,6) = -ANB(1,4)
      ANC(1,6) = -ANC(1,4)
      ANA(1,7) = +ANA(1,1) +M2
      ANB(1,7) = +ANB(1,1)
      ANC(1,7) = +ANC(1,1)
      ANA(1,8) = +ANA(1,5) +M2
      ANB(1,8) = +ANB(1,5)
      ANC(1,8) = +ANC(1,5)
      ANA(1,9) = +ANA(1,6) +M2
      ANB(1,9) = +ANB(1,6)
      ANC(1,9) = +ANC(1,6)


      ANA(2,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(2,1) = -2.D0*ANGDEF(4)*ANGDEF(7)
      ANC(2,1) =  0.D0
      ANA(2,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(2,2) = -ANB(2,1)
      ANC(2,2) = -ANC(2,1)
      ANA(2,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,3) = +2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(2,4) =
     +     2.D0*ANGDEF(4)*ANGDEF(7) -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(8)
      ANC(2,4) = -2.D0*ANGDEF(3)*ANGDEF(4)*ANGDEF(9)
      ANA(2,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(2,5) = -ANB(2,3)
      ANC(2,5) = -ANC(2,3)
      ANA(2,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(2,6) = -ANB(2,4)
      ANC(2,6) = -ANC(2,4)
      ANA(2,7) = +ANA(2,1) +M2
      ANB(2,7) = +ANB(2,1)
      ANC(2,7) = +ANC(2,1)
      ANA(2,8) = +ANA(2,5) +M2
      ANB(2,8) = +ANB(2,5)
      ANC(2,8) = +ANC(2,5)
      ANA(2,9) = +ANA(2,6) +M2
      ANB(2,9) = +ANB(2,6)
      ANC(2,9) = +ANC(2,6)


      ANA(3,1) = +2.D0*ANGDEF(4)*ANGDEF(6)
      ANB(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10)
      ANC(3,1) = -2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,2) = +2.D0*ANGDEF(5)*ANGDEF(6) +2.D0*MG2
      ANB(3,2) = -ANB(3,1)
      ANC(3,2) = -ANC(3,1)
      ANA(3,3) = -2.D0*ANGDEF(3)*ANGDEF(4)
      ANB(3,3) = 
     +     2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(10) -2.D0*ANGDEF(2)*ANGDEF(4)
      ANC(3,3) = +2.D0*ANGDEF(4)*ANGDEF(7)*ANGDEF(11)
      ANA(3,4) = -2.D0*ANGDEF(2)*ANGDEF(4)
      ANB(3,4) = -ANA(3,4)
      ANC(3,4) =  0.D0
      ANA(3,5) = -2.D0*ANGDEF(5)*ANGDEF(3)
      ANB(3,5) = -ANB(3,3)
      ANC(3,5) = -ANC(3,3)
      ANA(3,6) = -2.D0*ANGDEF(5)*ANGDEF(2)
      ANB(3,6) = -ANB(3,4)
      ANC(3,6) = -ANC(3,4)
      ANA(3,7) = +ANA(3,1) +M2
      ANB(3,7) = +ANB(3,1)
      ANC(3,7) = +ANC(3,1)
      ANA(3,8) = +ANA(3,5) +M2
      ANB(3,8) = +ANB(3,5)
      ANC(3,8) = +ANC(3,5)
      ANA(3,9) = +ANA(3,6) +M2
      ANB(3,9) = +ANB(3,6)
      ANC(3,9) = +ANC(3,6)


      CANG4(1) = K4M1P1(ANA(3,6),ANB(3,6),ANA(3,7),ANB(3,7),ANC(3,7))
      CANG4(2) = K4P1P0(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
      CANG4(3) = K4P1P1(ANA(2,7),ANB(2,7),ANA(2,8),ANB(2,8),ANC(2,8))
      CANG4(4) = K4P1P1(ANA(2,7),ANB(2,7),ANA(2,6),ANB(2,6),ANC(2,6))
      CANG4(5) = 0


      M2GBU = 0D0
      M2GBU = M2GBU + CANG4(1)*KPI*N*CK * (  - 2*S**(-1)*UG**(-1)*MG2*
     +    S4G - 2*S**(-1)*T1**(-1)*M2*MG2 + 2*T1**(-1)*MG2 )
     +
      M2GBU = M2GBU + CANG4(1)*KPI*CQED * ( 2*S**(-1)*T1**(-1)*M2*MG2
     +     - 2*S**(-1)*MG2 - 2*T1**(-1)*MG2 )
     +
      M2GBU = M2GBU + CANG4(2)*KPI*N*CK * (  - 4*S**(-1)*UG**(-1)*MG2*
     +    S4G**2 - 4*S**(-1)*T1**(-1)*M2*MG2*S4G + 8*S**(-1)*T1*MG2 - 
     +    12*S**(-1)*M2*MG2 + 4*S**(-1)*MG2*S4G - 2*S*UG**(-1)*MG2 + 6*
     +    S*T1**(-1)*MG2 + 8*UG**(-1)*MG2**2 - 4*T1**(-1)*M2*MG2 - 8*
     +    T1**(-1)*MG2**2 + 8*MG2 )
     +
      M2GBU = M2GBU + CANG4(2)*KPI*CQED * ( 4*S**(-1)*T1**(-1)*M2*MG2*
     +    S4G - 4*S**(-1)*T1*MG2 + 4*S**(-1)*M2*MG2 - 2*S**(-1)*MG2*S4G
     +     - 8*S*T1**(-1)*MG2 + 4*T1**(-1)*M2*MG2 - 2*T1**(-1)*MG2*S4G
     +     + 8*T1**(-1)*MG2**2 - 10*MG2 )
     +
      M2GBU = M2GBU + CANG4(3)*KPI*N*CK * (  - 2*S**(-1)*T1*M2*MG2 - 2*
     +    S**(-1)*M2*MG2*S4G + 6*S**(-1)*M2**2*MG2 + 2*S*UG**(-1)*M2*
     +    MG2 + 4*S*MG2 - 4*UG**(-1)*M2*MG2*S4G - 8*UG**(-1)*M2*MG2**2
     +     + 4*UG**(-1)*M2**2*MG2 + 8*UG**(-1)*MG2**2*S4G + 2*T1*MG2 - 
     +    4*M2*MG2 + 2*MG2*S4G - 8*MG2**2 )
     +
      M2GBU = M2GBU + CANG4(3)*KPI*CQED * ( 2*S**(-1)*T1*M2*MG2 + 2*
     +    S**(-1)*M2*MG2*S4G - 6*S**(-1)*M2**2*MG2 + 8*S*T1**(-1)*M2*
     +    MG2 + 8*S*T1**(-1)*MG2**2 - 6*S*MG2 - 4*S**2*T1**(-1)*MG2 - 
     +    16*T1**(-1)*M2*MG2**2 - 2*T1*MG2 + 6*M2*MG2 - 2*MG2*S4G + 8*
     +    MG2**2 )
     +
      M2GBU = M2GBU + CANG4(4)*KPI*N*CK * ( 2*S**(-1)*T1*M2*MG2 + 2*
     +    S**(-1)*M2*MG2*S4G - 6*S**(-1)*M2**2*MG2 + 2*S*T1**(-1)*M2*
     +    MG2 - 2*S*MG2 - 6*T1**(-1)*M2*MG2*S4G - 16*T1**(-1)*M2*MG2**2
     +     + 2*T1**(-1)*M2**2*MG2 + 2*T1*MG2 - 4*M2*MG2 + 8*MG2**2 )
     +
      M2GBU = M2GBU + CANG4(5)*KPI*N*CK * (  - 4*S**(-1)*UG**(-1)*MG2*
     +    S4G - 2*S**(-1)*T1**(-1)*M2*MG2 + 2*S**(-1)*T1**(-1)*MG2*S4G
     +     + 8*S**(-1)*MG2 + 2*UG**(-1)*MG2 + 4*T1**(-1)*MG2 )
     +
      M2GBU = M2GBU + CANG4(5)*KPI*CQED * ( 2*S**(-1)*T1**(-1)*M2*MG2
     +     - 2*S**(-1)*T1**(-1)*MG2*S4G - 6*S**(-1)*MG2 - 4*T1**(-1)*
     +    MG2 )


      DGGGBU = 
     +     0.5D0*ALPHAS**3 *AVG *M2GBU *S4G/(S4G +MG2)/8.D0/S**2 *CONV
      RETURN
      END






